/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ddh0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|h0) integrals */

void d12hrr_order_ddh0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][5][10] = int_stack + 315;
 Libderiv->deriv_classes[4][5][9] = int_stack + 630;
 Libderiv->deriv_classes[4][5][8] = int_stack + 945;
 Libderiv->deriv_classes[4][5][7] = int_stack + 1260;
 Libderiv->deriv_classes[4][5][6] = int_stack + 1575;
 Libderiv->deriv_classes[4][5][2] = int_stack + 1890;
 Libderiv->deriv_classes[4][5][1] = int_stack + 2205;
 Libderiv->dvrr_classes[3][5] = int_stack + 2520;
 Libderiv->deriv_classes[4][5][0] = int_stack + 2730;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 3045;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 3171;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 3381;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 3696;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 3822;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 4032;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 4347;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 4473;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 4683;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 4998;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 5124;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 5334;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 5649;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 5775;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 5985;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 6300;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 6426;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 6636;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 6951;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 7077;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 7287;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 7602;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 7728;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 7938;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 8253;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 8379;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 8589;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 8904;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 9030;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 9240;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 9555;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 9681;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 9891;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 10206;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 10332;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 10542;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 10857;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 10983;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 11193;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 11508;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 11634;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 11844;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 12159;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 12285;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 12495;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 12810;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 12936;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 13146;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 13461;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 13587;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 13797;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 14112;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 14238;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 14448;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 14763;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 14889;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 15099;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 15414;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 15540;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 15750;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 16065;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 16191;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 16401;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 16716;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 16842;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 17052;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 17367;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 17493;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 17703;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 18018;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 18144;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 18354;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 18669;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 18795;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 19005;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 19320;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 19446;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 19656;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 19971;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 20097;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 20307;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 20622;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 20748;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 20958;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 21273;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 21399;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 21609;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 21924;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 22050;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 22260;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 22575;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 22701;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 22911;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 23226;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 23352;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 23562;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 23877;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 24003;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 24213;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 24528;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 24654;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 24864;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 25179;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 25305;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 25515;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 25830;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 25956;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 26166;
 Libderiv->deriv_classes[2][5][11] = int_stack + 26481;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 26607;
 Libderiv->deriv_classes[3][5][11] = int_stack + 26733;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 26943;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 27153;
 Libderiv->deriv_classes[2][5][10] = int_stack + 27468;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 27594;
 Libderiv->deriv_classes[3][5][10] = int_stack + 27720;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 27930;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 28140;
 Libderiv->deriv_classes[2][5][9] = int_stack + 28455;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 28581;
 Libderiv->deriv_classes[3][5][9] = int_stack + 28707;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 28917;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 29127;
 Libderiv->deriv_classes[2][5][8] = int_stack + 29442;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 29568;
 Libderiv->deriv_classes[3][5][8] = int_stack + 29694;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 29904;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 30114;
 Libderiv->deriv_classes[2][5][7] = int_stack + 30429;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 30555;
 Libderiv->deriv_classes[3][5][7] = int_stack + 30681;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 30891;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 31101;
 Libderiv->deriv_classes[2][5][6] = int_stack + 31416;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 31542;
 Libderiv->deriv_classes[3][5][6] = int_stack + 31668;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 31878;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 32088;
 Libderiv->deriv_classes[2][5][2] = int_stack + 32403;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 32529;
 Libderiv->deriv_classes[3][5][2] = int_stack + 32655;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 32865;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 33075;
 Libderiv->deriv_classes[2][5][1] = int_stack + 33390;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 33516;
 Libderiv->deriv_classes[3][5][1] = int_stack + 33642;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 33852;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 34062;
 Libderiv->dvrr_classes[2][5] = int_stack + 34377;
 Libderiv->deriv_classes[2][5][0] = int_stack + 34503;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 34629;
 Libderiv->deriv_classes[3][5][0] = int_stack + 34755;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 34965;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 35175;
 memset(int_stack,0,283920);

 Libderiv->dvrr_stack = int_stack + 58926;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ddh0(Libderiv, Data);
   Data++;
 }

 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+35490,int_stack+26733,int_stack+26481,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+35868,int_stack+0,int_stack+26733,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+36498,int_stack+27720,int_stack+27468,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+36876,int_stack+315,int_stack+27720,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+28707,int_stack+28455,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+37506,int_stack+630,int_stack+28707,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+378,int_stack+29694,int_stack+29442,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+38136,int_stack+945,int_stack+29694,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+756,int_stack+30681,int_stack+30429,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+38766,int_stack+1260,int_stack+30681,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1134,int_stack+31668,int_stack+31416,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+39396,int_stack+1575,int_stack+31668,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1512,int_stack+2520,int_stack+34377,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+40026,int_stack+32655,int_stack+32403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+40404,int_stack+1890,int_stack+32655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+41034,int_stack+33642,int_stack+33390, 0.0, zero_stack, 1.0, int_stack+34377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+41412,int_stack+2205,int_stack+33642, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+1890,int_stack+34755,int_stack+34503, 1.0, int_stack+34377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+42042,int_stack+2730,int_stack+34755, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2268,int_stack+3171,int_stack+3045,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+42672,int_stack+3381,int_stack+3171,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2646,int_stack+3822,int_stack+3696,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+3024,int_stack+4032,int_stack+3822,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3654,int_stack+4473,int_stack+4347,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+43302,int_stack+4683,int_stack+4473,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+4032,int_stack+5124,int_stack+4998,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4410,int_stack+5334,int_stack+5124,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+5040,int_stack+5775,int_stack+5649,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+43932,int_stack+5985,int_stack+5775,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+5418,int_stack+6426,int_stack+6300,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5796,int_stack+6636,int_stack+6426,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+6426,int_stack+7077,int_stack+6951,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+44562,int_stack+7287,int_stack+7077,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+6804,int_stack+7728,int_stack+7602,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+45192,int_stack+7938,int_stack+7728,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+7182,int_stack+8379,int_stack+8253,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+7560,int_stack+8589,int_stack+8379,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+8190,int_stack+9030,int_stack+8904,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+45822,int_stack+9240,int_stack+9030,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+8568,int_stack+9681,int_stack+9555,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+8946,int_stack+9891,int_stack+9681,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+9576,int_stack+10332,int_stack+10206,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+46452,int_stack+10542,int_stack+10332,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+9954,int_stack+10983,int_stack+10857,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+10332,int_stack+11193,int_stack+10983,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+10962,int_stack+11634,int_stack+11508,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+47082,int_stack+11844,int_stack+11634,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+11340,int_stack+12285,int_stack+12159,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+47712,int_stack+12495,int_stack+12285,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+11718,int_stack+12936,int_stack+12810,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12096,int_stack+13146,int_stack+12936,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+12726,int_stack+13587,int_stack+13461,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+48342,int_stack+13797,int_stack+13587,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+13104,int_stack+14238,int_stack+14112,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+13482,int_stack+14448,int_stack+14238,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+14112,int_stack+14889,int_stack+14763,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+48972,int_stack+15099,int_stack+14889,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+14490,int_stack+15540,int_stack+15414,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+14868,int_stack+15750,int_stack+15540,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+15498,int_stack+16191,int_stack+16065,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+49602,int_stack+16401,int_stack+16191,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+15876,int_stack+16842,int_stack+16716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+50232,int_stack+17052,int_stack+16842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+16254,int_stack+17493,int_stack+17367, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+16632,int_stack+17703,int_stack+17493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+17262,int_stack+18144,int_stack+18018, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+50862,int_stack+18354,int_stack+18144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+17640,int_stack+18795,int_stack+18669, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+18018,int_stack+19005,int_stack+18795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+18648,int_stack+19446,int_stack+19320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+51492,int_stack+19656,int_stack+19446, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+19026,int_stack+20097,int_stack+19971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+19404,int_stack+20307,int_stack+20097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+20034,int_stack+20748,int_stack+20622, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+52122,int_stack+20958,int_stack+20748, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+20412,int_stack+21399,int_stack+21273, 0.0, zero_stack, 1.0, int_stack+26481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+52752,int_stack+21609,int_stack+21399, 0.0, zero_stack, 1.0, int_stack+26733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+20790,int_stack+22050,int_stack+21924, 0.0, zero_stack, 1.0, int_stack+27468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+21168,int_stack+22260,int_stack+22050, 0.0, zero_stack, 1.0, int_stack+27720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+21798,int_stack+22701,int_stack+22575, 0.0, zero_stack, 1.0, int_stack+28455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+53382,int_stack+22911,int_stack+22701, 0.0, zero_stack, 1.0, int_stack+28707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+22176,int_stack+23352,int_stack+23226, 0.0, zero_stack, 1.0, int_stack+29442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+22554,int_stack+23562,int_stack+23352, 0.0, zero_stack, 1.0, int_stack+29694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+23184,int_stack+24003,int_stack+23877, 0.0, zero_stack, 1.0, int_stack+30429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+54012,int_stack+24213,int_stack+24003, 0.0, zero_stack, 1.0, int_stack+30681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+23562,int_stack+24654,int_stack+24528, 0.0, zero_stack, 1.0, int_stack+31416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+23940,int_stack+24864,int_stack+24654, 0.0, zero_stack, 1.0, int_stack+31668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+24570,int_stack+25305,int_stack+25179, 0.0, zero_stack, 1.0, int_stack+32403, 1.0, int_stack+33390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+54642,int_stack+25515,int_stack+25305, 0.0, zero_stack, 1.0, int_stack+32655, 1.0, int_stack+33642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+24948,int_stack+25956,int_stack+25830, 0.0, zero_stack, 2.0, int_stack+33390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+25326,int_stack+26166,int_stack+25956, 0.0, zero_stack, 2.0, int_stack+33642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+25956,int_stack+26943,int_stack+26607, 1.0, int_stack+26481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+55272,int_stack+27153,int_stack+26943, 1.0, int_stack+26733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+26334,int_stack+27930,int_stack+27594, 1.0, int_stack+27468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+26712,int_stack+28140,int_stack+27930, 1.0, int_stack+27720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+27342,int_stack+28917,int_stack+28581, 1.0, int_stack+28455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+27720,int_stack+29127,int_stack+28917, 1.0, int_stack+28707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+28350,int_stack+29904,int_stack+29568, 1.0, int_stack+29442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+28728,int_stack+30114,int_stack+29904, 1.0, int_stack+29694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+29358,int_stack+30891,int_stack+30555, 1.0, int_stack+30429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+29736,int_stack+31101,int_stack+30891, 1.0, int_stack+30681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+30366,int_stack+31878,int_stack+31542, 1.0, int_stack+31416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+30744,int_stack+32088,int_stack+31878, 1.0, int_stack+31668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+31374,int_stack+32865,int_stack+32529, 1.0, int_stack+32403, 0.0, zero_stack, 1.0, int_stack+34503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+31752,int_stack+33075,int_stack+32865, 1.0, int_stack+32655, 0.0, zero_stack, 1.0, int_stack+34755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+32382,int_stack+33852,int_stack+33516, 1.0, int_stack+33390, 1.0, int_stack+34503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+32760,int_stack+34062,int_stack+33852, 1.0, int_stack+33642, 1.0, int_stack+34755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+33390,int_stack+34965,int_stack+34629, 2.0, int_stack+34503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+33768,int_stack+35175,int_stack+34965, 2.0, int_stack+34755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+34398,int_stack+35868,int_stack+35490,21);
     Libderiv->ABCD[11] = int_stack + 34398;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+55902,int_stack+36876,int_stack+36498,21);
     Libderiv->ABCD[10] = int_stack + 55902;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+56658,int_stack+37506,int_stack+0,21);
     Libderiv->ABCD[9] = int_stack + 56658;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+36876,int_stack+38136,int_stack+378,21);
     Libderiv->ABCD[8] = int_stack + 36876;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+37632,int_stack+38766,int_stack+756,21);
     Libderiv->ABCD[7] = int_stack + 37632;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+38388,int_stack+39396,int_stack+1134,21);
     Libderiv->ABCD[6] = int_stack + 38388;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+39144,int_stack+40404,int_stack+40026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[2] = int_stack + 39144;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+57414,int_stack+41412,int_stack+41034, 0.0, zero_stack, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[1] = int_stack + 57414;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+58170,int_stack+42042,int_stack+1890, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[0] = int_stack + 58170;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+41412,int_stack+42672,int_stack+2268,21);
     Libderiv->ABCD[155] = int_stack + 41412;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+42168,int_stack+3024,int_stack+2646,21);
     Libderiv->ABCD[143] = int_stack + 42168;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+2268,int_stack+43302,int_stack+3654,21);
     Libderiv->ABCD[142] = int_stack + 2268;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+3024,int_stack+4410,int_stack+4032,21);
     Libderiv->ABCD[131] = int_stack + 3024;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+3780,int_stack+43932,int_stack+5040,21);
     Libderiv->ABCD[130] = int_stack + 3780;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+4536,int_stack+5796,int_stack+5418,21);
     Libderiv->ABCD[129] = int_stack + 4536;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+5292,int_stack+44562,int_stack+6426,21);
     Libderiv->ABCD[119] = int_stack + 5292;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+6048,int_stack+45192,int_stack+6804,21);
     Libderiv->ABCD[118] = int_stack + 6048;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+42924,int_stack+7560,int_stack+7182,21);
     Libderiv->ABCD[117] = int_stack + 42924;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+6804,int_stack+45822,int_stack+8190,21);
     Libderiv->ABCD[116] = int_stack + 6804;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+7560,int_stack+8946,int_stack+8568,21);
     Libderiv->ABCD[107] = int_stack + 7560;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+8316,int_stack+46452,int_stack+9576,21);
     Libderiv->ABCD[106] = int_stack + 8316;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+9072,int_stack+10332,int_stack+9954,21);
     Libderiv->ABCD[105] = int_stack + 9072;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+9828,int_stack+47082,int_stack+10962,21);
     Libderiv->ABCD[104] = int_stack + 9828;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+10584,int_stack+47712,int_stack+11340,21);
     Libderiv->ABCD[103] = int_stack + 10584;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+43680,int_stack+12096,int_stack+11718,21);
     Libderiv->ABCD[95] = int_stack + 43680;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+11340,int_stack+48342,int_stack+12726,21);
     Libderiv->ABCD[94] = int_stack + 11340;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+12096,int_stack+13482,int_stack+13104,21);
     Libderiv->ABCD[93] = int_stack + 12096;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+12852,int_stack+48972,int_stack+14112,21);
     Libderiv->ABCD[92] = int_stack + 12852;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+13608,int_stack+14868,int_stack+14490,21);
     Libderiv->ABCD[91] = int_stack + 13608;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+14364,int_stack+49602,int_stack+15498,21);
     Libderiv->ABCD[90] = int_stack + 14364;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+15120,int_stack+50232,int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[47] = int_stack + 15120;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+44436,int_stack+16632,int_stack+16254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[46] = int_stack + 44436;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+15876,int_stack+50862,int_stack+17262, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[45] = int_stack + 15876;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+16632,int_stack+18018,int_stack+17640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[44] = int_stack + 16632;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+17388,int_stack+51492,int_stack+18648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[43] = int_stack + 17388;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+18144,int_stack+19404,int_stack+19026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[42] = int_stack + 18144;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+18900,int_stack+52122,int_stack+20034, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+40026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[38] = int_stack + 18900;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+19656,int_stack+52752,int_stack+20412, 0.0, zero_stack, 1.0, int_stack+35490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[35] = int_stack + 19656;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+45192,int_stack+21168,int_stack+20790, 0.0, zero_stack, 1.0, int_stack+36498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[34] = int_stack + 45192;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+20412,int_stack+53382,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[33] = int_stack + 20412;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+21168,int_stack+22554,int_stack+22176, 0.0, zero_stack, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[32] = int_stack + 21168;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+21924,int_stack+54012,int_stack+23184, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[31] = int_stack + 21924;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+22680,int_stack+23940,int_stack+23562, 0.0, zero_stack, 1.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[30] = int_stack + 22680;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+23436,int_stack+54642,int_stack+24570, 0.0, zero_stack, 1.0, int_stack+40026, 1.0, int_stack+41034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[26] = int_stack + 23436;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+24192,int_stack+25326,int_stack+24948, 0.0, zero_stack, 2.0, int_stack+41034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[25] = int_stack + 24192;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+24948,int_stack+55272,int_stack+25956, 1.0, int_stack+35490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[23] = int_stack + 24948;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+45948,int_stack+26712,int_stack+26334, 1.0, int_stack+36498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[22] = int_stack + 45948;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+25704,int_stack+27720,int_stack+27342, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[21] = int_stack + 25704;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+26460,int_stack+28728,int_stack+28350, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[20] = int_stack + 26460;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+0,int_stack+29736,int_stack+29358, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[19] = int_stack + 0;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+27216,int_stack+30744,int_stack+30366, 1.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[18] = int_stack + 27216;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+756,int_stack+31752,int_stack+31374, 1.0, int_stack+40026, 0.0, zero_stack, 1.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[14] = int_stack + 756;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+27972,int_stack+32760,int_stack+32382, 1.0, int_stack+41034, 1.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[13] = int_stack + 27972;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+28728,int_stack+33768,int_stack+33390, 2.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[12] = int_stack + 28728;

}
