/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_g0h0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|h0) integrals */

void d12hrr_order_g0h0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][5][10] = int_stack + 315;
 Libderiv->deriv_classes[4][5][9] = int_stack + 630;
 Libderiv->deriv_classes[4][5][8] = int_stack + 945;
 Libderiv->deriv_classes[4][5][7] = int_stack + 1260;
 Libderiv->deriv_classes[4][5][6] = int_stack + 1575;
 Libderiv->deriv_classes[4][5][2] = int_stack + 1890;
 Libderiv->deriv_classes[4][5][1] = int_stack + 2205;
 Libderiv->deriv_classes[4][5][0] = int_stack + 2520;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 2835;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 3150;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 3465;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 3780;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 4095;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 4410;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 4725;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 5040;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 5355;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 5670;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 5985;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 6300;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 6615;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 6930;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 7245;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 7560;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 7875;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 8190;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 8505;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 8820;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 9135;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 9450;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 9765;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 10080;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 10395;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 10710;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 11025;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 11340;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 11655;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 11970;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 12285;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 12600;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 12915;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 13230;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 13545;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 13860;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 14175;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 14490;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 14805;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 15120;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 15435;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 15750;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 16065;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 16380;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 16695;
 memset(int_stack,0,136080);

 Libderiv->dvrr_stack = int_stack + 17010;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_g0h0(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[10] = int_stack + 315;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[9] = int_stack + 630;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[8] = int_stack + 945;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[7] = int_stack + 1260;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[6] = int_stack + 1575;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[2] = int_stack + 1890;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[1] = int_stack + 2205;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[0] = int_stack + 2520;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[155] = int_stack + 2835;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[143] = int_stack + 3150;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[142] = int_stack + 3465;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[131] = int_stack + 3780;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[130] = int_stack + 4095;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[129] = int_stack + 4410;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[119] = int_stack + 4725;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[118] = int_stack + 5040;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[117] = int_stack + 5355;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[116] = int_stack + 5670;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[107] = int_stack + 5985;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[106] = int_stack + 6300;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[105] = int_stack + 6615;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[104] = int_stack + 6930;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[103] = int_stack + 7245;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[95] = int_stack + 7560;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[94] = int_stack + 7875;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[93] = int_stack + 8190;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[92] = int_stack + 8505;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[91] = int_stack + 8820;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[90] = int_stack + 9135;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[47] = int_stack + 9450;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[46] = int_stack + 9765;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[45] = int_stack + 10080;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[44] = int_stack + 10395;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[43] = int_stack + 10710;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[42] = int_stack + 11025;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[38] = int_stack + 11340;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[35] = int_stack + 11655;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[34] = int_stack + 11970;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[33] = int_stack + 12285;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[32] = int_stack + 12600;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[31] = int_stack + 12915;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[30] = int_stack + 13230;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[26] = int_stack + 13545;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[25] = int_stack + 13860;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[23] = int_stack + 14175;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[22] = int_stack + 14490;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[21] = int_stack + 14805;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[20] = int_stack + 15120;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[19] = int_stack + 15435;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[18] = int_stack + 15750;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[14] = int_stack + 16065;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[13] = int_stack + 16380;
 /*--- compute (g0|h0) ---*/
     Libderiv->ABCD[12] = int_stack + 16695;

}
