/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ppgd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (pp|gd) integrals */

void d12hrr_order_ppgd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][6][10] = int_stack + 168;
 Libderiv->deriv_classes[2][6][9] = int_stack + 336;
 Libderiv->deriv_classes[2][6][8] = int_stack + 504;
 Libderiv->deriv_classes[2][6][7] = int_stack + 672;
 Libderiv->dvrr_classes[2][5] = int_stack + 840;
 Libderiv->deriv_classes[2][6][6] = int_stack + 966;
 Libderiv->deriv_classes[2][6][2] = int_stack + 1134;
 Libderiv->deriv_classes[2][6][1] = int_stack + 1302;
 Libderiv->dvrr_classes[1][6] = int_stack + 1470;
 Libderiv->deriv_classes[2][6][0] = int_stack + 1554;
 Libderiv->deriv2_classes[1][4][143] = int_stack + 1722;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 1767;
 Libderiv->deriv2_classes[1][6][143] = int_stack + 1830;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 1914;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 2004;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 2130;
 Libderiv->deriv2_classes[1][4][131] = int_stack + 2298;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 2343;
 Libderiv->deriv2_classes[1][6][131] = int_stack + 2406;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 2490;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 2580;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 2706;
 Libderiv->deriv2_classes[1][4][130] = int_stack + 2874;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 2919;
 Libderiv->deriv2_classes[1][6][130] = int_stack + 2982;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 3066;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 3156;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 3282;
 Libderiv->deriv2_classes[1][4][119] = int_stack + 3450;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 3495;
 Libderiv->deriv2_classes[1][6][119] = int_stack + 3558;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 3642;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 3732;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 3858;
 Libderiv->deriv2_classes[1][4][118] = int_stack + 4026;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 4071;
 Libderiv->deriv2_classes[1][6][118] = int_stack + 4134;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 4218;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 4308;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 4434;
 Libderiv->deriv2_classes[1][4][117] = int_stack + 4602;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 4647;
 Libderiv->deriv2_classes[1][6][117] = int_stack + 4710;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 4794;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 4884;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 5010;
 Libderiv->deriv2_classes[1][4][107] = int_stack + 5178;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 5223;
 Libderiv->deriv2_classes[1][6][107] = int_stack + 5286;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 5370;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 5460;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 5586;
 Libderiv->deriv2_classes[1][4][106] = int_stack + 5754;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 5799;
 Libderiv->deriv2_classes[1][6][106] = int_stack + 5862;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 5946;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 6036;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 6162;
 Libderiv->deriv2_classes[1][4][105] = int_stack + 6330;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 6375;
 Libderiv->deriv2_classes[1][6][105] = int_stack + 6438;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 6522;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 6612;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 6738;
 Libderiv->deriv2_classes[1][4][104] = int_stack + 6906;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 6951;
 Libderiv->deriv2_classes[1][6][104] = int_stack + 7014;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 7098;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 7188;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 7314;
 Libderiv->deriv2_classes[1][4][95] = int_stack + 7482;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 7527;
 Libderiv->deriv2_classes[1][6][95] = int_stack + 7590;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 7674;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 7764;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 7890;
 Libderiv->deriv2_classes[1][4][94] = int_stack + 8058;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 8103;
 Libderiv->deriv2_classes[1][6][94] = int_stack + 8166;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 8250;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 8340;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 8466;
 Libderiv->deriv2_classes[1][4][93] = int_stack + 8634;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 8679;
 Libderiv->deriv2_classes[1][6][93] = int_stack + 8742;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 8826;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 8916;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 9042;
 Libderiv->deriv2_classes[1][4][92] = int_stack + 9210;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 9255;
 Libderiv->deriv2_classes[1][6][92] = int_stack + 9318;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 9402;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 9492;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 9618;
 Libderiv->deriv2_classes[1][4][91] = int_stack + 9786;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 9831;
 Libderiv->deriv2_classes[1][6][91] = int_stack + 9894;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 9978;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 10068;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 10194;
 Libderiv->deriv2_classes[1][4][83] = int_stack + 10362;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 10407;
 Libderiv->deriv2_classes[1][6][83] = int_stack + 10470;
 Libderiv->deriv_classes[2][4][11] = int_stack + 10554;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 10644;
 Libderiv->deriv_classes[2][5][11] = int_stack + 10734;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 10860;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 10986;
 Libderiv->deriv2_classes[1][4][82] = int_stack + 11154;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 11199;
 Libderiv->deriv2_classes[1][6][82] = int_stack + 11262;
 Libderiv->deriv_classes[2][4][10] = int_stack + 11346;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 11436;
 Libderiv->deriv_classes[2][5][10] = int_stack + 11526;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 11652;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 11778;
 Libderiv->deriv2_classes[1][4][81] = int_stack + 11946;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 11991;
 Libderiv->deriv2_classes[1][6][81] = int_stack + 12054;
 Libderiv->deriv_classes[2][4][9] = int_stack + 12138;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 12228;
 Libderiv->deriv_classes[2][5][9] = int_stack + 12318;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 12444;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 12570;
 Libderiv->deriv2_classes[1][4][80] = int_stack + 12738;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 12783;
 Libderiv->deriv2_classes[1][6][80] = int_stack + 12846;
 Libderiv->deriv_classes[2][4][8] = int_stack + 12930;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 13020;
 Libderiv->deriv_classes[2][5][8] = int_stack + 13110;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 13236;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 13362;
 Libderiv->deriv2_classes[1][4][79] = int_stack + 13530;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 13575;
 Libderiv->deriv2_classes[1][6][79] = int_stack + 13638;
 Libderiv->deriv_classes[2][4][7] = int_stack + 13722;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 13812;
 Libderiv->deriv_classes[2][5][7] = int_stack + 13902;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 14028;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 14154;
 Libderiv->deriv2_classes[1][4][78] = int_stack + 14322;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 14367;
 Libderiv->deriv2_classes[1][6][78] = int_stack + 14430;
 Libderiv->dvrr_classes[2][4] = int_stack + 14514;
 Libderiv->deriv_classes[2][4][6] = int_stack + 14604;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 14694;
 Libderiv->deriv_classes[2][5][6] = int_stack + 14784;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 14910;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 15036;
 Libderiv->deriv2_classes[1][4][35] = int_stack + 15204;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 15249;
 Libderiv->deriv2_classes[1][6][35] = int_stack + 15312;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 15396;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 15486;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 15612;
 Libderiv->deriv2_classes[1][4][34] = int_stack + 15780;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 15825;
 Libderiv->deriv2_classes[1][6][34] = int_stack + 15888;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 15972;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 16062;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 16188;
 Libderiv->deriv2_classes[1][4][33] = int_stack + 16356;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 16401;
 Libderiv->deriv2_classes[1][6][33] = int_stack + 16464;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 16548;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 16638;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 16764;
 Libderiv->deriv2_classes[1][4][32] = int_stack + 16932;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 16977;
 Libderiv->deriv2_classes[1][6][32] = int_stack + 17040;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 17124;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 17214;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 17340;
 Libderiv->deriv2_classes[1][4][31] = int_stack + 17508;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 17553;
 Libderiv->deriv2_classes[1][6][31] = int_stack + 17616;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 17700;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 17790;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 17916;
 Libderiv->deriv2_classes[1][4][30] = int_stack + 18084;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 18129;
 Libderiv->deriv2_classes[1][6][30] = int_stack + 18192;
 Libderiv->deriv_classes[2][4][2] = int_stack + 18276;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 18366;
 Libderiv->deriv_classes[2][5][2] = int_stack + 18456;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 18582;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 18708;
 Libderiv->deriv2_classes[1][4][26] = int_stack + 18876;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 18921;
 Libderiv->deriv2_classes[1][6][26] = int_stack + 18984;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 19068;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 19158;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 19284;
 Libderiv->deriv2_classes[1][4][23] = int_stack + 19452;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 19497;
 Libderiv->deriv2_classes[1][6][23] = int_stack + 19560;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 19644;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 19734;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 19860;
 Libderiv->deriv2_classes[1][4][22] = int_stack + 20028;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 20073;
 Libderiv->deriv2_classes[1][6][22] = int_stack + 20136;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 20220;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 20310;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 20436;
 Libderiv->deriv2_classes[1][4][21] = int_stack + 20604;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 20649;
 Libderiv->deriv2_classes[1][6][21] = int_stack + 20712;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 20796;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 20886;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 21012;
 Libderiv->deriv2_classes[1][4][20] = int_stack + 21180;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 21225;
 Libderiv->deriv2_classes[1][6][20] = int_stack + 21288;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 21372;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 21462;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 21588;
 Libderiv->deriv2_classes[1][4][19] = int_stack + 21756;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 21801;
 Libderiv->deriv2_classes[1][6][19] = int_stack + 21864;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 21948;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 22038;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 22164;
 Libderiv->deriv2_classes[1][4][18] = int_stack + 22332;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 22377;
 Libderiv->deriv2_classes[1][6][18] = int_stack + 22440;
 Libderiv->deriv_classes[2][4][1] = int_stack + 22524;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 22614;
 Libderiv->deriv_classes[2][5][1] = int_stack + 22704;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 22830;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 22956;
 Libderiv->deriv2_classes[1][4][14] = int_stack + 23124;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 23169;
 Libderiv->deriv2_classes[1][6][14] = int_stack + 23232;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 23316;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 23406;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 23532;
 Libderiv->deriv2_classes[1][4][13] = int_stack + 23700;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 23745;
 Libderiv->deriv2_classes[1][6][13] = int_stack + 23808;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 23892;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 23982;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 24108;
 Libderiv->deriv_classes[1][4][11] = int_stack + 24276;
 Libderiv->deriv_classes[1][5][11] = int_stack + 24321;
 Libderiv->deriv_classes[1][6][11] = int_stack + 24384;
 Libderiv->deriv2_classes[1][4][11] = int_stack + 24468;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 24513;
 Libderiv->deriv2_classes[1][6][11] = int_stack + 24576;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 24660;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 24750;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 24876;
 Libderiv->deriv_classes[1][4][10] = int_stack + 25044;
 Libderiv->deriv_classes[1][5][10] = int_stack + 25089;
 Libderiv->deriv_classes[1][6][10] = int_stack + 25152;
 Libderiv->deriv2_classes[1][4][10] = int_stack + 25236;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 25281;
 Libderiv->deriv2_classes[1][6][10] = int_stack + 25344;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 25428;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 25518;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 25644;
 Libderiv->deriv_classes[1][4][9] = int_stack + 25812;
 Libderiv->deriv_classes[1][5][9] = int_stack + 25857;
 Libderiv->deriv_classes[1][6][9] = int_stack + 25920;
 Libderiv->deriv2_classes[1][4][9] = int_stack + 26004;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 26049;
 Libderiv->deriv2_classes[1][6][9] = int_stack + 26112;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 26196;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 26286;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 26412;
 Libderiv->deriv_classes[1][4][8] = int_stack + 26580;
 Libderiv->deriv_classes[1][5][8] = int_stack + 26625;
 Libderiv->deriv_classes[1][6][8] = int_stack + 26688;
 Libderiv->deriv2_classes[1][4][8] = int_stack + 26772;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 26817;
 Libderiv->deriv2_classes[1][6][8] = int_stack + 26880;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 26964;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 27054;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 27180;
 Libderiv->deriv_classes[1][4][7] = int_stack + 27348;
 Libderiv->deriv_classes[1][5][7] = int_stack + 27393;
 Libderiv->deriv_classes[1][6][7] = int_stack + 27456;
 Libderiv->deriv2_classes[1][4][7] = int_stack + 27540;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 27585;
 Libderiv->deriv2_classes[1][6][7] = int_stack + 27648;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 27732;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 27822;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 27948;
 Libderiv->dvrr_classes[1][4] = int_stack + 28116;
 Libderiv->deriv_classes[1][4][6] = int_stack + 28161;
 Libderiv->dvrr_classes[1][5] = int_stack + 28206;
 Libderiv->deriv_classes[1][5][6] = int_stack + 28269;
 Libderiv->deriv_classes[1][6][6] = int_stack + 28332;
 Libderiv->deriv2_classes[1][4][6] = int_stack + 28416;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 28461;
 Libderiv->deriv2_classes[1][6][6] = int_stack + 28524;
 Libderiv->deriv_classes[2][4][0] = int_stack + 28608;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 28698;
 Libderiv->deriv_classes[2][5][0] = int_stack + 28788;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 28914;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 29040;
 Libderiv->deriv_classes[1][4][2] = int_stack + 29208;
 Libderiv->deriv_classes[1][5][2] = int_stack + 29253;
 Libderiv->deriv_classes[1][6][2] = int_stack + 29316;
 Libderiv->deriv2_classes[1][4][2] = int_stack + 29400;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 29445;
 Libderiv->deriv2_classes[1][6][2] = int_stack + 29508;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 29592;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 29682;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 29808;
 Libderiv->deriv_classes[1][4][1] = int_stack + 29976;
 Libderiv->deriv_classes[1][5][1] = int_stack + 30021;
 Libderiv->deriv_classes[1][6][1] = int_stack + 30084;
 Libderiv->deriv2_classes[1][4][1] = int_stack + 30168;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 30213;
 Libderiv->deriv2_classes[1][6][1] = int_stack + 30276;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 30360;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 30450;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 30576;
 Libderiv->deriv_classes[1][4][0] = int_stack + 30744;
 Libderiv->deriv_classes[1][5][0] = int_stack + 30789;
 Libderiv->deriv_classes[1][6][0] = int_stack + 30852;
 Libderiv->deriv2_classes[1][4][0] = int_stack + 30936;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 30981;
 Libderiv->deriv2_classes[1][6][0] = int_stack + 31044;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 31128;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 31218;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 31344;
 memset(int_stack,0,252096);

 Libderiv->dvrr_stack = int_stack + 56271;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ppgd(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+31512,int_stack+28206,int_stack+28116,3);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+31647,int_stack+24321,int_stack+24276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28116,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+24384,int_stack+24321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28206,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+31971,int_stack+31782,int_stack+31647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+32241,int_stack+840,int_stack+14514,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+32511,int_stack+10734,int_stack+10554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14514,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32781,int_stack+0,int_stack+10734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33159,int_stack+32781,int_stack+32511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32241,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+32781,int_stack+25089,int_stack+25044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28116, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+25152,int_stack+25089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28206, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33699,int_stack+31782,int_stack+32781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33969,int_stack+11526,int_stack+11346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14514, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34239,int_stack+168,int_stack+11526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+34617,int_stack+34239,int_stack+33969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32241, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+34239,int_stack+25857,int_stack+25812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28116, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+25920,int_stack+25857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28206, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+31782,int_stack+34239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+35157,int_stack+12318,int_stack+12138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14514, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35427,int_stack+336,int_stack+12318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+35805,int_stack+35427,int_stack+35157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32241, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+35427,int_stack+26625,int_stack+26580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+26688,int_stack+26625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36345,int_stack+31782,int_stack+35427, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36615,int_stack+13110,int_stack+12930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36885,int_stack+504,int_stack+13110, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+37263,int_stack+36885,int_stack+36615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36885,int_stack+27393,int_stack+27348, 0.0, zero_stack, 1.0, int_stack+28116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+27456,int_stack+27393, 0.0, zero_stack, 1.0, int_stack+28206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+270,int_stack+31782,int_stack+36885, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+37803,int_stack+13902,int_stack+13722, 0.0, zero_stack, 1.0, int_stack+14514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38073,int_stack+672,int_stack+13902, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38451,int_stack+38073,int_stack+37803, 0.0, zero_stack, 1.0, int_stack+32241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38073,int_stack+28269,int_stack+28161, 1.0, int_stack+28116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+28332,int_stack+28269, 1.0, int_stack+28206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+540,int_stack+31782,int_stack+38073, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+14784,int_stack+14604, 1.0, int_stack+14514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+39261,int_stack+966,int_stack+14784, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+39639,int_stack+39261,int_stack+38991, 1.0, int_stack+32241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+1470,int_stack+28206,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+32241,int_stack+31782,int_stack+31512,3);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+31512,int_stack+29253,int_stack+29208,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+29316,int_stack+29253,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+39261,int_stack+31782,int_stack+31512,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+18456,int_stack+18276,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+40179,int_stack+1134,int_stack+18456,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+40557,int_stack+40179,int_stack+810,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+40179,int_stack+30021,int_stack+29976,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+30084,int_stack+30021,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+41097,int_stack+31782,int_stack+40179,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+22704,int_stack+22524,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+41637,int_stack+1302,int_stack+22704,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+42015,int_stack+41637,int_stack+41367,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+41637,int_stack+30789,int_stack+30744,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+30852,int_stack+30789,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1080,int_stack+31782,int_stack+41637,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+42555,int_stack+28788,int_stack+28608,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+42825,int_stack+1554,int_stack+28788,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+43203,int_stack+42825,int_stack+42555,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+1767,int_stack+1722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+24276,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+1830,int_stack+1767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+24321,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1350,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+31647,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+2004,int_stack+1914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10554,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+2130,int_stack+2004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10734,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+43743,int_stack+1620,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32511,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+2343,int_stack+2298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24276, 1.0, int_stack+25044,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+2406,int_stack+2343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24321, 1.0, int_stack+25089,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1620,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31647, 1.0, int_stack+32781,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+2580,int_stack+2490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10554, 1.0, int_stack+11346,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+2706,int_stack+2580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10734, 1.0, int_stack+11526,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2268,int_stack+1890,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32511, 1.0, int_stack+33969,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+2919,int_stack+2874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+25044, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+2982,int_stack+2919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+25089, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1890,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32781, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+3156,int_stack+3066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11346, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+44283,int_stack+3282,int_stack+3156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11526, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2808,int_stack+44283,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+33969, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+3495,int_stack+3450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24276, 0.0, zero_stack, 1.0, int_stack+25812,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+3558,int_stack+3495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24321, 0.0, zero_stack, 1.0, int_stack+25857,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+44283,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31647, 0.0, zero_stack, 1.0, int_stack+34239,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+3732,int_stack+3642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10554, 0.0, zero_stack, 1.0, int_stack+12138,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+44553,int_stack+3858,int_stack+3732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10734, 0.0, zero_stack, 1.0, int_stack+12318,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3348,int_stack+44553,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32511, 0.0, zero_stack, 1.0, int_stack+35157,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+4071,int_stack+4026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25044, 1.0, int_stack+25812, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+4134,int_stack+4071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25089, 1.0, int_stack+25857, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+44553,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32781, 1.0, int_stack+34239, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+4308,int_stack+4218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11346, 1.0, int_stack+12138, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3888,int_stack+4434,int_stack+4308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11526, 1.0, int_stack+12318, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+44823,int_stack+3888,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33969, 1.0, int_stack+35157, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+4647,int_stack+4602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+25812, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+4710,int_stack+4647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+25857, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3888,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34239, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+4884,int_stack+4794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12138, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4158,int_stack+5010,int_stack+4884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12318, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4536,int_stack+4158,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35157, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+5223,int_stack+5178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26580,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+5286,int_stack+5223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26625,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4158,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31647, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35427,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+5460,int_stack+5370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12930,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5076,int_stack+5586,int_stack+5460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10734, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13110,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+45363,int_stack+5076,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32511, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36615,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+5799,int_stack+5754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25044, 0.0, zero_stack, 1.0, int_stack+26580, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+5862,int_stack+5799, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25089, 0.0, zero_stack, 1.0, int_stack+26625, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5076,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32781, 0.0, zero_stack, 1.0, int_stack+35427, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+6036,int_stack+5946, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11346, 0.0, zero_stack, 1.0, int_stack+12930, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5346,int_stack+6162,int_stack+6036, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11526, 0.0, zero_stack, 1.0, int_stack+13110, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5724,int_stack+5346,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33969, 0.0, zero_stack, 1.0, int_stack+36615, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+6375,int_stack+6330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25812, 1.0, int_stack+26580, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+6438,int_stack+6375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25857, 1.0, int_stack+26625, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5346,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34239, 1.0, int_stack+35427, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+6612,int_stack+6522, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12138, 1.0, int_stack+12930, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45903,int_stack+6738,int_stack+6612, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12318, 1.0, int_stack+13110, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6264,int_stack+45903,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35157, 1.0, int_stack+36615, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+6951,int_stack+6906, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+26580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+7014,int_stack+6951, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+26625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+45903,int_stack+31782,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+7188,int_stack+7098, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46173,int_stack+7314,int_stack+7188, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+13110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6804,int_stack+46173,int_stack+42825, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+36615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+7527,int_stack+7482, 0.0, zero_stack, 1.0, int_stack+24276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27348,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+7590,int_stack+7527, 0.0, zero_stack, 1.0, int_stack+24321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27393,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+46173,int_stack+31782,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+31647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36885,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+7764,int_stack+7674, 0.0, zero_stack, 1.0, int_stack+10554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13722,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46443,int_stack+7890,int_stack+7764, 0.0, zero_stack, 1.0, int_stack+10734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13902,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7344,int_stack+46443,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+32511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37803,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+8103,int_stack+8058, 0.0, zero_stack, 1.0, int_stack+25044, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27348, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+8166,int_stack+8103, 0.0, zero_stack, 1.0, int_stack+25089, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27393, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+46443,int_stack+31782,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+32781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36885, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+8340,int_stack+8250, 0.0, zero_stack, 1.0, int_stack+11346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13722, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7884,int_stack+8466,int_stack+8340, 0.0, zero_stack, 1.0, int_stack+11526, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13902, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+46713,int_stack+7884,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+33969, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37803, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+8679,int_stack+8634, 0.0, zero_stack, 1.0, int_stack+25812, 0.0, zero_stack, 1.0, int_stack+27348, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+8742,int_stack+8679, 0.0, zero_stack, 1.0, int_stack+25857, 0.0, zero_stack, 1.0, int_stack+27393, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7884,int_stack+31782,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+34239, 0.0, zero_stack, 1.0, int_stack+36885, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+8916,int_stack+8826, 0.0, zero_stack, 1.0, int_stack+12138, 0.0, zero_stack, 1.0, int_stack+13722, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8154,int_stack+9042,int_stack+8916, 0.0, zero_stack, 1.0, int_stack+12318, 0.0, zero_stack, 1.0, int_stack+13902, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8532,int_stack+8154,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+35157, 0.0, zero_stack, 1.0, int_stack+37803, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+9255,int_stack+9210, 0.0, zero_stack, 1.0, int_stack+26580, 1.0, int_stack+27348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+9318,int_stack+9255, 0.0, zero_stack, 1.0, int_stack+26625, 1.0, int_stack+27393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8154,int_stack+31782,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+35427, 1.0, int_stack+36885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+9492,int_stack+9402, 0.0, zero_stack, 1.0, int_stack+12930, 1.0, int_stack+13722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9072,int_stack+9618,int_stack+9492, 0.0, zero_stack, 1.0, int_stack+13110, 1.0, int_stack+13902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+47253,int_stack+9072,int_stack+42825, 0.0, zero_stack, 1.0, int_stack+36615, 1.0, int_stack+37803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+9831,int_stack+9786, 0.0, zero_stack, 2.0, int_stack+27348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+9894,int_stack+9831, 0.0, zero_stack, 2.0, int_stack+27393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9072,int_stack+31782,int_stack+42825, 0.0, zero_stack, 2.0, int_stack+36885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+10068,int_stack+9978, 0.0, zero_stack, 2.0, int_stack+13722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9342,int_stack+10194,int_stack+10068, 0.0, zero_stack, 2.0, int_stack+13902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9720,int_stack+9342,int_stack+42825, 0.0, zero_stack, 2.0, int_stack+37803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42825,int_stack+10407,int_stack+10362, 1.0, int_stack+24276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28161,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31782,int_stack+10470,int_stack+10407, 1.0, int_stack+24321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28269,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9342,int_stack+31782,int_stack+42825, 1.0, int_stack+31647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38073,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+31647,int_stack+10860,int_stack+10644, 1.0, int_stack+10554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14604,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42825,int_stack+10986,int_stack+10860, 1.0, int_stack+10734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14784,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10260,int_stack+42825,int_stack+31647, 1.0, int_stack+32511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38991,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+32511,int_stack+11199,int_stack+11154, 1.0, int_stack+25044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28161, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31647,int_stack+11262,int_stack+11199, 1.0, int_stack+25089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28269, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+42825,int_stack+31647,int_stack+32511, 1.0, int_stack+32781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38073, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+32511,int_stack+11652,int_stack+11436, 1.0, int_stack+11346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14604, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32781,int_stack+11778,int_stack+11652, 1.0, int_stack+11526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14784, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10800,int_stack+32781,int_stack+32511, 1.0, int_stack+33969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38991, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33969,int_stack+11991,int_stack+11946, 1.0, int_stack+25812, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28161, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+12054,int_stack+11991, 1.0, int_stack+25857, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28269, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+32700,int_stack+32511,int_stack+33969, 1.0, int_stack+34239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33969,int_stack+12444,int_stack+12228, 1.0, int_stack+12138, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14604, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34239,int_stack+12570,int_stack+12444, 1.0, int_stack+12318, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14784, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11340,int_stack+34239,int_stack+33969, 1.0, int_stack+35157, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38991, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+35157,int_stack+12783,int_stack+12738, 1.0, int_stack+26580, 0.0, zero_stack, 1.0, int_stack+28161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+12846,int_stack+12783, 1.0, int_stack+26625, 0.0, zero_stack, 1.0, int_stack+28269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33969,int_stack+32511,int_stack+35157, 1.0, int_stack+35427, 0.0, zero_stack, 1.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+35157,int_stack+13236,int_stack+13020, 1.0, int_stack+12930, 0.0, zero_stack, 1.0, int_stack+14604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35427,int_stack+13362,int_stack+13236, 1.0, int_stack+13110, 0.0, zero_stack, 1.0, int_stack+14784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11880,int_stack+35427,int_stack+35157, 1.0, int_stack+36615, 0.0, zero_stack, 1.0, int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36615,int_stack+13575,int_stack+13530, 1.0, int_stack+27348, 1.0, int_stack+28161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+13638,int_stack+13575, 1.0, int_stack+27393, 1.0, int_stack+28269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+35157,int_stack+32511,int_stack+36615, 1.0, int_stack+36885, 1.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36615,int_stack+14028,int_stack+13812, 1.0, int_stack+13722, 1.0, int_stack+14604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36885,int_stack+14154,int_stack+14028, 1.0, int_stack+13902, 1.0, int_stack+14784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12420,int_stack+36885,int_stack+36615, 1.0, int_stack+37803, 1.0, int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+37803,int_stack+14367,int_stack+14322, 2.0, int_stack+28161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+14430,int_stack+14367, 2.0, int_stack+28269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36615,int_stack+32511,int_stack+37803, 2.0, int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+37803,int_stack+14910,int_stack+14694, 2.0, int_stack+14604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38073,int_stack+15036,int_stack+14910, 2.0, int_stack+14784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12960,int_stack+38073,int_stack+37803, 2.0, int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+15249,int_stack+15204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29208,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+15312,int_stack+15249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29253,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+37803,int_stack+32511,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+15486,int_stack+15396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18276,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38073,int_stack+15612,int_stack+15486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18456,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13500,int_stack+38073,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+15825,int_stack+15780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29208, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+15888,int_stack+15825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29253, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38073,int_stack+32511,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+16062,int_stack+15972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18276, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36885,int_stack+16188,int_stack+16062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18456, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14040,int_stack+36885,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+16401,int_stack+16356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29208, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+16464,int_stack+16401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29253, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36885,int_stack+32511,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+16638,int_stack+16548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18276, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35427,int_stack+16764,int_stack+16638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18456, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14580,int_stack+35427,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+16977,int_stack+16932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+17040,int_stack+16977, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+35427,int_stack+32511,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+17214,int_stack+17124, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34239,int_stack+17340,int_stack+17214, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15120,int_stack+34239,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+17553,int_stack+17508, 0.0, zero_stack, 1.0, int_stack+29208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+17616,int_stack+17553, 0.0, zero_stack, 1.0, int_stack+29253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+34239,int_stack+32511,int_stack+38991, 0.0, zero_stack, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+17790,int_stack+17700, 0.0, zero_stack, 1.0, int_stack+18276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15660,int_stack+17916,int_stack+17790, 0.0, zero_stack, 1.0, int_stack+18456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+16038,int_stack+15660,int_stack+38991, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+18129,int_stack+18084, 1.0, int_stack+29208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+18192,int_stack+18129, 1.0, int_stack+29253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15660,int_stack+32511,int_stack+38991, 1.0, int_stack+31512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38991,int_stack+18582,int_stack+18366, 1.0, int_stack+18276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31512,int_stack+18708,int_stack+18582, 1.0, int_stack+18456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+16578,int_stack+31512,int_stack+38991, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+18921,int_stack+18876,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+18984,int_stack+18921,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+38991,int_stack+32511,int_stack+810,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+19158,int_stack+19068,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31512,int_stack+19284,int_stack+19158,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+17118,int_stack+31512,int_stack+810,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+19497,int_stack+19452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29976,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+19560,int_stack+19497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30021,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+31512,int_stack+32511,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40179,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+19734,int_stack+19644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22524,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+17658,int_stack+19860,int_stack+19734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22704,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18036,int_stack+17658,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41367,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+20073,int_stack+20028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29976, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+20136,int_stack+20073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30021, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17658,int_stack+32511,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40179, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+20310,int_stack+20220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22524, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18576,int_stack+20436,int_stack+20310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22704, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18954,int_stack+18576,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41367, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+20649,int_stack+20604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29976, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+20712,int_stack+20649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30021, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18576,int_stack+32511,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40179, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+20886,int_stack+20796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22524, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19494,int_stack+21012,int_stack+20886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22704, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+19872,int_stack+19494,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41367, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+21225,int_stack+21180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+21288,int_stack+21225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+19494,int_stack+32511,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+21462,int_stack+21372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20412,int_stack+21588,int_stack+21462, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+20790,int_stack+20412,int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+21801,int_stack+21756, 0.0, zero_stack, 1.0, int_stack+29976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+21864,int_stack+21801, 0.0, zero_stack, 1.0, int_stack+30021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+20412,int_stack+32511,int_stack+810, 0.0, zero_stack, 1.0, int_stack+40179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+22038,int_stack+21948, 0.0, zero_stack, 1.0, int_stack+22524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21330,int_stack+22164,int_stack+22038, 0.0, zero_stack, 1.0, int_stack+22704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+21708,int_stack+21330,int_stack+810, 0.0, zero_stack, 1.0, int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+22377,int_stack+22332, 1.0, int_stack+29976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+22440,int_stack+22377, 1.0, int_stack+30021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+21330,int_stack+32511,int_stack+810, 1.0, int_stack+40179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+22830,int_stack+22614, 1.0, int_stack+22524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+40179,int_stack+22956,int_stack+22830, 1.0, int_stack+22704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22248,int_stack+40179,int_stack+810, 1.0, int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+23169,int_stack+23124,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+23232,int_stack+23169,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+810,int_stack+32511,int_stack+41367,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+23406,int_stack+23316,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+40179,int_stack+23532,int_stack+23406,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+22788,int_stack+40179,int_stack+41367,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+23745,int_stack+23700,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+23808,int_stack+23745,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+40179,int_stack+32511,int_stack+41367,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+23982,int_stack+23892,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+23328,int_stack+24108,int_stack+23982,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+23706,int_stack+23328,int_stack+41367,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+24513,int_stack+24468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30744,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+24576,int_stack+24513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30789,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+23328,int_stack+32511,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41637,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+24750,int_stack+24660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28608,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24246,int_stack+24876,int_stack+24750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28788,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+24624,int_stack+24246,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42555,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+25281,int_stack+25236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30744, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+25344,int_stack+25281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30789, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+24246,int_stack+32511,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41637, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+25518,int_stack+25428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28608, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+47793,int_stack+25644,int_stack+25518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28788, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+25164,int_stack+47793,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42555, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+26049,int_stack+26004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30744, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+26112,int_stack+26049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30789, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+47793,int_stack+32511,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41637, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+26286,int_stack+26196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28608, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+48063,int_stack+26412,int_stack+26286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28788, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+48441,int_stack+48063,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42555, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+26817,int_stack+26772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+26880,int_stack+26817, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+48063,int_stack+32511,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+27054,int_stack+26964, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25704,int_stack+27180,int_stack+27054, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+26082,int_stack+25704,int_stack+41367, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+27585,int_stack+27540, 0.0, zero_stack, 1.0, int_stack+30744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+27648,int_stack+27585, 0.0, zero_stack, 1.0, int_stack+30789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+25704,int_stack+32511,int_stack+41367, 0.0, zero_stack, 1.0, int_stack+41637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+27822,int_stack+27732, 0.0, zero_stack, 1.0, int_stack+28608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26622,int_stack+27948,int_stack+27822, 0.0, zero_stack, 1.0, int_stack+28788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27000,int_stack+26622,int_stack+41367, 0.0, zero_stack, 1.0, int_stack+42555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+28461,int_stack+28416, 1.0, int_stack+30744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+28524,int_stack+28461, 1.0, int_stack+30789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+26622,int_stack+32511,int_stack+41367, 1.0, int_stack+41637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41367,int_stack+28914,int_stack+28698, 1.0, int_stack+28608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+41637,int_stack+29040,int_stack+28914, 1.0, int_stack+28788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27540,int_stack+41637,int_stack+41367, 1.0, int_stack+42555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+42555,int_stack+29445,int_stack+29400,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+29508,int_stack+29445,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+41367,int_stack+32511,int_stack+42555,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+42555,int_stack+29682,int_stack+29592,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+41637,int_stack+29808,int_stack+29682,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+28080,int_stack+41637,int_stack+42555,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+42555,int_stack+30213,int_stack+30168,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+30276,int_stack+30213,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+41637,int_stack+32511,int_stack+42555,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+42555,int_stack+30450,int_stack+30360,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+28620,int_stack+30576,int_stack+30450,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+28998,int_stack+28620,int_stack+42555,6);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+42555,int_stack+30981,int_stack+30936,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+32511,int_stack+31044,int_stack+30981,3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+28620,int_stack+32511,int_stack+42555,3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+42555,int_stack+31218,int_stack+31128,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+29538,int_stack+31344,int_stack+31218,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+29916,int_stack+29538,int_stack+42555,6);
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+30456,int_stack+33159,int_stack+31971,90);
     Libderiv->ABCD[11] = int_stack + 30456;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+48981,int_stack+34617,int_stack+33699,90);
     Libderiv->ABCD[10] = int_stack + 48981;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+49791,int_stack+35805,int_stack+0,90);
     Libderiv->ABCD[9] = int_stack + 49791;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+50601,int_stack+37263,int_stack+36345,90);
     Libderiv->ABCD[8] = int_stack + 50601;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+51411,int_stack+38451,int_stack+270,90);
     Libderiv->ABCD[7] = int_stack + 51411;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+52221,int_stack+39639,int_stack+540,90);
     Libderiv->ABCD[6] = int_stack + 52221;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+53031,int_stack+40557,int_stack+39261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[2] = int_stack + 53031;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+53841,int_stack+42015,int_stack+41097, 0.0, zero_stack, 1.0, int_stack+32241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[1] = int_stack + 53841;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+41907,int_stack+43203,int_stack+1080, 1.0, int_stack+32241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[0] = int_stack + 41907;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+54651,int_stack+43743,int_stack+1350,90);
     Libderiv->ABCD[155] = int_stack + 54651;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+43095,int_stack+2268,int_stack+1620,90);
     Libderiv->ABCD[143] = int_stack + 43095;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+55461,int_stack+2808,int_stack+1890,90);
     Libderiv->ABCD[142] = int_stack + 55461;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1350,int_stack+3348,int_stack+44283,90);
     Libderiv->ABCD[131] = int_stack + 1350;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2160,int_stack+44823,int_stack+44553,90);
     Libderiv->ABCD[130] = int_stack + 2160;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2970,int_stack+4536,int_stack+3888,90);
     Libderiv->ABCD[129] = int_stack + 2970;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+43905,int_stack+45363,int_stack+4158,90);
     Libderiv->ABCD[119] = int_stack + 43905;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3780,int_stack+5724,int_stack+5076,90);
     Libderiv->ABCD[118] = int_stack + 3780;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+44715,int_stack+6264,int_stack+5346,90);
     Libderiv->ABCD[117] = int_stack + 44715;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4590,int_stack+6804,int_stack+45903,90);
     Libderiv->ABCD[116] = int_stack + 4590;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+5400,int_stack+7344,int_stack+46173,90);
     Libderiv->ABCD[107] = int_stack + 5400;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+6210,int_stack+46713,int_stack+46443,90);
     Libderiv->ABCD[106] = int_stack + 6210;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+7020,int_stack+8532,int_stack+7884,90);
     Libderiv->ABCD[105] = int_stack + 7020;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+45525,int_stack+47253,int_stack+8154,90);
     Libderiv->ABCD[104] = int_stack + 45525;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+7830,int_stack+9720,int_stack+9072,90);
     Libderiv->ABCD[103] = int_stack + 7830;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+46335,int_stack+10260,int_stack+9342,90);
     Libderiv->ABCD[95] = int_stack + 46335;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+8640,int_stack+10800,int_stack+42825,90);
     Libderiv->ABCD[94] = int_stack + 8640;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+9450,int_stack+11340,int_stack+32700,90);
     Libderiv->ABCD[93] = int_stack + 9450;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+10260,int_stack+11880,int_stack+33969,90);
     Libderiv->ABCD[92] = int_stack + 10260;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+11070,int_stack+12420,int_stack+35157,90);
     Libderiv->ABCD[91] = int_stack + 11070;
 /*--- compute (pp|gd) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+11880,int_stack+12960,int_stack+36615,90);
     Libderiv->ABCD[90] = int_stack + 11880;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+12690,int_stack+13500,int_stack+37803, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[47] = int_stack + 12690;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+32241,int_stack+14040,int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[46] = int_stack + 32241;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+13500,int_stack+14580,int_stack+36885, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[45] = int_stack + 13500;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+14310,int_stack+15120,int_stack+35427, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[44] = int_stack + 14310;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+36615,int_stack+16038,int_stack+34239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[43] = int_stack + 36615;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+37425,int_stack+16578,int_stack+15660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[42] = int_stack + 37425;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+15120,int_stack+17118,int_stack+38991, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+39261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[38] = int_stack + 15120;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+15930,int_stack+18036,int_stack+31512, 0.0, zero_stack, 1.0, int_stack+31971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[35] = int_stack + 15930;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+16740,int_stack+18954,int_stack+17658, 0.0, zero_stack, 1.0, int_stack+33699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[34] = int_stack + 16740;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+17550,int_stack+19872,int_stack+18576, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[33] = int_stack + 17550;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+18360,int_stack+20790,int_stack+19494, 0.0, zero_stack, 1.0, int_stack+36345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[32] = int_stack + 18360;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+19170,int_stack+21708,int_stack+20412, 0.0, zero_stack, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[31] = int_stack + 19170;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+19980,int_stack+22248,int_stack+21330, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[30] = int_stack + 19980;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+20790,int_stack+22788,int_stack+810, 0.0, zero_stack, 1.0, int_stack+39261, 1.0, int_stack+41097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[26] = int_stack + 20790;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+21600,int_stack+23706,int_stack+40179, 0.0, zero_stack, 2.0, int_stack+41097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[25] = int_stack + 21600;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+22410,int_stack+24624,int_stack+23328, 1.0, int_stack+31971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[23] = int_stack + 22410;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+23220,int_stack+25164,int_stack+24246, 1.0, int_stack+33699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[22] = int_stack + 23220;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+24030,int_stack+48441,int_stack+47793, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[21] = int_stack + 24030;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+24840,int_stack+26082,int_stack+48063, 1.0, int_stack+36345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[20] = int_stack + 24840;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+38235,int_stack+27000,int_stack+25704, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[19] = int_stack + 38235;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+25650,int_stack+27540,int_stack+26622, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[18] = int_stack + 25650;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+0,int_stack+28080,int_stack+41367, 1.0, int_stack+39261, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[14] = int_stack + 0;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+26460,int_stack+28998,int_stack+41637, 1.0, int_stack+41097, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[13] = int_stack + 26460;
 /*--- compute (pp|gd) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+27270,int_stack+29916,int_stack+28620, 2.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[12] = int_stack + 27270;

}
