/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ddid(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|id) integrals */

void d1hrr_order_ddid(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][7][11] = int_stack + 168;
 Libderiv->deriv_classes[2][8][11] = int_stack + 384;
 Libderiv->deriv_classes[3][6][11] = int_stack + 654;
 Libderiv->deriv_classes[3][7][11] = int_stack + 934;
 Libderiv->deriv_classes[3][8][11] = int_stack + 1294;
 Libderiv->deriv_classes[4][6][11] = int_stack + 1744;
 Libderiv->deriv_classes[4][7][11] = int_stack + 2164;
 Libderiv->deriv_classes[4][8][11] = int_stack + 2704;
 Libderiv->deriv_classes[2][6][10] = int_stack + 3379;
 Libderiv->deriv_classes[2][7][10] = int_stack + 3547;
 Libderiv->deriv_classes[2][8][10] = int_stack + 3763;
 Libderiv->deriv_classes[3][6][10] = int_stack + 4033;
 Libderiv->deriv_classes[3][7][10] = int_stack + 4313;
 Libderiv->deriv_classes[3][8][10] = int_stack + 4673;
 Libderiv->deriv_classes[4][6][10] = int_stack + 5123;
 Libderiv->deriv_classes[4][7][10] = int_stack + 5543;
 Libderiv->deriv_classes[4][8][10] = int_stack + 6083;
 Libderiv->deriv_classes[2][6][9] = int_stack + 6758;
 Libderiv->deriv_classes[2][7][9] = int_stack + 6926;
 Libderiv->deriv_classes[2][8][9] = int_stack + 7142;
 Libderiv->deriv_classes[3][6][9] = int_stack + 7412;
 Libderiv->deriv_classes[3][7][9] = int_stack + 7692;
 Libderiv->deriv_classes[3][8][9] = int_stack + 8052;
 Libderiv->deriv_classes[4][6][9] = int_stack + 8502;
 Libderiv->deriv_classes[4][7][9] = int_stack + 8922;
 Libderiv->deriv_classes[4][8][9] = int_stack + 9462;
 Libderiv->deriv_classes[2][6][8] = int_stack + 10137;
 Libderiv->deriv_classes[2][7][8] = int_stack + 10305;
 Libderiv->deriv_classes[2][8][8] = int_stack + 10521;
 Libderiv->deriv_classes[3][6][8] = int_stack + 10791;
 Libderiv->deriv_classes[3][7][8] = int_stack + 11071;
 Libderiv->deriv_classes[3][8][8] = int_stack + 11431;
 Libderiv->deriv_classes[4][6][8] = int_stack + 11881;
 Libderiv->deriv_classes[4][7][8] = int_stack + 12301;
 Libderiv->deriv_classes[4][8][8] = int_stack + 12841;
 Libderiv->deriv_classes[2][6][7] = int_stack + 13516;
 Libderiv->deriv_classes[2][7][7] = int_stack + 13684;
 Libderiv->deriv_classes[2][8][7] = int_stack + 13900;
 Libderiv->deriv_classes[3][6][7] = int_stack + 14170;
 Libderiv->deriv_classes[3][7][7] = int_stack + 14450;
 Libderiv->deriv_classes[3][8][7] = int_stack + 14810;
 Libderiv->deriv_classes[4][6][7] = int_stack + 15260;
 Libderiv->deriv_classes[4][7][7] = int_stack + 15680;
 Libderiv->deriv_classes[4][8][7] = int_stack + 16220;
 Libderiv->deriv_classes[2][6][6] = int_stack + 16895;
 Libderiv->deriv_classes[2][7][6] = int_stack + 17063;
 Libderiv->deriv_classes[2][8][6] = int_stack + 17279;
 Libderiv->deriv_classes[3][6][6] = int_stack + 17549;
 Libderiv->deriv_classes[3][7][6] = int_stack + 17829;
 Libderiv->deriv_classes[3][8][6] = int_stack + 18189;
 Libderiv->dvrr_classes[4][6] = int_stack + 18639;
 Libderiv->deriv_classes[4][6][6] = int_stack + 19059;
 Libderiv->dvrr_classes[4][7] = int_stack + 19479;
 Libderiv->deriv_classes[4][7][6] = int_stack + 20019;
 Libderiv->deriv_classes[4][8][6] = int_stack + 20559;
 Libderiv->deriv_classes[2][6][2] = int_stack + 21234;
 Libderiv->deriv_classes[2][7][2] = int_stack + 21402;
 Libderiv->deriv_classes[2][8][2] = int_stack + 21618;
 Libderiv->deriv_classes[3][6][2] = int_stack + 21888;
 Libderiv->deriv_classes[3][7][2] = int_stack + 22168;
 Libderiv->deriv_classes[3][8][2] = int_stack + 22528;
 Libderiv->deriv_classes[4][6][2] = int_stack + 22978;
 Libderiv->deriv_classes[4][7][2] = int_stack + 23398;
 Libderiv->deriv_classes[4][8][2] = int_stack + 23938;
 Libderiv->deriv_classes[2][6][1] = int_stack + 24613;
 Libderiv->deriv_classes[2][7][1] = int_stack + 24781;
 Libderiv->deriv_classes[2][8][1] = int_stack + 24997;
 Libderiv->deriv_classes[3][6][1] = int_stack + 25267;
 Libderiv->deriv_classes[3][7][1] = int_stack + 25547;
 Libderiv->deriv_classes[3][8][1] = int_stack + 25907;
 Libderiv->deriv_classes[4][6][1] = int_stack + 26357;
 Libderiv->deriv_classes[4][7][1] = int_stack + 26777;
 Libderiv->deriv_classes[4][8][1] = int_stack + 27317;
 Libderiv->dvrr_classes[2][6] = int_stack + 27992;
 Libderiv->dvrr_classes[2][7] = int_stack + 28160;
 Libderiv->dvrr_classes[2][8] = int_stack + 28376;
 Libderiv->deriv_classes[2][6][0] = int_stack + 28646;
 Libderiv->deriv_classes[2][7][0] = int_stack + 28814;
 Libderiv->deriv_classes[2][8][0] = int_stack + 29030;
 Libderiv->dvrr_classes[3][6] = int_stack + 29300;
 Libderiv->dvrr_classes[3][7] = int_stack + 29580;
 Libderiv->dvrr_classes[3][8] = int_stack + 29940;
 Libderiv->deriv_classes[3][6][0] = int_stack + 30390;
 Libderiv->deriv_classes[3][7][0] = int_stack + 30670;
 Libderiv->deriv_classes[3][8][0] = int_stack + 31030;
 Libderiv->deriv_classes[4][6][0] = int_stack + 31480;
 Libderiv->deriv_classes[4][7][0] = int_stack + 31900;
 Libderiv->deriv_classes[4][8][0] = int_stack + 32440;
 memset(int_stack,0,264920);

 Libderiv->dvrr_stack = int_stack + 103675;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ddid(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+33115,int_stack+28160,int_stack+27992,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33619,int_stack+168,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27992,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+34123,int_stack+384,int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28160,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+34771,int_stack+34123,int_stack+33619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33115,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+33619,int_stack+29580,int_stack+29300,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+35779,int_stack+934,int_stack+654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29300,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36619,int_stack+1294,int_stack+934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29580,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+36619,int_stack+35779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33619,10);
 /*--- compute (dp|id) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+35779,int_stack+0,int_stack+34771,168);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+34459,int_stack+19479,int_stack+18639,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38803,int_stack+2164,int_stack+1744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18639,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40063,int_stack+2704,int_stack+2164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19479,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41683,int_stack+40063,int_stack+38803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34459,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+44203,int_stack+41683,int_stack+0,168);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+3547,int_stack+3379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27992, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+3763,int_stack+3547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28160, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+504,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33115, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+4313,int_stack+4033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29300, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2160,int_stack+4673,int_stack+4313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29580, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3240,int_stack+2160,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33619, 0.0, zero_stack,10);
 /*--- compute (dp|id) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+38803,int_stack+3240,int_stack+1152,168);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+5543,int_stack+5123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18639, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1260,int_stack+6083,int_stack+5543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19479, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+49243,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34459, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+51763,int_stack+49243,int_stack+3240,168);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49243,int_stack+6926,int_stack+6758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27992, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+49747,int_stack+7142,int_stack+6926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28160, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+50395,int_stack+49747,int_stack+49243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33115, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49243,int_stack+7692,int_stack+7412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29300, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+8052,int_stack+7692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29580, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1080,int_stack+0,int_stack+49243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33619, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|id) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2760,int_stack+1080,int_stack+50395,168);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49243,int_stack+8922,int_stack+8502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18639, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5784,int_stack+9462,int_stack+8922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19479, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7404,int_stack+5784,int_stack+49243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34459, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+56803,int_stack+7404,int_stack+1080,168);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49243,int_stack+10305,int_stack+10137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+49747,int_stack+10521,int_stack+10305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+50395,int_stack+49747,int_stack+49243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49243,int_stack+11071,int_stack+10791, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5784,int_stack+11431,int_stack+11071, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6864,int_stack+5784,int_stack+49243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|id) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+8544,int_stack+6864,int_stack+50395,168);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49243,int_stack+12301,int_stack+11881, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+12841,int_stack+12301, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+61843,int_stack+0,int_stack+49243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+64363,int_stack+61843,int_stack+6864,168);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+61843,int_stack+13684,int_stack+13516, 0.0, zero_stack, 1.0, int_stack+27992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+62347,int_stack+13900,int_stack+13684, 0.0, zero_stack, 1.0, int_stack+28160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+62995,int_stack+62347,int_stack+61843, 0.0, zero_stack, 1.0, int_stack+33115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+61843,int_stack+14450,int_stack+14170, 0.0, zero_stack, 1.0, int_stack+29300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+49243,int_stack+14810,int_stack+14450, 0.0, zero_stack, 1.0, int_stack+29580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+49243,int_stack+61843, 0.0, zero_stack, 1.0, int_stack+33619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|id) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+11568,int_stack+0,int_stack+62995,168);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+61843,int_stack+15680,int_stack+15260, 0.0, zero_stack, 1.0, int_stack+18639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+49243,int_stack+16220,int_stack+15680, 0.0, zero_stack, 1.0, int_stack+19479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5784,int_stack+49243,int_stack+61843, 0.0, zero_stack, 1.0, int_stack+34459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+69403,int_stack+5784,int_stack+0,168);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+17063,int_stack+16895, 1.0, int_stack+27992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+17279,int_stack+17063, 1.0, int_stack+28160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+504,int_stack+0, 1.0, int_stack+33115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+17829,int_stack+17549, 1.0, int_stack+29300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5784,int_stack+18189,int_stack+17829, 1.0, int_stack+29580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6864,int_stack+5784,int_stack+0, 1.0, int_stack+33619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|id) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+14592,int_stack+6864,int_stack+1152,168);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+20019,int_stack+19059, 1.0, int_stack+18639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61843,int_stack+20559,int_stack+20019, 1.0, int_stack+19479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+49243,int_stack+61843,int_stack+0, 1.0, int_stack+34459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|id) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+74443,int_stack+49243,int_stack+6864,168);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+49243,int_stack+28376,int_stack+28160,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+49891,int_stack+49243,int_stack+33115,6);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+34459,int_stack+29940,int_stack+29580,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+34459,int_stack+33619,10);
 /*--- compute (dp|id) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+17616,int_stack+0,int_stack+49891,168);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+33115,int_stack+21402,int_stack+21234,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+49243,int_stack+21618,int_stack+21402,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+33619,int_stack+49243,int_stack+33115,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+34627,int_stack+22168,int_stack+21888,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1680,int_stack+22528,int_stack+22168,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+61843,int_stack+1680,int_stack+34627,10);
 /*--- compute (dp|id) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+79483,int_stack+61843,int_stack+33619, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+33115,int_stack+23398,int_stack+22978,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5784,int_stack+23938,int_stack+23398,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+20640,int_stack+5784,int_stack+33115,15);
 /*--- compute (fp|id) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+82507,int_stack+20640,int_stack+61843, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+61843,int_stack+24781,int_stack+24613,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+49243,int_stack+24997,int_stack+24781,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+62347,int_stack+49243,int_stack+61843,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+63355,int_stack+25547,int_stack+25267,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1680,int_stack+25907,int_stack+25547,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+20640,int_stack+1680,int_stack+63355,10);
 /*--- compute (dp|id) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+22320,int_stack+20640,int_stack+62347, 0.0, zero_stack, 1.0, int_stack+49891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+61843,int_stack+26777,int_stack+26357,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+33115,int_stack+27317,int_stack+26777,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+25344,int_stack+33115,int_stack+61843,15);
 /*--- compute (fp|id) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+87547,int_stack+25344,int_stack+20640, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20640,int_stack+28814,int_stack+28646,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+49243,int_stack+29030,int_stack+28814,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+21144,int_stack+49243,int_stack+20640,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+25344,int_stack+30670,int_stack+30390,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1680,int_stack+31030,int_stack+30670,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+26184,int_stack+1680,int_stack+25344,10);
 /*--- compute (dp|id) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+27864,int_stack+26184,int_stack+21144, 1.0, int_stack+49891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20640,int_stack+31900,int_stack+31480,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+49243,int_stack+32440,int_stack+31900,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+61843,int_stack+49243,int_stack+20640,15);
 /*--- compute (fp|id) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+92587,int_stack+61843,int_stack+26184, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (dd|id) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+97627,int_stack+44203,int_stack+35779,168);
     Libderiv->ABCD[11] = int_stack + 97627;
 /*--- compute (dd|id) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+30888,int_stack+51763,int_stack+38803,168);
     Libderiv->ABCD[10] = int_stack + 30888;
 /*--- compute (dd|id) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+36936,int_stack+56803,int_stack+2760,168);
     Libderiv->ABCD[9] = int_stack + 36936;
 /*--- compute (dd|id) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+0,int_stack+64363,int_stack+8544,168);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (dd|id) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+42984,int_stack+69403,int_stack+11568,168);
     Libderiv->ABCD[7] = int_stack + 42984;
 /*--- compute (dd|id) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+6048,int_stack+74443,int_stack+14592,168);
     Libderiv->ABCD[6] = int_stack + 6048;
 /*--- compute (dd|id) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+49032,int_stack+82507,int_stack+79483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[2] = int_stack + 49032;
 /*--- compute (dd|id) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+55080,int_stack+87547,int_stack+22320, 0.0, zero_stack, 1.0, int_stack+17616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[1] = int_stack + 55080;
 /*--- compute (dd|id) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+20640,int_stack+92587,int_stack+27864, 1.0, int_stack+17616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[0] = int_stack + 20640;

}
