/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_f0hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (f0|hd) integrals */

void d1hrr_order_f0hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][6][11] = int_stack + 210;
 Libderiv->deriv_classes[3][7][11] = int_stack + 490;
 Libderiv->deriv_classes[3][5][10] = int_stack + 850;
 Libderiv->deriv_classes[3][6][10] = int_stack + 1060;
 Libderiv->deriv_classes[3][7][10] = int_stack + 1340;
 Libderiv->deriv_classes[3][5][9] = int_stack + 1700;
 Libderiv->deriv_classes[3][6][9] = int_stack + 1910;
 Libderiv->deriv_classes[3][7][9] = int_stack + 2190;
 Libderiv->deriv_classes[3][5][8] = int_stack + 2550;
 Libderiv->deriv_classes[3][6][8] = int_stack + 2760;
 Libderiv->deriv_classes[3][7][8] = int_stack + 3040;
 Libderiv->deriv_classes[3][5][7] = int_stack + 3400;
 Libderiv->deriv_classes[3][6][7] = int_stack + 3610;
 Libderiv->deriv_classes[3][7][7] = int_stack + 3890;
 Libderiv->dvrr_classes[3][5] = int_stack + 4250;
 Libderiv->deriv_classes[3][5][6] = int_stack + 4460;
 Libderiv->dvrr_classes[3][6] = int_stack + 4670;
 Libderiv->deriv_classes[3][6][6] = int_stack + 4950;
 Libderiv->deriv_classes[3][7][6] = int_stack + 5230;
 Libderiv->deriv_classes[3][5][2] = int_stack + 5590;
 Libderiv->deriv_classes[3][6][2] = int_stack + 5800;
 Libderiv->deriv_classes[3][7][2] = int_stack + 6080;
 Libderiv->deriv_classes[3][5][1] = int_stack + 6440;
 Libderiv->deriv_classes[3][6][1] = int_stack + 6650;
 Libderiv->deriv_classes[3][7][1] = int_stack + 6930;
 Libderiv->deriv_classes[3][5][0] = int_stack + 7290;
 Libderiv->deriv_classes[3][6][0] = int_stack + 7500;
 Libderiv->deriv_classes[3][7][0] = int_stack + 7780;
 memset(int_stack,0,65120);

 Libderiv->dvrr_stack = int_stack + 16540;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_f0hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8140,int_stack+4670,int_stack+4250,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8770,int_stack+210,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9400,int_stack+490,int_stack+210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4670,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+1060,int_stack+850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10240,int_stack+1340,int_stack+1060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4670, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+630,int_stack+1910,int_stack+1700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11080,int_stack+2190,int_stack+1910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4670, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+2760,int_stack+2550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1890,int_stack+3040,int_stack+2760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2730,int_stack+3610,int_stack+3400, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11920,int_stack+3890,int_stack+3610, 0.0, zero_stack, 1.0, int_stack+4670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3360,int_stack+4950,int_stack+4460, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12760,int_stack+5230,int_stack+4950, 1.0, int_stack+4670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3990,int_stack+5800,int_stack+5590,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+6080,int_stack+5800,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5460,int_stack+6650,int_stack+6440,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+13600,int_stack+6930,int_stack+6650,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6090,int_stack+7500,int_stack+7290,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14440,int_stack+7780,int_stack+7500,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6720,int_stack+9400,int_stack+8770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140,10);
     Libderiv->ABCD[11] = int_stack + 6720;
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8770,int_stack+10240,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack,10);
     Libderiv->ABCD[10] = int_stack + 8770;
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15280,int_stack+11080,int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[9] = int_stack + 15280;
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+1890,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1260,int_stack+11920,int_stack+2730, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[7] = int_stack + 1260;
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10030,int_stack+12760,int_stack+3360, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[6] = int_stack + 10030;
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2520,int_stack+4620,int_stack+3990,10);
     Libderiv->ABCD[2] = int_stack + 2520;
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3780,int_stack+13600,int_stack+5460,10);
     Libderiv->ABCD[1] = int_stack + 3780;
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+11290,int_stack+14440,int_stack+6090,10);
     Libderiv->ABCD[0] = int_stack + 11290;

}
