/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_f0id(Libderiv_t *, prim_data *);

  /* Computes derivatives of (f0|id) integrals */

void d1hrr_order_f0id(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][6][11] = int_stack + 0;
 Libderiv->deriv_classes[3][7][11] = int_stack + 280;
 Libderiv->deriv_classes[3][8][11] = int_stack + 640;
 Libderiv->deriv_classes[3][6][10] = int_stack + 1090;
 Libderiv->deriv_classes[3][7][10] = int_stack + 1370;
 Libderiv->deriv_classes[3][8][10] = int_stack + 1730;
 Libderiv->deriv_classes[3][6][9] = int_stack + 2180;
 Libderiv->deriv_classes[3][7][9] = int_stack + 2460;
 Libderiv->deriv_classes[3][8][9] = int_stack + 2820;
 Libderiv->deriv_classes[3][6][8] = int_stack + 3270;
 Libderiv->deriv_classes[3][7][8] = int_stack + 3550;
 Libderiv->deriv_classes[3][8][8] = int_stack + 3910;
 Libderiv->deriv_classes[3][6][7] = int_stack + 4360;
 Libderiv->deriv_classes[3][7][7] = int_stack + 4640;
 Libderiv->deriv_classes[3][8][7] = int_stack + 5000;
 Libderiv->dvrr_classes[3][6] = int_stack + 5450;
 Libderiv->deriv_classes[3][6][6] = int_stack + 5730;
 Libderiv->dvrr_classes[3][7] = int_stack + 6010;
 Libderiv->deriv_classes[3][7][6] = int_stack + 6370;
 Libderiv->deriv_classes[3][8][6] = int_stack + 6730;
 Libderiv->deriv_classes[3][6][2] = int_stack + 7180;
 Libderiv->deriv_classes[3][7][2] = int_stack + 7460;
 Libderiv->deriv_classes[3][8][2] = int_stack + 7820;
 Libderiv->deriv_classes[3][6][1] = int_stack + 8270;
 Libderiv->deriv_classes[3][7][1] = int_stack + 8550;
 Libderiv->deriv_classes[3][8][1] = int_stack + 8910;
 Libderiv->deriv_classes[3][6][0] = int_stack + 9360;
 Libderiv->deriv_classes[3][7][0] = int_stack + 9640;
 Libderiv->deriv_classes[3][8][0] = int_stack + 10000;
 memset(int_stack,0,83600);

 Libderiv->dvrr_stack = int_stack + 23050;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_f0id(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10450,int_stack+6010,int_stack+5450,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11290,int_stack+280,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5450,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12130,int_stack+640,int_stack+280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6010,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+1370,int_stack+1090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5450, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+13210,int_stack+1730,int_stack+1370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6010, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+840,int_stack+2460,int_stack+2180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5450, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14290,int_stack+2820,int_stack+2460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6010, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1680,int_stack+3550,int_stack+3270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15370,int_stack+3910,int_stack+3550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2520,int_stack+4640,int_stack+4360, 0.0, zero_stack, 1.0, int_stack+5450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3360,int_stack+5000,int_stack+4640, 0.0, zero_stack, 1.0, int_stack+6010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4440,int_stack+6370,int_stack+5730, 1.0, int_stack+5450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+16450,int_stack+6730,int_stack+6370, 1.0, int_stack+6010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5280,int_stack+7460,int_stack+7180,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6120,int_stack+7820,int_stack+7460,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7200,int_stack+8550,int_stack+8270,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+17530,int_stack+8910,int_stack+8550,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8040,int_stack+9640,int_stack+9360,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+18610,int_stack+10000,int_stack+9640,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19690,int_stack+12130,int_stack+11290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10450,10);
     Libderiv->ABCD[11] = int_stack + 19690;
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11290,int_stack+13210,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10450, 0.0, zero_stack,10);
     Libderiv->ABCD[10] = int_stack + 11290;
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21370,int_stack+14290,int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10450, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[9] = int_stack + 21370;
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+15370,int_stack+1680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12970,int_stack+3360,int_stack+2520, 0.0, zero_stack, 1.0, int_stack+10450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[7] = int_stack + 12970;
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1680,int_stack+16450,int_stack+4440, 1.0, int_stack+10450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[6] = int_stack + 1680;
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3360,int_stack+6120,int_stack+5280,10);
     Libderiv->ABCD[2] = int_stack + 3360;
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5040,int_stack+17530,int_stack+7200,10);
     Libderiv->ABCD[1] = int_stack + 5040;
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14650,int_stack+18610,int_stack+8040,10);
     Libderiv->ABCD[0] = int_stack + 14650;

}
