/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_g0hg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|hg) integrals */

void d1hrr_order_g0hg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 315;
 Libderiv->deriv_classes[4][7][11] = int_stack + 735;
 Libderiv->deriv_classes[4][8][11] = int_stack + 1275;
 Libderiv->deriv_classes[4][9][11] = int_stack + 1950;
 Libderiv->deriv_classes[4][5][10] = int_stack + 2775;
 Libderiv->deriv_classes[4][6][10] = int_stack + 3090;
 Libderiv->deriv_classes[4][7][10] = int_stack + 3510;
 Libderiv->deriv_classes[4][8][10] = int_stack + 4050;
 Libderiv->deriv_classes[4][9][10] = int_stack + 4725;
 Libderiv->deriv_classes[4][5][9] = int_stack + 5550;
 Libderiv->deriv_classes[4][6][9] = int_stack + 5865;
 Libderiv->deriv_classes[4][7][9] = int_stack + 6285;
 Libderiv->deriv_classes[4][8][9] = int_stack + 6825;
 Libderiv->deriv_classes[4][9][9] = int_stack + 7500;
 Libderiv->deriv_classes[4][5][8] = int_stack + 8325;
 Libderiv->deriv_classes[4][6][8] = int_stack + 8640;
 Libderiv->deriv_classes[4][7][8] = int_stack + 9060;
 Libderiv->deriv_classes[4][8][8] = int_stack + 9600;
 Libderiv->deriv_classes[4][9][8] = int_stack + 10275;
 Libderiv->deriv_classes[4][5][7] = int_stack + 11100;
 Libderiv->deriv_classes[4][6][7] = int_stack + 11415;
 Libderiv->deriv_classes[4][7][7] = int_stack + 11835;
 Libderiv->deriv_classes[4][8][7] = int_stack + 12375;
 Libderiv->deriv_classes[4][9][7] = int_stack + 13050;
 Libderiv->dvrr_classes[4][5] = int_stack + 13875;
 Libderiv->deriv_classes[4][5][6] = int_stack + 14190;
 Libderiv->dvrr_classes[4][6] = int_stack + 14505;
 Libderiv->deriv_classes[4][6][6] = int_stack + 14925;
 Libderiv->dvrr_classes[4][7] = int_stack + 15345;
 Libderiv->deriv_classes[4][7][6] = int_stack + 15885;
 Libderiv->dvrr_classes[4][8] = int_stack + 16425;
 Libderiv->deriv_classes[4][8][6] = int_stack + 17100;
 Libderiv->deriv_classes[4][9][6] = int_stack + 17775;
 Libderiv->deriv_classes[4][5][2] = int_stack + 18600;
 Libderiv->deriv_classes[4][6][2] = int_stack + 18915;
 Libderiv->deriv_classes[4][7][2] = int_stack + 19335;
 Libderiv->deriv_classes[4][8][2] = int_stack + 19875;
 Libderiv->deriv_classes[4][9][2] = int_stack + 20550;
 Libderiv->deriv_classes[4][5][1] = int_stack + 21375;
 Libderiv->deriv_classes[4][6][1] = int_stack + 21690;
 Libderiv->deriv_classes[4][7][1] = int_stack + 22110;
 Libderiv->deriv_classes[4][8][1] = int_stack + 22650;
 Libderiv->deriv_classes[4][9][1] = int_stack + 23325;
 Libderiv->deriv_classes[4][5][0] = int_stack + 24150;
 Libderiv->deriv_classes[4][6][0] = int_stack + 24465;
 Libderiv->deriv_classes[4][7][0] = int_stack + 24885;
 Libderiv->deriv_classes[4][8][0] = int_stack + 25425;
 Libderiv->deriv_classes[4][9][0] = int_stack + 26100;
 memset(int_stack,0,215400);

 Libderiv->dvrr_stack = int_stack + 90795;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_g0hg(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26925,int_stack+14505,int_stack+13875,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+27870,int_stack+15345,int_stack+14505,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+29130,int_stack+27870,int_stack+26925,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+31020,int_stack+16425,int_stack+15345,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+32640,int_stack+31020,int_stack+27870,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+35160,int_stack+32640,int_stack+29130,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38310,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13875,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+39255,int_stack+735,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14505,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+40515,int_stack+39255,int_stack+38310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26925,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42405,int_stack+1275,int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15345,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+44025,int_stack+42405,int_stack+39255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27870,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+46545,int_stack+44025,int_stack+40515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29130,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+38310,int_stack+1950,int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16425,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+49695,int_stack+38310,int_stack+42405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31020,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38310,int_stack+49695,int_stack+44025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32640,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+49695,int_stack+3090,int_stack+2775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13875, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+50640,int_stack+3510,int_stack+3090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14505, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+42510,int_stack+50640,int_stack+49695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26925, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+44400,int_stack+4050,int_stack+3510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15345, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+44400,int_stack+50640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27870, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+49695,int_stack+0,int_stack+42510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29130, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+52845,int_stack+4725,int_stack+4050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16425, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+54870,int_stack+52845,int_stack+44400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31020, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+58110,int_stack+54870,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32640, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+5865,int_stack+5550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13875, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+945,int_stack+6285,int_stack+5865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14505, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2205,int_stack+945,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26925, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4095,int_stack+6825,int_stack+6285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15345, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+52845,int_stack+4095,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27870, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+42510,int_stack+52845,int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29130, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+7500,int_stack+6825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16425, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+62310,int_stack+0,int_stack+4095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31020, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+62310,int_stack+52845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32640, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52845,int_stack+8640,int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+53790,int_stack+9060,int_stack+8640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+55050,int_stack+53790,int_stack+52845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+62310,int_stack+9600,int_stack+9060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4200,int_stack+62310,int_stack+53790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+63930,int_stack+4200,int_stack+55050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+52845,int_stack+10275,int_stack+9600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+54870,int_stack+52845,int_stack+62310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6720,int_stack+54870,int_stack+4200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4200,int_stack+11415,int_stack+11100, 0.0, zero_stack, 1.0, int_stack+13875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5145,int_stack+11835,int_stack+11415, 0.0, zero_stack, 1.0, int_stack+14505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+52845,int_stack+5145,int_stack+4200, 0.0, zero_stack, 1.0, int_stack+26925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+62310,int_stack+12375,int_stack+11835, 0.0, zero_stack, 1.0, int_stack+15345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+54735,int_stack+62310,int_stack+5145, 0.0, zero_stack, 1.0, int_stack+27870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+67080,int_stack+54735,int_stack+52845, 0.0, zero_stack, 1.0, int_stack+29130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4200,int_stack+13050,int_stack+12375, 0.0, zero_stack, 1.0, int_stack+16425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+70230,int_stack+4200,int_stack+62310, 0.0, zero_stack, 1.0, int_stack+31020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+73470,int_stack+70230,int_stack+54735, 0.0, zero_stack, 1.0, int_stack+32640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+70230,int_stack+14925,int_stack+14190, 1.0, int_stack+13875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+71175,int_stack+15885,int_stack+14925, 1.0, int_stack+14505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4200,int_stack+71175,int_stack+70230, 1.0, int_stack+26925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+62310,int_stack+17100,int_stack+15885, 1.0, int_stack+15345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+52845,int_stack+62310,int_stack+71175, 1.0, int_stack+27870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+70230,int_stack+52845,int_stack+4200, 1.0, int_stack+29130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4200,int_stack+17775,int_stack+17100, 1.0, int_stack+16425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26925,int_stack+4200,int_stack+62310, 1.0, int_stack+31020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+10920,int_stack+26925,int_stack+52845, 1.0, int_stack+32640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+52845,int_stack+18915,int_stack+18600,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+53790,int_stack+19335,int_stack+18915,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+55050,int_stack+53790,int_stack+52845,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+62310,int_stack+19875,int_stack+19335,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4200,int_stack+62310,int_stack+53790,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+26925,int_stack+4200,int_stack+55050,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+52845,int_stack+20550,int_stack+19875,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+54870,int_stack+52845,int_stack+62310,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+30075,int_stack+54870,int_stack+4200,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4200,int_stack+21690,int_stack+21375,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5145,int_stack+22110,int_stack+21690,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+52845,int_stack+5145,int_stack+4200,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+62310,int_stack+22650,int_stack+22110,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+54735,int_stack+62310,int_stack+5145,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+15120,int_stack+54735,int_stack+52845,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4200,int_stack+23325,int_stack+22650,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+18270,int_stack+4200,int_stack+62310,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+77670,int_stack+18270,int_stack+54735,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+18270,int_stack+24465,int_stack+24150,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+19215,int_stack+24885,int_stack+24465,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+20475,int_stack+19215,int_stack+18270,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+62310,int_stack+25425,int_stack+24885,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4200,int_stack+62310,int_stack+19215,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+52845,int_stack+4200,int_stack+20475,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+18270,int_stack+26100,int_stack+25425,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+20295,int_stack+18270,int_stack+62310,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+81870,int_stack+20295,int_stack+4200,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+18270,int_stack+38310,int_stack+46545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35160,15);
     Libderiv->ABCD[11] = int_stack + 18270;
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+86070,int_stack+58110,int_stack+49695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35160, 0.0, zero_stack,15);
     Libderiv->ABCD[10] = int_stack + 86070;
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+55995,int_stack+0,int_stack+42510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35160, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[9] = int_stack + 55995;
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+6720,int_stack+63930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4725,int_stack+73470,int_stack+67080, 0.0, zero_stack, 1.0, int_stack+35160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[7] = int_stack + 4725;
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+38310,int_stack+10920,int_stack+70230, 1.0, int_stack+35160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[6] = int_stack + 38310;
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+9450,int_stack+30075,int_stack+26925,15);
     Libderiv->ABCD[2] = int_stack + 9450;
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+43035,int_stack+77670,int_stack+15120,15);
     Libderiv->ABCD[1] = int_stack + 43035;
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+47760,int_stack+81870,int_stack+52845,15);
     Libderiv->ABCD[0] = int_stack + 47760;

}
