/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_h0gd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|gd) integrals */

void d1hrr_order_h0gd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][4][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][11] = int_stack + 315;
 Libderiv->deriv_classes[5][6][11] = int_stack + 756;
 Libderiv->deriv_classes[5][4][10] = int_stack + 1344;
 Libderiv->deriv_classes[5][5][10] = int_stack + 1659;
 Libderiv->deriv_classes[5][6][10] = int_stack + 2100;
 Libderiv->deriv_classes[5][4][9] = int_stack + 2688;
 Libderiv->deriv_classes[5][5][9] = int_stack + 3003;
 Libderiv->deriv_classes[5][6][9] = int_stack + 3444;
 Libderiv->deriv_classes[5][4][8] = int_stack + 4032;
 Libderiv->deriv_classes[5][5][8] = int_stack + 4347;
 Libderiv->deriv_classes[5][6][8] = int_stack + 4788;
 Libderiv->deriv_classes[5][4][7] = int_stack + 5376;
 Libderiv->deriv_classes[5][5][7] = int_stack + 5691;
 Libderiv->deriv_classes[5][6][7] = int_stack + 6132;
 Libderiv->dvrr_classes[5][4] = int_stack + 6720;
 Libderiv->deriv_classes[5][4][6] = int_stack + 7035;
 Libderiv->dvrr_classes[5][5] = int_stack + 7350;
 Libderiv->deriv_classes[5][5][6] = int_stack + 7791;
 Libderiv->deriv_classes[5][6][6] = int_stack + 8232;
 Libderiv->deriv_classes[5][4][2] = int_stack + 8820;
 Libderiv->deriv_classes[5][5][2] = int_stack + 9135;
 Libderiv->deriv_classes[5][6][2] = int_stack + 9576;
 Libderiv->deriv_classes[5][4][1] = int_stack + 10164;
 Libderiv->deriv_classes[5][5][1] = int_stack + 10479;
 Libderiv->deriv_classes[5][6][1] = int_stack + 10920;
 Libderiv->deriv_classes[5][4][0] = int_stack + 11508;
 Libderiv->deriv_classes[5][5][0] = int_stack + 11823;
 Libderiv->deriv_classes[5][6][0] = int_stack + 12264;
 memset(int_stack,0,102816);

 Libderiv->dvrr_stack = int_stack + 26460;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_h0gd(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12852,int_stack+7350,int_stack+6720,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13797,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6720,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14742,int_stack+756,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7350,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+1659,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6720, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16065,int_stack+2100,int_stack+1659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7350, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+945,int_stack+3003,int_stack+2688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6720, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+17388,int_stack+3444,int_stack+3003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7350, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1890,int_stack+4347,int_stack+4032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2835,int_stack+4788,int_stack+4347, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4158,int_stack+5691,int_stack+5376, 0.0, zero_stack, 1.0, int_stack+6720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18711,int_stack+6132,int_stack+5691, 0.0, zero_stack, 1.0, int_stack+7350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5103,int_stack+7791,int_stack+7035, 1.0, int_stack+6720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20034,int_stack+8232,int_stack+7791, 1.0, int_stack+7350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+6048,int_stack+9135,int_stack+8820,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6993,int_stack+9576,int_stack+9135,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+8316,int_stack+10479,int_stack+10164,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21357,int_stack+10920,int_stack+10479,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+9261,int_stack+11823,int_stack+11508,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+10206,int_stack+12264,int_stack+11823,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22680,int_stack+14742,int_stack+13797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12852,21);
     Libderiv->ABCD[11] = int_stack + 22680;
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13797,int_stack+16065,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12852, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 13797;
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+24570,int_stack+17388,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12852, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 24570;
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+2835,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1890,int_stack+18711,int_stack+4158, 0.0, zero_stack, 1.0, int_stack+12852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 1890;
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15687,int_stack+20034,int_stack+5103, 1.0, int_stack+12852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 15687;
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3780,int_stack+6993,int_stack+6048,21);
     Libderiv->ABCD[2] = int_stack + 3780;
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5670,int_stack+21357,int_stack+8316,21);
     Libderiv->ABCD[1] = int_stack + 5670;
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+17577,int_stack+10206,int_stack+9261,21);
     Libderiv->ABCD[0] = int_stack + 17577;

}
