/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_h0gf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|gf) integrals */

void d1hrr_order_h0gf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][4][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][11] = int_stack + 315;
 Libderiv->deriv_classes[5][6][11] = int_stack + 756;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][4][10] = int_stack + 2100;
 Libderiv->deriv_classes[5][5][10] = int_stack + 2415;
 Libderiv->deriv_classes[5][6][10] = int_stack + 2856;
 Libderiv->deriv_classes[5][7][10] = int_stack + 3444;
 Libderiv->deriv_classes[5][4][9] = int_stack + 4200;
 Libderiv->deriv_classes[5][5][9] = int_stack + 4515;
 Libderiv->deriv_classes[5][6][9] = int_stack + 4956;
 Libderiv->deriv_classes[5][7][9] = int_stack + 5544;
 Libderiv->deriv_classes[5][4][8] = int_stack + 6300;
 Libderiv->deriv_classes[5][5][8] = int_stack + 6615;
 Libderiv->deriv_classes[5][6][8] = int_stack + 7056;
 Libderiv->deriv_classes[5][7][8] = int_stack + 7644;
 Libderiv->deriv_classes[5][4][7] = int_stack + 8400;
 Libderiv->deriv_classes[5][5][7] = int_stack + 8715;
 Libderiv->deriv_classes[5][6][7] = int_stack + 9156;
 Libderiv->deriv_classes[5][7][7] = int_stack + 9744;
 Libderiv->dvrr_classes[5][4] = int_stack + 10500;
 Libderiv->deriv_classes[5][4][6] = int_stack + 10815;
 Libderiv->dvrr_classes[5][5] = int_stack + 11130;
 Libderiv->deriv_classes[5][5][6] = int_stack + 11571;
 Libderiv->dvrr_classes[5][6] = int_stack + 12012;
 Libderiv->deriv_classes[5][6][6] = int_stack + 12600;
 Libderiv->deriv_classes[5][7][6] = int_stack + 13188;
 Libderiv->deriv_classes[5][4][2] = int_stack + 13944;
 Libderiv->deriv_classes[5][5][2] = int_stack + 14259;
 Libderiv->deriv_classes[5][6][2] = int_stack + 14700;
 Libderiv->deriv_classes[5][7][2] = int_stack + 15288;
 Libderiv->deriv_classes[5][4][1] = int_stack + 16044;
 Libderiv->deriv_classes[5][5][1] = int_stack + 16359;
 Libderiv->deriv_classes[5][6][1] = int_stack + 16800;
 Libderiv->deriv_classes[5][7][1] = int_stack + 17388;
 Libderiv->deriv_classes[5][4][0] = int_stack + 18144;
 Libderiv->deriv_classes[5][5][0] = int_stack + 18459;
 Libderiv->deriv_classes[5][6][0] = int_stack + 18900;
 Libderiv->deriv_classes[5][7][0] = int_stack + 19488;
 memset(int_stack,0,161952);

 Libderiv->dvrr_stack = int_stack + 52374;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_h0gf(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+20244,int_stack+11130,int_stack+10500,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21189,int_stack+12012,int_stack+11130,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+22512,int_stack+21189,int_stack+20244,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24402,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10500,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25347,int_stack+756,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11130,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+26670,int_stack+25347,int_stack+24402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20244,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+1344,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12012,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+30324,int_stack+28560,int_stack+25347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21189,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+28560,int_stack+2415,int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10500, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24402,int_stack+2856,int_stack+2415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11130, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+24402,int_stack+28560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20244, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+3444,int_stack+2856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12012, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32970,int_stack+28560,int_stack+24402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21189, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24402,int_stack+4515,int_stack+4200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10500, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25347,int_stack+4956,int_stack+4515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11130, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1890,int_stack+25347,int_stack+24402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20244, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+5544,int_stack+4956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12012, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35616,int_stack+28560,int_stack+25347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21189, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+28560,int_stack+6615,int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24402,int_stack+7056,int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3780,int_stack+24402,int_stack+28560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+7644,int_stack+7056, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5670,int_stack+28560,int_stack+24402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24402,int_stack+8715,int_stack+8400, 0.0, zero_stack, 1.0, int_stack+10500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25347,int_stack+9156,int_stack+8715, 0.0, zero_stack, 1.0, int_stack+11130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38262,int_stack+25347,int_stack+24402, 0.0, zero_stack, 1.0, int_stack+20244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+9744,int_stack+9156, 0.0, zero_stack, 1.0, int_stack+12012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+40152,int_stack+28560,int_stack+25347, 0.0, zero_stack, 1.0, int_stack+21189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+28560,int_stack+11571,int_stack+10815, 1.0, int_stack+10500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24402,int_stack+12600,int_stack+11571, 1.0, int_stack+11130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8316,int_stack+24402,int_stack+28560, 1.0, int_stack+20244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+13188,int_stack+12600, 1.0, int_stack+12012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10206,int_stack+28560,int_stack+24402, 1.0, int_stack+21189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+24402,int_stack+14259,int_stack+13944,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+25347,int_stack+14700,int_stack+14259,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+20244,int_stack+25347,int_stack+24402,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+15288,int_stack+14700,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+12852,int_stack+28560,int_stack+25347,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+28560,int_stack+16359,int_stack+16044,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+24402,int_stack+16800,int_stack+16359,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+42798,int_stack+24402,int_stack+28560,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+17388,int_stack+16800,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+15498,int_stack+28560,int_stack+24402,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+24402,int_stack+18459,int_stack+18144,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+25347,int_stack+18900,int_stack+18459,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+44688,int_stack+25347,int_stack+24402,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+19488,int_stack+18900,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+46578,int_stack+28560,int_stack+25347,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+49224,int_stack+30324,int_stack+26670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22512,21);
     Libderiv->ABCD[11] = int_stack + 49224;
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+24402,int_stack+32970,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22512, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 24402;
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+27552,int_stack+35616,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22512, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 27552;
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+5670,int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3150,int_stack+40152,int_stack+38262, 0.0, zero_stack, 1.0, int_stack+22512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 3150;
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+30702,int_stack+10206,int_stack+8316, 1.0, int_stack+22512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 30702;
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+6300,int_stack+12852,int_stack+20244,21);
     Libderiv->ABCD[2] = int_stack + 6300;
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+9450,int_stack+15498,int_stack+42798,21);
     Libderiv->ABCD[1] = int_stack + 9450;
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+12600,int_stack+46578,int_stack+44688,21);
     Libderiv->ABCD[0] = int_stack + 12600;

}
