/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_i0hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (i0|hd) integrals */

void d1hrr_order_i0hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][5][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][11] = int_stack + 588;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1372;
 Libderiv->deriv_classes[6][5][10] = int_stack + 2380;
 Libderiv->deriv_classes[6][6][10] = int_stack + 2968;
 Libderiv->deriv_classes[6][7][10] = int_stack + 3752;
 Libderiv->deriv_classes[6][5][9] = int_stack + 4760;
 Libderiv->deriv_classes[6][6][9] = int_stack + 5348;
 Libderiv->deriv_classes[6][7][9] = int_stack + 6132;
 Libderiv->deriv_classes[6][5][8] = int_stack + 7140;
 Libderiv->deriv_classes[6][6][8] = int_stack + 7728;
 Libderiv->deriv_classes[6][7][8] = int_stack + 8512;
 Libderiv->deriv_classes[6][5][7] = int_stack + 9520;
 Libderiv->deriv_classes[6][6][7] = int_stack + 10108;
 Libderiv->deriv_classes[6][7][7] = int_stack + 10892;
 Libderiv->dvrr_classes[6][5] = int_stack + 11900;
 Libderiv->deriv_classes[6][5][6] = int_stack + 12488;
 Libderiv->dvrr_classes[6][6] = int_stack + 13076;
 Libderiv->deriv_classes[6][6][6] = int_stack + 13860;
 Libderiv->deriv_classes[6][7][6] = int_stack + 14644;
 Libderiv->deriv_classes[6][5][2] = int_stack + 15652;
 Libderiv->deriv_classes[6][6][2] = int_stack + 16240;
 Libderiv->deriv_classes[6][7][2] = int_stack + 17024;
 Libderiv->deriv_classes[6][5][1] = int_stack + 18032;
 Libderiv->deriv_classes[6][6][1] = int_stack + 18620;
 Libderiv->deriv_classes[6][7][1] = int_stack + 19404;
 Libderiv->deriv_classes[6][5][0] = int_stack + 20412;
 Libderiv->deriv_classes[6][6][0] = int_stack + 21000;
 Libderiv->deriv_classes[6][7][0] = int_stack + 21784;
 memset(int_stack,0,182336);

 Libderiv->dvrr_stack = int_stack + 46312;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_i0hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+22792,int_stack+13076,int_stack+11900,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24556,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11900,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26320,int_stack+1372,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13076,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+2968,int_stack+2380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11900, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28672,int_stack+3752,int_stack+2968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13076, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1764,int_stack+5348,int_stack+4760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11900, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+31024,int_stack+6132,int_stack+5348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13076, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3528,int_stack+7728,int_stack+7140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5292,int_stack+8512,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7644,int_stack+10108,int_stack+9520, 0.0, zero_stack, 1.0, int_stack+11900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33376,int_stack+10892,int_stack+10108, 0.0, zero_stack, 1.0, int_stack+13076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9408,int_stack+13860,int_stack+12488, 1.0, int_stack+11900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+35728,int_stack+14644,int_stack+13860, 1.0, int_stack+13076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11172,int_stack+16240,int_stack+15652,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12936,int_stack+17024,int_stack+16240,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+15288,int_stack+18620,int_stack+18032,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+38080,int_stack+19404,int_stack+18620,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+17052,int_stack+21000,int_stack+20412,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+40432,int_stack+21784,int_stack+21000,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18816,int_stack+26320,int_stack+24556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22792,28);
     Libderiv->ABCD[11] = int_stack + 18816;
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+24556,int_stack+28672,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22792, 0.0, zero_stack,28);
     Libderiv->ABCD[10] = int_stack + 24556;
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+42784,int_stack+31024,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22792, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[9] = int_stack + 42784;
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+5292,int_stack+3528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3528,int_stack+33376,int_stack+7644, 0.0, zero_stack, 1.0, int_stack+22792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[7] = int_stack + 3528;
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28084,int_stack+35728,int_stack+9408, 1.0, int_stack+22792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[6] = int_stack + 28084;
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+7056,int_stack+12936,int_stack+11172,28);
     Libderiv->ABCD[2] = int_stack + 7056;
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+10584,int_stack+38080,int_stack+15288,28);
     Libderiv->ABCD[1] = int_stack + 10584;
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+31612,int_stack+40432,int_stack+17052,28);
     Libderiv->ABCD[0] = int_stack + 31612;

}
