/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_i0id(Libderiv_t *, prim_data *);

  /* Computes derivatives of (i0|id) integrals */

void d1hrr_order_i0id(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][6][11] = int_stack + 0;
 Libderiv->deriv_classes[6][7][11] = int_stack + 784;
 Libderiv->deriv_classes[6][8][11] = int_stack + 1792;
 Libderiv->deriv_classes[6][6][10] = int_stack + 3052;
 Libderiv->deriv_classes[6][7][10] = int_stack + 3836;
 Libderiv->deriv_classes[6][8][10] = int_stack + 4844;
 Libderiv->deriv_classes[6][6][9] = int_stack + 6104;
 Libderiv->deriv_classes[6][7][9] = int_stack + 6888;
 Libderiv->deriv_classes[6][8][9] = int_stack + 7896;
 Libderiv->deriv_classes[6][6][8] = int_stack + 9156;
 Libderiv->deriv_classes[6][7][8] = int_stack + 9940;
 Libderiv->deriv_classes[6][8][8] = int_stack + 10948;
 Libderiv->deriv_classes[6][6][7] = int_stack + 12208;
 Libderiv->deriv_classes[6][7][7] = int_stack + 12992;
 Libderiv->deriv_classes[6][8][7] = int_stack + 14000;
 Libderiv->dvrr_classes[6][6] = int_stack + 15260;
 Libderiv->deriv_classes[6][6][6] = int_stack + 16044;
 Libderiv->dvrr_classes[6][7] = int_stack + 16828;
 Libderiv->deriv_classes[6][7][6] = int_stack + 17836;
 Libderiv->deriv_classes[6][8][6] = int_stack + 18844;
 Libderiv->deriv_classes[6][6][2] = int_stack + 20104;
 Libderiv->deriv_classes[6][7][2] = int_stack + 20888;
 Libderiv->deriv_classes[6][8][2] = int_stack + 21896;
 Libderiv->deriv_classes[6][6][1] = int_stack + 23156;
 Libderiv->deriv_classes[6][7][1] = int_stack + 23940;
 Libderiv->deriv_classes[6][8][1] = int_stack + 24948;
 Libderiv->deriv_classes[6][6][0] = int_stack + 26208;
 Libderiv->deriv_classes[6][7][0] = int_stack + 26992;
 Libderiv->deriv_classes[6][8][0] = int_stack + 28000;
 memset(int_stack,0,234080);

 Libderiv->dvrr_stack = int_stack + 64540;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_i0id(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+29260,int_stack+16828,int_stack+15260,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+31612,int_stack+784,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15260,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+33964,int_stack+1792,int_stack+784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16828,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+3836,int_stack+3052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15260, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36988,int_stack+4844,int_stack+3836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16828, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+6888,int_stack+6104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15260, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40012,int_stack+7896,int_stack+6888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16828, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4704,int_stack+9940,int_stack+9156, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+43036,int_stack+10948,int_stack+9940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7056,int_stack+12992,int_stack+12208, 0.0, zero_stack, 1.0, int_stack+15260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9408,int_stack+14000,int_stack+12992, 0.0, zero_stack, 1.0, int_stack+16828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12432,int_stack+17836,int_stack+16044, 1.0, int_stack+15260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+46060,int_stack+18844,int_stack+17836, 1.0, int_stack+16828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14784,int_stack+20888,int_stack+20104,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+17136,int_stack+21896,int_stack+20888,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20160,int_stack+23940,int_stack+23156,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+49084,int_stack+24948,int_stack+23940,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+22512,int_stack+26992,int_stack+26208,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+52108,int_stack+28000,int_stack+26992,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+55132,int_stack+33964,int_stack+31612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29260,28);
     Libderiv->ABCD[11] = int_stack + 55132;
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+31612,int_stack+36988,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29260, 0.0, zero_stack,28);
     Libderiv->ABCD[10] = int_stack + 31612;
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+59836,int_stack+40012,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29260, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[9] = int_stack + 59836;
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+43036,int_stack+4704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36316,int_stack+9408,int_stack+7056, 0.0, zero_stack, 1.0, int_stack+29260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[7] = int_stack + 36316;
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4704,int_stack+46060,int_stack+12432, 1.0, int_stack+29260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[6] = int_stack + 4704;
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+9408,int_stack+17136,int_stack+14784,28);
     Libderiv->ABCD[2] = int_stack + 9408;
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14112,int_stack+49084,int_stack+20160,28);
     Libderiv->ABCD[1] = int_stack + 14112;
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+41020,int_stack+52108,int_stack+22512,28);
     Libderiv->ABCD[0] = int_stack + 41020;

}
