/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of |oi) integrals */

#include "libint.h"

REALTYPE *_hrr3_build_oi_0(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);
REALTYPE *_hrr3_build_oi_1(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);
REALTYPE *_hrr3_build_oi_2(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);
REALTYPE *_hrr3_build_oi_3(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);
REALTYPE *_hrr3_build_oi_4(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);
REALTYPE *_hrr3_build_oi_5(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);
REALTYPE *_hrr3_build_oi_6(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);
REALTYPE *_hrr3_build_oi_7(const REALTYPE *, REALTYPE *, REALTYPE *, REALTYPE *);

void hrr3_build_oi(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1, int ab_num)
{
  int ab;

  for(ab=0;ab<ab_num;ab++) {
    vp = _hrr3_build_oi_0(CD, vp, I0, I1);
    vp = _hrr3_build_oi_1(CD, vp, I0, I1);
    vp = _hrr3_build_oi_2(CD, vp, I0, I1);
    vp = _hrr3_build_oi_3(CD, vp, I0, I1);
    vp = _hrr3_build_oi_4(CD, vp, I0, I1);
    vp = _hrr3_build_oi_5(CD, vp, I0, I1);
    vp = _hrr3_build_oi_6(CD, vp, I0, I1);
    vp = _hrr3_build_oi_7(CD, vp, I0, I1);
    I0 += 1911;
    I1 += 1638;
  }
}

REALTYPE *_hrr3_build_oi_0(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[0] + CD0*I1[0];
    *(vp++) = I0[1] + CD0*I1[1];
    *(vp++) = I0[2] + CD0*I1[2];
    *(vp++) = I0[3] + CD0*I1[3];
    *(vp++) = I0[4] + CD0*I1[4];
    *(vp++) = I0[5] + CD0*I1[5];
    *(vp++) = I0[6] + CD0*I1[6];
    *(vp++) = I0[7] + CD0*I1[7];
    *(vp++) = I0[8] + CD0*I1[8];
    *(vp++) = I0[9] + CD0*I1[9];
    *(vp++) = I0[10] + CD0*I1[10];
    *(vp++) = I0[11] + CD0*I1[11];
    *(vp++) = I0[12] + CD0*I1[12];
    *(vp++) = I0[13] + CD0*I1[13];
    *(vp++) = I0[14] + CD0*I1[14];
    *(vp++) = I0[15] + CD0*I1[15];
    *(vp++) = I0[16] + CD0*I1[16];
    *(vp++) = I0[17] + CD0*I1[17];
    *(vp++) = I0[18] + CD0*I1[18];
    *(vp++) = I0[19] + CD0*I1[19];
    *(vp++) = I0[20] + CD0*I1[20];
    *(vp++) = I0[36] + CD1*I1[15];
    *(vp++) = I0[37] + CD1*I1[16];
    *(vp++) = I0[38] + CD1*I1[17];
    *(vp++) = I0[39] + CD1*I1[18];
    *(vp++) = I0[40] + CD1*I1[19];
    *(vp++) = I0[41] + CD1*I1[20];
    *(vp++) = I0[62] + CD2*I1[20];
    *(vp++) = I0[21] + CD0*I1[21];
    *(vp++) = I0[22] + CD0*I1[22];
    *(vp++) = I0[23] + CD0*I1[23];
    *(vp++) = I0[24] + CD0*I1[24];
    *(vp++) = I0[25] + CD0*I1[25];
    *(vp++) = I0[26] + CD0*I1[26];
    *(vp++) = I0[27] + CD0*I1[27];
    *(vp++) = I0[28] + CD0*I1[28];
    *(vp++) = I0[29] + CD0*I1[29];
    *(vp++) = I0[30] + CD0*I1[30];
    *(vp++) = I0[31] + CD0*I1[31];
    *(vp++) = I0[32] + CD0*I1[32];
    *(vp++) = I0[33] + CD0*I1[33];
    *(vp++) = I0[34] + CD0*I1[34];
    *(vp++) = I0[35] + CD0*I1[35];
    *(vp++) = I0[36] + CD0*I1[36];
    *(vp++) = I0[37] + CD0*I1[37];
    *(vp++) = I0[38] + CD0*I1[38];
    *(vp++) = I0[39] + CD0*I1[39];
    *(vp++) = I0[40] + CD0*I1[40];
    *(vp++) = I0[41] + CD0*I1[41];
    *(vp++) = I0[78] + CD1*I1[36];
    *(vp++) = I0[79] + CD1*I1[37];
    *(vp++) = I0[80] + CD1*I1[38];
    *(vp++) = I0[81] + CD1*I1[39];
    *(vp++) = I0[82] + CD1*I1[40];
    *(vp++) = I0[83] + CD1*I1[41];
    *(vp++) = I0[104] + CD2*I1[41];
    *(vp++) = I0[42] + CD0*I1[42];
    *(vp++) = I0[43] + CD0*I1[43];
    *(vp++) = I0[44] + CD0*I1[44];
    *(vp++) = I0[45] + CD0*I1[45];
    *(vp++) = I0[46] + CD0*I1[46];
    *(vp++) = I0[47] + CD0*I1[47];
    *(vp++) = I0[48] + CD0*I1[48];
    *(vp++) = I0[49] + CD0*I1[49];
    *(vp++) = I0[50] + CD0*I1[50];
    *(vp++) = I0[51] + CD0*I1[51];
    *(vp++) = I0[52] + CD0*I1[52];
    *(vp++) = I0[53] + CD0*I1[53];
    *(vp++) = I0[54] + CD0*I1[54];
    *(vp++) = I0[55] + CD0*I1[55];
    *(vp++) = I0[56] + CD0*I1[56];
    *(vp++) = I0[57] + CD0*I1[57];
    *(vp++) = I0[58] + CD0*I1[58];
    *(vp++) = I0[59] + CD0*I1[59];
    *(vp++) = I0[60] + CD0*I1[60];
    *(vp++) = I0[61] + CD0*I1[61];
    *(vp++) = I0[62] + CD0*I1[62];
    *(vp++) = I0[99] + CD1*I1[57];
    *(vp++) = I0[100] + CD1*I1[58];
    *(vp++) = I0[101] + CD1*I1[59];
    *(vp++) = I0[102] + CD1*I1[60];
    *(vp++) = I0[103] + CD1*I1[61];
    *(vp++) = I0[104] + CD1*I1[62];
    *(vp++) = I0[125] + CD2*I1[62];
    *(vp++) = I0[63] + CD0*I1[63];
    *(vp++) = I0[64] + CD0*I1[64];
    *(vp++) = I0[65] + CD0*I1[65];
    *(vp++) = I0[66] + CD0*I1[66];
    *(vp++) = I0[67] + CD0*I1[67];
    *(vp++) = I0[68] + CD0*I1[68];
    *(vp++) = I0[69] + CD0*I1[69];
    *(vp++) = I0[70] + CD0*I1[70];
    *(vp++) = I0[71] + CD0*I1[71];
    *(vp++) = I0[72] + CD0*I1[72];
    *(vp++) = I0[73] + CD0*I1[73];
    *(vp++) = I0[74] + CD0*I1[74];
    *(vp++) = I0[75] + CD0*I1[75];
    *(vp++) = I0[76] + CD0*I1[76];
    *(vp++) = I0[77] + CD0*I1[77];
    *(vp++) = I0[78] + CD0*I1[78];
    *(vp++) = I0[79] + CD0*I1[79];
    *(vp++) = I0[80] + CD0*I1[80];
    *(vp++) = I0[81] + CD0*I1[81];
    *(vp++) = I0[82] + CD0*I1[82];
    *(vp++) = I0[83] + CD0*I1[83];
    *(vp++) = I0[141] + CD1*I1[78];
    *(vp++) = I0[142] + CD1*I1[79];
    *(vp++) = I0[143] + CD1*I1[80];
    *(vp++) = I0[144] + CD1*I1[81];
    *(vp++) = I0[145] + CD1*I1[82];
    *(vp++) = I0[146] + CD1*I1[83];
    *(vp++) = I0[167] + CD2*I1[83];
    *(vp++) = I0[84] + CD0*I1[84];
    *(vp++) = I0[85] + CD0*I1[85];
    *(vp++) = I0[86] + CD0*I1[86];
    *(vp++) = I0[87] + CD0*I1[87];
    *(vp++) = I0[88] + CD0*I1[88];
    *(vp++) = I0[89] + CD0*I1[89];
    *(vp++) = I0[90] + CD0*I1[90];
    *(vp++) = I0[91] + CD0*I1[91];
    *(vp++) = I0[92] + CD0*I1[92];
    *(vp++) = I0[93] + CD0*I1[93];
    *(vp++) = I0[94] + CD0*I1[94];
    *(vp++) = I0[95] + CD0*I1[95];
    *(vp++) = I0[96] + CD0*I1[96];
    *(vp++) = I0[97] + CD0*I1[97];
    *(vp++) = I0[98] + CD0*I1[98];
    *(vp++) = I0[99] + CD0*I1[99];
    *(vp++) = I0[100] + CD0*I1[100];
    *(vp++) = I0[101] + CD0*I1[101];
    *(vp++) = I0[102] + CD0*I1[102];
    *(vp++) = I0[103] + CD0*I1[103];
    *(vp++) = I0[104] + CD0*I1[104];
    *(vp++) = I0[162] + CD1*I1[99];
    *(vp++) = I0[163] + CD1*I1[100];
    *(vp++) = I0[164] + CD1*I1[101];
    *(vp++) = I0[165] + CD1*I1[102];
    *(vp++) = I0[166] + CD1*I1[103];
    *(vp++) = I0[167] + CD1*I1[104];
    *(vp++) = I0[188] + CD2*I1[104];
    *(vp++) = I0[105] + CD0*I1[105];
    *(vp++) = I0[106] + CD0*I1[106];
    *(vp++) = I0[107] + CD0*I1[107];
    *(vp++) = I0[108] + CD0*I1[108];
    *(vp++) = I0[109] + CD0*I1[109];
    *(vp++) = I0[110] + CD0*I1[110];
    *(vp++) = I0[111] + CD0*I1[111];
    *(vp++) = I0[112] + CD0*I1[112];
    *(vp++) = I0[113] + CD0*I1[113];
    *(vp++) = I0[114] + CD0*I1[114];
    *(vp++) = I0[115] + CD0*I1[115];
    *(vp++) = I0[116] + CD0*I1[116];
    *(vp++) = I0[117] + CD0*I1[117];
    *(vp++) = I0[118] + CD0*I1[118];
    *(vp++) = I0[119] + CD0*I1[119];
    *(vp++) = I0[120] + CD0*I1[120];
    *(vp++) = I0[121] + CD0*I1[121];
    *(vp++) = I0[122] + CD0*I1[122];
    *(vp++) = I0[123] + CD0*I1[123];
    *(vp++) = I0[124] + CD0*I1[124];
    *(vp++) = I0[125] + CD0*I1[125];
    *(vp++) = I0[183] + CD1*I1[120];
    *(vp++) = I0[184] + CD1*I1[121];
    *(vp++) = I0[185] + CD1*I1[122];
    *(vp++) = I0[186] + CD1*I1[123];
    *(vp++) = I0[187] + CD1*I1[124];
    *(vp++) = I0[188] + CD1*I1[125];
    *(vp++) = I0[209] + CD2*I1[125];
    *(vp++) = I0[126] + CD0*I1[126];
    *(vp++) = I0[127] + CD0*I1[127];
    *(vp++) = I0[128] + CD0*I1[128];
    *(vp++) = I0[129] + CD0*I1[129];
    *(vp++) = I0[130] + CD0*I1[130];
    *(vp++) = I0[131] + CD0*I1[131];
    *(vp++) = I0[132] + CD0*I1[132];
    *(vp++) = I0[133] + CD0*I1[133];
    *(vp++) = I0[134] + CD0*I1[134];
    *(vp++) = I0[135] + CD0*I1[135];
    *(vp++) = I0[136] + CD0*I1[136];
    *(vp++) = I0[137] + CD0*I1[137];
    *(vp++) = I0[138] + CD0*I1[138];
    *(vp++) = I0[139] + CD0*I1[139];
    *(vp++) = I0[140] + CD0*I1[140];
    *(vp++) = I0[141] + CD0*I1[141];
    *(vp++) = I0[142] + CD0*I1[142];
    *(vp++) = I0[143] + CD0*I1[143];
    *(vp++) = I0[144] + CD0*I1[144];
    *(vp++) = I0[145] + CD0*I1[145];
    *(vp++) = I0[146] + CD0*I1[146];
    *(vp++) = I0[225] + CD1*I1[141];
    *(vp++) = I0[226] + CD1*I1[142];
    *(vp++) = I0[227] + CD1*I1[143];
    *(vp++) = I0[228] + CD1*I1[144];
    *(vp++) = I0[229] + CD1*I1[145];
    *(vp++) = I0[230] + CD1*I1[146];
    *(vp++) = I0[251] + CD2*I1[146];
    *(vp++) = I0[147] + CD0*I1[147];
    *(vp++) = I0[148] + CD0*I1[148];
    *(vp++) = I0[149] + CD0*I1[149];
    *(vp++) = I0[150] + CD0*I1[150];
    *(vp++) = I0[151] + CD0*I1[151];
    *(vp++) = I0[152] + CD0*I1[152];
    *(vp++) = I0[153] + CD0*I1[153];
    *(vp++) = I0[154] + CD0*I1[154];
    *(vp++) = I0[155] + CD0*I1[155];
    *(vp++) = I0[156] + CD0*I1[156];
    *(vp++) = I0[157] + CD0*I1[157];
    *(vp++) = I0[158] + CD0*I1[158];
    *(vp++) = I0[159] + CD0*I1[159];
    *(vp++) = I0[160] + CD0*I1[160];
    *(vp++) = I0[161] + CD0*I1[161];
    *(vp++) = I0[162] + CD0*I1[162];
    *(vp++) = I0[163] + CD0*I1[163];
    *(vp++) = I0[164] + CD0*I1[164];
    *(vp++) = I0[165] + CD0*I1[165];
    *(vp++) = I0[166] + CD0*I1[166];
    *(vp++) = I0[167] + CD0*I1[167];
    *(vp++) = I0[246] + CD1*I1[162];
    *(vp++) = I0[247] + CD1*I1[163];
    *(vp++) = I0[248] + CD1*I1[164];
    *(vp++) = I0[249] + CD1*I1[165];
    *(vp++) = I0[250] + CD1*I1[166];
    *(vp++) = I0[251] + CD1*I1[167];
    *(vp++) = I0[272] + CD2*I1[167];
    *(vp++) = I0[168] + CD0*I1[168];
    *(vp++) = I0[169] + CD0*I1[169];
    *(vp++) = I0[170] + CD0*I1[170];
    *(vp++) = I0[171] + CD0*I1[171];
    *(vp++) = I0[172] + CD0*I1[172];
    *(vp++) = I0[173] + CD0*I1[173];
    *(vp++) = I0[174] + CD0*I1[174];
    *(vp++) = I0[175] + CD0*I1[175];
    *(vp++) = I0[176] + CD0*I1[176];
    *(vp++) = I0[177] + CD0*I1[177];
    *(vp++) = I0[178] + CD0*I1[178];
    *(vp++) = I0[179] + CD0*I1[179];
    *(vp++) = I0[180] + CD0*I1[180];
    *(vp++) = I0[181] + CD0*I1[181];
    *(vp++) = I0[182] + CD0*I1[182];
    *(vp++) = I0[183] + CD0*I1[183];
    *(vp++) = I0[184] + CD0*I1[184];
    *(vp++) = I0[185] + CD0*I1[185];
    *(vp++) = I0[186] + CD0*I1[186];
    *(vp++) = I0[187] + CD0*I1[187];
    *(vp++) = I0[188] + CD0*I1[188];
    *(vp++) = I0[267] + CD1*I1[183];
    *(vp++) = I0[268] + CD1*I1[184];
    *(vp++) = I0[269] + CD1*I1[185];
    *(vp++) = I0[270] + CD1*I1[186];
    *(vp++) = I0[271] + CD1*I1[187];
    *(vp++) = I0[272] + CD1*I1[188];
    *(vp++) = I0[293] + CD2*I1[188];
    *(vp++) = I0[189] + CD0*I1[189];
    *(vp++) = I0[190] + CD0*I1[190];
    *(vp++) = I0[191] + CD0*I1[191];
    *(vp++) = I0[192] + CD0*I1[192];
    *(vp++) = I0[193] + CD0*I1[193];
    *(vp++) = I0[194] + CD0*I1[194];
    *(vp++) = I0[195] + CD0*I1[195];
    *(vp++) = I0[196] + CD0*I1[196];
    *(vp++) = I0[197] + CD0*I1[197];
    *(vp++) = I0[198] + CD0*I1[198];
    *(vp++) = I0[199] + CD0*I1[199];
    *(vp++) = I0[200] + CD0*I1[200];
    *(vp++) = I0[201] + CD0*I1[201];
    *(vp++) = I0[202] + CD0*I1[202];
    *(vp++) = I0[203] + CD0*I1[203];
    *(vp++) = I0[204] + CD0*I1[204];
    *(vp++) = I0[205] + CD0*I1[205];
    *(vp++) = I0[206] + CD0*I1[206];
    *(vp++) = I0[207] + CD0*I1[207];
    *(vp++) = I0[208] + CD0*I1[208];
    *(vp++) = I0[209] + CD0*I1[209];
    *(vp++) = I0[288] + CD1*I1[204];
  return vp;
}

REALTYPE *_hrr3_build_oi_1(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[289] + CD1*I1[205];
    *(vp++) = I0[290] + CD1*I1[206];
    *(vp++) = I0[291] + CD1*I1[207];
    *(vp++) = I0[292] + CD1*I1[208];
    *(vp++) = I0[293] + CD1*I1[209];
    *(vp++) = I0[314] + CD2*I1[209];
    *(vp++) = I0[210] + CD0*I1[210];
    *(vp++) = I0[211] + CD0*I1[211];
    *(vp++) = I0[212] + CD0*I1[212];
    *(vp++) = I0[213] + CD0*I1[213];
    *(vp++) = I0[214] + CD0*I1[214];
    *(vp++) = I0[215] + CD0*I1[215];
    *(vp++) = I0[216] + CD0*I1[216];
    *(vp++) = I0[217] + CD0*I1[217];
    *(vp++) = I0[218] + CD0*I1[218];
    *(vp++) = I0[219] + CD0*I1[219];
    *(vp++) = I0[220] + CD0*I1[220];
    *(vp++) = I0[221] + CD0*I1[221];
    *(vp++) = I0[222] + CD0*I1[222];
    *(vp++) = I0[223] + CD0*I1[223];
    *(vp++) = I0[224] + CD0*I1[224];
    *(vp++) = I0[225] + CD0*I1[225];
    *(vp++) = I0[226] + CD0*I1[226];
    *(vp++) = I0[227] + CD0*I1[227];
    *(vp++) = I0[228] + CD0*I1[228];
    *(vp++) = I0[229] + CD0*I1[229];
    *(vp++) = I0[230] + CD0*I1[230];
    *(vp++) = I0[330] + CD1*I1[225];
    *(vp++) = I0[331] + CD1*I1[226];
    *(vp++) = I0[332] + CD1*I1[227];
    *(vp++) = I0[333] + CD1*I1[228];
    *(vp++) = I0[334] + CD1*I1[229];
    *(vp++) = I0[335] + CD1*I1[230];
    *(vp++) = I0[356] + CD2*I1[230];
    *(vp++) = I0[231] + CD0*I1[231];
    *(vp++) = I0[232] + CD0*I1[232];
    *(vp++) = I0[233] + CD0*I1[233];
    *(vp++) = I0[234] + CD0*I1[234];
    *(vp++) = I0[235] + CD0*I1[235];
    *(vp++) = I0[236] + CD0*I1[236];
    *(vp++) = I0[237] + CD0*I1[237];
    *(vp++) = I0[238] + CD0*I1[238];
    *(vp++) = I0[239] + CD0*I1[239];
    *(vp++) = I0[240] + CD0*I1[240];
    *(vp++) = I0[241] + CD0*I1[241];
    *(vp++) = I0[242] + CD0*I1[242];
    *(vp++) = I0[243] + CD0*I1[243];
    *(vp++) = I0[244] + CD0*I1[244];
    *(vp++) = I0[245] + CD0*I1[245];
    *(vp++) = I0[246] + CD0*I1[246];
    *(vp++) = I0[247] + CD0*I1[247];
    *(vp++) = I0[248] + CD0*I1[248];
    *(vp++) = I0[249] + CD0*I1[249];
    *(vp++) = I0[250] + CD0*I1[250];
    *(vp++) = I0[251] + CD0*I1[251];
    *(vp++) = I0[351] + CD1*I1[246];
    *(vp++) = I0[352] + CD1*I1[247];
    *(vp++) = I0[353] + CD1*I1[248];
    *(vp++) = I0[354] + CD1*I1[249];
    *(vp++) = I0[355] + CD1*I1[250];
    *(vp++) = I0[356] + CD1*I1[251];
    *(vp++) = I0[377] + CD2*I1[251];
    *(vp++) = I0[252] + CD0*I1[252];
    *(vp++) = I0[253] + CD0*I1[253];
    *(vp++) = I0[254] + CD0*I1[254];
    *(vp++) = I0[255] + CD0*I1[255];
    *(vp++) = I0[256] + CD0*I1[256];
    *(vp++) = I0[257] + CD0*I1[257];
    *(vp++) = I0[258] + CD0*I1[258];
    *(vp++) = I0[259] + CD0*I1[259];
    *(vp++) = I0[260] + CD0*I1[260];
    *(vp++) = I0[261] + CD0*I1[261];
    *(vp++) = I0[262] + CD0*I1[262];
    *(vp++) = I0[263] + CD0*I1[263];
    *(vp++) = I0[264] + CD0*I1[264];
    *(vp++) = I0[265] + CD0*I1[265];
    *(vp++) = I0[266] + CD0*I1[266];
    *(vp++) = I0[267] + CD0*I1[267];
    *(vp++) = I0[268] + CD0*I1[268];
    *(vp++) = I0[269] + CD0*I1[269];
    *(vp++) = I0[270] + CD0*I1[270];
    *(vp++) = I0[271] + CD0*I1[271];
    *(vp++) = I0[272] + CD0*I1[272];
    *(vp++) = I0[372] + CD1*I1[267];
    *(vp++) = I0[373] + CD1*I1[268];
    *(vp++) = I0[374] + CD1*I1[269];
    *(vp++) = I0[375] + CD1*I1[270];
    *(vp++) = I0[376] + CD1*I1[271];
    *(vp++) = I0[377] + CD1*I1[272];
    *(vp++) = I0[398] + CD2*I1[272];
    *(vp++) = I0[273] + CD0*I1[273];
    *(vp++) = I0[274] + CD0*I1[274];
    *(vp++) = I0[275] + CD0*I1[275];
    *(vp++) = I0[276] + CD0*I1[276];
    *(vp++) = I0[277] + CD0*I1[277];
    *(vp++) = I0[278] + CD0*I1[278];
    *(vp++) = I0[279] + CD0*I1[279];
    *(vp++) = I0[280] + CD0*I1[280];
    *(vp++) = I0[281] + CD0*I1[281];
    *(vp++) = I0[282] + CD0*I1[282];
    *(vp++) = I0[283] + CD0*I1[283];
    *(vp++) = I0[284] + CD0*I1[284];
    *(vp++) = I0[285] + CD0*I1[285];
    *(vp++) = I0[286] + CD0*I1[286];
    *(vp++) = I0[287] + CD0*I1[287];
    *(vp++) = I0[288] + CD0*I1[288];
    *(vp++) = I0[289] + CD0*I1[289];
    *(vp++) = I0[290] + CD0*I1[290];
    *(vp++) = I0[291] + CD0*I1[291];
    *(vp++) = I0[292] + CD0*I1[292];
    *(vp++) = I0[293] + CD0*I1[293];
    *(vp++) = I0[393] + CD1*I1[288];
    *(vp++) = I0[394] + CD1*I1[289];
    *(vp++) = I0[395] + CD1*I1[290];
    *(vp++) = I0[396] + CD1*I1[291];
    *(vp++) = I0[397] + CD1*I1[292];
    *(vp++) = I0[398] + CD1*I1[293];
    *(vp++) = I0[419] + CD2*I1[293];
    *(vp++) = I0[294] + CD0*I1[294];
    *(vp++) = I0[295] + CD0*I1[295];
    *(vp++) = I0[296] + CD0*I1[296];
    *(vp++) = I0[297] + CD0*I1[297];
    *(vp++) = I0[298] + CD0*I1[298];
    *(vp++) = I0[299] + CD0*I1[299];
    *(vp++) = I0[300] + CD0*I1[300];
    *(vp++) = I0[301] + CD0*I1[301];
    *(vp++) = I0[302] + CD0*I1[302];
    *(vp++) = I0[303] + CD0*I1[303];
    *(vp++) = I0[304] + CD0*I1[304];
    *(vp++) = I0[305] + CD0*I1[305];
    *(vp++) = I0[306] + CD0*I1[306];
    *(vp++) = I0[307] + CD0*I1[307];
    *(vp++) = I0[308] + CD0*I1[308];
    *(vp++) = I0[309] + CD0*I1[309];
    *(vp++) = I0[310] + CD0*I1[310];
    *(vp++) = I0[311] + CD0*I1[311];
    *(vp++) = I0[312] + CD0*I1[312];
    *(vp++) = I0[313] + CD0*I1[313];
    *(vp++) = I0[314] + CD0*I1[314];
    *(vp++) = I0[414] + CD1*I1[309];
    *(vp++) = I0[415] + CD1*I1[310];
    *(vp++) = I0[416] + CD1*I1[311];
    *(vp++) = I0[417] + CD1*I1[312];
    *(vp++) = I0[418] + CD1*I1[313];
    *(vp++) = I0[419] + CD1*I1[314];
    *(vp++) = I0[440] + CD2*I1[314];
    *(vp++) = I0[315] + CD0*I1[315];
    *(vp++) = I0[316] + CD0*I1[316];
    *(vp++) = I0[317] + CD0*I1[317];
    *(vp++) = I0[318] + CD0*I1[318];
    *(vp++) = I0[319] + CD0*I1[319];
    *(vp++) = I0[320] + CD0*I1[320];
    *(vp++) = I0[321] + CD0*I1[321];
    *(vp++) = I0[322] + CD0*I1[322];
    *(vp++) = I0[323] + CD0*I1[323];
    *(vp++) = I0[324] + CD0*I1[324];
    *(vp++) = I0[325] + CD0*I1[325];
    *(vp++) = I0[326] + CD0*I1[326];
    *(vp++) = I0[327] + CD0*I1[327];
    *(vp++) = I0[328] + CD0*I1[328];
    *(vp++) = I0[329] + CD0*I1[329];
    *(vp++) = I0[330] + CD0*I1[330];
    *(vp++) = I0[331] + CD0*I1[331];
    *(vp++) = I0[332] + CD0*I1[332];
    *(vp++) = I0[333] + CD0*I1[333];
    *(vp++) = I0[334] + CD0*I1[334];
    *(vp++) = I0[335] + CD0*I1[335];
    *(vp++) = I0[456] + CD1*I1[330];
    *(vp++) = I0[457] + CD1*I1[331];
    *(vp++) = I0[458] + CD1*I1[332];
    *(vp++) = I0[459] + CD1*I1[333];
    *(vp++) = I0[460] + CD1*I1[334];
    *(vp++) = I0[461] + CD1*I1[335];
    *(vp++) = I0[482] + CD2*I1[335];
    *(vp++) = I0[336] + CD0*I1[336];
    *(vp++) = I0[337] + CD0*I1[337];
    *(vp++) = I0[338] + CD0*I1[338];
    *(vp++) = I0[339] + CD0*I1[339];
    *(vp++) = I0[340] + CD0*I1[340];
    *(vp++) = I0[341] + CD0*I1[341];
    *(vp++) = I0[342] + CD0*I1[342];
    *(vp++) = I0[343] + CD0*I1[343];
    *(vp++) = I0[344] + CD0*I1[344];
    *(vp++) = I0[345] + CD0*I1[345];
    *(vp++) = I0[346] + CD0*I1[346];
    *(vp++) = I0[347] + CD0*I1[347];
    *(vp++) = I0[348] + CD0*I1[348];
    *(vp++) = I0[349] + CD0*I1[349];
    *(vp++) = I0[350] + CD0*I1[350];
    *(vp++) = I0[351] + CD0*I1[351];
    *(vp++) = I0[352] + CD0*I1[352];
    *(vp++) = I0[353] + CD0*I1[353];
    *(vp++) = I0[354] + CD0*I1[354];
    *(vp++) = I0[355] + CD0*I1[355];
    *(vp++) = I0[356] + CD0*I1[356];
    *(vp++) = I0[477] + CD1*I1[351];
    *(vp++) = I0[478] + CD1*I1[352];
    *(vp++) = I0[479] + CD1*I1[353];
    *(vp++) = I0[480] + CD1*I1[354];
    *(vp++) = I0[481] + CD1*I1[355];
    *(vp++) = I0[482] + CD1*I1[356];
    *(vp++) = I0[503] + CD2*I1[356];
    *(vp++) = I0[357] + CD0*I1[357];
    *(vp++) = I0[358] + CD0*I1[358];
    *(vp++) = I0[359] + CD0*I1[359];
    *(vp++) = I0[360] + CD0*I1[360];
    *(vp++) = I0[361] + CD0*I1[361];
    *(vp++) = I0[362] + CD0*I1[362];
    *(vp++) = I0[363] + CD0*I1[363];
    *(vp++) = I0[364] + CD0*I1[364];
    *(vp++) = I0[365] + CD0*I1[365];
    *(vp++) = I0[366] + CD0*I1[366];
    *(vp++) = I0[367] + CD0*I1[367];
    *(vp++) = I0[368] + CD0*I1[368];
    *(vp++) = I0[369] + CD0*I1[369];
    *(vp++) = I0[370] + CD0*I1[370];
    *(vp++) = I0[371] + CD0*I1[371];
    *(vp++) = I0[372] + CD0*I1[372];
    *(vp++) = I0[373] + CD0*I1[373];
    *(vp++) = I0[374] + CD0*I1[374];
    *(vp++) = I0[375] + CD0*I1[375];
    *(vp++) = I0[376] + CD0*I1[376];
    *(vp++) = I0[377] + CD0*I1[377];
    *(vp++) = I0[498] + CD1*I1[372];
    *(vp++) = I0[499] + CD1*I1[373];
    *(vp++) = I0[500] + CD1*I1[374];
    *(vp++) = I0[501] + CD1*I1[375];
    *(vp++) = I0[502] + CD1*I1[376];
    *(vp++) = I0[503] + CD1*I1[377];
    *(vp++) = I0[524] + CD2*I1[377];
    *(vp++) = I0[378] + CD0*I1[378];
    *(vp++) = I0[379] + CD0*I1[379];
    *(vp++) = I0[380] + CD0*I1[380];
    *(vp++) = I0[381] + CD0*I1[381];
    *(vp++) = I0[382] + CD0*I1[382];
    *(vp++) = I0[383] + CD0*I1[383];
    *(vp++) = I0[384] + CD0*I1[384];
    *(vp++) = I0[385] + CD0*I1[385];
    *(vp++) = I0[386] + CD0*I1[386];
    *(vp++) = I0[387] + CD0*I1[387];
    *(vp++) = I0[388] + CD0*I1[388];
    *(vp++) = I0[389] + CD0*I1[389];
    *(vp++) = I0[390] + CD0*I1[390];
    *(vp++) = I0[391] + CD0*I1[391];
    *(vp++) = I0[392] + CD0*I1[392];
    *(vp++) = I0[393] + CD0*I1[393];
    *(vp++) = I0[394] + CD0*I1[394];
    *(vp++) = I0[395] + CD0*I1[395];
    *(vp++) = I0[396] + CD0*I1[396];
    *(vp++) = I0[397] + CD0*I1[397];
    *(vp++) = I0[398] + CD0*I1[398];
    *(vp++) = I0[519] + CD1*I1[393];
    *(vp++) = I0[520] + CD1*I1[394];
    *(vp++) = I0[521] + CD1*I1[395];
    *(vp++) = I0[522] + CD1*I1[396];
    *(vp++) = I0[523] + CD1*I1[397];
    *(vp++) = I0[524] + CD1*I1[398];
    *(vp++) = I0[545] + CD2*I1[398];
    *(vp++) = I0[399] + CD0*I1[399];
    *(vp++) = I0[400] + CD0*I1[400];
    *(vp++) = I0[401] + CD0*I1[401];
    *(vp++) = I0[402] + CD0*I1[402];
    *(vp++) = I0[403] + CD0*I1[403];
    *(vp++) = I0[404] + CD0*I1[404];
    *(vp++) = I0[405] + CD0*I1[405];
    *(vp++) = I0[406] + CD0*I1[406];
    *(vp++) = I0[407] + CD0*I1[407];
    *(vp++) = I0[408] + CD0*I1[408];
    *(vp++) = I0[409] + CD0*I1[409];
    *(vp++) = I0[410] + CD0*I1[410];
    *(vp++) = I0[411] + CD0*I1[411];
    *(vp++) = I0[412] + CD0*I1[412];
    *(vp++) = I0[413] + CD0*I1[413];
    *(vp++) = I0[414] + CD0*I1[414];
  return vp;
}

REALTYPE *_hrr3_build_oi_2(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[415] + CD0*I1[415];
    *(vp++) = I0[416] + CD0*I1[416];
    *(vp++) = I0[417] + CD0*I1[417];
    *(vp++) = I0[418] + CD0*I1[418];
    *(vp++) = I0[419] + CD0*I1[419];
    *(vp++) = I0[540] + CD1*I1[414];
    *(vp++) = I0[541] + CD1*I1[415];
    *(vp++) = I0[542] + CD1*I1[416];
    *(vp++) = I0[543] + CD1*I1[417];
    *(vp++) = I0[544] + CD1*I1[418];
    *(vp++) = I0[545] + CD1*I1[419];
    *(vp++) = I0[566] + CD2*I1[419];
    *(vp++) = I0[420] + CD0*I1[420];
    *(vp++) = I0[421] + CD0*I1[421];
    *(vp++) = I0[422] + CD0*I1[422];
    *(vp++) = I0[423] + CD0*I1[423];
    *(vp++) = I0[424] + CD0*I1[424];
    *(vp++) = I0[425] + CD0*I1[425];
    *(vp++) = I0[426] + CD0*I1[426];
    *(vp++) = I0[427] + CD0*I1[427];
    *(vp++) = I0[428] + CD0*I1[428];
    *(vp++) = I0[429] + CD0*I1[429];
    *(vp++) = I0[430] + CD0*I1[430];
    *(vp++) = I0[431] + CD0*I1[431];
    *(vp++) = I0[432] + CD0*I1[432];
    *(vp++) = I0[433] + CD0*I1[433];
    *(vp++) = I0[434] + CD0*I1[434];
    *(vp++) = I0[435] + CD0*I1[435];
    *(vp++) = I0[436] + CD0*I1[436];
    *(vp++) = I0[437] + CD0*I1[437];
    *(vp++) = I0[438] + CD0*I1[438];
    *(vp++) = I0[439] + CD0*I1[439];
    *(vp++) = I0[440] + CD0*I1[440];
    *(vp++) = I0[561] + CD1*I1[435];
    *(vp++) = I0[562] + CD1*I1[436];
    *(vp++) = I0[563] + CD1*I1[437];
    *(vp++) = I0[564] + CD1*I1[438];
    *(vp++) = I0[565] + CD1*I1[439];
    *(vp++) = I0[566] + CD1*I1[440];
    *(vp++) = I0[587] + CD2*I1[440];
    *(vp++) = I0[441] + CD0*I1[441];
    *(vp++) = I0[442] + CD0*I1[442];
    *(vp++) = I0[443] + CD0*I1[443];
    *(vp++) = I0[444] + CD0*I1[444];
    *(vp++) = I0[445] + CD0*I1[445];
    *(vp++) = I0[446] + CD0*I1[446];
    *(vp++) = I0[447] + CD0*I1[447];
    *(vp++) = I0[448] + CD0*I1[448];
    *(vp++) = I0[449] + CD0*I1[449];
    *(vp++) = I0[450] + CD0*I1[450];
    *(vp++) = I0[451] + CD0*I1[451];
    *(vp++) = I0[452] + CD0*I1[452];
    *(vp++) = I0[453] + CD0*I1[453];
    *(vp++) = I0[454] + CD0*I1[454];
    *(vp++) = I0[455] + CD0*I1[455];
    *(vp++) = I0[456] + CD0*I1[456];
    *(vp++) = I0[457] + CD0*I1[457];
    *(vp++) = I0[458] + CD0*I1[458];
    *(vp++) = I0[459] + CD0*I1[459];
    *(vp++) = I0[460] + CD0*I1[460];
    *(vp++) = I0[461] + CD0*I1[461];
    *(vp++) = I0[603] + CD1*I1[456];
    *(vp++) = I0[604] + CD1*I1[457];
    *(vp++) = I0[605] + CD1*I1[458];
    *(vp++) = I0[606] + CD1*I1[459];
    *(vp++) = I0[607] + CD1*I1[460];
    *(vp++) = I0[608] + CD1*I1[461];
    *(vp++) = I0[629] + CD2*I1[461];
    *(vp++) = I0[462] + CD0*I1[462];
    *(vp++) = I0[463] + CD0*I1[463];
    *(vp++) = I0[464] + CD0*I1[464];
    *(vp++) = I0[465] + CD0*I1[465];
    *(vp++) = I0[466] + CD0*I1[466];
    *(vp++) = I0[467] + CD0*I1[467];
    *(vp++) = I0[468] + CD0*I1[468];
    *(vp++) = I0[469] + CD0*I1[469];
    *(vp++) = I0[470] + CD0*I1[470];
    *(vp++) = I0[471] + CD0*I1[471];
    *(vp++) = I0[472] + CD0*I1[472];
    *(vp++) = I0[473] + CD0*I1[473];
    *(vp++) = I0[474] + CD0*I1[474];
    *(vp++) = I0[475] + CD0*I1[475];
    *(vp++) = I0[476] + CD0*I1[476];
    *(vp++) = I0[477] + CD0*I1[477];
    *(vp++) = I0[478] + CD0*I1[478];
    *(vp++) = I0[479] + CD0*I1[479];
    *(vp++) = I0[480] + CD0*I1[480];
    *(vp++) = I0[481] + CD0*I1[481];
    *(vp++) = I0[482] + CD0*I1[482];
    *(vp++) = I0[624] + CD1*I1[477];
    *(vp++) = I0[625] + CD1*I1[478];
    *(vp++) = I0[626] + CD1*I1[479];
    *(vp++) = I0[627] + CD1*I1[480];
    *(vp++) = I0[628] + CD1*I1[481];
    *(vp++) = I0[629] + CD1*I1[482];
    *(vp++) = I0[650] + CD2*I1[482];
    *(vp++) = I0[483] + CD0*I1[483];
    *(vp++) = I0[484] + CD0*I1[484];
    *(vp++) = I0[485] + CD0*I1[485];
    *(vp++) = I0[486] + CD0*I1[486];
    *(vp++) = I0[487] + CD0*I1[487];
    *(vp++) = I0[488] + CD0*I1[488];
    *(vp++) = I0[489] + CD0*I1[489];
    *(vp++) = I0[490] + CD0*I1[490];
    *(vp++) = I0[491] + CD0*I1[491];
    *(vp++) = I0[492] + CD0*I1[492];
    *(vp++) = I0[493] + CD0*I1[493];
    *(vp++) = I0[494] + CD0*I1[494];
    *(vp++) = I0[495] + CD0*I1[495];
    *(vp++) = I0[496] + CD0*I1[496];
    *(vp++) = I0[497] + CD0*I1[497];
    *(vp++) = I0[498] + CD0*I1[498];
    *(vp++) = I0[499] + CD0*I1[499];
    *(vp++) = I0[500] + CD0*I1[500];
    *(vp++) = I0[501] + CD0*I1[501];
    *(vp++) = I0[502] + CD0*I1[502];
    *(vp++) = I0[503] + CD0*I1[503];
    *(vp++) = I0[645] + CD1*I1[498];
    *(vp++) = I0[646] + CD1*I1[499];
    *(vp++) = I0[647] + CD1*I1[500];
    *(vp++) = I0[648] + CD1*I1[501];
    *(vp++) = I0[649] + CD1*I1[502];
    *(vp++) = I0[650] + CD1*I1[503];
    *(vp++) = I0[671] + CD2*I1[503];
    *(vp++) = I0[504] + CD0*I1[504];
    *(vp++) = I0[505] + CD0*I1[505];
    *(vp++) = I0[506] + CD0*I1[506];
    *(vp++) = I0[507] + CD0*I1[507];
    *(vp++) = I0[508] + CD0*I1[508];
    *(vp++) = I0[509] + CD0*I1[509];
    *(vp++) = I0[510] + CD0*I1[510];
    *(vp++) = I0[511] + CD0*I1[511];
    *(vp++) = I0[512] + CD0*I1[512];
    *(vp++) = I0[513] + CD0*I1[513];
    *(vp++) = I0[514] + CD0*I1[514];
    *(vp++) = I0[515] + CD0*I1[515];
    *(vp++) = I0[516] + CD0*I1[516];
    *(vp++) = I0[517] + CD0*I1[517];
    *(vp++) = I0[518] + CD0*I1[518];
    *(vp++) = I0[519] + CD0*I1[519];
    *(vp++) = I0[520] + CD0*I1[520];
    *(vp++) = I0[521] + CD0*I1[521];
    *(vp++) = I0[522] + CD0*I1[522];
    *(vp++) = I0[523] + CD0*I1[523];
    *(vp++) = I0[524] + CD0*I1[524];
    *(vp++) = I0[666] + CD1*I1[519];
    *(vp++) = I0[667] + CD1*I1[520];
    *(vp++) = I0[668] + CD1*I1[521];
    *(vp++) = I0[669] + CD1*I1[522];
    *(vp++) = I0[670] + CD1*I1[523];
    *(vp++) = I0[671] + CD1*I1[524];
    *(vp++) = I0[692] + CD2*I1[524];
    *(vp++) = I0[525] + CD0*I1[525];
    *(vp++) = I0[526] + CD0*I1[526];
    *(vp++) = I0[527] + CD0*I1[527];
    *(vp++) = I0[528] + CD0*I1[528];
    *(vp++) = I0[529] + CD0*I1[529];
    *(vp++) = I0[530] + CD0*I1[530];
    *(vp++) = I0[531] + CD0*I1[531];
    *(vp++) = I0[532] + CD0*I1[532];
    *(vp++) = I0[533] + CD0*I1[533];
    *(vp++) = I0[534] + CD0*I1[534];
    *(vp++) = I0[535] + CD0*I1[535];
    *(vp++) = I0[536] + CD0*I1[536];
    *(vp++) = I0[537] + CD0*I1[537];
    *(vp++) = I0[538] + CD0*I1[538];
    *(vp++) = I0[539] + CD0*I1[539];
    *(vp++) = I0[540] + CD0*I1[540];
    *(vp++) = I0[541] + CD0*I1[541];
    *(vp++) = I0[542] + CD0*I1[542];
    *(vp++) = I0[543] + CD0*I1[543];
    *(vp++) = I0[544] + CD0*I1[544];
    *(vp++) = I0[545] + CD0*I1[545];
    *(vp++) = I0[687] + CD1*I1[540];
    *(vp++) = I0[688] + CD1*I1[541];
    *(vp++) = I0[689] + CD1*I1[542];
    *(vp++) = I0[690] + CD1*I1[543];
    *(vp++) = I0[691] + CD1*I1[544];
    *(vp++) = I0[692] + CD1*I1[545];
    *(vp++) = I0[713] + CD2*I1[545];
    *(vp++) = I0[546] + CD0*I1[546];
    *(vp++) = I0[547] + CD0*I1[547];
    *(vp++) = I0[548] + CD0*I1[548];
    *(vp++) = I0[549] + CD0*I1[549];
    *(vp++) = I0[550] + CD0*I1[550];
    *(vp++) = I0[551] + CD0*I1[551];
    *(vp++) = I0[552] + CD0*I1[552];
    *(vp++) = I0[553] + CD0*I1[553];
    *(vp++) = I0[554] + CD0*I1[554];
    *(vp++) = I0[555] + CD0*I1[555];
    *(vp++) = I0[556] + CD0*I1[556];
    *(vp++) = I0[557] + CD0*I1[557];
    *(vp++) = I0[558] + CD0*I1[558];
    *(vp++) = I0[559] + CD0*I1[559];
    *(vp++) = I0[560] + CD0*I1[560];
    *(vp++) = I0[561] + CD0*I1[561];
    *(vp++) = I0[562] + CD0*I1[562];
    *(vp++) = I0[563] + CD0*I1[563];
    *(vp++) = I0[564] + CD0*I1[564];
    *(vp++) = I0[565] + CD0*I1[565];
    *(vp++) = I0[566] + CD0*I1[566];
    *(vp++) = I0[708] + CD1*I1[561];
    *(vp++) = I0[709] + CD1*I1[562];
    *(vp++) = I0[710] + CD1*I1[563];
    *(vp++) = I0[711] + CD1*I1[564];
    *(vp++) = I0[712] + CD1*I1[565];
    *(vp++) = I0[713] + CD1*I1[566];
    *(vp++) = I0[734] + CD2*I1[566];
    *(vp++) = I0[567] + CD0*I1[567];
    *(vp++) = I0[568] + CD0*I1[568];
    *(vp++) = I0[569] + CD0*I1[569];
    *(vp++) = I0[570] + CD0*I1[570];
    *(vp++) = I0[571] + CD0*I1[571];
    *(vp++) = I0[572] + CD0*I1[572];
    *(vp++) = I0[573] + CD0*I1[573];
    *(vp++) = I0[574] + CD0*I1[574];
    *(vp++) = I0[575] + CD0*I1[575];
    *(vp++) = I0[576] + CD0*I1[576];
    *(vp++) = I0[577] + CD0*I1[577];
    *(vp++) = I0[578] + CD0*I1[578];
    *(vp++) = I0[579] + CD0*I1[579];
    *(vp++) = I0[580] + CD0*I1[580];
    *(vp++) = I0[581] + CD0*I1[581];
    *(vp++) = I0[582] + CD0*I1[582];
    *(vp++) = I0[583] + CD0*I1[583];
    *(vp++) = I0[584] + CD0*I1[584];
    *(vp++) = I0[585] + CD0*I1[585];
    *(vp++) = I0[586] + CD0*I1[586];
    *(vp++) = I0[587] + CD0*I1[587];
    *(vp++) = I0[729] + CD1*I1[582];
    *(vp++) = I0[730] + CD1*I1[583];
    *(vp++) = I0[731] + CD1*I1[584];
    *(vp++) = I0[732] + CD1*I1[585];
    *(vp++) = I0[733] + CD1*I1[586];
    *(vp++) = I0[734] + CD1*I1[587];
    *(vp++) = I0[755] + CD2*I1[587];
    *(vp++) = I0[588] + CD0*I1[588];
    *(vp++) = I0[589] + CD0*I1[589];
    *(vp++) = I0[590] + CD0*I1[590];
    *(vp++) = I0[591] + CD0*I1[591];
    *(vp++) = I0[592] + CD0*I1[592];
    *(vp++) = I0[593] + CD0*I1[593];
    *(vp++) = I0[594] + CD0*I1[594];
    *(vp++) = I0[595] + CD0*I1[595];
    *(vp++) = I0[596] + CD0*I1[596];
    *(vp++) = I0[597] + CD0*I1[597];
    *(vp++) = I0[598] + CD0*I1[598];
    *(vp++) = I0[599] + CD0*I1[599];
    *(vp++) = I0[600] + CD0*I1[600];
    *(vp++) = I0[601] + CD0*I1[601];
    *(vp++) = I0[602] + CD0*I1[602];
    *(vp++) = I0[603] + CD0*I1[603];
    *(vp++) = I0[604] + CD0*I1[604];
    *(vp++) = I0[605] + CD0*I1[605];
    *(vp++) = I0[606] + CD0*I1[606];
    *(vp++) = I0[607] + CD0*I1[607];
    *(vp++) = I0[608] + CD0*I1[608];
    *(vp++) = I0[771] + CD1*I1[603];
    *(vp++) = I0[772] + CD1*I1[604];
    *(vp++) = I0[773] + CD1*I1[605];
    *(vp++) = I0[774] + CD1*I1[606];
    *(vp++) = I0[775] + CD1*I1[607];
    *(vp++) = I0[776] + CD1*I1[608];
    *(vp++) = I0[797] + CD2*I1[608];
    *(vp++) = I0[609] + CD0*I1[609];
    *(vp++) = I0[610] + CD0*I1[610];
    *(vp++) = I0[611] + CD0*I1[611];
    *(vp++) = I0[612] + CD0*I1[612];
    *(vp++) = I0[613] + CD0*I1[613];
    *(vp++) = I0[614] + CD0*I1[614];
    *(vp++) = I0[615] + CD0*I1[615];
    *(vp++) = I0[616] + CD0*I1[616];
    *(vp++) = I0[617] + CD0*I1[617];
    *(vp++) = I0[618] + CD0*I1[618];
  return vp;
}

REALTYPE *_hrr3_build_oi_3(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[619] + CD0*I1[619];
    *(vp++) = I0[620] + CD0*I1[620];
    *(vp++) = I0[621] + CD0*I1[621];
    *(vp++) = I0[622] + CD0*I1[622];
    *(vp++) = I0[623] + CD0*I1[623];
    *(vp++) = I0[624] + CD0*I1[624];
    *(vp++) = I0[625] + CD0*I1[625];
    *(vp++) = I0[626] + CD0*I1[626];
    *(vp++) = I0[627] + CD0*I1[627];
    *(vp++) = I0[628] + CD0*I1[628];
    *(vp++) = I0[629] + CD0*I1[629];
    *(vp++) = I0[792] + CD1*I1[624];
    *(vp++) = I0[793] + CD1*I1[625];
    *(vp++) = I0[794] + CD1*I1[626];
    *(vp++) = I0[795] + CD1*I1[627];
    *(vp++) = I0[796] + CD1*I1[628];
    *(vp++) = I0[797] + CD1*I1[629];
    *(vp++) = I0[818] + CD2*I1[629];
    *(vp++) = I0[630] + CD0*I1[630];
    *(vp++) = I0[631] + CD0*I1[631];
    *(vp++) = I0[632] + CD0*I1[632];
    *(vp++) = I0[633] + CD0*I1[633];
    *(vp++) = I0[634] + CD0*I1[634];
    *(vp++) = I0[635] + CD0*I1[635];
    *(vp++) = I0[636] + CD0*I1[636];
    *(vp++) = I0[637] + CD0*I1[637];
    *(vp++) = I0[638] + CD0*I1[638];
    *(vp++) = I0[639] + CD0*I1[639];
    *(vp++) = I0[640] + CD0*I1[640];
    *(vp++) = I0[641] + CD0*I1[641];
    *(vp++) = I0[642] + CD0*I1[642];
    *(vp++) = I0[643] + CD0*I1[643];
    *(vp++) = I0[644] + CD0*I1[644];
    *(vp++) = I0[645] + CD0*I1[645];
    *(vp++) = I0[646] + CD0*I1[646];
    *(vp++) = I0[647] + CD0*I1[647];
    *(vp++) = I0[648] + CD0*I1[648];
    *(vp++) = I0[649] + CD0*I1[649];
    *(vp++) = I0[650] + CD0*I1[650];
    *(vp++) = I0[813] + CD1*I1[645];
    *(vp++) = I0[814] + CD1*I1[646];
    *(vp++) = I0[815] + CD1*I1[647];
    *(vp++) = I0[816] + CD1*I1[648];
    *(vp++) = I0[817] + CD1*I1[649];
    *(vp++) = I0[818] + CD1*I1[650];
    *(vp++) = I0[839] + CD2*I1[650];
    *(vp++) = I0[651] + CD0*I1[651];
    *(vp++) = I0[652] + CD0*I1[652];
    *(vp++) = I0[653] + CD0*I1[653];
    *(vp++) = I0[654] + CD0*I1[654];
    *(vp++) = I0[655] + CD0*I1[655];
    *(vp++) = I0[656] + CD0*I1[656];
    *(vp++) = I0[657] + CD0*I1[657];
    *(vp++) = I0[658] + CD0*I1[658];
    *(vp++) = I0[659] + CD0*I1[659];
    *(vp++) = I0[660] + CD0*I1[660];
    *(vp++) = I0[661] + CD0*I1[661];
    *(vp++) = I0[662] + CD0*I1[662];
    *(vp++) = I0[663] + CD0*I1[663];
    *(vp++) = I0[664] + CD0*I1[664];
    *(vp++) = I0[665] + CD0*I1[665];
    *(vp++) = I0[666] + CD0*I1[666];
    *(vp++) = I0[667] + CD0*I1[667];
    *(vp++) = I0[668] + CD0*I1[668];
    *(vp++) = I0[669] + CD0*I1[669];
    *(vp++) = I0[670] + CD0*I1[670];
    *(vp++) = I0[671] + CD0*I1[671];
    *(vp++) = I0[834] + CD1*I1[666];
    *(vp++) = I0[835] + CD1*I1[667];
    *(vp++) = I0[836] + CD1*I1[668];
    *(vp++) = I0[837] + CD1*I1[669];
    *(vp++) = I0[838] + CD1*I1[670];
    *(vp++) = I0[839] + CD1*I1[671];
    *(vp++) = I0[860] + CD2*I1[671];
    *(vp++) = I0[672] + CD0*I1[672];
    *(vp++) = I0[673] + CD0*I1[673];
    *(vp++) = I0[674] + CD0*I1[674];
    *(vp++) = I0[675] + CD0*I1[675];
    *(vp++) = I0[676] + CD0*I1[676];
    *(vp++) = I0[677] + CD0*I1[677];
    *(vp++) = I0[678] + CD0*I1[678];
    *(vp++) = I0[679] + CD0*I1[679];
    *(vp++) = I0[680] + CD0*I1[680];
    *(vp++) = I0[681] + CD0*I1[681];
    *(vp++) = I0[682] + CD0*I1[682];
    *(vp++) = I0[683] + CD0*I1[683];
    *(vp++) = I0[684] + CD0*I1[684];
    *(vp++) = I0[685] + CD0*I1[685];
    *(vp++) = I0[686] + CD0*I1[686];
    *(vp++) = I0[687] + CD0*I1[687];
    *(vp++) = I0[688] + CD0*I1[688];
    *(vp++) = I0[689] + CD0*I1[689];
    *(vp++) = I0[690] + CD0*I1[690];
    *(vp++) = I0[691] + CD0*I1[691];
    *(vp++) = I0[692] + CD0*I1[692];
    *(vp++) = I0[855] + CD1*I1[687];
    *(vp++) = I0[856] + CD1*I1[688];
    *(vp++) = I0[857] + CD1*I1[689];
    *(vp++) = I0[858] + CD1*I1[690];
    *(vp++) = I0[859] + CD1*I1[691];
    *(vp++) = I0[860] + CD1*I1[692];
    *(vp++) = I0[881] + CD2*I1[692];
    *(vp++) = I0[693] + CD0*I1[693];
    *(vp++) = I0[694] + CD0*I1[694];
    *(vp++) = I0[695] + CD0*I1[695];
    *(vp++) = I0[696] + CD0*I1[696];
    *(vp++) = I0[697] + CD0*I1[697];
    *(vp++) = I0[698] + CD0*I1[698];
    *(vp++) = I0[699] + CD0*I1[699];
    *(vp++) = I0[700] + CD0*I1[700];
    *(vp++) = I0[701] + CD0*I1[701];
    *(vp++) = I0[702] + CD0*I1[702];
    *(vp++) = I0[703] + CD0*I1[703];
    *(vp++) = I0[704] + CD0*I1[704];
    *(vp++) = I0[705] + CD0*I1[705];
    *(vp++) = I0[706] + CD0*I1[706];
    *(vp++) = I0[707] + CD0*I1[707];
    *(vp++) = I0[708] + CD0*I1[708];
    *(vp++) = I0[709] + CD0*I1[709];
    *(vp++) = I0[710] + CD0*I1[710];
    *(vp++) = I0[711] + CD0*I1[711];
    *(vp++) = I0[712] + CD0*I1[712];
    *(vp++) = I0[713] + CD0*I1[713];
    *(vp++) = I0[876] + CD1*I1[708];
    *(vp++) = I0[877] + CD1*I1[709];
    *(vp++) = I0[878] + CD1*I1[710];
    *(vp++) = I0[879] + CD1*I1[711];
    *(vp++) = I0[880] + CD1*I1[712];
    *(vp++) = I0[881] + CD1*I1[713];
    *(vp++) = I0[902] + CD2*I1[713];
    *(vp++) = I0[714] + CD0*I1[714];
    *(vp++) = I0[715] + CD0*I1[715];
    *(vp++) = I0[716] + CD0*I1[716];
    *(vp++) = I0[717] + CD0*I1[717];
    *(vp++) = I0[718] + CD0*I1[718];
    *(vp++) = I0[719] + CD0*I1[719];
    *(vp++) = I0[720] + CD0*I1[720];
    *(vp++) = I0[721] + CD0*I1[721];
    *(vp++) = I0[722] + CD0*I1[722];
    *(vp++) = I0[723] + CD0*I1[723];
    *(vp++) = I0[724] + CD0*I1[724];
    *(vp++) = I0[725] + CD0*I1[725];
    *(vp++) = I0[726] + CD0*I1[726];
    *(vp++) = I0[727] + CD0*I1[727];
    *(vp++) = I0[728] + CD0*I1[728];
    *(vp++) = I0[729] + CD0*I1[729];
    *(vp++) = I0[730] + CD0*I1[730];
    *(vp++) = I0[731] + CD0*I1[731];
    *(vp++) = I0[732] + CD0*I1[732];
    *(vp++) = I0[733] + CD0*I1[733];
    *(vp++) = I0[734] + CD0*I1[734];
    *(vp++) = I0[897] + CD1*I1[729];
    *(vp++) = I0[898] + CD1*I1[730];
    *(vp++) = I0[899] + CD1*I1[731];
    *(vp++) = I0[900] + CD1*I1[732];
    *(vp++) = I0[901] + CD1*I1[733];
    *(vp++) = I0[902] + CD1*I1[734];
    *(vp++) = I0[923] + CD2*I1[734];
    *(vp++) = I0[735] + CD0*I1[735];
    *(vp++) = I0[736] + CD0*I1[736];
    *(vp++) = I0[737] + CD0*I1[737];
    *(vp++) = I0[738] + CD0*I1[738];
    *(vp++) = I0[739] + CD0*I1[739];
    *(vp++) = I0[740] + CD0*I1[740];
    *(vp++) = I0[741] + CD0*I1[741];
    *(vp++) = I0[742] + CD0*I1[742];
    *(vp++) = I0[743] + CD0*I1[743];
    *(vp++) = I0[744] + CD0*I1[744];
    *(vp++) = I0[745] + CD0*I1[745];
    *(vp++) = I0[746] + CD0*I1[746];
    *(vp++) = I0[747] + CD0*I1[747];
    *(vp++) = I0[748] + CD0*I1[748];
    *(vp++) = I0[749] + CD0*I1[749];
    *(vp++) = I0[750] + CD0*I1[750];
    *(vp++) = I0[751] + CD0*I1[751];
    *(vp++) = I0[752] + CD0*I1[752];
    *(vp++) = I0[753] + CD0*I1[753];
    *(vp++) = I0[754] + CD0*I1[754];
    *(vp++) = I0[755] + CD0*I1[755];
    *(vp++) = I0[918] + CD1*I1[750];
    *(vp++) = I0[919] + CD1*I1[751];
    *(vp++) = I0[920] + CD1*I1[752];
    *(vp++) = I0[921] + CD1*I1[753];
    *(vp++) = I0[922] + CD1*I1[754];
    *(vp++) = I0[923] + CD1*I1[755];
    *(vp++) = I0[944] + CD2*I1[755];
    *(vp++) = I0[756] + CD0*I1[756];
    *(vp++) = I0[757] + CD0*I1[757];
    *(vp++) = I0[758] + CD0*I1[758];
    *(vp++) = I0[759] + CD0*I1[759];
    *(vp++) = I0[760] + CD0*I1[760];
    *(vp++) = I0[761] + CD0*I1[761];
    *(vp++) = I0[762] + CD0*I1[762];
    *(vp++) = I0[763] + CD0*I1[763];
    *(vp++) = I0[764] + CD0*I1[764];
    *(vp++) = I0[765] + CD0*I1[765];
    *(vp++) = I0[766] + CD0*I1[766];
    *(vp++) = I0[767] + CD0*I1[767];
    *(vp++) = I0[768] + CD0*I1[768];
    *(vp++) = I0[769] + CD0*I1[769];
    *(vp++) = I0[770] + CD0*I1[770];
    *(vp++) = I0[771] + CD0*I1[771];
    *(vp++) = I0[772] + CD0*I1[772];
    *(vp++) = I0[773] + CD0*I1[773];
    *(vp++) = I0[774] + CD0*I1[774];
    *(vp++) = I0[775] + CD0*I1[775];
    *(vp++) = I0[776] + CD0*I1[776];
    *(vp++) = I0[960] + CD1*I1[771];
    *(vp++) = I0[961] + CD1*I1[772];
    *(vp++) = I0[962] + CD1*I1[773];
    *(vp++) = I0[963] + CD1*I1[774];
    *(vp++) = I0[964] + CD1*I1[775];
    *(vp++) = I0[965] + CD1*I1[776];
    *(vp++) = I0[986] + CD2*I1[776];
    *(vp++) = I0[777] + CD0*I1[777];
    *(vp++) = I0[778] + CD0*I1[778];
    *(vp++) = I0[779] + CD0*I1[779];
    *(vp++) = I0[780] + CD0*I1[780];
    *(vp++) = I0[781] + CD0*I1[781];
    *(vp++) = I0[782] + CD0*I1[782];
    *(vp++) = I0[783] + CD0*I1[783];
    *(vp++) = I0[784] + CD0*I1[784];
    *(vp++) = I0[785] + CD0*I1[785];
    *(vp++) = I0[786] + CD0*I1[786];
    *(vp++) = I0[787] + CD0*I1[787];
    *(vp++) = I0[788] + CD0*I1[788];
    *(vp++) = I0[789] + CD0*I1[789];
    *(vp++) = I0[790] + CD0*I1[790];
    *(vp++) = I0[791] + CD0*I1[791];
    *(vp++) = I0[792] + CD0*I1[792];
    *(vp++) = I0[793] + CD0*I1[793];
    *(vp++) = I0[794] + CD0*I1[794];
    *(vp++) = I0[795] + CD0*I1[795];
    *(vp++) = I0[796] + CD0*I1[796];
    *(vp++) = I0[797] + CD0*I1[797];
    *(vp++) = I0[981] + CD1*I1[792];
    *(vp++) = I0[982] + CD1*I1[793];
    *(vp++) = I0[983] + CD1*I1[794];
    *(vp++) = I0[984] + CD1*I1[795];
    *(vp++) = I0[985] + CD1*I1[796];
    *(vp++) = I0[986] + CD1*I1[797];
    *(vp++) = I0[1007] + CD2*I1[797];
    *(vp++) = I0[798] + CD0*I1[798];
    *(vp++) = I0[799] + CD0*I1[799];
    *(vp++) = I0[800] + CD0*I1[800];
    *(vp++) = I0[801] + CD0*I1[801];
    *(vp++) = I0[802] + CD0*I1[802];
    *(vp++) = I0[803] + CD0*I1[803];
    *(vp++) = I0[804] + CD0*I1[804];
    *(vp++) = I0[805] + CD0*I1[805];
    *(vp++) = I0[806] + CD0*I1[806];
    *(vp++) = I0[807] + CD0*I1[807];
    *(vp++) = I0[808] + CD0*I1[808];
    *(vp++) = I0[809] + CD0*I1[809];
    *(vp++) = I0[810] + CD0*I1[810];
    *(vp++) = I0[811] + CD0*I1[811];
    *(vp++) = I0[812] + CD0*I1[812];
    *(vp++) = I0[813] + CD0*I1[813];
    *(vp++) = I0[814] + CD0*I1[814];
    *(vp++) = I0[815] + CD0*I1[815];
    *(vp++) = I0[816] + CD0*I1[816];
    *(vp++) = I0[817] + CD0*I1[817];
    *(vp++) = I0[818] + CD0*I1[818];
    *(vp++) = I0[1002] + CD1*I1[813];
    *(vp++) = I0[1003] + CD1*I1[814];
    *(vp++) = I0[1004] + CD1*I1[815];
    *(vp++) = I0[1005] + CD1*I1[816];
    *(vp++) = I0[1006] + CD1*I1[817];
    *(vp++) = I0[1007] + CD1*I1[818];
    *(vp++) = I0[1028] + CD2*I1[818];
    *(vp++) = I0[819] + CD0*I1[819];
    *(vp++) = I0[820] + CD0*I1[820];
    *(vp++) = I0[821] + CD0*I1[821];
    *(vp++) = I0[822] + CD0*I1[822];
  return vp;
}

REALTYPE *_hrr3_build_oi_4(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[823] + CD0*I1[823];
    *(vp++) = I0[824] + CD0*I1[824];
    *(vp++) = I0[825] + CD0*I1[825];
    *(vp++) = I0[826] + CD0*I1[826];
    *(vp++) = I0[827] + CD0*I1[827];
    *(vp++) = I0[828] + CD0*I1[828];
    *(vp++) = I0[829] + CD0*I1[829];
    *(vp++) = I0[830] + CD0*I1[830];
    *(vp++) = I0[831] + CD0*I1[831];
    *(vp++) = I0[832] + CD0*I1[832];
    *(vp++) = I0[833] + CD0*I1[833];
    *(vp++) = I0[834] + CD0*I1[834];
    *(vp++) = I0[835] + CD0*I1[835];
    *(vp++) = I0[836] + CD0*I1[836];
    *(vp++) = I0[837] + CD0*I1[837];
    *(vp++) = I0[838] + CD0*I1[838];
    *(vp++) = I0[839] + CD0*I1[839];
    *(vp++) = I0[1023] + CD1*I1[834];
    *(vp++) = I0[1024] + CD1*I1[835];
    *(vp++) = I0[1025] + CD1*I1[836];
    *(vp++) = I0[1026] + CD1*I1[837];
    *(vp++) = I0[1027] + CD1*I1[838];
    *(vp++) = I0[1028] + CD1*I1[839];
    *(vp++) = I0[1049] + CD2*I1[839];
    *(vp++) = I0[840] + CD0*I1[840];
    *(vp++) = I0[841] + CD0*I1[841];
    *(vp++) = I0[842] + CD0*I1[842];
    *(vp++) = I0[843] + CD0*I1[843];
    *(vp++) = I0[844] + CD0*I1[844];
    *(vp++) = I0[845] + CD0*I1[845];
    *(vp++) = I0[846] + CD0*I1[846];
    *(vp++) = I0[847] + CD0*I1[847];
    *(vp++) = I0[848] + CD0*I1[848];
    *(vp++) = I0[849] + CD0*I1[849];
    *(vp++) = I0[850] + CD0*I1[850];
    *(vp++) = I0[851] + CD0*I1[851];
    *(vp++) = I0[852] + CD0*I1[852];
    *(vp++) = I0[853] + CD0*I1[853];
    *(vp++) = I0[854] + CD0*I1[854];
    *(vp++) = I0[855] + CD0*I1[855];
    *(vp++) = I0[856] + CD0*I1[856];
    *(vp++) = I0[857] + CD0*I1[857];
    *(vp++) = I0[858] + CD0*I1[858];
    *(vp++) = I0[859] + CD0*I1[859];
    *(vp++) = I0[860] + CD0*I1[860];
    *(vp++) = I0[1044] + CD1*I1[855];
    *(vp++) = I0[1045] + CD1*I1[856];
    *(vp++) = I0[1046] + CD1*I1[857];
    *(vp++) = I0[1047] + CD1*I1[858];
    *(vp++) = I0[1048] + CD1*I1[859];
    *(vp++) = I0[1049] + CD1*I1[860];
    *(vp++) = I0[1070] + CD2*I1[860];
    *(vp++) = I0[861] + CD0*I1[861];
    *(vp++) = I0[862] + CD0*I1[862];
    *(vp++) = I0[863] + CD0*I1[863];
    *(vp++) = I0[864] + CD0*I1[864];
    *(vp++) = I0[865] + CD0*I1[865];
    *(vp++) = I0[866] + CD0*I1[866];
    *(vp++) = I0[867] + CD0*I1[867];
    *(vp++) = I0[868] + CD0*I1[868];
    *(vp++) = I0[869] + CD0*I1[869];
    *(vp++) = I0[870] + CD0*I1[870];
    *(vp++) = I0[871] + CD0*I1[871];
    *(vp++) = I0[872] + CD0*I1[872];
    *(vp++) = I0[873] + CD0*I1[873];
    *(vp++) = I0[874] + CD0*I1[874];
    *(vp++) = I0[875] + CD0*I1[875];
    *(vp++) = I0[876] + CD0*I1[876];
    *(vp++) = I0[877] + CD0*I1[877];
    *(vp++) = I0[878] + CD0*I1[878];
    *(vp++) = I0[879] + CD0*I1[879];
    *(vp++) = I0[880] + CD0*I1[880];
    *(vp++) = I0[881] + CD0*I1[881];
    *(vp++) = I0[1065] + CD1*I1[876];
    *(vp++) = I0[1066] + CD1*I1[877];
    *(vp++) = I0[1067] + CD1*I1[878];
    *(vp++) = I0[1068] + CD1*I1[879];
    *(vp++) = I0[1069] + CD1*I1[880];
    *(vp++) = I0[1070] + CD1*I1[881];
    *(vp++) = I0[1091] + CD2*I1[881];
    *(vp++) = I0[882] + CD0*I1[882];
    *(vp++) = I0[883] + CD0*I1[883];
    *(vp++) = I0[884] + CD0*I1[884];
    *(vp++) = I0[885] + CD0*I1[885];
    *(vp++) = I0[886] + CD0*I1[886];
    *(vp++) = I0[887] + CD0*I1[887];
    *(vp++) = I0[888] + CD0*I1[888];
    *(vp++) = I0[889] + CD0*I1[889];
    *(vp++) = I0[890] + CD0*I1[890];
    *(vp++) = I0[891] + CD0*I1[891];
    *(vp++) = I0[892] + CD0*I1[892];
    *(vp++) = I0[893] + CD0*I1[893];
    *(vp++) = I0[894] + CD0*I1[894];
    *(vp++) = I0[895] + CD0*I1[895];
    *(vp++) = I0[896] + CD0*I1[896];
    *(vp++) = I0[897] + CD0*I1[897];
    *(vp++) = I0[898] + CD0*I1[898];
    *(vp++) = I0[899] + CD0*I1[899];
    *(vp++) = I0[900] + CD0*I1[900];
    *(vp++) = I0[901] + CD0*I1[901];
    *(vp++) = I0[902] + CD0*I1[902];
    *(vp++) = I0[1086] + CD1*I1[897];
    *(vp++) = I0[1087] + CD1*I1[898];
    *(vp++) = I0[1088] + CD1*I1[899];
    *(vp++) = I0[1089] + CD1*I1[900];
    *(vp++) = I0[1090] + CD1*I1[901];
    *(vp++) = I0[1091] + CD1*I1[902];
    *(vp++) = I0[1112] + CD2*I1[902];
    *(vp++) = I0[903] + CD0*I1[903];
    *(vp++) = I0[904] + CD0*I1[904];
    *(vp++) = I0[905] + CD0*I1[905];
    *(vp++) = I0[906] + CD0*I1[906];
    *(vp++) = I0[907] + CD0*I1[907];
    *(vp++) = I0[908] + CD0*I1[908];
    *(vp++) = I0[909] + CD0*I1[909];
    *(vp++) = I0[910] + CD0*I1[910];
    *(vp++) = I0[911] + CD0*I1[911];
    *(vp++) = I0[912] + CD0*I1[912];
    *(vp++) = I0[913] + CD0*I1[913];
    *(vp++) = I0[914] + CD0*I1[914];
    *(vp++) = I0[915] + CD0*I1[915];
    *(vp++) = I0[916] + CD0*I1[916];
    *(vp++) = I0[917] + CD0*I1[917];
    *(vp++) = I0[918] + CD0*I1[918];
    *(vp++) = I0[919] + CD0*I1[919];
    *(vp++) = I0[920] + CD0*I1[920];
    *(vp++) = I0[921] + CD0*I1[921];
    *(vp++) = I0[922] + CD0*I1[922];
    *(vp++) = I0[923] + CD0*I1[923];
    *(vp++) = I0[1107] + CD1*I1[918];
    *(vp++) = I0[1108] + CD1*I1[919];
    *(vp++) = I0[1109] + CD1*I1[920];
    *(vp++) = I0[1110] + CD1*I1[921];
    *(vp++) = I0[1111] + CD1*I1[922];
    *(vp++) = I0[1112] + CD1*I1[923];
    *(vp++) = I0[1133] + CD2*I1[923];
    *(vp++) = I0[924] + CD0*I1[924];
    *(vp++) = I0[925] + CD0*I1[925];
    *(vp++) = I0[926] + CD0*I1[926];
    *(vp++) = I0[927] + CD0*I1[927];
    *(vp++) = I0[928] + CD0*I1[928];
    *(vp++) = I0[929] + CD0*I1[929];
    *(vp++) = I0[930] + CD0*I1[930];
    *(vp++) = I0[931] + CD0*I1[931];
    *(vp++) = I0[932] + CD0*I1[932];
    *(vp++) = I0[933] + CD0*I1[933];
    *(vp++) = I0[934] + CD0*I1[934];
    *(vp++) = I0[935] + CD0*I1[935];
    *(vp++) = I0[936] + CD0*I1[936];
    *(vp++) = I0[937] + CD0*I1[937];
    *(vp++) = I0[938] + CD0*I1[938];
    *(vp++) = I0[939] + CD0*I1[939];
    *(vp++) = I0[940] + CD0*I1[940];
    *(vp++) = I0[941] + CD0*I1[941];
    *(vp++) = I0[942] + CD0*I1[942];
    *(vp++) = I0[943] + CD0*I1[943];
    *(vp++) = I0[944] + CD0*I1[944];
    *(vp++) = I0[1128] + CD1*I1[939];
    *(vp++) = I0[1129] + CD1*I1[940];
    *(vp++) = I0[1130] + CD1*I1[941];
    *(vp++) = I0[1131] + CD1*I1[942];
    *(vp++) = I0[1132] + CD1*I1[943];
    *(vp++) = I0[1133] + CD1*I1[944];
    *(vp++) = I0[1154] + CD2*I1[944];
    *(vp++) = I0[945] + CD0*I1[945];
    *(vp++) = I0[946] + CD0*I1[946];
    *(vp++) = I0[947] + CD0*I1[947];
    *(vp++) = I0[948] + CD0*I1[948];
    *(vp++) = I0[949] + CD0*I1[949];
    *(vp++) = I0[950] + CD0*I1[950];
    *(vp++) = I0[951] + CD0*I1[951];
    *(vp++) = I0[952] + CD0*I1[952];
    *(vp++) = I0[953] + CD0*I1[953];
    *(vp++) = I0[954] + CD0*I1[954];
    *(vp++) = I0[955] + CD0*I1[955];
    *(vp++) = I0[956] + CD0*I1[956];
    *(vp++) = I0[957] + CD0*I1[957];
    *(vp++) = I0[958] + CD0*I1[958];
    *(vp++) = I0[959] + CD0*I1[959];
    *(vp++) = I0[960] + CD0*I1[960];
    *(vp++) = I0[961] + CD0*I1[961];
    *(vp++) = I0[962] + CD0*I1[962];
    *(vp++) = I0[963] + CD0*I1[963];
    *(vp++) = I0[964] + CD0*I1[964];
    *(vp++) = I0[965] + CD0*I1[965];
    *(vp++) = I0[1170] + CD1*I1[960];
    *(vp++) = I0[1171] + CD1*I1[961];
    *(vp++) = I0[1172] + CD1*I1[962];
    *(vp++) = I0[1173] + CD1*I1[963];
    *(vp++) = I0[1174] + CD1*I1[964];
    *(vp++) = I0[1175] + CD1*I1[965];
    *(vp++) = I0[1196] + CD2*I1[965];
    *(vp++) = I0[966] + CD0*I1[966];
    *(vp++) = I0[967] + CD0*I1[967];
    *(vp++) = I0[968] + CD0*I1[968];
    *(vp++) = I0[969] + CD0*I1[969];
    *(vp++) = I0[970] + CD0*I1[970];
    *(vp++) = I0[971] + CD0*I1[971];
    *(vp++) = I0[972] + CD0*I1[972];
    *(vp++) = I0[973] + CD0*I1[973];
    *(vp++) = I0[974] + CD0*I1[974];
    *(vp++) = I0[975] + CD0*I1[975];
    *(vp++) = I0[976] + CD0*I1[976];
    *(vp++) = I0[977] + CD0*I1[977];
    *(vp++) = I0[978] + CD0*I1[978];
    *(vp++) = I0[979] + CD0*I1[979];
    *(vp++) = I0[980] + CD0*I1[980];
    *(vp++) = I0[981] + CD0*I1[981];
    *(vp++) = I0[982] + CD0*I1[982];
    *(vp++) = I0[983] + CD0*I1[983];
    *(vp++) = I0[984] + CD0*I1[984];
    *(vp++) = I0[985] + CD0*I1[985];
    *(vp++) = I0[986] + CD0*I1[986];
    *(vp++) = I0[1191] + CD1*I1[981];
    *(vp++) = I0[1192] + CD1*I1[982];
    *(vp++) = I0[1193] + CD1*I1[983];
    *(vp++) = I0[1194] + CD1*I1[984];
    *(vp++) = I0[1195] + CD1*I1[985];
    *(vp++) = I0[1196] + CD1*I1[986];
    *(vp++) = I0[1217] + CD2*I1[986];
    *(vp++) = I0[987] + CD0*I1[987];
    *(vp++) = I0[988] + CD0*I1[988];
    *(vp++) = I0[989] + CD0*I1[989];
    *(vp++) = I0[990] + CD0*I1[990];
    *(vp++) = I0[991] + CD0*I1[991];
    *(vp++) = I0[992] + CD0*I1[992];
    *(vp++) = I0[993] + CD0*I1[993];
    *(vp++) = I0[994] + CD0*I1[994];
    *(vp++) = I0[995] + CD0*I1[995];
    *(vp++) = I0[996] + CD0*I1[996];
    *(vp++) = I0[997] + CD0*I1[997];
    *(vp++) = I0[998] + CD0*I1[998];
    *(vp++) = I0[999] + CD0*I1[999];
    *(vp++) = I0[1000] + CD0*I1[1000];
    *(vp++) = I0[1001] + CD0*I1[1001];
    *(vp++) = I0[1002] + CD0*I1[1002];
    *(vp++) = I0[1003] + CD0*I1[1003];
    *(vp++) = I0[1004] + CD0*I1[1004];
    *(vp++) = I0[1005] + CD0*I1[1005];
    *(vp++) = I0[1006] + CD0*I1[1006];
    *(vp++) = I0[1007] + CD0*I1[1007];
    *(vp++) = I0[1212] + CD1*I1[1002];
    *(vp++) = I0[1213] + CD1*I1[1003];
    *(vp++) = I0[1214] + CD1*I1[1004];
    *(vp++) = I0[1215] + CD1*I1[1005];
    *(vp++) = I0[1216] + CD1*I1[1006];
    *(vp++) = I0[1217] + CD1*I1[1007];
    *(vp++) = I0[1238] + CD2*I1[1007];
    *(vp++) = I0[1008] + CD0*I1[1008];
    *(vp++) = I0[1009] + CD0*I1[1009];
    *(vp++) = I0[1010] + CD0*I1[1010];
    *(vp++) = I0[1011] + CD0*I1[1011];
    *(vp++) = I0[1012] + CD0*I1[1012];
    *(vp++) = I0[1013] + CD0*I1[1013];
    *(vp++) = I0[1014] + CD0*I1[1014];
    *(vp++) = I0[1015] + CD0*I1[1015];
    *(vp++) = I0[1016] + CD0*I1[1016];
    *(vp++) = I0[1017] + CD0*I1[1017];
    *(vp++) = I0[1018] + CD0*I1[1018];
    *(vp++) = I0[1019] + CD0*I1[1019];
    *(vp++) = I0[1020] + CD0*I1[1020];
    *(vp++) = I0[1021] + CD0*I1[1021];
    *(vp++) = I0[1022] + CD0*I1[1022];
    *(vp++) = I0[1023] + CD0*I1[1023];
    *(vp++) = I0[1024] + CD0*I1[1024];
    *(vp++) = I0[1025] + CD0*I1[1025];
    *(vp++) = I0[1026] + CD0*I1[1026];
    *(vp++) = I0[1027] + CD0*I1[1027];
    *(vp++) = I0[1028] + CD0*I1[1028];
    *(vp++) = I0[1233] + CD1*I1[1023];
    *(vp++) = I0[1234] + CD1*I1[1024];
    *(vp++) = I0[1235] + CD1*I1[1025];
    *(vp++) = I0[1236] + CD1*I1[1026];
    *(vp++) = I0[1237] + CD1*I1[1027];
  return vp;
}

REALTYPE *_hrr3_build_oi_5(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[1238] + CD1*I1[1028];
    *(vp++) = I0[1259] + CD2*I1[1028];
    *(vp++) = I0[1029] + CD0*I1[1029];
    *(vp++) = I0[1030] + CD0*I1[1030];
    *(vp++) = I0[1031] + CD0*I1[1031];
    *(vp++) = I0[1032] + CD0*I1[1032];
    *(vp++) = I0[1033] + CD0*I1[1033];
    *(vp++) = I0[1034] + CD0*I1[1034];
    *(vp++) = I0[1035] + CD0*I1[1035];
    *(vp++) = I0[1036] + CD0*I1[1036];
    *(vp++) = I0[1037] + CD0*I1[1037];
    *(vp++) = I0[1038] + CD0*I1[1038];
    *(vp++) = I0[1039] + CD0*I1[1039];
    *(vp++) = I0[1040] + CD0*I1[1040];
    *(vp++) = I0[1041] + CD0*I1[1041];
    *(vp++) = I0[1042] + CD0*I1[1042];
    *(vp++) = I0[1043] + CD0*I1[1043];
    *(vp++) = I0[1044] + CD0*I1[1044];
    *(vp++) = I0[1045] + CD0*I1[1045];
    *(vp++) = I0[1046] + CD0*I1[1046];
    *(vp++) = I0[1047] + CD0*I1[1047];
    *(vp++) = I0[1048] + CD0*I1[1048];
    *(vp++) = I0[1049] + CD0*I1[1049];
    *(vp++) = I0[1254] + CD1*I1[1044];
    *(vp++) = I0[1255] + CD1*I1[1045];
    *(vp++) = I0[1256] + CD1*I1[1046];
    *(vp++) = I0[1257] + CD1*I1[1047];
    *(vp++) = I0[1258] + CD1*I1[1048];
    *(vp++) = I0[1259] + CD1*I1[1049];
    *(vp++) = I0[1280] + CD2*I1[1049];
    *(vp++) = I0[1050] + CD0*I1[1050];
    *(vp++) = I0[1051] + CD0*I1[1051];
    *(vp++) = I0[1052] + CD0*I1[1052];
    *(vp++) = I0[1053] + CD0*I1[1053];
    *(vp++) = I0[1054] + CD0*I1[1054];
    *(vp++) = I0[1055] + CD0*I1[1055];
    *(vp++) = I0[1056] + CD0*I1[1056];
    *(vp++) = I0[1057] + CD0*I1[1057];
    *(vp++) = I0[1058] + CD0*I1[1058];
    *(vp++) = I0[1059] + CD0*I1[1059];
    *(vp++) = I0[1060] + CD0*I1[1060];
    *(vp++) = I0[1061] + CD0*I1[1061];
    *(vp++) = I0[1062] + CD0*I1[1062];
    *(vp++) = I0[1063] + CD0*I1[1063];
    *(vp++) = I0[1064] + CD0*I1[1064];
    *(vp++) = I0[1065] + CD0*I1[1065];
    *(vp++) = I0[1066] + CD0*I1[1066];
    *(vp++) = I0[1067] + CD0*I1[1067];
    *(vp++) = I0[1068] + CD0*I1[1068];
    *(vp++) = I0[1069] + CD0*I1[1069];
    *(vp++) = I0[1070] + CD0*I1[1070];
    *(vp++) = I0[1275] + CD1*I1[1065];
    *(vp++) = I0[1276] + CD1*I1[1066];
    *(vp++) = I0[1277] + CD1*I1[1067];
    *(vp++) = I0[1278] + CD1*I1[1068];
    *(vp++) = I0[1279] + CD1*I1[1069];
    *(vp++) = I0[1280] + CD1*I1[1070];
    *(vp++) = I0[1301] + CD2*I1[1070];
    *(vp++) = I0[1071] + CD0*I1[1071];
    *(vp++) = I0[1072] + CD0*I1[1072];
    *(vp++) = I0[1073] + CD0*I1[1073];
    *(vp++) = I0[1074] + CD0*I1[1074];
    *(vp++) = I0[1075] + CD0*I1[1075];
    *(vp++) = I0[1076] + CD0*I1[1076];
    *(vp++) = I0[1077] + CD0*I1[1077];
    *(vp++) = I0[1078] + CD0*I1[1078];
    *(vp++) = I0[1079] + CD0*I1[1079];
    *(vp++) = I0[1080] + CD0*I1[1080];
    *(vp++) = I0[1081] + CD0*I1[1081];
    *(vp++) = I0[1082] + CD0*I1[1082];
    *(vp++) = I0[1083] + CD0*I1[1083];
    *(vp++) = I0[1084] + CD0*I1[1084];
    *(vp++) = I0[1085] + CD0*I1[1085];
    *(vp++) = I0[1086] + CD0*I1[1086];
    *(vp++) = I0[1087] + CD0*I1[1087];
    *(vp++) = I0[1088] + CD0*I1[1088];
    *(vp++) = I0[1089] + CD0*I1[1089];
    *(vp++) = I0[1090] + CD0*I1[1090];
    *(vp++) = I0[1091] + CD0*I1[1091];
    *(vp++) = I0[1296] + CD1*I1[1086];
    *(vp++) = I0[1297] + CD1*I1[1087];
    *(vp++) = I0[1298] + CD1*I1[1088];
    *(vp++) = I0[1299] + CD1*I1[1089];
    *(vp++) = I0[1300] + CD1*I1[1090];
    *(vp++) = I0[1301] + CD1*I1[1091];
    *(vp++) = I0[1322] + CD2*I1[1091];
    *(vp++) = I0[1092] + CD0*I1[1092];
    *(vp++) = I0[1093] + CD0*I1[1093];
    *(vp++) = I0[1094] + CD0*I1[1094];
    *(vp++) = I0[1095] + CD0*I1[1095];
    *(vp++) = I0[1096] + CD0*I1[1096];
    *(vp++) = I0[1097] + CD0*I1[1097];
    *(vp++) = I0[1098] + CD0*I1[1098];
    *(vp++) = I0[1099] + CD0*I1[1099];
    *(vp++) = I0[1100] + CD0*I1[1100];
    *(vp++) = I0[1101] + CD0*I1[1101];
    *(vp++) = I0[1102] + CD0*I1[1102];
    *(vp++) = I0[1103] + CD0*I1[1103];
    *(vp++) = I0[1104] + CD0*I1[1104];
    *(vp++) = I0[1105] + CD0*I1[1105];
    *(vp++) = I0[1106] + CD0*I1[1106];
    *(vp++) = I0[1107] + CD0*I1[1107];
    *(vp++) = I0[1108] + CD0*I1[1108];
    *(vp++) = I0[1109] + CD0*I1[1109];
    *(vp++) = I0[1110] + CD0*I1[1110];
    *(vp++) = I0[1111] + CD0*I1[1111];
    *(vp++) = I0[1112] + CD0*I1[1112];
    *(vp++) = I0[1317] + CD1*I1[1107];
    *(vp++) = I0[1318] + CD1*I1[1108];
    *(vp++) = I0[1319] + CD1*I1[1109];
    *(vp++) = I0[1320] + CD1*I1[1110];
    *(vp++) = I0[1321] + CD1*I1[1111];
    *(vp++) = I0[1322] + CD1*I1[1112];
    *(vp++) = I0[1343] + CD2*I1[1112];
    *(vp++) = I0[1113] + CD0*I1[1113];
    *(vp++) = I0[1114] + CD0*I1[1114];
    *(vp++) = I0[1115] + CD0*I1[1115];
    *(vp++) = I0[1116] + CD0*I1[1116];
    *(vp++) = I0[1117] + CD0*I1[1117];
    *(vp++) = I0[1118] + CD0*I1[1118];
    *(vp++) = I0[1119] + CD0*I1[1119];
    *(vp++) = I0[1120] + CD0*I1[1120];
    *(vp++) = I0[1121] + CD0*I1[1121];
    *(vp++) = I0[1122] + CD0*I1[1122];
    *(vp++) = I0[1123] + CD0*I1[1123];
    *(vp++) = I0[1124] + CD0*I1[1124];
    *(vp++) = I0[1125] + CD0*I1[1125];
    *(vp++) = I0[1126] + CD0*I1[1126];
    *(vp++) = I0[1127] + CD0*I1[1127];
    *(vp++) = I0[1128] + CD0*I1[1128];
    *(vp++) = I0[1129] + CD0*I1[1129];
    *(vp++) = I0[1130] + CD0*I1[1130];
    *(vp++) = I0[1131] + CD0*I1[1131];
    *(vp++) = I0[1132] + CD0*I1[1132];
    *(vp++) = I0[1133] + CD0*I1[1133];
    *(vp++) = I0[1338] + CD1*I1[1128];
    *(vp++) = I0[1339] + CD1*I1[1129];
    *(vp++) = I0[1340] + CD1*I1[1130];
    *(vp++) = I0[1341] + CD1*I1[1131];
    *(vp++) = I0[1342] + CD1*I1[1132];
    *(vp++) = I0[1343] + CD1*I1[1133];
    *(vp++) = I0[1364] + CD2*I1[1133];
    *(vp++) = I0[1134] + CD0*I1[1134];
    *(vp++) = I0[1135] + CD0*I1[1135];
    *(vp++) = I0[1136] + CD0*I1[1136];
    *(vp++) = I0[1137] + CD0*I1[1137];
    *(vp++) = I0[1138] + CD0*I1[1138];
    *(vp++) = I0[1139] + CD0*I1[1139];
    *(vp++) = I0[1140] + CD0*I1[1140];
    *(vp++) = I0[1141] + CD0*I1[1141];
    *(vp++) = I0[1142] + CD0*I1[1142];
    *(vp++) = I0[1143] + CD0*I1[1143];
    *(vp++) = I0[1144] + CD0*I1[1144];
    *(vp++) = I0[1145] + CD0*I1[1145];
    *(vp++) = I0[1146] + CD0*I1[1146];
    *(vp++) = I0[1147] + CD0*I1[1147];
    *(vp++) = I0[1148] + CD0*I1[1148];
    *(vp++) = I0[1149] + CD0*I1[1149];
    *(vp++) = I0[1150] + CD0*I1[1150];
    *(vp++) = I0[1151] + CD0*I1[1151];
    *(vp++) = I0[1152] + CD0*I1[1152];
    *(vp++) = I0[1153] + CD0*I1[1153];
    *(vp++) = I0[1154] + CD0*I1[1154];
    *(vp++) = I0[1359] + CD1*I1[1149];
    *(vp++) = I0[1360] + CD1*I1[1150];
    *(vp++) = I0[1361] + CD1*I1[1151];
    *(vp++) = I0[1362] + CD1*I1[1152];
    *(vp++) = I0[1363] + CD1*I1[1153];
    *(vp++) = I0[1364] + CD1*I1[1154];
    *(vp++) = I0[1385] + CD2*I1[1154];
    *(vp++) = I0[1155] + CD0*I1[1155];
    *(vp++) = I0[1156] + CD0*I1[1156];
    *(vp++) = I0[1157] + CD0*I1[1157];
    *(vp++) = I0[1158] + CD0*I1[1158];
    *(vp++) = I0[1159] + CD0*I1[1159];
    *(vp++) = I0[1160] + CD0*I1[1160];
    *(vp++) = I0[1161] + CD0*I1[1161];
    *(vp++) = I0[1162] + CD0*I1[1162];
    *(vp++) = I0[1163] + CD0*I1[1163];
    *(vp++) = I0[1164] + CD0*I1[1164];
    *(vp++) = I0[1165] + CD0*I1[1165];
    *(vp++) = I0[1166] + CD0*I1[1166];
    *(vp++) = I0[1167] + CD0*I1[1167];
    *(vp++) = I0[1168] + CD0*I1[1168];
    *(vp++) = I0[1169] + CD0*I1[1169];
    *(vp++) = I0[1170] + CD0*I1[1170];
    *(vp++) = I0[1171] + CD0*I1[1171];
    *(vp++) = I0[1172] + CD0*I1[1172];
    *(vp++) = I0[1173] + CD0*I1[1173];
    *(vp++) = I0[1174] + CD0*I1[1174];
    *(vp++) = I0[1175] + CD0*I1[1175];
    *(vp++) = I0[1401] + CD1*I1[1170];
    *(vp++) = I0[1402] + CD1*I1[1171];
    *(vp++) = I0[1403] + CD1*I1[1172];
    *(vp++) = I0[1404] + CD1*I1[1173];
    *(vp++) = I0[1405] + CD1*I1[1174];
    *(vp++) = I0[1406] + CD1*I1[1175];
    *(vp++) = I0[1427] + CD2*I1[1175];
    *(vp++) = I0[1176] + CD0*I1[1176];
    *(vp++) = I0[1177] + CD0*I1[1177];
    *(vp++) = I0[1178] + CD0*I1[1178];
    *(vp++) = I0[1179] + CD0*I1[1179];
    *(vp++) = I0[1180] + CD0*I1[1180];
    *(vp++) = I0[1181] + CD0*I1[1181];
    *(vp++) = I0[1182] + CD0*I1[1182];
    *(vp++) = I0[1183] + CD0*I1[1183];
    *(vp++) = I0[1184] + CD0*I1[1184];
    *(vp++) = I0[1185] + CD0*I1[1185];
    *(vp++) = I0[1186] + CD0*I1[1186];
    *(vp++) = I0[1187] + CD0*I1[1187];
    *(vp++) = I0[1188] + CD0*I1[1188];
    *(vp++) = I0[1189] + CD0*I1[1189];
    *(vp++) = I0[1190] + CD0*I1[1190];
    *(vp++) = I0[1191] + CD0*I1[1191];
    *(vp++) = I0[1192] + CD0*I1[1192];
    *(vp++) = I0[1193] + CD0*I1[1193];
    *(vp++) = I0[1194] + CD0*I1[1194];
    *(vp++) = I0[1195] + CD0*I1[1195];
    *(vp++) = I0[1196] + CD0*I1[1196];
    *(vp++) = I0[1422] + CD1*I1[1191];
    *(vp++) = I0[1423] + CD1*I1[1192];
    *(vp++) = I0[1424] + CD1*I1[1193];
    *(vp++) = I0[1425] + CD1*I1[1194];
    *(vp++) = I0[1426] + CD1*I1[1195];
    *(vp++) = I0[1427] + CD1*I1[1196];
    *(vp++) = I0[1448] + CD2*I1[1196];
    *(vp++) = I0[1197] + CD0*I1[1197];
    *(vp++) = I0[1198] + CD0*I1[1198];
    *(vp++) = I0[1199] + CD0*I1[1199];
    *(vp++) = I0[1200] + CD0*I1[1200];
    *(vp++) = I0[1201] + CD0*I1[1201];
    *(vp++) = I0[1202] + CD0*I1[1202];
    *(vp++) = I0[1203] + CD0*I1[1203];
    *(vp++) = I0[1204] + CD0*I1[1204];
    *(vp++) = I0[1205] + CD0*I1[1205];
    *(vp++) = I0[1206] + CD0*I1[1206];
    *(vp++) = I0[1207] + CD0*I1[1207];
    *(vp++) = I0[1208] + CD0*I1[1208];
    *(vp++) = I0[1209] + CD0*I1[1209];
    *(vp++) = I0[1210] + CD0*I1[1210];
    *(vp++) = I0[1211] + CD0*I1[1211];
    *(vp++) = I0[1212] + CD0*I1[1212];
    *(vp++) = I0[1213] + CD0*I1[1213];
    *(vp++) = I0[1214] + CD0*I1[1214];
    *(vp++) = I0[1215] + CD0*I1[1215];
    *(vp++) = I0[1216] + CD0*I1[1216];
    *(vp++) = I0[1217] + CD0*I1[1217];
    *(vp++) = I0[1443] + CD1*I1[1212];
    *(vp++) = I0[1444] + CD1*I1[1213];
    *(vp++) = I0[1445] + CD1*I1[1214];
    *(vp++) = I0[1446] + CD1*I1[1215];
    *(vp++) = I0[1447] + CD1*I1[1216];
    *(vp++) = I0[1448] + CD1*I1[1217];
    *(vp++) = I0[1469] + CD2*I1[1217];
    *(vp++) = I0[1218] + CD0*I1[1218];
    *(vp++) = I0[1219] + CD0*I1[1219];
    *(vp++) = I0[1220] + CD0*I1[1220];
    *(vp++) = I0[1221] + CD0*I1[1221];
    *(vp++) = I0[1222] + CD0*I1[1222];
    *(vp++) = I0[1223] + CD0*I1[1223];
    *(vp++) = I0[1224] + CD0*I1[1224];
    *(vp++) = I0[1225] + CD0*I1[1225];
    *(vp++) = I0[1226] + CD0*I1[1226];
    *(vp++) = I0[1227] + CD0*I1[1227];
    *(vp++) = I0[1228] + CD0*I1[1228];
    *(vp++) = I0[1229] + CD0*I1[1229];
    *(vp++) = I0[1230] + CD0*I1[1230];
    *(vp++) = I0[1231] + CD0*I1[1231];
    *(vp++) = I0[1232] + CD0*I1[1232];
    *(vp++) = I0[1233] + CD0*I1[1233];
    *(vp++) = I0[1234] + CD0*I1[1234];
    *(vp++) = I0[1235] + CD0*I1[1235];
    *(vp++) = I0[1236] + CD0*I1[1236];
    *(vp++) = I0[1237] + CD0*I1[1237];
  return vp;
}

REALTYPE *_hrr3_build_oi_6(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[1238] + CD0*I1[1238];
    *(vp++) = I0[1464] + CD1*I1[1233];
    *(vp++) = I0[1465] + CD1*I1[1234];
    *(vp++) = I0[1466] + CD1*I1[1235];
    *(vp++) = I0[1467] + CD1*I1[1236];
    *(vp++) = I0[1468] + CD1*I1[1237];
    *(vp++) = I0[1469] + CD1*I1[1238];
    *(vp++) = I0[1490] + CD2*I1[1238];
    *(vp++) = I0[1239] + CD0*I1[1239];
    *(vp++) = I0[1240] + CD0*I1[1240];
    *(vp++) = I0[1241] + CD0*I1[1241];
    *(vp++) = I0[1242] + CD0*I1[1242];
    *(vp++) = I0[1243] + CD0*I1[1243];
    *(vp++) = I0[1244] + CD0*I1[1244];
    *(vp++) = I0[1245] + CD0*I1[1245];
    *(vp++) = I0[1246] + CD0*I1[1246];
    *(vp++) = I0[1247] + CD0*I1[1247];
    *(vp++) = I0[1248] + CD0*I1[1248];
    *(vp++) = I0[1249] + CD0*I1[1249];
    *(vp++) = I0[1250] + CD0*I1[1250];
    *(vp++) = I0[1251] + CD0*I1[1251];
    *(vp++) = I0[1252] + CD0*I1[1252];
    *(vp++) = I0[1253] + CD0*I1[1253];
    *(vp++) = I0[1254] + CD0*I1[1254];
    *(vp++) = I0[1255] + CD0*I1[1255];
    *(vp++) = I0[1256] + CD0*I1[1256];
    *(vp++) = I0[1257] + CD0*I1[1257];
    *(vp++) = I0[1258] + CD0*I1[1258];
    *(vp++) = I0[1259] + CD0*I1[1259];
    *(vp++) = I0[1485] + CD1*I1[1254];
    *(vp++) = I0[1486] + CD1*I1[1255];
    *(vp++) = I0[1487] + CD1*I1[1256];
    *(vp++) = I0[1488] + CD1*I1[1257];
    *(vp++) = I0[1489] + CD1*I1[1258];
    *(vp++) = I0[1490] + CD1*I1[1259];
    *(vp++) = I0[1511] + CD2*I1[1259];
    *(vp++) = I0[1260] + CD0*I1[1260];
    *(vp++) = I0[1261] + CD0*I1[1261];
    *(vp++) = I0[1262] + CD0*I1[1262];
    *(vp++) = I0[1263] + CD0*I1[1263];
    *(vp++) = I0[1264] + CD0*I1[1264];
    *(vp++) = I0[1265] + CD0*I1[1265];
    *(vp++) = I0[1266] + CD0*I1[1266];
    *(vp++) = I0[1267] + CD0*I1[1267];
    *(vp++) = I0[1268] + CD0*I1[1268];
    *(vp++) = I0[1269] + CD0*I1[1269];
    *(vp++) = I0[1270] + CD0*I1[1270];
    *(vp++) = I0[1271] + CD0*I1[1271];
    *(vp++) = I0[1272] + CD0*I1[1272];
    *(vp++) = I0[1273] + CD0*I1[1273];
    *(vp++) = I0[1274] + CD0*I1[1274];
    *(vp++) = I0[1275] + CD0*I1[1275];
    *(vp++) = I0[1276] + CD0*I1[1276];
    *(vp++) = I0[1277] + CD0*I1[1277];
    *(vp++) = I0[1278] + CD0*I1[1278];
    *(vp++) = I0[1279] + CD0*I1[1279];
    *(vp++) = I0[1280] + CD0*I1[1280];
    *(vp++) = I0[1506] + CD1*I1[1275];
    *(vp++) = I0[1507] + CD1*I1[1276];
    *(vp++) = I0[1508] + CD1*I1[1277];
    *(vp++) = I0[1509] + CD1*I1[1278];
    *(vp++) = I0[1510] + CD1*I1[1279];
    *(vp++) = I0[1511] + CD1*I1[1280];
    *(vp++) = I0[1532] + CD2*I1[1280];
    *(vp++) = I0[1281] + CD0*I1[1281];
    *(vp++) = I0[1282] + CD0*I1[1282];
    *(vp++) = I0[1283] + CD0*I1[1283];
    *(vp++) = I0[1284] + CD0*I1[1284];
    *(vp++) = I0[1285] + CD0*I1[1285];
    *(vp++) = I0[1286] + CD0*I1[1286];
    *(vp++) = I0[1287] + CD0*I1[1287];
    *(vp++) = I0[1288] + CD0*I1[1288];
    *(vp++) = I0[1289] + CD0*I1[1289];
    *(vp++) = I0[1290] + CD0*I1[1290];
    *(vp++) = I0[1291] + CD0*I1[1291];
    *(vp++) = I0[1292] + CD0*I1[1292];
    *(vp++) = I0[1293] + CD0*I1[1293];
    *(vp++) = I0[1294] + CD0*I1[1294];
    *(vp++) = I0[1295] + CD0*I1[1295];
    *(vp++) = I0[1296] + CD0*I1[1296];
    *(vp++) = I0[1297] + CD0*I1[1297];
    *(vp++) = I0[1298] + CD0*I1[1298];
    *(vp++) = I0[1299] + CD0*I1[1299];
    *(vp++) = I0[1300] + CD0*I1[1300];
    *(vp++) = I0[1301] + CD0*I1[1301];
    *(vp++) = I0[1527] + CD1*I1[1296];
    *(vp++) = I0[1528] + CD1*I1[1297];
    *(vp++) = I0[1529] + CD1*I1[1298];
    *(vp++) = I0[1530] + CD1*I1[1299];
    *(vp++) = I0[1531] + CD1*I1[1300];
    *(vp++) = I0[1532] + CD1*I1[1301];
    *(vp++) = I0[1553] + CD2*I1[1301];
    *(vp++) = I0[1302] + CD0*I1[1302];
    *(vp++) = I0[1303] + CD0*I1[1303];
    *(vp++) = I0[1304] + CD0*I1[1304];
    *(vp++) = I0[1305] + CD0*I1[1305];
    *(vp++) = I0[1306] + CD0*I1[1306];
    *(vp++) = I0[1307] + CD0*I1[1307];
    *(vp++) = I0[1308] + CD0*I1[1308];
    *(vp++) = I0[1309] + CD0*I1[1309];
    *(vp++) = I0[1310] + CD0*I1[1310];
    *(vp++) = I0[1311] + CD0*I1[1311];
    *(vp++) = I0[1312] + CD0*I1[1312];
    *(vp++) = I0[1313] + CD0*I1[1313];
    *(vp++) = I0[1314] + CD0*I1[1314];
    *(vp++) = I0[1315] + CD0*I1[1315];
    *(vp++) = I0[1316] + CD0*I1[1316];
    *(vp++) = I0[1317] + CD0*I1[1317];
    *(vp++) = I0[1318] + CD0*I1[1318];
    *(vp++) = I0[1319] + CD0*I1[1319];
    *(vp++) = I0[1320] + CD0*I1[1320];
    *(vp++) = I0[1321] + CD0*I1[1321];
    *(vp++) = I0[1322] + CD0*I1[1322];
    *(vp++) = I0[1548] + CD1*I1[1317];
    *(vp++) = I0[1549] + CD1*I1[1318];
    *(vp++) = I0[1550] + CD1*I1[1319];
    *(vp++) = I0[1551] + CD1*I1[1320];
    *(vp++) = I0[1552] + CD1*I1[1321];
    *(vp++) = I0[1553] + CD1*I1[1322];
    *(vp++) = I0[1574] + CD2*I1[1322];
    *(vp++) = I0[1323] + CD0*I1[1323];
    *(vp++) = I0[1324] + CD0*I1[1324];
    *(vp++) = I0[1325] + CD0*I1[1325];
    *(vp++) = I0[1326] + CD0*I1[1326];
    *(vp++) = I0[1327] + CD0*I1[1327];
    *(vp++) = I0[1328] + CD0*I1[1328];
    *(vp++) = I0[1329] + CD0*I1[1329];
    *(vp++) = I0[1330] + CD0*I1[1330];
    *(vp++) = I0[1331] + CD0*I1[1331];
    *(vp++) = I0[1332] + CD0*I1[1332];
    *(vp++) = I0[1333] + CD0*I1[1333];
    *(vp++) = I0[1334] + CD0*I1[1334];
    *(vp++) = I0[1335] + CD0*I1[1335];
    *(vp++) = I0[1336] + CD0*I1[1336];
    *(vp++) = I0[1337] + CD0*I1[1337];
    *(vp++) = I0[1338] + CD0*I1[1338];
    *(vp++) = I0[1339] + CD0*I1[1339];
    *(vp++) = I0[1340] + CD0*I1[1340];
    *(vp++) = I0[1341] + CD0*I1[1341];
    *(vp++) = I0[1342] + CD0*I1[1342];
    *(vp++) = I0[1343] + CD0*I1[1343];
    *(vp++) = I0[1569] + CD1*I1[1338];
    *(vp++) = I0[1570] + CD1*I1[1339];
    *(vp++) = I0[1571] + CD1*I1[1340];
    *(vp++) = I0[1572] + CD1*I1[1341];
    *(vp++) = I0[1573] + CD1*I1[1342];
    *(vp++) = I0[1574] + CD1*I1[1343];
    *(vp++) = I0[1595] + CD2*I1[1343];
    *(vp++) = I0[1344] + CD0*I1[1344];
    *(vp++) = I0[1345] + CD0*I1[1345];
    *(vp++) = I0[1346] + CD0*I1[1346];
    *(vp++) = I0[1347] + CD0*I1[1347];
    *(vp++) = I0[1348] + CD0*I1[1348];
    *(vp++) = I0[1349] + CD0*I1[1349];
    *(vp++) = I0[1350] + CD0*I1[1350];
    *(vp++) = I0[1351] + CD0*I1[1351];
    *(vp++) = I0[1352] + CD0*I1[1352];
    *(vp++) = I0[1353] + CD0*I1[1353];
    *(vp++) = I0[1354] + CD0*I1[1354];
    *(vp++) = I0[1355] + CD0*I1[1355];
    *(vp++) = I0[1356] + CD0*I1[1356];
    *(vp++) = I0[1357] + CD0*I1[1357];
    *(vp++) = I0[1358] + CD0*I1[1358];
    *(vp++) = I0[1359] + CD0*I1[1359];
    *(vp++) = I0[1360] + CD0*I1[1360];
    *(vp++) = I0[1361] + CD0*I1[1361];
    *(vp++) = I0[1362] + CD0*I1[1362];
    *(vp++) = I0[1363] + CD0*I1[1363];
    *(vp++) = I0[1364] + CD0*I1[1364];
    *(vp++) = I0[1590] + CD1*I1[1359];
    *(vp++) = I0[1591] + CD1*I1[1360];
    *(vp++) = I0[1592] + CD1*I1[1361];
    *(vp++) = I0[1593] + CD1*I1[1362];
    *(vp++) = I0[1594] + CD1*I1[1363];
    *(vp++) = I0[1595] + CD1*I1[1364];
    *(vp++) = I0[1616] + CD2*I1[1364];
    *(vp++) = I0[1365] + CD0*I1[1365];
    *(vp++) = I0[1366] + CD0*I1[1366];
    *(vp++) = I0[1367] + CD0*I1[1367];
    *(vp++) = I0[1368] + CD0*I1[1368];
    *(vp++) = I0[1369] + CD0*I1[1369];
    *(vp++) = I0[1370] + CD0*I1[1370];
    *(vp++) = I0[1371] + CD0*I1[1371];
    *(vp++) = I0[1372] + CD0*I1[1372];
    *(vp++) = I0[1373] + CD0*I1[1373];
    *(vp++) = I0[1374] + CD0*I1[1374];
    *(vp++) = I0[1375] + CD0*I1[1375];
    *(vp++) = I0[1376] + CD0*I1[1376];
    *(vp++) = I0[1377] + CD0*I1[1377];
    *(vp++) = I0[1378] + CD0*I1[1378];
    *(vp++) = I0[1379] + CD0*I1[1379];
    *(vp++) = I0[1380] + CD0*I1[1380];
    *(vp++) = I0[1381] + CD0*I1[1381];
    *(vp++) = I0[1382] + CD0*I1[1382];
    *(vp++) = I0[1383] + CD0*I1[1383];
    *(vp++) = I0[1384] + CD0*I1[1384];
    *(vp++) = I0[1385] + CD0*I1[1385];
    *(vp++) = I0[1611] + CD1*I1[1380];
    *(vp++) = I0[1612] + CD1*I1[1381];
    *(vp++) = I0[1613] + CD1*I1[1382];
    *(vp++) = I0[1614] + CD1*I1[1383];
    *(vp++) = I0[1615] + CD1*I1[1384];
    *(vp++) = I0[1616] + CD1*I1[1385];
    *(vp++) = I0[1637] + CD2*I1[1385];
    *(vp++) = I0[1386] + CD0*I1[1386];
    *(vp++) = I0[1387] + CD0*I1[1387];
    *(vp++) = I0[1388] + CD0*I1[1388];
    *(vp++) = I0[1389] + CD0*I1[1389];
    *(vp++) = I0[1390] + CD0*I1[1390];
    *(vp++) = I0[1391] + CD0*I1[1391];
    *(vp++) = I0[1392] + CD0*I1[1392];
    *(vp++) = I0[1393] + CD0*I1[1393];
    *(vp++) = I0[1394] + CD0*I1[1394];
    *(vp++) = I0[1395] + CD0*I1[1395];
    *(vp++) = I0[1396] + CD0*I1[1396];
    *(vp++) = I0[1397] + CD0*I1[1397];
    *(vp++) = I0[1398] + CD0*I1[1398];
    *(vp++) = I0[1399] + CD0*I1[1399];
    *(vp++) = I0[1400] + CD0*I1[1400];
    *(vp++) = I0[1401] + CD0*I1[1401];
    *(vp++) = I0[1402] + CD0*I1[1402];
    *(vp++) = I0[1403] + CD0*I1[1403];
    *(vp++) = I0[1404] + CD0*I1[1404];
    *(vp++) = I0[1405] + CD0*I1[1405];
    *(vp++) = I0[1406] + CD0*I1[1406];
    *(vp++) = I0[1653] + CD1*I1[1401];
    *(vp++) = I0[1654] + CD1*I1[1402];
    *(vp++) = I0[1655] + CD1*I1[1403];
    *(vp++) = I0[1656] + CD1*I1[1404];
    *(vp++) = I0[1657] + CD1*I1[1405];
    *(vp++) = I0[1658] + CD1*I1[1406];
    *(vp++) = I0[1679] + CD2*I1[1406];
    *(vp++) = I0[1407] + CD0*I1[1407];
    *(vp++) = I0[1408] + CD0*I1[1408];
    *(vp++) = I0[1409] + CD0*I1[1409];
    *(vp++) = I0[1410] + CD0*I1[1410];
    *(vp++) = I0[1411] + CD0*I1[1411];
    *(vp++) = I0[1412] + CD0*I1[1412];
    *(vp++) = I0[1413] + CD0*I1[1413];
    *(vp++) = I0[1414] + CD0*I1[1414];
    *(vp++) = I0[1415] + CD0*I1[1415];
    *(vp++) = I0[1416] + CD0*I1[1416];
    *(vp++) = I0[1417] + CD0*I1[1417];
    *(vp++) = I0[1418] + CD0*I1[1418];
    *(vp++) = I0[1419] + CD0*I1[1419];
    *(vp++) = I0[1420] + CD0*I1[1420];
    *(vp++) = I0[1421] + CD0*I1[1421];
    *(vp++) = I0[1422] + CD0*I1[1422];
    *(vp++) = I0[1423] + CD0*I1[1423];
    *(vp++) = I0[1424] + CD0*I1[1424];
    *(vp++) = I0[1425] + CD0*I1[1425];
    *(vp++) = I0[1426] + CD0*I1[1426];
    *(vp++) = I0[1427] + CD0*I1[1427];
    *(vp++) = I0[1674] + CD1*I1[1422];
    *(vp++) = I0[1675] + CD1*I1[1423];
    *(vp++) = I0[1676] + CD1*I1[1424];
    *(vp++) = I0[1677] + CD1*I1[1425];
    *(vp++) = I0[1678] + CD1*I1[1426];
    *(vp++) = I0[1679] + CD1*I1[1427];
    *(vp++) = I0[1700] + CD2*I1[1427];
    *(vp++) = I0[1428] + CD0*I1[1428];
    *(vp++) = I0[1429] + CD0*I1[1429];
    *(vp++) = I0[1430] + CD0*I1[1430];
    *(vp++) = I0[1431] + CD0*I1[1431];
    *(vp++) = I0[1432] + CD0*I1[1432];
    *(vp++) = I0[1433] + CD0*I1[1433];
    *(vp++) = I0[1434] + CD0*I1[1434];
    *(vp++) = I0[1435] + CD0*I1[1435];
    *(vp++) = I0[1436] + CD0*I1[1436];
    *(vp++) = I0[1437] + CD0*I1[1437];
    *(vp++) = I0[1438] + CD0*I1[1438];
    *(vp++) = I0[1439] + CD0*I1[1439];
    *(vp++) = I0[1440] + CD0*I1[1440];
    *(vp++) = I0[1441] + CD0*I1[1441];
  return vp;
}

REALTYPE *_hrr3_build_oi_7(const REALTYPE *CD, REALTYPE *vp, REALTYPE *I0, REALTYPE *I1)
{
  const REALTYPE CD0 = CD[0];
  const REALTYPE CD1 = CD[1];
  const REALTYPE CD2 = CD[2];

    *(vp++) = I0[1442] + CD0*I1[1442];
    *(vp++) = I0[1443] + CD0*I1[1443];
    *(vp++) = I0[1444] + CD0*I1[1444];
    *(vp++) = I0[1445] + CD0*I1[1445];
    *(vp++) = I0[1446] + CD0*I1[1446];
    *(vp++) = I0[1447] + CD0*I1[1447];
    *(vp++) = I0[1448] + CD0*I1[1448];
    *(vp++) = I0[1695] + CD1*I1[1443];
    *(vp++) = I0[1696] + CD1*I1[1444];
    *(vp++) = I0[1697] + CD1*I1[1445];
    *(vp++) = I0[1698] + CD1*I1[1446];
    *(vp++) = I0[1699] + CD1*I1[1447];
    *(vp++) = I0[1700] + CD1*I1[1448];
    *(vp++) = I0[1721] + CD2*I1[1448];
    *(vp++) = I0[1449] + CD0*I1[1449];
    *(vp++) = I0[1450] + CD0*I1[1450];
    *(vp++) = I0[1451] + CD0*I1[1451];
    *(vp++) = I0[1452] + CD0*I1[1452];
    *(vp++) = I0[1453] + CD0*I1[1453];
    *(vp++) = I0[1454] + CD0*I1[1454];
    *(vp++) = I0[1455] + CD0*I1[1455];
    *(vp++) = I0[1456] + CD0*I1[1456];
    *(vp++) = I0[1457] + CD0*I1[1457];
    *(vp++) = I0[1458] + CD0*I1[1458];
    *(vp++) = I0[1459] + CD0*I1[1459];
    *(vp++) = I0[1460] + CD0*I1[1460];
    *(vp++) = I0[1461] + CD0*I1[1461];
    *(vp++) = I0[1462] + CD0*I1[1462];
    *(vp++) = I0[1463] + CD0*I1[1463];
    *(vp++) = I0[1464] + CD0*I1[1464];
    *(vp++) = I0[1465] + CD0*I1[1465];
    *(vp++) = I0[1466] + CD0*I1[1466];
    *(vp++) = I0[1467] + CD0*I1[1467];
    *(vp++) = I0[1468] + CD0*I1[1468];
    *(vp++) = I0[1469] + CD0*I1[1469];
    *(vp++) = I0[1716] + CD1*I1[1464];
    *(vp++) = I0[1717] + CD1*I1[1465];
    *(vp++) = I0[1718] + CD1*I1[1466];
    *(vp++) = I0[1719] + CD1*I1[1467];
    *(vp++) = I0[1720] + CD1*I1[1468];
    *(vp++) = I0[1721] + CD1*I1[1469];
    *(vp++) = I0[1742] + CD2*I1[1469];
    *(vp++) = I0[1470] + CD0*I1[1470];
    *(vp++) = I0[1471] + CD0*I1[1471];
    *(vp++) = I0[1472] + CD0*I1[1472];
    *(vp++) = I0[1473] + CD0*I1[1473];
    *(vp++) = I0[1474] + CD0*I1[1474];
    *(vp++) = I0[1475] + CD0*I1[1475];
    *(vp++) = I0[1476] + CD0*I1[1476];
    *(vp++) = I0[1477] + CD0*I1[1477];
    *(vp++) = I0[1478] + CD0*I1[1478];
    *(vp++) = I0[1479] + CD0*I1[1479];
    *(vp++) = I0[1480] + CD0*I1[1480];
    *(vp++) = I0[1481] + CD0*I1[1481];
    *(vp++) = I0[1482] + CD0*I1[1482];
    *(vp++) = I0[1483] + CD0*I1[1483];
    *(vp++) = I0[1484] + CD0*I1[1484];
    *(vp++) = I0[1485] + CD0*I1[1485];
    *(vp++) = I0[1486] + CD0*I1[1486];
    *(vp++) = I0[1487] + CD0*I1[1487];
    *(vp++) = I0[1488] + CD0*I1[1488];
    *(vp++) = I0[1489] + CD0*I1[1489];
    *(vp++) = I0[1490] + CD0*I1[1490];
    *(vp++) = I0[1737] + CD1*I1[1485];
    *(vp++) = I0[1738] + CD1*I1[1486];
    *(vp++) = I0[1739] + CD1*I1[1487];
    *(vp++) = I0[1740] + CD1*I1[1488];
    *(vp++) = I0[1741] + CD1*I1[1489];
    *(vp++) = I0[1742] + CD1*I1[1490];
    *(vp++) = I0[1763] + CD2*I1[1490];
    *(vp++) = I0[1491] + CD0*I1[1491];
    *(vp++) = I0[1492] + CD0*I1[1492];
    *(vp++) = I0[1493] + CD0*I1[1493];
    *(vp++) = I0[1494] + CD0*I1[1494];
    *(vp++) = I0[1495] + CD0*I1[1495];
    *(vp++) = I0[1496] + CD0*I1[1496];
    *(vp++) = I0[1497] + CD0*I1[1497];
    *(vp++) = I0[1498] + CD0*I1[1498];
    *(vp++) = I0[1499] + CD0*I1[1499];
    *(vp++) = I0[1500] + CD0*I1[1500];
    *(vp++) = I0[1501] + CD0*I1[1501];
    *(vp++) = I0[1502] + CD0*I1[1502];
    *(vp++) = I0[1503] + CD0*I1[1503];
    *(vp++) = I0[1504] + CD0*I1[1504];
    *(vp++) = I0[1505] + CD0*I1[1505];
    *(vp++) = I0[1506] + CD0*I1[1506];
    *(vp++) = I0[1507] + CD0*I1[1507];
    *(vp++) = I0[1508] + CD0*I1[1508];
    *(vp++) = I0[1509] + CD0*I1[1509];
    *(vp++) = I0[1510] + CD0*I1[1510];
    *(vp++) = I0[1511] + CD0*I1[1511];
    *(vp++) = I0[1758] + CD1*I1[1506];
    *(vp++) = I0[1759] + CD1*I1[1507];
    *(vp++) = I0[1760] + CD1*I1[1508];
    *(vp++) = I0[1761] + CD1*I1[1509];
    *(vp++) = I0[1762] + CD1*I1[1510];
    *(vp++) = I0[1763] + CD1*I1[1511];
    *(vp++) = I0[1784] + CD2*I1[1511];
    *(vp++) = I0[1512] + CD0*I1[1512];
    *(vp++) = I0[1513] + CD0*I1[1513];
    *(vp++) = I0[1514] + CD0*I1[1514];
    *(vp++) = I0[1515] + CD0*I1[1515];
    *(vp++) = I0[1516] + CD0*I1[1516];
    *(vp++) = I0[1517] + CD0*I1[1517];
    *(vp++) = I0[1518] + CD0*I1[1518];
    *(vp++) = I0[1519] + CD0*I1[1519];
    *(vp++) = I0[1520] + CD0*I1[1520];
    *(vp++) = I0[1521] + CD0*I1[1521];
    *(vp++) = I0[1522] + CD0*I1[1522];
    *(vp++) = I0[1523] + CD0*I1[1523];
    *(vp++) = I0[1524] + CD0*I1[1524];
    *(vp++) = I0[1525] + CD0*I1[1525];
    *(vp++) = I0[1526] + CD0*I1[1526];
    *(vp++) = I0[1527] + CD0*I1[1527];
    *(vp++) = I0[1528] + CD0*I1[1528];
    *(vp++) = I0[1529] + CD0*I1[1529];
    *(vp++) = I0[1530] + CD0*I1[1530];
    *(vp++) = I0[1531] + CD0*I1[1531];
    *(vp++) = I0[1532] + CD0*I1[1532];
    *(vp++) = I0[1779] + CD1*I1[1527];
    *(vp++) = I0[1780] + CD1*I1[1528];
    *(vp++) = I0[1781] + CD1*I1[1529];
    *(vp++) = I0[1782] + CD1*I1[1530];
    *(vp++) = I0[1783] + CD1*I1[1531];
    *(vp++) = I0[1784] + CD1*I1[1532];
    *(vp++) = I0[1805] + CD2*I1[1532];
    *(vp++) = I0[1533] + CD0*I1[1533];
    *(vp++) = I0[1534] + CD0*I1[1534];
    *(vp++) = I0[1535] + CD0*I1[1535];
    *(vp++) = I0[1536] + CD0*I1[1536];
    *(vp++) = I0[1537] + CD0*I1[1537];
    *(vp++) = I0[1538] + CD0*I1[1538];
    *(vp++) = I0[1539] + CD0*I1[1539];
    *(vp++) = I0[1540] + CD0*I1[1540];
    *(vp++) = I0[1541] + CD0*I1[1541];
    *(vp++) = I0[1542] + CD0*I1[1542];
    *(vp++) = I0[1543] + CD0*I1[1543];
    *(vp++) = I0[1544] + CD0*I1[1544];
    *(vp++) = I0[1545] + CD0*I1[1545];
    *(vp++) = I0[1546] + CD0*I1[1546];
    *(vp++) = I0[1547] + CD0*I1[1547];
    *(vp++) = I0[1548] + CD0*I1[1548];
    *(vp++) = I0[1549] + CD0*I1[1549];
    *(vp++) = I0[1550] + CD0*I1[1550];
    *(vp++) = I0[1551] + CD0*I1[1551];
    *(vp++) = I0[1552] + CD0*I1[1552];
    *(vp++) = I0[1553] + CD0*I1[1553];
    *(vp++) = I0[1800] + CD1*I1[1548];
    *(vp++) = I0[1801] + CD1*I1[1549];
    *(vp++) = I0[1802] + CD1*I1[1550];
    *(vp++) = I0[1803] + CD1*I1[1551];
    *(vp++) = I0[1804] + CD1*I1[1552];
    *(vp++) = I0[1805] + CD1*I1[1553];
    *(vp++) = I0[1826] + CD2*I1[1553];
    *(vp++) = I0[1554] + CD0*I1[1554];
    *(vp++) = I0[1555] + CD0*I1[1555];
    *(vp++) = I0[1556] + CD0*I1[1556];
    *(vp++) = I0[1557] + CD0*I1[1557];
    *(vp++) = I0[1558] + CD0*I1[1558];
    *(vp++) = I0[1559] + CD0*I1[1559];
    *(vp++) = I0[1560] + CD0*I1[1560];
    *(vp++) = I0[1561] + CD0*I1[1561];
    *(vp++) = I0[1562] + CD0*I1[1562];
    *(vp++) = I0[1563] + CD0*I1[1563];
    *(vp++) = I0[1564] + CD0*I1[1564];
    *(vp++) = I0[1565] + CD0*I1[1565];
    *(vp++) = I0[1566] + CD0*I1[1566];
    *(vp++) = I0[1567] + CD0*I1[1567];
    *(vp++) = I0[1568] + CD0*I1[1568];
    *(vp++) = I0[1569] + CD0*I1[1569];
    *(vp++) = I0[1570] + CD0*I1[1570];
    *(vp++) = I0[1571] + CD0*I1[1571];
    *(vp++) = I0[1572] + CD0*I1[1572];
    *(vp++) = I0[1573] + CD0*I1[1573];
    *(vp++) = I0[1574] + CD0*I1[1574];
    *(vp++) = I0[1821] + CD1*I1[1569];
    *(vp++) = I0[1822] + CD1*I1[1570];
    *(vp++) = I0[1823] + CD1*I1[1571];
    *(vp++) = I0[1824] + CD1*I1[1572];
    *(vp++) = I0[1825] + CD1*I1[1573];
    *(vp++) = I0[1826] + CD1*I1[1574];
    *(vp++) = I0[1847] + CD2*I1[1574];
    *(vp++) = I0[1575] + CD0*I1[1575];
    *(vp++) = I0[1576] + CD0*I1[1576];
    *(vp++) = I0[1577] + CD0*I1[1577];
    *(vp++) = I0[1578] + CD0*I1[1578];
    *(vp++) = I0[1579] + CD0*I1[1579];
    *(vp++) = I0[1580] + CD0*I1[1580];
    *(vp++) = I0[1581] + CD0*I1[1581];
    *(vp++) = I0[1582] + CD0*I1[1582];
    *(vp++) = I0[1583] + CD0*I1[1583];
    *(vp++) = I0[1584] + CD0*I1[1584];
    *(vp++) = I0[1585] + CD0*I1[1585];
    *(vp++) = I0[1586] + CD0*I1[1586];
    *(vp++) = I0[1587] + CD0*I1[1587];
    *(vp++) = I0[1588] + CD0*I1[1588];
    *(vp++) = I0[1589] + CD0*I1[1589];
    *(vp++) = I0[1590] + CD0*I1[1590];
    *(vp++) = I0[1591] + CD0*I1[1591];
    *(vp++) = I0[1592] + CD0*I1[1592];
    *(vp++) = I0[1593] + CD0*I1[1593];
    *(vp++) = I0[1594] + CD0*I1[1594];
    *(vp++) = I0[1595] + CD0*I1[1595];
    *(vp++) = I0[1842] + CD1*I1[1590];
    *(vp++) = I0[1843] + CD1*I1[1591];
    *(vp++) = I0[1844] + CD1*I1[1592];
    *(vp++) = I0[1845] + CD1*I1[1593];
    *(vp++) = I0[1846] + CD1*I1[1594];
    *(vp++) = I0[1847] + CD1*I1[1595];
    *(vp++) = I0[1868] + CD2*I1[1595];
    *(vp++) = I0[1596] + CD0*I1[1596];
    *(vp++) = I0[1597] + CD0*I1[1597];
    *(vp++) = I0[1598] + CD0*I1[1598];
    *(vp++) = I0[1599] + CD0*I1[1599];
    *(vp++) = I0[1600] + CD0*I1[1600];
    *(vp++) = I0[1601] + CD0*I1[1601];
    *(vp++) = I0[1602] + CD0*I1[1602];
    *(vp++) = I0[1603] + CD0*I1[1603];
    *(vp++) = I0[1604] + CD0*I1[1604];
    *(vp++) = I0[1605] + CD0*I1[1605];
    *(vp++) = I0[1606] + CD0*I1[1606];
    *(vp++) = I0[1607] + CD0*I1[1607];
    *(vp++) = I0[1608] + CD0*I1[1608];
    *(vp++) = I0[1609] + CD0*I1[1609];
    *(vp++) = I0[1610] + CD0*I1[1610];
    *(vp++) = I0[1611] + CD0*I1[1611];
    *(vp++) = I0[1612] + CD0*I1[1612];
    *(vp++) = I0[1613] + CD0*I1[1613];
    *(vp++) = I0[1614] + CD0*I1[1614];
    *(vp++) = I0[1615] + CD0*I1[1615];
    *(vp++) = I0[1616] + CD0*I1[1616];
    *(vp++) = I0[1863] + CD1*I1[1611];
    *(vp++) = I0[1864] + CD1*I1[1612];
    *(vp++) = I0[1865] + CD1*I1[1613];
    *(vp++) = I0[1866] + CD1*I1[1614];
    *(vp++) = I0[1867] + CD1*I1[1615];
    *(vp++) = I0[1868] + CD1*I1[1616];
    *(vp++) = I0[1889] + CD2*I1[1616];
    *(vp++) = I0[1617] + CD0*I1[1617];
    *(vp++) = I0[1618] + CD0*I1[1618];
    *(vp++) = I0[1619] + CD0*I1[1619];
    *(vp++) = I0[1620] + CD0*I1[1620];
    *(vp++) = I0[1621] + CD0*I1[1621];
    *(vp++) = I0[1622] + CD0*I1[1622];
    *(vp++) = I0[1623] + CD0*I1[1623];
    *(vp++) = I0[1624] + CD0*I1[1624];
    *(vp++) = I0[1625] + CD0*I1[1625];
    *(vp++) = I0[1626] + CD0*I1[1626];
    *(vp++) = I0[1627] + CD0*I1[1627];
    *(vp++) = I0[1628] + CD0*I1[1628];
    *(vp++) = I0[1629] + CD0*I1[1629];
    *(vp++) = I0[1630] + CD0*I1[1630];
    *(vp++) = I0[1631] + CD0*I1[1631];
    *(vp++) = I0[1632] + CD0*I1[1632];
    *(vp++) = I0[1633] + CD0*I1[1633];
    *(vp++) = I0[1634] + CD0*I1[1634];
    *(vp++) = I0[1635] + CD0*I1[1635];
    *(vp++) = I0[1636] + CD0*I1[1636];
    *(vp++) = I0[1637] + CD0*I1[1637];
    *(vp++) = I0[1884] + CD1*I1[1632];
    *(vp++) = I0[1885] + CD1*I1[1633];
    *(vp++) = I0[1886] + CD1*I1[1634];
    *(vp++) = I0[1887] + CD1*I1[1635];
    *(vp++) = I0[1888] + CD1*I1[1636];
    *(vp++) = I0[1889] + CD1*I1[1637];
    *(vp++) = I0[1910] + CD2*I1[1637];
  return vp;
}
/* Total number of FLOPs = 4368 * ab_num */
