/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00ng(Libint_t*, prim_data*);

  /* Computes quartets of (00|ng) integrals */

REALTYPE *hrr_order_00ng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][10] = int_stack + 0;
 Libint->vrr_classes[0][11] = int_stack + 66;
 Libint->vrr_classes[0][12] = int_stack + 144;
 Libint->vrr_classes[0][13] = int_stack + 235;
 Libint->vrr_classes[0][14] = int_stack + 340;
 memset(int_stack,0,460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00ng(Libint, Data);
   Data++;
 }
 /*--- compute (00|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+460,int_stack+66,int_stack+0,1);
 /*--- compute (00|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+658,int_stack+144,int_stack+66,1);
 /*--- compute (00|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+892,int_stack+658,int_stack+460,1);
 /*--- compute (00|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1288,int_stack+235,int_stack+144,1);
 /*--- compute (00|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1561,int_stack+1288,int_stack+658,1);
 /*--- compute (00|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2029,int_stack+1561,int_stack+892,1);
 /*--- compute (00|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+460,int_stack+340,int_stack+235,1);
 /*--- compute (00|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2689,int_stack+460,int_stack+1288,1);
 /*--- compute (00|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+2689,int_stack+1561,1);
 /*--- compute (00|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2689,int_stack+0,int_stack+2029,1);
 return int_stack+2689;}
