/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddg0(Libint_t*, prim_data*);

  /* Computes quartets of (dd|g0) integrals */

REALTYPE *hrr_order_ddg0(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][4] = int_stack + 0;
 Libint->vrr_classes[3][4] = int_stack + 90;
 Libint->vrr_classes[4][4] = int_stack + 240;
 memset(int_stack,0,465*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 465;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddg0(Libint, Data);
   Data++;
 }
 /*--- compute (dp|g0) ---*/
 hrr1_build_dp(Libint->AB,int_stack+465,int_stack+90,int_stack+0,15);
 /*--- compute (fp|g0) ---*/
 hrr1_build_fp(Libint->AB,int_stack+735,int_stack+240,int_stack+90,15);
 /*--- compute (dd|g0) ---*/
 hrr1_build_dd(Libint->AB,int_stack+1185,int_stack+735,int_stack+465,15);
 return int_stack+1185;}
