/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddnp(Libint_t*, prim_data*);

  /* Computes quartets of (dd|np) integrals */

REALTYPE *hrr_order_ddnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[3][10] = int_stack + 864;
 Libint->vrr_classes[3][11] = int_stack + 1524;
 Libint->vrr_classes[4][10] = int_stack + 2304;
 Libint->vrr_classes[4][11] = int_stack + 3294;
 memset(int_stack,0,4464*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 4464;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddnp(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4464,int_stack+396,int_stack+0,6);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5652,int_stack+1524,int_stack+864,10);
 /*--- compute (dp|np) ---*/
 hrr1_build_dp(Libint->AB,int_stack+7632,int_stack+5652,int_stack+4464,198);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11196,int_stack+3294,int_stack+2304,15);
 /*--- compute (fp|np) ---*/
 hrr1_build_fp(Libint->AB,int_stack+14166,int_stack+11196,int_stack+5652,198);
 /*--- compute (dd|np) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+14166,int_stack+7632,198);
 return int_stack+0;}
