/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdmi(Libint_t*, prim_data*);

  /* Computes quartets of (fd|mi) integrals */

REALTYPE *hrr_order_fdmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[4][9] = int_stack + 6510;
 Libint->vrr_classes[4][10] = int_stack + 7335;
 Libint->vrr_classes[4][11] = int_stack + 8325;
 Libint->vrr_classes[4][12] = int_stack + 9495;
 Libint->vrr_classes[4][13] = int_stack + 10860;
 Libint->vrr_classes[4][14] = int_stack + 12435;
 Libint->vrr_classes[4][15] = int_stack + 14235;
 Libint->vrr_classes[5][9] = int_stack + 16275;
 Libint->vrr_classes[5][10] = int_stack + 17430;
 Libint->vrr_classes[5][11] = int_stack + 18816;
 Libint->vrr_classes[5][12] = int_stack + 20454;
 Libint->vrr_classes[5][13] = int_stack + 22365;
 Libint->vrr_classes[5][14] = int_stack + 24570;
 Libint->vrr_classes[5][15] = int_stack + 27090;
 memset(int_stack,0,29946*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29946;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdmi(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29946,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31596,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33576,int_stack+31596,int_stack+29946,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36876,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39216,int_stack+36876,int_stack+31596,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+43176,int_stack+39216,int_stack+33576,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29946,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+48676,int_stack+29946,int_stack+36876,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+53356,int_stack+48676,int_stack+39216,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32676,int_stack+53356,int_stack+43176,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+40926,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+59956,int_stack+40926,int_stack+29946,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+65416,int_stack+59956,int_stack+48676,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+73216,int_stack+65416,int_stack+53356,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+44076,int_stack+73216,int_stack+32676,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+29946,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+33546,int_stack+29946,int_stack+40926,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+83116,int_stack+33546,int_stack+59956,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+29946,int_stack+83116,int_stack+65416,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+55626,int_stack+29946,int_stack+73216,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+69486,int_stack+55626,int_stack+44076,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29946,int_stack+7335,int_stack+6510,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32421,int_stack+8325,int_stack+7335,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+35391,int_stack+32421,int_stack+29946,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40341,int_stack+9495,int_stack+8325,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43851,int_stack+40341,int_stack+32421,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+49791,int_stack+43851,int_stack+35391,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29946,int_stack+10860,int_stack+9495,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+58041,int_stack+29946,int_stack+40341,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+58041,int_stack+43851,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+34041,int_stack+0,int_stack+49791,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+46416,int_stack+12435,int_stack+10860,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+84886,int_stack+46416,int_stack+29946,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+93076,int_stack+84886,int_stack+58041,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+51141,int_stack+93076,int_stack+0,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+104776,int_stack+51141,int_stack+34041,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+14235,int_stack+12435,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5400,int_stack+0,int_stack+46416,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+29946,int_stack+5400,int_stack+84886,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+122101,int_stack+29946,int_stack+93076,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+29946,int_stack+122101,int_stack+51141,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+122101,int_stack+29946,int_stack+104776,15);
 /*--- compute (fp|mi) ---*/
 hrr1_build_fp(Libint->AB,int_stack+145201,int_stack+122101,int_stack+69486,1540);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29946,int_stack+17430,int_stack+16275,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33411,int_stack+18816,int_stack+17430,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+37569,int_stack+33411,int_stack+29946,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+44499,int_stack+20454,int_stack+18816,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+49413,int_stack+44499,int_stack+33411,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+57729,int_stack+49413,int_stack+37569,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29946,int_stack+22365,int_stack+20454,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+69279,int_stack+29946,int_stack+44499,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+79107,int_stack+69279,int_stack+49413,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+35679,int_stack+79107,int_stack+57729,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+53004,int_stack+24570,int_stack+22365,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+92967,int_stack+53004,int_stack+29946,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+104433,int_stack+92967,int_stack+69279,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+104433,int_stack+79107,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+59619,int_stack+0,int_stack+35679,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+29946,int_stack+27090,int_stack+24570,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37506,int_stack+29946,int_stack+53004,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+191401,int_stack+37506,int_stack+92967,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+20790,int_stack+191401,int_stack+104433,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+83874,int_stack+20790,int_stack+0,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+83874,int_stack+59619,21);
 /*--- compute (gp|mi) ---*/
 hrr1_build_gp(Libint->AB,int_stack+32340,int_stack+0,int_stack+122101,1540);
 /*--- compute (fd|mi) ---*/
 hrr1_build_fd(Libint->AB,int_stack+191401,int_stack+32340,int_stack+145201,1540);
 return int_stack+191401;}
