/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdml(Libint_t*, prim_data*);

  /* Computes quartets of (fd|ml) integrals */

REALTYPE *hrr_order_fdml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[3][16] = int_stack + 6510;
 Libint->vrr_classes[3][17] = int_stack + 8040;
 Libint->vrr_classes[4][9] = int_stack + 9750;
 Libint->vrr_classes[4][10] = int_stack + 10575;
 Libint->vrr_classes[4][11] = int_stack + 11565;
 Libint->vrr_classes[4][12] = int_stack + 12735;
 Libint->vrr_classes[4][13] = int_stack + 14100;
 Libint->vrr_classes[4][14] = int_stack + 15675;
 Libint->vrr_classes[4][15] = int_stack + 17475;
 Libint->vrr_classes[4][16] = int_stack + 19515;
 Libint->vrr_classes[4][17] = int_stack + 21810;
 Libint->vrr_classes[5][9] = int_stack + 24375;
 Libint->vrr_classes[5][10] = int_stack + 25530;
 Libint->vrr_classes[5][11] = int_stack + 26916;
 Libint->vrr_classes[5][12] = int_stack + 28554;
 Libint->vrr_classes[5][13] = int_stack + 30465;
 Libint->vrr_classes[5][14] = int_stack + 32670;
 Libint->vrr_classes[5][15] = int_stack + 35190;
 Libint->vrr_classes[5][16] = int_stack + 38046;
 Libint->vrr_classes[5][17] = int_stack + 41259;
 memset(int_stack,0,44850*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 44850;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdml(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44850,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46500,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48480,int_stack+46500,int_stack+44850,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51780,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54120,int_stack+51780,int_stack+46500,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+58080,int_stack+54120,int_stack+48480,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+44850,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+63580,int_stack+44850,int_stack+51780,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+68260,int_stack+63580,int_stack+54120,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+47580,int_stack+68260,int_stack+58080,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+55830,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+74860,int_stack+55830,int_stack+44850,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+80320,int_stack+74860,int_stack+63580,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+88120,int_stack+80320,int_stack+68260,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+58980,int_stack+88120,int_stack+47580,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+44850,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48450,int_stack+44850,int_stack+55830,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+98020,int_stack+48450,int_stack+74860,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+107120,int_stack+98020,int_stack+80320,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+70530,int_stack+107120,int_stack+88120,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+118820,int_stack+70530,int_stack+58980,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+54750,int_stack+6510,int_stack+5150,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+58830,int_stack+54750,int_stack+44850,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+84390,int_stack+58830,int_stack+48450,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+134220,int_stack+84390,int_stack+98020,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+147870,int_stack+134220,int_stack+107120,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+94890,int_stack+147870,int_stack+70530,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+164250,int_stack+94890,int_stack+118820,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+44850,int_stack+8040,int_stack+6510,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+66030,int_stack+44850,int_stack+54750,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+44850,int_stack+66030,int_stack+58830,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+56850,int_stack+44850,int_stack+84390,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+72600,int_stack+56850,int_stack+134220,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+44850,int_stack+72600,int_stack+147870,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+66690,int_stack+44850,int_stack+94890,10);
 /*--- compute (f0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+90450,int_stack+66690,int_stack+164250,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44850,int_stack+10575,int_stack+9750,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47325,int_stack+11565,int_stack+10575,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50295,int_stack+47325,int_stack+44850,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+55245,int_stack+12735,int_stack+11565,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58755,int_stack+55245,int_stack+47325,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+64695,int_stack+58755,int_stack+50295,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+44850,int_stack+14100,int_stack+12735,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72945,int_stack+44850,int_stack+55245,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+79965,int_stack+72945,int_stack+58755,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+48945,int_stack+79965,int_stack+64695,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+61320,int_stack+15675,int_stack+14100,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+115200,int_stack+61320,int_stack+44850,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+123390,int_stack+115200,int_stack+72945,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+135090,int_stack+123390,int_stack+79965,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+66045,int_stack+135090,int_stack+48945,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+44850,int_stack+17475,int_stack+15675,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+50250,int_stack+44850,int_stack+61320,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+149940,int_stack+50250,int_stack+115200,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+163590,int_stack+149940,int_stack+123390,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+181140,int_stack+163590,int_stack+135090,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+115200,int_stack+181140,int_stack+66045,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+138300,int_stack+19515,int_stack+17475,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+59700,int_stack+138300,int_stack+44850,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+70500,int_stack+59700,int_stack+50250,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+201930,int_stack+70500,int_stack+149940,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+222405,int_stack+201930,int_stack+163590,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+144420,int_stack+222405,int_stack+181140,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+172140,int_stack+144420,int_stack+115200,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+115200,int_stack+21810,int_stack+19515,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+122085,int_stack+115200,int_stack+138300,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+122085,int_stack+59700,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+115200,int_stack+0,int_stack+70500,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+44850,int_stack+115200,int_stack+201930,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+246975,int_stack+44850,int_stack+222405,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+44850,int_stack+246975,int_stack+144420,15);
 /*--- compute (g0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+115200,int_stack+44850,int_stack+172140,15);
 /*--- compute (fp|ml) ---*/
 hrr1_build_fp(Libint->AB,int_stack+152325,int_stack+115200,int_stack+90450,2475);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44850,int_stack+25530,int_stack+24375,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48315,int_stack+26916,int_stack+25530,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+52473,int_stack+48315,int_stack+44850,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+59403,int_stack+28554,int_stack+26916,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64317,int_stack+59403,int_stack+48315,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+72633,int_stack+64317,int_stack+52473,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+44850,int_stack+30465,int_stack+28554,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+84183,int_stack+44850,int_stack+59403,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+94011,int_stack+84183,int_stack+64317,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+50583,int_stack+94011,int_stack+72633,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+67908,int_stack+32670,int_stack+30465,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+226575,int_stack+67908,int_stack+44850,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+238041,int_stack+226575,int_stack+84183,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+254421,int_stack+238041,int_stack+94011,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+74523,int_stack+254421,int_stack+50583,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+44850,int_stack+35190,int_stack+32670,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+52410,int_stack+44850,int_stack+67908,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+52410,int_stack+226575,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+275211,int_stack+0,int_stack+238041,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+299781,int_stack+275211,int_stack+254421,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+226575,int_stack+299781,int_stack+74523,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+258915,int_stack+38046,int_stack+35190,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+65640,int_stack+258915,int_stack+44850,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+80760,int_stack+65640,int_stack+52410,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+328887,int_stack+80760,int_stack+0,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+328887,int_stack+275211,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+357552,int_stack+0,int_stack+299781,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+267483,int_stack+357552,int_stack+226575,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+226575,int_stack+41259,int_stack+38046,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+236214,int_stack+226575,int_stack+258915,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+34398,int_stack+236214,int_stack+65640,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+226575,int_stack+34398,int_stack+80760,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+34398,int_stack+226575,int_stack+328887,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+309063,int_stack+34398,int_stack+0,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+309063,int_stack+357552,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+309063,int_stack+0,int_stack+267483,21);
 /*--- compute (gp|ml) ---*/
 hrr1_build_gp(Libint->AB,int_stack+0,int_stack+309063,int_stack+115200,2475);
 /*--- compute (fd|ml) ---*/
 hrr1_build_fd(Libint->AB,int_stack+226575,int_stack+0,int_stack+152325,2475);
 return int_stack+226575;}
