/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffii(Libint_t*, prim_data*);

  /* Computes quartets of (ff|ii) integrals */

REALTYPE *hrr_order_ffii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[3][7] = int_stack + 280;
 Libint->vrr_classes[3][8] = int_stack + 640;
 Libint->vrr_classes[3][9] = int_stack + 1090;
 Libint->vrr_classes[3][10] = int_stack + 1640;
 Libint->vrr_classes[3][11] = int_stack + 2300;
 Libint->vrr_classes[3][12] = int_stack + 3080;
 Libint->vrr_classes[4][6] = int_stack + 3990;
 Libint->vrr_classes[4][7] = int_stack + 4410;
 Libint->vrr_classes[4][8] = int_stack + 4950;
 Libint->vrr_classes[4][9] = int_stack + 5625;
 Libint->vrr_classes[4][10] = int_stack + 6450;
 Libint->vrr_classes[4][11] = int_stack + 7440;
 Libint->vrr_classes[4][12] = int_stack + 8610;
 Libint->vrr_classes[5][6] = int_stack + 9975;
 Libint->vrr_classes[5][7] = int_stack + 10563;
 Libint->vrr_classes[5][8] = int_stack + 11319;
 Libint->vrr_classes[5][9] = int_stack + 12264;
 Libint->vrr_classes[5][10] = int_stack + 13419;
 Libint->vrr_classes[5][11] = int_stack + 14805;
 Libint->vrr_classes[5][12] = int_stack + 16443;
 Libint->vrr_classes[6][6] = int_stack + 18354;
 Libint->vrr_classes[6][7] = int_stack + 19138;
 Libint->vrr_classes[6][8] = int_stack + 20146;
 Libint->vrr_classes[6][9] = int_stack + 21406;
 Libint->vrr_classes[6][10] = int_stack + 22946;
 Libint->vrr_classes[6][11] = int_stack + 24794;
 Libint->vrr_classes[6][12] = int_stack + 26978;
 memset(int_stack,0,29526*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29526;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffii(Libint, Data);
   Data++;
 }
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+29526,int_stack+280,int_stack+0,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30366,int_stack+640,int_stack+280,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+31446,int_stack+30366,int_stack+29526,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33126,int_stack+1090,int_stack+640,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+34476,int_stack+33126,int_stack+30366,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+36636,int_stack+34476,int_stack+31446,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29526,int_stack+1640,int_stack+1090,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+39436,int_stack+29526,int_stack+33126,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+42136,int_stack+39436,int_stack+34476,10);
 /*--- compute (f0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+31176,int_stack+42136,int_stack+36636,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35376,int_stack+2300,int_stack+1640,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+45736,int_stack+35376,int_stack+29526,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+49036,int_stack+45736,int_stack+39436,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+53536,int_stack+49036,int_stack+42136,10);
 /*--- compute (f0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+37356,int_stack+53536,int_stack+31176,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29526,int_stack+3080,int_stack+2300,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+29526,int_stack+35376,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+29526,int_stack+0,int_stack+45736,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+58936,int_stack+29526,int_stack+49036,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+29526,int_stack+58936,int_stack+53536,10);
 /*--- compute (f0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+43236,int_stack+29526,int_stack+37356,10);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+29526,int_stack+4410,int_stack+3990,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30786,int_stack+4950,int_stack+4410,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+32406,int_stack+30786,int_stack+29526,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+34926,int_stack+5625,int_stack+4950,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+36951,int_stack+34926,int_stack+30786,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+36951,int_stack+32406,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29526,int_stack+6450,int_stack+5625,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+51076,int_stack+29526,int_stack+34926,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+55126,int_stack+51076,int_stack+36951,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+32001,int_stack+55126,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+7440,int_stack+6450,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+60526,int_stack+0,int_stack+29526,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+65476,int_stack+60526,int_stack+51076,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+72226,int_stack+65476,int_stack+55126,15);
 /*--- compute (g0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+51076,int_stack+72226,int_stack+32001,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29526,int_stack+8610,int_stack+7440,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33036,int_stack+29526,int_stack+0,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+33036,int_stack+60526,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+29526,int_stack+0,int_stack+65476,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+59896,int_stack+29526,int_stack+72226,15);
 /*--- compute (g0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+29526,int_stack+59896,int_stack+51076,15);
 /*--- compute (fp|ii) ---*/
 hrr1_build_fp(Libint->AB,int_stack+51076,int_stack+29526,int_stack+43236,784);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+74596,int_stack+10563,int_stack+9975,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+76360,int_stack+11319,int_stack+10563,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+41286,int_stack+76360,int_stack+74596,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+44814,int_stack+12264,int_stack+11319,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+44814,int_stack+76360,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+74596,int_stack+0,int_stack+41286,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41286,int_stack+13419,int_stack+12264,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+4536,int_stack+41286,int_stack+44814,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+80476,int_stack+4536,int_stack+0,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+88036,int_stack+80476,int_stack+74596,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74596,int_stack+14805,int_stack+13419,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96856,int_stack+74596,int_stack+41286,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+41286,int_stack+96856,int_stack+4536,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+41286,int_stack+80476,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+103786,int_stack+0,int_stack+88036,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+78754,int_stack+16443,int_stack+14805,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+83668,int_stack+78754,int_stack+74596,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+116134,int_stack+83668,int_stack+96856,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+74596,int_stack+116134,int_stack+41286,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+116134,int_stack+74596,int_stack+0,21);
 /*--- compute (h0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+0,int_stack+116134,int_stack+103786,21);
 /*--- compute (gp|ii) ---*/
 hrr1_build_gp(Libint->AB,int_stack+74596,int_stack+0,int_stack+29526,784);
 /*--- compute (fd|ii) ---*/
 hrr1_build_fd(Libint->AB,int_stack+109876,int_stack+74596,int_stack+51076,784);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+29526,int_stack+19138,int_stack+18354,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+31878,int_stack+20146,int_stack+19138,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+34902,int_stack+31878,int_stack+29526,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39606,int_stack+21406,int_stack+20146,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+43386,int_stack+39606,int_stack+31878,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+49434,int_stack+43386,int_stack+34902,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29526,int_stack+22946,int_stack+21406,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+57274,int_stack+29526,int_stack+39606,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+156916,int_stack+57274,int_stack+43386,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+34146,int_stack+156916,int_stack+49434,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45906,int_stack+24794,int_stack+22946,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+64834,int_stack+45906,int_stack+29526,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+166996,int_stack+64834,int_stack+57274,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+179596,int_stack+166996,int_stack+156916,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+194716,int_stack+179596,int_stack+34146,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+156916,int_stack+26978,int_stack+24794,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51450,int_stack+156916,int_stack+45906,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+16464,int_stack+51450,int_stack+64834,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+31864,int_stack+16464,int_stack+166996,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+156916,int_stack+31864,int_stack+179596,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+16464,int_stack+156916,int_stack+194716,28);
 /*--- compute (hp|ii) ---*/
 hrr1_build_hp(Libint->AB,int_stack+156916,int_stack+16464,int_stack+0,784);
 /*--- compute (gd|ii) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+156916,int_stack+74596,784);
 /*--- compute (ff|ii) ---*/
 hrr1_build_ff(Libint->AB,int_stack+156916,int_stack+0,int_stack+109876,784);
 return int_stack+156916;}
