/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffki(Libint_t*, prim_data*);

  /* Computes quartets of (ff|ki) integrals */

REALTYPE *hrr_order_ffki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[3][12] = int_stack + 2800;
 Libint->vrr_classes[3][13] = int_stack + 3710;
 Libint->vrr_classes[4][7] = int_stack + 4760;
 Libint->vrr_classes[4][8] = int_stack + 5300;
 Libint->vrr_classes[4][9] = int_stack + 5975;
 Libint->vrr_classes[4][10] = int_stack + 6800;
 Libint->vrr_classes[4][11] = int_stack + 7790;
 Libint->vrr_classes[4][12] = int_stack + 8960;
 Libint->vrr_classes[4][13] = int_stack + 10325;
 Libint->vrr_classes[5][7] = int_stack + 11900;
 Libint->vrr_classes[5][8] = int_stack + 12656;
 Libint->vrr_classes[5][9] = int_stack + 13601;
 Libint->vrr_classes[5][10] = int_stack + 14756;
 Libint->vrr_classes[5][11] = int_stack + 16142;
 Libint->vrr_classes[5][12] = int_stack + 17780;
 Libint->vrr_classes[5][13] = int_stack + 19691;
 Libint->vrr_classes[6][7] = int_stack + 21896;
 Libint->vrr_classes[6][8] = int_stack + 22904;
 Libint->vrr_classes[6][9] = int_stack + 24164;
 Libint->vrr_classes[6][10] = int_stack + 25704;
 Libint->vrr_classes[6][11] = int_stack + 27552;
 Libint->vrr_classes[6][12] = int_stack + 29736;
 Libint->vrr_classes[6][13] = int_stack + 32284;
 memset(int_stack,0,35224*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 35224;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffki(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35224,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+36304,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+37654,int_stack+36304,int_stack+35224,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39814,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41464,int_stack+39814,int_stack+36304,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+44164,int_stack+41464,int_stack+37654,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35224,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+47764,int_stack+35224,int_stack+39814,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51064,int_stack+47764,int_stack+41464,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+37204,int_stack+51064,int_stack+44164,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+42604,int_stack+2800,int_stack+2020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+55564,int_stack+42604,int_stack+35224,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+59524,int_stack+55564,int_stack+47764,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+65024,int_stack+59524,int_stack+51064,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+44944,int_stack+65024,int_stack+37204,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+35224,int_stack+3710,int_stack+2800,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+35224,int_stack+42604,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+35224,int_stack+0,int_stack+55564,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+71774,int_stack+35224,int_stack+59524,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+35224,int_stack+71774,int_stack+65024,10);
 /*--- compute (f0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+52504,int_stack+35224,int_stack+44944,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35224,int_stack+5300,int_stack+4760,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+36844,int_stack+5975,int_stack+5300,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38869,int_stack+36844,int_stack+35224,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+42109,int_stack+6800,int_stack+5975,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+44584,int_stack+42109,int_stack+36844,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+44584,int_stack+38869,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35224,int_stack+7790,int_stack+6800,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+62584,int_stack+35224,int_stack+42109,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+67534,int_stack+62584,int_stack+44584,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+38194,int_stack+67534,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+8960,int_stack+7790,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+46294,int_stack+0,int_stack+35224,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+74284,int_stack+46294,int_stack+62584,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+82534,int_stack+74284,int_stack+67534,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+62584,int_stack+82534,int_stack+38194,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+35224,int_stack+10325,int_stack+8960,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3510,int_stack+35224,int_stack+0,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+35224,int_stack+3510,int_stack+46294,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92659,int_stack+35224,int_stack+74284,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+35224,int_stack+92659,int_stack+82534,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+73924,int_stack+35224,int_stack+62584,15);
 /*--- compute (fp|ki) ---*/
 hrr1_build_fp(Libint->AB,int_stack+89044,int_stack+73924,int_stack+52504,1008);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35224,int_stack+12656,int_stack+11900,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+37492,int_stack+13601,int_stack+12656,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+40327,int_stack+37492,int_stack+35224,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44863,int_stack+14756,int_stack+13601,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48328,int_stack+44863,int_stack+37492,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+53998,int_stack+48328,int_stack+40327,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35224,int_stack+16142,int_stack+14756,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+61558,int_stack+35224,int_stack+44863,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+61558,int_stack+48328,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+39382,int_stack+0,int_stack+53998,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+50722,int_stack+17780,int_stack+16142,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+9450,int_stack+50722,int_stack+35224,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+119284,int_stack+9450,int_stack+61558,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+55636,int_stack+119284,int_stack+0,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+130834,int_stack+55636,int_stack+39382,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+19691,int_stack+17780,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+35224,int_stack+0,int_stack+50722,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146710,int_stack+35224,int_stack+9450,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+35224,int_stack+146710,int_stack+119284,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+35224,int_stack+55636,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+35224,int_stack+0,int_stack+130834,21);
 /*--- compute (gp|ki) ---*/
 hrr1_build_gp(Libint->AB,int_stack+119284,int_stack+35224,int_stack+73924,1008);
 /*--- compute (fd|ki) ---*/
 hrr1_build_fd(Libint->AB,int_stack+164644,int_stack+119284,int_stack+89044,1008);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+22904,int_stack+21896,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3024,int_stack+24164,int_stack+22904,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+6804,int_stack+3024,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12852,int_stack+25704,int_stack+24164,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+17472,int_stack+12852,int_stack+3024,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+56392,int_stack+17472,int_stack+6804,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+27552,int_stack+25704,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66472,int_stack+0,int_stack+12852,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+75712,int_stack+66472,int_stack+17472,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+5544,int_stack+75712,int_stack+56392,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56392,int_stack+29736,int_stack+27552,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88312,int_stack+56392,int_stack+0,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+99400,int_stack+88312,int_stack+66472,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+225124,int_stack+99400,int_stack+75712,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+62944,int_stack+225124,int_stack+5544,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+32284,int_stack+29736,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7644,int_stack+0,int_stack+56392,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+244024,int_stack+7644,int_stack+88312,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+244024,int_stack+99400,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+84112,int_stack+0,int_stack+225124,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+225124,int_stack+84112,int_stack+62944,28);
 /*--- compute (hp|ki) ---*/
 hrr1_build_hp(Libint->AB,int_stack+253348,int_stack+225124,int_stack+35224,1008);
 /*--- compute (gd|ki) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+253348,int_stack+119284,1008);
 /*--- compute (ff|ki) ---*/
 hrr1_build_ff(Libint->AB,int_stack+225124,int_stack+0,int_stack+164644,1008);
 return int_stack+225124;}
