/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffkp(Libint_t*, prim_data*);

  /* Computes quartets of (ff|kp) integrals */

REALTYPE *hrr_order_ffkp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[4][7] = int_stack + 810;
 Libint->vrr_classes[4][8] = int_stack + 1350;
 Libint->vrr_classes[5][7] = int_stack + 2025;
 Libint->vrr_classes[5][8] = int_stack + 2781;
 Libint->vrr_classes[6][7] = int_stack + 3726;
 Libint->vrr_classes[6][8] = int_stack + 4734;
 memset(int_stack,0,5994*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5994;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffkp(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+5994,int_stack+360,int_stack+0,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7074,int_stack+1350,int_stack+810,15);
 /*--- compute (fp|kp) ---*/
 hrr1_build_fp(Libint->AB,int_stack+8694,int_stack+7074,int_stack+5994,108);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11934,int_stack+2781,int_stack+2025,21);
 /*--- compute (gp|kp) ---*/
 hrr1_build_gp(Libint->AB,int_stack+14202,int_stack+11934,int_stack+7074,108);
 /*--- compute (fd|kp) ---*/
 hrr1_build_fd(Libint->AB,int_stack+19062,int_stack+14202,int_stack+8694,108);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+5994,int_stack+4734,int_stack+3726,28);
 /*--- compute (hp|kp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+25542,int_stack+5994,int_stack+11934,108);
 /*--- compute (gd|kp) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+25542,int_stack+14202,108);
 /*--- compute (ff|kp) ---*/
 hrr1_build_ff(Libint->AB,int_stack+25542,int_stack+0,int_stack+19062,108);
 return int_stack+25542;}
