/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fflk(Libint_t*, prim_data*);

  /* Computes quartets of (ff|lk) integrals */

REALTYPE *hrr_order_fflk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[3][14] = int_stack + 4400;
 Libint->vrr_classes[3][15] = int_stack + 5600;
 Libint->vrr_classes[4][8] = int_stack + 6960;
 Libint->vrr_classes[4][9] = int_stack + 7635;
 Libint->vrr_classes[4][10] = int_stack + 8460;
 Libint->vrr_classes[4][11] = int_stack + 9450;
 Libint->vrr_classes[4][12] = int_stack + 10620;
 Libint->vrr_classes[4][13] = int_stack + 11985;
 Libint->vrr_classes[4][14] = int_stack + 13560;
 Libint->vrr_classes[4][15] = int_stack + 15360;
 Libint->vrr_classes[5][8] = int_stack + 17400;
 Libint->vrr_classes[5][9] = int_stack + 18345;
 Libint->vrr_classes[5][10] = int_stack + 19500;
 Libint->vrr_classes[5][11] = int_stack + 20886;
 Libint->vrr_classes[5][12] = int_stack + 22524;
 Libint->vrr_classes[5][13] = int_stack + 24435;
 Libint->vrr_classes[5][14] = int_stack + 26640;
 Libint->vrr_classes[5][15] = int_stack + 29160;
 Libint->vrr_classes[6][8] = int_stack + 32016;
 Libint->vrr_classes[6][9] = int_stack + 33276;
 Libint->vrr_classes[6][10] = int_stack + 34816;
 Libint->vrr_classes[6][11] = int_stack + 36664;
 Libint->vrr_classes[6][12] = int_stack + 38848;
 Libint->vrr_classes[6][13] = int_stack + 41396;
 Libint->vrr_classes[6][14] = int_stack + 44336;
 Libint->vrr_classes[6][15] = int_stack + 47696;
 memset(int_stack,0,51504*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 51504;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fflk(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+51504,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+52854,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54504,int_stack+52854,int_stack+51504,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+57204,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59184,int_stack+57204,int_stack+52854,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+62484,int_stack+59184,int_stack+54504,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51504,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66984,int_stack+51504,int_stack+57204,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+70944,int_stack+66984,int_stack+59184,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+53844,int_stack+70944,int_stack+62484,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+60594,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+76444,int_stack+60594,int_stack+51504,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+81124,int_stack+76444,int_stack+66984,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+87724,int_stack+81124,int_stack+70944,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+63324,int_stack+87724,int_stack+53844,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+51504,int_stack+4400,int_stack+3350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+54654,int_stack+51504,int_stack+60594,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+95974,int_stack+54654,int_stack+76444,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+103774,int_stack+95974,int_stack+81124,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+72774,int_stack+103774,int_stack+87724,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+113674,int_stack+72774,int_stack+63324,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+60114,int_stack+5600,int_stack+4400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+63714,int_stack+60114,int_stack+51504,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+84324,int_stack+63714,int_stack+54654,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+51504,int_stack+84324,int_stack+95974,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+84324,int_stack+51504,int_stack+103774,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+51504,int_stack+84324,int_stack+72774,10);
 /*--- compute (f0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+66904,int_stack+51504,int_stack+113674,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+51504,int_stack+7635,int_stack+6960,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53529,int_stack+8460,int_stack+7635,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56004,int_stack+53529,int_stack+51504,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60054,int_stack+9450,int_stack+8460,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+83104,int_stack+60054,int_stack+53529,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+88054,int_stack+83104,int_stack+56004,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51504,int_stack+10620,int_stack+9450,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+94804,int_stack+51504,int_stack+60054,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+55014,int_stack+94804,int_stack+83104,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+100744,int_stack+55014,int_stack+88054,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+83104,int_stack+11985,int_stack+10620,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+87199,int_stack+83104,int_stack+51504,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+110869,int_stack+87199,int_stack+94804,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+120769,int_stack+110869,int_stack+55014,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+51504,int_stack+120769,int_stack+100744,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+94219,int_stack+13560,int_stack+11985,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+98944,int_stack+94219,int_stack+83104,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+98944,int_stack+87199,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+133144,int_stack+0,int_stack+110869,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+147994,int_stack+133144,int_stack+120769,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+107134,int_stack+147994,int_stack+51504,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+51504,int_stack+15360,int_stack+13560,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+56904,int_stack+51504,int_stack+94219,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+83104,int_stack+56904,int_stack+98944,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+165319,int_stack+83104,int_stack+0,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+83104,int_stack+165319,int_stack+133144,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+165319,int_stack+83104,int_stack+147994,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+126034,int_stack+165319,int_stack+107134,15);
 /*--- compute (fp|lk) ---*/
 hrr1_build_fp(Libint->AB,int_stack+150334,int_stack+126034,int_stack+66904,1620);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+18345,int_stack+17400,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2835,int_stack+19500,int_stack+18345,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+6300,int_stack+2835,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11970,int_stack+20886,int_stack+19500,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+51504,int_stack+11970,int_stack+2835,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+58434,int_stack+51504,int_stack+6300,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+22524,int_stack+20886,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+67884,int_stack+0,int_stack+11970,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+4914,int_stack+67884,int_stack+51504,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+76200,int_stack+4914,int_stack+58434,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+51504,int_stack+24435,int_stack+22524,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57237,int_stack+51504,int_stack+0,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+90375,int_stack+57237,int_stack+67884,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+104235,int_stack+90375,int_stack+4914,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+104235,int_stack+76200,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+67065,int_stack+26640,int_stack+24435,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+73680,int_stack+67065,int_stack+51504,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+198934,int_stack+73680,int_stack+57237,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+215314,int_stack+198934,int_stack+90375,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+236104,int_stack+215314,int_stack+104235,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+85146,int_stack+236104,int_stack+0,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+29160,int_stack+26640,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+7560,int_stack+0,int_stack+67065,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+51504,int_stack+7560,int_stack+73680,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+51504,int_stack+198934,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+51504,int_stack+0,int_stack+215314,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+198934,int_stack+51504,int_stack+236104,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+231274,int_stack+198934,int_stack+85146,21);
 /*--- compute (gp|lk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+51504,int_stack+231274,int_stack+126034,1620);
 /*--- compute (fd|lk) ---*/
 hrr1_build_fd(Libint->AB,int_stack+265294,int_stack+51504,int_stack+150334,1620);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124404,int_stack+33276,int_stack+32016,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+128184,int_stack+34816,int_stack+33276,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+132804,int_stack+128184,int_stack+124404,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+140364,int_stack+36664,int_stack+34816,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+145908,int_stack+140364,int_stack+128184,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+155148,int_stack+145908,int_stack+132804,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124404,int_stack+38848,int_stack+36664,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+167748,int_stack+124404,int_stack+140364,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+178836,int_stack+167748,int_stack+145908,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+130956,int_stack+178836,int_stack+155148,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149856,int_stack+41396,int_stack+38848,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+194236,int_stack+149856,int_stack+124404,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+207340,int_stack+194236,int_stack+167748,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+207340,int_stack+178836,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+157500,int_stack+0,int_stack+130956,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+124404,int_stack+44336,int_stack+41396,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+133224,int_stack+124404,int_stack+149856,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+362494,int_stack+133224,int_stack+194236,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+384334,int_stack+362494,int_stack+207340,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+183960,int_stack+384334,int_stack+0,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+183960,int_stack+157500,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148512,int_stack+47696,int_stack+44336,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+158592,int_stack+148512,int_stack+124404,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+412054,int_stack+158592,int_stack+133224,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+124404,int_stack+412054,int_stack+362494,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+412054,int_stack+124404,int_stack+384334,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+124404,int_stack+412054,int_stack+183960,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+167524,int_stack+124404,int_stack+0,28);
 /*--- compute (hp|lk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+362494,int_stack+167524,int_stack+231274,1620);
 /*--- compute (gd|lk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+464554,int_stack+362494,int_stack+51504,1620);
 /*--- compute (ff|lk) ---*/
 hrr1_build_ff(Libint->AB,int_stack+0,int_stack+464554,int_stack+265294,1620);
 return int_stack+0;}
