/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffnl(Libint_t*, prim_data*);

  /* Computes quartets of (ff|nl) integrals */

REALTYPE *hrr_order_ffnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[3][17] = int_stack + 7490;
 Libint->vrr_classes[3][18] = int_stack + 9200;
 Libint->vrr_classes[4][10] = int_stack + 11100;
 Libint->vrr_classes[4][11] = int_stack + 12090;
 Libint->vrr_classes[4][12] = int_stack + 13260;
 Libint->vrr_classes[4][13] = int_stack + 14625;
 Libint->vrr_classes[4][14] = int_stack + 16200;
 Libint->vrr_classes[4][15] = int_stack + 18000;
 Libint->vrr_classes[4][16] = int_stack + 20040;
 Libint->vrr_classes[4][17] = int_stack + 22335;
 Libint->vrr_classes[4][18] = int_stack + 24900;
 Libint->vrr_classes[5][10] = int_stack + 27750;
 Libint->vrr_classes[5][11] = int_stack + 29136;
 Libint->vrr_classes[5][12] = int_stack + 30774;
 Libint->vrr_classes[5][13] = int_stack + 32685;
 Libint->vrr_classes[5][14] = int_stack + 34890;
 Libint->vrr_classes[5][15] = int_stack + 37410;
 Libint->vrr_classes[5][16] = int_stack + 40266;
 Libint->vrr_classes[5][17] = int_stack + 43479;
 Libint->vrr_classes[5][18] = int_stack + 47070;
 Libint->vrr_classes[6][10] = int_stack + 51060;
 Libint->vrr_classes[6][11] = int_stack + 52908;
 Libint->vrr_classes[6][12] = int_stack + 55092;
 Libint->vrr_classes[6][13] = int_stack + 57640;
 Libint->vrr_classes[6][14] = int_stack + 60580;
 Libint->vrr_classes[6][15] = int_stack + 63940;
 Libint->vrr_classes[6][16] = int_stack + 67748;
 Libint->vrr_classes[6][17] = int_stack + 72032;
 Libint->vrr_classes[6][18] = int_stack + 76820;
 memset(int_stack,0,82140*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 82140;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffnl(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+82140,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84120,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+86460,int_stack+84120,int_stack+82140,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+90420,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+93150,int_stack+90420,int_stack+84120,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+97830,int_stack+93150,int_stack+86460,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+82140,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+104430,int_stack+82140,int_stack+90420,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+85290,int_stack+104430,int_stack+93150,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+109890,int_stack+85290,int_stack+97830,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+93090,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96690,int_stack+93090,int_stack+82140,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+119790,int_stack+96690,int_stack+104430,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+128890,int_stack+119790,int_stack+85290,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+140590,int_stack+128890,int_stack+109890,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+82140,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+102990,int_stack+82140,int_stack+93090,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+154450,int_stack+102990,int_stack+96690,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+86220,int_stack+154450,int_stack+119790,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+110190,int_stack+86220,int_stack+128890,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+164950,int_stack+110190,int_stack+140590,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+126570,int_stack+7490,int_stack+5960,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+131160,int_stack+126570,int_stack+82140,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+139320,int_stack+131160,int_stack+102990,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+183430,int_stack+139320,int_stack+154450,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+199180,int_stack+183430,int_stack+86220,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+82140,int_stack+199180,int_stack+110190,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+218290,int_stack+82140,int_stack+164950,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+103980,int_stack+9200,int_stack+7490,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+109110,int_stack+103980,int_stack+126570,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+151320,int_stack+109110,int_stack+131160,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+103980,int_stack+151320,int_stack+139320,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+121980,int_stack+103980,int_stack+183430,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+144030,int_stack+121980,int_stack+199180,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+103980,int_stack+144030,int_stack+82140,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+132060,int_stack+103980,int_stack+218290,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+82140,int_stack+12090,int_stack+11100,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85110,int_stack+13260,int_stack+12090,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88620,int_stack+85110,int_stack+82140,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+94560,int_stack+14625,int_stack+13260,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+98655,int_stack+94560,int_stack+85110,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+105675,int_stack+98655,int_stack+88620,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+82140,int_stack+16200,int_stack+14625,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+115575,int_stack+82140,int_stack+94560,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+86865,int_stack+115575,int_stack+98655,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+161760,int_stack+86865,int_stack+105675,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+98565,int_stack+18000,int_stack+16200,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+103965,int_stack+98565,int_stack+82140,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+176610,int_stack+103965,int_stack+115575,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+113415,int_stack+176610,int_stack+86865,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+190260,int_stack+113415,int_stack+161760,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+161760,int_stack+20040,int_stack+18000,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+82140,int_stack+161760,int_stack+98565,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+211050,int_stack+82140,int_stack+103965,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+92940,int_stack+211050,int_stack+176610,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+226800,int_stack+92940,int_stack+113415,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+251370,int_stack+226800,int_stack+190260,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+113415,int_stack+22335,int_stack+20040,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+167880,int_stack+113415,int_stack+161760,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+180120,int_stack+167880,int_stack+82140,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+279090,int_stack+180120,int_stack+211050,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+198120,int_stack+279090,int_stack+92940,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+302715,int_stack+198120,int_stack+226800,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+335475,int_stack+302715,int_stack+251370,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+82140,int_stack+24900,int_stack+22335,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+89835,int_stack+82140,int_stack+113415,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+103605,int_stack+89835,int_stack+167880,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+226785,int_stack+103605,int_stack+180120,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+82140,int_stack+226785,int_stack+279090,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+226785,int_stack+82140,int_stack+198120,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+82140,int_stack+226785,int_stack+302715,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+161760,int_stack+82140,int_stack+335475,15);
 /*--- compute (fp|nl) ---*/
 hrr1_build_fp(Libint->AB,int_stack+206310,int_stack+161760,int_stack+132060,2970);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+82140,int_stack+29136,int_stack+27750,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+86298,int_stack+30774,int_stack+29136,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91212,int_stack+86298,int_stack+82140,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99528,int_stack+32685,int_stack+30774,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+105261,int_stack+99528,int_stack+86298,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+115089,int_stack+105261,int_stack+91212,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+82140,int_stack+34890,int_stack+32685,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+128949,int_stack+82140,int_stack+99528,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+88755,int_stack+128949,int_stack+105261,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+140415,int_stack+88755,int_stack+115089,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+105135,int_stack+37410,int_stack+34890,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+112695,int_stack+105135,int_stack+82140,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+295410,int_stack+112695,int_stack+128949,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+314520,int_stack+295410,int_stack+88755,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+339090,int_stack+314520,int_stack+140415,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+82140,int_stack+40266,int_stack+37410,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+125925,int_stack+82140,int_stack+105135,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+125925,int_stack+112695,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+90708,int_stack+0,int_stack+295410,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+368196,int_stack+90708,int_stack+314520,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+295410,int_stack+368196,int_stack+339090,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+334218,int_stack+43479,int_stack+40266,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+343857,int_stack+334218,int_stack+82140,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+402594,int_stack+343857,int_stack+125925,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+119373,int_stack+402594,int_stack+0,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+119373,int_stack+90708,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+427794,int_stack+0,int_stack+368196,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+473658,int_stack+427794,int_stack+295410,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+295410,int_stack+47070,int_stack+43479,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+306183,int_stack+295410,int_stack+334218,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+82140,int_stack+306183,int_stack+343857,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+295410,int_stack+82140,int_stack+402594,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+333210,int_stack+295410,int_stack+119373,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+82140,int_stack+333210,int_stack+0,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+295410,int_stack+82140,int_stack+427794,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+82140,int_stack+295410,int_stack+473658,21);
 /*--- compute (gp|nl) ---*/
 hrr1_build_gp(Libint->AB,int_stack+295410,int_stack+82140,int_stack+161760,2970);
 /*--- compute (fd|nl) ---*/
 hrr1_build_fd(Libint->AB,int_stack+429060,int_stack+295410,int_stack+206310,2970);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+144510,int_stack+52908,int_stack+51060,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+150054,int_stack+55092,int_stack+52908,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+156606,int_stack+150054,int_stack+144510,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+167694,int_stack+57640,int_stack+55092,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+175338,int_stack+167694,int_stack+150054,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188442,int_stack+175338,int_stack+156606,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+144510,int_stack+60580,int_stack+57640,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+206922,int_stack+144510,int_stack+167694,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+153330,int_stack+206922,int_stack+175338,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+222210,int_stack+153330,int_stack+188442,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+175170,int_stack+63940,int_stack+60580,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+185250,int_stack+175170,int_stack+144510,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+249930,int_stack+185250,int_stack+206922,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+249930,int_stack+153330,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+607260,int_stack+0,int_stack+222210,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+144510,int_stack+67748,int_stack+63940,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+202890,int_stack+144510,int_stack+175170,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+32760,int_stack+202890,int_stack+185250,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+155934,int_stack+32760,int_stack+249930,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+223050,int_stack+155934,int_stack+0,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+646068,int_stack+223050,int_stack+607260,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+607260,int_stack+72032,int_stack+67748,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+620112,int_stack+607260,int_stack+144510,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+697812,int_stack+620112,int_stack+202890,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+731412,int_stack+697812,int_stack+32760,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+731412,int_stack+155934,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+144510,int_stack+0,int_stack+223050,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+205662,int_stack+144510,int_stack+646068,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+272190,int_stack+76820,int_stack+72032,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+642960,int_stack+272190,int_stack+607260,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+775512,int_stack+642960,int_stack+620112,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+607260,int_stack+775512,int_stack+697812,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+657660,int_stack+607260,int_stack+731412,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+719400,int_stack+657660,int_stack+0,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+719400,int_stack+144510,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+607260,int_stack+0,int_stack+205662,28);
 /*--- compute (hp|nl) ---*/
 hrr1_build_hp(Libint->AB,int_stack+690420,int_stack+607260,int_stack+82140,2970);
 /*--- compute (gd|nl) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+690420,int_stack+295410,2970);
 /*--- compute (ff|nl) ---*/
 hrr1_build_ff(Libint->AB,int_stack+607260,int_stack+0,int_stack+429060,2970);
 return int_stack+607260;}
