/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpkp(Libint_t*, prim_data*);

  /* Computes quartets of (fp|kp) integrals */

REALTYPE *hrr_order_fpkp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[4][7] = int_stack + 810;
 Libint->vrr_classes[4][8] = int_stack + 1350;
 memset(int_stack,0,2025*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2025;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpkp(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2025,int_stack+360,int_stack+0,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3105,int_stack+1350,int_stack+810,15);
 /*--- compute (fp|kp) ---*/
 hrr1_build_fp(Libint->AB,int_stack+4725,int_stack+3105,int_stack+2025,108);
 return int_stack+4725;}
