/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fplf(Libint_t*, prim_data*);

  /* Computes quartets of (fp|lf) integrals */

REALTYPE *hrr_order_fplf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[4][8] = int_stack + 2440;
 Libint->vrr_classes[4][9] = int_stack + 3115;
 Libint->vrr_classes[4][10] = int_stack + 3940;
 Libint->vrr_classes[4][11] = int_stack + 4930;
 memset(int_stack,0,6100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fplf(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+6100,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7450,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+9100,int_stack+7450,int_stack+6100,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11800,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13780,int_stack+11800,int_stack+7450,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+17080,int_stack+13780,int_stack+9100,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+6100,int_stack+3115,int_stack+2440,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8125,int_stack+3940,int_stack+3115,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10600,int_stack+8125,int_stack+6100,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+4930,int_stack+3940,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2970,int_stack+0,int_stack+8125,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+21580,int_stack+2970,int_stack+10600,15);
 /*--- compute (fp|lf) ---*/
 hrr1_build_fp(Libint->AB,int_stack+0,int_stack+21580,int_stack+17080,450);
 return int_stack+0;}
