/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdni(Libint_t*, prim_data*);

  /* Computes quartets of (gd|ni) integrals */

REALTYPE *hrr_order_gdni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[5][10] = int_stack + 11235;
 Libint->vrr_classes[5][11] = int_stack + 12621;
 Libint->vrr_classes[5][12] = int_stack + 14259;
 Libint->vrr_classes[5][13] = int_stack + 16170;
 Libint->vrr_classes[5][14] = int_stack + 18375;
 Libint->vrr_classes[5][15] = int_stack + 20895;
 Libint->vrr_classes[5][16] = int_stack + 23751;
 Libint->vrr_classes[6][10] = int_stack + 26964;
 Libint->vrr_classes[6][11] = int_stack + 28812;
 Libint->vrr_classes[6][12] = int_stack + 30996;
 Libint->vrr_classes[6][13] = int_stack + 33544;
 Libint->vrr_classes[6][14] = int_stack + 36484;
 Libint->vrr_classes[6][15] = int_stack + 39844;
 Libint->vrr_classes[6][16] = int_stack + 43652;
 memset(int_stack,0,47936*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47936;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdni(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47936,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+50906,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54416,int_stack+50906,int_stack+47936,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+60356,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+64451,int_stack+60356,int_stack+50906,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+71471,int_stack+64451,int_stack+54416,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47936,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+81371,int_stack+47936,int_stack+60356,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+52661,int_stack+81371,int_stack+64451,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+89561,int_stack+52661,int_stack+71471,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+64361,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+69761,int_stack+64361,int_stack+47936,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+104411,int_stack+69761,int_stack+81371,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+118061,int_stack+104411,int_stack+52661,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+135611,int_stack+118061,int_stack+89561,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+47936,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+79211,int_stack+47936,int_stack+64361,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+47936,int_stack+79211,int_stack+69761,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+63686,int_stack+47936,int_stack+104411,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+84161,int_stack+63686,int_stack+118061,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+47936,int_stack+84161,int_stack+135611,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75656,int_stack+12621,int_stack+11235,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+79814,int_stack+14259,int_stack+12621,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84728,int_stack+79814,int_stack+75656,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+93044,int_stack+16170,int_stack+14259,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+98777,int_stack+93044,int_stack+79814,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+108605,int_stack+98777,int_stack+84728,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+75656,int_stack+18375,int_stack+16170,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+122465,int_stack+75656,int_stack+93044,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+82271,int_stack+122465,int_stack+98777,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+133931,int_stack+82271,int_stack+108605,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+98651,int_stack+20895,int_stack+18375,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+106211,int_stack+98651,int_stack+75656,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+106211,int_stack+122465,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+154721,int_stack+0,int_stack+82271,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+179291,int_stack+154721,int_stack+133931,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+75656,int_stack+23751,int_stack+20895,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+119441,int_stack+75656,int_stack+98651,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+75656,int_stack+119441,int_stack+106211,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+97706,int_stack+75656,int_stack+0,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+208397,int_stack+97706,int_stack+154721,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+75656,int_stack+208397,int_stack+179291,21);
 /*--- compute (gp|ni) ---*/
 hrr1_build_gp(Libint->AB,int_stack+114464,int_stack+75656,int_stack+47936,1848);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47936,int_stack+28812,int_stack+26964,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+53480,int_stack+30996,int_stack+28812,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+60032,int_stack+53480,int_stack+47936,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+33544,int_stack+30996,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7644,int_stack+0,int_stack+53480,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+197624,int_stack+7644,int_stack+60032,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47936,int_stack+36484,int_stack+33544,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+56756,int_stack+47936,int_stack+0,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+216104,int_stack+56756,int_stack+7644,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+216104,int_stack+197624,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+197624,int_stack+39844,int_stack+36484,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+237944,int_stack+197624,int_stack+47936,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+255584,int_stack+237944,int_stack+56756,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+281064,int_stack+255584,int_stack+216104,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+313824,int_stack+281064,int_stack+0,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+43652,int_stack+39844,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+11424,int_stack+0,int_stack+197624,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+197624,int_stack+11424,int_stack+237944,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+197624,int_stack+255584,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+197624,int_stack+0,int_stack+281064,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+197624,int_stack+313824,28);
 /*--- compute (hp|ni) ---*/
 hrr1_build_hp(Libint->AB,int_stack+197624,int_stack+0,int_stack+75656,1848);
 /*--- compute (gd|ni) ---*/
 hrr1_build_gd(Libint->AB,int_stack+314048,int_stack+197624,int_stack+114464,1848);
 return int_stack+314048;}
