/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfnh(Libint_t*, prim_data*);

  /* Computes quartets of (gf|nh) integrals */

REALTYPE *hrr_order_gfnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[5][10] = int_stack + 8940;
 Libint->vrr_classes[5][11] = int_stack + 10326;
 Libint->vrr_classes[5][12] = int_stack + 11964;
 Libint->vrr_classes[5][13] = int_stack + 13875;
 Libint->vrr_classes[5][14] = int_stack + 16080;
 Libint->vrr_classes[5][15] = int_stack + 18600;
 Libint->vrr_classes[6][10] = int_stack + 21456;
 Libint->vrr_classes[6][11] = int_stack + 23304;
 Libint->vrr_classes[6][12] = int_stack + 25488;
 Libint->vrr_classes[6][13] = int_stack + 28036;
 Libint->vrr_classes[6][14] = int_stack + 30976;
 Libint->vrr_classes[6][15] = int_stack + 34336;
 Libint->vrr_classes[7][10] = int_stack + 38144;
 Libint->vrr_classes[7][11] = int_stack + 40520;
 Libint->vrr_classes[7][12] = int_stack + 43328;
 Libint->vrr_classes[7][13] = int_stack + 46604;
 Libint->vrr_classes[7][14] = int_stack + 50384;
 Libint->vrr_classes[7][15] = int_stack + 54704;
 memset(int_stack,0,59600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 59600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfnh(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59600,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+62570,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66080,int_stack+62570,int_stack+59600,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+72020,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+76115,int_stack+72020,int_stack+62570,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+83135,int_stack+76115,int_stack+66080,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59600,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+93035,int_stack+59600,int_stack+72020,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+64325,int_stack+93035,int_stack+76115,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+101225,int_stack+64325,int_stack+83135,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+76025,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+81425,int_stack+76025,int_stack+59600,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+116075,int_stack+81425,int_stack+93035,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+76025,int_stack+116075,int_stack+64325,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+116075,int_stack+76025,int_stack+101225,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59600,int_stack+10326,int_stack+8940,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63758,int_stack+11964,int_stack+10326,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+68672,int_stack+63758,int_stack+59600,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+76988,int_stack+13875,int_stack+11964,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+82721,int_stack+76988,int_stack+63758,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+92549,int_stack+82721,int_stack+68672,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59600,int_stack+16080,int_stack+13875,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+59600,int_stack+76988,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+66215,int_stack+0,int_stack+82721,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+136865,int_stack+66215,int_stack+92549,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+82595,int_stack+18600,int_stack+16080,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+90155,int_stack+82595,int_stack+59600,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+157655,int_stack+90155,int_stack+0,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+82595,int_stack+157655,int_stack+66215,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+157655,int_stack+82595,int_stack+136865,21);
 /*--- compute (gp|nh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+186761,int_stack+157655,int_stack+116075,1386);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+23304,int_stack+21456,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+25488,int_stack+23304,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12096,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+59600,int_stack+28036,int_stack+25488,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+67244,int_stack+59600,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+80348,int_stack+67244,int_stack+12096,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+30976,int_stack+28036,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+59600,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+98828,int_stack+8820,int_stack+67244,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+120668,int_stack+98828,int_stack+80348,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+59600,int_stack+34336,int_stack+30976,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+69680,int_stack+59600,int_stack+0,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+249131,int_stack+69680,int_stack+8820,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+249131,int_stack+98828,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+59600,int_stack+0,int_stack+120668,28);
 /*--- compute (hp|nh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+249131,int_stack+59600,int_stack+157655,1386);
 /*--- compute (gd|nh) ---*/
 hrr1_build_gd(Libint->AB,int_stack+336449,int_stack+249131,int_stack+186761,1386);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+40520,int_stack+38144,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+43328,int_stack+40520,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15552,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29808,int_stack+46604,int_stack+43328,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+98408,int_stack+29808,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+115256,int_stack+98408,int_stack+15552,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+50384,int_stack+46604,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+139016,int_stack+0,int_stack+29808,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+11340,int_stack+139016,int_stack+98408,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+158672,int_stack+11340,int_stack+115256,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+98408,int_stack+54704,int_stack+50384,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+111368,int_stack+98408,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+194312,int_stack+111368,int_stack+139016,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+98408,int_stack+194312,int_stack+11340,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+194312,int_stack+98408,int_stack+158672,36);
 /*--- compute (ip|nh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+461189,int_stack+194312,int_stack+59600,1386);
 /*--- compute (hd|nh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+461189,int_stack+249131,1386);
 /*--- compute (gf|nh) ---*/
 hrr1_build_gf(Libint->AB,int_stack+461189,int_stack+0,int_stack+336449,1386);
 return int_stack+461189;}
