/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gglf(Libint_t*, prim_data*);

  /* Computes quartets of (gg|lf) integrals */

REALTYPE *hrr_order_gglf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[5][8] = int_stack + 3660;
 Libint->vrr_classes[5][9] = int_stack + 4605;
 Libint->vrr_classes[5][10] = int_stack + 5760;
 Libint->vrr_classes[5][11] = int_stack + 7146;
 Libint->vrr_classes[6][8] = int_stack + 8784;
 Libint->vrr_classes[6][9] = int_stack + 10044;
 Libint->vrr_classes[6][10] = int_stack + 11584;
 Libint->vrr_classes[6][11] = int_stack + 13432;
 Libint->vrr_classes[7][8] = int_stack + 15616;
 Libint->vrr_classes[7][9] = int_stack + 17236;
 Libint->vrr_classes[7][10] = int_stack + 19216;
 Libint->vrr_classes[7][11] = int_stack + 21592;
 Libint->vrr_classes[8][8] = int_stack + 24400;
 Libint->vrr_classes[8][9] = int_stack + 26425;
 Libint->vrr_classes[8][10] = int_stack + 28900;
 Libint->vrr_classes[8][11] = int_stack + 31870;
 memset(int_stack,0,35380*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 35380;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gglf(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35380,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+37405,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+39880,int_stack+37405,int_stack+35380,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+43930,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46900,int_stack+43930,int_stack+37405,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51850,int_stack+46900,int_stack+39880,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35380,int_stack+4605,int_stack+3660,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38215,int_stack+5760,int_stack+4605,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41680,int_stack+38215,int_stack+35380,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47350,int_stack+7146,int_stack+5760,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+47350,int_stack+38215,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+58600,int_stack+0,int_stack+41680,21);
 /*--- compute (gp|lf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+68050,int_stack+58600,int_stack+51850,450);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+10044,int_stack+8784,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3780,int_stack+11584,int_stack+10044,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35380,int_stack+3780,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+42940,int_stack+13432,int_stack+11584,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48484,int_stack+42940,int_stack+3780,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+48484,int_stack+35380,28);
 /*--- compute (hp|lf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+88300,int_stack+0,int_stack+58600,450);
 /*--- compute (gd|lf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+116650,int_stack+88300,int_stack+68050,450);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35380,int_stack+17236,int_stack+15616,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40240,int_stack+19216,int_stack+17236,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+46180,int_stack+40240,int_stack+35380,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55900,int_stack+21592,int_stack+19216,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+63028,int_stack+55900,int_stack+40240,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+157150,int_stack+63028,int_stack+46180,36);
 /*--- compute (ip|lf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+35380,int_stack+157150,int_stack+0,450);
 /*--- compute (hd|lf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+173350,int_stack+35380,int_stack+88300,450);
 /*--- compute (gf|lf) ---*/
 hrr1_build_gf(Libint->AB,int_stack+230050,int_stack+173350,int_stack+116650,450);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+26425,int_stack+24400,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6075,int_stack+28900,int_stack+26425,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13500,int_stack+6075,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+73180,int_stack+31870,int_stack+28900,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+82090,int_stack+73180,int_stack+6075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+96940,int_stack+82090,int_stack+13500,45);
 /*--- compute (kp|lf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+297550,int_stack+96940,int_stack+157150,450);
 /*--- compute (id|lf) ---*/
 hrr1_build_id(Libint->AB,int_stack+73180,int_stack+297550,int_stack+35380,450);
 /*--- compute (hf|lf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+297550,int_stack+73180,int_stack+173350,450);
 /*--- compute (gg|lf) ---*/
 hrr1_build_gg(Libint->AB,int_stack+0,int_stack+297550,int_stack+230050,450);
 return int_stack+0;}
