/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdmi(Libint_t*, prim_data*);

  /* Computes quartets of (hd|mi) integrals */

REALTYPE *hrr_order_hdmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[6][9] = int_stack + 13671;
 Libint->vrr_classes[6][10] = int_stack + 15211;
 Libint->vrr_classes[6][11] = int_stack + 17059;
 Libint->vrr_classes[6][12] = int_stack + 19243;
 Libint->vrr_classes[6][13] = int_stack + 21791;
 Libint->vrr_classes[6][14] = int_stack + 24731;
 Libint->vrr_classes[6][15] = int_stack + 28091;
 Libint->vrr_classes[7][9] = int_stack + 31899;
 Libint->vrr_classes[7][10] = int_stack + 33879;
 Libint->vrr_classes[7][11] = int_stack + 36255;
 Libint->vrr_classes[7][12] = int_stack + 39063;
 Libint->vrr_classes[7][13] = int_stack + 42339;
 Libint->vrr_classes[7][14] = int_stack + 46119;
 Libint->vrr_classes[7][15] = int_stack + 50439;
 memset(int_stack,0,55335*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 55335;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdmi(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+55335,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58800,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+62958,int_stack+58800,int_stack+55335,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+69888,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+74802,int_stack+69888,int_stack+58800,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+83118,int_stack+74802,int_stack+62958,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+55335,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+94668,int_stack+55335,int_stack+69888,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+104496,int_stack+94668,int_stack+74802,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+61068,int_stack+104496,int_stack+83118,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+78393,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+118356,int_stack+78393,int_stack+55335,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+129822,int_stack+118356,int_stack+94668,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+146202,int_stack+129822,int_stack+104496,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+85008,int_stack+146202,int_stack+61068,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+55335,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+62895,int_stack+55335,int_stack+78393,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+166992,int_stack+62895,int_stack+118356,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+55335,int_stack+166992,int_stack+129822,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+109263,int_stack+55335,int_stack+146202,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+138369,int_stack+109263,int_stack+85008,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+55335,int_stack+15211,int_stack+13671,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59955,int_stack+17059,int_stack+15211,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+65499,int_stack+59955,int_stack+55335,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+74739,int_stack+19243,int_stack+17059,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+81291,int_stack+74739,int_stack+59955,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+92379,int_stack+81291,int_stack+65499,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+55335,int_stack+21791,int_stack+19243,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+107779,int_stack+55335,int_stack+74739,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+107779,int_stack+81291,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+62979,int_stack+0,int_stack+92379,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+86079,int_stack+24731,int_stack+21791,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+120883,int_stack+86079,int_stack+55335,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+170709,int_stack+120883,int_stack+107779,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+192549,int_stack+170709,int_stack+0,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+220269,int_stack+192549,int_stack+62979,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+28091,int_stack+24731,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10080,int_stack+0,int_stack+86079,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+55335,int_stack+10080,int_stack+120883,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+80815,int_stack+55335,int_stack+170709,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+252609,int_stack+80815,int_stack+192549,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+170709,int_stack+252609,int_stack+220269,28);
 /*--- compute (hp|mi) ---*/
 hrr1_build_hp(Libint->AB,int_stack+213829,int_stack+170709,int_stack+138369,1540);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+55335,int_stack+33879,int_stack+31899,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61275,int_stack+36255,int_stack+33879,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+68403,int_stack+61275,int_stack+55335,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+80283,int_stack+39063,int_stack+36255,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88707,int_stack+80283,int_stack+61275,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+102963,int_stack+88707,int_stack+68403,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+55335,int_stack+42339,int_stack+39063,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+122763,int_stack+55335,int_stack+80283,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+139611,int_stack+122763,int_stack+88707,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+65163,int_stack+139611,int_stack+102963,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+94863,int_stack+46119,int_stack+42339,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+94863,int_stack+55335,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+310849,int_stack+0,int_stack+122763,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+338929,int_stack+310849,int_stack+139611,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+106203,int_stack+338929,int_stack+65163,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+55335,int_stack+50439,int_stack+46119,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+68295,int_stack+55335,int_stack+94863,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+19656,int_stack+68295,int_stack+0,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+52416,int_stack+19656,int_stack+310849,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+52416,int_stack+338929,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+310849,int_stack+0,int_stack+106203,36);
 /*--- compute (ip|mi) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+310849,int_stack+170709,1540);
 /*--- compute (hd|mi) ---*/
 hrr1_build_hd(Libint->AB,int_stack+310849,int_stack+0,int_stack+213829,1540);
 return int_stack+310849;}
