/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfih(Libint_t*, prim_data*);

  /* Computes quartets of (hf|ih) integrals */

REALTYPE *hrr_order_hfih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[5][9] = int_stack + 2289;
 Libint->vrr_classes[5][10] = int_stack + 3444;
 Libint->vrr_classes[5][11] = int_stack + 4830;
 Libint->vrr_classes[6][6] = int_stack + 6468;
 Libint->vrr_classes[6][7] = int_stack + 7252;
 Libint->vrr_classes[6][8] = int_stack + 8260;
 Libint->vrr_classes[6][9] = int_stack + 9520;
 Libint->vrr_classes[6][10] = int_stack + 11060;
 Libint->vrr_classes[6][11] = int_stack + 12908;
 Libint->vrr_classes[7][6] = int_stack + 15092;
 Libint->vrr_classes[7][7] = int_stack + 16100;
 Libint->vrr_classes[7][8] = int_stack + 17396;
 Libint->vrr_classes[7][9] = int_stack + 19016;
 Libint->vrr_classes[7][10] = int_stack + 20996;
 Libint->vrr_classes[7][11] = int_stack + 23372;
 Libint->vrr_classes[8][6] = int_stack + 26180;
 Libint->vrr_classes[8][7] = int_stack + 27440;
 Libint->vrr_classes[8][8] = int_stack + 29060;
 Libint->vrr_classes[8][9] = int_stack + 31085;
 Libint->vrr_classes[8][10] = int_stack + 33560;
 Libint->vrr_classes[8][11] = int_stack + 36530;
 memset(int_stack,0,40040*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40040;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfih(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+40040,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+41804,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+44072,int_stack+41804,int_stack+40040,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+47600,int_stack+2289,int_stack+1344,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+50435,int_stack+47600,int_stack+41804,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+54971,int_stack+50435,int_stack+44072,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40040,int_stack+3444,int_stack+2289,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60851,int_stack+40040,int_stack+47600,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+66521,int_stack+60851,int_stack+50435,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+43505,int_stack+66521,int_stack+54971,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+52325,int_stack+4830,int_stack+3444,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+74081,int_stack+52325,int_stack+40040,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+81011,int_stack+74081,int_stack+60851,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+52325,int_stack+81011,int_stack+66521,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+63665,int_stack+52325,int_stack+43505,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+40040,int_stack+7252,int_stack+6468,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+42392,int_stack+8260,int_stack+7252,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+45416,int_stack+42392,int_stack+40040,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+50120,int_stack+9520,int_stack+8260,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+53900,int_stack+50120,int_stack+42392,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+76013,int_stack+53900,int_stack+45416,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40040,int_stack+11060,int_stack+9520,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+40040,int_stack+50120,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+83853,int_stack+0,int_stack+53900,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+44660,int_stack+83853,int_stack+76013,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+76013,int_stack+12908,int_stack+11060,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+93933,int_stack+76013,int_stack+40040,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+103173,int_stack+93933,int_stack+0,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+115773,int_stack+103173,int_stack+83853,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+76013,int_stack+115773,int_stack+44660,28);
 /*--- compute (hp|ih) ---*/
 hrr1_build_hp(Libint->AB,int_stack+92477,int_stack+76013,int_stack+63665,588);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+16100,int_stack+15092,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3024,int_stack+17396,int_stack+16100,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+6912,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40040,int_stack+19016,int_stack+17396,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+44900,int_stack+40040,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+52676,int_stack+44900,int_stack+6912,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+20996,int_stack+19016,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+5940,int_stack+0,int_stack+40040,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+62756,int_stack+5940,int_stack+44900,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+129521,int_stack+62756,int_stack+52676,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40040,int_stack+23372,int_stack+20996,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+47168,int_stack+40040,int_stack+0,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+144641,int_stack+47168,int_stack+5940,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+144641,int_stack+62756,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+40040,int_stack+0,int_stack+129521,36);
 /*--- compute (ip|ih) ---*/
 hrr1_build_ip(Libint->AB,int_stack+129521,int_stack+40040,int_stack+76013,588);
 /*--- compute (hd|ih) ---*/
 hrr1_build_hd(Libint->AB,int_stack+178913,int_stack+129521,int_stack+92477,588);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+27440,int_stack+26180,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3780,int_stack+29060,int_stack+27440,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8640,int_stack+3780,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16200,int_stack+31085,int_stack+29060,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+61208,int_stack+16200,int_stack+3780,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+70928,int_stack+61208,int_stack+8640,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+33560,int_stack+31085,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+83528,int_stack+0,int_stack+16200,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+7425,int_stack+83528,int_stack+61208,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+95678,int_stack+7425,int_stack+70928,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61208,int_stack+36530,int_stack+33560,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23625,int_stack+61208,int_stack+0,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+61208,int_stack+23625,int_stack+83528,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+253001,int_stack+61208,int_stack+7425,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+61208,int_stack+253001,int_stack+95678,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+253001,int_stack+61208,int_stack+40040,588);
 /*--- compute (id|ih) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+253001,int_stack+129521,588);
 /*--- compute (hf|ih) ---*/
 hrr1_build_hf(Libint->AB,int_stack+253001,int_stack+0,int_stack+178913,588);
 return int_stack+253001;}
