/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfmm(Libint_t*, prim_data*);

  /* Computes quartets of (hf|mm) integrals */

REALTYPE *hrr_order_hfmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[5][18] = int_stack + 20475;
 Libint->vrr_classes[6][9] = int_stack + 24465;
 Libint->vrr_classes[6][10] = int_stack + 26005;
 Libint->vrr_classes[6][11] = int_stack + 27853;
 Libint->vrr_classes[6][12] = int_stack + 30037;
 Libint->vrr_classes[6][13] = int_stack + 32585;
 Libint->vrr_classes[6][14] = int_stack + 35525;
 Libint->vrr_classes[6][15] = int_stack + 38885;
 Libint->vrr_classes[6][16] = int_stack + 42693;
 Libint->vrr_classes[6][17] = int_stack + 46977;
 Libint->vrr_classes[6][18] = int_stack + 51765;
 Libint->vrr_classes[7][9] = int_stack + 57085;
 Libint->vrr_classes[7][10] = int_stack + 59065;
 Libint->vrr_classes[7][11] = int_stack + 61441;
 Libint->vrr_classes[7][12] = int_stack + 64249;
 Libint->vrr_classes[7][13] = int_stack + 67525;
 Libint->vrr_classes[7][14] = int_stack + 71305;
 Libint->vrr_classes[7][15] = int_stack + 75625;
 Libint->vrr_classes[7][16] = int_stack + 80521;
 Libint->vrr_classes[7][17] = int_stack + 86029;
 Libint->vrr_classes[7][18] = int_stack + 92185;
 Libint->vrr_classes[8][9] = int_stack + 99025;
 Libint->vrr_classes[8][10] = int_stack + 101500;
 Libint->vrr_classes[8][11] = int_stack + 104470;
 Libint->vrr_classes[8][12] = int_stack + 107980;
 Libint->vrr_classes[8][13] = int_stack + 112075;
 Libint->vrr_classes[8][14] = int_stack + 116800;
 Libint->vrr_classes[8][15] = int_stack + 122200;
 Libint->vrr_classes[8][16] = int_stack + 128320;
 Libint->vrr_classes[8][17] = int_stack + 135205;
 Libint->vrr_classes[8][18] = int_stack + 142900;
 memset(int_stack,0,151450*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 151450;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfmm(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+151450,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+154915,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+159073,int_stack+154915,int_stack+151450,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+166003,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+170917,int_stack+166003,int_stack+154915,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+179233,int_stack+170917,int_stack+159073,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+151450,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+190783,int_stack+151450,int_stack+166003,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+200611,int_stack+190783,int_stack+170917,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+157183,int_stack+200611,int_stack+179233,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+174508,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+214471,int_stack+174508,int_stack+151450,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+225937,int_stack+214471,int_stack+190783,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+242317,int_stack+225937,int_stack+200611,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+181123,int_stack+242317,int_stack+157183,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+151450,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+159010,int_stack+151450,int_stack+174508,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+263107,int_stack+159010,int_stack+214471,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+282217,int_stack+263107,int_stack+225937,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+205378,int_stack+282217,int_stack+242317,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+306787,int_stack+205378,int_stack+181123,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+172240,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+180808,int_stack+172240,int_stack+151450,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+234484,int_stack+180808,int_stack+159010,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+339127,int_stack+234484,int_stack+263107,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+367792,int_stack+339127,int_stack+282217,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+256534,int_stack+367792,int_stack+205378,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+402190,int_stack+256534,int_stack+306787,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+151450,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+195928,int_stack+151450,int_stack+172240,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+295342,int_stack+195928,int_stack+180808,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+161089,int_stack+295342,int_stack+234484,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+213064,int_stack+161089,int_stack+339127,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+320542,int_stack+213064,int_stack+367792,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+443770,int_stack+320542,int_stack+256534,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+493666,int_stack+443770,int_stack+402190,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+253195,int_stack+20475,int_stack+16884,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+263968,int_stack+253195,int_stack+151450,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+366406,int_stack+263968,int_stack+195928,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+253195,int_stack+366406,int_stack+295342,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+366406,int_stack+253195,int_stack+161089,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+253195,int_stack+366406,int_stack+213064,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+366406,int_stack+253195,int_stack+320542,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+151450,int_stack+366406,int_stack+443770,21);
 /*--- compute (h0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+213820,int_stack+151450,int_stack+493666,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+151450,int_stack+26005,int_stack+24465,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+156070,int_stack+27853,int_stack+26005,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+161614,int_stack+156070,int_stack+151450,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+170854,int_stack+30037,int_stack+27853,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+177406,int_stack+170854,int_stack+156070,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+188494,int_stack+177406,int_stack+161614,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+151450,int_stack+32585,int_stack+30037,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+277345,int_stack+151450,int_stack+170854,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+290449,int_stack+277345,int_stack+177406,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+159094,int_stack+290449,int_stack+188494,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+182194,int_stack+35525,int_stack+32585,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+191014,int_stack+182194,int_stack+151450,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+308929,int_stack+191014,int_stack+277345,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+330769,int_stack+308929,int_stack+290449,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+358489,int_stack+330769,int_stack+159094,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+277345,int_stack+38885,int_stack+35525,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+287425,int_stack+277345,int_stack+182194,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+151450,int_stack+287425,int_stack+191014,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+176930,int_stack+151450,int_stack+308929,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+390829,int_stack+176930,int_stack+330769,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+305065,int_stack+390829,int_stack+358489,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+348185,int_stack+42693,int_stack+38885,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+359609,int_stack+348185,int_stack+277345,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+429637,int_stack+359609,int_stack+287425,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+459037,int_stack+429637,int_stack+151450,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+497257,int_stack+459037,int_stack+176930,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+151450,int_stack+497257,int_stack+390829,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+543121,int_stack+151450,int_stack+305065,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+277345,int_stack+46977,int_stack+42693,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+290197,int_stack+277345,int_stack+348185,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+313045,int_stack+290197,int_stack+359609,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+346645,int_stack+313045,int_stack+429637,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+390745,int_stack+346645,int_stack+459037,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+598561,int_stack+390745,int_stack+497257,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+444253,int_stack+598561,int_stack+151450,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+659713,int_stack+444253,int_stack+543121,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+151450,int_stack+51765,int_stack+46977,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+165814,int_stack+151450,int_stack+277345,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+510781,int_stack+165814,int_stack+290197,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+151450,int_stack+510781,int_stack+313045,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+510781,int_stack+151450,int_stack+346645,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+277345,int_stack+510781,int_stack+390745,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+510781,int_stack+277345,int_stack+598561,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+277345,int_stack+510781,int_stack+444253,28);
 /*--- compute (i0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+360505,int_stack+277345,int_stack+659713,28);
 /*--- compute (hp|mm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+445205,int_stack+360505,int_stack+213820,3025);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+635780,int_stack+59065,int_stack+57085,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+641720,int_stack+61441,int_stack+59065,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+648848,int_stack+641720,int_stack+635780,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+660728,int_stack+64249,int_stack+61441,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+669152,int_stack+660728,int_stack+641720,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+683408,int_stack+669152,int_stack+648848,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+635780,int_stack+67525,int_stack+64249,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+703208,int_stack+635780,int_stack+660728,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+151450,int_stack+703208,int_stack+669152,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+645608,int_stack+151450,int_stack+683408,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+675308,int_stack+71305,int_stack+67525,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+175210,int_stack+675308,int_stack+635780,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+194866,int_stack+175210,int_stack+703208,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+686648,int_stack+194866,int_stack+151450,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+222946,int_stack+686648,int_stack+645608,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+151450,int_stack+75625,int_stack+71305,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+635780,int_stack+151450,int_stack+675308,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+264526,int_stack+635780,int_stack+175210,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+297286,int_stack+264526,int_stack+194866,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+164410,int_stack+297286,int_stack+686648,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+658460,int_stack+164410,int_stack+222946,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+214306,int_stack+80521,int_stack+75625,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+228994,int_stack+214306,int_stack+151450,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+228994,int_stack+635780,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+713900,int_stack+0,int_stack+264526,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+763040,int_stack+713900,int_stack+297286,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254914,int_stack+763040,int_stack+164410,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+822008,int_stack+254914,int_stack+658460,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+635780,int_stack+86029,int_stack+80521,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+652304,int_stack+635780,int_stack+214306,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+151450,int_stack+652304,int_stack+228994,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+194650,int_stack+151450,int_stack+0,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+194650,int_stack+713900,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+681680,int_stack+0,int_stack+763040,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+893288,int_stack+681680,int_stack+254914,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+251350,int_stack+893288,int_stack+822008,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+760304,int_stack+92185,int_stack+86029,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+778772,int_stack+760304,int_stack+635780,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+811820,int_stack+778772,int_stack+652304,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+978824,int_stack+811820,int_stack+151450,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+760304,int_stack+978824,int_stack+194650,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+151450,int_stack+760304,int_stack+0,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+760304,int_stack+151450,int_stack+681680,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+635780,int_stack+760304,int_stack+893288,36);
 /*--- compute (k0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+742700,int_stack+635780,int_stack+251350,36);
 /*--- compute (ip|mm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+851600,int_stack+742700,int_stack+360505,3025);
 /*--- compute (hd|mm) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1105700,int_stack+851600,int_stack+445205,3025);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+151450,int_stack+101500,int_stack+99025,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+158875,int_stack+104470,int_stack+101500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+167785,int_stack+158875,int_stack+151450,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+182635,int_stack+107980,int_stack+104470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+193165,int_stack+182635,int_stack+158875,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+210985,int_stack+193165,int_stack+167785,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+151450,int_stack+112075,int_stack+107980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+235735,int_stack+151450,int_stack+182635,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+256795,int_stack+235735,int_stack+193165,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+163735,int_stack+256795,int_stack+210985,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+200860,int_stack+116800,int_stack+112075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+286495,int_stack+200860,int_stack+151450,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+311065,int_stack+286495,int_stack+235735,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+346165,int_stack+311065,int_stack+256795,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+215035,int_stack+346165,int_stack+163735,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+151450,int_stack+122200,int_stack+116800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+167650,int_stack+151450,int_stack+200860,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+390715,int_stack+167650,int_stack+286495,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+431665,int_stack+390715,int_stack+311065,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+267010,int_stack+431665,int_stack+346165,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+484315,int_stack+267010,int_stack+215035,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+196000,int_stack+128320,int_stack+122200,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+214360,int_stack+196000,int_stack+151450,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+329380,int_stack+214360,int_stack+167650,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+553615,int_stack+329380,int_stack+390715,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+615040,int_stack+553615,int_stack+431665,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+376630,int_stack+615040,int_stack+267010,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+376630,int_stack+484315,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+151450,int_stack+135205,int_stack+128320,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+246760,int_stack+151450,int_stack+196000,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+459790,int_stack+246760,int_stack+214360,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+172105,int_stack+459790,int_stack+329380,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+283480,int_stack+172105,int_stack+553615,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+513790,int_stack+283480,int_stack+615040,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+612070,int_stack+513790,int_stack+376630,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1486850,int_stack+612070,int_stack+0,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+142900,int_stack+135205,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+23085,int_stack+0,int_stack+151450,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+64395,int_stack+23085,int_stack+246760,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+369475,int_stack+64395,int_stack+459790,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+369475,int_stack+172105,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+369475,int_stack+0,int_stack+283480,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+369475,int_stack+513790,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+126360,int_stack+0,int_stack+612070,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+260010,int_stack+126360,int_stack+1486850,45);
 /*--- compute (kp|mm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+396135,int_stack+260010,int_stack+742700,3025);
 /*--- compute (id|mm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1486850,int_stack+396135,int_stack+851600,3025);
 /*--- compute (hf|mm) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+1486850,int_stack+1105700,3025);
 return int_stack+0;}
