/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfmp(Libint_t*, prim_data*);

  /* Computes quartets of (hf|mp) integrals */

REALTYPE *hrr_order_hfmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[6][9] = int_stack + 2541;
 Libint->vrr_classes[6][10] = int_stack + 4081;
 Libint->vrr_classes[7][9] = int_stack + 5929;
 Libint->vrr_classes[7][10] = int_stack + 7909;
 Libint->vrr_classes[8][9] = int_stack + 10285;
 Libint->vrr_classes[8][10] = int_stack + 12760;
 memset(int_stack,0,15730*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 15730;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfmp(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+15730,int_stack+1155,int_stack+0,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19195,int_stack+4081,int_stack+2541,28);
 /*--- compute (hp|mp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+23815,int_stack+19195,int_stack+15730,165);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+34210,int_stack+7909,int_stack+5929,36);
 /*--- compute (ip|mp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+40150,int_stack+34210,int_stack+19195,165);
 /*--- compute (hd|mp) ---*/
 hrr1_build_hd(Libint->AB,int_stack+54010,int_stack+40150,int_stack+23815,165);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+15730,int_stack+12760,int_stack+10285,45);
 /*--- compute (kp|mp) ---*/
 hrr1_build_kp(Libint->AB,int_stack+74800,int_stack+15730,int_stack+34210,165);
 /*--- compute (id|mp) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+74800,int_stack+40150,165);
 /*--- compute (hf|mp) ---*/
 hrr1_build_hf(Libint->AB,int_stack+74800,int_stack+0,int_stack+54010,165);
 return int_stack+74800;}
