/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhki(Libint_t*, prim_data*);

  /* Computes quartets of (hh|ki) integrals */

REALTYPE *hrr_order_hhki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[6][7] = int_stack + 9996;
 Libint->vrr_classes[6][8] = int_stack + 11004;
 Libint->vrr_classes[6][9] = int_stack + 12264;
 Libint->vrr_classes[6][10] = int_stack + 13804;
 Libint->vrr_classes[6][11] = int_stack + 15652;
 Libint->vrr_classes[6][12] = int_stack + 17836;
 Libint->vrr_classes[6][13] = int_stack + 20384;
 Libint->vrr_classes[7][7] = int_stack + 23324;
 Libint->vrr_classes[7][8] = int_stack + 24620;
 Libint->vrr_classes[7][9] = int_stack + 26240;
 Libint->vrr_classes[7][10] = int_stack + 28220;
 Libint->vrr_classes[7][11] = int_stack + 30596;
 Libint->vrr_classes[7][12] = int_stack + 33404;
 Libint->vrr_classes[7][13] = int_stack + 36680;
 Libint->vrr_classes[8][7] = int_stack + 40460;
 Libint->vrr_classes[8][8] = int_stack + 42080;
 Libint->vrr_classes[8][9] = int_stack + 44105;
 Libint->vrr_classes[8][10] = int_stack + 46580;
 Libint->vrr_classes[8][11] = int_stack + 49550;
 Libint->vrr_classes[8][12] = int_stack + 53060;
 Libint->vrr_classes[8][13] = int_stack + 57155;
 Libint->vrr_classes[9][7] = int_stack + 61880;
 Libint->vrr_classes[9][8] = int_stack + 63860;
 Libint->vrr_classes[9][9] = int_stack + 66335;
 Libint->vrr_classes[9][10] = int_stack + 69360;
 Libint->vrr_classes[9][11] = int_stack + 72990;
 Libint->vrr_classes[9][12] = int_stack + 77280;
 Libint->vrr_classes[9][13] = int_stack + 82285;
 Libint->vrr_classes[10][7] = int_stack + 88060;
 Libint->vrr_classes[10][8] = int_stack + 90436;
 Libint->vrr_classes[10][9] = int_stack + 93406;
 Libint->vrr_classes[10][10] = int_stack + 97036;
 Libint->vrr_classes[10][11] = int_stack + 101392;
 Libint->vrr_classes[10][12] = int_stack + 106540;
 Libint->vrr_classes[10][13] = int_stack + 112546;
 memset(int_stack,0,119476*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 119476;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhki(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+119476,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+121744,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+124579,int_stack+121744,int_stack+119476,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129115,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+132580,int_stack+129115,int_stack+121744,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+138250,int_stack+132580,int_stack+124579,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119476,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+145810,int_stack+119476,int_stack+129115,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+152740,int_stack+145810,int_stack+132580,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+123634,int_stack+152740,int_stack+138250,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+134974,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162190,int_stack+134974,int_stack+119476,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+170506,int_stack+162190,int_stack+145810,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+182056,int_stack+170506,int_stack+152740,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+139888,int_stack+182056,int_stack+123634,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+119476,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+119476,int_stack+134974,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119476,int_stack+0,int_stack+162190,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+196231,int_stack+119476,int_stack+170506,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+119476,int_stack+196231,int_stack+182056,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+155764,int_stack+119476,int_stack+139888,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+119476,int_stack+11004,int_stack+9996,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+122500,int_stack+12264,int_stack+11004,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+126280,int_stack+122500,int_stack+119476,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+132328,int_stack+13804,int_stack+12264,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+136948,int_stack+132328,int_stack+122500,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+144508,int_stack+136948,int_stack+126280,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119476,int_stack+15652,int_stack+13804,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+119476,int_stack+132328,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+176932,int_stack+0,int_stack+136948,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+125020,int_stack+176932,int_stack+144508,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140140,int_stack+17836,int_stack+15652,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+189532,int_stack+140140,int_stack+119476,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+200620,int_stack+189532,int_stack+0,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+216020,int_stack+200620,int_stack+176932,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+234920,int_stack+216020,int_stack+125020,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+176932,int_stack+20384,int_stack+17836,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+176932,int_stack+140140,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119476,int_stack+0,int_stack+189532,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+119476,int_stack+200620,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+119476,int_stack+0,int_stack+216020,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+176932,int_stack+119476,int_stack+234920,28);
 /*--- compute (hp|ki) ---*/
 hrr1_build_hp(Libint->AB,int_stack+205156,int_stack+176932,int_stack+155764,1008);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+119476,int_stack+24620,int_stack+23324,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+123364,int_stack+26240,int_stack+24620,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+128224,int_stack+123364,int_stack+119476,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+136000,int_stack+28220,int_stack+26240,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+141940,int_stack+136000,int_stack+123364,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+151660,int_stack+141940,int_stack+128224,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119476,int_stack+30596,int_stack+28220,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+164620,int_stack+119476,int_stack+136000,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+164620,int_stack+141940,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+126604,int_stack+0,int_stack+151660,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+146044,int_stack+33404,int_stack+30596,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+16200,int_stack+146044,int_stack+119476,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+268660,int_stack+16200,int_stack+164620,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+288460,int_stack+268660,int_stack+0,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+312760,int_stack+288460,int_stack+126604,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+36680,int_stack+33404,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+119476,int_stack+0,int_stack+146044,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+136324,int_stack+119476,int_stack+16200,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+136324,int_stack+268660,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+119476,int_stack+0,int_stack+288460,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+119476,int_stack+312760,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+268660,int_stack+0,int_stack+176932,1008);
 /*--- compute (hd|ki) ---*/
 hrr1_build_hd(Libint->AB,int_stack+353332,int_stack+268660,int_stack+205156,1008);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+119476,int_stack+42080,int_stack+40460,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124336,int_stack+44105,int_stack+42080,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+130411,int_stack+124336,int_stack+119476,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+140131,int_stack+46580,int_stack+44105,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+147556,int_stack+140131,int_stack+124336,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+159706,int_stack+147556,int_stack+130411,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119476,int_stack+49550,int_stack+46580,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175906,int_stack+119476,int_stack+140131,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+190756,int_stack+175906,int_stack+147556,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+128386,int_stack+190756,int_stack+159706,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+152686,int_stack+53060,int_stack+49550,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+211006,int_stack+152686,int_stack+119476,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+228826,int_stack+211006,int_stack+175906,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+480340,int_stack+228826,int_stack+190756,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+163216,int_stack+480340,int_stack+128386,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+119476,int_stack+57155,int_stack+53060,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+36288,int_stack+119476,int_stack+152686,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119476,int_stack+36288,int_stack+211006,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+510715,int_stack+119476,int_stack+228826,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+119476,int_stack+510715,int_stack+480340,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+480340,int_stack+119476,int_stack+163216,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+119476,int_stack+480340,int_stack+0,1008);
 /*--- compute (id|ki) ---*/
 hrr1_build_id(Libint->AB,int_stack+525700,int_stack+119476,int_stack+268660,1008);
 /*--- compute (hf|ki) ---*/
 hrr1_build_hf(Libint->AB,int_stack+695044,int_stack+525700,int_stack+353332,1008);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+63860,int_stack+61880,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+66335,int_stack+63860,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+69360,int_stack+66335,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34320,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+49170,int_stack+34320,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+72990,int_stack+69360,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+228340,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+246490,int_stack+228340,int_stack+34320,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10890,int_stack+246490,int_stack+49170,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40590,int_stack+77280,int_stack+72990,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+53460,int_stack+40590,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+271240,int_stack+53460,int_stack+228340,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+301490,int_stack+271240,int_stack+246490,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+228340,int_stack+301490,int_stack+10890,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+82285,int_stack+77280,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+338615,int_stack+0,int_stack+40590,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+338615,int_stack+53460,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+338615,int_stack+0,int_stack+271240,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+338615,int_stack+301490,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+269920,int_stack+0,int_stack+228340,55);
 /*--- compute (lp|ki) ---*/
 hrr1_build_lp(Libint->AB,int_stack+325360,int_stack+269920,int_stack+480340,1008);
 /*--- compute (kd|ki) ---*/
 hrr1_build_kd(Libint->AB,int_stack+906724,int_stack+325360,int_stack+119476,1008);
 /*--- compute (if|ki) ---*/
 hrr1_build_if(Libint->AB,int_stack+1124452,int_stack+906724,int_stack+525700,1008);
 /*--- compute (hg|ki) ---*/
 hrr1_build_hg(Libint->AB,int_stack+1406692,int_stack+1124452,int_stack+695044,1008);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+119476,int_stack+90436,int_stack+88060,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+126604,int_stack+93406,int_stack+90436,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+135514,int_stack+126604,int_stack+119476,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+149770,int_stack+97036,int_stack+93406,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+160660,int_stack+149770,int_stack+126604,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+178480,int_stack+160660,int_stack+135514,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119476,int_stack+101392,int_stack+97036,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+202240,int_stack+119476,int_stack+149770,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+224020,int_stack+202240,int_stack+160660,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+132544,int_stack+224020,int_stack+178480,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+168184,int_stack+106540,int_stack+101392,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+168184,int_stack+119476,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26136,int_stack+0,int_stack+202240,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+461440,int_stack+26136,int_stack+224020,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+183628,int_stack+461440,int_stack+132544,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+119476,int_stack+112546,int_stack+106540,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+233524,int_stack+119476,int_stack+168184,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+62436,int_stack+233524,int_stack+0,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+105996,int_stack+62436,int_stack+26136,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+105996,int_stack+461440,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+461440,int_stack+0,int_stack+183628,66);
 /*--- compute (mp|ki) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+461440,int_stack+269920,1008);
 /*--- compute (ld|ki) ---*/
 hrr1_build_ld(Libint->AB,int_stack+461440,int_stack+0,int_stack+325360,1008);
 /*--- compute (kf|ki) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+461440,int_stack+906724,1008);
 /*--- compute (ig|ki) ---*/
 hrr1_build_ig(Libint->AB,int_stack+362880,int_stack+0,int_stack+1124452,1008);
 /*--- compute (hh|ki) ---*/
 hrr1_build_hh(Libint->AB,int_stack+786240,int_stack+362880,int_stack+1406692,1008);
 return int_stack+786240;}
