/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhlh(Libint_t*, prim_data*);

  /* Computes quartets of (hh|lh) integrals */

REALTYPE *hrr_order_hhlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[6][8] = int_stack + 9240;
 Libint->vrr_classes[6][9] = int_stack + 10500;
 Libint->vrr_classes[6][10] = int_stack + 12040;
 Libint->vrr_classes[6][11] = int_stack + 13888;
 Libint->vrr_classes[6][12] = int_stack + 16072;
 Libint->vrr_classes[6][13] = int_stack + 18620;
 Libint->vrr_classes[7][8] = int_stack + 21560;
 Libint->vrr_classes[7][9] = int_stack + 23180;
 Libint->vrr_classes[7][10] = int_stack + 25160;
 Libint->vrr_classes[7][11] = int_stack + 27536;
 Libint->vrr_classes[7][12] = int_stack + 30344;
 Libint->vrr_classes[7][13] = int_stack + 33620;
 Libint->vrr_classes[8][8] = int_stack + 37400;
 Libint->vrr_classes[8][9] = int_stack + 39425;
 Libint->vrr_classes[8][10] = int_stack + 41900;
 Libint->vrr_classes[8][11] = int_stack + 44870;
 Libint->vrr_classes[8][12] = int_stack + 48380;
 Libint->vrr_classes[8][13] = int_stack + 52475;
 Libint->vrr_classes[9][8] = int_stack + 57200;
 Libint->vrr_classes[9][9] = int_stack + 59675;
 Libint->vrr_classes[9][10] = int_stack + 62700;
 Libint->vrr_classes[9][11] = int_stack + 66330;
 Libint->vrr_classes[9][12] = int_stack + 70620;
 Libint->vrr_classes[9][13] = int_stack + 75625;
 Libint->vrr_classes[10][8] = int_stack + 81400;
 Libint->vrr_classes[10][9] = int_stack + 84370;
 Libint->vrr_classes[10][10] = int_stack + 88000;
 Libint->vrr_classes[10][11] = int_stack + 92356;
 Libint->vrr_classes[10][12] = int_stack + 97504;
 Libint->vrr_classes[10][13] = int_stack + 103510;
 memset(int_stack,0,110440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 110440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhlh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110440,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+113275,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+116740,int_stack+113275,int_stack+110440,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+122410,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126568,int_stack+122410,int_stack+113275,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+133498,int_stack+126568,int_stack+116740,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110440,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+142948,int_stack+110440,int_stack+122410,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+151264,int_stack+142948,int_stack+126568,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+115354,int_stack+151264,int_stack+133498,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+129529,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+162814,int_stack+129529,int_stack+110440,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+172642,int_stack+162814,int_stack+142948,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+129529,int_stack+172642,int_stack+151264,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+146854,int_stack+129529,int_stack+115354,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110440,int_stack+10500,int_stack+9240,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+114220,int_stack+12040,int_stack+10500,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+118840,int_stack+114220,int_stack+110440,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+126400,int_stack+13888,int_stack+12040,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131944,int_stack+126400,int_stack+114220,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+166699,int_stack+131944,int_stack+118840,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110440,int_stack+16072,int_stack+13888,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+110440,int_stack+126400,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+179299,int_stack+0,int_stack+131944,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+116992,int_stack+179299,int_stack+166699,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+166699,int_stack+18620,int_stack+16072,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+194699,int_stack+166699,int_stack+110440,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+207803,int_stack+194699,int_stack+0,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+226283,int_stack+207803,int_stack+179299,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+166699,int_stack+226283,int_stack+116992,28);
 /*--- compute (hp|lh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+193159,int_stack+166699,int_stack+146854,945);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+23180,int_stack+21560,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+25160,int_stack+23180,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10800,int_stack+4860,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+110440,int_stack+27536,int_stack+25160,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+117568,int_stack+110440,int_stack+4860,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+129448,int_stack+117568,int_stack+10800,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+30344,int_stack+27536,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+8424,int_stack+0,int_stack+110440,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+145648,int_stack+8424,int_stack+117568,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+252694,int_stack+145648,int_stack+129448,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110440,int_stack+33620,int_stack+30344,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+120268,int_stack+110440,int_stack+0,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+276994,int_stack+120268,int_stack+8424,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+276994,int_stack+145648,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+110440,int_stack+0,int_stack+252694,36);
 /*--- compute (ip|lh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+252694,int_stack+110440,int_stack+166699,945);
 /*--- compute (hd|lh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+332074,int_stack+252694,int_stack+193159,945);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+39425,int_stack+37400,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6075,int_stack+41900,int_stack+39425,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13500,int_stack+6075,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25650,int_stack+44870,int_stack+41900,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144460,int_stack+25650,int_stack+6075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+159310,int_stack+144460,int_stack+13500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+48380,int_stack+44870,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+179560,int_stack+0,int_stack+25650,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+10530,int_stack+179560,int_stack+144460,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+197380,int_stack+10530,int_stack+159310,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+144460,int_stack+52475,int_stack+48380,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+156745,int_stack+144460,int_stack+0,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+451144,int_stack+156745,int_stack+179560,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+144460,int_stack+451144,int_stack+10530,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+144460,int_stack+197380,45);
 /*--- compute (kp|lh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+144460,int_stack+0,int_stack+110440,945);
 /*--- compute (id|lh) ---*/
 hrr1_build_id(Libint->AB,int_stack+451144,int_stack+144460,int_stack+252694,945);
 /*--- compute (hf|lh) ---*/
 hrr1_build_hf(Libint->AB,int_stack+609904,int_stack+451144,int_stack+332074,945);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110440,int_stack+59675,int_stack+57200,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+117865,int_stack+62700,int_stack+59675,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+126940,int_stack+117865,int_stack+110440,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+246520,int_stack+66330,int_stack+62700,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+257410,int_stack+246520,int_stack+117865,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+275560,int_stack+257410,int_stack+126940,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110440,int_stack+70620,int_stack+66330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+300310,int_stack+110440,int_stack+246520,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+322090,int_stack+300310,int_stack+257410,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+352340,int_stack+322090,int_stack+275560,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+246520,int_stack+75625,int_stack+70620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+261535,int_stack+246520,int_stack+110440,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+389465,int_stack+261535,int_stack+300310,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+246520,int_stack+389465,int_stack+322090,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+389465,int_stack+246520,int_stack+352340,55);
 /*--- compute (lp|lh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+246520,int_stack+389465,int_stack+0,945);
 /*--- compute (kd|lh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+808354,int_stack+246520,int_stack+144460,945);
 /*--- compute (if|lh) ---*/
 hrr1_build_if(Libint->AB,int_stack+1012474,int_stack+808354,int_stack+451144,945);
 /*--- compute (hg|lh) ---*/
 hrr1_build_hg(Libint->AB,int_stack+1277074,int_stack+1012474,int_stack+609904,945);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+84370,int_stack+81400,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+88000,int_stack+84370,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+92356,int_stack+88000,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50688,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+441440,int_stack+50688,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+97504,int_stack+92356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+471140,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+497276,int_stack+471140,int_stack+50688,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15444,int_stack+497276,int_stack+441440,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+441440,int_stack+103510,int_stack+97504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+59994,int_stack+441440,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+90882,int_stack+59994,int_stack+471140,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+441440,int_stack+90882,int_stack+497276,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+59994,int_stack+441440,int_stack+15444,66);
 /*--- compute (mp|lh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+441440,int_stack+59994,int_stack+389465,945);
 /*--- compute (ld|lh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1574749,int_stack+441440,int_stack+246520,945);
 /*--- compute (kf|lh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+1574749,int_stack+808354,945);
 /*--- compute (ig|lh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+340200,int_stack+0,int_stack+1012474,945);
 /*--- compute (hh|lh) ---*/
 hrr1_build_hh(Libint->AB,int_stack+737100,int_stack+340200,int_stack+1277074,945);
 return int_stack+737100;}
