/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhmh(Libint_t*, prim_data*);

  /* Computes quartets of (hh|mh) integrals */

REALTYPE *hrr_order_hhmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[6][9] = int_stack + 10815;
 Libint->vrr_classes[6][10] = int_stack + 12355;
 Libint->vrr_classes[6][11] = int_stack + 14203;
 Libint->vrr_classes[6][12] = int_stack + 16387;
 Libint->vrr_classes[6][13] = int_stack + 18935;
 Libint->vrr_classes[6][14] = int_stack + 21875;
 Libint->vrr_classes[7][9] = int_stack + 25235;
 Libint->vrr_classes[7][10] = int_stack + 27215;
 Libint->vrr_classes[7][11] = int_stack + 29591;
 Libint->vrr_classes[7][12] = int_stack + 32399;
 Libint->vrr_classes[7][13] = int_stack + 35675;
 Libint->vrr_classes[7][14] = int_stack + 39455;
 Libint->vrr_classes[8][9] = int_stack + 43775;
 Libint->vrr_classes[8][10] = int_stack + 46250;
 Libint->vrr_classes[8][11] = int_stack + 49220;
 Libint->vrr_classes[8][12] = int_stack + 52730;
 Libint->vrr_classes[8][13] = int_stack + 56825;
 Libint->vrr_classes[8][14] = int_stack + 61550;
 Libint->vrr_classes[9][9] = int_stack + 66950;
 Libint->vrr_classes[9][10] = int_stack + 69975;
 Libint->vrr_classes[9][11] = int_stack + 73605;
 Libint->vrr_classes[9][12] = int_stack + 77895;
 Libint->vrr_classes[9][13] = int_stack + 82900;
 Libint->vrr_classes[9][14] = int_stack + 88675;
 Libint->vrr_classes[10][9] = int_stack + 95275;
 Libint->vrr_classes[10][10] = int_stack + 98905;
 Libint->vrr_classes[10][11] = int_stack + 103261;
 Libint->vrr_classes[10][12] = int_stack + 108409;
 Libint->vrr_classes[10][13] = int_stack + 114415;
 Libint->vrr_classes[10][14] = int_stack + 121345;
 memset(int_stack,0,129265*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 129265;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhmh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129265,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+132730,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+136888,int_stack+132730,int_stack+129265,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+143818,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+148732,int_stack+143818,int_stack+132730,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+157048,int_stack+148732,int_stack+136888,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+129265,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168598,int_stack+129265,int_stack+143818,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+178426,int_stack+168598,int_stack+148732,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+134998,int_stack+178426,int_stack+157048,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+152323,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+192286,int_stack+152323,int_stack+129265,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+203752,int_stack+192286,int_stack+168598,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+152323,int_stack+203752,int_stack+178426,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+173113,int_stack+152323,int_stack+134998,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129265,int_stack+12355,int_stack+10815,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133885,int_stack+14203,int_stack+12355,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139429,int_stack+133885,int_stack+129265,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+148669,int_stack+16387,int_stack+14203,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+155221,int_stack+148669,int_stack+133885,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+197368,int_stack+155221,int_stack+139429,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+129265,int_stack+18935,int_stack+16387,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+129265,int_stack+148669,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+212768,int_stack+0,int_stack+155221,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+136909,int_stack+212768,int_stack+197368,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+197368,int_stack+21875,int_stack+18935,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+231248,int_stack+197368,int_stack+129265,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+246536,int_stack+231248,int_stack+0,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+268376,int_stack+246536,int_stack+212768,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+197368,int_stack+268376,int_stack+136909,28);
 /*--- compute (hp|mh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+229708,int_stack+197368,int_stack+173113,1155);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+27215,int_stack+25235,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5940,int_stack+29591,int_stack+27215,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13068,int_stack+5940,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+129265,int_stack+32399,int_stack+29591,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+137689,int_stack+129265,int_stack+5940,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+151945,int_stack+137689,int_stack+13068,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+35675,int_stack+32399,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+129265,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+171745,int_stack+9828,int_stack+137689,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+302473,int_stack+171745,int_stack+151945,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+129265,int_stack+39455,int_stack+35675,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+140605,int_stack+129265,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+332173,int_stack+140605,int_stack+9828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+332173,int_stack+171745,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+129265,int_stack+0,int_stack+302473,36);
 /*--- compute (ip|mh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+302473,int_stack+129265,int_stack+197368,1155);
 /*--- compute (hd|mh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+399493,int_stack+302473,int_stack+229708,1155);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+46250,int_stack+43775,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+49220,int_stack+46250,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+31185,int_stack+52730,int_stack+49220,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+170845,int_stack+31185,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+188665,int_stack+170845,int_stack+16335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+56825,int_stack+52730,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+213415,int_stack+0,int_stack+31185,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12285,int_stack+213415,int_stack+170845,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+234475,int_stack+12285,int_stack+188665,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170845,int_stack+61550,int_stack+56825,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+185020,int_stack+170845,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+545023,int_stack+185020,int_stack+213415,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+170845,int_stack+545023,int_stack+12285,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+170845,int_stack+234475,45);
 /*--- compute (kp|mh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+170845,int_stack+0,int_stack+129265,1155);
 /*--- compute (id|mh) ---*/
 hrr1_build_id(Libint->AB,int_stack+545023,int_stack+170845,int_stack+302473,1155);
 /*--- compute (hf|mh) ---*/
 hrr1_build_hf(Libint->AB,int_stack+739063,int_stack+545023,int_stack+399493,1155);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129265,int_stack+69975,int_stack+66950,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+138340,int_stack+73605,int_stack+69975,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+149230,int_stack+138340,int_stack+129265,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+295585,int_stack+77895,int_stack+73605,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+308455,int_stack+295585,int_stack+138340,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+330235,int_stack+308455,int_stack+149230,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+129265,int_stack+82900,int_stack+77895,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+144280,int_stack+129265,int_stack+295585,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+360485,int_stack+144280,int_stack+308455,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+396785,int_stack+360485,int_stack+330235,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+295585,int_stack+88675,int_stack+82900,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+312910,int_stack+295585,int_stack+129265,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+442160,int_stack+312910,int_stack+144280,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+295585,int_stack+442160,int_stack+360485,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+442160,int_stack+295585,int_stack+396785,55);
 /*--- compute (lp|mh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+981613,int_stack+442160,int_stack+0,1155);
 /*--- compute (kd|mh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1137538,int_stack+981613,int_stack+170845,1155);
 /*--- compute (if|mh) ---*/
 hrr1_build_if(Libint->AB,int_stack+1387018,int_stack+1137538,int_stack+545023,1155);
 /*--- compute (hg|mh) ---*/
 hrr1_build_hg(Libint->AB,int_stack+1710418,int_stack+1387018,int_stack+739063,1155);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+98905,int_stack+95275,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+103261,int_stack+98905,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+108409,int_stack+103261,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+61182,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+505685,int_stack+61182,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+114415,int_stack+108409,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+541985,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+572873,int_stack+541985,int_stack+61182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+18018,int_stack+572873,int_stack+505685,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+505685,int_stack+121345,int_stack+114415,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+72468,int_stack+505685,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+108504,int_stack+72468,int_stack+541985,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+505685,int_stack+108504,int_stack+572873,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+72468,int_stack+505685,int_stack+18018,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+505685,int_stack+72468,int_stack+442160,1155);
 /*--- compute (ld|mh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+505685,int_stack+981613,1155);
 /*--- compute (kf|mh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+311850,int_stack+0,int_stack+1137538,1155);
 /*--- compute (ig|mh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+727650,int_stack+311850,int_stack+1387018,1155);
 /*--- compute (hh|mh) ---*/
 hrr1_build_hh(Libint->AB,int_stack+0,int_stack+727650,int_stack+1710418,1155);
 return int_stack+0;}
