/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpmh(Libint_t*, prim_data*);

  /* Computes quartets of (hp|mh) integrals */

REALTYPE *hrr_order_hpmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[6][9] = int_stack + 10815;
 Libint->vrr_classes[6][10] = int_stack + 12355;
 Libint->vrr_classes[6][11] = int_stack + 14203;
 Libint->vrr_classes[6][12] = int_stack + 16387;
 Libint->vrr_classes[6][13] = int_stack + 18935;
 Libint->vrr_classes[6][14] = int_stack + 21875;
 memset(int_stack,0,25235*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 25235;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpmh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25235,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28700,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+32858,int_stack+28700,int_stack+25235,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39788,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+44702,int_stack+39788,int_stack+28700,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+53018,int_stack+44702,int_stack+32858,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+25235,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+64568,int_stack+25235,int_stack+39788,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+74396,int_stack+64568,int_stack+44702,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+30968,int_stack+74396,int_stack+53018,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+48293,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+88256,int_stack+48293,int_stack+25235,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+99722,int_stack+88256,int_stack+64568,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+48293,int_stack+99722,int_stack+74396,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+69083,int_stack+48293,int_stack+30968,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25235,int_stack+12355,int_stack+10815,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29855,int_stack+14203,int_stack+12355,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+35399,int_stack+29855,int_stack+25235,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+44639,int_stack+16387,int_stack+14203,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51191,int_stack+44639,int_stack+29855,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+93338,int_stack+51191,int_stack+35399,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+25235,int_stack+18935,int_stack+16387,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+25235,int_stack+44639,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+108738,int_stack+0,int_stack+51191,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32879,int_stack+108738,int_stack+93338,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+93338,int_stack+21875,int_stack+18935,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+127218,int_stack+93338,int_stack+25235,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+142506,int_stack+127218,int_stack+0,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+142506,int_stack+108738,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+93338,int_stack+0,int_stack+32879,28);
 /*--- compute (hp|mh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+125678,int_stack+93338,int_stack+69083,1155);
 return int_stack+125678;}
