/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idif(Libint_t*, prim_data*);

  /* Computes quartets of (id|if) integrals */

REALTYPE *hrr_order_idif(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[7][6] = int_stack + 4592;
 Libint->vrr_classes[7][7] = int_stack + 5600;
 Libint->vrr_classes[7][8] = int_stack + 6896;
 Libint->vrr_classes[7][9] = int_stack + 8516;
 Libint->vrr_classes[8][6] = int_stack + 10496;
 Libint->vrr_classes[8][7] = int_stack + 11756;
 Libint->vrr_classes[8][8] = int_stack + 13376;
 Libint->vrr_classes[8][9] = int_stack + 15401;
 memset(int_stack,0,17876*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 17876;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idif(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+17876,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+20228,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+23252,int_stack+20228,int_stack+17876,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27956,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+31736,int_stack+27956,int_stack+20228,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+37784,int_stack+31736,int_stack+23252,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+17876,int_stack+5600,int_stack+4592,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+20900,int_stack+6896,int_stack+5600,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+24788,int_stack+20900,int_stack+17876,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30836,int_stack+8516,int_stack+6896,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+30836,int_stack+20900,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+45624,int_stack+0,int_stack+24788,36);
 /*--- compute (ip|if) ---*/
 hrr1_build_ip(Libint->AB,int_stack+55704,int_stack+45624,int_stack+37784,280);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+11756,int_stack+10496,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3780,int_stack+13376,int_stack+11756,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+17876,int_stack+3780,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+25436,int_stack+15401,int_stack+13376,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+31511,int_stack+25436,int_stack+3780,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+31511,int_stack+17876,45);
 /*--- compute (kp|if) ---*/
 hrr1_build_kp(Libint->AB,int_stack+12600,int_stack+0,int_stack+45624,280);
 /*--- compute (id|if) ---*/
 hrr1_build_id(Libint->AB,int_stack+79224,int_stack+12600,int_stack+55704,280);
 return int_stack+79224;}
