/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ighh(Libint_t*, prim_data*);

  /* Computes quartets of (ig|hh) integrals */

REALTYPE *hrr_order_ighh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][5] = int_stack + 0;
 Libint->vrr_classes[6][6] = int_stack + 588;
 Libint->vrr_classes[6][7] = int_stack + 1372;
 Libint->vrr_classes[6][8] = int_stack + 2380;
 Libint->vrr_classes[6][9] = int_stack + 3640;
 Libint->vrr_classes[6][10] = int_stack + 5180;
 Libint->vrr_classes[7][5] = int_stack + 7028;
 Libint->vrr_classes[7][6] = int_stack + 7784;
 Libint->vrr_classes[7][7] = int_stack + 8792;
 Libint->vrr_classes[7][8] = int_stack + 10088;
 Libint->vrr_classes[7][9] = int_stack + 11708;
 Libint->vrr_classes[7][10] = int_stack + 13688;
 Libint->vrr_classes[8][5] = int_stack + 16064;
 Libint->vrr_classes[8][6] = int_stack + 17009;
 Libint->vrr_classes[8][7] = int_stack + 18269;
 Libint->vrr_classes[8][8] = int_stack + 19889;
 Libint->vrr_classes[8][9] = int_stack + 21914;
 Libint->vrr_classes[8][10] = int_stack + 24389;
 Libint->vrr_classes[9][5] = int_stack + 27359;
 Libint->vrr_classes[9][6] = int_stack + 28514;
 Libint->vrr_classes[9][7] = int_stack + 30054;
 Libint->vrr_classes[9][8] = int_stack + 32034;
 Libint->vrr_classes[9][9] = int_stack + 34509;
 Libint->vrr_classes[9][10] = int_stack + 37534;
 Libint->vrr_classes[10][5] = int_stack + 41164;
 Libint->vrr_classes[10][6] = int_stack + 42550;
 Libint->vrr_classes[10][7] = int_stack + 44398;
 Libint->vrr_classes[10][8] = int_stack + 46774;
 Libint->vrr_classes[10][9] = int_stack + 49744;
 Libint->vrr_classes[10][10] = int_stack + 53374;
 memset(int_stack,0,57730*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 57730;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ighh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+57730,int_stack+588,int_stack+0,28);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+59494,int_stack+1372,int_stack+588,28);
 /*--- compute (i0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+61846,int_stack+59494,int_stack+57730,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+65374,int_stack+2380,int_stack+1372,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+68398,int_stack+65374,int_stack+59494,28);
 /*--- compute (i0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+73102,int_stack+68398,int_stack+61846,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57730,int_stack+3640,int_stack+2380,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+78982,int_stack+57730,int_stack+65374,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+85030,int_stack+78982,int_stack+68398,28);
 /*--- compute (i0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+61510,int_stack+85030,int_stack+73102,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+70330,int_stack+5180,int_stack+3640,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+92870,int_stack+70330,int_stack+57730,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+100430,int_stack+92870,int_stack+78982,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+70330,int_stack+100430,int_stack+85030,28);
 /*--- compute (i0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+82090,int_stack+70330,int_stack+61510,28);
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+57730,int_stack+7784,int_stack+7028,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+59998,int_stack+8792,int_stack+7784,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+63022,int_stack+59998,int_stack+57730,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+67558,int_stack+10088,int_stack+8792,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+71446,int_stack+67558,int_stack+59998,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+94438,int_stack+71446,int_stack+63022,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57730,int_stack+11708,int_stack+10088,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+101998,int_stack+57730,int_stack+67558,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+101998,int_stack+71446,36);
 /*--- compute (k0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+62590,int_stack+0,int_stack+94438,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94438,int_stack+13688,int_stack+11708,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+109774,int_stack+94438,int_stack+57730,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+119494,int_stack+109774,int_stack+101998,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+94438,int_stack+119494,int_stack+0,36);
 /*--- compute (k0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+0,int_stack+94438,int_stack+62590,36);
 /*--- compute (ip|hh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+94438,int_stack+0,int_stack+82090,441);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+57730,int_stack+17009,int_stack+16064,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+60565,int_stack+18269,int_stack+17009,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+64345,int_stack+60565,int_stack+57730,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+70015,int_stack+19889,int_stack+18269,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+74875,int_stack+70015,int_stack+60565,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+82435,int_stack+74875,int_stack+64345,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57730,int_stack+21914,int_stack+19889,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+131482,int_stack+57730,int_stack+70015,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+141202,int_stack+131482,int_stack+74875,45);
 /*--- compute (l0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+63805,int_stack+141202,int_stack+82435,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+77980,int_stack+24389,int_stack+21914,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+153802,int_stack+77980,int_stack+57730,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+77980,int_stack+153802,int_stack+131482,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+153802,int_stack+77980,int_stack+141202,45);
 /*--- compute (l0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+131482,int_stack+153802,int_stack+63805,45);
 /*--- compute (kp|hh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+151327,int_stack+131482,int_stack+0,441);
 /*--- compute (id|hh) ---*/
 hrr1_build_id(Libint->AB,int_stack+198955,int_stack+151327,int_stack+94438,441);
 /*--- compute (m0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+0,int_stack+28514,int_stack+27359,55);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+3465,int_stack+30054,int_stack+28514,55);
 /*--- compute (m0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+8085,int_stack+3465,int_stack+0,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+15015,int_stack+32034,int_stack+30054,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+20955,int_stack+15015,int_stack+3465,55);
 /*--- compute (m0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+57730,int_stack+20955,int_stack+8085,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+34509,int_stack+32034,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+69280,int_stack+0,int_stack+15015,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+81160,int_stack+69280,int_stack+20955,55);
 /*--- compute (m0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+7425,int_stack+81160,int_stack+57730,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57730,int_stack+37534,int_stack+34509,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+24750,int_stack+57730,int_stack+0,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+96560,int_stack+24750,int_stack+69280,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+57730,int_stack+96560,int_stack+81160,55);
 /*--- compute (m0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+80830,int_stack+57730,int_stack+7425,55);
 /*--- compute (lp|hh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+273043,int_stack+80830,int_stack+131482,441);
 /*--- compute (kd|hh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+332578,int_stack+273043,int_stack+151327,441);
 /*--- compute (if|hh) ---*/
 hrr1_build_if(Libint->AB,int_stack+427834,int_stack+332578,int_stack+198955,441);
 /*--- compute (n0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+57730,int_stack+42550,int_stack+41164,66);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+61888,int_stack+44398,int_stack+42550,66);
 /*--- compute (n0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+67432,int_stack+61888,int_stack+57730,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+46774,int_stack+44398,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+7128,int_stack+0,int_stack+61888,66);
 /*--- compute (n0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+18216,int_stack+7128,int_stack+67432,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57730,int_stack+49744,int_stack+46774,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32076,int_stack+57730,int_stack+0,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+105085,int_stack+32076,int_stack+7128,66);
 /*--- compute (n0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+123565,int_stack+105085,int_stack+18216,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+53374,int_stack+49744,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10890,int_stack+0,int_stack+57730,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+46332,int_stack+10890,int_stack+32076,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+0,int_stack+46332,int_stack+105085,66);
 /*--- compute (n0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+27720,int_stack+0,int_stack+123565,66);
 /*--- compute (mp|hh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+105085,int_stack+27720,int_stack+80830,441);
 /*--- compute (ld|hh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+551314,int_stack+105085,int_stack+273043,441);
 /*--- compute (kf|hh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+551314,int_stack+332578,441);
 /*--- compute (ig|hh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+158760,int_stack+0,int_stack+427834,441);
 return int_stack+158760;}
