/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iglg(Libint_t*, prim_data*);

  /* Computes quartets of (ig|lg) integrals */

REALTYPE *hrr_order_iglg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[7][8] = int_stack + 9380;
 Libint->vrr_classes[7][9] = int_stack + 11000;
 Libint->vrr_classes[7][10] = int_stack + 12980;
 Libint->vrr_classes[7][11] = int_stack + 15356;
 Libint->vrr_classes[7][12] = int_stack + 18164;
 Libint->vrr_classes[8][8] = int_stack + 21440;
 Libint->vrr_classes[8][9] = int_stack + 23465;
 Libint->vrr_classes[8][10] = int_stack + 25940;
 Libint->vrr_classes[8][11] = int_stack + 28910;
 Libint->vrr_classes[8][12] = int_stack + 32420;
 Libint->vrr_classes[9][8] = int_stack + 36515;
 Libint->vrr_classes[9][9] = int_stack + 38990;
 Libint->vrr_classes[9][10] = int_stack + 42015;
 Libint->vrr_classes[9][11] = int_stack + 45645;
 Libint->vrr_classes[9][12] = int_stack + 49935;
 Libint->vrr_classes[10][8] = int_stack + 54940;
 Libint->vrr_classes[10][9] = int_stack + 57910;
 Libint->vrr_classes[10][10] = int_stack + 61540;
 Libint->vrr_classes[10][11] = int_stack + 65896;
 Libint->vrr_classes[10][12] = int_stack + 71044;
 memset(int_stack,0,77050*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 77050;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iglg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+77050,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+80830,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+85450,int_stack+80830,int_stack+77050,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+93010,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+98554,int_stack+93010,int_stack+80830,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107794,int_stack+98554,int_stack+85450,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77050,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120394,int_stack+77050,int_stack+93010,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+77050,int_stack+120394,int_stack+98554,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+120394,int_stack+77050,int_stack+107794,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+77050,int_stack+11000,int_stack+9380,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+81910,int_stack+12980,int_stack+11000,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+87850,int_stack+81910,int_stack+77050,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+97570,int_stack+15356,int_stack+12980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+104698,int_stack+97570,int_stack+81910,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+139294,int_stack+104698,int_stack+87850,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77050,int_stack+18164,int_stack+15356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+77050,int_stack+97570,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+77050,int_stack+0,int_stack+104698,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+155494,int_stack+77050,int_stack+139294,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+179794,int_stack+155494,int_stack+120394,675);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+77050,int_stack+23465,int_stack+21440,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+83125,int_stack+25940,int_stack+23465,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+90550,int_stack+83125,int_stack+77050,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+102700,int_stack+28910,int_stack+25940,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+111610,int_stack+102700,int_stack+83125,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+126460,int_stack+111610,int_stack+90550,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77050,int_stack+32420,int_stack+28910,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+77050,int_stack+102700,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+77050,int_stack+0,int_stack+111610,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+77050,int_stack+126460,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+77050,int_stack+0,int_stack+155494,675);
 /*--- compute (id|lg) ---*/
 hrr1_build_id(Libint->AB,int_stack+236494,int_stack+77050,int_stack+179794,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+149950,int_stack+38990,int_stack+36515,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+157375,int_stack+42015,int_stack+38990,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+166450,int_stack+157375,int_stack+149950,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181300,int_stack+45645,int_stack+42015,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+192190,int_stack+181300,int_stack+157375,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+210340,int_stack+192190,int_stack+166450,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+149950,int_stack+49935,int_stack+45645,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30375,int_stack+149950,int_stack+181300,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+149950,int_stack+30375,int_stack+192190,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+349894,int_stack+149950,int_stack+210340,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+387019,int_stack+349894,int_stack+0,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+478144,int_stack+387019,int_stack+77050,675);
 /*--- compute (if|lg) ---*/
 hrr1_build_if(Libint->AB,int_stack+623944,int_stack+478144,int_stack+236494,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+77050,int_stack+57910,int_stack+54940,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+85960,int_stack+61540,int_stack+57910,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+96850,int_stack+85960,int_stack+77050,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+114670,int_stack+65896,int_stack+61540,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+127738,int_stack+114670,int_stack+85960,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+149518,int_stack+127738,int_stack+96850,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77050,int_stack+71044,int_stack+65896,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+179218,int_stack+77050,int_stack+114670,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+205354,int_stack+179218,int_stack+127738,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+241654,int_stack+205354,int_stack+149518,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+241654,int_stack+349894,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+111375,int_stack+0,int_stack+387019,675);
 /*--- compute (kf|lg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+812944,int_stack+111375,int_stack+478144,675);
 /*--- compute (ig|lg) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+812944,int_stack+623944,675);
 return int_stack+0;}
