/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igmf(Libint_t*, prim_data*);

  /* Computes quartets of (ig|mf) integrals */

REALTYPE *hrr_order_igmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[7][9] = int_stack + 8120;
 Libint->vrr_classes[7][10] = int_stack + 10100;
 Libint->vrr_classes[7][11] = int_stack + 12476;
 Libint->vrr_classes[7][12] = int_stack + 15284;
 Libint->vrr_classes[8][9] = int_stack + 18560;
 Libint->vrr_classes[8][10] = int_stack + 21035;
 Libint->vrr_classes[8][11] = int_stack + 24005;
 Libint->vrr_classes[8][12] = int_stack + 27515;
 Libint->vrr_classes[9][9] = int_stack + 31610;
 Libint->vrr_classes[9][10] = int_stack + 34635;
 Libint->vrr_classes[9][11] = int_stack + 38265;
 Libint->vrr_classes[9][12] = int_stack + 42555;
 Libint->vrr_classes[10][9] = int_stack + 47560;
 Libint->vrr_classes[10][10] = int_stack + 51190;
 Libint->vrr_classes[10][11] = int_stack + 55546;
 Libint->vrr_classes[10][12] = int_stack + 60694;
 memset(int_stack,0,66700*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 66700;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igmf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66700,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71320,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+76864,int_stack+71320,int_stack+66700,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+86104,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+92656,int_stack+86104,int_stack+71320,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103744,int_stack+92656,int_stack+76864,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66700,int_stack+10100,int_stack+8120,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+72640,int_stack+12476,int_stack+10100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+79768,int_stack+72640,int_stack+66700,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+91648,int_stack+15284,int_stack+12476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+91648,int_stack+72640,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+119144,int_stack+0,int_stack+79768,36);
 /*--- compute (ip|mf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+138944,int_stack+119144,int_stack+103744,550);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+21035,int_stack+18560,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+24005,int_stack+21035,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66700,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81550,int_stack+27515,int_stack+24005,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+92080,int_stack+81550,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+92080,int_stack+66700,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+185144,int_stack+0,int_stack+119144,550);
 /*--- compute (id|mf) ---*/
 hrr1_build_id(Libint->AB,int_stack+244544,int_stack+185144,int_stack+138944,550);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66700,int_stack+34635,int_stack+31610,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75775,int_stack+38265,int_stack+34635,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+86665,int_stack+75775,int_stack+66700,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+104815,int_stack+42555,int_stack+38265,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+117685,int_stack+104815,int_stack+75775,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+139465,int_stack+117685,int_stack+86665,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+336944,int_stack+139465,int_stack+0,550);
 /*--- compute (kd|mf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+411194,int_stack+336944,int_stack+185144,550);
 /*--- compute (if|mf) ---*/
 hrr1_build_if(Libint->AB,int_stack+529994,int_stack+411194,int_stack+244544,550);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+51190,int_stack+47560,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+55546,int_stack+51190,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66700,int_stack+60694,int_stack+55546,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+82144,int_stack+66700,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+45738,int_stack+82144,int_stack+23958,66);
 /*--- compute (mp|mf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+169715,int_stack+45738,int_stack+139465,550);
 /*--- compute (ld|mf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+169715,int_stack+336944,550);
 /*--- compute (kf|mf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+148500,int_stack+0,int_stack+411194,550);
 /*--- compute (ig|mf) ---*/
 hrr1_build_ig(Libint->AB,int_stack+683994,int_stack+148500,int_stack+529994,550);
 return int_stack+683994;}
