/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igmk(Libint_t*, prim_data*);

  /* Computes quartets of (ig|mk) integrals */

REALTYPE *hrr_order_igmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[6][15] = int_stack + 14420;
 Libint->vrr_classes[6][16] = int_stack + 18228;
 Libint->vrr_classes[7][9] = int_stack + 22512;
 Libint->vrr_classes[7][10] = int_stack + 24492;
 Libint->vrr_classes[7][11] = int_stack + 26868;
 Libint->vrr_classes[7][12] = int_stack + 29676;
 Libint->vrr_classes[7][13] = int_stack + 32952;
 Libint->vrr_classes[7][14] = int_stack + 36732;
 Libint->vrr_classes[7][15] = int_stack + 41052;
 Libint->vrr_classes[7][16] = int_stack + 45948;
 Libint->vrr_classes[8][9] = int_stack + 51456;
 Libint->vrr_classes[8][10] = int_stack + 53931;
 Libint->vrr_classes[8][11] = int_stack + 56901;
 Libint->vrr_classes[8][12] = int_stack + 60411;
 Libint->vrr_classes[8][13] = int_stack + 64506;
 Libint->vrr_classes[8][14] = int_stack + 69231;
 Libint->vrr_classes[8][15] = int_stack + 74631;
 Libint->vrr_classes[8][16] = int_stack + 80751;
 Libint->vrr_classes[9][9] = int_stack + 87636;
 Libint->vrr_classes[9][10] = int_stack + 90661;
 Libint->vrr_classes[9][11] = int_stack + 94291;
 Libint->vrr_classes[9][12] = int_stack + 98581;
 Libint->vrr_classes[9][13] = int_stack + 103586;
 Libint->vrr_classes[9][14] = int_stack + 109361;
 Libint->vrr_classes[9][15] = int_stack + 115961;
 Libint->vrr_classes[9][16] = int_stack + 123441;
 Libint->vrr_classes[10][9] = int_stack + 131856;
 Libint->vrr_classes[10][10] = int_stack + 135486;
 Libint->vrr_classes[10][11] = int_stack + 139842;
 Libint->vrr_classes[10][12] = int_stack + 144990;
 Libint->vrr_classes[10][13] = int_stack + 150996;
 Libint->vrr_classes[10][14] = int_stack + 157926;
 Libint->vrr_classes[10][15] = int_stack + 165846;
 Libint->vrr_classes[10][16] = int_stack + 174822;
 memset(int_stack,0,184920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 184920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igmk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+184920,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+189540,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+195084,int_stack+189540,int_stack+184920,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+204324,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210876,int_stack+204324,int_stack+189540,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+221964,int_stack+210876,int_stack+195084,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+184920,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+237364,int_stack+184920,int_stack+204324,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+250468,int_stack+237364,int_stack+210876,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+192564,int_stack+250468,int_stack+221964,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+215664,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+268948,int_stack+215664,int_stack+184920,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+284236,int_stack+268948,int_stack+237364,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+306076,int_stack+284236,int_stack+250468,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+224484,int_stack+306076,int_stack+192564,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+184920,int_stack+14420,int_stack+11060,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+195000,int_stack+184920,int_stack+215664,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+333796,int_stack+195000,int_stack+268948,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+359276,int_stack+333796,int_stack+284236,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+256824,int_stack+359276,int_stack+306076,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+392036,int_stack+256824,int_stack+224484,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+212640,int_stack+18228,int_stack+14420,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+224064,int_stack+212640,int_stack+184920,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+295632,int_stack+224064,int_stack+195000,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+184920,int_stack+295632,int_stack+333796,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+295632,int_stack+184920,int_stack+359276,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+184920,int_stack+295632,int_stack+256824,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+236664,int_stack+184920,int_stack+392036,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+184920,int_stack+24492,int_stack+22512,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+190860,int_stack+26868,int_stack+24492,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+197988,int_stack+190860,int_stack+184920,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+209868,int_stack+29676,int_stack+26868,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+218292,int_stack+209868,int_stack+190860,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+292104,int_stack+218292,int_stack+197988,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+184920,int_stack+32952,int_stack+29676,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+311904,int_stack+184920,int_stack+209868,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+328752,int_stack+311904,int_stack+218292,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+194748,int_stack+328752,int_stack+292104,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+292104,int_stack+36732,int_stack+32952,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+352512,int_stack+292104,int_stack+184920,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+372168,int_stack+352512,int_stack+311904,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+400248,int_stack+372168,int_stack+328752,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+303444,int_stack+400248,int_stack+194748,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+184920,int_stack+41052,int_stack+36732,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+184920,int_stack+292104,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+197880,int_stack+352512,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+435888,int_stack+0,int_stack+372168,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+345024,int_stack+435888,int_stack+400248,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+478008,int_stack+345024,int_stack+303444,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+292104,int_stack+45948,int_stack+41052,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+306792,int_stack+292104,int_stack+184920,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+394920,int_stack+306792,int_stack+197880,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+184920,int_stack+394920,int_stack+0,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+533448,int_stack+184920,int_stack+435888,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+394920,int_stack+533448,int_stack+345024,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+292104,int_stack+394920,int_stack+478008,36);
 /*--- compute (ip|mk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+363384,int_stack+292104,int_stack+236664,1980);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+184920,int_stack+53931,int_stack+51456,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+192345,int_stack+56901,int_stack+53931,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+201255,int_stack+192345,int_stack+184920,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+216105,int_stack+60411,int_stack+56901,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+226635,int_stack+216105,int_stack+192345,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+244455,int_stack+226635,int_stack+201255,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+184920,int_stack+64506,int_stack+60411,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+269205,int_stack+184920,int_stack+216105,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+269205,int_stack+226635,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+197205,int_stack+0,int_stack+244455,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+234330,int_stack+69231,int_stack+64506,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+29700,int_stack+234330,int_stack+184920,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+529704,int_stack+29700,int_stack+269205,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+564804,int_stack+529704,int_stack+0,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+609354,int_stack+564804,int_stack+197205,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+74631,int_stack+69231,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+184920,int_stack+0,int_stack+234330,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+213270,int_stack+184920,int_stack+29700,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16200,int_stack+213270,int_stack+529704,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+661329,int_stack+16200,int_stack+564804,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+529704,int_stack+661329,int_stack+609354,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+599004,int_stack+80751,int_stack+74631,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+617364,int_stack+599004,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+723699,int_stack+617364,int_stack+184920,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+599004,int_stack+723699,int_stack+213270,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+184920,int_stack+599004,int_stack+16200,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+184920,int_stack+661329,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+184920,int_stack+0,int_stack+529704,45);
 /*--- compute (kp|mk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+529704,int_stack+184920,int_stack+292104,1980);
 /*--- compute (id|mk) ---*/
 hrr1_build_id(Libint->AB,int_stack+743544,int_stack+529704,int_stack+363384,1980);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+90661,int_stack+87636,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+94291,int_stack+90661,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38115,int_stack+98581,int_stack+94291,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+50985,int_stack+38115,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+274020,int_stack+50985,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+103586,int_stack+98581,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72765,int_stack+0,int_stack+38115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+304270,int_stack+72765,int_stack+50985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+15015,int_stack+304270,int_stack+274020,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274020,int_stack+109361,int_stack+103586,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+340570,int_stack+274020,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+370600,int_stack+340570,int_stack+72765,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+413500,int_stack+370600,int_stack+304270,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1076184,int_stack+413500,int_stack+15015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+115961,int_stack+109361,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+274020,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+274020,int_stack+19800,int_stack+340570,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1139709,int_stack+274020,int_stack+370600,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+324070,int_stack+1139709,int_stack+413500,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+400300,int_stack+324070,int_stack+1076184,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1076184,int_stack+123441,int_stack+115961,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1098624,int_stack+1076184,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+54450,int_stack+1098624,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1204059,int_stack+54450,int_stack+274020,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1204059,int_stack+1139709,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1076184,int_stack+0,int_stack+324070,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1076184,int_stack+400300,55);
 /*--- compute (lp|mk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1076184,int_stack+0,int_stack+184920,1980);
 /*--- compute (kd|mk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1343484,int_stack+1076184,int_stack+529704,1980);
 /*--- compute (if|mk) ---*/
 hrr1_build_if(Libint->AB,int_stack+184920,int_stack+1343484,int_stack+743544,1980);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+739320,int_stack+135486,int_stack+131856,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+750210,int_stack+139842,int_stack+135486,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+763278,int_stack+750210,int_stack+739320,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+785058,int_stack+144990,int_stack+139842,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+800502,int_stack+785058,int_stack+750210,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+826638,int_stack+800502,int_stack+763278,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+739320,int_stack+150996,int_stack+144990,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+862938,int_stack+739320,int_stack+785058,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+893826,int_stack+862938,int_stack+800502,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+757338,int_stack+893826,int_stack+826638,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+811788,int_stack+157926,int_stack+150996,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+937386,int_stack+811788,int_stack+739320,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+973422,int_stack+937386,int_stack+862938,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1771164,int_stack+973422,int_stack+893826,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+832578,int_stack+1771164,int_stack+757338,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+739320,int_stack+165846,int_stack+157926,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+763080,int_stack+739320,int_stack+811788,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1836504,int_stack+763080,int_stack+937386,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1896564,int_stack+1836504,int_stack+973422,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+908808,int_stack+1896564,int_stack+1771164,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1973784,int_stack+908808,int_stack+832578,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1771164,int_stack+174822,int_stack+165846,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+804660,int_stack+1771164,int_stack+739320,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1000284,int_stack+804660,int_stack+763080,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+739320,int_stack+1000284,int_stack+1836504,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1771164,int_stack+739320,int_stack+1896564,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+739320,int_stack+1771164,int_stack+908808,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1771164,int_stack+739320,int_stack+1973784,66);
 /*--- compute (mp|mk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+739320,int_stack+1771164,int_stack+0,1980);
 /*--- compute (ld|mk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1771164,int_stack+739320,int_stack+1076184,1980);
 /*--- compute (kf|mk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2305764,int_stack+1771164,int_stack+1343484,1980);
 /*--- compute (ig|mk) ---*/
 hrr1_build_ig(Libint->AB,int_stack+739320,int_stack+2305764,int_stack+184920,1980);
 return int_stack+739320;}
