/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihki(Libint_t*, prim_data*);

  /* Computes quartets of (ih|ki) integrals */

REALTYPE *hrr_order_ihki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[6][13] = int_stack + 10388;
 Libint->vrr_classes[7][7] = int_stack + 13328;
 Libint->vrr_classes[7][8] = int_stack + 14624;
 Libint->vrr_classes[7][9] = int_stack + 16244;
 Libint->vrr_classes[7][10] = int_stack + 18224;
 Libint->vrr_classes[7][11] = int_stack + 20600;
 Libint->vrr_classes[7][12] = int_stack + 23408;
 Libint->vrr_classes[7][13] = int_stack + 26684;
 Libint->vrr_classes[8][7] = int_stack + 30464;
 Libint->vrr_classes[8][8] = int_stack + 32084;
 Libint->vrr_classes[8][9] = int_stack + 34109;
 Libint->vrr_classes[8][10] = int_stack + 36584;
 Libint->vrr_classes[8][11] = int_stack + 39554;
 Libint->vrr_classes[8][12] = int_stack + 43064;
 Libint->vrr_classes[8][13] = int_stack + 47159;
 Libint->vrr_classes[9][7] = int_stack + 51884;
 Libint->vrr_classes[9][8] = int_stack + 53864;
 Libint->vrr_classes[9][9] = int_stack + 56339;
 Libint->vrr_classes[9][10] = int_stack + 59364;
 Libint->vrr_classes[9][11] = int_stack + 62994;
 Libint->vrr_classes[9][12] = int_stack + 67284;
 Libint->vrr_classes[9][13] = int_stack + 72289;
 Libint->vrr_classes[10][7] = int_stack + 78064;
 Libint->vrr_classes[10][8] = int_stack + 80440;
 Libint->vrr_classes[10][9] = int_stack + 83410;
 Libint->vrr_classes[10][10] = int_stack + 87040;
 Libint->vrr_classes[10][11] = int_stack + 91396;
 Libint->vrr_classes[10][12] = int_stack + 96544;
 Libint->vrr_classes[10][13] = int_stack + 102550;
 Libint->vrr_classes[11][7] = int_stack + 109480;
 Libint->vrr_classes[11][8] = int_stack + 112288;
 Libint->vrr_classes[11][9] = int_stack + 115798;
 Libint->vrr_classes[11][10] = int_stack + 120088;
 Libint->vrr_classes[11][11] = int_stack + 125236;
 Libint->vrr_classes[11][12] = int_stack + 131320;
 Libint->vrr_classes[11][13] = int_stack + 138418;
 memset(int_stack,0,146608*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 146608;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihki(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+146608,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+149632,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+153412,int_stack+149632,int_stack+146608,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+159460,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+164080,int_stack+159460,int_stack+149632,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+171640,int_stack+164080,int_stack+153412,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+146608,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+181720,int_stack+146608,int_stack+159460,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+190960,int_stack+181720,int_stack+164080,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+152152,int_stack+190960,int_stack+171640,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+167272,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+203560,int_stack+167272,int_stack+146608,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+214648,int_stack+203560,int_stack+181720,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+230048,int_stack+214648,int_stack+190960,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+173824,int_stack+230048,int_stack+152152,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+146608,int_stack+10388,int_stack+7840,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+146608,int_stack+167272,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146608,int_stack+0,int_stack+203560,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+248948,int_stack+146608,int_stack+214648,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+146608,int_stack+248948,int_stack+230048,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+194992,int_stack+146608,int_stack+173824,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+146608,int_stack+14624,int_stack+13328,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+150496,int_stack+16244,int_stack+14624,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+155356,int_stack+150496,int_stack+146608,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+163132,int_stack+18224,int_stack+16244,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+169072,int_stack+163132,int_stack+150496,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+178792,int_stack+169072,int_stack+155356,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+146608,int_stack+20600,int_stack+18224,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+146608,int_stack+163132,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+223216,int_stack+0,int_stack+169072,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+153736,int_stack+223216,int_stack+178792,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+173176,int_stack+23408,int_stack+20600,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+239416,int_stack+173176,int_stack+146608,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+253672,int_stack+239416,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+273472,int_stack+253672,int_stack+223216,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+297772,int_stack+273472,int_stack+153736,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+223216,int_stack+26684,int_stack+23408,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+223216,int_stack+173176,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146608,int_stack+0,int_stack+239416,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+146608,int_stack+253672,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+146608,int_stack+0,int_stack+273472,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+223216,int_stack+146608,int_stack+297772,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+259504,int_stack+223216,int_stack+194992,1008);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+146608,int_stack+32084,int_stack+30464,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+151468,int_stack+34109,int_stack+32084,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+157543,int_stack+151468,int_stack+146608,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+167263,int_stack+36584,int_stack+34109,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+174688,int_stack+167263,int_stack+151468,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+186838,int_stack+174688,int_stack+157543,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+146608,int_stack+39554,int_stack+36584,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+203038,int_stack+146608,int_stack+167263,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+203038,int_stack+174688,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+155518,int_stack+0,int_stack+186838,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+179818,int_stack+43064,int_stack+39554,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20250,int_stack+179818,int_stack+146608,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+344176,int_stack+20250,int_stack+203038,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+190348,int_stack+344176,int_stack+0,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+368926,int_stack+190348,int_stack+155518,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+47159,int_stack+43064,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146608,int_stack+0,int_stack+179818,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+402946,int_stack+146608,int_stack+20250,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+146608,int_stack+402946,int_stack+344176,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+146608,int_stack+190348,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+146608,int_stack+0,int_stack+368926,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+344176,int_stack+146608,int_stack+223216,1008);
 /*--- compute (id|ki) ---*/
 hrr1_build_id(Libint->AB,int_stack+453040,int_stack+344176,int_stack+259504,1008);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+53864,int_stack+51884,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+56339,int_stack+53864,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+59364,int_stack+56339,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34320,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+191968,int_stack+34320,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+62994,int_stack+59364,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+211768,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+229918,int_stack+211768,int_stack+34320,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10890,int_stack+229918,int_stack+191968,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+191968,int_stack+67284,int_stack+62994,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40590,int_stack+191968,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+254668,int_stack+40590,int_stack+211768,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+284918,int_stack+254668,int_stack+229918,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+204838,int_stack+284918,int_stack+10890,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72289,int_stack+67284,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+622384,int_stack+0,int_stack+191968,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+622384,int_stack+40590,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+622384,int_stack+0,int_stack+254668,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+622384,int_stack+284918,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+246418,int_stack+0,int_stack+204838,55);
 /*--- compute (lp|ki) ---*/
 hrr1_build_lp(Libint->AB,int_stack+622384,int_stack+246418,int_stack+146608,1008);
 /*--- compute (kd|ki) ---*/
 hrr1_build_kd(Libint->AB,int_stack+758464,int_stack+622384,int_stack+344176,1008);
 /*--- compute (if|ki) ---*/
 hrr1_build_if(Libint->AB,int_stack+976192,int_stack+758464,int_stack+453040,1008);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+146608,int_stack+80440,int_stack+78064,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+153736,int_stack+83410,int_stack+80440,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+162646,int_stack+153736,int_stack+146608,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+176902,int_stack+87040,int_stack+83410,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+187792,int_stack+176902,int_stack+153736,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+205612,int_stack+187792,int_stack+162646,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+146608,int_stack+91396,int_stack+87040,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+146608,int_stack+176902,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+21780,int_stack+0,int_stack+187792,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+159676,int_stack+21780,int_stack+205612,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+195316,int_stack+96544,int_stack+91396,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210760,int_stack+195316,int_stack+146608,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51480,int_stack+210760,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+301858,int_stack+51480,int_stack+21780,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+301858,int_stack+159676,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+146608,int_stack+102550,int_stack+96544,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+346408,int_stack+146608,int_stack+195316,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146608,int_stack+346408,int_stack+210760,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+346408,int_stack+146608,int_stack+51480,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+146608,int_stack+346408,int_stack+301858,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+301858,int_stack+146608,int_stack+0,66);
 /*--- compute (mp|ki) ---*/
 hrr1_build_mp(Libint->AB,int_stack+368386,int_stack+301858,int_stack+246418,1008);
 /*--- compute (ld|ki) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1258432,int_stack+368386,int_stack+622384,1008);
 /*--- compute (kf|ki) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1530592,int_stack+1258432,int_stack+758464,1008);
 /*--- compute (ig|ki) ---*/
 hrr1_build_ig(Libint->AB,int_stack+534706,int_stack+1530592,int_stack+976192,1008);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+112288,int_stack+109480,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+115798,int_stack+112288,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+120088,int_stack+115798,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48672,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+69732,int_stack+48672,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+125236,int_stack+120088,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+97812,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+146608,int_stack+97812,int_stack+48672,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+15444,int_stack+146608,int_stack+69732,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57564,int_stack+131320,int_stack+125236,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+181708,int_stack+57564,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+212596,int_stack+181708,int_stack+97812,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+75816,int_stack+212596,int_stack+146608,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+958066,int_stack+75816,int_stack+15444,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+146608,int_stack+138418,int_stack+131320,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+146608,int_stack+57564,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+128466,int_stack+0,int_stack+181708,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+128466,int_stack+212596,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+128466,int_stack+0,int_stack+75816,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+128466,int_stack+958066,78);
 /*--- compute (np|ki) ---*/
 hrr1_build_np(Libint->AB,int_stack+958066,int_stack+0,int_stack+301858,1008);
 /*--- compute (md|ki) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+958066,int_stack+368386,1008);
 /*--- compute (lf|ki) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1893472,int_stack+0,int_stack+1258432,1008);
 /*--- compute (kg|ki) ---*/
 hrr1_build_kg(Libint->AB,int_stack+958066,int_stack+1893472,int_stack+1530592,1008);
 /*--- compute (ih|ki) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1502386,int_stack+958066,int_stack+534706,1008);
 return int_stack+1502386;}
