/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipkf(Libint_t*, prim_data*);

  /* Computes quartets of (ip|kf) integrals */

REALTYPE *hrr_order_ipkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[7][7] = int_stack + 5656;
 Libint->vrr_classes[7][8] = int_stack + 6952;
 Libint->vrr_classes[7][9] = int_stack + 8572;
 Libint->vrr_classes[7][10] = int_stack + 10552;
 memset(int_stack,0,12928*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12928;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipkf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12928,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15952,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+19732,int_stack+15952,int_stack+12928,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25780,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+30400,int_stack+25780,int_stack+15952,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+37960,int_stack+30400,int_stack+19732,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12928,int_stack+6952,int_stack+5656,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16816,int_stack+8572,int_stack+6952,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+21676,int_stack+16816,int_stack+12928,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29452,int_stack+10552,int_stack+8572,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+29452,int_stack+16816,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+48040,int_stack+0,int_stack+21676,36);
 /*--- compute (ip|kf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+48040,int_stack+37960,360);
 return int_stack+0;}
