/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdlk(Libint_t*, prim_data*);

  /* Computes quartets of (kd|lk) integrals */

REALTYPE *hrr_order_kdlk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[8][8] = int_stack + 25056;
 Libint->vrr_classes[8][9] = int_stack + 27081;
 Libint->vrr_classes[8][10] = int_stack + 29556;
 Libint->vrr_classes[8][11] = int_stack + 32526;
 Libint->vrr_classes[8][12] = int_stack + 36036;
 Libint->vrr_classes[8][13] = int_stack + 40131;
 Libint->vrr_classes[8][14] = int_stack + 44856;
 Libint->vrr_classes[8][15] = int_stack + 50256;
 Libint->vrr_classes[9][8] = int_stack + 56376;
 Libint->vrr_classes[9][9] = int_stack + 58851;
 Libint->vrr_classes[9][10] = int_stack + 61876;
 Libint->vrr_classes[9][11] = int_stack + 65506;
 Libint->vrr_classes[9][12] = int_stack + 69796;
 Libint->vrr_classes[9][13] = int_stack + 74801;
 Libint->vrr_classes[9][14] = int_stack + 80576;
 Libint->vrr_classes[9][15] = int_stack + 87176;
 memset(int_stack,0,94656*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 94656;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdlk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+94656,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+99516,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+105456,int_stack+99516,int_stack+94656,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115176,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+122304,int_stack+115176,int_stack+99516,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+134184,int_stack+122304,int_stack+105456,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94656,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+150384,int_stack+94656,int_stack+115176,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+164640,int_stack+150384,int_stack+122304,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+103080,int_stack+164640,int_stack+134184,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+127380,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+184440,int_stack+127380,int_stack+94656,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+201288,int_stack+184440,int_stack+150384,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+225048,int_stack+201288,int_stack+164640,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+137208,int_stack+225048,int_stack+103080,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+94656,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+105996,int_stack+94656,int_stack+127380,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+254748,int_stack+105996,int_stack+184440,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+282828,int_stack+254748,int_stack+201288,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+171228,int_stack+282828,int_stack+225048,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+318468,int_stack+171228,int_stack+137208,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+125652,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+138612,int_stack+125652,int_stack+94656,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+212808,int_stack+138612,int_stack+105996,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+94656,int_stack+212808,int_stack+254748,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+212808,int_stack+94656,int_stack+282828,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+94656,int_stack+212808,int_stack+171228,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+150096,int_stack+94656,int_stack+318468,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+94656,int_stack+27081,int_stack+25056,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+100731,int_stack+29556,int_stack+27081,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+108156,int_stack+100731,int_stack+94656,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+120306,int_stack+32526,int_stack+29556,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+129216,int_stack+120306,int_stack+100731,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+208416,int_stack+129216,int_stack+108156,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94656,int_stack+36036,int_stack+32526,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+228666,int_stack+94656,int_stack+120306,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+246486,int_stack+228666,int_stack+129216,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+105186,int_stack+246486,int_stack+208416,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+208416,int_stack+40131,int_stack+36036,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+271236,int_stack+208416,int_stack+94656,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+292296,int_stack+271236,int_stack+228666,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+321996,int_stack+292296,int_stack+246486,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+220701,int_stack+321996,int_stack+105186,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+94656,int_stack+44856,int_stack+40131,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+108831,int_stack+94656,int_stack+208416,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+108831,int_stack+271236,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+359121,int_stack+0,int_stack+292296,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+263226,int_stack+359121,int_stack+321996,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+403671,int_stack+263226,int_stack+220701,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+208416,int_stack+50256,int_stack+44856,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+224616,int_stack+208416,int_stack+94656,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+315201,int_stack+224616,int_stack+108831,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+94656,int_stack+315201,int_stack+0,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+460371,int_stack+94656,int_stack+359121,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+315201,int_stack+460371,int_stack+263226,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+208416,int_stack+315201,int_stack+403671,45);
 /*--- compute (kp|lk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+281316,int_stack+208416,int_stack+150096,1620);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+94656,int_stack+58851,int_stack+56376,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+102081,int_stack+61876,int_stack+58851,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+111156,int_stack+102081,int_stack+94656,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+126006,int_stack+65506,int_stack+61876,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+136896,int_stack+126006,int_stack+102081,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+155046,int_stack+136896,int_stack+111156,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94656,int_stack+69796,int_stack+65506,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+179796,int_stack+94656,int_stack+126006,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+179796,int_stack+136896,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+107526,int_stack+0,int_stack+155046,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+144651,int_stack+74801,int_stack+69796,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+30250,int_stack+144651,int_stack+94656,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+456276,int_stack+30250,int_stack+179796,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+159666,int_stack+456276,int_stack+0,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+492576,int_stack+159666,int_stack+107526,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+80576,int_stack+74801,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+94656,int_stack+0,int_stack+144651,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+544551,int_stack+94656,int_stack+30250,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+17325,int_stack+544551,int_stack+456276,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+587451,int_stack+17325,int_stack+159666,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+124686,int_stack+587451,int_stack+492576,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+456276,int_stack+87176,int_stack+80576,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+476076,int_stack+456276,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+650976,int_stack+476076,int_stack+94656,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+456276,int_stack+650976,int_stack+544551,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+650976,int_stack+456276,int_stack+17325,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+456276,int_stack+650976,int_stack+587451,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+540976,int_stack+456276,int_stack+124686,55);
 /*--- compute (lp|lk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+630076,int_stack+540976,int_stack+208416,1620);
 /*--- compute (kd|lk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+848776,int_stack+630076,int_stack+281316,1620);
 return int_stack+848776;}
