/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdmf(Libint_t*, prim_data*);

  /* Computes quartets of (kd|mf) integrals */

REALTYPE *hrr_order_kdmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[8][9] = int_stack + 10440;
 Libint->vrr_classes[8][10] = int_stack + 12915;
 Libint->vrr_classes[8][11] = int_stack + 15885;
 Libint->vrr_classes[8][12] = int_stack + 19395;
 Libint->vrr_classes[9][9] = int_stack + 23490;
 Libint->vrr_classes[9][10] = int_stack + 26515;
 Libint->vrr_classes[9][11] = int_stack + 30145;
 Libint->vrr_classes[9][12] = int_stack + 34435;
 memset(int_stack,0,39440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 39440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdmf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39440,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45380,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+52508,int_stack+45380,int_stack+39440,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+64388,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72812,int_stack+64388,int_stack+45380,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+87068,int_stack+72812,int_stack+52508,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39440,int_stack+12915,int_stack+10440,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46865,int_stack+15885,int_stack+12915,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+55775,int_stack+46865,int_stack+39440,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+70625,int_stack+19395,int_stack+15885,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+70625,int_stack+46865,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+106868,int_stack+0,int_stack+55775,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+131618,int_stack+106868,int_stack+87068,550);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+26515,int_stack+23490,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+30145,int_stack+26515,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+39440,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57590,int_stack+34435,int_stack+30145,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+70460,int_stack+57590,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+70460,int_stack+39440,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+30250,int_stack+0,int_stack+106868,550);
 /*--- compute (kd|mf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+191018,int_stack+30250,int_stack+131618,550);
 return int_stack+191018;}
