/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kflk(Libint_t*, prim_data*);

  /* Computes quartets of (kf|lk) integrals */

REALTYPE *hrr_order_kflk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[8][8] = int_stack + 25056;
 Libint->vrr_classes[8][9] = int_stack + 27081;
 Libint->vrr_classes[8][10] = int_stack + 29556;
 Libint->vrr_classes[8][11] = int_stack + 32526;
 Libint->vrr_classes[8][12] = int_stack + 36036;
 Libint->vrr_classes[8][13] = int_stack + 40131;
 Libint->vrr_classes[8][14] = int_stack + 44856;
 Libint->vrr_classes[8][15] = int_stack + 50256;
 Libint->vrr_classes[9][8] = int_stack + 56376;
 Libint->vrr_classes[9][9] = int_stack + 58851;
 Libint->vrr_classes[9][10] = int_stack + 61876;
 Libint->vrr_classes[9][11] = int_stack + 65506;
 Libint->vrr_classes[9][12] = int_stack + 69796;
 Libint->vrr_classes[9][13] = int_stack + 74801;
 Libint->vrr_classes[9][14] = int_stack + 80576;
 Libint->vrr_classes[9][15] = int_stack + 87176;
 Libint->vrr_classes[10][8] = int_stack + 94656;
 Libint->vrr_classes[10][9] = int_stack + 97626;
 Libint->vrr_classes[10][10] = int_stack + 101256;
 Libint->vrr_classes[10][11] = int_stack + 105612;
 Libint->vrr_classes[10][12] = int_stack + 110760;
 Libint->vrr_classes[10][13] = int_stack + 116766;
 Libint->vrr_classes[10][14] = int_stack + 123696;
 Libint->vrr_classes[10][15] = int_stack + 131616;
 memset(int_stack,0,140592*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 140592;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kflk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140592,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+145452,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+151392,int_stack+145452,int_stack+140592,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161112,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+168240,int_stack+161112,int_stack+145452,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+180120,int_stack+168240,int_stack+151392,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140592,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+196320,int_stack+140592,int_stack+161112,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+210576,int_stack+196320,int_stack+168240,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+149016,int_stack+210576,int_stack+180120,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173316,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+230376,int_stack+173316,int_stack+140592,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+247224,int_stack+230376,int_stack+196320,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+270984,int_stack+247224,int_stack+210576,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+183144,int_stack+270984,int_stack+149016,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+140592,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+151932,int_stack+140592,int_stack+173316,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+300684,int_stack+151932,int_stack+230376,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+328764,int_stack+300684,int_stack+247224,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+217164,int_stack+328764,int_stack+270984,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+364404,int_stack+217164,int_stack+183144,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+171588,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+184548,int_stack+171588,int_stack+140592,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+258744,int_stack+184548,int_stack+151932,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140592,int_stack+258744,int_stack+300684,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+258744,int_stack+140592,int_stack+328764,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+140592,int_stack+258744,int_stack+217164,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+196032,int_stack+140592,int_stack+364404,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140592,int_stack+27081,int_stack+25056,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+146667,int_stack+29556,int_stack+27081,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+154092,int_stack+146667,int_stack+140592,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+166242,int_stack+32526,int_stack+29556,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175152,int_stack+166242,int_stack+146667,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+254352,int_stack+175152,int_stack+154092,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140592,int_stack+36036,int_stack+32526,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+274602,int_stack+140592,int_stack+166242,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+292422,int_stack+274602,int_stack+175152,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+151122,int_stack+292422,int_stack+254352,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+254352,int_stack+40131,int_stack+36036,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+317172,int_stack+254352,int_stack+140592,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+338232,int_stack+317172,int_stack+274602,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+367932,int_stack+338232,int_stack+292422,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+266637,int_stack+367932,int_stack+151122,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+140592,int_stack+44856,int_stack+40131,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+154767,int_stack+140592,int_stack+254352,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+154767,int_stack+317172,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+405057,int_stack+0,int_stack+338232,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+309162,int_stack+405057,int_stack+367932,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+449607,int_stack+309162,int_stack+266637,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+254352,int_stack+50256,int_stack+44856,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+270552,int_stack+254352,int_stack+140592,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+361137,int_stack+270552,int_stack+154767,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140592,int_stack+361137,int_stack+0,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+506307,int_stack+140592,int_stack+405057,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+361137,int_stack+506307,int_stack+309162,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+254352,int_stack+361137,int_stack+449607,45);
 /*--- compute (kp|lk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+327252,int_stack+254352,int_stack+196032,1620);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140592,int_stack+58851,int_stack+56376,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+148017,int_stack+61876,int_stack+58851,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+157092,int_stack+148017,int_stack+140592,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+171942,int_stack+65506,int_stack+61876,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+182832,int_stack+171942,int_stack+148017,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+200982,int_stack+182832,int_stack+157092,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140592,int_stack+69796,int_stack+65506,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+225732,int_stack+140592,int_stack+171942,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+225732,int_stack+182832,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+153462,int_stack+0,int_stack+200982,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+190587,int_stack+74801,int_stack+69796,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+30250,int_stack+190587,int_stack+140592,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+502212,int_stack+30250,int_stack+225732,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+205602,int_stack+502212,int_stack+0,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+538512,int_stack+205602,int_stack+153462,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+80576,int_stack+74801,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+140592,int_stack+0,int_stack+190587,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+590487,int_stack+140592,int_stack+30250,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+17325,int_stack+590487,int_stack+502212,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+633387,int_stack+17325,int_stack+205602,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+170622,int_stack+633387,int_stack+538512,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+502212,int_stack+87176,int_stack+80576,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+522012,int_stack+502212,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+696912,int_stack+522012,int_stack+140592,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+502212,int_stack+696912,int_stack+590487,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+696912,int_stack+502212,int_stack+17325,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+502212,int_stack+696912,int_stack+633387,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+586912,int_stack+502212,int_stack+170622,55);
 /*--- compute (lp|lk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+676012,int_stack+586912,int_stack+254352,1620);
 /*--- compute (kd|lk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+894712,int_stack+676012,int_stack+327252,1620);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140592,int_stack+97626,int_stack+94656,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+149502,int_stack+101256,int_stack+97626,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+160392,int_stack+149502,int_stack+140592,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+178212,int_stack+105612,int_stack+101256,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+191280,int_stack+178212,int_stack+149502,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+213060,int_stack+191280,int_stack+160392,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140592,int_stack+110760,int_stack+105612,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+242760,int_stack+140592,int_stack+178212,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+268896,int_stack+242760,int_stack+191280,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+156036,int_stack+268896,int_stack+213060,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+200586,int_stack+116766,int_stack+110760,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+305196,int_stack+200586,int_stack+140592,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+336084,int_stack+305196,int_stack+242760,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+379644,int_stack+336084,int_stack+268896,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+218604,int_stack+379644,int_stack+156036,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+140592,int_stack+123696,int_stack+116766,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+161382,int_stack+140592,int_stack+200586,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+434094,int_stack+161382,int_stack+305196,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+485574,int_stack+434094,int_stack+336084,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+280974,int_stack+485574,int_stack+379644,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+280974,int_stack+218604,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+197418,int_stack+131616,int_stack+123696,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+221178,int_stack+197418,int_stack+140592,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+357204,int_stack+221178,int_stack+161382,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+83160,int_stack+357204,int_stack+434094,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+357204,int_stack+83160,int_stack+485574,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+83160,int_stack+357204,int_stack+280974,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+184800,int_stack+83160,int_stack+0,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+291720,int_stack+184800,int_stack+586912,1620);
 /*--- compute (ld|lk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1244632,int_stack+291720,int_stack+676012,1620);
 /*--- compute (kf|lk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+1244632,int_stack+894712,1620);
 return int_stack+0;}
