/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgli(Libint_t*, prim_data*);

  /* Computes quartets of (kg|li) integrals */

REALTYPE *hrr_order_kgli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[8][8] = int_stack + 20160;
 Libint->vrr_classes[8][9] = int_stack + 22185;
 Libint->vrr_classes[8][10] = int_stack + 24660;
 Libint->vrr_classes[8][11] = int_stack + 27630;
 Libint->vrr_classes[8][12] = int_stack + 31140;
 Libint->vrr_classes[8][13] = int_stack + 35235;
 Libint->vrr_classes[8][14] = int_stack + 39960;
 Libint->vrr_classes[9][8] = int_stack + 45360;
 Libint->vrr_classes[9][9] = int_stack + 47835;
 Libint->vrr_classes[9][10] = int_stack + 50860;
 Libint->vrr_classes[9][11] = int_stack + 54490;
 Libint->vrr_classes[9][12] = int_stack + 58780;
 Libint->vrr_classes[9][13] = int_stack + 63785;
 Libint->vrr_classes[9][14] = int_stack + 69560;
 Libint->vrr_classes[10][8] = int_stack + 76160;
 Libint->vrr_classes[10][9] = int_stack + 79130;
 Libint->vrr_classes[10][10] = int_stack + 82760;
 Libint->vrr_classes[10][11] = int_stack + 87116;
 Libint->vrr_classes[10][12] = int_stack + 92264;
 Libint->vrr_classes[10][13] = int_stack + 98270;
 Libint->vrr_classes[10][14] = int_stack + 105200;
 Libint->vrr_classes[11][8] = int_stack + 113120;
 Libint->vrr_classes[11][9] = int_stack + 116630;
 Libint->vrr_classes[11][10] = int_stack + 120920;
 Libint->vrr_classes[11][11] = int_stack + 126068;
 Libint->vrr_classes[11][12] = int_stack + 132152;
 Libint->vrr_classes[11][13] = int_stack + 139250;
 Libint->vrr_classes[11][14] = int_stack + 147440;
 memset(int_stack,0,156800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 156800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgli(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+156800,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+161660,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+167600,int_stack+161660,int_stack+156800,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+177320,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+184448,int_stack+177320,int_stack+161660,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+196328,int_stack+184448,int_stack+167600,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+156800,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+212528,int_stack+156800,int_stack+177320,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+226784,int_stack+212528,int_stack+184448,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+165224,int_stack+226784,int_stack+196328,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+189524,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+246584,int_stack+189524,int_stack+156800,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+263432,int_stack+246584,int_stack+212528,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+287192,int_stack+263432,int_stack+226784,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+199352,int_stack+287192,int_stack+165224,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+156800,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+168140,int_stack+156800,int_stack+189524,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+316892,int_stack+168140,int_stack+246584,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+156800,int_stack+316892,int_stack+263432,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+233372,int_stack+156800,int_stack+287192,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+274952,int_stack+233372,int_stack+199352,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+156800,int_stack+22185,int_stack+20160,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+162875,int_stack+24660,int_stack+22185,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+170300,int_stack+162875,int_stack+156800,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+182450,int_stack+27630,int_stack+24660,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+191360,int_stack+182450,int_stack+162875,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+206210,int_stack+191360,int_stack+170300,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+156800,int_stack+31140,int_stack+27630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+226460,int_stack+156800,int_stack+182450,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+244280,int_stack+226460,int_stack+191360,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+167330,int_stack+244280,int_stack+206210,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+197705,int_stack+35235,int_stack+31140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+320312,int_stack+197705,int_stack+156800,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+320312,int_stack+226460,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+341372,int_stack+0,int_stack+244280,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+209990,int_stack+341372,int_stack+167330,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+156800,int_stack+39960,int_stack+35235,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+170975,int_stack+156800,int_stack+197705,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+378497,int_stack+170975,int_stack+320312,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+156800,int_stack+378497,int_stack+0,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+378497,int_stack+156800,int_stack+341372,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+320312,int_stack+378497,int_stack+209990,45);
 /*--- compute (kp|li) ---*/
 hrr1_build_kp(Libint->AB,int_stack+377012,int_stack+320312,int_stack+274952,1260);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+156800,int_stack+47835,int_stack+45360,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+164225,int_stack+50860,int_stack+47835,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+173300,int_stack+164225,int_stack+156800,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+188150,int_stack+54490,int_stack+50860,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+199040,int_stack+188150,int_stack+164225,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+217190,int_stack+199040,int_stack+173300,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+156800,int_stack+58780,int_stack+54490,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+241940,int_stack+156800,int_stack+188150,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+263720,int_stack+241940,int_stack+199040,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+169670,int_stack+263720,int_stack+217190,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+206795,int_stack+63785,int_stack+58780,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+293970,int_stack+206795,int_stack+156800,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+293970,int_stack+241940,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+513092,int_stack+0,int_stack+263720,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+221810,int_stack+513092,int_stack+169670,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+156800,int_stack+69560,int_stack+63785,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+174125,int_stack+156800,int_stack+206795,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+558467,int_stack+174125,int_stack+293970,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+156800,int_stack+558467,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+156800,int_stack+513092,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+513092,int_stack+0,int_stack+221810,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+582392,int_stack+513092,int_stack+320312,1260);
 /*--- compute (kd|li) ---*/
 hrr1_build_kd(Libint->AB,int_stack+752492,int_stack+582392,int_stack+377012,1260);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+79130,int_stack+76160,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+82760,int_stack+79130,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+87116,int_stack+82760,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50688,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+156800,int_stack+50688,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+92264,int_stack+87116,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+186500,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+212636,int_stack+186500,int_stack+50688,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15444,int_stack+212636,int_stack+156800,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156800,int_stack+98270,int_stack+92264,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+59994,int_stack+156800,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+248936,int_stack+59994,int_stack+186500,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+292496,int_stack+248936,int_stack+212636,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+174818,int_stack+292496,int_stack+15444,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+105200,int_stack+98270,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+156800,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+346946,int_stack+20790,int_stack+59994,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+346946,int_stack+248936,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+346946,int_stack+0,int_stack+292496,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+346946,int_stack+174818,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+156800,int_stack+0,int_stack+513092,1260);
 /*--- compute (ld|li) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1024652,int_stack+156800,int_stack+582392,1260);
 /*--- compute (kf|li) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1364852,int_stack+1024652,int_stack+752492,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+83160,int_stack+116630,int_stack+113120,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93690,int_stack+120920,int_stack+116630,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+364700,int_stack+93690,int_stack+83160,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+385760,int_stack+126068,int_stack+120920,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+401204,int_stack+385760,int_stack+93690,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+83160,int_stack+401204,int_stack+364700,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+364700,int_stack+132152,int_stack+126068,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+426944,int_stack+364700,int_stack+385760,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+457832,int_stack+426944,int_stack+401204,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+500732,int_stack+457832,int_stack+83160,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+83160,int_stack+139250,int_stack+132152,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+382952,int_stack+83160,int_stack+364700,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+553382,int_stack+382952,int_stack+426944,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+604862,int_stack+553382,int_stack+457832,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+419456,int_stack+604862,int_stack+500732,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+104454,int_stack+147440,int_stack+139250,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+493166,int_stack+104454,int_stack+83160,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+83160,int_stack+493166,int_stack+382952,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+669212,int_stack+83160,int_stack+553382,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+493166,int_stack+669212,int_stack+604862,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+583256,int_stack+493166,int_stack+419456,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+681536,int_stack+583256,int_stack+0,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+1818452,int_stack+681536,int_stack+156800,1260);
 /*--- compute (lf|li) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1818452,int_stack+1024652,1260);
 /*--- compute (kg|li) ---*/
 hrr1_build_kg(Libint->AB,int_stack+567000,int_stack+0,int_stack+1364852,1260);
 return int_stack+567000;}
