/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgng(Libint_t*, prim_data*);

  /* Computes quartets of (kg|ng) integrals */

REALTYPE *hrr_order_kgng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[8][10] = int_stack + 16560;
 Libint->vrr_classes[8][11] = int_stack + 19530;
 Libint->vrr_classes[8][12] = int_stack + 23040;
 Libint->vrr_classes[8][13] = int_stack + 27135;
 Libint->vrr_classes[8][14] = int_stack + 31860;
 Libint->vrr_classes[9][10] = int_stack + 37260;
 Libint->vrr_classes[9][11] = int_stack + 40890;
 Libint->vrr_classes[9][12] = int_stack + 45180;
 Libint->vrr_classes[9][13] = int_stack + 50185;
 Libint->vrr_classes[9][14] = int_stack + 55960;
 Libint->vrr_classes[10][10] = int_stack + 62560;
 Libint->vrr_classes[10][11] = int_stack + 66916;
 Libint->vrr_classes[10][12] = int_stack + 72064;
 Libint->vrr_classes[10][13] = int_stack + 78070;
 Libint->vrr_classes[10][14] = int_stack + 85000;
 Libint->vrr_classes[11][10] = int_stack + 92920;
 Libint->vrr_classes[11][11] = int_stack + 98068;
 Libint->vrr_classes[11][12] = int_stack + 104152;
 Libint->vrr_classes[11][13] = int_stack + 111250;
 Libint->vrr_classes[11][14] = int_stack + 119440;
 memset(int_stack,0,128800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 128800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgng(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128800,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+135928,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+144352,int_stack+135928,int_stack+128800,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+158608,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168436,int_stack+158608,int_stack+135928,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+185284,int_stack+168436,int_stack+144352,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+128800,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+209044,int_stack+128800,int_stack+158608,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+128800,int_stack+209044,int_stack+168436,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+209044,int_stack+128800,int_stack+185284,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128800,int_stack+19530,int_stack+16560,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+137710,int_stack+23040,int_stack+19530,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+148240,int_stack+137710,int_stack+128800,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+166060,int_stack+27135,int_stack+23040,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+178345,int_stack+166060,int_stack+137710,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+244684,int_stack+178345,int_stack+148240,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+128800,int_stack+31860,int_stack+27135,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+128800,int_stack+166060,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+128800,int_stack+0,int_stack+178345,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+163900,int_stack+128800,int_stack+244684,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+244684,int_stack+163900,int_stack+209044,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128800,int_stack+40890,int_stack+37260,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+139690,int_stack+45180,int_stack+40890,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+139690,int_stack+128800,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21780,int_stack+50185,int_stack+45180,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+208450,int_stack+21780,int_stack+139690,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+351604,int_stack+208450,int_stack+0,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+55960,int_stack+50185,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+128800,int_stack+0,int_stack+21780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+128800,int_stack+208450,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+387904,int_stack+0,int_stack+351604,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+442354,int_stack+387904,int_stack+163900,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+576004,int_stack+442354,int_stack+244684,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+66916,int_stack+62560,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+72064,int_stack+66916,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+128800,int_stack+78070,int_stack+72064,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146818,int_stack+128800,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+177706,int_stack+146818,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+85000,int_stack+78070,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+128800,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+221266,int_stack+20790,int_stack+146818,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+221266,int_stack+177706,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+128800,int_stack+0,int_stack+387904,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+789844,int_stack+128800,int_stack+442354,990);
 /*--- compute (kf|ng) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1057144,int_stack+789844,int_stack+576004,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+292150,int_stack+98068,int_stack+92920,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+307594,int_stack+104152,int_stack+98068,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+325846,int_stack+307594,int_stack+292150,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+356734,int_stack+111250,int_stack+104152,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+378028,int_stack+356734,int_stack+307594,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+414532,int_stack+378028,int_stack+325846,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+292150,int_stack+119440,int_stack+111250,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+466012,int_stack+292150,int_stack+356734,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+292150,int_stack+466012,int_stack+378028,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+466012,int_stack+292150,int_stack+414532,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+543232,int_stack+466012,int_stack+0,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+1413544,int_stack+543232,int_stack+128800,990);
 /*--- compute (lf|ng) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1413544,int_stack+789844,990);
 /*--- compute (kg|ng) ---*/
 hrr1_build_kg(Libint->AB,int_stack+445500,int_stack+0,int_stack+1057144,990);
 return int_stack+445500;}
