/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khng(Libint_t*, prim_data*);

  /* Computes quartets of (kh|ng) integrals */

REALTYPE *hrr_order_khng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[8][10] = int_stack + 16560;
 Libint->vrr_classes[8][11] = int_stack + 19530;
 Libint->vrr_classes[8][12] = int_stack + 23040;
 Libint->vrr_classes[8][13] = int_stack + 27135;
 Libint->vrr_classes[8][14] = int_stack + 31860;
 Libint->vrr_classes[9][10] = int_stack + 37260;
 Libint->vrr_classes[9][11] = int_stack + 40890;
 Libint->vrr_classes[9][12] = int_stack + 45180;
 Libint->vrr_classes[9][13] = int_stack + 50185;
 Libint->vrr_classes[9][14] = int_stack + 55960;
 Libint->vrr_classes[10][10] = int_stack + 62560;
 Libint->vrr_classes[10][11] = int_stack + 66916;
 Libint->vrr_classes[10][12] = int_stack + 72064;
 Libint->vrr_classes[10][13] = int_stack + 78070;
 Libint->vrr_classes[10][14] = int_stack + 85000;
 Libint->vrr_classes[11][10] = int_stack + 92920;
 Libint->vrr_classes[11][11] = int_stack + 98068;
 Libint->vrr_classes[11][12] = int_stack + 104152;
 Libint->vrr_classes[11][13] = int_stack + 111250;
 Libint->vrr_classes[11][14] = int_stack + 119440;
 Libint->vrr_classes[12][10] = int_stack + 128800;
 Libint->vrr_classes[12][11] = int_stack + 134806;
 Libint->vrr_classes[12][12] = int_stack + 141904;
 Libint->vrr_classes[12][13] = int_stack + 150185;
 Libint->vrr_classes[12][14] = int_stack + 159740;
 memset(int_stack,0,170660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 170660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khng(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170660,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+177788,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+186212,int_stack+177788,int_stack+170660,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+200468,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+210296,int_stack+200468,int_stack+177788,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+227144,int_stack+210296,int_stack+186212,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170660,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+250904,int_stack+170660,int_stack+200468,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+170660,int_stack+250904,int_stack+210296,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+250904,int_stack+170660,int_stack+227144,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170660,int_stack+19530,int_stack+16560,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+179570,int_stack+23040,int_stack+19530,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+190100,int_stack+179570,int_stack+170660,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+207920,int_stack+27135,int_stack+23040,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+220205,int_stack+207920,int_stack+179570,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+286544,int_stack+220205,int_stack+190100,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170660,int_stack+31860,int_stack+27135,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+170660,int_stack+207920,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+170660,int_stack+0,int_stack+220205,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+205760,int_stack+170660,int_stack+286544,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+286544,int_stack+205760,int_stack+250904,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170660,int_stack+40890,int_stack+37260,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+181550,int_stack+45180,int_stack+40890,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+181550,int_stack+170660,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21780,int_stack+50185,int_stack+45180,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+250310,int_stack+21780,int_stack+181550,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+393464,int_stack+250310,int_stack+0,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+55960,int_stack+50185,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+170660,int_stack+0,int_stack+21780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+170660,int_stack+250310,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+429764,int_stack+0,int_stack+393464,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+484214,int_stack+429764,int_stack+205760,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+617864,int_stack+484214,int_stack+286544,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+66916,int_stack+62560,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+72064,int_stack+66916,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+170660,int_stack+78070,int_stack+72064,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+188678,int_stack+170660,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+219566,int_stack+188678,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+85000,int_stack+78070,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+170660,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+263126,int_stack+20790,int_stack+188678,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+263126,int_stack+219566,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+170660,int_stack+0,int_stack+429764,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+831704,int_stack+170660,int_stack+484214,990);
 /*--- compute (kf|ng) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1099004,int_stack+831704,int_stack+617864,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+334010,int_stack+98068,int_stack+92920,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+349454,int_stack+104152,int_stack+98068,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+367706,int_stack+349454,int_stack+334010,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+398594,int_stack+111250,int_stack+104152,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+419888,int_stack+398594,int_stack+349454,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+456392,int_stack+419888,int_stack+367706,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+334010,int_stack+119440,int_stack+111250,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+507872,int_stack+334010,int_stack+398594,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+334010,int_stack+507872,int_stack+419888,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+507872,int_stack+334010,int_stack+456392,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+585092,int_stack+507872,int_stack+0,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+1455404,int_stack+585092,int_stack+170660,990);
 /*--- compute (lf|ng) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1782104,int_stack+1455404,int_stack+831704,990);
 /*--- compute (kg|ng) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2227604,int_stack+1782104,int_stack+1099004,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170660,int_stack+134806,int_stack+128800,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+188678,int_stack+141904,int_stack+134806,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+209972,int_stack+188678,int_stack+170660,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+246008,int_stack+150185,int_stack+141904,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+270851,int_stack+246008,int_stack+188678,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+313439,int_stack+270851,int_stack+209972,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170660,int_stack+159740,int_stack+150185,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+373499,int_stack+170660,int_stack+246008,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+423185,int_stack+373499,int_stack+270851,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+423185,int_stack+313439,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+90090,int_stack+0,int_stack+507872,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+781112,int_stack+90090,int_stack+585092,990);
 /*--- compute (mf|ng) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+781112,int_stack+1455404,990);
 /*--- compute (lg|ng) ---*/
 hrr1_build_lg(Libint->AB,int_stack+544500,int_stack+0,int_stack+1782104,990);
 /*--- compute (kh|ng) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1212750,int_stack+544500,int_stack+2227604,990);
 return int_stack+1212750;}
