/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khni(Libint_t*, prim_data*);

  /* Computes quartets of (kh|ni) integrals */

REALTYPE *hrr_order_khni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[8][10] = int_stack + 26964;
 Libint->vrr_classes[8][11] = int_stack + 29934;
 Libint->vrr_classes[8][12] = int_stack + 33444;
 Libint->vrr_classes[8][13] = int_stack + 37539;
 Libint->vrr_classes[8][14] = int_stack + 42264;
 Libint->vrr_classes[8][15] = int_stack + 47664;
 Libint->vrr_classes[8][16] = int_stack + 53784;
 Libint->vrr_classes[9][10] = int_stack + 60669;
 Libint->vrr_classes[9][11] = int_stack + 64299;
 Libint->vrr_classes[9][12] = int_stack + 68589;
 Libint->vrr_classes[9][13] = int_stack + 73594;
 Libint->vrr_classes[9][14] = int_stack + 79369;
 Libint->vrr_classes[9][15] = int_stack + 85969;
 Libint->vrr_classes[9][16] = int_stack + 93449;
 Libint->vrr_classes[10][10] = int_stack + 101864;
 Libint->vrr_classes[10][11] = int_stack + 106220;
 Libint->vrr_classes[10][12] = int_stack + 111368;
 Libint->vrr_classes[10][13] = int_stack + 117374;
 Libint->vrr_classes[10][14] = int_stack + 124304;
 Libint->vrr_classes[10][15] = int_stack + 132224;
 Libint->vrr_classes[10][16] = int_stack + 141200;
 Libint->vrr_classes[11][10] = int_stack + 151298;
 Libint->vrr_classes[11][11] = int_stack + 156446;
 Libint->vrr_classes[11][12] = int_stack + 162530;
 Libint->vrr_classes[11][13] = int_stack + 169628;
 Libint->vrr_classes[11][14] = int_stack + 177818;
 Libint->vrr_classes[11][15] = int_stack + 187178;
 Libint->vrr_classes[11][16] = int_stack + 197786;
 Libint->vrr_classes[12][10] = int_stack + 209720;
 Libint->vrr_classes[12][11] = int_stack + 215726;
 Libint->vrr_classes[12][12] = int_stack + 222824;
 Libint->vrr_classes[12][13] = int_stack + 231105;
 Libint->vrr_classes[12][14] = int_stack + 240660;
 Libint->vrr_classes[12][15] = int_stack + 251580;
 Libint->vrr_classes[12][16] = int_stack + 263956;
 memset(int_stack,0,277879*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 277879;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khni(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+277879,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+285007,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+293431,int_stack+285007,int_stack+277879,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+307687,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+317515,int_stack+307687,int_stack+285007,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+334363,int_stack+317515,int_stack+293431,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+277879,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+358123,int_stack+277879,int_stack+307687,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+289219,int_stack+358123,int_stack+317515,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377779,int_stack+289219,int_stack+334363,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+317299,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+330259,int_stack+317299,int_stack+277879,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+413419,int_stack+330259,int_stack+358123,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+446179,int_stack+413419,int_stack+289219,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+488299,int_stack+446179,int_stack+377779,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+277879,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+352939,int_stack+277879,int_stack+317299,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+277879,int_stack+352939,int_stack+330259,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+315679,int_stack+277879,int_stack+413419,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+364819,int_stack+315679,int_stack+446179,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+277879,int_stack+364819,int_stack+488299,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+344407,int_stack+29934,int_stack+26964,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+353317,int_stack+33444,int_stack+29934,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+363847,int_stack+353317,int_stack+344407,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+381667,int_stack+37539,int_stack+33444,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+393952,int_stack+381667,int_stack+353317,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+415012,int_stack+393952,int_stack+363847,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+344407,int_stack+42264,int_stack+37539,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+444712,int_stack+344407,int_stack+381667,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+358582,int_stack+444712,int_stack+393952,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+469282,int_stack+358582,int_stack+415012,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+393682,int_stack+47664,int_stack+42264,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+409882,int_stack+393682,int_stack+344407,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+409882,int_stack+444712,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+513832,int_stack+0,int_stack+358582,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+566482,int_stack+513832,int_stack+469282,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+344407,int_stack+53784,int_stack+47664,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+438232,int_stack+344407,int_stack+393682,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+344407,int_stack+438232,int_stack+409882,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+391657,int_stack+344407,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+628852,int_stack+391657,int_stack+513832,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+344407,int_stack+628852,int_stack+566482,45);
 /*--- compute (kp|ni) ---*/
 hrr1_build_kp(Libint->AB,int_stack+427567,int_stack+344407,int_stack+277879,1848);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+277879,int_stack+64299,int_stack+60669,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+288769,int_stack+68589,int_stack+64299,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+301639,int_stack+288769,int_stack+277879,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+323419,int_stack+73594,int_stack+68589,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+323419,int_stack+288769,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25740,int_stack+0,int_stack+301639,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+277879,int_stack+79369,int_stack+73594,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+627151,int_stack+277879,int_stack+323419,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+295204,int_stack+627151,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+657181,int_stack+295204,int_stack+25740,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+85969,int_stack+79369,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+277879,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+711631,int_stack+19800,int_stack+627151,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+761681,int_stack+711631,int_stack+295204,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+826031,int_stack+761681,int_stack+657181,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+627151,int_stack+93449,int_stack+85969,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+649591,int_stack+627151,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+277879,int_stack+649591,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+277879,int_stack+711631,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+627151,int_stack+0,int_stack+761681,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+627151,int_stack+826031,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+627151,int_stack+0,int_stack+344407,1848);
 /*--- compute (kd|ni) ---*/
 hrr1_build_kd(Libint->AB,int_stack+876631,int_stack+627151,int_stack+427567,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+277879,int_stack+106220,int_stack+101864,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+290947,int_stack+111368,int_stack+106220,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+306391,int_stack+290947,int_stack+277879,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+332527,int_stack+117374,int_stack+111368,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+350545,int_stack+332527,int_stack+290947,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+381433,int_stack+350545,int_stack+306391,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+277879,int_stack+124304,int_stack+117374,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+424993,int_stack+277879,int_stack+332527,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+298669,int_stack+424993,int_stack+350545,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+461029,int_stack+298669,int_stack+381433,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+350149,int_stack+132224,int_stack+124304,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+373909,int_stack+350149,int_stack+277879,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+526369,int_stack+373909,int_stack+424993,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1275799,int_stack+526369,int_stack+298669,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1353019,int_stack+1275799,int_stack+461029,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+277879,int_stack+141200,int_stack+132224,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+415489,int_stack+277879,int_stack+350149,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+277879,int_stack+415489,int_stack+373909,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+347179,int_stack+277879,int_stack+526369,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+437269,int_stack+347179,int_stack+1275799,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+277879,int_stack+437269,int_stack+1353019,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1275799,int_stack+277879,int_stack+0,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1580719,int_stack+1275799,int_stack+627151,1848);
 /*--- compute (kf|ni) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2079679,int_stack+1580719,int_stack+876631,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+156446,int_stack+151298,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+162530,int_stack+156446,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+169628,int_stack+162530,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+399847,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+177818,int_stack+169628,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+122382,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+122382,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+451327,int_stack+24570,int_stack+399847,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+399847,int_stack+187178,int_stack+177818,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+528547,int_stack+399847,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+577687,int_stack+528547,int_stack+122382,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+85410,int_stack+577687,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+648667,int_stack+85410,int_stack+451327,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+197786,int_stack+187178,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+427927,int_stack+0,int_stack+399847,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+427927,int_stack+528547,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+399847,int_stack+0,int_stack+577687,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+506317,int_stack+399847,int_stack+85410,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+506317,int_stack+648667,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+399847,int_stack+0,int_stack+277879,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+2744959,int_stack+399847,int_stack+1275799,1848);
 /*--- compute (lf|ni) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3354799,int_stack+2744959,int_stack+1580719,1848);
 /*--- compute (kg|ni) ---*/
 hrr1_build_kg(Libint->AB,int_stack+765751,int_stack+3354799,int_stack+2079679,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+277879,int_stack+215726,int_stack+209720,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+295897,int_stack+222824,int_stack+215726,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+317191,int_stack+295897,int_stack+277879,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+353227,int_stack+231105,int_stack+222824,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1763671,int_stack+353227,int_stack+295897,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1806259,int_stack+1763671,int_stack+317191,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+277879,int_stack+240660,int_stack+231105,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1866319,int_stack+277879,int_stack+353227,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+306544,int_stack+1866319,int_stack+1763671,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1916005,int_stack+306544,int_stack+1806259,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1763671,int_stack+251580,int_stack+240660,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1796431,int_stack+1763671,int_stack+277879,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2006095,int_stack+1796431,int_stack+1866319,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2088905,int_stack+2006095,int_stack+306544,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2195375,int_stack+2088905,int_stack+1916005,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+277879,int_stack+263956,int_stack+251580,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+315007,int_stack+277879,int_stack+1763671,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1853761,int_stack+315007,int_stack+1796431,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2321501,int_stack+1853761,int_stack+2006095,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1763671,int_stack+2321501,int_stack+2088905,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2321501,int_stack+1763671,int_stack+2195375,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1763671,int_stack+2321501,int_stack+0,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4186399,int_stack+1763671,int_stack+399847,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4918207,int_stack+4186399,int_stack+2744959,1848);
 /*--- compute (lg|ni) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1763671,int_stack+4918207,int_stack+3354799,1848);
 /*--- compute (kh|ni) ---*/
 hrr1_build_kh(Libint->AB,int_stack+3011071,int_stack+1763671,int_stack+765751,1848);
 return int_stack+3011071;}
