/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kklk(Libint_t*, prim_data*);

  /* Computes quartets of (kk|lk) integrals */

REALTYPE *hrr_order_kklk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[8][8] = int_stack + 25056;
 Libint->vrr_classes[8][9] = int_stack + 27081;
 Libint->vrr_classes[8][10] = int_stack + 29556;
 Libint->vrr_classes[8][11] = int_stack + 32526;
 Libint->vrr_classes[8][12] = int_stack + 36036;
 Libint->vrr_classes[8][13] = int_stack + 40131;
 Libint->vrr_classes[8][14] = int_stack + 44856;
 Libint->vrr_classes[8][15] = int_stack + 50256;
 Libint->vrr_classes[9][8] = int_stack + 56376;
 Libint->vrr_classes[9][9] = int_stack + 58851;
 Libint->vrr_classes[9][10] = int_stack + 61876;
 Libint->vrr_classes[9][11] = int_stack + 65506;
 Libint->vrr_classes[9][12] = int_stack + 69796;
 Libint->vrr_classes[9][13] = int_stack + 74801;
 Libint->vrr_classes[9][14] = int_stack + 80576;
 Libint->vrr_classes[9][15] = int_stack + 87176;
 Libint->vrr_classes[10][8] = int_stack + 94656;
 Libint->vrr_classes[10][9] = int_stack + 97626;
 Libint->vrr_classes[10][10] = int_stack + 101256;
 Libint->vrr_classes[10][11] = int_stack + 105612;
 Libint->vrr_classes[10][12] = int_stack + 110760;
 Libint->vrr_classes[10][13] = int_stack + 116766;
 Libint->vrr_classes[10][14] = int_stack + 123696;
 Libint->vrr_classes[10][15] = int_stack + 131616;
 Libint->vrr_classes[11][8] = int_stack + 140592;
 Libint->vrr_classes[11][9] = int_stack + 144102;
 Libint->vrr_classes[11][10] = int_stack + 148392;
 Libint->vrr_classes[11][11] = int_stack + 153540;
 Libint->vrr_classes[11][12] = int_stack + 159624;
 Libint->vrr_classes[11][13] = int_stack + 166722;
 Libint->vrr_classes[11][14] = int_stack + 174912;
 Libint->vrr_classes[11][15] = int_stack + 184272;
 Libint->vrr_classes[12][8] = int_stack + 194880;
 Libint->vrr_classes[12][9] = int_stack + 198975;
 Libint->vrr_classes[12][10] = int_stack + 203980;
 Libint->vrr_classes[12][11] = int_stack + 209986;
 Libint->vrr_classes[12][12] = int_stack + 217084;
 Libint->vrr_classes[12][13] = int_stack + 225365;
 Libint->vrr_classes[12][14] = int_stack + 234920;
 Libint->vrr_classes[12][15] = int_stack + 245840;
 Libint->vrr_classes[13][8] = int_stack + 258216;
 Libint->vrr_classes[13][9] = int_stack + 262941;
 Libint->vrr_classes[13][10] = int_stack + 268716;
 Libint->vrr_classes[13][11] = int_stack + 275646;
 Libint->vrr_classes[13][12] = int_stack + 283836;
 Libint->vrr_classes[13][13] = int_stack + 293391;
 Libint->vrr_classes[13][14] = int_stack + 304416;
 Libint->vrr_classes[13][15] = int_stack + 317016;
 Libint->vrr_classes[14][8] = int_stack + 331296;
 Libint->vrr_classes[14][9] = int_stack + 336696;
 Libint->vrr_classes[14][10] = int_stack + 343296;
 Libint->vrr_classes[14][11] = int_stack + 351216;
 Libint->vrr_classes[14][12] = int_stack + 360576;
 Libint->vrr_classes[14][13] = int_stack + 371496;
 Libint->vrr_classes[14][14] = int_stack + 384096;
 Libint->vrr_classes[14][15] = int_stack + 398496;
 memset(int_stack,0,414816*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 414816;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kklk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+414816,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+419676,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+425616,int_stack+419676,int_stack+414816,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+435336,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+442464,int_stack+435336,int_stack+419676,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+454344,int_stack+442464,int_stack+425616,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+414816,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+470544,int_stack+414816,int_stack+435336,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+484800,int_stack+470544,int_stack+442464,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+423240,int_stack+484800,int_stack+454344,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+447540,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+504600,int_stack+447540,int_stack+414816,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+521448,int_stack+504600,int_stack+470544,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+545208,int_stack+521448,int_stack+484800,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+457368,int_stack+545208,int_stack+423240,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+414816,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+426156,int_stack+414816,int_stack+447540,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+574908,int_stack+426156,int_stack+504600,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+602988,int_stack+574908,int_stack+521448,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+491388,int_stack+602988,int_stack+545208,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+638628,int_stack+491388,int_stack+457368,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+445812,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+458772,int_stack+445812,int_stack+414816,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+532968,int_stack+458772,int_stack+426156,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+414816,int_stack+532968,int_stack+574908,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+532968,int_stack+414816,int_stack+602988,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+414816,int_stack+532968,int_stack+491388,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+470256,int_stack+414816,int_stack+638628,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+414816,int_stack+27081,int_stack+25056,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+420891,int_stack+29556,int_stack+27081,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+428316,int_stack+420891,int_stack+414816,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+440466,int_stack+32526,int_stack+29556,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+449376,int_stack+440466,int_stack+420891,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+528576,int_stack+449376,int_stack+428316,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+414816,int_stack+36036,int_stack+32526,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+548826,int_stack+414816,int_stack+440466,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+566646,int_stack+548826,int_stack+449376,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+425346,int_stack+566646,int_stack+528576,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+528576,int_stack+40131,int_stack+36036,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+591396,int_stack+528576,int_stack+414816,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+612456,int_stack+591396,int_stack+548826,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+642156,int_stack+612456,int_stack+566646,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+540861,int_stack+642156,int_stack+425346,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+414816,int_stack+44856,int_stack+40131,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+428991,int_stack+414816,int_stack+528576,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+428991,int_stack+591396,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+679281,int_stack+0,int_stack+612456,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+583386,int_stack+679281,int_stack+642156,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+723831,int_stack+583386,int_stack+540861,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+528576,int_stack+50256,int_stack+44856,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+544776,int_stack+528576,int_stack+414816,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+635361,int_stack+544776,int_stack+428991,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+414816,int_stack+635361,int_stack+0,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+780531,int_stack+414816,int_stack+679281,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+635361,int_stack+780531,int_stack+583386,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+528576,int_stack+635361,int_stack+723831,45);
 /*--- compute (kp|lk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+601476,int_stack+528576,int_stack+470256,1620);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+414816,int_stack+58851,int_stack+56376,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+422241,int_stack+61876,int_stack+58851,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+431316,int_stack+422241,int_stack+414816,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446166,int_stack+65506,int_stack+61876,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+457056,int_stack+446166,int_stack+422241,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+475206,int_stack+457056,int_stack+431316,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+414816,int_stack+69796,int_stack+65506,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+499956,int_stack+414816,int_stack+446166,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+499956,int_stack+457056,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+427686,int_stack+0,int_stack+475206,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+464811,int_stack+74801,int_stack+69796,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+30250,int_stack+464811,int_stack+414816,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+776436,int_stack+30250,int_stack+499956,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+479826,int_stack+776436,int_stack+0,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+812736,int_stack+479826,int_stack+427686,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+80576,int_stack+74801,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+414816,int_stack+0,int_stack+464811,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+864711,int_stack+414816,int_stack+30250,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+17325,int_stack+864711,int_stack+776436,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+907611,int_stack+17325,int_stack+479826,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+444846,int_stack+907611,int_stack+812736,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+776436,int_stack+87176,int_stack+80576,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+796236,int_stack+776436,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+971136,int_stack+796236,int_stack+414816,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+776436,int_stack+971136,int_stack+864711,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+971136,int_stack+776436,int_stack+17325,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+776436,int_stack+971136,int_stack+907611,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+861136,int_stack+776436,int_stack+444846,55);
 /*--- compute (lp|lk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+950236,int_stack+861136,int_stack+528576,1620);
 /*--- compute (kd|lk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1168936,int_stack+950236,int_stack+601476,1620);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+414816,int_stack+97626,int_stack+94656,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+423726,int_stack+101256,int_stack+97626,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+434616,int_stack+423726,int_stack+414816,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+452436,int_stack+105612,int_stack+101256,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+465504,int_stack+452436,int_stack+423726,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+487284,int_stack+465504,int_stack+434616,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+414816,int_stack+110760,int_stack+105612,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+516984,int_stack+414816,int_stack+452436,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+543120,int_stack+516984,int_stack+465504,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+430260,int_stack+543120,int_stack+487284,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+474810,int_stack+116766,int_stack+110760,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+579420,int_stack+474810,int_stack+414816,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+610308,int_stack+579420,int_stack+516984,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+653868,int_stack+610308,int_stack+543120,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+492828,int_stack+653868,int_stack+430260,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+414816,int_stack+123696,int_stack+116766,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+435606,int_stack+414816,int_stack+474810,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+708318,int_stack+435606,int_stack+579420,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+759798,int_stack+708318,int_stack+610308,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+555198,int_stack+759798,int_stack+653868,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+555198,int_stack+492828,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+471642,int_stack+131616,int_stack+123696,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+495402,int_stack+471642,int_stack+414816,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+631428,int_stack+495402,int_stack+435606,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+414816,int_stack+631428,int_stack+708318,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+631428,int_stack+414816,int_stack+759798,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+414816,int_stack+631428,int_stack+555198,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+516456,int_stack+414816,int_stack+0,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1518856,int_stack+516456,int_stack+861136,1620);
 /*--- compute (ld|lk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1786156,int_stack+1518856,int_stack+950236,1620);
 /*--- compute (kf|lk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2223556,int_stack+1786156,int_stack+1168936,1620);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+144102,int_stack+140592,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+148392,int_stack+144102,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+153540,int_stack+148392,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85644,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+159624,int_stack+153540,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120744,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+414816,int_stack+120744,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+414816,int_stack+85644,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+70902,int_stack+166722,int_stack+159624,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+457716,int_stack+70902,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+623376,int_stack+457716,int_stack+120744,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92196,int_stack+623376,int_stack+414816,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+674856,int_stack+92196,int_stack+18252,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+414816,int_stack+174912,int_stack+166722,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+414816,int_stack+70902,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+748566,int_stack+0,int_stack+457716,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+809406,int_stack+748566,int_stack+623376,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+886626,int_stack+809406,int_stack+92196,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+42588,int_stack+886626,int_stack+674856,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+623376,int_stack+184272,int_stack+174912,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+651456,int_stack+623376,int_stack+414816,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+414816,int_stack+651456,int_stack+0,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+623376,int_stack+414816,int_stack+748566,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+976716,int_stack+623376,int_stack+809406,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+623376,int_stack+976716,int_stack+886626,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+743496,int_stack+623376,int_stack+42588,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+869856,int_stack+743496,int_stack+516456,1620);
 /*--- compute (md|lk) ---*/
 hrr1_build_md(Libint->AB,int_stack+2806756,int_stack+869856,int_stack+1518856,1620);
 /*--- compute (lf|lk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3341356,int_stack+2806756,int_stack+1786156,1620);
 /*--- compute (kg|lk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1190616,int_stack+3341356,int_stack+2223556,1620);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2065416,int_stack+198975,int_stack+194880,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2077701,int_stack+203980,int_stack+198975,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2092716,int_stack+2077701,int_stack+2065416,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2117286,int_stack+209986,int_stack+203980,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2135304,int_stack+2117286,int_stack+2077701,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+2165334,int_stack+2135304,int_stack+2092716,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2065416,int_stack+217084,int_stack+209986,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2206284,int_stack+2065416,int_stack+2117286,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2242320,int_stack+2206284,int_stack+2135304,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2086710,int_stack+2242320,int_stack+2165334,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2148135,int_stack+225365,int_stack+217084,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2292370,int_stack+2148135,int_stack+2065416,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2334958,int_stack+2292370,int_stack+2206284,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2395018,int_stack+2334958,int_stack+2242320,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+2172978,int_stack+2395018,int_stack+2086710,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2065416,int_stack+234920,int_stack+225365,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2094081,int_stack+2065416,int_stack+2148135,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2470093,int_stack+2094081,int_stack+2292370,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2541073,int_stack+2470093,int_stack+2334958,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2258973,int_stack+2541073,int_stack+2395018,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+2631163,int_stack+2258973,int_stack+2172978,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2143767,int_stack+245840,int_stack+234920,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2176527,int_stack+2143767,int_stack+2065416,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2364078,int_stack+2176527,int_stack+2094081,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2065416,int_stack+2364078,int_stack+2470093,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2364078,int_stack+2065416,int_stack+2541073,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2065416,int_stack+2364078,int_stack+2258973,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2205556,int_stack+2065416,int_stack+2631163,91);
 /*--- compute (op|lk) ---*/
 hrr1_build_op(Libint->AB,int_stack+2352976,int_stack+2205556,int_stack+743496,1620);
 /*--- compute (nd|lk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4070356,int_stack+2352976,int_stack+869856,1620);
 /*--- compute (mf|lk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4711876,int_stack+4070356,int_stack+2806756,1620);
 /*--- compute (lg|lk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+5602876,int_stack+4711876,int_stack+3341356,1620);
 /*--- compute (kh|lk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+2732056,int_stack+5602876,int_stack+1190616,1620);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3956776,int_stack+262941,int_stack+258216,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3970951,int_stack+268716,int_stack+262941,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+3988276,int_stack+3970951,int_stack+3956776,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4016626,int_stack+275646,int_stack+268716,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+414816,int_stack+4016626,int_stack+3970951,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+449466,int_stack+414816,int_stack+3988276,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3956776,int_stack+283836,int_stack+275646,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+496716,int_stack+3956776,int_stack+4016626,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+3981346,int_stack+496716,int_stack+414816,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+538296,int_stack+3981346,int_stack+449466,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+414816,int_stack+293391,int_stack+283836,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+443481,int_stack+414816,int_stack+3956776,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+609171,int_stack+443481,int_stack+496716,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+678471,int_stack+609171,int_stack+3981346,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+3956776,int_stack+678471,int_stack+538296,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+492621,int_stack+304416,int_stack+293391,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+525696,int_stack+492621,int_stack+414816,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+765096,int_stack+525696,int_stack+443481,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+846996,int_stack+765096,int_stack+609171,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+950946,int_stack+846996,int_stack+678471,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+583026,int_stack+950946,int_stack+3956776,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3956776,int_stack+317016,int_stack+304416,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3994576,int_stack+3956776,int_stack+492621,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+414816,int_stack+3994576,int_stack+525696,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1072221,int_stack+414816,int_stack+765096,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+414816,int_stack+1072221,int_stack+846996,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1072221,int_stack+414816,int_stack+950946,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1233921,int_stack+1072221,int_stack+583026,105);
 /*--- compute (qp|lk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+414816,int_stack+1233921,int_stack+2205556,1620);
 /*--- compute (od|lk) ---*/
 hrr1_build_od(Libint->AB,int_stack+1404021,int_stack+414816,int_stack+2352976,1620);
 /*--- compute (nf|lk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6696376,int_stack+1404021,int_stack+4070356,1620);
 /*--- compute (mg|lk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+7765576,int_stack+6696376,int_stack+4711876,1620);
 /*--- compute (lh|lk) ---*/
 hrr1_build_lh(Libint->AB,int_stack+3956776,int_stack+7765576,int_stack+5602876,1620);
 /*--- compute (ki|lk) ---*/
 hrr1_build_ki(Libint->AB,int_stack+9102076,int_stack+3956776,int_stack+2732056,1620);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+857076,int_stack+336696,int_stack+331296,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+873276,int_stack+343296,int_stack+336696,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+893076,int_stack+873276,int_stack+857076,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+925476,int_stack+351216,int_stack+343296,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+949236,int_stack+925476,int_stack+873276,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+988836,int_stack+949236,int_stack+893076,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+857076,int_stack+360576,int_stack+351216,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1042836,int_stack+857076,int_stack+925476,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1090356,int_stack+1042836,int_stack+949236,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+885156,int_stack+1090356,int_stack+988836,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+966156,int_stack+371496,int_stack+360576,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1156356,int_stack+966156,int_stack+857076,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2162181,int_stack+1156356,int_stack+1042836,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2241381,int_stack+2162181,int_stack+1090356,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+998916,int_stack+2241381,int_stack+885156,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+857076,int_stack+384096,int_stack+371496,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+894876,int_stack+857076,int_stack+966156,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2340381,int_stack+894876,int_stack+1156356,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1112316,int_stack+2340381,int_stack+2162181,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2433981,int_stack+1112316,int_stack+2241381,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+2162181,int_stack+2433981,int_stack+998916,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+960396,int_stack+398496,int_stack+384096,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1003596,int_stack+960396,int_stack+857076,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2572581,int_stack+1003596,int_stack+894876,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+857076,int_stack+2572581,int_stack+2340381,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2572581,int_stack+857076,int_stack+1112316,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+857076,int_stack+2572581,int_stack+2433981,120);
 /*--- compute (t0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2313381,int_stack+857076,int_stack+2162181,120);
 /*--- compute (rp|lk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2507781,int_stack+2313381,int_stack+1233921,1620);
 /*--- compute (qd|lk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3018081,int_stack+2507781,int_stack+414816,1620);
 /*--- compute (of|lk) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+3018081,int_stack+1404021,1620);
 /*--- compute (ng|lk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+1263600,int_stack+0,int_stack+6696376,1620);
 /*--- compute (mh|lk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+5487676,int_stack+1263600,int_stack+7765576,1620);
 /*--- compute (li|lk) ---*/
 hrr1_build_li(Libint->AB,int_stack+0,int_stack+5487676,int_stack+3956776,1620);
 /*--- compute (kk|lk) ---*/
 hrr1_build_kk(Libint->AB,int_stack+2041200,int_stack+0,int_stack+9102076,1620);
 return int_stack+2041200;}
