/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kkng(Libint_t*, prim_data*);

  /* Computes quartets of (kk|ng) integrals */

REALTYPE *hrr_order_kkng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[8][10] = int_stack + 16560;
 Libint->vrr_classes[8][11] = int_stack + 19530;
 Libint->vrr_classes[8][12] = int_stack + 23040;
 Libint->vrr_classes[8][13] = int_stack + 27135;
 Libint->vrr_classes[8][14] = int_stack + 31860;
 Libint->vrr_classes[9][10] = int_stack + 37260;
 Libint->vrr_classes[9][11] = int_stack + 40890;
 Libint->vrr_classes[9][12] = int_stack + 45180;
 Libint->vrr_classes[9][13] = int_stack + 50185;
 Libint->vrr_classes[9][14] = int_stack + 55960;
 Libint->vrr_classes[10][10] = int_stack + 62560;
 Libint->vrr_classes[10][11] = int_stack + 66916;
 Libint->vrr_classes[10][12] = int_stack + 72064;
 Libint->vrr_classes[10][13] = int_stack + 78070;
 Libint->vrr_classes[10][14] = int_stack + 85000;
 Libint->vrr_classes[11][10] = int_stack + 92920;
 Libint->vrr_classes[11][11] = int_stack + 98068;
 Libint->vrr_classes[11][12] = int_stack + 104152;
 Libint->vrr_classes[11][13] = int_stack + 111250;
 Libint->vrr_classes[11][14] = int_stack + 119440;
 Libint->vrr_classes[12][10] = int_stack + 128800;
 Libint->vrr_classes[12][11] = int_stack + 134806;
 Libint->vrr_classes[12][12] = int_stack + 141904;
 Libint->vrr_classes[12][13] = int_stack + 150185;
 Libint->vrr_classes[12][14] = int_stack + 159740;
 Libint->vrr_classes[13][10] = int_stack + 170660;
 Libint->vrr_classes[13][11] = int_stack + 177590;
 Libint->vrr_classes[13][12] = int_stack + 185780;
 Libint->vrr_classes[13][13] = int_stack + 195335;
 Libint->vrr_classes[13][14] = int_stack + 206360;
 Libint->vrr_classes[14][10] = int_stack + 218960;
 Libint->vrr_classes[14][11] = int_stack + 226880;
 Libint->vrr_classes[14][12] = int_stack + 236240;
 Libint->vrr_classes[14][13] = int_stack + 247160;
 Libint->vrr_classes[14][14] = int_stack + 259760;
 memset(int_stack,0,274160*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 274160;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kkng(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+281288,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+289712,int_stack+281288,int_stack+274160,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+303968,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+313796,int_stack+303968,int_stack+281288,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+330644,int_stack+313796,int_stack+289712,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+354404,int_stack+274160,int_stack+303968,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+274160,int_stack+354404,int_stack+313796,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+354404,int_stack+274160,int_stack+330644,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+19530,int_stack+16560,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+283070,int_stack+23040,int_stack+19530,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+293600,int_stack+283070,int_stack+274160,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+311420,int_stack+27135,int_stack+23040,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+323705,int_stack+311420,int_stack+283070,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+390044,int_stack+323705,int_stack+293600,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+31860,int_stack+27135,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+274160,int_stack+311420,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+274160,int_stack+0,int_stack+323705,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+309260,int_stack+274160,int_stack+390044,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+390044,int_stack+309260,int_stack+354404,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+40890,int_stack+37260,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+285050,int_stack+45180,int_stack+40890,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+285050,int_stack+274160,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21780,int_stack+50185,int_stack+45180,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+353810,int_stack+21780,int_stack+285050,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+496964,int_stack+353810,int_stack+0,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+55960,int_stack+50185,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+274160,int_stack+0,int_stack+21780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+274160,int_stack+353810,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+533264,int_stack+0,int_stack+496964,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+587714,int_stack+533264,int_stack+309260,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+721364,int_stack+587714,int_stack+390044,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+66916,int_stack+62560,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+72064,int_stack+66916,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+274160,int_stack+78070,int_stack+72064,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+292178,int_stack+274160,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+323066,int_stack+292178,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+85000,int_stack+78070,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+274160,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+366626,int_stack+20790,int_stack+292178,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+366626,int_stack+323066,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+274160,int_stack+0,int_stack+533264,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+935204,int_stack+274160,int_stack+587714,990);
 /*--- compute (kf|ng) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1202504,int_stack+935204,int_stack+721364,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+437510,int_stack+98068,int_stack+92920,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+452954,int_stack+104152,int_stack+98068,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+471206,int_stack+452954,int_stack+437510,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+502094,int_stack+111250,int_stack+104152,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+523388,int_stack+502094,int_stack+452954,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+559892,int_stack+523388,int_stack+471206,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+437510,int_stack+119440,int_stack+111250,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+611372,int_stack+437510,int_stack+502094,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+437510,int_stack+611372,int_stack+523388,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+611372,int_stack+437510,int_stack+559892,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+688592,int_stack+611372,int_stack+0,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+1558904,int_stack+688592,int_stack+274160,990);
 /*--- compute (lf|ng) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1885604,int_stack+1558904,int_stack+935204,990);
 /*--- compute (kg|ng) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2331104,int_stack+1885604,int_stack+1202504,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+134806,int_stack+128800,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+292178,int_stack+141904,int_stack+134806,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+313472,int_stack+292178,int_stack+274160,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+349508,int_stack+150185,int_stack+141904,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+374351,int_stack+349508,int_stack+292178,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+416939,int_stack+374351,int_stack+313472,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+159740,int_stack+150185,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+476999,int_stack+274160,int_stack+349508,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+274160,int_stack+476999,int_stack+374351,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+476999,int_stack+274160,int_stack+416939,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+884612,int_stack+476999,int_stack+611372,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1116272,int_stack+884612,int_stack+688592,990);
 /*--- compute (mf|ng) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2865704,int_stack+1116272,int_stack+1558904,990);
 /*--- compute (lg|ng) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3410204,int_stack+2865704,int_stack+1885604,990);
 /*--- compute (kh|ng) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1508312,int_stack+3410204,int_stack+2331104,990);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+177590,int_stack+170660,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+294950,int_stack+185780,int_stack+177590,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+319520,int_stack+294950,int_stack+274160,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+361100,int_stack+195335,int_stack+185780,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+389765,int_stack+361100,int_stack+294950,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+567089,int_stack+389765,int_stack+319520,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+206360,int_stack+195335,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+636389,int_stack+274160,int_stack+361100,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+274160,int_stack+636389,int_stack+389765,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+636389,int_stack+274160,int_stack+567089,105);
 /*--- compute (qp|ng) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2256752,int_stack+636389,int_stack+476999,990);
 /*--- compute (od|ng) ---*/
 hrr1_build_od(Libint->AB,int_stack+4078454,int_stack+2256752,int_stack+884612,990);
 /*--- compute (nf|ng) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4541774,int_stack+4078454,int_stack+1116272,990);
 /*--- compute (mg|ng) ---*/
 hrr1_build_mg(Libint->AB,int_stack+5195174,int_stack+4541774,int_stack+2865704,990);
 /*--- compute (lh|ng) ---*/
 hrr1_build_lh(Libint->AB,int_stack+6011924,int_stack+5195174,int_stack+3410204,990);
 /*--- compute (ki|ng) ---*/
 hrr1_build_ki(Libint->AB,int_stack+2527022,int_stack+6011924,int_stack+1508312,990);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+226880,int_stack+218960,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+297920,int_stack+236240,int_stack+226880,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+326000,int_stack+297920,int_stack+274160,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+373520,int_stack+247160,int_stack+236240,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+406280,int_stack+373520,int_stack+297920,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+462440,int_stack+406280,int_stack+326000,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+259760,int_stack+247160,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+541640,int_stack+274160,int_stack+373520,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+740339,int_stack+541640,int_stack+406280,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+833939,int_stack+740339,int_stack+462440,120);
 /*--- compute (rp|ng) ---*/
 hrr1_build_rp(Libint->AB,int_stack+952739,int_stack+833939,int_stack+636389,990);
 /*--- compute (qd|ng) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1264589,int_stack+952739,int_stack+2256752,990);
 /*--- compute (of|ng) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+1264589,int_stack+4078454,990);
 /*--- compute (ng|ng) ---*/
 hrr1_build_ng(Libint->AB,int_stack+772200,int_stack+0,int_stack+4541774,990);
 /*--- compute (mh|ng) ---*/
 hrr1_build_mh(Libint->AB,int_stack+3524942,int_stack+772200,int_stack+5195174,990);
 /*--- compute (li|ng) ---*/
 hrr1_build_li(Libint->AB,int_stack+0,int_stack+3524942,int_stack+6011924,990);
 /*--- compute (kk|ng) ---*/
 hrr1_build_kk(Libint->AB,int_stack+3524942,int_stack+0,int_stack+2527022,990);
 return int_stack+3524942;}
