/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpli(Libint_t*, prim_data*);

  /* Computes quartets of (kp|li) integrals */

REALTYPE *hrr_order_kpli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[8][8] = int_stack + 20160;
 Libint->vrr_classes[8][9] = int_stack + 22185;
 Libint->vrr_classes[8][10] = int_stack + 24660;
 Libint->vrr_classes[8][11] = int_stack + 27630;
 Libint->vrr_classes[8][12] = int_stack + 31140;
 Libint->vrr_classes[8][13] = int_stack + 35235;
 Libint->vrr_classes[8][14] = int_stack + 39960;
 memset(int_stack,0,45360*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 45360;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpli(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45360,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50220,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56160,int_stack+50220,int_stack+45360,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+65880,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+73008,int_stack+65880,int_stack+50220,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+84888,int_stack+73008,int_stack+56160,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45360,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+101088,int_stack+45360,int_stack+65880,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+115344,int_stack+101088,int_stack+73008,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+53784,int_stack+115344,int_stack+84888,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+78084,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+135144,int_stack+78084,int_stack+45360,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+151992,int_stack+135144,int_stack+101088,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+175752,int_stack+151992,int_stack+115344,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+87912,int_stack+175752,int_stack+53784,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+45360,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+56700,int_stack+45360,int_stack+78084,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+205452,int_stack+56700,int_stack+135144,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+45360,int_stack+205452,int_stack+151992,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+121932,int_stack+45360,int_stack+175752,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+163512,int_stack+121932,int_stack+87912,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45360,int_stack+22185,int_stack+20160,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51435,int_stack+24660,int_stack+22185,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+58860,int_stack+51435,int_stack+45360,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71010,int_stack+27630,int_stack+24660,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+79920,int_stack+71010,int_stack+51435,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+94770,int_stack+79920,int_stack+58860,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45360,int_stack+31140,int_stack+27630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+115020,int_stack+45360,int_stack+71010,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+132840,int_stack+115020,int_stack+79920,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+55890,int_stack+132840,int_stack+94770,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86265,int_stack+35235,int_stack+31140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+208872,int_stack+86265,int_stack+45360,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+208872,int_stack+115020,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+229932,int_stack+0,int_stack+132840,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+98550,int_stack+229932,int_stack+55890,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+45360,int_stack+39960,int_stack+35235,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+59535,int_stack+45360,int_stack+86265,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+267057,int_stack+59535,int_stack+208872,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+29700,int_stack+267057,int_stack+0,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+267057,int_stack+29700,int_stack+229932,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+267057,int_stack+98550,45);
 /*--- compute (kp|li) ---*/
 hrr1_build_kp(Libint->AB,int_stack+208872,int_stack+0,int_stack+163512,1260);
 return int_stack+208872;}
