/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpnh(Libint_t*, prim_data*);

  /* Computes quartets of (kp|nh) integrals */

REALTYPE *hrr_order_kpnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[8][10] = int_stack + 21456;
 Libint->vrr_classes[8][11] = int_stack + 24426;
 Libint->vrr_classes[8][12] = int_stack + 27936;
 Libint->vrr_classes[8][13] = int_stack + 32031;
 Libint->vrr_classes[8][14] = int_stack + 36756;
 Libint->vrr_classes[8][15] = int_stack + 42156;
 memset(int_stack,0,48276*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 48276;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpnh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48276,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+55404,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+63828,int_stack+55404,int_stack+48276,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+78084,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+87912,int_stack+78084,int_stack+55404,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+104760,int_stack+87912,int_stack+63828,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+48276,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+128520,int_stack+48276,int_stack+78084,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+59616,int_stack+128520,int_stack+87912,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+148176,int_stack+59616,int_stack+104760,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+87696,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+100656,int_stack+87696,int_stack+48276,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+183816,int_stack+100656,int_stack+128520,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+87696,int_stack+183816,int_stack+59616,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+183816,int_stack+87696,int_stack+148176,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48276,int_stack+24426,int_stack+21456,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57186,int_stack+27936,int_stack+24426,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+67716,int_stack+57186,int_stack+48276,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+85536,int_stack+32031,int_stack+27936,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+97821,int_stack+85536,int_stack+57186,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+118881,int_stack+97821,int_stack+67716,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+48276,int_stack+36756,int_stack+32031,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+148581,int_stack+48276,int_stack+85536,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+62451,int_stack+148581,int_stack+97821,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+233712,int_stack+62451,int_stack+118881,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+97551,int_stack+42156,int_stack+36756,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113751,int_stack+97551,int_stack+48276,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+113751,int_stack+148581,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+97551,int_stack+0,int_stack+62451,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+97551,int_stack+233712,45);
 /*--- compute (kp|nh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+233712,int_stack+0,int_stack+183816,1386);
 return int_stack+233712;}
