/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldkf(Libint_t*, prim_data*);

  /* Computes quartets of (ld|kf) integrals */

REALTYPE *hrr_order_ldkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][7] = int_stack + 0;
 Libint->vrr_classes[8][8] = int_stack + 1620;
 Libint->vrr_classes[8][9] = int_stack + 3645;
 Libint->vrr_classes[8][10] = int_stack + 6120;
 Libint->vrr_classes[9][7] = int_stack + 9090;
 Libint->vrr_classes[9][8] = int_stack + 11070;
 Libint->vrr_classes[9][9] = int_stack + 13545;
 Libint->vrr_classes[9][10] = int_stack + 16570;
 Libint->vrr_classes[10][7] = int_stack + 20200;
 Libint->vrr_classes[10][8] = int_stack + 22576;
 Libint->vrr_classes[10][9] = int_stack + 25546;
 Libint->vrr_classes[10][10] = int_stack + 29176;
 memset(int_stack,0,33532*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33532;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldkf(Libint, Data);
   Data++;
 }
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+33532,int_stack+1620,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38392,int_stack+3645,int_stack+1620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+44467,int_stack+38392,int_stack+33532,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+54187,int_stack+6120,int_stack+3645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+61612,int_stack+54187,int_stack+38392,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+73762,int_stack+61612,int_stack+44467,45);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+33532,int_stack+11070,int_stack+9090,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39472,int_stack+13545,int_stack+11070,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+46897,int_stack+39472,int_stack+33532,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58777,int_stack+16570,int_stack+13545,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+58777,int_stack+39472,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+89962,int_stack+0,int_stack+46897,55);
 /*--- compute (lp|kf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+109762,int_stack+89962,int_stack+73762,360);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+22576,int_stack+20200,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+25546,int_stack+22576,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33532,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47788,int_stack+29176,int_stack+25546,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+58678,int_stack+47788,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+58678,int_stack+33532,66);
 /*--- compute (mp|kf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+23760,int_stack+0,int_stack+89962,360);
 /*--- compute (ld|kf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+158362,int_stack+23760,int_stack+109762,360);
 return int_stack+158362;}
