/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldmg(Libint_t*, prim_data*);

  /* Computes quartets of (ld|mg) integrals */

REALTYPE *hrr_order_ldmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[9][9] = int_stack + 17775;
 Libint->vrr_classes[9][10] = int_stack + 20800;
 Libint->vrr_classes[9][11] = int_stack + 24430;
 Libint->vrr_classes[9][12] = int_stack + 28720;
 Libint->vrr_classes[9][13] = int_stack + 33725;
 Libint->vrr_classes[10][9] = int_stack + 39500;
 Libint->vrr_classes[10][10] = int_stack + 43130;
 Libint->vrr_classes[10][11] = int_stack + 47486;
 Libint->vrr_classes[10][12] = int_stack + 52634;
 Libint->vrr_classes[10][13] = int_stack + 58640;
 memset(int_stack,0,65570*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 65570;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldmg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65570,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+72995,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+81905,int_stack+72995,int_stack+65570,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+96755,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+107285,int_stack+96755,int_stack+72995,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+125105,int_stack+107285,int_stack+81905,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+65570,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149855,int_stack+65570,int_stack+96755,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+65570,int_stack+149855,int_stack+107285,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+149855,int_stack+65570,int_stack+125105,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65570,int_stack+20800,int_stack+17775,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+74645,int_stack+24430,int_stack+20800,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+85535,int_stack+74645,int_stack+65570,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103685,int_stack+28720,int_stack+24430,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+116555,int_stack+103685,int_stack+74645,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+186980,int_stack+116555,int_stack+85535,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+65570,int_stack+33725,int_stack+28720,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+65570,int_stack+103685,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+65570,int_stack+0,int_stack+116555,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+101870,int_stack+65570,int_stack+186980,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+186980,int_stack+101870,int_stack+149855,825);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65570,int_stack+43130,int_stack+39500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+76460,int_stack+47486,int_stack+43130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+76460,int_stack+65570,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21780,int_stack+52634,int_stack+47486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+147245,int_stack+21780,int_stack+76460,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+65570,int_stack+147245,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+58640,int_stack+52634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+298355,int_stack+0,int_stack+21780,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+298355,int_stack+147245,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+298355,int_stack+0,int_stack+65570,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+352805,int_stack+298355,int_stack+101870,825);
 /*--- compute (ld|mg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+488930,int_stack+352805,int_stack+186980,825);
 return int_stack+488930;}
