/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldml(Libint_t*, prim_data*);

  /* Computes quartets of (ld|ml) integrals */

REALTYPE *hrr_order_ldml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[9][9] = int_stack + 43875;
 Libint->vrr_classes[9][10] = int_stack + 46900;
 Libint->vrr_classes[9][11] = int_stack + 50530;
 Libint->vrr_classes[9][12] = int_stack + 54820;
 Libint->vrr_classes[9][13] = int_stack + 59825;
 Libint->vrr_classes[9][14] = int_stack + 65600;
 Libint->vrr_classes[9][15] = int_stack + 72200;
 Libint->vrr_classes[9][16] = int_stack + 79680;
 Libint->vrr_classes[9][17] = int_stack + 88095;
 Libint->vrr_classes[10][9] = int_stack + 97500;
 Libint->vrr_classes[10][10] = int_stack + 101130;
 Libint->vrr_classes[10][11] = int_stack + 105486;
 Libint->vrr_classes[10][12] = int_stack + 110634;
 Libint->vrr_classes[10][13] = int_stack + 116640;
 Libint->vrr_classes[10][14] = int_stack + 123570;
 Libint->vrr_classes[10][15] = int_stack + 131490;
 Libint->vrr_classes[10][16] = int_stack + 140466;
 Libint->vrr_classes[10][17] = int_stack + 150564;
 memset(int_stack,0,161850*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 161850;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldml(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+161850,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+169275,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+178185,int_stack+169275,int_stack+161850,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+193035,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+203565,int_stack+193035,int_stack+169275,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+221385,int_stack+203565,int_stack+178185,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161850,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+246135,int_stack+161850,int_stack+193035,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+267195,int_stack+246135,int_stack+203565,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+174135,int_stack+267195,int_stack+221385,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+211260,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+296895,int_stack+211260,int_stack+161850,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+321465,int_stack+296895,int_stack+246135,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+356565,int_stack+321465,int_stack+267195,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+225435,int_stack+356565,int_stack+174135,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+161850,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+178050,int_stack+161850,int_stack+211260,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+401115,int_stack+178050,int_stack+296895,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+442065,int_stack+401115,int_stack+321465,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+277410,int_stack+442065,int_stack+356565,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+494715,int_stack+277410,int_stack+225435,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+206400,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+224760,int_stack+206400,int_stack+161850,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+339780,int_stack+224760,int_stack+178050,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+564015,int_stack+339780,int_stack+401115,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+625440,int_stack+564015,int_stack+442065,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+387030,int_stack+625440,int_stack+277410,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+699150,int_stack+387030,int_stack+494715,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+161850,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+257160,int_stack+161850,int_stack+206400,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+161850,int_stack+257160,int_stack+224760,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+215850,int_stack+161850,int_stack+339780,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+286725,int_stack+215850,int_stack+564015,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+161850,int_stack+286725,int_stack+625440,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+260130,int_stack+161850,int_stack+387030,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+367050,int_stack+260130,int_stack+699150,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+161850,int_stack+46900,int_stack+43875,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170925,int_stack+50530,int_stack+46900,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+181815,int_stack+170925,int_stack+161850,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+199965,int_stack+54820,int_stack+50530,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+212835,int_stack+199965,int_stack+170925,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+234615,int_stack+212835,int_stack+181815,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161850,int_stack+59825,int_stack+54820,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+264865,int_stack+161850,int_stack+199965,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+290605,int_stack+264865,int_stack+212835,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+176865,int_stack+290605,int_stack+234615,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+222240,int_stack+65600,int_stack+59825,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+326905,int_stack+222240,int_stack+161850,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+478425,int_stack+326905,int_stack+264865,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+521325,int_stack+478425,int_stack+290605,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+239565,int_stack+521325,int_stack+176865,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+161850,int_stack+72200,int_stack+65600,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+181650,int_stack+161850,int_stack+222240,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+575775,int_stack+181650,int_stack+326905,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+625825,int_stack+575775,int_stack+478425,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+690175,int_stack+625825,int_stack+521325,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+478425,int_stack+690175,int_stack+239565,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+216300,int_stack+79680,int_stack+72200,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+238740,int_stack+216300,int_stack+161850,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+278340,int_stack+238740,int_stack+181650,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+278340,int_stack+575775,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+766405,int_stack+0,int_stack+625825,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+563125,int_stack+766405,int_stack+690175,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+856495,int_stack+563125,int_stack+478425,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+478425,int_stack+88095,int_stack+79680,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+503670,int_stack+478425,int_stack+216300,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+161850,int_stack+503670,int_stack+238740,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+664765,int_stack+161850,int_stack+278340,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+161850,int_stack+664765,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+965395,int_stack+161850,int_stack+766405,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+161850,int_stack+965395,int_stack+563125,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+478425,int_stack+161850,int_stack+856495,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+614550,int_stack+478425,int_stack+367050,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+161850,int_stack+101130,int_stack+97500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+172740,int_stack+105486,int_stack+101130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+185808,int_stack+172740,int_stack+161850,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207588,int_stack+110634,int_stack+105486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+223032,int_stack+207588,int_stack+172740,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+249168,int_stack+223032,int_stack+185808,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161850,int_stack+116640,int_stack+110634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+285468,int_stack+161850,int_stack+207588,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+316356,int_stack+285468,int_stack+223032,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+179868,int_stack+316356,int_stack+249168,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+234318,int_stack+123570,int_stack+116640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+359916,int_stack+234318,int_stack+161850,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+395952,int_stack+359916,int_stack+285468,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+395952,int_stack+316356,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+255108,int_stack+0,int_stack+179868,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+161850,int_stack+131490,int_stack+123570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+185610,int_stack+161850,int_stack+234318,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65340,int_stack+185610,int_stack+359916,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+948675,int_stack+65340,int_stack+395952,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+331338,int_stack+948675,int_stack+0,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1025895,int_stack+331338,int_stack+255108,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+140466,int_stack+131490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+227190,int_stack+0,int_stack+161850,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1127535,int_stack+227190,int_stack+185610,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1196835,int_stack+1127535,int_stack+65340,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+26928,int_stack+1196835,int_stack+948675,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1286925,int_stack+26928,int_stack+331338,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+274710,int_stack+1286925,int_stack+1025895,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+948675,int_stack+150564,int_stack+140466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+978969,int_stack+948675,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1032825,int_stack+978969,int_stack+227190,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+135036,int_stack+1032825,int_stack+1127535,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+948675,int_stack+135036,int_stack+1196835,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1074801,int_stack+948675,int_stack+26928,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1074801,int_stack+1286925,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+948675,int_stack+0,int_stack+274710,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+948675,int_stack+478425,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+948675,int_stack+0,int_stack+614550,2475);
 return int_stack+948675;}
