/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfnl(Libint_t*, prim_data*);

  /* Computes quartets of (lf|nl) integrals */

REALTYPE *hrr_order_lfnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[9][10] = int_stack + 49950;
 Libint->vrr_classes[9][11] = int_stack + 53580;
 Libint->vrr_classes[9][12] = int_stack + 57870;
 Libint->vrr_classes[9][13] = int_stack + 62875;
 Libint->vrr_classes[9][14] = int_stack + 68650;
 Libint->vrr_classes[9][15] = int_stack + 75250;
 Libint->vrr_classes[9][16] = int_stack + 82730;
 Libint->vrr_classes[9][17] = int_stack + 91145;
 Libint->vrr_classes[9][18] = int_stack + 100550;
 Libint->vrr_classes[10][10] = int_stack + 111000;
 Libint->vrr_classes[10][11] = int_stack + 115356;
 Libint->vrr_classes[10][12] = int_stack + 120504;
 Libint->vrr_classes[10][13] = int_stack + 126510;
 Libint->vrr_classes[10][14] = int_stack + 133440;
 Libint->vrr_classes[10][15] = int_stack + 141360;
 Libint->vrr_classes[10][16] = int_stack + 150336;
 Libint->vrr_classes[10][17] = int_stack + 160434;
 Libint->vrr_classes[10][18] = int_stack + 171720;
 Libint->vrr_classes[11][10] = int_stack + 184260;
 Libint->vrr_classes[11][11] = int_stack + 189408;
 Libint->vrr_classes[11][12] = int_stack + 195492;
 Libint->vrr_classes[11][13] = int_stack + 202590;
 Libint->vrr_classes[11][14] = int_stack + 210780;
 Libint->vrr_classes[11][15] = int_stack + 220140;
 Libint->vrr_classes[11][16] = int_stack + 230748;
 Libint->vrr_classes[11][17] = int_stack + 242682;
 Libint->vrr_classes[11][18] = int_stack + 256020;
 memset(int_stack,0,270840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 270840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfnl(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+270840,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+279750,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+290280,int_stack+279750,int_stack+270840,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+308100,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+320385,int_stack+308100,int_stack+279750,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+341445,int_stack+320385,int_stack+290280,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+270840,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+371145,int_stack+270840,int_stack+308100,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+285015,int_stack+371145,int_stack+320385,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+395715,int_stack+285015,int_stack+341445,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+320115,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+336315,int_stack+320115,int_stack+270840,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+440265,int_stack+336315,int_stack+371145,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+481215,int_stack+440265,int_stack+285015,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+533865,int_stack+481215,int_stack+395715,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+270840,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+364665,int_stack+270840,int_stack+320115,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+596235,int_stack+364665,int_stack+336315,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+289200,int_stack+596235,int_stack+440265,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+397065,int_stack+289200,int_stack+481215,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+643485,int_stack+397065,int_stack+533865,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+470775,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+491430,int_stack+470775,int_stack+270840,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+528150,int_stack+491430,int_stack+364665,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+726645,int_stack+528150,int_stack+596235,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+797520,int_stack+726645,int_stack+289200,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+270840,int_stack+797520,int_stack+397065,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+883515,int_stack+270840,int_stack+643485,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+369120,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+392205,int_stack+369120,int_stack+470775,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+582150,int_stack+392205,int_stack+491430,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+369120,int_stack+582150,int_stack+528150,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+450120,int_stack+369120,int_stack+726645,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+549345,int_stack+450120,int_stack+797520,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+369120,int_stack+549345,int_stack+270840,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+495480,int_stack+369120,int_stack+883515,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+270840,int_stack+53580,int_stack+49950,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+281730,int_stack+57870,int_stack+53580,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+294600,int_stack+281730,int_stack+270840,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+316380,int_stack+62875,int_stack+57870,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+331395,int_stack+316380,int_stack+281730,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+357135,int_stack+331395,int_stack+294600,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+270840,int_stack+68650,int_stack+62875,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+393435,int_stack+270840,int_stack+316380,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+288165,int_stack+393435,int_stack+331395,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+423465,int_stack+288165,int_stack+357135,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+331065,int_stack+75250,int_stack+68650,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+350865,int_stack+331065,int_stack+270840,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+629130,int_stack+350865,int_stack+393435,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+679180,int_stack+629130,int_stack+288165,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+743530,int_stack+679180,int_stack+423465,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+270840,int_stack+82730,int_stack+75250,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+385515,int_stack+270840,int_stack+331065,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+425115,int_stack+385515,int_stack+350865,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+293280,int_stack+425115,int_stack+629130,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+819760,int_stack+293280,int_stack+679180,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+629130,int_stack+819760,int_stack+743530,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+730770,int_stack+91145,int_stack+82730,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+756015,int_stack+730770,int_stack+270840,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+909850,int_stack+756015,int_stack+385515,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+909850,int_stack+425115,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+368355,int_stack+0,int_stack+293280,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+975850,int_stack+368355,int_stack+819760,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1095970,int_stack+975850,int_stack+629130,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+629130,int_stack+100550,int_stack+91145,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+657345,int_stack+629130,int_stack+730770,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+270840,int_stack+657345,int_stack+756015,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+629130,int_stack+270840,int_stack+909850,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+728130,int_stack+629130,int_stack+0,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1226650,int_stack+728130,int_stack+368355,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+629130,int_stack+1226650,int_stack+975850,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+783570,int_stack+629130,int_stack+1095970,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+946920,int_stack+783570,int_stack+495480,2970);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+115356,int_stack+111000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+120504,int_stack+115356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+126510,int_stack+120504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+270840,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+133440,int_stack+126510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+314400,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+314400,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+350436,int_stack+20790,int_stack+270840,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+270840,int_stack+141360,int_stack+133440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+72270,int_stack+270840,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+415776,int_stack+72270,int_stack+314400,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+475836,int_stack+415776,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+553056,int_stack+475836,int_stack+350436,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+150336,int_stack+141360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+294600,int_stack+0,int_stack+270840,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+342120,int_stack+294600,int_stack+72270,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+26928,int_stack+342120,int_stack+415776,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+644532,int_stack+26928,int_stack+475836,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+411420,int_stack+644532,int_stack+553056,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+117018,int_stack+160434,int_stack+150336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+533388,int_stack+117018,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1347870,int_stack+533388,int_stack+294600,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1427070,int_stack+1347870,int_stack+342120,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+270840,int_stack+1427070,int_stack+26928,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1531020,int_stack+270840,int_stack+644532,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+587244,int_stack+1531020,int_stack+411420,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+171720,int_stack+160434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+33858,int_stack+0,int_stack+117018,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+94446,int_stack+33858,int_stack+533388,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+396966,int_stack+94446,int_stack+1347870,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+396966,int_stack+1427070,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+396966,int_stack+0,int_stack+270840,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1675164,int_stack+396966,int_stack+1531020,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+270840,int_stack+1675164,int_stack+587244,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1347870,int_stack+270840,int_stack+783570,2970);
 /*--- compute (ld|nl) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1837920,int_stack+1347870,int_stack+946920,2970);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+466860,int_stack+189408,int_stack+184260,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+482304,int_stack+195492,int_stack+189408,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+500556,int_stack+482304,int_stack+466860,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+531444,int_stack+202590,int_stack+195492,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+552738,int_stack+531444,int_stack+482304,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+589242,int_stack+552738,int_stack+500556,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+466860,int_stack+210780,int_stack+202590,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+640722,int_stack+466860,int_stack+531444,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+491430,int_stack+640722,int_stack+552738,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+683310,int_stack+491430,int_stack+589242,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+552270,int_stack+220140,int_stack+210780,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+580350,int_stack+552270,int_stack+466860,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+760530,int_stack+580350,int_stack+640722,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+831510,int_stack+760530,int_stack+491430,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+922770,int_stack+831510,int_stack+683310,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+466860,int_stack+230748,int_stack+220140,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+629490,int_stack+466860,int_stack+552270,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1030878,int_stack+629490,int_stack+580350,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+498684,int_stack+1030878,int_stack+760530,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+685650,int_stack+498684,int_stack+831510,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1112778,int_stack+685650,int_stack+922770,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+813414,int_stack+242682,int_stack+230748,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+849216,int_stack+813414,int_stack+466860,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+912864,int_stack+849216,int_stack+629490,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+912864,int_stack+1030878,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2639820,int_stack+0,int_stack+498684,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+466860,int_stack+2639820,int_stack+685650,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2788878,int_stack+466860,int_stack+1112778,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+637212,int_stack+256020,int_stack+242682,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+677226,int_stack+637212,int_stack+813414,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1006464,int_stack+677226,int_stack+849216,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+637212,int_stack+1006464,int_stack+912864,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+777612,int_stack+637212,int_stack+0,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+777612,int_stack+2639820,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+637212,int_stack+0,int_stack+466860,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+637212,int_stack+2788878,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+466860,int_stack+0,int_stack+270840,2970);
 /*--- compute (md|nl) ---*/
 hrr1_build_md(Libint->AB,int_stack+2639820,int_stack+466860,int_stack+1347870,2970);
 /*--- compute (lf|nl) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+2639820,int_stack+1837920,2970);
 return int_stack+0;}
