/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgnd(Libint_t*, prim_data*);

  /* Computes quartets of (lg|nd) integrals */

REALTYPE *hrr_order_lgnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[9][10] = int_stack + 10575;
 Libint->vrr_classes[9][11] = int_stack + 14205;
 Libint->vrr_classes[9][12] = int_stack + 18495;
 Libint->vrr_classes[10][10] = int_stack + 23500;
 Libint->vrr_classes[10][11] = int_stack + 27856;
 Libint->vrr_classes[10][12] = int_stack + 33004;
 Libint->vrr_classes[11][10] = int_stack + 39010;
 Libint->vrr_classes[11][11] = int_stack + 44158;
 Libint->vrr_classes[11][12] = int_stack + 50242;
 Libint->vrr_classes[12][10] = int_stack + 57340;
 Libint->vrr_classes[12][11] = int_stack + 63346;
 Libint->vrr_classes[12][12] = int_stack + 70444;
 memset(int_stack,0,78725*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 78725;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgnd(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78725,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+87635,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98165,int_stack+87635,int_stack+78725,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78725,int_stack+14205,int_stack+10575,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+18495,int_stack+14205,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+115985,int_stack+0,int_stack+78725,55);
 /*--- compute (lp|nd) ---*/
 hrr1_build_lp(Libint->AB,int_stack+137765,int_stack+115985,int_stack+98165,396);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78725,int_stack+27856,int_stack+23500,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+91793,int_stack+33004,int_stack+27856,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+91793,int_stack+78725,66);
 /*--- compute (mp|nd) ---*/
 hrr1_build_mp(Libint->AB,int_stack+191225,int_stack+0,int_stack+115985,396);
 /*--- compute (ld|nd) ---*/
 hrr1_build_ld(Libint->AB,int_stack+256565,int_stack+191225,int_stack+137765,396);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78725,int_stack+44158,int_stack+39010,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94169,int_stack+50242,int_stack+44158,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+112421,int_stack+94169,int_stack+78725,78);
 /*--- compute (np|nd) ---*/
 hrr1_build_np(Libint->AB,int_stack+363485,int_stack+112421,int_stack+0,396);
 /*--- compute (md|nd) ---*/
 hrr1_build_md(Libint->AB,int_stack+441893,int_stack+363485,int_stack+191225,396);
 /*--- compute (lf|nd) ---*/
 hrr1_build_lf(Libint->AB,int_stack+572573,int_stack+441893,int_stack+256565,396);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+63346,int_stack+57340,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+70444,int_stack+63346,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (op|nd) ---*/
 hrr1_build_op(Libint->AB,int_stack+143309,int_stack+39312,int_stack+112421,396);
 /*--- compute (nd|nd) ---*/
 hrr1_build_nd(Libint->AB,int_stack+750773,int_stack+143309,int_stack+363485,396);
 /*--- compute (mf|nd) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+750773,int_stack+441893,396);
 /*--- compute (lg|nd) ---*/
 hrr1_build_lg(Libint->AB,int_stack+217800,int_stack+0,int_stack+572573,396);
 return int_stack+217800;}
