/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgnf(Libint_t*, prim_data*);

  /* Computes quartets of (lg|nf) integrals */

REALTYPE *hrr_order_lgnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[9][10] = int_stack + 15300;
 Libint->vrr_classes[9][11] = int_stack + 18930;
 Libint->vrr_classes[9][12] = int_stack + 23220;
 Libint->vrr_classes[9][13] = int_stack + 28225;
 Libint->vrr_classes[10][10] = int_stack + 34000;
 Libint->vrr_classes[10][11] = int_stack + 38356;
 Libint->vrr_classes[10][12] = int_stack + 43504;
 Libint->vrr_classes[10][13] = int_stack + 49510;
 Libint->vrr_classes[11][10] = int_stack + 56440;
 Libint->vrr_classes[11][11] = int_stack + 61588;
 Libint->vrr_classes[11][12] = int_stack + 67672;
 Libint->vrr_classes[11][13] = int_stack + 74770;
 Libint->vrr_classes[12][10] = int_stack + 82960;
 Libint->vrr_classes[12][11] = int_stack + 88966;
 Libint->vrr_classes[12][12] = int_stack + 96064;
 Libint->vrr_classes[12][13] = int_stack + 104345;
 memset(int_stack,0,113900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 113900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgnf(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113900,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+122810,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+133340,int_stack+122810,int_stack+113900,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+151160,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+163445,int_stack+151160,int_stack+122810,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+184505,int_stack+163445,int_stack+133340,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113900,int_stack+18930,int_stack+15300,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124790,int_stack+23220,int_stack+18930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+137660,int_stack+124790,int_stack+113900,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+159440,int_stack+28225,int_stack+23220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+159440,int_stack+124790,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+214205,int_stack+0,int_stack+137660,55);
 /*--- compute (lp|nf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+250505,int_stack+214205,int_stack+184505,660);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+38356,int_stack+34000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+43504,int_stack+38356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113900,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+140036,int_stack+49510,int_stack+43504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+158054,int_stack+140036,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+158054,int_stack+113900,66);
 /*--- compute (mp|nf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+339605,int_stack+0,int_stack+214205,660);
 /*--- compute (ld|nf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+448505,int_stack+339605,int_stack+250505,660);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113900,int_stack+61588,int_stack+56440,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+129344,int_stack+67672,int_stack+61588,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+147596,int_stack+129344,int_stack+113900,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+178484,int_stack+74770,int_stack+67672,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+199778,int_stack+178484,int_stack+129344,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+236282,int_stack+199778,int_stack+147596,78);
 /*--- compute (np|nf) ---*/
 hrr1_build_np(Libint->AB,int_stack+626705,int_stack+236282,int_stack+0,660);
 /*--- compute (md|nf) ---*/
 hrr1_build_md(Libint->AB,int_stack+757385,int_stack+626705,int_stack+339605,660);
 /*--- compute (lf|nf) ---*/
 hrr1_build_lf(Libint->AB,int_stack+975185,int_stack+757385,int_stack+448505,660);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+88966,int_stack+82960,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+96064,int_stack+88966,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+113900,int_stack+104345,int_stack+96064,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+138743,int_stack+113900,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+75348,int_stack+138743,int_stack+39312,91);
 /*--- compute (op|nf) ---*/
 hrr1_build_op(Libint->AB,int_stack+287762,int_stack+75348,int_stack+236282,660);
 /*--- compute (nd|nf) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+287762,int_stack+626705,660);
 /*--- compute (mf|nf) ---*/
 hrr1_build_mf(Libint->AB,int_stack+261360,int_stack+0,int_stack+757385,660);
 /*--- compute (lg|nf) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1272185,int_stack+261360,int_stack+975185,660);
 return int_stack+1272185;}
