/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpnh(Libint_t*, prim_data*);

  /* Computes quartets of (lp|nh) integrals */

REALTYPE *hrr_order_lpnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[9][10] = int_stack + 26820;
 Libint->vrr_classes[9][11] = int_stack + 30450;
 Libint->vrr_classes[9][12] = int_stack + 34740;
 Libint->vrr_classes[9][13] = int_stack + 39745;
 Libint->vrr_classes[9][14] = int_stack + 45520;
 Libint->vrr_classes[9][15] = int_stack + 52120;
 memset(int_stack,0,59600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 59600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpnh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59600,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+68510,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79040,int_stack+68510,int_stack+59600,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+96860,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+109145,int_stack+96860,int_stack+68510,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+130205,int_stack+109145,int_stack+79040,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59600,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+159905,int_stack+59600,int_stack+96860,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+73775,int_stack+159905,int_stack+109145,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+184475,int_stack+73775,int_stack+130205,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+108875,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+125075,int_stack+108875,int_stack+59600,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+229025,int_stack+125075,int_stack+159905,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+108875,int_stack+229025,int_stack+73775,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+229025,int_stack+108875,int_stack+184475,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59600,int_stack+30450,int_stack+26820,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+70490,int_stack+34740,int_stack+30450,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+83360,int_stack+70490,int_stack+59600,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+105140,int_stack+39745,int_stack+34740,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+120155,int_stack+105140,int_stack+70490,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+145895,int_stack+120155,int_stack+83360,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+59600,int_stack+45520,int_stack+39745,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+182195,int_stack+59600,int_stack+105140,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+76925,int_stack+182195,int_stack+120155,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+291395,int_stack+76925,int_stack+145895,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+119825,int_stack+52120,int_stack+45520,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+139625,int_stack+119825,int_stack+59600,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+139625,int_stack+182195,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+119825,int_stack+0,int_stack+76925,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+119825,int_stack+291395,55);
 /*--- compute (lp|nh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+291395,int_stack+0,int_stack+229025,1386);
 return int_stack+291395;}
