/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_m0hh(Libint_t*, prim_data*);

  /* Computes quartets of (m0|hh) integrals */

REALTYPE *hrr_order_m0hh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][5] = int_stack + 0;
 Libint->vrr_classes[9][6] = int_stack + 1155;
 Libint->vrr_classes[9][7] = int_stack + 2695;
 Libint->vrr_classes[9][8] = int_stack + 4675;
 Libint->vrr_classes[9][9] = int_stack + 7150;
 Libint->vrr_classes[9][10] = int_stack + 10175;
 memset(int_stack,0,13805*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 13805;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_m0hh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+13805,int_stack+1155,int_stack+0,55);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+17270,int_stack+2695,int_stack+1155,55);
 /*--- compute (m0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+21890,int_stack+17270,int_stack+13805,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+28820,int_stack+4675,int_stack+2695,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+34760,int_stack+28820,int_stack+17270,55);
 /*--- compute (m0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+44000,int_stack+34760,int_stack+21890,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13805,int_stack+7150,int_stack+4675,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+55550,int_stack+13805,int_stack+28820,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+67430,int_stack+55550,int_stack+34760,55);
 /*--- compute (m0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+21230,int_stack+67430,int_stack+44000,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38555,int_stack+10175,int_stack+7150,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82830,int_stack+38555,int_stack+13805,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+82830,int_stack+55550,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+38555,int_stack+0,int_stack+67430,55);
 /*--- compute (m0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+61655,int_stack+38555,int_stack+21230,55);
 return int_stack+61655;}
