/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdmf(Libint_t*, prim_data*);

  /* Computes quartets of (md|mf) integrals */

REALTYPE *hrr_order_mdmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[10][9] = int_stack + 15950;
 Libint->vrr_classes[10][10] = int_stack + 19580;
 Libint->vrr_classes[10][11] = int_stack + 23936;
 Libint->vrr_classes[10][12] = int_stack + 29084;
 Libint->vrr_classes[11][9] = int_stack + 35090;
 Libint->vrr_classes[11][10] = int_stack + 39380;
 Libint->vrr_classes[11][11] = int_stack + 44528;
 Libint->vrr_classes[11][12] = int_stack + 50612;
 memset(int_stack,0,57710*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 57710;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdmf(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57710,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+66785,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+77675,int_stack+66785,int_stack+57710,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+95825,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108695,int_stack+95825,int_stack+66785,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+130475,int_stack+108695,int_stack+77675,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57710,int_stack+19580,int_stack+15950,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68600,int_stack+23936,int_stack+19580,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+81668,int_stack+68600,int_stack+57710,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103448,int_stack+29084,int_stack+23936,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+103448,int_stack+68600,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+160725,int_stack+0,int_stack+81668,66);
 /*--- compute (mp|mf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+197025,int_stack+160725,int_stack+130475,550);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+39380,int_stack+35090,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+44528,int_stack+39380,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+57710,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83450,int_stack+50612,int_stack+44528,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+101702,int_stack+83450,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+101702,int_stack+57710,78);
 /*--- compute (np|mf) ---*/
 hrr1_build_np(Libint->AB,int_stack+42900,int_stack+0,int_stack+160725,550);
 /*--- compute (md|mf) ---*/
 hrr1_build_md(Libint->AB,int_stack+287775,int_stack+42900,int_stack+197025,550);
 return int_stack+287775;}
