/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdnp(Libint_t*, prim_data*);

  /* Computes quartets of (md|np) integrals */

REALTYPE *hrr_order_mdnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[10][10] = int_stack + 7920;
 Libint->vrr_classes[10][11] = int_stack + 12276;
 Libint->vrr_classes[11][10] = int_stack + 17424;
 Libint->vrr_classes[11][11] = int_stack + 22572;
 memset(int_stack,0,28656*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 28656;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdnp(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28656,int_stack+3630,int_stack+0,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39546,int_stack+12276,int_stack+7920,66);
 /*--- compute (mp|np) ---*/
 hrr1_build_mp(Libint->AB,int_stack+52614,int_stack+39546,int_stack+28656,198);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+22572,int_stack+17424,78);
 /*--- compute (np|np) ---*/
 hrr1_build_np(Libint->AB,int_stack+85284,int_stack+0,int_stack+39546,198);
 /*--- compute (md|np) ---*/
 hrr1_build_md(Libint->AB,int_stack+124488,int_stack+85284,int_stack+52614,198);
 return int_stack+124488;}
