/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhkk(Libint_t*, prim_data*);

  /* Computes quartets of (mh|kk) integrals */

REALTYPE *hrr_order_mhkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][7] = int_stack + 0;
 Libint->vrr_classes[9][8] = int_stack + 1980;
 Libint->vrr_classes[9][9] = int_stack + 4455;
 Libint->vrr_classes[9][10] = int_stack + 7480;
 Libint->vrr_classes[9][11] = int_stack + 11110;
 Libint->vrr_classes[9][12] = int_stack + 15400;
 Libint->vrr_classes[9][13] = int_stack + 20405;
 Libint->vrr_classes[9][14] = int_stack + 26180;
 Libint->vrr_classes[10][7] = int_stack + 32780;
 Libint->vrr_classes[10][8] = int_stack + 35156;
 Libint->vrr_classes[10][9] = int_stack + 38126;
 Libint->vrr_classes[10][10] = int_stack + 41756;
 Libint->vrr_classes[10][11] = int_stack + 46112;
 Libint->vrr_classes[10][12] = int_stack + 51260;
 Libint->vrr_classes[10][13] = int_stack + 57266;
 Libint->vrr_classes[10][14] = int_stack + 64196;
 Libint->vrr_classes[11][7] = int_stack + 72116;
 Libint->vrr_classes[11][8] = int_stack + 74924;
 Libint->vrr_classes[11][9] = int_stack + 78434;
 Libint->vrr_classes[11][10] = int_stack + 82724;
 Libint->vrr_classes[11][11] = int_stack + 87872;
 Libint->vrr_classes[11][12] = int_stack + 93956;
 Libint->vrr_classes[11][13] = int_stack + 101054;
 Libint->vrr_classes[11][14] = int_stack + 109244;
 Libint->vrr_classes[12][7] = int_stack + 118604;
 Libint->vrr_classes[12][8] = int_stack + 121880;
 Libint->vrr_classes[12][9] = int_stack + 125975;
 Libint->vrr_classes[12][10] = int_stack + 130980;
 Libint->vrr_classes[12][11] = int_stack + 136986;
 Libint->vrr_classes[12][12] = int_stack + 144084;
 Libint->vrr_classes[12][13] = int_stack + 152365;
 Libint->vrr_classes[12][14] = int_stack + 161920;
 Libint->vrr_classes[13][7] = int_stack + 172840;
 Libint->vrr_classes[13][8] = int_stack + 176620;
 Libint->vrr_classes[13][9] = int_stack + 181345;
 Libint->vrr_classes[13][10] = int_stack + 187120;
 Libint->vrr_classes[13][11] = int_stack + 194050;
 Libint->vrr_classes[13][12] = int_stack + 202240;
 Libint->vrr_classes[13][13] = int_stack + 211795;
 Libint->vrr_classes[13][14] = int_stack + 222820;
 Libint->vrr_classes[14][7] = int_stack + 235420;
 Libint->vrr_classes[14][8] = int_stack + 239740;
 Libint->vrr_classes[14][9] = int_stack + 245140;
 Libint->vrr_classes[14][10] = int_stack + 251740;
 Libint->vrr_classes[14][11] = int_stack + 259660;
 Libint->vrr_classes[14][12] = int_stack + 269020;
 Libint->vrr_classes[14][13] = int_stack + 279940;
 Libint->vrr_classes[14][14] = int_stack + 292540;
 memset(int_stack,0,306940*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 306940;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhkk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+306940,int_stack+1980,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+312880,int_stack+4455,int_stack+1980,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+320305,int_stack+312880,int_stack+306940,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+332185,int_stack+7480,int_stack+4455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+341260,int_stack+332185,int_stack+312880,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+356110,int_stack+341260,int_stack+320305,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306940,int_stack+11110,int_stack+7480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+375910,int_stack+306940,int_stack+332185,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+394060,int_stack+375910,int_stack+341260,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+317830,int_stack+394060,int_stack+356110,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+347530,int_stack+15400,int_stack+11110,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+418810,int_stack+347530,int_stack+306940,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+440590,int_stack+418810,int_stack+375910,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+470840,int_stack+440590,int_stack+394060,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+360400,int_stack+470840,int_stack+317830,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306940,int_stack+20405,int_stack+15400,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+507965,int_stack+306940,int_stack+347530,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+321955,int_stack+507965,int_stack+418810,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+533705,int_stack+321955,int_stack+440590,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+401980,int_stack+533705,int_stack+470840,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+579080,int_stack+401980,int_stack+360400,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+358255,int_stack+26180,int_stack+20405,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+453955,int_stack+358255,int_stack+306940,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+358255,int_stack+453955,int_stack+507965,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+453955,int_stack+358255,int_stack+321955,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+306940,int_stack+453955,int_stack+533705,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+453955,int_stack+306940,int_stack+401980,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+306940,int_stack+453955,int_stack+579080,55);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+378220,int_stack+35156,int_stack+32780,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+385348,int_stack+38126,int_stack+35156,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+394258,int_stack+385348,int_stack+378220,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+408514,int_stack+41756,int_stack+38126,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+419404,int_stack+408514,int_stack+385348,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+437224,int_stack+419404,int_stack+394258,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+378220,int_stack+46112,int_stack+41756,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+460984,int_stack+378220,int_stack+408514,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+482764,int_stack+460984,int_stack+419404,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+391288,int_stack+482764,int_stack+437224,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+426928,int_stack+51260,int_stack+46112,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+512464,int_stack+426928,int_stack+378220,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+538600,int_stack+512464,int_stack+460984,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+574900,int_stack+538600,int_stack+482764,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+442372,int_stack+574900,int_stack+391288,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+378220,int_stack+57266,int_stack+51260,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+378220,int_stack+426928,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+396238,int_stack+0,int_stack+512464,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+619450,int_stack+396238,int_stack+538600,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+492268,int_stack+619450,int_stack+574900,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+673900,int_stack+492268,int_stack+442372,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+439798,int_stack+64196,int_stack+57266,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+554638,int_stack+439798,int_stack+378220,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+439798,int_stack+554638,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+439798,int_stack+396238,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+378220,int_stack+0,int_stack+619450,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+554638,int_stack+378220,int_stack+492268,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+378220,int_stack+554638,int_stack+673900,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+463756,int_stack+378220,int_stack+306940,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+306940,int_stack+74924,int_stack+72116,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+315364,int_stack+78434,int_stack+74924,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+325894,int_stack+315364,int_stack+306940,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+342742,int_stack+82724,int_stack+78434,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+355612,int_stack+342742,int_stack+315364,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+677596,int_stack+355612,int_stack+325894,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306940,int_stack+87872,int_stack+82724,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+705676,int_stack+306940,int_stack+342742,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+705676,int_stack+355612,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+322384,int_stack+0,int_stack+677596,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+677596,int_stack+93956,int_stack+87872,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35100,int_stack+677596,int_stack+306940,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+731416,int_stack+35100,int_stack+705676,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+774316,int_stack+731416,int_stack+0,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+826966,int_stack+774316,int_stack+322384,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+101054,int_stack+93956,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+306940,int_stack+0,int_stack+677596,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+677596,int_stack+306940,int_stack+35100,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+677596,int_stack+731416,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+885934,int_stack+21294,int_stack+774316,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+729076,int_stack+885934,int_stack+826966,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+807700,int_stack+109244,int_stack+101054,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+832270,int_stack+807700,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+959644,int_stack+832270,int_stack+306940,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+807700,int_stack+959644,int_stack+677596,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+959644,int_stack+807700,int_stack+21294,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+959644,int_stack+885934,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+807700,int_stack+0,int_stack+729076,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+908788,int_stack+807700,int_stack+378220,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1165396,int_stack+908788,int_stack+463756,1296);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+121880,int_stack+118604,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9828,int_stack+125975,int_stack+121880,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22113,int_stack+9828,int_stack+0,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41769,int_stack+130980,int_stack+125975,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56784,int_stack+41769,int_stack+9828,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81354,int_stack+56784,int_stack+22113,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+136986,int_stack+130980,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+306940,int_stack+0,int_stack+41769,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+336970,int_stack+306940,int_stack+56784,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18018,int_stack+336970,int_stack+81354,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67158,int_stack+144084,int_stack+136986,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88452,int_stack+67158,int_stack+0,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+377920,int_stack+88452,int_stack+306940,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+427970,int_stack+377920,int_stack+336970,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+306940,int_stack+427970,int_stack+18018,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+152365,int_stack+144084,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+489395,int_stack+0,int_stack+67158,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24843,int_stack+489395,int_stack+88452,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+531983,int_stack+24843,int_stack+377920,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+607058,int_stack+531983,int_stack+427970,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+375736,int_stack+607058,int_stack+306940,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+306940,int_stack+161920,int_stack+152365,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+84903,int_stack+306940,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+693053,int_stack+84903,int_stack+489395,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1593076,int_stack+693053,int_stack+24843,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+693053,int_stack+1593076,int_stack+531983,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+693053,int_stack+607058,91);
 /*--- compute (q0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+467464,int_stack+0,int_stack+375736,91);
 /*--- compute (op|kk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1593076,int_stack+467464,int_stack+807700,1296);
 /*--- compute (nd|kk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1896340,int_stack+1593076,int_stack+908788,1296);
 /*--- compute (mf|kk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2409556,int_stack+1896340,int_stack+1165396,1296);
 /*--- compute (r0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+176620,int_stack+172840,105);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11340,int_stack+181345,int_stack+176620,105);
 /*--- compute (r0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+25515,int_stack+11340,int_stack+0,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48195,int_stack+187120,int_stack+181345,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65520,int_stack+48195,int_stack+11340,105);
 /*--- compute (r0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+93870,int_stack+65520,int_stack+25515,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+194050,int_stack+187120,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131670,int_stack+0,int_stack+48195,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+306940,int_stack+131670,int_stack+65520,105);
 /*--- compute (r0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+20790,int_stack+306940,int_stack+93870,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77490,int_stack+202240,int_stack+194050,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+354190,int_stack+77490,int_stack+0,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+395770,int_stack+354190,int_stack+131670,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+102060,int_stack+395770,int_stack+306940,105);
 /*--- compute (r0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+585400,int_stack+102060,int_stack+20790,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306940,int_stack+211795,int_stack+202240,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+306940,int_stack+77490,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+664780,int_stack+0,int_stack+354190,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+734080,int_stack+664780,int_stack+395770,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+335605,int_stack+734080,int_stack+102060,105);
 /*--- compute (r0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+49140,int_stack+335605,int_stack+585400,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+585400,int_stack+222820,int_stack+211795,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+154980,int_stack+585400,int_stack+306940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+820705,int_stack+154980,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+902605,int_stack+820705,int_stack+664780,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+585400,int_stack+902605,int_stack+734080,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+706675,int_stack+585400,int_stack+335605,105);
 /*--- compute (r0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+306940,int_stack+706675,int_stack+49140,105);
 /*--- compute (qp|kk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+585400,int_stack+306940,int_stack+467464,1296);
 /*--- compute (od|kk) ---*/
 hrr1_build_od(Libint->AB,int_stack+939208,int_stack+585400,int_stack+1593076,1296);
 /*--- compute (nf|kk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3122356,int_stack+939208,int_stack+1896340,1296);
 /*--- compute (mg|kk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+3977716,int_stack+3122356,int_stack+2409556,1296);
 /*--- compute (t0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1545736,int_stack+239740,int_stack+235420,120);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1558696,int_stack+245140,int_stack+239740,120);
 /*--- compute (t0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+1574896,int_stack+1558696,int_stack+1545736,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1600816,int_stack+251740,int_stack+245140,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+1620616,int_stack+1600816,int_stack+1558696,120);
 /*--- compute (t0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+1653016,int_stack+1620616,int_stack+1574896,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1545736,int_stack+259660,int_stack+251740,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1696216,int_stack+1545736,int_stack+1600816,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+1735816,int_stack+1696216,int_stack+1620616,120);
 /*--- compute (t0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+1569496,int_stack+1735816,int_stack+1653016,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1634296,int_stack+269020,int_stack+259660,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1789816,int_stack+1634296,int_stack+1545736,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1837336,int_stack+1789816,int_stack+1696216,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+1903336,int_stack+1837336,int_stack+1735816,120);
 /*--- compute (t0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+1662376,int_stack+1903336,int_stack+1569496,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1545736,int_stack+279940,int_stack+269020,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1984336,int_stack+1545736,int_stack+1634296,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1578496,int_stack+1984336,int_stack+1789816,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2040496,int_stack+1578496,int_stack+1837336,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1753096,int_stack+2040496,int_stack+1903336,120);
 /*--- compute (t0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+2139496,int_stack+1753096,int_stack+1662376,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1657696,int_stack+292540,int_stack+279940,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1866496,int_stack+1657696,int_stack+1545736,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1657696,int_stack+1866496,int_stack+1984336,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1866496,int_stack+1657696,int_stack+1578496,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1545736,int_stack+1866496,int_stack+2040496,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1866496,int_stack+1545736,int_stack+1753096,120);
 /*--- compute (t0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+1545736,int_stack+1866496,int_stack+2139496,120);
 /*--- compute (rp|kk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1701256,int_stack+1545736,int_stack+306940,1296);
 /*--- compute (qd|kk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+2109496,int_stack+1701256,int_stack+585400,1296);
 /*--- compute (of|kk) ---*/
 hrr1_build_of(Libint->AB,int_stack+5046916,int_stack+2109496,int_stack+939208,1296);
 /*--- compute (ng|kk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+0,int_stack+5046916,int_stack+3122356,1296);
 /*--- compute (mh|kk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+1283040,int_stack+0,int_stack+3977716,1296);
 return int_stack+1283040;}
