/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpnn(Libint_t*, prim_data*);

  /* Computes quartets of (mp|nn) integrals */

REALTYPE *hrr_order_mpnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[9][19] = int_stack + 61050;
 Libint->vrr_classes[9][20] = int_stack + 72600;
 Libint->vrr_classes[10][10] = int_stack + 85305;
 Libint->vrr_classes[10][11] = int_stack + 89661;
 Libint->vrr_classes[10][12] = int_stack + 94809;
 Libint->vrr_classes[10][13] = int_stack + 100815;
 Libint->vrr_classes[10][14] = int_stack + 107745;
 Libint->vrr_classes[10][15] = int_stack + 115665;
 Libint->vrr_classes[10][16] = int_stack + 124641;
 Libint->vrr_classes[10][17] = int_stack + 134739;
 Libint->vrr_classes[10][18] = int_stack + 146025;
 Libint->vrr_classes[10][19] = int_stack + 158565;
 Libint->vrr_classes[10][20] = int_stack + 172425;
 memset(int_stack,0,187671*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 187671;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpnn(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187671,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+198561,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+211431,int_stack+198561,int_stack+187671,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+233211,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+248226,int_stack+233211,int_stack+198561,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+273966,int_stack+248226,int_stack+211431,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187671,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+310266,int_stack+187671,int_stack+233211,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+204996,int_stack+310266,int_stack+248226,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+340296,int_stack+204996,int_stack+273966,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+247896,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+267696,int_stack+247896,int_stack+187671,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+394746,int_stack+267696,int_stack+310266,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+444796,int_stack+394746,int_stack+204996,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+509146,int_stack+444796,int_stack+340296,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+187671,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+302346,int_stack+187671,int_stack+247896,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+585376,int_stack+302346,int_stack+267696,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+210111,int_stack+585376,int_stack+394746,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+341946,int_stack+210111,int_stack+444796,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+643126,int_stack+341946,int_stack+509146,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+432036,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+457281,int_stack+432036,int_stack+187671,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+502161,int_stack+457281,int_stack+302346,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+744766,int_stack+502161,int_stack+585376,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+831391,int_stack+744766,int_stack+210111,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+187671,int_stack+831391,int_stack+341946,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+936496,int_stack+187671,int_stack+643126,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+307791,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+336006,int_stack+307791,int_stack+432036,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+568161,int_stack+336006,int_stack+457281,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+386496,int_stack+568161,int_stack+502161,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1067176,int_stack+386496,int_stack+744766,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+642961,int_stack+1067176,int_stack+831391,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1188451,int_stack+642961,int_stack+187671,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1342891,int_stack+1188451,int_stack+936496,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+187671,int_stack+61050,int_stack+50600,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+219021,int_stack+187671,int_stack+307791,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+783101,int_stack+219021,int_stack+336006,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+867251,int_stack+783101,int_stack+568161,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+485496,int_stack+867251,int_stack+386496,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+275451,int_stack+485496,int_stack+1067176,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+979451,int_stack+275451,int_stack+642961,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1506241,int_stack+979451,int_stack+1188451,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1699291,int_stack+1506241,int_stack+1342891,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+437151,int_stack+72600,int_stack+61050,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+624096,int_stack+437151,int_stack+187671,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+686796,int_stack+624096,int_stack+219021,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1159631,int_stack+686796,int_stack+783101,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+624096,int_stack+1159631,int_stack+867251,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1159631,int_stack+624096,int_stack+485496,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+437151,int_stack+1159631,int_stack+275451,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1159631,int_stack+437151,int_stack+979451,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+187671,int_stack+1159631,int_stack+1506241,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+423621,int_stack+187671,int_stack+1699291,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187671,int_stack+89661,int_stack+85305,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+200739,int_stack+94809,int_stack+89661,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+216183,int_stack+200739,int_stack+187671,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+242319,int_stack+100815,int_stack+94809,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+260337,int_stack+242319,int_stack+200739,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+291225,int_stack+260337,int_stack+216183,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+187671,int_stack+107745,int_stack+100815,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+334785,int_stack+187671,int_stack+242319,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+208461,int_stack+334785,int_stack+260337,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+663201,int_stack+208461,int_stack+291225,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+259941,int_stack+115665,int_stack+107745,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+283701,int_stack+259941,int_stack+187671,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+728541,int_stack+283701,int_stack+334785,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+325281,int_stack+728541,int_stack+208461,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+788601,int_stack+325281,int_stack+663201,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+663201,int_stack+124641,int_stack+115665,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+187671,int_stack+663201,int_stack+259941,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+880077,int_stack+187671,int_stack+283701,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+235191,int_stack+880077,int_stack+728541,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+949377,int_stack+235191,int_stack+325281,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1057485,int_stack+949377,int_stack+788601,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+325281,int_stack+134739,int_stack+124641,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+355575,int_stack+325281,int_stack+663201,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+663201,int_stack+355575,int_stack+187671,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+742401,int_stack+663201,int_stack+880077,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1179453,int_stack+742401,int_stack+235191,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1305579,int_stack+1179453,int_stack+949377,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+846351,int_stack+1305579,int_stack+1057485,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+187671,int_stack+146025,int_stack+134739,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+221529,int_stack+187671,int_stack+325281,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1003167,int_stack+221529,int_stack+355575,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+282117,int_stack+1003167,int_stack+663201,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1449723,int_stack+282117,int_stack+742401,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+663201,int_stack+1449723,int_stack+1179453,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1092927,int_stack+663201,int_stack+1305579,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1595253,int_stack+1092927,int_stack+846351,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+831369,int_stack+158565,int_stack+146025,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+868989,int_stack+831369,int_stack+187671,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1278255,int_stack+868989,int_stack+221529,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1278255,int_stack+1003167,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1791273,int_stack+0,int_stack+282117,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+187671,int_stack+1791273,int_stack+1449723,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1957593,int_stack+187671,int_stack+663201,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2173809,int_stack+1957593,int_stack+1092927,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+936705,int_stack+2173809,int_stack+1595253,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+663201,int_stack+172425,int_stack+158565,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+704781,int_stack+663201,int_stack+831369,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1379235,int_stack+704781,int_stack+868989,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+663201,int_stack+1379235,int_stack+1278255,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1176285,int_stack+663201,int_stack+0,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+663201,int_stack+1176285,int_stack+1791273,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1176285,int_stack+663201,int_stack+187671,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+663201,int_stack+1176285,int_stack+1957593,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1176285,int_stack+663201,int_stack+2173809,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1459425,int_stack+1176285,int_stack+936705,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+663201,int_stack+1459425,int_stack+423621,4356);
 return int_stack+663201;}
