/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngng(Libint_t*, prim_data*);

  /* Computes quartets of (ng|ng) integrals */

REALTYPE *hrr_order_ngng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[11][10] = int_stack + 30360;
 Libint->vrr_classes[11][11] = int_stack + 35508;
 Libint->vrr_classes[11][12] = int_stack + 41592;
 Libint->vrr_classes[11][13] = int_stack + 48690;
 Libint->vrr_classes[11][14] = int_stack + 56880;
 Libint->vrr_classes[12][10] = int_stack + 66240;
 Libint->vrr_classes[12][11] = int_stack + 72246;
 Libint->vrr_classes[12][12] = int_stack + 79344;
 Libint->vrr_classes[12][13] = int_stack + 87625;
 Libint->vrr_classes[12][14] = int_stack + 97180;
 Libint->vrr_classes[13][10] = int_stack + 108100;
 Libint->vrr_classes[13][11] = int_stack + 115030;
 Libint->vrr_classes[13][12] = int_stack + 123220;
 Libint->vrr_classes[13][13] = int_stack + 132775;
 Libint->vrr_classes[13][14] = int_stack + 143800;
 Libint->vrr_classes[14][10] = int_stack + 156400;
 Libint->vrr_classes[14][11] = int_stack + 164320;
 Libint->vrr_classes[14][12] = int_stack + 173680;
 Libint->vrr_classes[14][13] = int_stack + 184600;
 Libint->vrr_classes[14][14] = int_stack + 197200;
 memset(int_stack,0,211600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 211600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngng(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211600,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+224668,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+240112,int_stack+224668,int_stack+211600,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+266248,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+284266,int_stack+266248,int_stack+224668,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+315154,int_stack+284266,int_stack+240112,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+211600,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+358714,int_stack+211600,int_stack+266248,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+211600,int_stack+358714,int_stack+284266,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+358714,int_stack+211600,int_stack+315154,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211600,int_stack+35508,int_stack+30360,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+227044,int_stack+41592,int_stack+35508,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+245296,int_stack+227044,int_stack+211600,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+276184,int_stack+48690,int_stack+41592,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+297478,int_stack+276184,int_stack+227044,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+424054,int_stack+297478,int_stack+245296,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+211600,int_stack+56880,int_stack+48690,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+211600,int_stack+276184,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+211600,int_stack+0,int_stack+297478,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+272440,int_stack+211600,int_stack+424054,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+424054,int_stack+272440,int_stack+358714,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211600,int_stack+72246,int_stack+66240,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+229618,int_stack+79344,int_stack+72246,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+229618,int_stack+211600,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+36036,int_stack+87625,int_stack+79344,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+349660,int_stack+36036,int_stack+229618,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+211600,int_stack+349660,int_stack+0,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+97180,int_stack+87625,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+620074,int_stack+0,int_stack+36036,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+620074,int_stack+349660,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+620074,int_stack+0,int_stack+211600,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+710164,int_stack+620074,int_stack+272440,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+941824,int_stack+710164,int_stack+424054,990);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211600,int_stack+115030,int_stack+108100,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+232390,int_stack+123220,int_stack+115030,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+256960,int_stack+232390,int_stack+211600,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+298540,int_stack+132775,int_stack+123220,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+327205,int_stack+298540,int_stack+232390,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+376345,int_stack+327205,int_stack+256960,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+211600,int_stack+143800,int_stack+132775,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+445645,int_stack+211600,int_stack+298540,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+211600,int_stack+445645,int_stack+327205,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+445645,int_stack+211600,int_stack+376345,105);
 /*--- compute (qp|ng) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1333864,int_stack+445645,int_stack+620074,990);
 /*--- compute (od|ng) ---*/
 hrr1_build_od(Libint->AB,int_stack+1604134,int_stack+1333864,int_stack+710164,990);
 /*--- compute (nf|ng) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2067454,int_stack+1604134,int_stack+941824,990);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211600,int_stack+164320,int_stack+156400,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+235360,int_stack+173680,int_stack+164320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+263440,int_stack+235360,int_stack+211600,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+310960,int_stack+184600,int_stack+173680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+343720,int_stack+310960,int_stack+235360,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+549595,int_stack+343720,int_stack+263440,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+211600,int_stack+197200,int_stack+184600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+628795,int_stack+211600,int_stack+310960,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+694315,int_stack+628795,int_stack+343720,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+787915,int_stack+694315,int_stack+549595,120);
 /*--- compute (rp|ng) ---*/
 hrr1_build_rp(Libint->AB,int_stack+906715,int_stack+787915,int_stack+445645,990);
 /*--- compute (qd|ng) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+906715,int_stack+1333864,990);
 /*--- compute (of|ng) ---*/
 hrr1_build_of(Libint->AB,int_stack+540540,int_stack+0,int_stack+1604134,990);
 /*--- compute (ng|ng) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2720854,int_stack+540540,int_stack+2067454,990);
 return int_stack+2720854;}
