/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngnh(Libint_t*, prim_data*);

  /* Computes quartets of (ng|nh) integrals */

REALTYPE *hrr_order_ngnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[11][10] = int_stack + 39336;
 Libint->vrr_classes[11][11] = int_stack + 44484;
 Libint->vrr_classes[11][12] = int_stack + 50568;
 Libint->vrr_classes[11][13] = int_stack + 57666;
 Libint->vrr_classes[11][14] = int_stack + 65856;
 Libint->vrr_classes[11][15] = int_stack + 75216;
 Libint->vrr_classes[12][10] = int_stack + 85824;
 Libint->vrr_classes[12][11] = int_stack + 91830;
 Libint->vrr_classes[12][12] = int_stack + 98928;
 Libint->vrr_classes[12][13] = int_stack + 107209;
 Libint->vrr_classes[12][14] = int_stack + 116764;
 Libint->vrr_classes[12][15] = int_stack + 127684;
 Libint->vrr_classes[13][10] = int_stack + 140060;
 Libint->vrr_classes[13][11] = int_stack + 146990;
 Libint->vrr_classes[13][12] = int_stack + 155180;
 Libint->vrr_classes[13][13] = int_stack + 164735;
 Libint->vrr_classes[13][14] = int_stack + 175760;
 Libint->vrr_classes[13][15] = int_stack + 188360;
 Libint->vrr_classes[14][10] = int_stack + 202640;
 Libint->vrr_classes[14][11] = int_stack + 210560;
 Libint->vrr_classes[14][12] = int_stack + 219920;
 Libint->vrr_classes[14][13] = int_stack + 230840;
 Libint->vrr_classes[14][14] = int_stack + 243440;
 Libint->vrr_classes[14][15] = int_stack + 257840;
 memset(int_stack,0,274160*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 274160;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngnh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+287228,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+302672,int_stack+287228,int_stack+274160,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+328808,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+346826,int_stack+328808,int_stack+287228,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+377714,int_stack+346826,int_stack+302672,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+421274,int_stack+274160,int_stack+328808,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+294950,int_stack+421274,int_stack+346826,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+457310,int_stack+294950,int_stack+377714,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+346430,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+370190,int_stack+346430,int_stack+274160,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+522650,int_stack+370190,int_stack+421274,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+346430,int_stack+522650,int_stack+294950,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+522650,int_stack+346430,int_stack+457310,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+44484,int_stack+39336,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+289604,int_stack+50568,int_stack+44484,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+307856,int_stack+289604,int_stack+274160,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+338744,int_stack+57666,int_stack+50568,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+360038,int_stack+338744,int_stack+289604,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+396542,int_stack+360038,int_stack+307856,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+65856,int_stack+57666,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+448022,int_stack+274160,int_stack+338744,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+298730,int_stack+448022,int_stack+360038,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+614126,int_stack+298730,int_stack+396542,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+359570,int_stack+75216,int_stack+65856,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+387650,int_stack+359570,int_stack+274160,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+387650,int_stack+448022,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+359570,int_stack+0,int_stack+298730,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+691346,int_stack+359570,int_stack+614126,78);
 /*--- compute (np|nh) ---*/
 hrr1_build_np(Libint->AB,int_stack+799454,int_stack+691346,int_stack+522650,1386);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+91830,int_stack+85824,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+98928,int_stack+91830,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+274160,int_stack+107209,int_stack+98928,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+299003,int_stack+274160,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+341591,int_stack+299003,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+116764,int_stack+107209,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+28665,int_stack+0,int_stack+274160,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+401651,int_stack+28665,int_stack+299003,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+472631,int_stack+401651,int_stack+341591,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+274160,int_stack+127684,int_stack+116764,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+306920,int_stack+274160,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+562721,int_stack+306920,int_stack+28665,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+562721,int_stack+401651,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+562721,int_stack+0,int_stack+472631,91);
 /*--- compute (op|nh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1073882,int_stack+562721,int_stack+691346,1386);
 /*--- compute (nd|nh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1398206,int_stack+1073882,int_stack+799454,1386);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+146990,int_stack+140060,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+155180,int_stack+146990,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+164735,int_stack+155180,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+688847,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+737987,int_stack+688847,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+175760,int_stack+164735,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+115605,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+115605,int_stack+688847,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+807287,int_stack+33075,int_stack+737987,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+688847,int_stack+188360,int_stack+175760,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+726647,int_stack+688847,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+911237,int_stack+726647,int_stack+115605,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+274160,int_stack+911237,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+911237,int_stack+274160,int_stack+807287,105);
 /*--- compute (qp|nh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1947062,int_stack+911237,int_stack+562721,1386);
 /*--- compute (od|nh) ---*/
 hrr1_build_od(Libint->AB,int_stack+2325440,int_stack+1947062,int_stack+1073882,1386);
 /*--- compute (nf|nh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+2974088,int_stack+2325440,int_stack+1398206,1386);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274160,int_stack+210560,int_stack+202640,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+297920,int_stack+219920,int_stack+210560,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+326000,int_stack+297920,int_stack+274160,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+373520,int_stack+230840,int_stack+219920,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+406280,int_stack+373520,int_stack+297920,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+462440,int_stack+406280,int_stack+326000,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274160,int_stack+243440,int_stack+230840,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+541640,int_stack+274160,int_stack+373520,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+311960,int_stack+541640,int_stack+406280,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+607160,int_stack+311960,int_stack+462440,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+405560,int_stack+257840,int_stack+243440,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+448760,int_stack+405560,int_stack+274160,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+725960,int_stack+448760,int_stack+541640,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+405560,int_stack+725960,int_stack+311960,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+725960,int_stack+405560,int_stack+607160,120);
 /*--- compute (rp|nh) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1056767,int_stack+725960,int_stack+911237,1386);
 /*--- compute (qd|nh) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+1056767,int_stack+1947062,1386);
 /*--- compute (of|nh) ---*/
 hrr1_build_of(Libint->AB,int_stack+756756,int_stack+0,int_stack+2325440,1386);
 /*--- compute (ng|nh) ---*/
 hrr1_build_ng(Libint->AB,int_stack+3888848,int_stack+756756,int_stack+2974088,1386);
 return int_stack+3888848;}
