/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nink(Libint_t*, prim_data*);

  /* Computes quartets of (ni|nk) integrals */

REALTYPE *hrr_order_nink(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[11][10] = int_stack + 60720;
 Libint->vrr_classes[11][11] = int_stack + 65868;
 Libint->vrr_classes[11][12] = int_stack + 71952;
 Libint->vrr_classes[11][13] = int_stack + 79050;
 Libint->vrr_classes[11][14] = int_stack + 87240;
 Libint->vrr_classes[11][15] = int_stack + 96600;
 Libint->vrr_classes[11][16] = int_stack + 107208;
 Libint->vrr_classes[11][17] = int_stack + 119142;
 Libint->vrr_classes[12][10] = int_stack + 132480;
 Libint->vrr_classes[12][11] = int_stack + 138486;
 Libint->vrr_classes[12][12] = int_stack + 145584;
 Libint->vrr_classes[12][13] = int_stack + 153865;
 Libint->vrr_classes[12][14] = int_stack + 163420;
 Libint->vrr_classes[12][15] = int_stack + 174340;
 Libint->vrr_classes[12][16] = int_stack + 186716;
 Libint->vrr_classes[12][17] = int_stack + 200639;
 Libint->vrr_classes[13][10] = int_stack + 216200;
 Libint->vrr_classes[13][11] = int_stack + 223130;
 Libint->vrr_classes[13][12] = int_stack + 231320;
 Libint->vrr_classes[13][13] = int_stack + 240875;
 Libint->vrr_classes[13][14] = int_stack + 251900;
 Libint->vrr_classes[13][15] = int_stack + 264500;
 Libint->vrr_classes[13][16] = int_stack + 278780;
 Libint->vrr_classes[13][17] = int_stack + 294845;
 Libint->vrr_classes[14][10] = int_stack + 312800;
 Libint->vrr_classes[14][11] = int_stack + 320720;
 Libint->vrr_classes[14][12] = int_stack + 330080;
 Libint->vrr_classes[14][13] = int_stack + 341000;
 Libint->vrr_classes[14][14] = int_stack + 353600;
 Libint->vrr_classes[14][15] = int_stack + 368000;
 Libint->vrr_classes[14][16] = int_stack + 384320;
 Libint->vrr_classes[14][17] = int_stack + 402680;
 Libint->vrr_classes[15][10] = int_stack + 423200;
 Libint->vrr_classes[15][11] = int_stack + 432176;
 Libint->vrr_classes[15][12] = int_stack + 442784;
 Libint->vrr_classes[15][13] = int_stack + 455160;
 Libint->vrr_classes[15][14] = int_stack + 469440;
 Libint->vrr_classes[15][15] = int_stack + 485760;
 Libint->vrr_classes[15][16] = int_stack + 504256;
 Libint->vrr_classes[15][17] = int_stack + 525064;
 Libint->vrr_classes[16][10] = int_stack + 548320;
 Libint->vrr_classes[16][11] = int_stack + 558418;
 Libint->vrr_classes[16][12] = int_stack + 570352;
 Libint->vrr_classes[16][13] = int_stack + 584275;
 Libint->vrr_classes[16][14] = int_stack + 600340;
 Libint->vrr_classes[16][15] = int_stack + 618700;
 Libint->vrr_classes[16][16] = int_stack + 639508;
 Libint->vrr_classes[16][17] = int_stack + 662917;
 memset(int_stack,0,689080*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 689080;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nink(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+689080,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+702148,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+717592,int_stack+702148,int_stack+689080,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+743728,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+761746,int_stack+743728,int_stack+702148,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+792634,int_stack+761746,int_stack+717592,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+689080,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+836194,int_stack+689080,int_stack+743728,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+709870,int_stack+836194,int_stack+761746,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+872230,int_stack+709870,int_stack+792634,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+761350,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+785110,int_stack+761350,int_stack+689080,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+937570,int_stack+785110,int_stack+836194,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+997630,int_stack+937570,int_stack+709870,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1074850,int_stack+997630,int_stack+872230,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+689080,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+826690,int_stack+689080,int_stack+761350,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1166326,int_stack+826690,int_stack+785110,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+716008,int_stack+1166326,int_stack+937570,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+874210,int_stack+716008,int_stack+997630,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1235626,int_stack+874210,int_stack+1074850,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+982318,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1012612,int_stack+982318,int_stack+689080,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1066468,int_stack+1012612,int_stack+826690,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1357594,int_stack+1066468,int_stack+1166326,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+982318,int_stack+1357594,int_stack+716008,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+689080,int_stack+982318,int_stack+874210,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+833224,int_stack+689080,int_stack+1235626,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+689080,int_stack+65868,int_stack+60720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+704524,int_stack+71952,int_stack+65868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+722776,int_stack+704524,int_stack+689080,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+753664,int_stack+79050,int_stack+71952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+774958,int_stack+753664,int_stack+704524,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+990040,int_stack+774958,int_stack+722776,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+689080,int_stack+87240,int_stack+79050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1041520,int_stack+689080,int_stack+753664,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+713650,int_stack+1041520,int_stack+774958,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1084108,int_stack+713650,int_stack+990040,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+990040,int_stack+96600,int_stack+87240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+774490,int_stack+990040,int_stack+689080,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1161328,int_stack+774490,int_stack+1041520,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1232308,int_stack+1161328,int_stack+713650,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1323568,int_stack+1232308,int_stack+1084108,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+689080,int_stack+107208,int_stack+96600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1018120,int_stack+689080,int_stack+990040,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1074280,int_stack+1018120,int_stack+774490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+720904,int_stack+1074280,int_stack+1161328,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1431676,int_stack+720904,int_stack+1232308,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1156180,int_stack+1431676,int_stack+1323568,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1300324,int_stack+119142,int_stack+107208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1336126,int_stack+1300324,int_stack+689080,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1336126,int_stack+1018120,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1300324,int_stack+0,int_stack+1074280,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+990040,int_stack+1300324,int_stack+720904,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1559440,int_stack+990040,int_stack+1431676,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1300324,int_stack+1559440,int_stack+1156180,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1485652,int_stack+1300324,int_stack+833224,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+138486,int_stack+132480,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+145584,int_stack+138486,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+153865,int_stack+145584,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+689080,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+163420,int_stack+153865,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+749140,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+749140,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+798826,int_stack+28665,int_stack+689080,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+689080,int_stack+174340,int_stack+163420,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+99645,int_stack+689080,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+888916,int_stack+99645,int_stack+749140,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+971726,int_stack+888916,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1078196,int_stack+971726,int_stack+798826,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+186716,int_stack+174340,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+721840,int_stack+0,int_stack+689080,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+787360,int_stack+721840,int_stack+99645,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+37128,int_stack+787360,int_stack+888916,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1956100,int_stack+37128,int_stack+971726,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+882910,int_stack+1956100,int_stack+1078196,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1051078,int_stack+200639,int_stack+186716,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1092847,int_stack+1051078,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1167103,int_stack+1092847,int_stack+721840,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2105158,int_stack+1167103,int_stack+787360,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1051078,int_stack+2105158,int_stack+37128,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1051078,int_stack+1956100,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1956100,int_stack+0,int_stack+882910,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+689080,int_stack+1956100,int_stack+1300324,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2172316,int_stack+689080,int_stack+1485652,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+223130,int_stack+216200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+231320,int_stack+223130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+240875,int_stack+231320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+251900,int_stack+240875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1245064,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+1245064,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1302394,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+264500,int_stack+251900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1406344,int_stack+152775,int_stack+1245064,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1501894,int_stack+1406344,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1624744,int_stack+1501894,int_stack+1302394,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1245064,int_stack+278780,int_stack+264500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1287904,int_stack+1245064,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1287904,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+110250,int_stack+0,int_stack+1406344,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1770274,int_stack+110250,int_stack+1501894,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1363504,int_stack+1770274,int_stack+1624744,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1557544,int_stack+294845,int_stack+278780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1605739,int_stack+1557544,int_stack+1245064,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3113212,int_stack+1605739,int_stack+1287904,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1557544,int_stack+3113212,int_stack+0,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3113212,int_stack+1557544,int_stack+110250,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+3113212,int_stack+1770274,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1557544,int_stack+0,int_stack+1363504,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+3113212,int_stack+1557544,int_stack+1956100,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+3761860,int_stack+3113212,int_stack+689080,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4873828,int_stack+3761860,int_stack+2172316,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+689080,int_stack+320720,int_stack+312800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+712840,int_stack+330080,int_stack+320720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+740920,int_stack+712840,int_stack+689080,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+788440,int_stack+341000,int_stack+330080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+821200,int_stack+788440,int_stack+712840,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+877360,int_stack+821200,int_stack+740920,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+689080,int_stack+353600,int_stack+341000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+956560,int_stack+689080,int_stack+788440,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+726880,int_stack+956560,int_stack+821200,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1022080,int_stack+726880,int_stack+877360,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+820480,int_stack+368000,int_stack+353600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+863680,int_stack+820480,int_stack+689080,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1140880,int_stack+863680,int_stack+956560,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1250080,int_stack+1140880,int_stack+726880,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1390480,int_stack+1250080,int_stack+1022080,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+689080,int_stack+384320,int_stack+368000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+939280,int_stack+689080,int_stack+820480,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+939280,int_stack+863680,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+738040,int_stack+0,int_stack+1140880,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1025680,int_stack+738040,int_stack+1250080,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+126000,int_stack+1025680,int_stack+1390480,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1222240,int_stack+402680,int_stack+384320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1277320,int_stack+1222240,int_stack+689080,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1375240,int_stack+1277320,int_stack+939280,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1807024,int_stack+1375240,int_stack+0,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1222240,int_stack+1807024,int_stack+738040,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1807024,int_stack+1222240,int_stack+1025680,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2069104,int_stack+1807024,int_stack+126000,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2354224,int_stack+2069104,int_stack+1557544,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+689080,int_stack+2354224,int_stack+3113212,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+6441988,int_stack+689080,int_stack+3761860,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+8295268,int_stack+6441988,int_stack+4873828,2376);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3102664,int_stack+432176,int_stack+423200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3129592,int_stack+442784,int_stack+432176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3161416,int_stack+3129592,int_stack+3102664,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3215272,int_stack+455160,int_stack+442784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3252400,int_stack+3215272,int_stack+3129592,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3316048,int_stack+3252400,int_stack+3161416,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3102664,int_stack+469440,int_stack+455160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3405808,int_stack+3102664,int_stack+3215272,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3145504,int_stack+3405808,int_stack+3252400,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3480064,int_stack+3145504,int_stack+3316048,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3251584,int_stack+485760,int_stack+469440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3300544,int_stack+3251584,int_stack+3102664,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3614704,int_stack+3300544,int_stack+3405808,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3738464,int_stack+3614704,int_stack+3145504,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3897584,int_stack+3738464,int_stack+3480064,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3102664,int_stack+504256,int_stack+485760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3386224,int_stack+3102664,int_stack+3251584,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4086080,int_stack+3386224,int_stack+3300544,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3158152,int_stack+4086080,int_stack+3614704,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3484144,int_stack+3158152,int_stack+3738464,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4228880,int_stack+3484144,int_stack+3897584,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3706912,int_stack+525064,int_stack+504256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3769336,int_stack+3706912,int_stack+3102664,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3880312,int_stack+3769336,int_stack+3386224,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4480208,int_stack+3880312,int_stack+4086080,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3706912,int_stack+4480208,int_stack+3158152,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4480208,int_stack+3706912,int_stack+3484144,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4777232,int_stack+4480208,int_stack+4228880,136);
 /*--- compute (tp|nk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5100368,int_stack+4777232,int_stack+2069104,2376);
 /*--- compute (rd|nk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+3102664,int_stack+5100368,int_stack+2354224,2376);
 /*--- compute (qf|nk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+10647508,int_stack+3102664,int_stack+689080,2376);
 /*--- compute (og|nk) ---*/
 hrr1_build_og(Libint->AB,int_stack+12809668,int_stack+10647508,int_stack+6441988,2376);
 /*--- compute (nh|nk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+15589588,int_stack+12809668,int_stack+8295268,2376);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+689080,int_stack+558418,int_stack+548320,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+719374,int_stack+570352,int_stack+558418,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+755176,int_stack+719374,int_stack+689080,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+815764,int_stack+584275,int_stack+570352,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+857533,int_stack+815764,int_stack+719374,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+929137,int_stack+857533,int_stack+755176,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+689080,int_stack+600340,int_stack+584275,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1030117,int_stack+689080,int_stack+815764,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+737275,int_stack+1030117,int_stack+857533,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1113655,int_stack+737275,int_stack+929137,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+856615,int_stack+618700,int_stack+600340,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+911695,int_stack+856615,int_stack+689080,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1265125,int_stack+911695,int_stack+1030117,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1404355,int_stack+1265125,int_stack+737275,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1583365,int_stack+1404355,int_stack+1113655,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+689080,int_stack+639508,int_stack+618700,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1008085,int_stack+689080,int_stack+856615,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1795423,int_stack+1008085,int_stack+911695,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+751504,int_stack+1795423,int_stack+1265125,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1118245,int_stack+751504,int_stack+1404355,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1956073,int_stack+1118245,int_stack+1583365,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1368859,int_stack+662917,int_stack+639508,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1439086,int_stack+1368859,int_stack+689080,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1563934,int_stack+1439086,int_stack+1008085,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2238817,int_stack+1563934,int_stack+1795423,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1368859,int_stack+2238817,int_stack+751504,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2238817,int_stack+1368859,int_stack+1118245,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2572969,int_stack+2238817,int_stack+1956073,153);
 /*--- compute (up|nk) ---*/
 hrr1_build_up(Libint->AB,int_stack+5955728,int_stack+2572969,int_stack+4777232,2376);
 /*--- compute (td|nk) ---*/
 hrr1_build_td(Libint->AB,int_stack+6925136,int_stack+5955728,int_stack+5100368,2376);
 /*--- compute (rf|nk) ---*/
 hrr1_build_rf(Libint->AB,int_stack+0,int_stack+6925136,int_stack+3102664,2376);
 /*--- compute (qg|nk) ---*/
 hrr1_build_qg(Libint->AB,int_stack+2494800,int_stack+0,int_stack+10647508,2376);
 /*--- compute (oh|nk) ---*/
 hrr1_build_oh(Libint->AB,int_stack+5738040,int_stack+2494800,int_stack+12809668,2376);
 /*--- compute (ni|nk) ---*/
 hrr1_build_ni(Libint->AB,int_stack+0,int_stack+5738040,int_stack+15589588,2376);
 return int_stack+0;}
