/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nkmm(Libint_t*, prim_data*);

  /* Computes quartets of (nk|mm) integrals */

REALTYPE *hrr_order_nkmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[10][18] = int_stack + 64350;
 Libint->vrr_classes[11][9] = int_stack + 76890;
 Libint->vrr_classes[11][10] = int_stack + 81180;
 Libint->vrr_classes[11][11] = int_stack + 86328;
 Libint->vrr_classes[11][12] = int_stack + 92412;
 Libint->vrr_classes[11][13] = int_stack + 99510;
 Libint->vrr_classes[11][14] = int_stack + 107700;
 Libint->vrr_classes[11][15] = int_stack + 117060;
 Libint->vrr_classes[11][16] = int_stack + 127668;
 Libint->vrr_classes[11][17] = int_stack + 139602;
 Libint->vrr_classes[11][18] = int_stack + 152940;
 Libint->vrr_classes[12][9] = int_stack + 167760;
 Libint->vrr_classes[12][10] = int_stack + 172765;
 Libint->vrr_classes[12][11] = int_stack + 178771;
 Libint->vrr_classes[12][12] = int_stack + 185869;
 Libint->vrr_classes[12][13] = int_stack + 194150;
 Libint->vrr_classes[12][14] = int_stack + 203705;
 Libint->vrr_classes[12][15] = int_stack + 214625;
 Libint->vrr_classes[12][16] = int_stack + 227001;
 Libint->vrr_classes[12][17] = int_stack + 240924;
 Libint->vrr_classes[12][18] = int_stack + 256485;
 Libint->vrr_classes[13][9] = int_stack + 273775;
 Libint->vrr_classes[13][10] = int_stack + 279550;
 Libint->vrr_classes[13][11] = int_stack + 286480;
 Libint->vrr_classes[13][12] = int_stack + 294670;
 Libint->vrr_classes[13][13] = int_stack + 304225;
 Libint->vrr_classes[13][14] = int_stack + 315250;
 Libint->vrr_classes[13][15] = int_stack + 327850;
 Libint->vrr_classes[13][16] = int_stack + 342130;
 Libint->vrr_classes[13][17] = int_stack + 358195;
 Libint->vrr_classes[13][18] = int_stack + 376150;
 Libint->vrr_classes[14][9] = int_stack + 396100;
 Libint->vrr_classes[14][10] = int_stack + 402700;
 Libint->vrr_classes[14][11] = int_stack + 410620;
 Libint->vrr_classes[14][12] = int_stack + 419980;
 Libint->vrr_classes[14][13] = int_stack + 430900;
 Libint->vrr_classes[14][14] = int_stack + 443500;
 Libint->vrr_classes[14][15] = int_stack + 457900;
 Libint->vrr_classes[14][16] = int_stack + 474220;
 Libint->vrr_classes[14][17] = int_stack + 492580;
 Libint->vrr_classes[14][18] = int_stack + 513100;
 Libint->vrr_classes[15][9] = int_stack + 535900;
 Libint->vrr_classes[15][10] = int_stack + 543380;
 Libint->vrr_classes[15][11] = int_stack + 552356;
 Libint->vrr_classes[15][12] = int_stack + 562964;
 Libint->vrr_classes[15][13] = int_stack + 575340;
 Libint->vrr_classes[15][14] = int_stack + 589620;
 Libint->vrr_classes[15][15] = int_stack + 605940;
 Libint->vrr_classes[15][16] = int_stack + 624436;
 Libint->vrr_classes[15][17] = int_stack + 645244;
 Libint->vrr_classes[15][18] = int_stack + 668500;
 Libint->vrr_classes[16][9] = int_stack + 694340;
 Libint->vrr_classes[16][10] = int_stack + 702755;
 Libint->vrr_classes[16][11] = int_stack + 712853;
 Libint->vrr_classes[16][12] = int_stack + 724787;
 Libint->vrr_classes[16][13] = int_stack + 738710;
 Libint->vrr_classes[16][14] = int_stack + 754775;
 Libint->vrr_classes[16][15] = int_stack + 773135;
 Libint->vrr_classes[16][16] = int_stack + 793943;
 Libint->vrr_classes[16][17] = int_stack + 817352;
 Libint->vrr_classes[16][18] = int_stack + 843515;
 Libint->vrr_classes[17][9] = int_stack + 872585;
 Libint->vrr_classes[17][10] = int_stack + 881990;
 Libint->vrr_classes[17][11] = int_stack + 893276;
 Libint->vrr_classes[17][12] = int_stack + 906614;
 Libint->vrr_classes[17][13] = int_stack + 922175;
 Libint->vrr_classes[17][14] = int_stack + 940130;
 Libint->vrr_classes[17][15] = int_stack + 960650;
 Libint->vrr_classes[17][16] = int_stack + 983906;
 Libint->vrr_classes[17][17] = int_stack + 1010069;
 Libint->vrr_classes[17][18] = int_stack + 1039310;
 memset(int_stack,0,1071800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1071800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nkmm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1071800,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1082690,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1095758,int_stack+1082690,int_stack+1071800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1117538,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1132982,int_stack+1117538,int_stack+1082690,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1159118,int_stack+1132982,int_stack+1095758,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1071800,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1195418,int_stack+1071800,int_stack+1117538,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1226306,int_stack+1195418,int_stack+1132982,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1089818,int_stack+1226306,int_stack+1159118,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1144268,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1269866,int_stack+1144268,int_stack+1071800,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1305902,int_stack+1269866,int_stack+1195418,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1357382,int_stack+1305902,int_stack+1226306,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1165058,int_stack+1357382,int_stack+1089818,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1071800,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1095560,int_stack+1071800,int_stack+1144268,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1422722,int_stack+1095560,int_stack+1269866,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1482782,int_stack+1422722,int_stack+1305902,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1241288,int_stack+1482782,int_stack+1357382,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1560002,int_stack+1241288,int_stack+1165058,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1137140,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1164068,int_stack+1137140,int_stack+1071800,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1332764,int_stack+1164068,int_stack+1095560,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1661642,int_stack+1332764,int_stack+1422722,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1751732,int_stack+1661642,int_stack+1482782,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1402064,int_stack+1751732,int_stack+1241288,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1859840,int_stack+1402064,int_stack+1560002,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1071800,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1211588,int_stack+1071800,int_stack+1137140,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1524032,int_stack+1211588,int_stack+1164068,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1102094,int_stack+1524032,int_stack+1332764,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1265444,int_stack+1102094,int_stack+1661642,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1603232,int_stack+1265444,int_stack+1751732,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1990520,int_stack+1603232,int_stack+1402064,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2147336,int_stack+1990520,int_stack+1859840,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1391570,int_stack+64350,int_stack+53064,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1425428,int_stack+1391570,int_stack+1071800,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1747376,int_stack+1425428,int_stack+1211588,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1391570,int_stack+1747376,int_stack+1524032,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1747376,int_stack+1391570,int_stack+1102094,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1391570,int_stack+1747376,int_stack+1265444,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1747376,int_stack+1391570,int_stack+1603232,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1071800,int_stack+1747376,int_stack+1990520,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1267820,int_stack+1071800,int_stack+2147336,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1071800,int_stack+81180,int_stack+76890,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1084670,int_stack+86328,int_stack+81180,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1100114,int_stack+1084670,int_stack+1071800,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1125854,int_stack+92412,int_stack+86328,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1144106,int_stack+1125854,int_stack+1084670,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1174994,int_stack+1144106,int_stack+1100114,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1071800,int_stack+99510,int_stack+92412,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1217894,int_stack+1071800,int_stack+1125854,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1467470,int_stack+1217894,int_stack+1144106,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1093094,int_stack+1467470,int_stack+1174994,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1157444,int_stack+107700,int_stack+99510,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1518950,int_stack+1157444,int_stack+1071800,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1561538,int_stack+1518950,int_stack+1217894,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1182014,int_stack+1561538,int_stack+1467470,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1622378,int_stack+1182014,int_stack+1093094,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1467470,int_stack+117060,int_stack+107700,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1071800,int_stack+1467470,int_stack+1157444,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1712468,int_stack+1071800,int_stack+1518950,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1783448,int_stack+1712468,int_stack+1561538,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1495550,int_stack+1783448,int_stack+1182014,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1120940,int_stack+1495550,int_stack+1622378,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1603658,int_stack+127668,int_stack+117060,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1635482,int_stack+1603658,int_stack+1467470,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1874708,int_stack+1635482,int_stack+1071800,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1956608,int_stack+1874708,int_stack+1712468,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2063078,int_stack+1956608,int_stack+1783448,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1691642,int_stack+2063078,int_stack+1495550,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2190842,int_stack+1691642,int_stack+1120940,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1071800,int_stack+139602,int_stack+127668,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1107602,int_stack+1071800,int_stack+1603658,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1171250,int_stack+1107602,int_stack+1635482,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1467470,int_stack+1171250,int_stack+1874708,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2345282,int_stack+1467470,int_stack+1956608,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1835786,int_stack+2345282,int_stack+2063078,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2494340,int_stack+1835786,int_stack+1691642,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1590320,int_stack+2494340,int_stack+2190842,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1783370,int_stack+152940,int_stack+139602,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2006138,int_stack+1783370,int_stack+1071800,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2077742,int_stack+2006138,int_stack+1107602,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2183822,int_stack+2077742,int_stack+1171250,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2006138,int_stack+2183822,int_stack+1467470,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2679668,int_stack+2006138,int_stack+2345282,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2006138,int_stack+2679668,int_stack+1835786,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2225162,int_stack+2006138,int_stack+2494340,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2456822,int_stack+2225162,int_stack+1590320,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1467470,int_stack+2456822,int_stack+1267820,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2692772,int_stack+172765,int_stack+167760,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2707787,int_stack+178771,int_stack+172765,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2725805,int_stack+2707787,int_stack+2692772,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2755835,int_stack+185869,int_stack+178771,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2777129,int_stack+2755835,int_stack+2707787,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2813165,int_stack+2777129,int_stack+2725805,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2692772,int_stack+194150,int_stack+185869,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2066420,int_stack+2692772,int_stack+2755835,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2109008,int_stack+2066420,int_stack+2777129,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2717615,int_stack+2109008,int_stack+2813165,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2792690,int_stack+203705,int_stack+194150,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2821355,int_stack+2792690,int_stack+2692772,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2169068,int_stack+2821355,int_stack+2066420,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2240048,int_stack+2169068,int_stack+2109008,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2330138,int_stack+2240048,int_stack+2717615,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2066420,int_stack+214625,int_stack+203705,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2099180,int_stack+2066420,int_stack+2792690,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2692772,int_stack+2099180,int_stack+2821355,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1071800,int_stack+2692772,int_stack+2169068,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1178270,int_stack+1071800,int_stack+2240048,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2156510,int_stack+1178270,int_stack+2330138,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2296650,int_stack+227001,int_stack+214625,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2333778,int_stack+2296650,int_stack+2066420,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2775582,int_stack+2333778,int_stack+2099180,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1304396,int_stack+2775582,int_stack+2692772,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1304396,int_stack+1071800,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2871132,int_stack+0,int_stack+1178270,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1071800,int_stack+2871132,int_stack+2156510,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1251980,int_stack+240924,int_stack+227001,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2692772,int_stack+1251980,int_stack+2296650,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2066420,int_stack+2692772,int_stack+2333778,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2175620,int_stack+2066420,int_stack+2775582,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3039300,int_stack+2175620,int_stack+1304396,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3213201,int_stack+3039300,int_stack+0,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+3213201,int_stack+2871132,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2767028,int_stack+0,int_stack+1071800,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1071800,int_stack+256485,int_stack+240924,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1118483,int_stack+1071800,int_stack+1251980,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1202021,int_stack+1118483,int_stack+2692772,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3411945,int_stack+1202021,int_stack+2066420,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1071800,int_stack+3411945,int_stack+2175620,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2066420,int_stack+1071800,int_stack+3039300,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1071800,int_stack+2066420,int_stack+3213201,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2066420,int_stack+1071800,int_stack+0,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1071800,int_stack+2066420,int_stack+2767028,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2692772,int_stack+1071800,int_stack+2456822,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3400622,int_stack+2692772,int_stack+1467470,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+279550,int_stack+273775,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17325,int_stack+286480,int_stack+279550,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38115,int_stack+17325,int_stack+0,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72765,int_stack+294670,int_stack+286480,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97335,int_stack+72765,int_stack+17325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138915,int_stack+97335,int_stack+38115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+304225,int_stack+294670,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196665,int_stack+0,int_stack+72765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1347075,int_stack+196665,int_stack+97335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28665,int_stack+1347075,int_stack+138915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115290,int_stack+315250,int_stack+304225,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+245805,int_stack+115290,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1416375,int_stack+245805,int_stack+196665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1498275,int_stack+1416375,int_stack+1347075,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1602225,int_stack+1498275,int_stack+28665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1347075,int_stack+327850,int_stack+315250,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+1347075,int_stack+115290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+66150,int_stack+0,int_stack+245805,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+161700,int_stack+66150,int_stack+1416375,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1723500,int_stack+161700,int_stack+1498275,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1384875,int_stack+1723500,int_stack+1602225,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1546575,int_stack+342130,int_stack+327850,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1589415,int_stack+1546575,int_stack+1347075,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1869030,int_stack+1589415,int_stack+0,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1979280,int_stack+1869030,int_stack+66150,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2122605,int_stack+1979280,int_stack+161700,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2122605,int_stack+1723500,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2294595,int_stack+0,int_stack+1384875,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+194040,int_stack+358195,int_stack+342130,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+242235,int_stack+194040,int_stack+1546575,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1347075,int_stack+242235,int_stack+1589415,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1473075,int_stack+1347075,int_stack+1869030,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1638450,int_stack+1473075,int_stack+1979280,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1839105,int_stack+1638450,int_stack+2122605,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4598522,int_stack+1839105,int_stack+0,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4848002,int_stack+4598522,int_stack+2294595,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+376150,int_stack+358195,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+53865,int_stack+0,int_stack+194040,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2068425,int_stack+53865,int_stack+242235,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+2068425,int_stack+1347075,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2068425,int_stack+0,int_stack+1473075,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2068425,int_stack+1638450,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2068425,int_stack+0,int_stack+1839105,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2068425,int_stack+4598522,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1347075,int_stack+0,int_stack+4848002,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1664700,int_stack+1347075,int_stack+1071800,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+4598522,int_stack+1664700,int_stack+2692772,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6014222,int_stack+4598522,int_stack+3400622,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1071800,int_stack+402700,int_stack+396100,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1091600,int_stack+410620,int_stack+402700,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1115360,int_stack+1091600,int_stack+1071800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1154960,int_stack+419980,int_stack+410620,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1183040,int_stack+1154960,int_stack+1091600,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1230560,int_stack+1183040,int_stack+1115360,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1071800,int_stack+430900,int_stack+419980,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+1071800,int_stack+1154960,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56160,int_stack+0,int_stack+1183040,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1104560,int_stack+56160,int_stack+1230560,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1203560,int_stack+443500,int_stack+430900,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1241360,int_stack+1203560,int_stack+1071800,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+135360,int_stack+1241360,int_stack+0,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+228960,int_stack+135360,int_stack+56160,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2490525,int_stack+228960,int_stack+1104560,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+457900,int_stack+443500,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+1203560,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1071800,int_stack+43200,int_stack+1241360,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1181000,int_stack+1071800,int_stack+135360,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2629125,int_stack+1181000,int_stack+228960,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+118800,int_stack+2629125,int_stack+2490525,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2490525,int_stack+474220,int_stack+457900,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2539485,int_stack+2490525,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+303600,int_stack+2539485,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2795445,int_stack+303600,int_stack+1071800,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2959245,int_stack+2795445,int_stack+1181000,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1071800,int_stack+2959245,int_stack+2629125,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3155805,int_stack+1071800,int_stack+118800,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+492580,int_stack+474220,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+55080,int_stack+0,int_stack+2490525,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+153000,int_stack+55080,int_stack+2539485,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2490525,int_stack+153000,int_stack+303600,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3393405,int_stack+2490525,int_stack+2795445,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2679525,int_stack+3393405,int_stack+2959245,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3622725,int_stack+2679525,int_stack+1071800,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3907845,int_stack+3622725,int_stack+3155805,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1071800,int_stack+513100,int_stack+492580,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1133360,int_stack+1071800,int_stack+0,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2941605,int_stack+1133360,int_stack+55080,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1071800,int_stack+2941605,int_stack+153000,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2941605,int_stack+1071800,int_stack+2490525,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2941605,int_stack+3393405,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2941605,int_stack+0,int_stack+2679525,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2941605,int_stack+3622725,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2490525,int_stack+0,int_stack+3907845,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2853525,int_stack+2490525,int_stack+1347075,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+8010722,int_stack+2853525,int_stack+1664700,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+9662372,int_stack+8010722,int_stack+4598522,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+12021872,int_stack+9662372,int_stack+6014222,3025);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+543380,int_stack+535900,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+22440,int_stack+552356,int_stack+543380,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49368,int_stack+22440,int_stack+0,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94248,int_stack+562964,int_stack+552356,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+126072,int_stack+94248,int_stack+22440,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+179928,int_stack+126072,int_stack+49368,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+575340,int_stack+562964,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+254728,int_stack+0,int_stack+94248,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+318376,int_stack+254728,int_stack+126072,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+37128,int_stack+318376,int_stack+179928,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149328,int_stack+589620,int_stack+575340,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+408136,int_stack+149328,int_stack+0,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+482392,int_stack+408136,int_stack+254728,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3806400,int_stack+482392,int_stack+318376,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+192168,int_stack+3806400,int_stack+37128,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+605940,int_stack+589620,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48960,int_stack+0,int_stack+149328,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3941040,int_stack+48960,int_stack+408136,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4064800,int_stack+3941040,int_stack+482392,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+349248,int_stack+4064800,int_stack+3806400,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4223920,int_stack+349248,int_stack+192168,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3806400,int_stack+624436,int_stack+605940,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+134640,int_stack+3806400,int_stack+0,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4433360,int_stack+134640,int_stack+48960,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4576160,int_stack+4433360,int_stack+3941040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4761800,int_stack+4576160,int_stack+4064800,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3861888,int_stack+4761800,int_stack+349248,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+232560,int_stack+3861888,int_stack+4223920,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+645244,int_stack+624436,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4113216,int_stack+0,int_stack+3806400,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4224192,int_stack+4113216,int_stack+134640,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4984568,int_stack+4224192,int_stack+4433360,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5198768,int_stack+4984568,int_stack+4576160,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4387392,int_stack+5198768,int_stack+4761800,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5458664,int_stack+4387392,int_stack+3861888,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+5781800,int_stack+5458664,int_stack+232560,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3806400,int_stack+668500,int_stack+645244,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3876168,int_stack+3806400,int_stack+0,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+3876168,int_stack+4113216,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+184960,int_stack+0,int_stack+4224192,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3806400,int_stack+184960,int_stack+4984568,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+3806400,int_stack+5198768,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3806400,int_stack+0,int_stack+4387392,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+3806400,int_stack+5458664,136);
 /*--- compute (u0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+3806400,int_stack+0,int_stack+5781800,136);
 /*--- compute (tp|mm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4217800,int_stack+3806400,int_stack+2490525,3025);
 /*--- compute (rd|mm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+5306800,int_stack+4217800,int_stack+2853525,3025);
 /*--- compute (qf|mm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+15016622,int_stack+5306800,int_stack+8010722,3025);
 /*--- compute (og|mm) ---*/
 hrr1_build_og(Libint->AB,int_stack+17769372,int_stack+15016622,int_stack+9662372,3025);
 /*--- compute (nh|mm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+7212550,int_stack+17769372,int_stack+12021872,3025);
 /*--- compute (v0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+702755,int_stack+694340,153);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25245,int_stack+712853,int_stack+702755,153);
 /*--- compute (v0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+55539,int_stack+25245,int_stack+0,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+106029,int_stack+724787,int_stack+712853,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+141831,int_stack+106029,int_stack+25245,153);
 /*--- compute (v0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+202419,int_stack+141831,int_stack+55539,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+738710,int_stack+724787,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+286569,int_stack+0,int_stack+106029,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+358173,int_stack+286569,int_stack+141831,153);
 /*--- compute (v0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+41769,int_stack+358173,int_stack+202419,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+167994,int_stack+754775,int_stack+738710,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+459153,int_stack+167994,int_stack+0,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+542691,int_stack+459153,int_stack+286569,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+11405200,int_stack+542691,int_stack+358173,153);
 /*--- compute (v0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+216189,int_stack+11405200,int_stack+41769,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+773135,int_stack+754775,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+55080,int_stack+0,int_stack+167994,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+11556670,int_stack+55080,int_stack+459153,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+11695900,int_stack+11556670,int_stack+542691,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+392904,int_stack+11695900,int_stack+11405200,153);
 /*--- compute (v0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+11874910,int_stack+392904,int_stack+216189,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+11405200,int_stack+793943,int_stack+773135,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+151470,int_stack+11405200,int_stack+0,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+604962,int_stack+151470,int_stack+55080,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+12110530,int_stack+604962,int_stack+11556670,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+12319375,int_stack+12110530,int_stack+11695900,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+11467624,int_stack+12319375,int_stack+392904,153);
 /*--- compute (v0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+261630,int_stack+11467624,int_stack+11874910,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+817352,int_stack+793943,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+11750368,int_stack+0,int_stack+11405200,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+11875216,int_stack+11750368,int_stack+151470,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+12569989,int_stack+11875216,int_stack+604962,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+12810964,int_stack+12569989,int_stack+12110530,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+13103347,int_stack+12810964,int_stack+12319375,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+12058816,int_stack+13103347,int_stack+11467624,153);
 /*--- compute (v0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+13437499,int_stack+12058816,int_stack+261630,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+11405200,int_stack+843515,int_stack+817352,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+11483689,int_stack+11405200,int_stack+0,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+11483689,int_stack+11750368,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+208080,int_stack+0,int_stack+11875216,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+483480,int_stack+208080,int_stack+12569989,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+483480,int_stack+12810964,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+389844,int_stack+0,int_stack+13103347,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+11405200,int_stack+389844,int_stack+12058816,153);
 /*--- compute (v0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+11405200,int_stack+13437499,153);
 /*--- compute (up|mm) ---*/
 hrr1_build_up(Libint->AB,int_stack+11405200,int_stack+0,int_stack+3806400,3025);
 /*--- compute (td|mm) ---*/
 hrr1_build_td(Libint->AB,int_stack+12639400,int_stack+11405200,int_stack+4217800,3025);
 /*--- compute (rf|mm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+1071800,int_stack+12639400,int_stack+5306800,3025);
 /*--- compute (qg|mm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+21308622,int_stack+1071800,int_stack+15016622,3025);
 /*--- compute (oh|mm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+25437747,int_stack+21308622,int_stack+17769372,3025);
 /*--- compute (ni|mm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+14817400,int_stack+25437747,int_stack+7212550,3025);
 /*--- compute (w0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20407600,int_stack+881990,int_stack+872585,171);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20435815,int_stack+893276,int_stack+881990,171);
 /*--- compute (w0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+20469673,int_stack+20435815,int_stack+20407600,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20526103,int_stack+906614,int_stack+893276,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20566117,int_stack+20526103,int_stack+20435815,171);
 /*--- compute (w0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+20633833,int_stack+20566117,int_stack+20469673,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+20407600,int_stack+922175,int_stack+906614,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+20727883,int_stack+20407600,int_stack+20526103,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+20807911,int_stack+20727883,int_stack+20566117,171);
 /*--- compute (w0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+20454283,int_stack+20807911,int_stack+20633833,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+20595358,int_stack+940130,int_stack+922175,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20920771,int_stack+20595358,int_stack+20407600,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+21014137,int_stack+20920771,int_stack+20727883,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+462825,int_stack+21014137,int_stack+20807911,171);
 /*--- compute (w0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+20649223,int_stack+462825,int_stack+20454283,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+20407600,int_stack+960650,int_stack+940130,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+20469160,int_stack+20407600,int_stack+20595358,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+21147517,int_stack+20469160,int_stack+20920771,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+632115,int_stack+21147517,int_stack+21014137,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+20846728,int_stack+632115,int_stack+462825,171);
 /*--- compute (w0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4248050,int_stack+20846728,int_stack+20649223,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+462825,int_stack+983906,int_stack+960650,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+20576890,int_stack+462825,int_stack+20407600,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4511390,int_stack+20576890,int_stack+20469160,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4690940,int_stack+4511390,int_stack+21147517,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4924355,int_stack+4690940,int_stack+632115,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+532593,int_stack+4924355,int_stack+20846728,171);
 /*--- compute (w0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+20700010,int_stack+532593,int_stack+4248050,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4248050,int_stack+1010069,int_stack+983906,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4326539,int_stack+4248050,int_stack+462825,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+21038590,int_stack+4326539,int_stack+20576890,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+20407600,int_stack+21038590,int_stack+4511390,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5204453,int_stack+20407600,int_stack+4690940,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4466075,int_stack+5204453,int_stack+4924355,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5531234,int_stack+4466075,int_stack+532593,171);
 /*--- compute (w0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+462825,int_stack+5531234,int_stack+20700010,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+886050,int_stack+1039310,int_stack+1010069,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+4839539,int_stack+886050,int_stack+4248050,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+20676925,int_stack+4839539,int_stack+4326539,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+4839539,int_stack+20676925,int_stack+21038590,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+20676925,int_stack+4839539,int_stack+20407600,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5937530,int_stack+20676925,int_stack+5204453,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+20407600,int_stack+5937530,int_stack+4466075,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5937530,int_stack+20407600,int_stack+5531234,171);
 /*--- compute (w0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+20407600,int_stack+5937530,int_stack+462825,171);
 /*--- compute (vp|mm) ---*/
 hrr1_build_vp(Libint->AB,int_stack+4248050,int_stack+20407600,int_stack+0,3025);
 /*--- compute (ud|mm) ---*/
 hrr1_build_ud(Libint->AB,int_stack+5636525,int_stack+4248050,int_stack+11405200,3025);
 /*--- compute (tf|mm) ---*/
 hrr1_build_tf(Libint->AB,int_stack+8104925,int_stack+5636525,int_stack+12639400,3025);
 /*--- compute (rg|mm) ---*/
 hrr1_build_rg(Libint->AB,int_stack+30392697,int_stack+8104925,int_stack+1071800,3025);
 /*--- compute (qh|mm) ---*/
 hrr1_build_qh(Libint->AB,int_stack+0,int_stack+30392697,int_stack+21308622,3025);
 /*--- compute (oi|mm) ---*/
 hrr1_build_oi(Libint->AB,int_stack+5780775,int_stack+0,int_stack+25437747,3025);
 /*--- compute (nk|mm) ---*/
 hrr1_build_nk(Libint->AB,int_stack+20407600,int_stack+5780775,int_stack+14817400,3025);
 return int_stack+20407600;}
