/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npli(Libint_t*, prim_data*);

  /* Computes quartets of (np|li) integrals */

REALTYPE *hrr_order_npli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[10][14] = int_stack + 29040;
 Libint->vrr_classes[11][8] = int_stack + 36960;
 Libint->vrr_classes[11][9] = int_stack + 40470;
 Libint->vrr_classes[11][10] = int_stack + 44760;
 Libint->vrr_classes[11][11] = int_stack + 49908;
 Libint->vrr_classes[11][12] = int_stack + 55992;
 Libint->vrr_classes[11][13] = int_stack + 63090;
 Libint->vrr_classes[11][14] = int_stack + 71280;
 memset(int_stack,0,80640*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 80640;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npli(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+80640,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+89550,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+100440,int_stack+89550,int_stack+80640,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118260,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131328,int_stack+118260,int_stack+89550,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+153108,int_stack+131328,int_stack+100440,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+80640,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+182808,int_stack+80640,int_stack+118260,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+208944,int_stack+182808,int_stack+131328,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+96084,int_stack+208944,int_stack+153108,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+140634,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+245244,int_stack+140634,int_stack+80640,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+276132,int_stack+245244,int_stack+182808,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+319692,int_stack+276132,int_stack+208944,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+158652,int_stack+319692,int_stack+96084,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+80640,int_stack+29040,int_stack+22110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+101430,int_stack+80640,int_stack+140634,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+374142,int_stack+101430,int_stack+245244,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+80640,int_stack+374142,int_stack+276132,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+221022,int_stack+80640,int_stack+319692,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+297252,int_stack+221022,int_stack+158652,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+80640,int_stack+40470,int_stack+36960,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91170,int_stack+44760,int_stack+40470,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+104040,int_stack+91170,int_stack+80640,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125100,int_stack+49908,int_stack+44760,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+140544,int_stack+125100,int_stack+91170,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+166284,int_stack+140544,int_stack+104040,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+80640,int_stack+55992,int_stack+49908,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+201384,int_stack+80640,int_stack+125100,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+232272,int_stack+201384,int_stack+140544,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+98892,int_stack+232272,int_stack+166284,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+151542,int_stack+63090,int_stack+55992,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+380412,int_stack+151542,int_stack+80640,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+380412,int_stack+201384,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+416916,int_stack+0,int_stack+232272,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+172836,int_stack+416916,int_stack+98892,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+80640,int_stack+71280,int_stack+63090,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+105210,int_stack+80640,int_stack+151542,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+481266,int_stack+105210,int_stack+380412,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+51480,int_stack+481266,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+481266,int_stack+51480,int_stack+416916,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+481266,int_stack+172836,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+380412,int_stack+0,int_stack+297252,1260);
 return int_stack+380412;}
