/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npnp(Libint_t*, prim_data*);

  /* Computes quartets of (np|np) integrals */

REALTYPE *hrr_order_npnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[11][10] = int_stack + 9504;
 Libint->vrr_classes[11][11] = int_stack + 14652;
 memset(int_stack,0,20736*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20736;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npnp(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20736,int_stack+4356,int_stack+0,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33804,int_stack+14652,int_stack+9504,78);
 /*--- compute (np|np) ---*/
 hrr1_build_np(Libint->AB,int_stack+49248,int_stack+33804,int_stack+20736,198);
 return int_stack+49248;}
