/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0lk(Libint_t*, prim_data*);

  /* Computes quartets of (p0|lk) integrals */

REALTYPE *hrr_order_p0lk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][8] = int_stack + 0;
 Libint->vrr_classes[1][9] = int_stack + 135;
 Libint->vrr_classes[1][10] = int_stack + 300;
 Libint->vrr_classes[1][11] = int_stack + 498;
 Libint->vrr_classes[1][12] = int_stack + 732;
 Libint->vrr_classes[1][13] = int_stack + 1005;
 Libint->vrr_classes[1][14] = int_stack + 1320;
 Libint->vrr_classes[1][15] = int_stack + 1680;
 memset(int_stack,0,2088*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2088;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0lk(Libint, Data);
   Data++;
 }
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2088,int_stack+135,int_stack+0,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2493,int_stack+300,int_stack+135,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2988,int_stack+2493,int_stack+2088,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3798,int_stack+498,int_stack+300,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+4392,int_stack+3798,int_stack+2493,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+5382,int_stack+4392,int_stack+2988,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2088,int_stack+732,int_stack+498,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6732,int_stack+2088,int_stack+3798,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+7920,int_stack+6732,int_stack+4392,3);
 /*--- compute (p0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2790,int_stack+7920,int_stack+5382,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+4815,int_stack+1005,int_stack+732,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9570,int_stack+4815,int_stack+2088,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10974,int_stack+9570,int_stack+6732,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12954,int_stack+10974,int_stack+7920,3);
 /*--- compute (p0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+5634,int_stack+12954,int_stack+2790,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2088,int_stack+1320,int_stack+1005,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3033,int_stack+2088,int_stack+4815,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+15429,int_stack+3033,int_stack+9570,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+17769,int_stack+15429,int_stack+10974,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+8469,int_stack+17769,int_stack+12954,3);
 /*--- compute (p0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+20739,int_stack+8469,int_stack+5634,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+4671,int_stack+1680,int_stack+1320,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5751,int_stack+4671,int_stack+2088,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+11934,int_stack+5751,int_stack+3033,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+11934,int_stack+15429,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+11934,int_stack+0,int_stack+17769,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+11934,int_stack+8469,3);
 /*--- compute (p0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+4620,int_stack+0,int_stack+20739,3);
 return int_stack+4620;}
