/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppmd(Libint_t*, prim_data*);

  /* Computes quartets of (pp|md) integrals */

REALTYPE *hrr_order_ppmd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[2][9] = int_stack + 597;
 Libint->vrr_classes[2][10] = int_stack + 927;
 Libint->vrr_classes[2][11] = int_stack + 1323;
 memset(int_stack,0,1791*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1791;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppmd(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1791,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2286,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2880,int_stack+2286,int_stack+1791,3);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1791,int_stack+927,int_stack+597,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3870,int_stack+1323,int_stack+927,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5058,int_stack+3870,int_stack+1791,6);
 /*--- compute (pp|md) ---*/
 hrr1_build_pp(Libint->AB,int_stack+7038,int_stack+5058,int_stack+2880,330);
 return int_stack+7038;}
