/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (ff|hg) integrals */

void vrr_order_ffhg(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+12, vrr_stack+3, vrr_stack+9, NULL, NULL, Data->F+6);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+3, NULL, NULL, Data->F+5);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+21, vrr_stack+12, vrr_stack+6, vrr_stack+3, vrr_stack+0);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+3, vrr_stack+9, Data->F+5, Data->F+6, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+6, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+6, Data->F+3, Data->F+4, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+6);
 _BUILD_00p0(Data,vrr_stack+102, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+105, vrr_stack+9, vrr_stack+102, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+111, vrr_stack+48, vrr_stack+105, NULL, NULL, vrr_stack+9);
 _BUILD_d0d0(Data,vrr_stack+129, vrr_stack+60, vrr_stack+111, vrr_stack+54, vrr_stack+48, vrr_stack+12);
 _BUILD_d0d0(Data,vrr_stack+165, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+201, vrr_stack+165, vrr_stack+129, vrr_stack+84, vrr_stack+60, vrr_stack+30);
 _BUILD_00f0(Data,vrr_stack+12, vrr_stack+54, vrr_stack+48, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00f0(Data,vrr_stack+22, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00f0(Data,vrr_stack+32, vrr_stack+48, vrr_stack+105, vrr_stack+3, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+261, vrr_stack+12, vrr_stack+32, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+291, vrr_stack+22, vrr_stack+12, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+321, vrr_stack+291, vrr_stack+261, vrr_stack+22, vrr_stack+12, vrr_stack+60);
 _BUILD_00p0(Data,vrr_stack+60, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+60, vrr_stack+0, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+63, vrr_stack+3, vrr_stack+78, vrr_stack+60, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+381, vrr_stack+63, vrr_stack+22, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+411, vrr_stack+381, vrr_stack+291, vrr_stack+63, vrr_stack+22, vrr_stack+84);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+42, vrr_stack+102, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+105, vrr_stack+42, vrr_stack+9, vrr_stack+102, NULL);
 _BUILD_p0f0(Data,vrr_stack+471, vrr_stack+32, vrr_stack+84, NULL, NULL, vrr_stack+105);
 _BUILD_d0f0(Data,vrr_stack+501, vrr_stack+261, vrr_stack+471, vrr_stack+12, vrr_stack+32, vrr_stack+111);
 _BUILD_f0f0(Data,vrr_stack+561, vrr_stack+321, vrr_stack+501, vrr_stack+291, vrr_stack+261, vrr_stack+129);
 _BUILD_f0f0(Data,vrr_stack+661, vrr_stack+411, vrr_stack+321, vrr_stack+381, vrr_stack+291, vrr_stack+165);
 _BUILD_g0f0(Data,vrr_stack+761, vrr_stack+661, vrr_stack+561, vrr_stack+411, vrr_stack+321, vrr_stack+201);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+12, vrr_stack+32, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+126, vrr_stack+22, vrr_stack+12, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+141, vrr_stack+126, vrr_stack+111, NULL, NULL, vrr_stack+12);
 _BUILD_00g0(Data,vrr_stack+186, vrr_stack+63, vrr_stack+22, vrr_stack+3, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+201, vrr_stack+186, vrr_stack+126, NULL, NULL, vrr_stack+22);
 _BUILD_00g0(Data,vrr_stack+246, vrr_stack+32, vrr_stack+84, vrr_stack+48, vrr_stack+105, NULL);
 _BUILD_p0g0(Data,vrr_stack+911, vrr_stack+111, vrr_stack+246, NULL, NULL, vrr_stack+32);
 _BUILD_d0g0(Data,vrr_stack+956, vrr_stack+141, vrr_stack+911, vrr_stack+126, vrr_stack+111, vrr_stack+261);
 _BUILD_d0g0(Data,vrr_stack+1046, vrr_stack+201, vrr_stack+141, vrr_stack+186, vrr_stack+126, vrr_stack+291);
 _BUILD_f0g0(Data,vrr_stack+1136, vrr_stack+1046, vrr_stack+956, vrr_stack+201, vrr_stack+141, vrr_stack+321);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+261, vrr_stack+9, vrr_stack+60, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+267, vrr_stack+261, vrr_stack+3, vrr_stack+9, vrr_stack+60, NULL);
 _BUILD_00g0(Data,vrr_stack+48, vrr_stack+267, vrr_stack+63, vrr_stack+261, vrr_stack+3, NULL);
 _BUILD_p0g0(Data,vrr_stack+277, vrr_stack+48, vrr_stack+186, NULL, NULL, vrr_stack+63);
 _BUILD_d0g0(Data,vrr_stack+1286, vrr_stack+277, vrr_stack+201, vrr_stack+48, vrr_stack+186, vrr_stack+381);
 _BUILD_f0g0(Data,vrr_stack+1376, vrr_stack+1286, vrr_stack+1046, vrr_stack+277, vrr_stack+201, vrr_stack+411);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+322, vrr_stack+0, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+328, vrr_stack+42, vrr_stack+322, vrr_stack+102, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+338, vrr_stack+84, vrr_stack+328, vrr_stack+105, vrr_stack+42, NULL);
 _BUILD_p0g0(Data,vrr_stack+353, vrr_stack+246, vrr_stack+338, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+1526, vrr_stack+911, vrr_stack+353, vrr_stack+111, vrr_stack+246, vrr_stack+471);
 _BUILD_f0g0(Data,vrr_stack+1616, vrr_stack+956, vrr_stack+1526, vrr_stack+141, vrr_stack+911, vrr_stack+501);
 _BUILD_g0g0(Data,vrr_stack+1766, vrr_stack+1136, vrr_stack+1616, vrr_stack+1046, vrr_stack+956, vrr_stack+561);
 _BUILD_g0g0(Data,vrr_stack+398, vrr_stack+1376, vrr_stack+1136, vrr_stack+1286, vrr_stack+1046, vrr_stack+661);
 _BUILD_h0g0(Data,vrr_stack+1991, vrr_stack+398, vrr_stack+1766, vrr_stack+1376, vrr_stack+1136, vrr_stack+761);
 _BUILD_00h0(Data,vrr_stack+623, vrr_stack+126, vrr_stack+111, vrr_stack+22, vrr_stack+12, NULL);
 _BUILD_00h0(Data,vrr_stack+644, vrr_stack+186, vrr_stack+126, vrr_stack+63, vrr_stack+22, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+111, vrr_stack+246, vrr_stack+12, vrr_stack+32, NULL);
 _BUILD_p0h0(Data,vrr_stack+686, vrr_stack+623, vrr_stack+665, NULL, NULL, vrr_stack+111);
 _BUILD_p0h0(Data,vrr_stack+749, vrr_stack+644, vrr_stack+623, NULL, NULL, vrr_stack+126);
 _BUILD_d0h0(Data,vrr_stack+2306, vrr_stack+749, vrr_stack+686, vrr_stack+644, vrr_stack+623, vrr_stack+141);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+48, vrr_stack+186, vrr_stack+267, vrr_stack+63, NULL);
 _BUILD_p0h0(Data,vrr_stack+812, vrr_stack+141, vrr_stack+644, NULL, NULL, vrr_stack+186);
 _BUILD_d0h0(Data,vrr_stack+2432, vrr_stack+812, vrr_stack+749, vrr_stack+141, vrr_stack+644, vrr_stack+201);
 _BUILD_00h0(Data,vrr_stack+63, vrr_stack+246, vrr_stack+338, vrr_stack+32, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+2558, vrr_stack+665, vrr_stack+63, NULL, NULL, vrr_stack+246);
 _BUILD_d0h0(Data,vrr_stack+2621, vrr_stack+686, vrr_stack+2558, vrr_stack+623, vrr_stack+665, vrr_stack+911);
 _BUILD_f0h0(Data,vrr_stack+2747, vrr_stack+2306, vrr_stack+2621, vrr_stack+749, vrr_stack+686, vrr_stack+956);
 _BUILD_f0h0(Data,vrr_stack+2957, vrr_stack+2432, vrr_stack+2306, vrr_stack+812, vrr_stack+749, vrr_stack+1046);
 _BUILD_g0h0(Data,vrr_stack+3167, vrr_stack+2957, vrr_stack+2747, vrr_stack+2432, vrr_stack+2306, vrr_stack+1136);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+6, vrr_stack+9, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+201, vrr_stack+261, vrr_stack+6, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+207, vrr_stack+267, vrr_stack+201, vrr_stack+261, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+48, vrr_stack+207, vrr_stack+267, NULL);
 _BUILD_p0h0(Data,vrr_stack+875, vrr_stack+21, vrr_stack+141, NULL, NULL, vrr_stack+48);
 _BUILD_d0h0(Data,vrr_stack+938, vrr_stack+875, vrr_stack+812, vrr_stack+21, vrr_stack+141, vrr_stack+277);
 _BUILD_f0h0(Data,vrr_stack+1064, vrr_stack+938, vrr_stack+2432, vrr_stack+875, vrr_stack+812, vrr_stack+1286);
   tmp = vrr_stack + 1064;
   target_ptr = Libint->vrr_classes[3][5];
   for(i=0;i<210;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0h0(Data,vrr_stack+3482, vrr_stack+1064, vrr_stack+2957, vrr_stack+938, vrr_stack+2432, vrr_stack+1376);
   tmp = vrr_stack + 3482;
   target_ptr = Libint->vrr_classes[4][5];
   for(i=0;i<315;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+875, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+878, vrr_stack+3, vrr_stack+875, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+884, vrr_stack+322, vrr_stack+878, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+894, vrr_stack+328, vrr_stack+884, vrr_stack+42, vrr_stack+322, NULL);
 _BUILD_00h0(Data,vrr_stack+909, vrr_stack+338, vrr_stack+894, vrr_stack+84, vrr_stack+328, NULL);
 _BUILD_p0h0(Data,vrr_stack+930, vrr_stack+63, vrr_stack+909, NULL, NULL, vrr_stack+338);
 _BUILD_d0h0(Data,vrr_stack+1274, vrr_stack+2558, vrr_stack+930, vrr_stack+665, vrr_stack+63, vrr_stack+353);
 _BUILD_f0h0(Data,vrr_stack+3797, vrr_stack+2621, vrr_stack+1274, vrr_stack+686, vrr_stack+2558, vrr_stack+1526);
 _BUILD_g0h0(Data,vrr_stack+4007, vrr_stack+2747, vrr_stack+3797, vrr_stack+2306, vrr_stack+2621, vrr_stack+1616);
 _BUILD_h0h0(Data,vrr_stack+4322, vrr_stack+3167, vrr_stack+4007, vrr_stack+2957, vrr_stack+2747, vrr_stack+1766);
 _BUILD_h0h0(Data,vrr_stack+1400, vrr_stack+3482, vrr_stack+3167, vrr_stack+1064, vrr_stack+2957, vrr_stack+398);
   tmp = vrr_stack + 1400;
   target_ptr = Libint->vrr_classes[5][5];
   for(i=0;i<441;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00i0(Data,vrr_stack+353, vrr_stack+623, vrr_stack+665, vrr_stack+126, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+381, vrr_stack+644, vrr_stack+623, vrr_stack+186, vrr_stack+126, NULL);
 _BUILD_00i0(Data,vrr_stack+409, vrr_stack+665, vrr_stack+63, vrr_stack+111, vrr_stack+246, NULL);
 _BUILD_p0i0(Data,vrr_stack+437, vrr_stack+353, vrr_stack+409, NULL, NULL, vrr_stack+665);
 _BUILD_p0i0(Data,vrr_stack+521, vrr_stack+381, vrr_stack+353, NULL, NULL, vrr_stack+623);
 _BUILD_d0i0(Data,vrr_stack+993, vrr_stack+521, vrr_stack+437, vrr_stack+381, vrr_stack+353, vrr_stack+686);
 _BUILD_00i0(Data,vrr_stack+686, vrr_stack+141, vrr_stack+644, vrr_stack+48, vrr_stack+186, NULL);
 _BUILD_p0i0(Data,vrr_stack+162, vrr_stack+686, vrr_stack+381, NULL, NULL, vrr_stack+644);
 _BUILD_d0i0(Data,vrr_stack+4763, vrr_stack+162, vrr_stack+521, vrr_stack+686, vrr_stack+381, vrr_stack+749);
 _BUILD_00i0(Data,vrr_stack+714, vrr_stack+63, vrr_stack+909, vrr_stack+246, vrr_stack+338, NULL);
 _BUILD_p0i0(Data,vrr_stack+1161, vrr_stack+409, vrr_stack+714, NULL, NULL, vrr_stack+63);
 _BUILD_d0i0(Data,vrr_stack+4931, vrr_stack+437, vrr_stack+1161, vrr_stack+353, vrr_stack+409, vrr_stack+2558);
 _BUILD_f0i0(Data,vrr_stack+5099, vrr_stack+993, vrr_stack+4931, vrr_stack+521, vrr_stack+437, vrr_stack+2621);
 _BUILD_f0i0(Data,vrr_stack+5379, vrr_stack+4763, vrr_stack+993, vrr_stack+162, vrr_stack+521, vrr_stack+2306);
 _BUILD_g0i0(Data,vrr_stack+5659, vrr_stack+5379, vrr_stack+5099, vrr_stack+4763, vrr_stack+993, vrr_stack+2747);
 _BUILD_00i0(Data,vrr_stack+2306, vrr_stack+21, vrr_stack+141, vrr_stack+6, vrr_stack+48, NULL);
 _BUILD_p0i0(Data,vrr_stack+2334, vrr_stack+2306, vrr_stack+686, NULL, NULL, vrr_stack+141);
 _BUILD_d0i0(Data,vrr_stack+2558, vrr_stack+2334, vrr_stack+162, vrr_stack+2306, vrr_stack+686, vrr_stack+812);
 _BUILD_f0i0(Data,vrr_stack+6079, vrr_stack+2558, vrr_stack+4763, vrr_stack+2334, vrr_stack+162, vrr_stack+2432);
   tmp = vrr_stack + 6079;
   target_ptr = Libint->vrr_classes[3][6];
   for(i=0;i<280;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0i0(Data,vrr_stack+6359, vrr_stack+6079, vrr_stack+5379, vrr_stack+2558, vrr_stack+4763, vrr_stack+2957);
   tmp = vrr_stack + 6359;
   target_ptr = Libint->vrr_classes[4][6];
   for(i=0;i<420;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2334, vrr_stack+875, vrr_stack+0, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+2340, vrr_stack+878, vrr_stack+2334, vrr_stack+3, vrr_stack+875, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+884, vrr_stack+2340, vrr_stack+322, vrr_stack+878, NULL);
 _BUILD_00h0(Data,vrr_stack+42, vrr_stack+894, vrr_stack+3, vrr_stack+328, vrr_stack+884, NULL);
 _BUILD_00i0(Data,vrr_stack+2350, vrr_stack+909, vrr_stack+42, vrr_stack+338, vrr_stack+894, NULL);
 _BUILD_p0i0(Data,vrr_stack+2378, vrr_stack+714, vrr_stack+2350, NULL, NULL, vrr_stack+909);
 _BUILD_d0i0(Data,vrr_stack+2462, vrr_stack+1161, vrr_stack+2378, vrr_stack+409, vrr_stack+714, vrr_stack+930);
 _BUILD_f0i0(Data,vrr_stack+2630, vrr_stack+4931, vrr_stack+2462, vrr_stack+437, vrr_stack+1161, vrr_stack+1274);
 _BUILD_g0i0(Data,vrr_stack+6779, vrr_stack+5099, vrr_stack+2630, vrr_stack+993, vrr_stack+4931, vrr_stack+3797);
 _BUILD_h0i0(Data,vrr_stack+7199, vrr_stack+5659, vrr_stack+6779, vrr_stack+5379, vrr_stack+5099, vrr_stack+4007);
 _BUILD_h0i0(Data,vrr_stack+7787, vrr_stack+6359, vrr_stack+5659, vrr_stack+6079, vrr_stack+5379, vrr_stack+3167);
   tmp = vrr_stack + 7787;
   target_ptr = Libint->vrr_classes[5][6];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+6079, vrr_stack+353, vrr_stack+409, vrr_stack+623, vrr_stack+665, NULL);
 _BUILD_00k0(Data,vrr_stack+6115, vrr_stack+381, vrr_stack+353, vrr_stack+644, vrr_stack+623, NULL);
 _BUILD_00k0(Data,vrr_stack+6151, vrr_stack+409, vrr_stack+714, vrr_stack+665, vrr_stack+63, NULL);
 _BUILD_p0k0(Data,vrr_stack+6187, vrr_stack+6079, vrr_stack+6151, NULL, NULL, vrr_stack+409);
 _BUILD_p0k0(Data,vrr_stack+3797, vrr_stack+6115, vrr_stack+6079, NULL, NULL, vrr_stack+353);
 _BUILD_d0k0(Data,vrr_stack+3905, vrr_stack+3797, vrr_stack+6187, vrr_stack+6115, vrr_stack+6079, vrr_stack+437);
 _BUILD_00k0(Data,vrr_stack+437, vrr_stack+686, vrr_stack+381, vrr_stack+141, vrr_stack+644, NULL);
 _BUILD_p0k0(Data,vrr_stack+4121, vrr_stack+437, vrr_stack+6115, NULL, NULL, vrr_stack+381);
 _BUILD_d0k0(Data,vrr_stack+2910, vrr_stack+4121, vrr_stack+3797, vrr_stack+437, vrr_stack+6115, vrr_stack+521);
 _BUILD_00k0(Data,vrr_stack+473, vrr_stack+714, vrr_stack+2350, vrr_stack+63, vrr_stack+909, NULL);
 _BUILD_p0k0(Data,vrr_stack+509, vrr_stack+6151, vrr_stack+473, NULL, NULL, vrr_stack+714);
 _BUILD_d0k0(Data,vrr_stack+8375, vrr_stack+6187, vrr_stack+509, vrr_stack+6079, vrr_stack+6151, vrr_stack+1161);
 _BUILD_f0k0(Data,vrr_stack+8591, vrr_stack+3905, vrr_stack+8375, vrr_stack+3797, vrr_stack+6187, vrr_stack+4931);
 _BUILD_f0k0(Data,vrr_stack+8951, vrr_stack+2910, vrr_stack+3905, vrr_stack+4121, vrr_stack+3797, vrr_stack+993);
 _BUILD_g0k0(Data,vrr_stack+9311, vrr_stack+8951, vrr_stack+8591, vrr_stack+2910, vrr_stack+3905, vrr_stack+5099);
 _BUILD_00k0(Data,vrr_stack+4931, vrr_stack+2306, vrr_stack+686, vrr_stack+21, vrr_stack+141, NULL);
 _BUILD_p0k0(Data,vrr_stack+4967, vrr_stack+4931, vrr_stack+437, NULL, NULL, vrr_stack+686);
 _BUILD_d0k0(Data,vrr_stack+5075, vrr_stack+4967, vrr_stack+4121, vrr_stack+4931, vrr_stack+437, vrr_stack+162);
 _BUILD_f0k0(Data,vrr_stack+930, vrr_stack+5075, vrr_stack+2910, vrr_stack+4967, vrr_stack+4121, vrr_stack+4763);
   tmp = vrr_stack + 930;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0k0(Data,vrr_stack+9851, vrr_stack+930, vrr_stack+8951, vrr_stack+5075, vrr_stack+2910, vrr_stack+5379);
   tmp = vrr_stack + 9851;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+4763, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4766, vrr_stack+0, vrr_stack+4763, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+4772, vrr_stack+2334, vrr_stack+4766, vrr_stack+875, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+4782, vrr_stack+2340, vrr_stack+4772, vrr_stack+878, vrr_stack+2334, NULL);
 _BUILD_00h0(Data,vrr_stack+4797, vrr_stack+3, vrr_stack+4782, vrr_stack+884, vrr_stack+2340, NULL);
 _BUILD_00i0(Data,vrr_stack+4818, vrr_stack+42, vrr_stack+4797, vrr_stack+894, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+4846, vrr_stack+2350, vrr_stack+4818, vrr_stack+909, vrr_stack+42, NULL);
 _BUILD_p0k0(Data,vrr_stack+4967, vrr_stack+473, vrr_stack+4846, NULL, NULL, vrr_stack+2350);
 _BUILD_d0k0(Data,vrr_stack+5075, vrr_stack+509, vrr_stack+4967, vrr_stack+6151, vrr_stack+473, vrr_stack+2378);
 _BUILD_f0k0(Data,vrr_stack+5291, vrr_stack+8375, vrr_stack+5075, vrr_stack+6187, vrr_stack+509, vrr_stack+2462);
 _BUILD_g0k0(Data,vrr_stack+10391, vrr_stack+8591, vrr_stack+5291, vrr_stack+3905, vrr_stack+8375, vrr_stack+2630);
 _BUILD_h0k0(Data,vrr_stack+10931, vrr_stack+9311, vrr_stack+10391, vrr_stack+8951, vrr_stack+8591, vrr_stack+6779);
 _BUILD_h0k0(Data,vrr_stack+11687, vrr_stack+9851, vrr_stack+9311, vrr_stack+930, vrr_stack+8951, vrr_stack+5659);
   tmp = vrr_stack + 11687;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+6779, vrr_stack+6079, vrr_stack+6151, vrr_stack+353, vrr_stack+409, NULL);
 _BUILD_00l0(Data,vrr_stack+6824, vrr_stack+6115, vrr_stack+6079, vrr_stack+381, vrr_stack+353, NULL);
 _BUILD_00l0(Data,vrr_stack+6869, vrr_stack+6151, vrr_stack+473, vrr_stack+409, vrr_stack+714, NULL);
 _BUILD_p0l0(Data,vrr_stack+6914, vrr_stack+6779, vrr_stack+6869, NULL, NULL, vrr_stack+6151);
 _BUILD_p0l0(Data,vrr_stack+7049, vrr_stack+6824, vrr_stack+6779, NULL, NULL, vrr_stack+6079);
 _BUILD_d0l0(Data,vrr_stack+2378, vrr_stack+7049, vrr_stack+6914, vrr_stack+6824, vrr_stack+6779, vrr_stack+6187);
 _BUILD_00l0(Data,vrr_stack+6187, vrr_stack+437, vrr_stack+6115, vrr_stack+686, vrr_stack+381, NULL);
 _BUILD_p0l0(Data,vrr_stack+2648, vrr_stack+6187, vrr_stack+6824, NULL, NULL, vrr_stack+6115);
 _BUILD_d0l0(Data,vrr_stack+63, vrr_stack+2648, vrr_stack+7049, vrr_stack+6187, vrr_stack+6824, vrr_stack+3797);
 _BUILD_00l0(Data,vrr_stack+3797, vrr_stack+473, vrr_stack+4846, vrr_stack+714, vrr_stack+2350, NULL);
 _BUILD_p0l0(Data,vrr_stack+714, vrr_stack+6869, vrr_stack+3797, NULL, NULL, vrr_stack+473);
 _BUILD_d0l0(Data,vrr_stack+849, vrr_stack+6914, vrr_stack+714, vrr_stack+6779, vrr_stack+6869, vrr_stack+509);
 _BUILD_f0l0(Data,vrr_stack+12443, vrr_stack+2378, vrr_stack+849, vrr_stack+7049, vrr_stack+6914, vrr_stack+8375);
 _BUILD_f0l0(Data,vrr_stack+12893, vrr_stack+63, vrr_stack+2378, vrr_stack+2648, vrr_stack+7049, vrr_stack+3905);
 _BUILD_g0l0(Data,vrr_stack+13343, vrr_stack+12893, vrr_stack+12443, vrr_stack+63, vrr_stack+2378, vrr_stack+8591);
 _BUILD_00l0(Data,vrr_stack+8375, vrr_stack+4931, vrr_stack+437, vrr_stack+2306, vrr_stack+686, NULL);
 _BUILD_p0l0(Data,vrr_stack+8420, vrr_stack+8375, vrr_stack+6187, NULL, NULL, vrr_stack+437);
 _BUILD_d0l0(Data,vrr_stack+8555, vrr_stack+8420, vrr_stack+2648, vrr_stack+8375, vrr_stack+6187, vrr_stack+4121);
 _BUILD_f0l0(Data,vrr_stack+3842, vrr_stack+8555, vrr_stack+63, vrr_stack+8420, vrr_stack+2648, vrr_stack+2910);
   tmp = vrr_stack + 3842;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0l0(Data,vrr_stack+14018, vrr_stack+3842, vrr_stack+12893, vrr_stack+8555, vrr_stack+63, vrr_stack+8951);
   tmp = vrr_stack + 14018;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+8420, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+8423, vrr_stack+4763, vrr_stack+8420, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+8429, vrr_stack+4766, vrr_stack+8423, vrr_stack+0, vrr_stack+4763, NULL);
 _BUILD_00g0(Data,vrr_stack+7184, vrr_stack+4772, vrr_stack+8429, vrr_stack+2334, vrr_stack+4766, NULL);
 _BUILD_00h0(Data,vrr_stack+8439, vrr_stack+4782, vrr_stack+7184, vrr_stack+2340, vrr_stack+4772, NULL);
 _BUILD_00i0(Data,vrr_stack+8460, vrr_stack+4797, vrr_stack+8439, vrr_stack+3, vrr_stack+4782, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+4818, vrr_stack+8460, vrr_stack+42, vrr_stack+4797, NULL);
 _BUILD_00l0(Data,vrr_stack+8488, vrr_stack+4846, vrr_stack+0, vrr_stack+2350, vrr_stack+4818, NULL);
 _BUILD_p0l0(Data,vrr_stack+8533, vrr_stack+3797, vrr_stack+8488, NULL, NULL, vrr_stack+4846);
 _BUILD_d0l0(Data,vrr_stack+8668, vrr_stack+714, vrr_stack+8533, vrr_stack+6869, vrr_stack+3797, vrr_stack+4967);
 _BUILD_f0l0(Data,vrr_stack+14693, vrr_stack+849, vrr_stack+8668, vrr_stack+6914, vrr_stack+714, vrr_stack+5075);
 _BUILD_g0l0(Data,vrr_stack+15143, vrr_stack+12443, vrr_stack+14693, vrr_stack+2378, vrr_stack+849, vrr_stack+5291);
 _BUILD_h0l0(Data,vrr_stack+15818, vrr_stack+13343, vrr_stack+15143, vrr_stack+12893, vrr_stack+12443, vrr_stack+10391);
 _BUILD_h0l0(Data,vrr_stack+16763, vrr_stack+14018, vrr_stack+13343, vrr_stack+3842, vrr_stack+12893, vrr_stack+9311);
   tmp = vrr_stack + 16763;
   target_ptr = Libint->vrr_classes[5][8];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+3842, vrr_stack+6779, vrr_stack+6869, vrr_stack+6079, vrr_stack+6151, NULL);
 _BUILD_00m0(Data,vrr_stack+3897, vrr_stack+6824, vrr_stack+6779, vrr_stack+6115, vrr_stack+6079, NULL);
 _BUILD_00m0(Data,vrr_stack+3952, vrr_stack+6869, vrr_stack+3797, vrr_stack+6151, vrr_stack+473, NULL);
 _BUILD_p0m0(Data,vrr_stack+4007, vrr_stack+3842, vrr_stack+3952, NULL, NULL, vrr_stack+6869);
 _BUILD_p0m0(Data,vrr_stack+10391, vrr_stack+3897, vrr_stack+3842, NULL, NULL, vrr_stack+6779);
 _BUILD_d0m0(Data,vrr_stack+10556, vrr_stack+10391, vrr_stack+4007, vrr_stack+3897, vrr_stack+3842, vrr_stack+6914);
 _BUILD_00m0(Data,vrr_stack+6869, vrr_stack+6187, vrr_stack+6824, vrr_stack+437, vrr_stack+6115, NULL);
 _BUILD_p0m0(Data,vrr_stack+4967, vrr_stack+6869, vrr_stack+3897, NULL, NULL, vrr_stack+6824);
 _BUILD_d0m0(Data,vrr_stack+5132, vrr_stack+4967, vrr_stack+10391, vrr_stack+6869, vrr_stack+3897, vrr_stack+7049);
 _BUILD_00m0(Data,vrr_stack+3897, vrr_stack+3797, vrr_stack+8488, vrr_stack+473, vrr_stack+4846, NULL);
 _BUILD_p0m0(Data,vrr_stack+473, vrr_stack+3952, vrr_stack+3897, NULL, NULL, vrr_stack+3797);
 _BUILD_d0m0(Data,vrr_stack+8938, vrr_stack+4007, vrr_stack+473, vrr_stack+3842, vrr_stack+3952, vrr_stack+714);
 _BUILD_f0m0(Data,vrr_stack+17708, vrr_stack+10556, vrr_stack+8938, vrr_stack+10391, vrr_stack+4007, vrr_stack+849);
 _BUILD_f0m0(Data,vrr_stack+638, vrr_stack+5132, vrr_stack+10556, vrr_stack+4967, vrr_stack+10391, vrr_stack+2378);
 _BUILD_g0m0(Data,vrr_stack+18258, vrr_stack+638, vrr_stack+17708, vrr_stack+5132, vrr_stack+10556, vrr_stack+12443);
 _BUILD_00m0(Data,vrr_stack+12443, vrr_stack+8375, vrr_stack+6187, vrr_stack+4931, vrr_stack+437, NULL);
 _BUILD_p0m0(Data,vrr_stack+10391, vrr_stack+12443, vrr_stack+6869, NULL, NULL, vrr_stack+6187);
 _BUILD_d0m0(Data,vrr_stack+12498, vrr_stack+10391, vrr_stack+4967, vrr_stack+12443, vrr_stack+6869, vrr_stack+2648);
 _BUILD_f0m0(Data,vrr_stack+2306, vrr_stack+12498, vrr_stack+5132, vrr_stack+10391, vrr_stack+4967, vrr_stack+63);
   tmp = vrr_stack + 2306;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0m0(Data,vrr_stack+19083, vrr_stack+2306, vrr_stack+638, vrr_stack+12498, vrr_stack+5132, vrr_stack+12893);
   tmp = vrr_stack + 19083;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+10391, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+10394, vrr_stack+8420, vrr_stack+10391, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+10400, vrr_stack+8423, vrr_stack+10394, vrr_stack+4763, vrr_stack+8420, NULL);
 _BUILD_00g0(Data,vrr_stack+10410, vrr_stack+8429, vrr_stack+10400, vrr_stack+4766, vrr_stack+8423, NULL);
 _BUILD_00h0(Data,vrr_stack+10425, vrr_stack+7184, vrr_stack+10410, vrr_stack+4772, vrr_stack+8429, NULL);
 _BUILD_00i0(Data,vrr_stack+10391, vrr_stack+8439, vrr_stack+10425, vrr_stack+4782, vrr_stack+7184, NULL);
 _BUILD_00k0(Data,vrr_stack+10419, vrr_stack+8460, vrr_stack+10391, vrr_stack+4797, vrr_stack+8439, NULL);
 _BUILD_00l0(Data,vrr_stack+10886, vrr_stack+0, vrr_stack+10419, vrr_stack+4818, vrr_stack+8460, NULL);
 _BUILD_00m0(Data,vrr_stack+10391, vrr_stack+8488, vrr_stack+10886, vrr_stack+4846, vrr_stack+0, NULL);
 _BUILD_p0m0(Data,vrr_stack+0, vrr_stack+3897, vrr_stack+10391, NULL, NULL, vrr_stack+8488);
 _BUILD_d0m0(Data,vrr_stack+4763, vrr_stack+473, vrr_stack+0, vrr_stack+3952, vrr_stack+3897, vrr_stack+8533);
 _BUILD_f0m0(Data,vrr_stack+5093, vrr_stack+8938, vrr_stack+4763, vrr_stack+4007, vrr_stack+473, vrr_stack+8668);
 _BUILD_g0m0(Data,vrr_stack+12443, vrr_stack+17708, vrr_stack+5093, vrr_stack+10556, vrr_stack+8938, vrr_stack+14693);
 _BUILD_h0m0(Data,vrr_stack+19908, vrr_stack+18258, vrr_stack+12443, vrr_stack+638, vrr_stack+17708, vrr_stack+15143);
 _BUILD_h0m0(Data,vrr_stack+21063, vrr_stack+19083, vrr_stack+18258, vrr_stack+2306, vrr_stack+638, vrr_stack+13343);
   tmp = vrr_stack + 21063;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0h0(Data,vrr_stack+2306, vrr_stack+1400, vrr_stack+4322, vrr_stack+3482, vrr_stack+3167, vrr_stack+1991);
   tmp = vrr_stack + 2306;
   target_ptr = Libint->vrr_classes[6][5];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0i0(Data,vrr_stack+2894, vrr_stack+7787, vrr_stack+7199, vrr_stack+6359, vrr_stack+5659, vrr_stack+4322);
   tmp = vrr_stack + 2894;
   target_ptr = Libint->vrr_classes[6][6];
   for(i=0;i<784;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0k0(Data,vrr_stack+7787, vrr_stack+11687, vrr_stack+10931, vrr_stack+9851, vrr_stack+9311, vrr_stack+7199);
   tmp = vrr_stack + 7787;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0l0(Data,vrr_stack+11687, vrr_stack+16763, vrr_stack+15818, vrr_stack+14018, vrr_stack+13343, vrr_stack+10931);
   tmp = vrr_stack + 11687;
   target_ptr = Libint->vrr_classes[6][8];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0m0(Data,vrr_stack+12947, vrr_stack+21063, vrr_stack+19908, vrr_stack+19083, vrr_stack+18258, vrr_stack+15818);
   tmp = vrr_stack + 12947;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];

}

