/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (pp|mh) integrals */

void vrr_order_ppmh(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+5, Data->F+6, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+31, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+81, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+3, vrr_stack+31, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+50, vrr_stack+34, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+163, vrr_stack+56, vrr_stack+40, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+178, vrr_stack+66, vrr_stack+163, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+199, vrr_stack+96, vrr_stack+178, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+255, vrr_stack+227, vrr_stack+199, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+31, vrr_stack+81, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+34, vrr_stack+84, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+40, vrr_stack+21, vrr_stack+50, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+306, vrr_stack+163, vrr_stack+291, vrr_stack+56, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+327, vrr_stack+178, vrr_stack+306, vrr_stack+66, vrr_stack+163, NULL);
 _BUILD_00k0(Data,vrr_stack+355, vrr_stack+199, vrr_stack+327, vrr_stack+96, vrr_stack+178, NULL);
 _BUILD_00l0(Data,vrr_stack+391, vrr_stack+255, vrr_stack+355, vrr_stack+227, vrr_stack+199, NULL);
 _BUILD_00p0(Data,vrr_stack+50, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+53, vrr_stack+50, vrr_stack+0, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+59, vrr_stack+53, vrr_stack+15, vrr_stack+50, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+59, vrr_stack+117, vrr_stack+53, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+127, vrr_stack+59, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+436, vrr_stack+90, vrr_stack+142, vrr_stack+0, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+464, vrr_stack+436, vrr_stack+227, vrr_stack+90, vrr_stack+142, NULL);
 _BUILD_00l0(Data,vrr_stack+111, vrr_stack+464, vrr_stack+255, vrr_stack+436, vrr_stack+227, NULL);
 _BUILD_p0l0(Data,vrr_stack+500, vrr_stack+111, vrr_stack+391, NULL, NULL, vrr_stack+255);
 _BUILD_00m0(Data,vrr_stack+635, vrr_stack+111, vrr_stack+391, vrr_stack+464, vrr_stack+255, NULL);
 _BUILD_00p0(Data,vrr_stack+227, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+227, vrr_stack+50, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+230, vrr_stack+15, vrr_stack+53, vrr_stack+227, vrr_stack+50, NULL);
 _BUILD_00g0(Data,vrr_stack+240, vrr_stack+230, vrr_stack+59, vrr_stack+15, vrr_stack+53, NULL);
 _BUILD_00h0(Data,vrr_stack+690, vrr_stack+240, vrr_stack+0, vrr_stack+230, vrr_stack+59, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+690, vrr_stack+90, vrr_stack+240, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+711, vrr_stack+50, vrr_stack+436, vrr_stack+690, vrr_stack+90, NULL);
 _BUILD_00l0(Data,vrr_stack+747, vrr_stack+711, vrr_stack+464, vrr_stack+50, vrr_stack+436, NULL);
 _BUILD_00m0(Data,vrr_stack+792, vrr_stack+747, vrr_stack+111, vrr_stack+711, vrr_stack+464, NULL);
 _BUILD_00p0(Data,vrr_stack+436, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+439, vrr_stack+81, vrr_stack+436, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+445, vrr_stack+84, vrr_stack+439, vrr_stack+31, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+455, vrr_stack+21, vrr_stack+445, vrr_stack+34, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+90, vrr_stack+291, vrr_stack+455, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+306, vrr_stack+90, vrr_stack+163, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+31, vrr_stack+327, vrr_stack+227, vrr_stack+178, vrr_stack+306, NULL);
 _BUILD_00l0(Data,vrr_stack+690, vrr_stack+355, vrr_stack+31, vrr_stack+199, vrr_stack+327, NULL);
 _BUILD_00m0(Data,vrr_stack+156, vrr_stack+391, vrr_stack+690, vrr_stack+255, vrr_stack+355, NULL);
 _BUILD_p0m0(Data,vrr_stack+847, vrr_stack+635, vrr_stack+156, NULL, NULL, vrr_stack+391);
 _BUILD_p0m0(Data,vrr_stack+1012, vrr_stack+792, vrr_stack+635, NULL, NULL, vrr_stack+111);
   tmp = vrr_stack + 1012;
   target_ptr = Libint->vrr_classes[1][9];
   for(i=0;i<165;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+1177, vrr_stack+635, vrr_stack+156, vrr_stack+111, vrr_stack+391, NULL);
 _BUILD_00n0(Data,vrr_stack+1243, vrr_stack+792, vrr_stack+635, vrr_stack+747, vrr_stack+111, NULL);
 _BUILD_00p0(Data,vrr_stack+111, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+114, vrr_stack+436, vrr_stack+111, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+120, vrr_stack+439, vrr_stack+114, vrr_stack+81, vrr_stack+436, NULL);
 _BUILD_00g0(Data,vrr_stack+130, vrr_stack+445, vrr_stack+120, vrr_stack+84, vrr_stack+439, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+455, vrr_stack+130, vrr_stack+21, vrr_stack+445, NULL);
 _BUILD_00i0(Data,vrr_stack+255, vrr_stack+90, vrr_stack+0, vrr_stack+291, vrr_stack+455, NULL);
 _BUILD_00k0(Data,vrr_stack+735, vrr_stack+227, vrr_stack+255, vrr_stack+306, vrr_stack+90, NULL);
 _BUILD_00l0(Data,vrr_stack+1309, vrr_stack+31, vrr_stack+735, vrr_stack+327, vrr_stack+227, NULL);
 _BUILD_00m0(Data,vrr_stack+283, vrr_stack+690, vrr_stack+1309, vrr_stack+355, vrr_stack+31, NULL);
 _BUILD_00n0(Data,vrr_stack+1354, vrr_stack+156, vrr_stack+283, vrr_stack+391, vrr_stack+690, NULL);
 _BUILD_p0n0(Data,vrr_stack+1420, vrr_stack+1177, vrr_stack+1354, NULL, NULL, vrr_stack+156);
 _BUILD_p0n0(Data,vrr_stack+1618, vrr_stack+1243, vrr_stack+1177, NULL, NULL, vrr_stack+635);
   tmp = vrr_stack + 1618;
   target_ptr = Libint->vrr_classes[1][10];
   for(i=0;i<198;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+338, vrr_stack+1177, vrr_stack+1354, vrr_stack+635, vrr_stack+156, NULL);
 _BUILD_00o0(Data,vrr_stack+1816, vrr_stack+1243, vrr_stack+1177, vrr_stack+792, vrr_stack+635, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+111, vrr_stack+21, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+145, vrr_stack+114, vrr_stack+24, vrr_stack+436, vrr_stack+111, NULL);
 _BUILD_00g0(Data,vrr_stack+416, vrr_stack+120, vrr_stack+145, vrr_stack+439, vrr_stack+114, NULL);
 _BUILD_00h0(Data,vrr_stack+771, vrr_stack+130, vrr_stack+416, vrr_stack+445, vrr_stack+120, NULL);
 _BUILD_00i0(Data,vrr_stack+470, vrr_stack+0, vrr_stack+771, vrr_stack+455, vrr_stack+130, NULL);
 _BUILD_00k0(Data,vrr_stack+431, vrr_stack+255, vrr_stack+470, vrr_stack+90, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+1894, vrr_stack+735, vrr_stack+431, vrr_stack+227, vrr_stack+255, NULL);
 _BUILD_00m0(Data,vrr_stack+1939, vrr_stack+1309, vrr_stack+1894, vrr_stack+31, vrr_stack+735, NULL);
 _BUILD_00n0(Data,vrr_stack+30, vrr_stack+283, vrr_stack+1939, vrr_stack+690, vrr_stack+1309, NULL);
 _BUILD_00o0(Data,vrr_stack+1994, vrr_stack+1354, vrr_stack+30, vrr_stack+156, vrr_stack+283, NULL);
 _BUILD_p0o0(Data,vrr_stack+2072, vrr_stack+338, vrr_stack+1994, NULL, NULL, vrr_stack+1354);
 _BUILD_p0o0(Data,vrr_stack+2306, vrr_stack+1816, vrr_stack+338, NULL, NULL, vrr_stack+1177);
   tmp = vrr_stack + 2306;
   target_ptr = Libint->vrr_classes[1][11];
   for(i=0;i<234;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+155, vrr_stack+338, vrr_stack+1994, vrr_stack+1177, vrr_stack+1354, NULL);
 _BUILD_00q0(Data,vrr_stack+2540, vrr_stack+1816, vrr_stack+338, vrr_stack+1243, vrr_stack+1177, NULL);
 _BUILD_00p0(Data,vrr_stack+467, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+690, vrr_stack+21, vrr_stack+467, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+696, vrr_stack+24, vrr_stack+690, vrr_stack+111, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+706, vrr_stack+145, vrr_stack+696, vrr_stack+114, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+416, vrr_stack+706, vrr_stack+120, vrr_stack+145, NULL);
 _BUILD_00i0(Data,vrr_stack+2631, vrr_stack+771, vrr_stack+96, vrr_stack+130, vrr_stack+416, NULL);
 _BUILD_00k0(Data,vrr_stack+2659, vrr_stack+470, vrr_stack+2631, vrr_stack+0, vrr_stack+771, NULL);
 _BUILD_00l0(Data,vrr_stack+2695, vrr_stack+431, vrr_stack+2659, vrr_stack+255, vrr_stack+470, NULL);
 _BUILD_00m0(Data,vrr_stack+2740, vrr_stack+1894, vrr_stack+2695, vrr_stack+735, vrr_stack+431, NULL);
 _BUILD_00n0(Data,vrr_stack+2795, vrr_stack+1939, vrr_stack+2740, vrr_stack+1309, vrr_stack+1894, NULL);
 _BUILD_00o0(Data,vrr_stack+2861, vrr_stack+30, vrr_stack+2795, vrr_stack+283, vrr_stack+1939, NULL);
 _BUILD_00q0(Data,vrr_stack+246, vrr_stack+1994, vrr_stack+2861, vrr_stack+1354, vrr_stack+30, NULL);
 _BUILD_p0q0(Data,vrr_stack+2939, vrr_stack+155, vrr_stack+246, NULL, NULL, vrr_stack+1994);
 _BUILD_p0q0(Data,vrr_stack+3212, vrr_stack+2540, vrr_stack+155, NULL, NULL, vrr_stack+338);
   tmp = vrr_stack + 3212;
   target_ptr = Libint->vrr_classes[1][12];
   for(i=0;i<273;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1309, vrr_stack+155, vrr_stack+246, vrr_stack+338, vrr_stack+1994, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3485, vrr_stack+2540, vrr_stack+155, vrr_stack+1816, vrr_stack+338, NULL);
 _BUILD_00p0(Data,vrr_stack+1414, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+467, vrr_stack+1414, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+6, vrr_stack+690, vrr_stack+0, vrr_stack+21, vrr_stack+467, NULL);
 _BUILD_00g0(Data,vrr_stack+721, vrr_stack+696, vrr_stack+6, vrr_stack+24, vrr_stack+690, NULL);
 _BUILD_00h0(Data,vrr_stack+736, vrr_stack+706, vrr_stack+721, vrr_stack+145, vrr_stack+696, NULL);
 _BUILD_00i0(Data,vrr_stack+117, vrr_stack+96, vrr_stack+736, vrr_stack+416, vrr_stack+706, NULL);
 _BUILD_00k0(Data,vrr_stack+3590, vrr_stack+2631, vrr_stack+117, vrr_stack+771, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+3626, vrr_stack+2659, vrr_stack+3590, vrr_stack+470, vrr_stack+2631, NULL);
 _BUILD_00m0(Data,vrr_stack+3671, vrr_stack+2695, vrr_stack+3626, vrr_stack+431, vrr_stack+2659, NULL);
 _BUILD_00n0(Data,vrr_stack+3726, vrr_stack+2740, vrr_stack+3671, vrr_stack+1894, vrr_stack+2695, NULL);
 _BUILD_00o0(Data,vrr_stack+3792, vrr_stack+2795, vrr_stack+3726, vrr_stack+1939, vrr_stack+2740, NULL);
 _BUILD_00q0(Data,vrr_stack+1894, vrr_stack+2861, vrr_stack+3792, vrr_stack+30, vrr_stack+2795, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3870, vrr_stack+246, vrr_stack+1894, vrr_stack+1994, vrr_stack+2861, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3975, vrr_stack+1309, vrr_stack+3870, NULL, NULL, vrr_stack+246);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4290, vrr_stack+3485, vrr_stack+1309, NULL, NULL, vrr_stack+155);
   tmp = vrr_stack + 4290;
   target_ptr = Libint->vrr_classes[1][13];
   for(i=0;i<315;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4605, vrr_stack+1309, vrr_stack+3870, vrr_stack+155, vrr_stack+246, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4725, vrr_stack+3485, vrr_stack+1309, vrr_stack+2540, vrr_stack+155, NULL);
 _BUILD_00p0(Data,vrr_stack+1417, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1985, vrr_stack+1414, vrr_stack+1417, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+145, vrr_stack+0, vrr_stack+1985, vrr_stack+467, vrr_stack+1414, NULL);
 _BUILD_00g0(Data,vrr_stack+1985, vrr_stack+6, vrr_stack+145, vrr_stack+690, vrr_stack+0, NULL);
 _BUILD_00h0(Data,vrr_stack+2000, vrr_stack+721, vrr_stack+1985, vrr_stack+696, vrr_stack+6, NULL);
 _BUILD_00i0(Data,vrr_stack+0, vrr_stack+736, vrr_stack+2000, vrr_stack+706, vrr_stack+721, NULL);
 _BUILD_00k0(Data,vrr_stack+1985, vrr_stack+117, vrr_stack+0, vrr_stack+96, vrr_stack+736, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+3590, vrr_stack+1985, vrr_stack+2631, vrr_stack+117, NULL);
 _BUILD_00m0(Data,vrr_stack+1985, vrr_stack+3626, vrr_stack+0, vrr_stack+2659, vrr_stack+3590, NULL);
 _BUILD_00n0(Data,vrr_stack+0, vrr_stack+3671, vrr_stack+1985, vrr_stack+2695, vrr_stack+3626, NULL);
 _BUILD_00o0(Data,vrr_stack+1985, vrr_stack+3726, vrr_stack+0, vrr_stack+2740, vrr_stack+3671, NULL);
 _BUILD_00q0(Data,vrr_stack+0, vrr_stack+3792, vrr_stack+1985, vrr_stack+2795, vrr_stack+3726, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3590, vrr_stack+1894, vrr_stack+0, vrr_stack+2861, vrr_stack+3792, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+3870, vrr_stack+3590, vrr_stack+246, vrr_stack+1894, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4845, vrr_stack+4605, vrr_stack+0, NULL, NULL, vrr_stack+3870);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3590, vrr_stack+4725, vrr_stack+4605, NULL, NULL, vrr_stack+1309);
   tmp = vrr_stack + 3590;
   target_ptr = Libint->vrr_classes[1][14];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0m0(Data,vrr_stack+5205, vrr_stack+1012, vrr_stack+847, vrr_stack+792, vrr_stack+635, vrr_stack+500);
   tmp = vrr_stack + 5205;
   target_ptr = Libint->vrr_classes[2][9];
   for(i=0;i<330;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0n0(Data,vrr_stack+416, vrr_stack+1618, vrr_stack+1420, vrr_stack+1243, vrr_stack+1177, vrr_stack+847);
   tmp = vrr_stack + 416;
   target_ptr = Libint->vrr_classes[2][10];
   for(i=0;i<396;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0o0(Data,vrr_stack+812, vrr_stack+2306, vrr_stack+2072, vrr_stack+1816, vrr_stack+338, vrr_stack+1420);
   tmp = vrr_stack + 812;
   target_ptr = Libint->vrr_classes[2][11];
   for(i=0;i<468;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0q0(Data,vrr_stack+1414, vrr_stack+3212, vrr_stack+2939, vrr_stack+2540, vrr_stack+155, vrr_stack+2072);
   tmp = vrr_stack + 1414;
   target_ptr = Libint->vrr_classes[2][12];
   for(i=0;i<546;i++)
     target_ptr[i] += tmp[i];
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1960, vrr_stack+4290, vrr_stack+3975, vrr_stack+3485, vrr_stack+1309, vrr_stack+2939);
   tmp = vrr_stack + 1960;
   target_ptr = Libint->vrr_classes[2][13];
   for(i=0;i<630;i++)
     target_ptr[i] += tmp[i];
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2590, vrr_stack+3590, vrr_stack+4845, vrr_stack+4725, vrr_stack+4605, vrr_stack+3975);
   tmp = vrr_stack + 2590;
   target_ptr = Libint->vrr_classes[2][14];
   for(i=0;i<720;i++)
     target_ptr[i] += tmp[i];

}

