/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_00fd(Libr12_t *, prim_data *);

  /* Computes (00|fd) integrals for linear R12-methods */

void hrr_grt_order_00fd(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[1][3] = int_stack + 0;
 Libr12->t2vrr_classes[0][3] = int_stack + 30;
 Libr12->gvrr_classes[1][4] = int_stack + 40;
 Libr12->t2vrr_classes[0][4] = int_stack + 85;
 Libr12->t2vrr_classes[0][5] = int_stack + 100;
 Libr12->t1vrr_classes[0][3] = int_stack + 121;
 Libr12->t1vrr_classes[0][4] = int_stack + 131;
 Libr12->t1vrr_classes[0][5] = int_stack + 146;
 Libr12->rvrr_classes[0][3] = int_stack + 167;
 Libr12->rvrr_classes[0][4] = int_stack + 177;
 Libr12->rvrr_classes[0][5] = int_stack + 192;
 Libr12->gvrr_classes[0][3] = int_stack + 213;
 Libr12->gvrr_classes[0][4] = int_stack + 223;
 Libr12->gvrr_classes[0][5] = int_stack + 238;
 memset(int_stack,0,259*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 259;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_00fd(Libr12, Data);
   Data++;
 }

 /*--- compute (00|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+259, int_stack+223, int_stack+213, 1);
 /*--- compute (p0|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+289, int_stack+40, int_stack+0, 3);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+379, int_stack+238, int_stack+223, 1);
 /*--- compute (00|[r12,T2]|fp) ---*/
   t2hrr3_build_fp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+424, int_stack+85, int_stack+30, int_stack+223, int_stack+0, int_stack+213, 0, 0);
 /*--- compute (00|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+454, int_stack+100, int_stack+85, int_stack+238, int_stack+40, int_stack+223, 0, 0);
 /*--- compute (00|[r12,T1]|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+213, int_stack+131, int_stack+121, 1);
 /*--- compute (00|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+146, int_stack+131, 1);
 /*--- compute (00||fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+45, int_stack+177, int_stack+167, 1);
 /*--- compute (00||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+75, int_stack+192, int_stack+177, 1);
 /*--- compute (00|[r12,T2]|fd) ---*/
   t2hrr3_build_fd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+120, int_stack+454, int_stack+424, int_stack+379, int_stack+289, int_stack+259, 0, 0);
     Libr12->te_ptr[3] = int_stack + 120;
 /*--- compute (00|[r12,T1]|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+289, int_stack+0, int_stack+213, 1);
     Libr12->te_ptr[2] = int_stack + 289;
 /*--- compute (00||fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+424, int_stack+75, int_stack+45, 1);
     Libr12->te_ptr[1] = int_stack + 424;
 /*--- compute (00|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+0, int_stack+379, int_stack+259, 1);
     Libr12->te_ptr[0] = int_stack + 0;

}
