/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_hdhh(Libr12_t *, prim_data *);

  /* Computes (hd|hh) integrals for linear R12-methods */

void hrr_grt_order_hdhh(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[5][5] = int_stack + 0;
 Libr12->t2vrr_classes[5][6] = int_stack + 441;
 Libr12->t2vrr_classes[5][7] = int_stack + 1029;
 Libr12->t2vrr_classes[5][8] = int_stack + 1785;
 Libr12->t2vrr_classes[5][9] = int_stack + 2730;
 Libr12->t2vrr_classes[5][10] = int_stack + 3885;
 Libr12->t2vrr_classes[6][5] = int_stack + 5271;
 Libr12->t2vrr_classes[6][6] = int_stack + 5859;
 Libr12->t2vrr_classes[6][7] = int_stack + 6643;
 Libr12->t2vrr_classes[6][8] = int_stack + 7651;
 Libr12->t2vrr_classes[6][9] = int_stack + 8911;
 Libr12->t2vrr_classes[6][10] = int_stack + 10451;
 Libr12->gvrr_classes[8][5] = int_stack + 12299;
 Libr12->t2vrr_classes[7][5] = int_stack + 13244;
 Libr12->gvrr_classes[8][6] = int_stack + 14000;
 Libr12->t2vrr_classes[7][6] = int_stack + 15260;
 Libr12->gvrr_classes[8][7] = int_stack + 16268;
 Libr12->t2vrr_classes[7][7] = int_stack + 17888;
 Libr12->gvrr_classes[8][8] = int_stack + 19184;
 Libr12->t2vrr_classes[7][8] = int_stack + 21209;
 Libr12->gvrr_classes[8][9] = int_stack + 22829;
 Libr12->t2vrr_classes[7][9] = int_stack + 25304;
 Libr12->t2vrr_classes[7][10] = int_stack + 27284;
 Libr12->gvrr_classes[5][11] = int_stack + 29660;
 Libr12->t1vrr_classes[5][5] = int_stack + 31298;
 Libr12->t1vrr_classes[5][6] = int_stack + 31739;
 Libr12->t1vrr_classes[5][7] = int_stack + 32327;
 Libr12->t1vrr_classes[5][8] = int_stack + 33083;
 Libr12->t1vrr_classes[5][9] = int_stack + 34028;
 Libr12->t1vrr_classes[5][10] = int_stack + 35183;
 Libr12->gvrr_classes[6][11] = int_stack + 36569;
 Libr12->t1vrr_classes[6][5] = int_stack + 38753;
 Libr12->t1vrr_classes[6][6] = int_stack + 39341;
 Libr12->t1vrr_classes[6][7] = int_stack + 40125;
 Libr12->t1vrr_classes[6][8] = int_stack + 41133;
 Libr12->t1vrr_classes[6][9] = int_stack + 42393;
 Libr12->t1vrr_classes[6][10] = int_stack + 43933;
 Libr12->t1vrr_classes[7][5] = int_stack + 45781;
 Libr12->t1vrr_classes[7][6] = int_stack + 46537;
 Libr12->t1vrr_classes[7][7] = int_stack + 47545;
 Libr12->t1vrr_classes[7][8] = int_stack + 48841;
 Libr12->t1vrr_classes[7][9] = int_stack + 50461;
 Libr12->t1vrr_classes[7][10] = int_stack + 52441;
 Libr12->rvrr_classes[5][5] = int_stack + 54817;
 Libr12->rvrr_classes[5][6] = int_stack + 55258;
 Libr12->rvrr_classes[5][7] = int_stack + 55846;
 Libr12->rvrr_classes[5][8] = int_stack + 56602;
 Libr12->rvrr_classes[5][9] = int_stack + 57547;
 Libr12->rvrr_classes[5][10] = int_stack + 58702;
 Libr12->rvrr_classes[6][5] = int_stack + 60088;
 Libr12->rvrr_classes[6][6] = int_stack + 60676;
 Libr12->rvrr_classes[6][7] = int_stack + 61460;
 Libr12->rvrr_classes[6][8] = int_stack + 62468;
 Libr12->rvrr_classes[6][9] = int_stack + 63728;
 Libr12->rvrr_classes[6][10] = int_stack + 65268;
 Libr12->rvrr_classes[7][5] = int_stack + 67116;
 Libr12->rvrr_classes[7][6] = int_stack + 67872;
 Libr12->rvrr_classes[7][7] = int_stack + 68880;
 Libr12->rvrr_classes[7][8] = int_stack + 70176;
 Libr12->rvrr_classes[7][9] = int_stack + 71796;
 Libr12->rvrr_classes[7][10] = int_stack + 73776;
 Libr12->gvrr_classes[5][5] = int_stack + 76152;
 Libr12->gvrr_classes[5][6] = int_stack + 76593;
 Libr12->gvrr_classes[5][7] = int_stack + 77181;
 Libr12->gvrr_classes[5][8] = int_stack + 77937;
 Libr12->gvrr_classes[5][9] = int_stack + 78882;
 Libr12->gvrr_classes[5][10] = int_stack + 80037;
 Libr12->gvrr_classes[6][5] = int_stack + 81423;
 Libr12->gvrr_classes[6][6] = int_stack + 82011;
 Libr12->gvrr_classes[6][7] = int_stack + 82795;
 Libr12->gvrr_classes[6][8] = int_stack + 83803;
 Libr12->gvrr_classes[6][9] = int_stack + 85063;
 Libr12->gvrr_classes[6][10] = int_stack + 86603;
 Libr12->gvrr_classes[7][5] = int_stack + 88451;
 Libr12->gvrr_classes[7][6] = int_stack + 89207;
 Libr12->gvrr_classes[7][7] = int_stack + 90215;
 Libr12->gvrr_classes[7][8] = int_stack + 91511;
 Libr12->gvrr_classes[7][9] = int_stack + 93131;
 Libr12->gvrr_classes[7][10] = int_stack + 95111;
 memset(int_stack,0,97487*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 97487;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_hdhh(Libr12, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+97487, int_stack+76593, int_stack+76152, 21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+98810, int_stack+77181, int_stack+76593, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+100574, int_stack+98810, int_stack+97487, 21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+103220, int_stack+77937, int_stack+77181, 21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+105488, int_stack+103220, int_stack+98810, 21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+109016, int_stack+105488, int_stack+100574, 21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+113426, int_stack+78882, int_stack+77937, 21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+116261, int_stack+113426, int_stack+103220, 21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+120797, int_stack+116261, int_stack+105488, 21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+126677, int_stack+120797, int_stack+109016, 21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+133292, int_stack+82011, int_stack+81423, 28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+135056, int_stack+82795, int_stack+82011, 28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+137408, int_stack+135056, int_stack+133292, 28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+140936, int_stack+83803, int_stack+82795, 28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+143960, int_stack+140936, int_stack+135056, 28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+148664, int_stack+143960, int_stack+137408, 28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+154544, int_stack+85063, int_stack+83803, 28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+158324, int_stack+154544, int_stack+140936, 28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+164372, int_stack+158324, int_stack+143960, 28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+172212, int_stack+164372, int_stack+148664, 28);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+181032, int_stack+80037, int_stack+78882, 21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+184497, int_stack+181032, int_stack+113426, 21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+190167, int_stack+184497, int_stack+116261, 21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+197727, int_stack+190167, int_stack+120797, 21);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+206547, int_stack+441, int_stack+0, int_stack+76593, int_stack+81423, int_stack+76152, 5, 0);
 /*--- compute (h0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+207870, int_stack+1029, int_stack+441, int_stack+77181, int_stack+82011, int_stack+76593, 5, 0);
 /*--- compute (h0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+209634, int_stack+207870, int_stack+206547, int_stack+98810, int_stack+133292, int_stack+97487, 5, 0);
 /*--- compute (h0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+212280, int_stack+1785, int_stack+1029, int_stack+77937, int_stack+82795, int_stack+77181, 5, 0);
 /*--- compute (h0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+214548, int_stack+212280, int_stack+207870, int_stack+103220, int_stack+135056, int_stack+98810, 5, 0);
 /*--- compute (h0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+218076, int_stack+214548, int_stack+209634, int_stack+105488, int_stack+137408, int_stack+100574, 5, 0);
 /*--- compute (h0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+97487, int_stack+2730, int_stack+1785, int_stack+78882, int_stack+83803, int_stack+77937, 5, 0);
 /*--- compute (h0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+206547, int_stack+97487, int_stack+212280, int_stack+113426, int_stack+140936, int_stack+103220, 5, 0);
 /*--- compute (h0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+222486, int_stack+206547, int_stack+214548, int_stack+116261, int_stack+143960, int_stack+105488, 5, 0);
 /*--- compute (h0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+100322, int_stack+222486, int_stack+218076, int_stack+120797, int_stack+148664, int_stack+109016, 5, 0);
 /*--- compute (h0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+106937, int_stack+3885, int_stack+2730, int_stack+80037, int_stack+85063, int_stack+78882, 5, 0);
 /*--- compute (h0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+211083, int_stack+106937, int_stack+97487, int_stack+181032, int_stack+154544, int_stack+113426, 5, 0);
 /*--- compute (h0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+106937, int_stack+211083, int_stack+206547, int_stack+184497, int_stack+158324, int_stack+116261, 5, 0);
 /*--- compute (h0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+206547, int_stack+106937, int_stack+222486, int_stack+190167, int_stack+164372, int_stack+120797, 5, 0);
 /*--- compute (h0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+106937, int_stack+206547, int_stack+100322, int_stack+197727, int_stack+172212, int_stack+126677, 5, 0);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+206547, int_stack+89207, int_stack+88451, 36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+208815, int_stack+90215, int_stack+89207, 36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+211839, int_stack+208815, int_stack+206547, 36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+216375, int_stack+91511, int_stack+90215, 36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+220263, int_stack+216375, int_stack+208815, 36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+116198, int_stack+220263, int_stack+211839, 36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+97487, int_stack+93131, int_stack+91511, 36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+226311, int_stack+97487, int_stack+216375, 36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+234087, int_stack+226311, int_stack+220263, 36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+244167, int_stack+234087, int_stack+116198, 36);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+86603, int_stack+85063, 28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+255507, int_stack+0, int_stack+154544, 28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+263067, int_stack+255507, int_stack+158324, 28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+273147, int_stack+263067, int_stack+164372, 28);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+123758, int_stack+5859, int_stack+5271, int_stack+82011, int_stack+88451, int_stack+81423, 6, 0);
 /*--- compute (i0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+102347, int_stack+6643, int_stack+5859, int_stack+82795, int_stack+89207, int_stack+82011, 6, 0);
 /*--- compute (i0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+76152, int_stack+102347, int_stack+123758, int_stack+135056, int_stack+206547, int_stack+133292, 6, 0);
 /*--- compute (i0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+284907, int_stack+7651, int_stack+6643, int_stack+83803, int_stack+90215, int_stack+82795, 6, 0);
 /*--- compute (i0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+287931, int_stack+284907, int_stack+102347, int_stack+140936, int_stack+208815, int_stack+135056, 6, 0);
 /*--- compute (i0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+292635, int_stack+287931, int_stack+76152, int_stack+143960, int_stack+211839, int_stack+137408, 6, 0);
 /*--- compute (i0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+76152, int_stack+8911, int_stack+7651, int_stack+85063, int_stack+91511, int_stack+83803, 6, 0);
 /*--- compute (i0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+133292, int_stack+76152, int_stack+284907, int_stack+154544, int_stack+216375, int_stack+140936, 6, 0);
 /*--- compute (i0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+298515, int_stack+133292, int_stack+287931, int_stack+158324, int_stack+220263, int_stack+143960, 6, 0);
 /*--- compute (i0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+139340, int_stack+298515, int_stack+292635, int_stack+164372, int_stack+116198, int_stack+148664, 6, 0);
 /*--- compute (i0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+284907, int_stack+10451, int_stack+8911, int_stack+86603, int_stack+93131, int_stack+85063, 6, 0);
 /*--- compute (i0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+289527, int_stack+284907, int_stack+76152, int_stack+0, int_stack+97487, int_stack+154544, 6, 0);
 /*--- compute (i0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+148160, int_stack+289527, int_stack+133292, int_stack+255507, int_stack+226311, int_stack+158324, 6, 0);
 /*--- compute (i0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+284907, int_stack+148160, int_stack+298515, int_stack+263067, int_stack+234087, int_stack+164372, 6, 0);
 /*--- compute (i0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+148160, int_stack+284907, int_stack+139340, int_stack+273147, int_stack+244167, int_stack+172212, 6, 0);
 /*--- compute (hp|[r12,T2]|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+284907, int_stack+148160, int_stack+106937, 441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+160508, int_stack+14000, int_stack+12299, 45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+163343, int_stack+16268, int_stack+14000, 45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+133292, int_stack+163343, int_stack+160508, 45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+167123, int_stack+19184, int_stack+16268, 45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+138962, int_stack+167123, int_stack+163343, 45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+102347, int_stack+138962, int_stack+133292, 45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+4620, int_stack+22829, int_stack+19184, 45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+4620, int_stack+167123, 45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+322410, int_stack+312690, int_stack+138962, 45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+335010, int_stack+322410, int_stack+102347, 45);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+349185, int_stack+95111, int_stack+93131, 36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+355125, int_stack+349185, int_stack+97487, 36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+364845, int_stack+355125, int_stack+226311, 36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+377805, int_stack+364845, int_stack+234087, 36);
 /*--- compute (k0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+76152, int_stack+15260, int_stack+13244, int_stack+89207, int_stack+12299, int_stack+88451, 7, 0);
 /*--- compute (k0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+111797, int_stack+17888, int_stack+15260, int_stack+90215, int_stack+14000, int_stack+89207, 7, 0);
 /*--- compute (k0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+81423, int_stack+111797, int_stack+76152, int_stack+208815, int_stack+160508, int_stack+206547, 7, 0);
 /*--- compute (k0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+10695, int_stack+21209, int_stack+17888, int_stack+91511, int_stack+16268, int_stack+90215, 7, 0);
 /*--- compute (k0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+392925, int_stack+10695, int_stack+111797, int_stack+216375, int_stack+163343, int_stack+208815, 7, 0);
 /*--- compute (k0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+398973, int_stack+392925, int_stack+81423, int_stack+220263, int_stack+133292, int_stack+211839, 7, 0);
 /*--- compute (k0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+133292, int_stack+25304, int_stack+21209, int_stack+93131, int_stack+19184, int_stack+91511, 7, 0);
 /*--- compute (k0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+206547, int_stack+133292, int_stack+10695, int_stack+97487, int_stack+167123, int_stack+216375, 7, 0);
 /*--- compute (k0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+10695, int_stack+206547, int_stack+392925, int_stack+226311, int_stack+138962, int_stack+220263, 7, 0);
 /*--- compute (k0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+214323, int_stack+10695, int_stack+398973, int_stack+234087, int_stack+102347, int_stack+116198, 7, 0);
 /*--- compute (k0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+102347, int_stack+27284, int_stack+25304, int_stack+95111, int_stack+22829, int_stack+93131, 7, 0);
 /*--- compute (k0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+108287, int_stack+102347, int_stack+133292, int_stack+349185, int_stack+4620, int_stack+97487, 7, 0);
 /*--- compute (k0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+133292, int_stack+108287, int_stack+206547, int_stack+355125, int_stack+312690, int_stack+226311, 7, 0);
 /*--- compute (k0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+349185, int_stack+133292, int_stack+10695, int_stack+364845, int_stack+322410, int_stack+234087, 7, 0);
 /*--- compute (k0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+312690, int_stack+349185, int_stack+214323, int_stack+377805, int_stack+335010, int_stack+244167, 7, 0);
 /*--- compute (ip|[r12,T2]|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+328566, int_stack+312690, int_stack+148160, 441);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+197727, int_stack+126677, 21);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+206547, int_stack+273147, int_stack+172212, 28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+88451, int_stack+206547, int_stack+312690, 441);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+321951, int_stack+29660, int_stack+80037, 21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+365610, int_stack+321951, int_stack+181032, 21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+218895, int_stack+365610, int_stack+184497, 21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+365610, int_stack+218895, int_stack+190167, 21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+218895, int_stack+365610, int_stack+197727, 21);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+365610, int_stack+36569, int_stack+86603, 28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+231243, int_stack+365610, int_stack+0, 28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+0, int_stack+231243, int_stack+255507, 28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+12600, int_stack+0, int_stack+263067, 28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+255507, int_stack+12600, int_stack+273147, 28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+116234, int_stack+255507, int_stack+218895, 588);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+0, int_stack+377805, int_stack+244167, 36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+365610, int_stack+0, int_stack+206547, 441);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+15876, int_stack+31739, int_stack+31298, 21);
 /*--- compute (h0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+17199, int_stack+32327, int_stack+31739, 21);
 /*--- compute (h0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+18963, int_stack+17199, int_stack+15876, 21);
 /*--- compute (h0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+21609, int_stack+33083, int_stack+32327, 21);
 /*--- compute (h0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+23877, int_stack+21609, int_stack+17199, 21);
 /*--- compute (h0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+27405, int_stack+23877, int_stack+18963, 21);
 /*--- compute (h0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+15876, int_stack+34028, int_stack+33083, 21);
 /*--- compute (h0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+271971, int_stack+15876, int_stack+21609, 21);
 /*--- compute (h0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+276507, int_stack+271971, int_stack+23877, 21);
 /*--- compute (h0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+321951, int_stack+276507, int_stack+27405, 21);
 /*--- compute (h0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+18711, int_stack+35183, int_stack+34028, 21);
 /*--- compute (h0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+22176, int_stack+18711, int_stack+15876, 21);
 /*--- compute (h0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+27846, int_stack+22176, int_stack+271971, 21);
 /*--- compute (h0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+15876, int_stack+27846, int_stack+276507, 21);
 /*--- compute (h0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+271971, int_stack+15876, int_stack+321951, 21);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+321951, int_stack+39341, int_stack+38753, 28);
 /*--- compute (i0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+323715, int_stack+40125, int_stack+39341, 28);
 /*--- compute (i0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+15876, int_stack+323715, int_stack+321951, 28);
 /*--- compute (i0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+19404, int_stack+41133, int_stack+40125, 28);
 /*--- compute (i0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+22428, int_stack+19404, int_stack+323715, 28);
 /*--- compute (i0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+321951, int_stack+22428, int_stack+15876, 28);
 /*--- compute (i0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+27132, int_stack+42393, int_stack+41133, 28);
 /*--- compute (i0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+30912, int_stack+27132, int_stack+19404, 28);
 /*--- compute (i0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+231243, int_stack+30912, int_stack+22428, 28);
 /*--- compute (i0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+15876, int_stack+231243, int_stack+321951, 28);
 /*--- compute (i0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+321951, int_stack+43933, int_stack+42393, 28);
 /*--- compute (i0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+36960, int_stack+321951, int_stack+27132, 28);
 /*--- compute (i0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+239083, int_stack+36960, int_stack+30912, 28);
 /*--- compute (i0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+24696, int_stack+239083, int_stack+231243, 28);
 /*--- compute (i0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+231243, int_stack+24696, int_stack+15876, 28);
 /*--- compute (hp|[r12,T1]|hh) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+15876, int_stack+231243, int_stack+271971, int_stack+206547, int_stack+218895, int_stack+312690, 5, 5);
 /*--- compute (k0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+46537, int_stack+45781, 36);
 /*--- compute (k0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+314958, int_stack+47545, int_stack+46537, 36);
 /*--- compute (k0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+317982, int_stack+314958, int_stack+312690, 36);
 /*--- compute (k0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+322518, int_stack+48841, int_stack+47545, 36);
 /*--- compute (k0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+218895, int_stack+322518, int_stack+314958, 36);
 /*--- compute (k0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+271971, int_stack+218895, int_stack+317982, 36);
 /*--- compute (k0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+50461, int_stack+48841, 36);
 /*--- compute (k0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+243591, int_stack+312690, int_stack+322518, 36);
 /*--- compute (k0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+317550, int_stack+243591, int_stack+218895, 36);
 /*--- compute (k0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+218895, int_stack+317550, int_stack+271971, 36);
 /*--- compute (k0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+271971, int_stack+52441, int_stack+50461, 36);
 /*--- compute (k0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+43659, int_stack+271971, int_stack+312690, 36);
 /*--- compute (k0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+153278, int_stack+43659, int_stack+243591, 36);
 /*--- compute (k0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+166238, int_stack+153278, int_stack+317550, 36);
 /*--- compute (k0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+166238, int_stack+218895, 36);
 /*--- compute (ip|[r12,T1]|hh) ---*/
   t1hrr1_build_ip(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+153278, int_stack+312690, int_stack+231243, int_stack+0, int_stack+255507, int_stack+206547, 5, 5);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+55258, int_stack+54817, 21);
 /*--- compute (h0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1323, int_stack+55846, int_stack+55258, 21);
 /*--- compute (h0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+3087, int_stack+1323, int_stack+0, 21);
 /*--- compute (h0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+5733, int_stack+56602, int_stack+55846, 21);
 /*--- compute (h0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+8001, int_stack+5733, int_stack+1323, 21);
 /*--- compute (h0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+8001, int_stack+3087, 21);
 /*--- compute (h0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+57547, int_stack+56602, 21);
 /*--- compute (h0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+317100, int_stack+0, int_stack+5733, 21);
 /*--- compute (h0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+321636, int_stack+317100, int_stack+8001, 21);
 /*--- compute (h0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+2835, int_stack+321636, int_stack+312690, 21);
 /*--- compute (h0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+58702, int_stack+57547, 21);
 /*--- compute (h0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+9450, int_stack+312690, int_stack+0, 21);
 /*--- compute (h0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+190322, int_stack+9450, int_stack+317100, 21);
 /*--- compute (h0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+190322, int_stack+321636, 21);
 /*--- compute (h0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+190322, int_stack+312690, int_stack+2835, 21);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+60676, int_stack+60088, 28);
 /*--- compute (i0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+314454, int_stack+61460, int_stack+60676, 28);
 /*--- compute (i0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+316806, int_stack+314454, int_stack+312690, 28);
 /*--- compute (i0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+320334, int_stack+62468, int_stack+61460, 28);
 /*--- compute (i0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+323358, int_stack+320334, int_stack+314454, 28);
 /*--- compute (i0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+199583, int_stack+323358, int_stack+316806, 28);
 /*--- compute (i0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+63728, int_stack+62468, 28);
 /*--- compute (i0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+205463, int_stack+312690, int_stack+320334, 28);
 /*--- compute (i0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+211511, int_stack+205463, int_stack+323358, 28);
 /*--- compute (i0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+316470, int_stack+211511, int_stack+199583, 28);
 /*--- compute (i0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+199583, int_stack+65268, int_stack+63728, 28);
 /*--- compute (i0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+219351, int_stack+199583, int_stack+312690, 28);
 /*--- compute (i0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+226911, int_stack+219351, int_stack+205463, 28);
 /*--- compute (i0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+199583, int_stack+226911, int_stack+211511, 28);
 /*--- compute (i0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+211343, int_stack+199583, int_stack+316470, 28);
 /*--- compute (hp||hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+223691, int_stack+211343, int_stack+190322, 441);
 /*--- compute (k0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+190322, int_stack+67872, int_stack+67116, 36);
 /*--- compute (k0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+192590, int_stack+68880, int_stack+67872, 36);
 /*--- compute (k0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+195614, int_stack+192590, int_stack+190322, 36);
 /*--- compute (k0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+200150, int_stack+70176, int_stack+68880, 36);
 /*--- compute (k0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+204038, int_stack+200150, int_stack+192590, 36);
 /*--- compute (k0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+204038, int_stack+195614, 36);
 /*--- compute (k0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+190322, int_stack+71796, int_stack+70176, 36);
 /*--- compute (k0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+320250, int_stack+190322, int_stack+200150, 36);
 /*--- compute (k0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+251474, int_stack+320250, int_stack+204038, 36);
 /*--- compute (k0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+195182, int_stack+251474, int_stack+312690, 36);
 /*--- compute (k0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+73776, int_stack+71796, 36);
 /*--- compute (k0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+261554, int_stack+312690, int_stack+190322, 36);
 /*--- compute (k0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+271274, int_stack+261554, int_stack+320250, 36);
 /*--- compute (k0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+312690, int_stack+271274, int_stack+251474, 36);
 /*--- compute (k0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+0, int_stack+312690, int_stack+195182, 36);
 /*--- compute (ip||hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+43659, int_stack+0, int_stack+211343, 441);
 /*--- compute (hd|[r12,T2]|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+402654, int_stack+328566, int_stack+284907, 441);
     Libr12->te_ptr[3] = int_stack + 402654;
 /*--- compute (hd|[r12,T1]|hh) ---*/
   t1hrr1_build_hd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+251474, int_stack+153278, int_stack+15876, int_stack+365610, int_stack+116234, int_stack+88451, 5, 5);
     Libr12->te_ptr[2] = int_stack + 251474;
 /*--- compute (hd||hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+116234, int_stack+43659, int_stack+223691, 441);
     Libr12->te_ptr[1] = int_stack + 116234;
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+171800, int_stack+365610, int_stack+88451, 441);
     Libr12->te_ptr[0] = int_stack + 171800;

}
