/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (hs||0s) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_h000(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (fouro2z)*I1[0] - (fouro4zn)*I4[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (threeo2z)*I1[1] - (threeo4zn)*I4[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (threeo2z)*I1[2] - (threeo4zn)*I4[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (twoo2z)*I1[3] - (twoo4zn)*I4[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (twoo2z)*I1[4] - (twoo4zn)*I4[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (twoo2z)*I1[5] - (twoo4zn)*I4[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (oneo2z)*I1[6] - (oneo4zn)*I4[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (oneo2z)*I1[7] - (oneo4zn)*I4[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (oneo2z)*I1[8] - (oneo4zn)*I4[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14];
*(vp++) = U01*I0[10] - U11*I3[10] + loo2p*I2[15]
        + (fouro2z)*I1[6] - (fouro4zn)*I4[6];
*(vp++) = U01*I0[11] - U11*I3[11] + loo2p*I2[16]
        + (threeo2z)*I1[7] - (threeo4zn)*I4[7];
*(vp++) = U01*I0[12] - U11*I3[12] + loo2p*I2[17]
        + (twoo2z)*I1[8] - (twoo4zn)*I4[8];
*(vp++) = U01*I0[13] - U11*I3[13] + loo2p*I2[18]
        + (oneo2z)*I1[9] - (oneo4zn)*I4[9];
*(vp++) = U01*I0[14] - U11*I3[14] + loo2p*I2[19];
*(vp++) = U02*I0[14] - U12*I3[14] + loo2p*I2[20]
        + (fouro2z)*I1[9] - (fouro4zn)*I4[9];

}
