/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00gg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|gg) integrals */

void d12hrr_order_00gg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][8][11] = int_stack + 0;
 Libderiv->deriv_classes[0][8][10] = int_stack + 45;
 Libderiv->deriv_classes[0][8][9] = int_stack + 90;
 Libderiv->deriv_classes[0][8][8] = int_stack + 135;
 Libderiv->deriv_classes[0][8][7] = int_stack + 180;
 Libderiv->dvrr_classes[0][7] = int_stack + 225;
 Libderiv->deriv_classes[0][8][6] = int_stack + 261;
 Libderiv->deriv_classes[0][8][2] = int_stack + 306;
 Libderiv->deriv_classes[0][8][1] = int_stack + 351;
 Libderiv->deriv_classes[0][8][0] = int_stack + 396;
 Libderiv->deriv2_classes[0][4][143] = int_stack + 441;
 Libderiv->deriv2_classes[0][5][143] = int_stack + 456;
 Libderiv->deriv2_classes[0][6][143] = int_stack + 477;
 Libderiv->deriv2_classes[0][7][143] = int_stack + 505;
 Libderiv->deriv2_classes[0][8][143] = int_stack + 541;
 Libderiv->deriv2_classes[0][4][131] = int_stack + 586;
 Libderiv->deriv2_classes[0][5][131] = int_stack + 601;
 Libderiv->deriv2_classes[0][6][131] = int_stack + 622;
 Libderiv->deriv2_classes[0][7][131] = int_stack + 650;
 Libderiv->deriv2_classes[0][8][131] = int_stack + 686;
 Libderiv->deriv2_classes[0][4][130] = int_stack + 731;
 Libderiv->deriv2_classes[0][5][130] = int_stack + 746;
 Libderiv->deriv2_classes[0][6][130] = int_stack + 767;
 Libderiv->deriv2_classes[0][7][130] = int_stack + 795;
 Libderiv->deriv2_classes[0][8][130] = int_stack + 831;
 Libderiv->deriv2_classes[0][4][119] = int_stack + 876;
 Libderiv->deriv2_classes[0][5][119] = int_stack + 891;
 Libderiv->deriv2_classes[0][6][119] = int_stack + 912;
 Libderiv->deriv2_classes[0][7][119] = int_stack + 940;
 Libderiv->deriv2_classes[0][8][119] = int_stack + 976;
 Libderiv->deriv2_classes[0][4][118] = int_stack + 1021;
 Libderiv->deriv2_classes[0][5][118] = int_stack + 1036;
 Libderiv->deriv2_classes[0][6][118] = int_stack + 1057;
 Libderiv->deriv2_classes[0][7][118] = int_stack + 1085;
 Libderiv->deriv2_classes[0][8][118] = int_stack + 1121;
 Libderiv->deriv2_classes[0][4][117] = int_stack + 1166;
 Libderiv->deriv2_classes[0][5][117] = int_stack + 1181;
 Libderiv->deriv2_classes[0][6][117] = int_stack + 1202;
 Libderiv->deriv2_classes[0][7][117] = int_stack + 1230;
 Libderiv->deriv2_classes[0][8][117] = int_stack + 1266;
 Libderiv->deriv2_classes[0][4][107] = int_stack + 1311;
 Libderiv->deriv2_classes[0][5][107] = int_stack + 1326;
 Libderiv->deriv2_classes[0][6][107] = int_stack + 1347;
 Libderiv->deriv2_classes[0][7][107] = int_stack + 1375;
 Libderiv->deriv2_classes[0][8][107] = int_stack + 1411;
 Libderiv->deriv2_classes[0][4][106] = int_stack + 1456;
 Libderiv->deriv2_classes[0][5][106] = int_stack + 1471;
 Libderiv->deriv2_classes[0][6][106] = int_stack + 1492;
 Libderiv->deriv2_classes[0][7][106] = int_stack + 1520;
 Libderiv->deriv2_classes[0][8][106] = int_stack + 1556;
 Libderiv->deriv2_classes[0][4][105] = int_stack + 1601;
 Libderiv->deriv2_classes[0][5][105] = int_stack + 1616;
 Libderiv->deriv2_classes[0][6][105] = int_stack + 1637;
 Libderiv->deriv2_classes[0][7][105] = int_stack + 1665;
 Libderiv->deriv2_classes[0][8][105] = int_stack + 1701;
 Libderiv->deriv2_classes[0][4][104] = int_stack + 1746;
 Libderiv->deriv2_classes[0][5][104] = int_stack + 1761;
 Libderiv->deriv2_classes[0][6][104] = int_stack + 1782;
 Libderiv->deriv2_classes[0][7][104] = int_stack + 1810;
 Libderiv->deriv2_classes[0][8][104] = int_stack + 1846;
 Libderiv->deriv2_classes[0][4][95] = int_stack + 1891;
 Libderiv->deriv2_classes[0][5][95] = int_stack + 1906;
 Libderiv->deriv2_classes[0][6][95] = int_stack + 1927;
 Libderiv->deriv2_classes[0][7][95] = int_stack + 1955;
 Libderiv->deriv2_classes[0][8][95] = int_stack + 1991;
 Libderiv->deriv2_classes[0][4][94] = int_stack + 2036;
 Libderiv->deriv2_classes[0][5][94] = int_stack + 2051;
 Libderiv->deriv2_classes[0][6][94] = int_stack + 2072;
 Libderiv->deriv2_classes[0][7][94] = int_stack + 2100;
 Libderiv->deriv2_classes[0][8][94] = int_stack + 2136;
 Libderiv->deriv2_classes[0][4][93] = int_stack + 2181;
 Libderiv->deriv2_classes[0][5][93] = int_stack + 2196;
 Libderiv->deriv2_classes[0][6][93] = int_stack + 2217;
 Libderiv->deriv2_classes[0][7][93] = int_stack + 2245;
 Libderiv->deriv2_classes[0][8][93] = int_stack + 2281;
 Libderiv->deriv2_classes[0][4][92] = int_stack + 2326;
 Libderiv->deriv2_classes[0][5][92] = int_stack + 2341;
 Libderiv->deriv2_classes[0][6][92] = int_stack + 2362;
 Libderiv->deriv2_classes[0][7][92] = int_stack + 2390;
 Libderiv->deriv2_classes[0][8][92] = int_stack + 2426;
 Libderiv->deriv2_classes[0][4][91] = int_stack + 2471;
 Libderiv->deriv2_classes[0][5][91] = int_stack + 2486;
 Libderiv->deriv2_classes[0][6][91] = int_stack + 2507;
 Libderiv->deriv2_classes[0][7][91] = int_stack + 2535;
 Libderiv->deriv2_classes[0][8][91] = int_stack + 2571;
 Libderiv->deriv_classes[0][4][11] = int_stack + 2616;
 Libderiv->deriv2_classes[0][4][83] = int_stack + 2631;
 Libderiv->deriv_classes[0][5][11] = int_stack + 2646;
 Libderiv->deriv2_classes[0][5][83] = int_stack + 2667;
 Libderiv->deriv_classes[0][6][11] = int_stack + 2688;
 Libderiv->deriv2_classes[0][6][83] = int_stack + 2716;
 Libderiv->deriv_classes[0][7][11] = int_stack + 2744;
 Libderiv->deriv2_classes[0][7][83] = int_stack + 2780;
 Libderiv->deriv2_classes[0][8][83] = int_stack + 2816;
 Libderiv->deriv_classes[0][4][10] = int_stack + 2861;
 Libderiv->deriv2_classes[0][4][82] = int_stack + 2876;
 Libderiv->deriv_classes[0][5][10] = int_stack + 2891;
 Libderiv->deriv2_classes[0][5][82] = int_stack + 2912;
 Libderiv->deriv_classes[0][6][10] = int_stack + 2933;
 Libderiv->deriv2_classes[0][6][82] = int_stack + 2961;
 Libderiv->deriv_classes[0][7][10] = int_stack + 2989;
 Libderiv->deriv2_classes[0][7][82] = int_stack + 3025;
 Libderiv->deriv2_classes[0][8][82] = int_stack + 3061;
 Libderiv->deriv_classes[0][4][9] = int_stack + 3106;
 Libderiv->deriv2_classes[0][4][81] = int_stack + 3121;
 Libderiv->deriv_classes[0][5][9] = int_stack + 3136;
 Libderiv->deriv2_classes[0][5][81] = int_stack + 3157;
 Libderiv->deriv_classes[0][6][9] = int_stack + 3178;
 Libderiv->deriv2_classes[0][6][81] = int_stack + 3206;
 Libderiv->deriv_classes[0][7][9] = int_stack + 3234;
 Libderiv->deriv2_classes[0][7][81] = int_stack + 3270;
 Libderiv->deriv2_classes[0][8][81] = int_stack + 3306;
 Libderiv->deriv_classes[0][4][8] = int_stack + 3351;
 Libderiv->deriv2_classes[0][4][80] = int_stack + 3366;
 Libderiv->deriv_classes[0][5][8] = int_stack + 3381;
 Libderiv->deriv2_classes[0][5][80] = int_stack + 3402;
 Libderiv->deriv_classes[0][6][8] = int_stack + 3423;
 Libderiv->deriv2_classes[0][6][80] = int_stack + 3451;
 Libderiv->deriv_classes[0][7][8] = int_stack + 3479;
 Libderiv->deriv2_classes[0][7][80] = int_stack + 3515;
 Libderiv->deriv2_classes[0][8][80] = int_stack + 3551;
 Libderiv->deriv_classes[0][4][7] = int_stack + 3596;
 Libderiv->deriv2_classes[0][4][79] = int_stack + 3611;
 Libderiv->deriv_classes[0][5][7] = int_stack + 3626;
 Libderiv->deriv2_classes[0][5][79] = int_stack + 3647;
 Libderiv->deriv_classes[0][6][7] = int_stack + 3668;
 Libderiv->deriv2_classes[0][6][79] = int_stack + 3696;
 Libderiv->deriv_classes[0][7][7] = int_stack + 3724;
 Libderiv->deriv2_classes[0][7][79] = int_stack + 3760;
 Libderiv->deriv2_classes[0][8][79] = int_stack + 3796;
 Libderiv->dvrr_classes[0][4] = int_stack + 3841;
 Libderiv->deriv_classes[0][4][6] = int_stack + 3856;
 Libderiv->deriv2_classes[0][4][78] = int_stack + 3871;
 Libderiv->dvrr_classes[0][5] = int_stack + 3886;
 Libderiv->deriv_classes[0][5][6] = int_stack + 3907;
 Libderiv->deriv2_classes[0][5][78] = int_stack + 3928;
 Libderiv->dvrr_classes[0][6] = int_stack + 3949;
 Libderiv->deriv_classes[0][6][6] = int_stack + 3977;
 Libderiv->deriv2_classes[0][6][78] = int_stack + 4005;
 Libderiv->deriv_classes[0][7][6] = int_stack + 4033;
 Libderiv->deriv2_classes[0][7][78] = int_stack + 4069;
 Libderiv->deriv2_classes[0][8][78] = int_stack + 4105;
 Libderiv->deriv2_classes[0][4][35] = int_stack + 4150;
 Libderiv->deriv2_classes[0][5][35] = int_stack + 4165;
 Libderiv->deriv2_classes[0][6][35] = int_stack + 4186;
 Libderiv->deriv2_classes[0][7][35] = int_stack + 4214;
 Libderiv->deriv2_classes[0][8][35] = int_stack + 4250;
 Libderiv->deriv2_classes[0][4][34] = int_stack + 4295;
 Libderiv->deriv2_classes[0][5][34] = int_stack + 4310;
 Libderiv->deriv2_classes[0][6][34] = int_stack + 4331;
 Libderiv->deriv2_classes[0][7][34] = int_stack + 4359;
 Libderiv->deriv2_classes[0][8][34] = int_stack + 4395;
 Libderiv->deriv2_classes[0][4][33] = int_stack + 4440;
 Libderiv->deriv2_classes[0][5][33] = int_stack + 4455;
 Libderiv->deriv2_classes[0][6][33] = int_stack + 4476;
 Libderiv->deriv2_classes[0][7][33] = int_stack + 4504;
 Libderiv->deriv2_classes[0][8][33] = int_stack + 4540;
 Libderiv->deriv2_classes[0][4][32] = int_stack + 4585;
 Libderiv->deriv2_classes[0][5][32] = int_stack + 4600;
 Libderiv->deriv2_classes[0][6][32] = int_stack + 4621;
 Libderiv->deriv2_classes[0][7][32] = int_stack + 4649;
 Libderiv->deriv2_classes[0][8][32] = int_stack + 4685;
 Libderiv->deriv2_classes[0][4][31] = int_stack + 4730;
 Libderiv->deriv2_classes[0][5][31] = int_stack + 4745;
 Libderiv->deriv2_classes[0][6][31] = int_stack + 4766;
 Libderiv->deriv2_classes[0][7][31] = int_stack + 4794;
 Libderiv->deriv2_classes[0][8][31] = int_stack + 4830;
 Libderiv->deriv_classes[0][4][2] = int_stack + 4875;
 Libderiv->deriv2_classes[0][4][30] = int_stack + 4890;
 Libderiv->deriv_classes[0][5][2] = int_stack + 4905;
 Libderiv->deriv2_classes[0][5][30] = int_stack + 4926;
 Libderiv->deriv_classes[0][6][2] = int_stack + 4947;
 Libderiv->deriv2_classes[0][6][30] = int_stack + 4975;
 Libderiv->deriv_classes[0][7][2] = int_stack + 5003;
 Libderiv->deriv2_classes[0][7][30] = int_stack + 5039;
 Libderiv->deriv2_classes[0][8][30] = int_stack + 5075;
 Libderiv->deriv2_classes[0][4][26] = int_stack + 5120;
 Libderiv->deriv2_classes[0][5][26] = int_stack + 5135;
 Libderiv->deriv2_classes[0][6][26] = int_stack + 5156;
 Libderiv->deriv2_classes[0][7][26] = int_stack + 5184;
 Libderiv->deriv2_classes[0][8][26] = int_stack + 5220;
 Libderiv->deriv2_classes[0][4][23] = int_stack + 5265;
 Libderiv->deriv2_classes[0][5][23] = int_stack + 5280;
 Libderiv->deriv2_classes[0][6][23] = int_stack + 5301;
 Libderiv->deriv2_classes[0][7][23] = int_stack + 5329;
 Libderiv->deriv2_classes[0][8][23] = int_stack + 5365;
 Libderiv->deriv2_classes[0][4][22] = int_stack + 5410;
 Libderiv->deriv2_classes[0][5][22] = int_stack + 5425;
 Libderiv->deriv2_classes[0][6][22] = int_stack + 5446;
 Libderiv->deriv2_classes[0][7][22] = int_stack + 5474;
 Libderiv->deriv2_classes[0][8][22] = int_stack + 5510;
 Libderiv->deriv2_classes[0][4][21] = int_stack + 5555;
 Libderiv->deriv2_classes[0][5][21] = int_stack + 5570;
 Libderiv->deriv2_classes[0][6][21] = int_stack + 5591;
 Libderiv->deriv2_classes[0][7][21] = int_stack + 5619;
 Libderiv->deriv2_classes[0][8][21] = int_stack + 5655;
 Libderiv->deriv2_classes[0][4][20] = int_stack + 5700;
 Libderiv->deriv2_classes[0][5][20] = int_stack + 5715;
 Libderiv->deriv2_classes[0][6][20] = int_stack + 5736;
 Libderiv->deriv2_classes[0][7][20] = int_stack + 5764;
 Libderiv->deriv2_classes[0][8][20] = int_stack + 5800;
 Libderiv->deriv2_classes[0][4][19] = int_stack + 5845;
 Libderiv->deriv2_classes[0][5][19] = int_stack + 5860;
 Libderiv->deriv2_classes[0][6][19] = int_stack + 5881;
 Libderiv->deriv2_classes[0][7][19] = int_stack + 5909;
 Libderiv->deriv2_classes[0][8][19] = int_stack + 5945;
 Libderiv->deriv_classes[0][4][1] = int_stack + 5990;
 Libderiv->deriv2_classes[0][4][18] = int_stack + 6005;
 Libderiv->deriv_classes[0][5][1] = int_stack + 6020;
 Libderiv->deriv2_classes[0][5][18] = int_stack + 6041;
 Libderiv->deriv_classes[0][6][1] = int_stack + 6062;
 Libderiv->deriv2_classes[0][6][18] = int_stack + 6090;
 Libderiv->deriv_classes[0][7][1] = int_stack + 6118;
 Libderiv->deriv2_classes[0][7][18] = int_stack + 6154;
 Libderiv->deriv2_classes[0][8][18] = int_stack + 6190;
 Libderiv->deriv2_classes[0][4][14] = int_stack + 6235;
 Libderiv->deriv2_classes[0][5][14] = int_stack + 6250;
 Libderiv->deriv2_classes[0][6][14] = int_stack + 6271;
 Libderiv->deriv2_classes[0][7][14] = int_stack + 6299;
 Libderiv->deriv2_classes[0][8][14] = int_stack + 6335;
 Libderiv->deriv2_classes[0][4][13] = int_stack + 6380;
 Libderiv->deriv2_classes[0][5][13] = int_stack + 6395;
 Libderiv->deriv2_classes[0][6][13] = int_stack + 6416;
 Libderiv->deriv2_classes[0][7][13] = int_stack + 6444;
 Libderiv->deriv2_classes[0][8][13] = int_stack + 6480;
 Libderiv->deriv2_classes[0][4][11] = int_stack + 6525;
 Libderiv->deriv2_classes[0][5][11] = int_stack + 6540;
 Libderiv->deriv2_classes[0][6][11] = int_stack + 6561;
 Libderiv->deriv2_classes[0][7][11] = int_stack + 6589;
 Libderiv->deriv2_classes[0][8][11] = int_stack + 6625;
 Libderiv->deriv2_classes[0][4][10] = int_stack + 6670;
 Libderiv->deriv2_classes[0][5][10] = int_stack + 6685;
 Libderiv->deriv2_classes[0][6][10] = int_stack + 6706;
 Libderiv->deriv2_classes[0][7][10] = int_stack + 6734;
 Libderiv->deriv2_classes[0][8][10] = int_stack + 6770;
 Libderiv->deriv2_classes[0][4][9] = int_stack + 6815;
 Libderiv->deriv2_classes[0][5][9] = int_stack + 6830;
 Libderiv->deriv2_classes[0][6][9] = int_stack + 6851;
 Libderiv->deriv2_classes[0][7][9] = int_stack + 6879;
 Libderiv->deriv2_classes[0][8][9] = int_stack + 6915;
 Libderiv->deriv2_classes[0][4][8] = int_stack + 6960;
 Libderiv->deriv2_classes[0][5][8] = int_stack + 6975;
 Libderiv->deriv2_classes[0][6][8] = int_stack + 6996;
 Libderiv->deriv2_classes[0][7][8] = int_stack + 7024;
 Libderiv->deriv2_classes[0][8][8] = int_stack + 7060;
 Libderiv->deriv2_classes[0][4][7] = int_stack + 7105;
 Libderiv->deriv2_classes[0][5][7] = int_stack + 7120;
 Libderiv->deriv2_classes[0][6][7] = int_stack + 7141;
 Libderiv->deriv2_classes[0][7][7] = int_stack + 7169;
 Libderiv->deriv2_classes[0][8][7] = int_stack + 7205;
 Libderiv->deriv_classes[0][4][0] = int_stack + 7250;
 Libderiv->deriv2_classes[0][4][6] = int_stack + 7265;
 Libderiv->deriv_classes[0][5][0] = int_stack + 7280;
 Libderiv->deriv2_classes[0][5][6] = int_stack + 7301;
 Libderiv->deriv_classes[0][6][0] = int_stack + 7322;
 Libderiv->deriv2_classes[0][6][6] = int_stack + 7350;
 Libderiv->deriv_classes[0][7][0] = int_stack + 7378;
 Libderiv->deriv2_classes[0][7][6] = int_stack + 7414;
 Libderiv->deriv2_classes[0][8][6] = int_stack + 7450;
 Libderiv->deriv2_classes[0][4][2] = int_stack + 7495;
 Libderiv->deriv2_classes[0][5][2] = int_stack + 7510;
 Libderiv->deriv2_classes[0][6][2] = int_stack + 7531;
 Libderiv->deriv2_classes[0][7][2] = int_stack + 7559;
 Libderiv->deriv2_classes[0][8][2] = int_stack + 7595;
 Libderiv->deriv2_classes[0][4][1] = int_stack + 7640;
 Libderiv->deriv2_classes[0][5][1] = int_stack + 7655;
 Libderiv->deriv2_classes[0][6][1] = int_stack + 7676;
 Libderiv->deriv2_classes[0][7][1] = int_stack + 7704;
 Libderiv->deriv2_classes[0][8][1] = int_stack + 7740;
 Libderiv->deriv2_classes[0][4][0] = int_stack + 7785;
 Libderiv->deriv2_classes[0][5][0] = int_stack + 7800;
 Libderiv->deriv2_classes[0][6][0] = int_stack + 7821;
 Libderiv->deriv2_classes[0][7][0] = int_stack + 7849;
 Libderiv->deriv2_classes[0][8][0] = int_stack + 7885;
 memset(int_stack,0,63440);

 Libderiv->dvrr_stack = int_stack + 22363;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00gg(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+7930,int_stack+3886,int_stack+3841,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7975,int_stack+3949,int_stack+3886,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+8038,int_stack+7975,int_stack+7930,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8128,int_stack+225,int_stack+3949,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+8212,int_stack+8128,int_stack+7975,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+8338,int_stack+8212,int_stack+8038,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8488,int_stack+2646,int_stack+2616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3841,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8533,int_stack+2688,int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3886,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8596,int_stack+8533,int_stack+8488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7930,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8686,int_stack+2744,int_stack+2688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3949,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8770,int_stack+8686,int_stack+8533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7975,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8896,int_stack+8770,int_stack+8596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8038,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9046,int_stack+0,int_stack+2744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9154,int_stack+9046,int_stack+8686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8128,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9322,int_stack+9154,int_stack+8770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8212,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+2891,int_stack+2861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3841, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9046,int_stack+2933,int_stack+2891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3886, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9109,int_stack+9046,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7930, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9199,int_stack+2989,int_stack+2933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3949, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9532,int_stack+9199,int_stack+9046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7975, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9658,int_stack+9532,int_stack+9109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8038, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9808,int_stack+45,int_stack+2989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9916,int_stack+9808,int_stack+9199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8128, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10084,int_stack+9916,int_stack+9532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8212, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+45,int_stack+3136,int_stack+3106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3841, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9808,int_stack+3178,int_stack+3136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3886, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9871,int_stack+9808,int_stack+45, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7930, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9961,int_stack+3234,int_stack+3178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3949, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10294,int_stack+9961,int_stack+9808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7975, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+10420,int_stack+10294,int_stack+9871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8038, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10570,int_stack+90,int_stack+3234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10678,int_stack+10570,int_stack+9961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8128, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10846,int_stack+10678,int_stack+10294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8212, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90,int_stack+3381,int_stack+3351, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10570,int_stack+3423,int_stack+3381, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10633,int_stack+10570,int_stack+90, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10723,int_stack+3479,int_stack+3423, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11056,int_stack+10723,int_stack+10570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+11182,int_stack+11056,int_stack+10633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11332,int_stack+135,int_stack+3479, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11440,int_stack+11332,int_stack+10723, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11608,int_stack+11440,int_stack+11056, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+135,int_stack+3626,int_stack+3596, 0.0, zero_stack, 1.0, int_stack+3841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11332,int_stack+3668,int_stack+3626, 0.0, zero_stack, 1.0, int_stack+3886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11395,int_stack+11332,int_stack+135, 0.0, zero_stack, 1.0, int_stack+7930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11485,int_stack+3724,int_stack+3668, 0.0, zero_stack, 1.0, int_stack+3949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11818,int_stack+11485,int_stack+11332, 0.0, zero_stack, 1.0, int_stack+7975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+11944,int_stack+11818,int_stack+11395, 0.0, zero_stack, 1.0, int_stack+8038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12094,int_stack+180,int_stack+3724, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12202,int_stack+12094,int_stack+11485, 0.0, zero_stack, 1.0, int_stack+8128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12370,int_stack+12202,int_stack+11818, 0.0, zero_stack, 1.0, int_stack+8212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+180,int_stack+3907,int_stack+3856, 1.0, int_stack+3841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12094,int_stack+3977,int_stack+3907, 1.0, int_stack+3886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12157,int_stack+12094,int_stack+180, 1.0, int_stack+7930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12247,int_stack+4033,int_stack+3977, 1.0, int_stack+3949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+12247,int_stack+12094, 1.0, int_stack+7975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12706,int_stack+12580,int_stack+12157, 1.0, int_stack+8038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7930,int_stack+261,int_stack+4033, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12856,int_stack+7930,int_stack+12247, 1.0, int_stack+8128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7930,int_stack+12856,int_stack+12580, 1.0, int_stack+8212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12856,int_stack+4905,int_stack+4875,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+12901,int_stack+4947,int_stack+4905,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+12964,int_stack+12901,int_stack+12856,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+13054,int_stack+5003,int_stack+4947,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+13138,int_stack+13054,int_stack+12901,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+13264,int_stack+13138,int_stack+12964,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+13414,int_stack+306,int_stack+5003,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+13522,int_stack+13414,int_stack+13054,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+13690,int_stack+13522,int_stack+13138,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+13414,int_stack+6020,int_stack+5990,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13459,int_stack+6062,int_stack+6020,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+13522,int_stack+13459,int_stack+13414,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+6118,int_stack+6062,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+225,int_stack+13900,int_stack+13459,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+8140,int_stack+225,int_stack+13522,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+13984,int_stack+351,int_stack+6118,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14092,int_stack+13984,int_stack+13900,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+14260,int_stack+14092,int_stack+225,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+351,int_stack+7280,int_stack+7250,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13984,int_stack+7322,int_stack+7280,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+14047,int_stack+13984,int_stack+351,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14137,int_stack+7378,int_stack+7322,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+14470,int_stack+14137,int_stack+13984,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+14596,int_stack+14470,int_stack+14047,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14746,int_stack+396,int_stack+7378,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14854,int_stack+14746,int_stack+14137,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+15022,int_stack+14854,int_stack+14470,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+396,int_stack+456,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2616,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14746,int_stack+477,int_stack+456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2646,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14809,int_stack+14746,int_stack+396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8488,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14899,int_stack+505,int_stack+477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2688,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15232,int_stack+14899,int_stack+14746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8533,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15358,int_stack+15232,int_stack+14809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8596,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14746,int_stack+541,int_stack+505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2744,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+396,int_stack+14746,int_stack+14899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8686,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+14746,int_stack+396,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8770,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15232,int_stack+601,int_stack+586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2616, 1.0, int_stack+2861,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15277,int_stack+622,int_stack+601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2646, 1.0, int_stack+2891,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+396,int_stack+15277,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8488, 1.0, int_stack+0,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+486,int_stack+650,int_stack+622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2688, 1.0, int_stack+2933,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+486,int_stack+15277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8533, 1.0, int_stack+9046,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15634,int_stack+15508,int_stack+396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8596, 1.0, int_stack+9109,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15232,int_stack+686,int_stack+650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2744, 1.0, int_stack+2989,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15784,int_stack+15232,int_stack+486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8686, 1.0, int_stack+9199,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+396,int_stack+15784,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8770, 1.0, int_stack+9532,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+746,int_stack+731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2861, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+767,int_stack+746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2891, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15784,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15874,int_stack+795,int_stack+767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2933, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15232,int_stack+15874,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9046, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+606,int_stack+15232,int_stack+15784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9109, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+831,int_stack+795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2989, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15958,int_stack+15508,int_stack+15874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9199, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16126,int_stack+15958,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9532, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15232,int_stack+891,int_stack+876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2616, 0.0, zero_stack, 1.0, int_stack+3106,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15277,int_stack+912,int_stack+891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2646, 0.0, zero_stack, 1.0, int_stack+3136,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15508,int_stack+15277,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8488, 0.0, zero_stack, 1.0, int_stack+45,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15784,int_stack+940,int_stack+912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2688, 0.0, zero_stack, 1.0, int_stack+3178,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15868,int_stack+15784,int_stack+15277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8533, 0.0, zero_stack, 1.0, int_stack+9808,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16336,int_stack+15868,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8596, 0.0, zero_stack, 1.0, int_stack+9871,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+976,int_stack+940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2744, 0.0, zero_stack, 1.0, int_stack+3234,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16486,int_stack+15508,int_stack+15784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8686, 0.0, zero_stack, 1.0, int_stack+9961,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16654,int_stack+16486,int_stack+15868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8770, 0.0, zero_stack, 1.0, int_stack+10294,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16486,int_stack+1036,int_stack+1021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2861, 1.0, int_stack+3106, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16531,int_stack+1057,int_stack+1036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2891, 1.0, int_stack+3136, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15784,int_stack+16531,int_stack+16486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+45, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15874,int_stack+1085,int_stack+1057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2933, 1.0, int_stack+3178, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+15874,int_stack+16531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9046, 1.0, int_stack+9808, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16486,int_stack+15508,int_stack+15784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9109, 1.0, int_stack+9871, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15958,int_stack+1121,int_stack+1085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2989, 1.0, int_stack+3234, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+756,int_stack+15958,int_stack+15874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9199, 1.0, int_stack+9961, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+15784,int_stack+756,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9532, 1.0, int_stack+10294, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+1181,int_stack+1166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3106, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+1202,int_stack+1181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3136, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+756,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+45, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+846,int_stack+1230,int_stack+1202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3178, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15232,int_stack+846,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9808, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+930,int_stack+15232,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9871, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+1266,int_stack+1230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3234, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1080,int_stack+15508,int_stack+846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9961, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16864,int_stack+1080,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10294, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15232,int_stack+1326,int_stack+1311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2616, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3351,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15277,int_stack+1347,int_stack+1326, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3381,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1080,int_stack+15277,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8488, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1170,int_stack+1375,int_stack+1347, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2688, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3423,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+1170,int_stack+15277, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8533, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10570,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+756,int_stack+15508,int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8596, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10633,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15232,int_stack+1411,int_stack+1375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2744, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3479,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1254,int_stack+15232,int_stack+1170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10723,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17074,int_stack+1254,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11056,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+1471,int_stack+1456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2861, 0.0, zero_stack, 1.0, int_stack+3351, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+1492,int_stack+1471, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2891, 0.0, zero_stack, 1.0, int_stack+3381, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15232,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+90, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1080,int_stack+1520,int_stack+1492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2933, 0.0, zero_stack, 1.0, int_stack+3423, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1164,int_stack+1080,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9046, 0.0, zero_stack, 1.0, int_stack+10570, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1290,int_stack+1164,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9109, 0.0, zero_stack, 1.0, int_stack+10633, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15232,int_stack+1556,int_stack+1520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2989, 0.0, zero_stack, 1.0, int_stack+3479, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17284,int_stack+15232,int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9199, 0.0, zero_stack, 1.0, int_stack+10723, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17452,int_stack+17284,int_stack+1164, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9532, 0.0, zero_stack, 1.0, int_stack+11056, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17284,int_stack+1616,int_stack+1601, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3106, 1.0, int_stack+3351, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+17329,int_stack+1637,int_stack+1616, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3136, 1.0, int_stack+3381, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1080,int_stack+17329,int_stack+17284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45, 1.0, int_stack+90, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1170,int_stack+1665,int_stack+1637, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3178, 1.0, int_stack+3423, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15232,int_stack+1170,int_stack+17329, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9808, 1.0, int_stack+10570, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+17284,int_stack+15232,int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9871, 1.0, int_stack+10633, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+1701,int_stack+1665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3234, 1.0, int_stack+3479, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1440,int_stack+15508,int_stack+1170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9961, 1.0, int_stack+10723, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1080,int_stack+1440,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10294, 1.0, int_stack+11056, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15232,int_stack+1761,int_stack+1746, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15277,int_stack+1782,int_stack+1761, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1440,int_stack+15277,int_stack+15232, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+90, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1530,int_stack+1810,int_stack+1782, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+1530,int_stack+15277, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1614,int_stack+15508,int_stack+1440, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15232,int_stack+1846,int_stack+1810, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17662,int_stack+15232,int_stack+1530, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17830,int_stack+17662,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+1906,int_stack+1891, 0.0, zero_stack, 1.0, int_stack+2616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3596,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+1927,int_stack+1906, 0.0, zero_stack, 1.0, int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3626,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17662,int_stack+15553,int_stack+15508, 0.0, zero_stack, 1.0, int_stack+8488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15232,int_stack+1955,int_stack+1927, 0.0, zero_stack, 1.0, int_stack+2688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3668,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1440,int_stack+15232,int_stack+15553, 0.0, zero_stack, 1.0, int_stack+8533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11332,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1764,int_stack+1440,int_stack+17662, 0.0, zero_stack, 1.0, int_stack+8596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11395,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17662,int_stack+1991,int_stack+1955, 0.0, zero_stack, 1.0, int_stack+2744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3724,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18040,int_stack+17662,int_stack+15232, 0.0, zero_stack, 1.0, int_stack+8686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11485,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18208,int_stack+18040,int_stack+1440, 0.0, zero_stack, 1.0, int_stack+8770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11818,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1440,int_stack+2051,int_stack+2036, 0.0, zero_stack, 1.0, int_stack+2861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3596, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1485,int_stack+2072,int_stack+2051, 0.0, zero_stack, 1.0, int_stack+2891, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3626, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18040,int_stack+1485,int_stack+1440, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15232,int_stack+2100,int_stack+2072, 0.0, zero_stack, 1.0, int_stack+2933, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3668, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+15232,int_stack+1485, 0.0, zero_stack, 1.0, int_stack+9046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11332, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1440,int_stack+15508,int_stack+18040, 0.0, zero_stack, 1.0, int_stack+9109, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11395, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+18040,int_stack+2136,int_stack+2100, 0.0, zero_stack, 1.0, int_stack+2989, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3724, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17662,int_stack+18040,int_stack+15232, 0.0, zero_stack, 1.0, int_stack+9199, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11485, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1914,int_stack+17662,int_stack+15508, 0.0, zero_stack, 1.0, int_stack+9532, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11818, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+2196,int_stack+2181, 0.0, zero_stack, 1.0, int_stack+3106, 0.0, zero_stack, 1.0, int_stack+3596, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+2217,int_stack+2196, 0.0, zero_stack, 1.0, int_stack+3136, 0.0, zero_stack, 1.0, int_stack+3626, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17662,int_stack+15553,int_stack+15508, 0.0, zero_stack, 1.0, int_stack+45, 0.0, zero_stack, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15232,int_stack+2245,int_stack+2217, 0.0, zero_stack, 1.0, int_stack+3178, 0.0, zero_stack, 1.0, int_stack+3668, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18040,int_stack+15232,int_stack+15553, 0.0, zero_stack, 1.0, int_stack+9808, 0.0, zero_stack, 1.0, int_stack+11332, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+18418,int_stack+18040,int_stack+17662, 0.0, zero_stack, 1.0, int_stack+9871, 0.0, zero_stack, 1.0, int_stack+11395, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17662,int_stack+2281,int_stack+2245, 0.0, zero_stack, 1.0, int_stack+3234, 0.0, zero_stack, 1.0, int_stack+3724, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2124,int_stack+17662,int_stack+15232, 0.0, zero_stack, 1.0, int_stack+9961, 0.0, zero_stack, 1.0, int_stack+11485, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18568,int_stack+2124,int_stack+18040, 0.0, zero_stack, 1.0, int_stack+10294, 0.0, zero_stack, 1.0, int_stack+11818, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18040,int_stack+2341,int_stack+2326, 0.0, zero_stack, 1.0, int_stack+3351, 1.0, int_stack+3596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18085,int_stack+2362,int_stack+2341, 0.0, zero_stack, 1.0, int_stack+3381, 1.0, int_stack+3626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2124,int_stack+18085,int_stack+18040, 0.0, zero_stack, 1.0, int_stack+90, 1.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2214,int_stack+2390,int_stack+2362, 0.0, zero_stack, 1.0, int_stack+3423, 1.0, int_stack+3668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15232,int_stack+2214,int_stack+18085, 0.0, zero_stack, 1.0, int_stack+10570, 1.0, int_stack+11332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+18040,int_stack+15232,int_stack+2124, 0.0, zero_stack, 1.0, int_stack+10633, 1.0, int_stack+11395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17662,int_stack+2426,int_stack+2390, 0.0, zero_stack, 1.0, int_stack+3479, 1.0, int_stack+3724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2298,int_stack+17662,int_stack+2214, 0.0, zero_stack, 1.0, int_stack+10723, 1.0, int_stack+11485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18778,int_stack+2298,int_stack+15232, 0.0, zero_stack, 1.0, int_stack+11056, 1.0, int_stack+11818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15232,int_stack+2486,int_stack+2471, 0.0, zero_stack, 2.0, int_stack+3596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15277,int_stack+2507,int_stack+2486, 0.0, zero_stack, 2.0, int_stack+3626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17662,int_stack+15277,int_stack+15232, 0.0, zero_stack, 2.0, int_stack+135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+2535,int_stack+2507, 0.0, zero_stack, 2.0, int_stack+3668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+15277, 0.0, zero_stack, 2.0, int_stack+11332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2208,int_stack+15508,int_stack+17662, 0.0, zero_stack, 2.0, int_stack+11395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17662,int_stack+2571,int_stack+2535, 0.0, zero_stack, 2.0, int_stack+3724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2358,int_stack+17662,int_stack+2124, 0.0, zero_stack, 2.0, int_stack+11485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18988,int_stack+2358,int_stack+15508, 0.0, zero_stack, 2.0, int_stack+11818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+2667,int_stack+2631, 1.0, int_stack+2616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3856,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+2716,int_stack+2667, 1.0, int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3907,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 1.0, int_stack+8488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+2780,int_stack+2716, 1.0, int_stack+2688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3977,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15232,int_stack+2124,int_stack+15553, 1.0, int_stack+8533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12094,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2448,int_stack+15232,int_stack+2358, 1.0, int_stack+8596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12157,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8488,int_stack+2816,int_stack+2780, 1.0, int_stack+2744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4033,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17662,int_stack+8488,int_stack+2124, 1.0, int_stack+8686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12247,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8488,int_stack+17662,int_stack+15232, 1.0, int_stack+8770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12580,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15232,int_stack+2912,int_stack+2876, 1.0, int_stack+2861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3856, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15277,int_stack+2961,int_stack+2912, 1.0, int_stack+2891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3907, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15277,int_stack+15232, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+3025,int_stack+2961, 1.0, int_stack+2933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3977, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+15277, 1.0, int_stack+9046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12094, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+17662,int_stack+15508,int_stack+2358, 1.0, int_stack+9109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12157, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9046,int_stack+3061,int_stack+3025, 1.0, int_stack+2989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4033, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8698,int_stack+9046,int_stack+2124, 1.0, int_stack+9199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12247, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9046,int_stack+8698,int_stack+15508, 1.0, int_stack+9532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12580, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+3157,int_stack+3121, 1.0, int_stack+3106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3856, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9532,int_stack+3206,int_stack+3157, 1.0, int_stack+3136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3907, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+9532,int_stack+0, 1.0, int_stack+45, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+3270,int_stack+3206, 1.0, int_stack+3178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3977, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+9532, 1.0, int_stack+9808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12094, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8698,int_stack+15508,int_stack+2358, 1.0, int_stack+9871, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12157, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9808,int_stack+3306,int_stack+3270, 1.0, int_stack+3234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4033, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2598,int_stack+9808,int_stack+2124, 1.0, int_stack+9961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12247, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9808,int_stack+2598,int_stack+15508, 1.0, int_stack+10294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12580, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10294,int_stack+3402,int_stack+3366, 1.0, int_stack+3351, 0.0, zero_stack, 1.0, int_stack+3856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10339,int_stack+3451,int_stack+3402, 1.0, int_stack+3381, 0.0, zero_stack, 1.0, int_stack+3907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+10339,int_stack+10294, 1.0, int_stack+90, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+3515,int_stack+3451, 1.0, int_stack+3423, 0.0, zero_stack, 1.0, int_stack+3977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+10339, 1.0, int_stack+10570, 0.0, zero_stack, 1.0, int_stack+12094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2598,int_stack+15508,int_stack+2358, 1.0, int_stack+10633, 0.0, zero_stack, 1.0, int_stack+12157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10570,int_stack+3551,int_stack+3515, 1.0, int_stack+3479, 0.0, zero_stack, 1.0, int_stack+4033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2748,int_stack+10570,int_stack+2124, 1.0, int_stack+10723, 0.0, zero_stack, 1.0, int_stack+12247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10570,int_stack+2748,int_stack+15508, 1.0, int_stack+11056, 0.0, zero_stack, 1.0, int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11056,int_stack+3647,int_stack+3611, 1.0, int_stack+3596, 1.0, int_stack+3856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11101,int_stack+3696,int_stack+3647, 1.0, int_stack+3626, 1.0, int_stack+3907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+11101,int_stack+11056, 1.0, int_stack+135, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+3760,int_stack+3696, 1.0, int_stack+3668, 1.0, int_stack+3977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+11101, 1.0, int_stack+11332, 1.0, int_stack+12094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2748,int_stack+15508,int_stack+2358, 1.0, int_stack+11395, 1.0, int_stack+12157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11332,int_stack+3796,int_stack+3760, 1.0, int_stack+3724, 1.0, int_stack+4033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2898,int_stack+11332,int_stack+2124, 1.0, int_stack+11485, 1.0, int_stack+12247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11332,int_stack+2898,int_stack+15508, 1.0, int_stack+11818, 1.0, int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11818,int_stack+3928,int_stack+3871, 2.0, int_stack+3856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11863,int_stack+4005,int_stack+3928, 2.0, int_stack+3907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+11863,int_stack+11818, 2.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+4069,int_stack+4005, 2.0, int_stack+3977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+11863, 2.0, int_stack+12094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2898,int_stack+15508,int_stack+2358, 2.0, int_stack+12157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12094,int_stack+4105,int_stack+4069, 2.0, int_stack+4033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3048,int_stack+12094,int_stack+2124, 2.0, int_stack+12247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12094,int_stack+3048,int_stack+15508, 2.0, int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+4165,int_stack+4150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4875,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+4186,int_stack+4165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4905,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12856,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+4214,int_stack+4186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4947,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+12625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12901,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3048,int_stack+15508,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12964,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+4250,int_stack+4214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5003,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3198,int_stack+12580,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13054,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3366,int_stack+3198,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13138,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+4310,int_stack+4295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4875, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+4331,int_stack+4310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4905, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12856, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+4359,int_stack+4331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4947, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+2124,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12901, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3198,int_stack+12580,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12964, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+4395,int_stack+4359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5003, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3576,int_stack+15508,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13054, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3744,int_stack+3576,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13138, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+4455,int_stack+4440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4875, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+4476,int_stack+4455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4905, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12856, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+4504,int_stack+4476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4947, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+12625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12901, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3576,int_stack+15508,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12964, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+4540,int_stack+4504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5003, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3954,int_stack+12580,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13054, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4122,int_stack+3954,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13138, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+4600,int_stack+4585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+4621,int_stack+4600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+4649,int_stack+4621, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+2124,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3954,int_stack+12580,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+4685,int_stack+4649, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4332,int_stack+15508,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4500,int_stack+4332,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+4745,int_stack+4730, 0.0, zero_stack, 1.0, int_stack+4875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+4766,int_stack+4745, 0.0, zero_stack, 1.0, int_stack+4905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 0.0, zero_stack, 1.0, int_stack+12856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+4794,int_stack+4766, 0.0, zero_stack, 1.0, int_stack+4947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+12625, 0.0, zero_stack, 1.0, int_stack+12901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4332,int_stack+15508,int_stack+2358, 0.0, zero_stack, 1.0, int_stack+12964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+4830,int_stack+4794, 0.0, zero_stack, 1.0, int_stack+5003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+12580,int_stack+2124, 0.0, zero_stack, 1.0, int_stack+13054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19198,int_stack+0,int_stack+15508, 0.0, zero_stack, 1.0, int_stack+13138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+4926,int_stack+4890, 1.0, int_stack+4875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+4975,int_stack+4926, 1.0, int_stack+4905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 1.0, int_stack+12856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+5039,int_stack+4975, 1.0, int_stack+4947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+2124,int_stack+15553, 1.0, int_stack+12901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+12580,int_stack+2358, 1.0, int_stack+12964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12856,int_stack+5075,int_stack+5039, 1.0, int_stack+5003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4710,int_stack+12856,int_stack+2124, 1.0, int_stack+13054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12856,int_stack+4710,int_stack+12580, 1.0, int_stack+13138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+5135,int_stack+5120,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+5156,int_stack+5135,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+5184,int_stack+5156,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+12625,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+4710,int_stack+15508,int_stack+2358,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+5220,int_stack+5184,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4860,int_stack+12580,int_stack+2124,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5028,int_stack+4860,int_stack+15508,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+5280,int_stack+5265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5990,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+5301,int_stack+5280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6020,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13414,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+5329,int_stack+5301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6062,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+2124,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13459,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4860,int_stack+12580,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13522,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+5365,int_stack+5329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6118,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5238,int_stack+15508,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13900,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19408,int_stack+5238,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+5425,int_stack+5410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5990, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+5446,int_stack+5425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6020, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13414, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+5474,int_stack+5446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6062, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+12625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13459, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5238,int_stack+15508,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13522, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+5510,int_stack+5474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6118, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13066,int_stack+12580,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13900, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19618,int_stack+13066,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+5570,int_stack+5555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5990, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+5591,int_stack+5570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6020, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13414, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+5619,int_stack+5591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6062, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+2124,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13459, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13066,int_stack+12580,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13522, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+5655,int_stack+5619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6118, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5388,int_stack+15508,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13900, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19828,int_stack+5388,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+5715,int_stack+5700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+5736,int_stack+5715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+5764,int_stack+5736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+12625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5388,int_stack+15508,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+5800,int_stack+5764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5538,int_stack+12580,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20038,int_stack+5538,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+5860,int_stack+5845, 0.0, zero_stack, 1.0, int_stack+5990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+5881,int_stack+5860, 0.0, zero_stack, 1.0, int_stack+6020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 1.0, int_stack+13414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+5909,int_stack+5881, 0.0, zero_stack, 1.0, int_stack+6062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+2124,int_stack+15553, 0.0, zero_stack, 1.0, int_stack+13459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5538,int_stack+12580,int_stack+2358, 0.0, zero_stack, 1.0, int_stack+13522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+5945,int_stack+5909, 0.0, zero_stack, 1.0, int_stack+6118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5688,int_stack+15508,int_stack+2124, 0.0, zero_stack, 1.0, int_stack+13900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20248,int_stack+5688,int_stack+12580, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+6041,int_stack+6005, 1.0, int_stack+5990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+6090,int_stack+6041, 1.0, int_stack+6020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 1.0, int_stack+13414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+6154,int_stack+6090, 1.0, int_stack+6062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+12625, 1.0, int_stack+13459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5688,int_stack+15508,int_stack+2358, 1.0, int_stack+13522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+13414,int_stack+6190,int_stack+6154, 1.0, int_stack+6118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13522,int_stack+13414,int_stack+2124, 1.0, int_stack+13900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5838,int_stack+13522,int_stack+15508, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+6250,int_stack+6235,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+6271,int_stack+6250,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+6299,int_stack+6271,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+13900,int_stack+15553,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+13414,int_stack+12580,int_stack+2358,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+6335,int_stack+6299,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6048,int_stack+15508,int_stack+13900,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+20458,int_stack+6048,int_stack+12580,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+6395,int_stack+6380,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+6416,int_stack+6395,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+6444,int_stack+6416,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+13900,int_stack+12625,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+6048,int_stack+15508,int_stack+2358,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+6480,int_stack+6444,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6198,int_stack+12580,int_stack+13900,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+20668,int_stack+6198,int_stack+15508,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+6540,int_stack+6525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7250,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+6561,int_stack+6540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7280,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+6589,int_stack+6561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7322,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+13900,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13984,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6198,int_stack+12580,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14047,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+6625,int_stack+6589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7378,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6348,int_stack+15508,int_stack+13900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14137,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20878,int_stack+6348,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14470,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+6685,int_stack+6670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7250, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+6706,int_stack+6685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7280, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+6734,int_stack+6706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7322, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+13900,int_stack+12625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13984, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6348,int_stack+15508,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14047, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+6770,int_stack+6734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7378, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6498,int_stack+12580,int_stack+13900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14137, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21088,int_stack+6498,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14470, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+6830,int_stack+6815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7250, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+6851,int_stack+6830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7280, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+6879,int_stack+6851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7322, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+13900,int_stack+15553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13984, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6498,int_stack+12580,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14047, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+6915,int_stack+6879, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7378, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6648,int_stack+15508,int_stack+13900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14137, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21298,int_stack+6648,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14470, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+6975,int_stack+6960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+6996,int_stack+6975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+7024,int_stack+6996, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+13900,int_stack+12625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6648,int_stack+15508,int_stack+2358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12580,int_stack+7060,int_stack+7024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6798,int_stack+12580,int_stack+13900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21508,int_stack+6798,int_stack+15508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+7120,int_stack+7105, 0.0, zero_stack, 1.0, int_stack+7250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+7141,int_stack+7120, 0.0, zero_stack, 1.0, int_stack+7280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508, 0.0, zero_stack, 1.0, int_stack+351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+7169,int_stack+7141, 0.0, zero_stack, 1.0, int_stack+7322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12580,int_stack+13900,int_stack+15553, 0.0, zero_stack, 1.0, int_stack+13984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6798,int_stack+12580,int_stack+2358, 0.0, zero_stack, 1.0, int_stack+14047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+7205,int_stack+7169, 0.0, zero_stack, 1.0, int_stack+7378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6948,int_stack+15508,int_stack+13900, 0.0, zero_stack, 1.0, int_stack+14137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21718,int_stack+6948,int_stack+12580, 0.0, zero_stack, 1.0, int_stack+14470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12580,int_stack+7301,int_stack+7265, 1.0, int_stack+7250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12625,int_stack+7350,int_stack+7301, 1.0, int_stack+7280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+12625,int_stack+12580, 1.0, int_stack+351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13900,int_stack+7414,int_stack+7350, 1.0, int_stack+7322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+13900,int_stack+12625, 1.0, int_stack+13984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6948,int_stack+15508,int_stack+2358, 1.0, int_stack+14047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+13984,int_stack+7450,int_stack+7414, 1.0, int_stack+7378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7098,int_stack+13984,int_stack+13900, 1.0, int_stack+14137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13900,int_stack+7098,int_stack+15508, 1.0, int_stack+14470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+14470,int_stack+7510,int_stack+7495,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+14515,int_stack+7531,int_stack+7510,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+14515,int_stack+14470,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+7559,int_stack+7531,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+14515,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+14110,int_stack+15508,int_stack+2358,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14470,int_stack+7595,int_stack+7559,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7098,int_stack+14470,int_stack+2124,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7266,int_stack+7098,int_stack+15508,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15508,int_stack+7655,int_stack+7640,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+15553,int_stack+7676,int_stack+7655,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+15553,int_stack+15508,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+7704,int_stack+7676,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+14470,int_stack+2124,int_stack+15553,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+7098,int_stack+14470,int_stack+2358,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+15508,int_stack+7740,int_stack+7704,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7476,int_stack+15508,int_stack+2124,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+150,int_stack+7476,int_stack+14470,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+14470,int_stack+7800,int_stack+7785,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+14515,int_stack+7821,int_stack+7800,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2358,int_stack+14515,int_stack+14470,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2124,int_stack+7849,int_stack+7821,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+15508,int_stack+2124,int_stack+14515,1);
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+7476,int_stack+15508,int_stack+2358,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14470,int_stack+7885,int_stack+7849,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7626,int_stack+14470,int_stack+2124,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+21928,int_stack+7626,int_stack+15508,1);
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+7626,int_stack+9322,int_stack+8896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8338,1);
     Libderiv->ABCD[11] = int_stack + 7626;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+9256,int_stack+10084,int_stack+9658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8338, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 9256;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+10018,int_stack+10846,int_stack+10420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8338, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 10018;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+10780,int_stack+11608,int_stack+11182, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 10780;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+11542,int_stack+12370,int_stack+11944, 0.0, zero_stack, 1.0, int_stack+8338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 11542;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12304,int_stack+7930,int_stack+12706, 1.0, int_stack+8338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 12304;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+7851,int_stack+13690,int_stack+13264,1);
     Libderiv->ABCD[2] = int_stack + 7851;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+13564,int_stack+14260,int_stack+8140,1);
     Libderiv->ABCD[1] = int_stack + 13564;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+14260,int_stack+15022,int_stack+14596,1);
     Libderiv->ABCD[0] = int_stack + 14260;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+22138,int_stack+14746,int_stack+15358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8896,1);
     Libderiv->ABCD[155] = int_stack + 22138;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+14746,int_stack+396,int_stack+15634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8896, 1.0, int_stack+9658,1);
     Libderiv->ABCD[143] = int_stack + 14746;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+14971,int_stack+16126,int_stack+606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9658, 0.0, zero_stack,1);
     Libderiv->ABCD[142] = int_stack + 14971;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15196,int_stack+16654,int_stack+16336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8896, 0.0, zero_stack, 1.0, int_stack+10420,1);
     Libderiv->ABCD[131] = int_stack + 15196;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15421,int_stack+15784,int_stack+16486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9658, 1.0, int_stack+10420, 0.0, zero_stack,1);
     Libderiv->ABCD[130] = int_stack + 15421;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15646,int_stack+16864,int_stack+930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10420, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[129] = int_stack + 15646;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15871,int_stack+17074,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8896, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11182,1);
     Libderiv->ABCD[119] = int_stack + 15871;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16096,int_stack+17452,int_stack+1290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9658, 0.0, zero_stack, 1.0, int_stack+11182, 0.0, zero_stack,1);
     Libderiv->ABCD[118] = int_stack + 16096;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16321,int_stack+1080,int_stack+17284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10420, 1.0, int_stack+11182, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[117] = int_stack + 16321;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16546,int_stack+17830,int_stack+1614, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[116] = int_stack + 16546;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16771,int_stack+18208,int_stack+1764, 0.0, zero_stack, 1.0, int_stack+8896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11944,1);
     Libderiv->ABCD[107] = int_stack + 16771;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16996,int_stack+1914,int_stack+1440, 0.0, zero_stack, 1.0, int_stack+9658, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11944, 0.0, zero_stack,1);
     Libderiv->ABCD[106] = int_stack + 16996;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17221,int_stack+18568,int_stack+18418, 0.0, zero_stack, 1.0, int_stack+10420, 0.0, zero_stack, 1.0, int_stack+11944, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[105] = int_stack + 17221;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+360,int_stack+18778,int_stack+18040, 0.0, zero_stack, 1.0, int_stack+11182, 1.0, int_stack+11944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[104] = int_stack + 360;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+585,int_stack+18988,int_stack+2208, 0.0, zero_stack, 2.0, int_stack+11944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[103] = int_stack + 585;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+810,int_stack+8488,int_stack+2448, 1.0, int_stack+8896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12706,1);
     Libderiv->ABCD[95] = int_stack + 810;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1035,int_stack+9046,int_stack+17662, 1.0, int_stack+9658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12706, 0.0, zero_stack,1);
     Libderiv->ABCD[94] = int_stack + 1035;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17446,int_stack+9808,int_stack+8698, 1.0, int_stack+10420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12706, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[93] = int_stack + 17446;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17671,int_stack+10570,int_stack+2598, 1.0, int_stack+11182, 0.0, zero_stack, 1.0, int_stack+12706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[92] = int_stack + 17671;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17896,int_stack+11332,int_stack+2748, 1.0, int_stack+11944, 1.0, int_stack+12706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[91] = int_stack + 17896;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+18121,int_stack+12094,int_stack+2898, 2.0, int_stack+12706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[90] = int_stack + 18121;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+18346,int_stack+3366,int_stack+3048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13264,1);
     Libderiv->ABCD[47] = int_stack + 18346;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+18571,int_stack+3744,int_stack+3198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13264, 0.0, zero_stack,1);
     Libderiv->ABCD[46] = int_stack + 18571;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+18796,int_stack+4122,int_stack+3576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13264, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[45] = int_stack + 18796;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1260,int_stack+4500,int_stack+3954, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[44] = int_stack + 1260;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1485,int_stack+19198,int_stack+4332, 0.0, zero_stack, 1.0, int_stack+13264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[43] = int_stack + 1485;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+19021,int_stack+12856,int_stack+0, 1.0, int_stack+13264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[42] = int_stack + 19021;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1710,int_stack+5028,int_stack+4710,1);
     Libderiv->ABCD[38] = int_stack + 1710;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+5010,int_stack+19408,int_stack+4860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140,1);
     Libderiv->ABCD[35] = int_stack + 5010;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+19246,int_stack+19618,int_stack+5238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack,1);
     Libderiv->ABCD[34] = int_stack + 19246;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+19471,int_stack+19828,int_stack+13066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[33] = int_stack + 19471;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+19696,int_stack+20038,int_stack+5388, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[32] = int_stack + 19696;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+19921,int_stack+20248,int_stack+5538, 0.0, zero_stack, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[31] = int_stack + 19921;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+20146,int_stack+5838,int_stack+5688, 1.0, int_stack+8140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[30] = int_stack + 20146;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+8076,int_stack+20458,int_stack+13414,1);
     Libderiv->ABCD[26] = int_stack + 8076;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+20371,int_stack+20668,int_stack+6048,1);
     Libderiv->ABCD[25] = int_stack + 20371;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+20596,int_stack+20878,int_stack+6198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14596,1);
     Libderiv->ABCD[23] = int_stack + 20596;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+20821,int_stack+21088,int_stack+6348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14596, 0.0, zero_stack,1);
     Libderiv->ABCD[22] = int_stack + 20821;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+21046,int_stack+21298,int_stack+6498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14596, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[21] = int_stack + 21046;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+21271,int_stack+21508,int_stack+6648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[20] = int_stack + 21271;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+8301,int_stack+21718,int_stack+6798, 0.0, zero_stack, 1.0, int_stack+14596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[19] = int_stack + 8301;
 /*--- compute (00|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+21496,int_stack+13900,int_stack+6948, 1.0, int_stack+14596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[18] = int_stack + 21496;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+14485,int_stack+7266,int_stack+14110,1);
     Libderiv->ABCD[14] = int_stack + 14485;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+8526,int_stack+150,int_stack+7098,1);
     Libderiv->ABCD[13] = int_stack + 8526;
 /*--- compute (00|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+21928,int_stack+7476,1);
     Libderiv->ABCD[12] = int_stack + 0;

}
