/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fdhg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fd|hg) integrals */

void d12hrr_order_fdhg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][9][11] = int_stack + 0;
 Libderiv->deriv_classes[5][9][10] = int_stack + 1155;
 Libderiv->deriv_classes[5][9][9] = int_stack + 2310;
 Libderiv->deriv_classes[5][9][8] = int_stack + 3465;
 Libderiv->deriv_classes[5][9][7] = int_stack + 4620;
 Libderiv->dvrr_classes[5][8] = int_stack + 5775;
 Libderiv->deriv_classes[5][9][6] = int_stack + 6720;
 Libderiv->deriv_classes[5][9][2] = int_stack + 7875;
 Libderiv->deriv_classes[5][9][1] = int_stack + 9030;
 Libderiv->dvrr_classes[4][9] = int_stack + 10185;
 Libderiv->deriv_classes[5][9][0] = int_stack + 11010;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 12165;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 12375;
 Libderiv->deriv2_classes[3][7][143] = int_stack + 12655;
 Libderiv->deriv2_classes[3][8][143] = int_stack + 13015;
 Libderiv->deriv2_classes[3][9][143] = int_stack + 13465;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 14015;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 14330;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 14750;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 15290;
 Libderiv->deriv2_classes[4][9][143] = int_stack + 15965;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 16790;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 17231;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 17819;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 18575;
 Libderiv->deriv2_classes[5][9][143] = int_stack + 19520;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 20675;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 20885;
 Libderiv->deriv2_classes[3][7][131] = int_stack + 21165;
 Libderiv->deriv2_classes[3][8][131] = int_stack + 21525;
 Libderiv->deriv2_classes[3][9][131] = int_stack + 21975;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 22525;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 22840;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 23260;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 23800;
 Libderiv->deriv2_classes[4][9][131] = int_stack + 24475;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 25300;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 25741;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 26329;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 27085;
 Libderiv->deriv2_classes[5][9][131] = int_stack + 28030;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 29185;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 29395;
 Libderiv->deriv2_classes[3][7][130] = int_stack + 29675;
 Libderiv->deriv2_classes[3][8][130] = int_stack + 30035;
 Libderiv->deriv2_classes[3][9][130] = int_stack + 30485;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 31035;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 31350;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 31770;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 32310;
 Libderiv->deriv2_classes[4][9][130] = int_stack + 32985;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 33810;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 34251;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 34839;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 35595;
 Libderiv->deriv2_classes[5][9][130] = int_stack + 36540;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 37695;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 37905;
 Libderiv->deriv2_classes[3][7][119] = int_stack + 38185;
 Libderiv->deriv2_classes[3][8][119] = int_stack + 38545;
 Libderiv->deriv2_classes[3][9][119] = int_stack + 38995;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 39545;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 39860;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 40280;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 40820;
 Libderiv->deriv2_classes[4][9][119] = int_stack + 41495;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 42320;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 42761;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 43349;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 44105;
 Libderiv->deriv2_classes[5][9][119] = int_stack + 45050;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 46205;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 46415;
 Libderiv->deriv2_classes[3][7][118] = int_stack + 46695;
 Libderiv->deriv2_classes[3][8][118] = int_stack + 47055;
 Libderiv->deriv2_classes[3][9][118] = int_stack + 47505;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 48055;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 48370;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 48790;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 49330;
 Libderiv->deriv2_classes[4][9][118] = int_stack + 50005;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 50830;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 51271;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 51859;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 52615;
 Libderiv->deriv2_classes[5][9][118] = int_stack + 53560;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 54715;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 54925;
 Libderiv->deriv2_classes[3][7][117] = int_stack + 55205;
 Libderiv->deriv2_classes[3][8][117] = int_stack + 55565;
 Libderiv->deriv2_classes[3][9][117] = int_stack + 56015;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 56565;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 56880;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 57300;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 57840;
 Libderiv->deriv2_classes[4][9][117] = int_stack + 58515;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 59340;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 59781;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 60369;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 61125;
 Libderiv->deriv2_classes[5][9][117] = int_stack + 62070;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 63225;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 63435;
 Libderiv->deriv2_classes[3][7][107] = int_stack + 63715;
 Libderiv->deriv2_classes[3][8][107] = int_stack + 64075;
 Libderiv->deriv2_classes[3][9][107] = int_stack + 64525;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 65075;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 65390;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 65810;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 66350;
 Libderiv->deriv2_classes[4][9][107] = int_stack + 67025;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 67850;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 68291;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 68879;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 69635;
 Libderiv->deriv2_classes[5][9][107] = int_stack + 70580;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 71735;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 71945;
 Libderiv->deriv2_classes[3][7][106] = int_stack + 72225;
 Libderiv->deriv2_classes[3][8][106] = int_stack + 72585;
 Libderiv->deriv2_classes[3][9][106] = int_stack + 73035;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 73585;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 73900;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 74320;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 74860;
 Libderiv->deriv2_classes[4][9][106] = int_stack + 75535;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 76360;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 76801;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 77389;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 78145;
 Libderiv->deriv2_classes[5][9][106] = int_stack + 79090;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 80245;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 80455;
 Libderiv->deriv2_classes[3][7][105] = int_stack + 80735;
 Libderiv->deriv2_classes[3][8][105] = int_stack + 81095;
 Libderiv->deriv2_classes[3][9][105] = int_stack + 81545;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 82095;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 82410;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 82830;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 83370;
 Libderiv->deriv2_classes[4][9][105] = int_stack + 84045;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 84870;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 85311;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 85899;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 86655;
 Libderiv->deriv2_classes[5][9][105] = int_stack + 87600;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 88755;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 88965;
 Libderiv->deriv2_classes[3][7][104] = int_stack + 89245;
 Libderiv->deriv2_classes[3][8][104] = int_stack + 89605;
 Libderiv->deriv2_classes[3][9][104] = int_stack + 90055;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 90605;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 90920;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 91340;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 91880;
 Libderiv->deriv2_classes[4][9][104] = int_stack + 92555;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 93380;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 93821;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 94409;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 95165;
 Libderiv->deriv2_classes[5][9][104] = int_stack + 96110;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 97265;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 97475;
 Libderiv->deriv2_classes[3][7][95] = int_stack + 97755;
 Libderiv->deriv2_classes[3][8][95] = int_stack + 98115;
 Libderiv->deriv2_classes[3][9][95] = int_stack + 98565;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 99115;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 99430;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 99850;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 100390;
 Libderiv->deriv2_classes[4][9][95] = int_stack + 101065;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 101890;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 102331;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 102919;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 103675;
 Libderiv->deriv2_classes[5][9][95] = int_stack + 104620;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 105775;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 105985;
 Libderiv->deriv2_classes[3][7][94] = int_stack + 106265;
 Libderiv->deriv2_classes[3][8][94] = int_stack + 106625;
 Libderiv->deriv2_classes[3][9][94] = int_stack + 107075;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 107625;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 107940;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 108360;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 108900;
 Libderiv->deriv2_classes[4][9][94] = int_stack + 109575;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 110400;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 110841;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 111429;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 112185;
 Libderiv->deriv2_classes[5][9][94] = int_stack + 113130;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 114285;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 114495;
 Libderiv->deriv2_classes[3][7][93] = int_stack + 114775;
 Libderiv->deriv2_classes[3][8][93] = int_stack + 115135;
 Libderiv->deriv2_classes[3][9][93] = int_stack + 115585;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 116135;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 116450;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 116870;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 117410;
 Libderiv->deriv2_classes[4][9][93] = int_stack + 118085;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 118910;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 119351;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 119939;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 120695;
 Libderiv->deriv2_classes[5][9][93] = int_stack + 121640;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 122795;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 123005;
 Libderiv->deriv2_classes[3][7][92] = int_stack + 123285;
 Libderiv->deriv2_classes[3][8][92] = int_stack + 123645;
 Libderiv->deriv2_classes[3][9][92] = int_stack + 124095;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 124645;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 124960;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 125380;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 125920;
 Libderiv->deriv2_classes[4][9][92] = int_stack + 126595;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 127420;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 127861;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 128449;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 129205;
 Libderiv->deriv2_classes[5][9][92] = int_stack + 130150;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 131305;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 131515;
 Libderiv->deriv2_classes[3][7][91] = int_stack + 131795;
 Libderiv->deriv2_classes[3][8][91] = int_stack + 132155;
 Libderiv->deriv2_classes[3][9][91] = int_stack + 132605;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 133155;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 133470;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 133890;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 134430;
 Libderiv->deriv2_classes[4][9][91] = int_stack + 135105;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 135930;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 136371;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 136959;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 137715;
 Libderiv->deriv2_classes[5][9][91] = int_stack + 138660;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 139815;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 140025;
 Libderiv->deriv2_classes[3][7][83] = int_stack + 140305;
 Libderiv->deriv2_classes[3][8][83] = int_stack + 140665;
 Libderiv->deriv2_classes[3][9][83] = int_stack + 141115;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 141665;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 141980;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 142400;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 142940;
 Libderiv->deriv2_classes[4][9][83] = int_stack + 143615;
 Libderiv->deriv_classes[5][5][11] = int_stack + 144440;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 144881;
 Libderiv->deriv_classes[5][6][11] = int_stack + 145322;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 145910;
 Libderiv->deriv_classes[5][7][11] = int_stack + 146498;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 147254;
 Libderiv->deriv_classes[5][8][11] = int_stack + 148010;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 148955;
 Libderiv->deriv2_classes[5][9][83] = int_stack + 149900;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 151055;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 151265;
 Libderiv->deriv2_classes[3][7][82] = int_stack + 151545;
 Libderiv->deriv2_classes[3][8][82] = int_stack + 151905;
 Libderiv->deriv2_classes[3][9][82] = int_stack + 152355;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 152905;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 153220;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 153640;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 154180;
 Libderiv->deriv2_classes[4][9][82] = int_stack + 154855;
 Libderiv->deriv_classes[5][5][10] = int_stack + 155680;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 156121;
 Libderiv->deriv_classes[5][6][10] = int_stack + 156562;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 157150;
 Libderiv->deriv_classes[5][7][10] = int_stack + 157738;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 158494;
 Libderiv->deriv_classes[5][8][10] = int_stack + 159250;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 160195;
 Libderiv->deriv2_classes[5][9][82] = int_stack + 161140;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 162295;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 162505;
 Libderiv->deriv2_classes[3][7][81] = int_stack + 162785;
 Libderiv->deriv2_classes[3][8][81] = int_stack + 163145;
 Libderiv->deriv2_classes[3][9][81] = int_stack + 163595;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 164145;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 164460;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 164880;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 165420;
 Libderiv->deriv2_classes[4][9][81] = int_stack + 166095;
 Libderiv->deriv_classes[5][5][9] = int_stack + 166920;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 167361;
 Libderiv->deriv_classes[5][6][9] = int_stack + 167802;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 168390;
 Libderiv->deriv_classes[5][7][9] = int_stack + 168978;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 169734;
 Libderiv->deriv_classes[5][8][9] = int_stack + 170490;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 171435;
 Libderiv->deriv2_classes[5][9][81] = int_stack + 172380;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 173535;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 173745;
 Libderiv->deriv2_classes[3][7][80] = int_stack + 174025;
 Libderiv->deriv2_classes[3][8][80] = int_stack + 174385;
 Libderiv->deriv2_classes[3][9][80] = int_stack + 174835;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 175385;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 175700;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 176120;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 176660;
 Libderiv->deriv2_classes[4][9][80] = int_stack + 177335;
 Libderiv->deriv_classes[5][5][8] = int_stack + 178160;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 178601;
 Libderiv->deriv_classes[5][6][8] = int_stack + 179042;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 179630;
 Libderiv->deriv_classes[5][7][8] = int_stack + 180218;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 180974;
 Libderiv->deriv_classes[5][8][8] = int_stack + 181730;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 182675;
 Libderiv->deriv2_classes[5][9][80] = int_stack + 183620;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 184775;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 184985;
 Libderiv->deriv2_classes[3][7][79] = int_stack + 185265;
 Libderiv->deriv2_classes[3][8][79] = int_stack + 185625;
 Libderiv->deriv2_classes[3][9][79] = int_stack + 186075;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 186625;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 186940;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 187360;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 187900;
 Libderiv->deriv2_classes[4][9][79] = int_stack + 188575;
 Libderiv->deriv_classes[5][5][7] = int_stack + 189400;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 189841;
 Libderiv->deriv_classes[5][6][7] = int_stack + 190282;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 190870;
 Libderiv->deriv_classes[5][7][7] = int_stack + 191458;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 192214;
 Libderiv->deriv_classes[5][8][7] = int_stack + 192970;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 193915;
 Libderiv->deriv2_classes[5][9][79] = int_stack + 194860;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 196015;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 196225;
 Libderiv->deriv2_classes[3][7][78] = int_stack + 196505;
 Libderiv->deriv2_classes[3][8][78] = int_stack + 196865;
 Libderiv->deriv2_classes[3][9][78] = int_stack + 197315;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 197865;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 198180;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 198600;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 199140;
 Libderiv->deriv2_classes[4][9][78] = int_stack + 199815;
 Libderiv->dvrr_classes[5][5] = int_stack + 200640;
 Libderiv->deriv_classes[5][5][6] = int_stack + 201081;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 201522;
 Libderiv->dvrr_classes[5][6] = int_stack + 201963;
 Libderiv->deriv_classes[5][6][6] = int_stack + 202551;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 203139;
 Libderiv->dvrr_classes[5][7] = int_stack + 203727;
 Libderiv->deriv_classes[5][7][6] = int_stack + 204483;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 205239;
 Libderiv->deriv_classes[5][8][6] = int_stack + 205995;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 206940;
 Libderiv->deriv2_classes[5][9][78] = int_stack + 207885;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 209040;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 209250;
 Libderiv->deriv2_classes[3][7][35] = int_stack + 209530;
 Libderiv->deriv2_classes[3][8][35] = int_stack + 209890;
 Libderiv->deriv2_classes[3][9][35] = int_stack + 210340;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 210890;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 211205;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 211625;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 212165;
 Libderiv->deriv2_classes[4][9][35] = int_stack + 212840;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 213665;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 214106;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 214694;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 215450;
 Libderiv->deriv2_classes[5][9][35] = int_stack + 216395;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 217550;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 217760;
 Libderiv->deriv2_classes[3][7][34] = int_stack + 218040;
 Libderiv->deriv2_classes[3][8][34] = int_stack + 218400;
 Libderiv->deriv2_classes[3][9][34] = int_stack + 218850;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 219400;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 219715;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 220135;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 220675;
 Libderiv->deriv2_classes[4][9][34] = int_stack + 221350;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 222175;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 222616;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 223204;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 223960;
 Libderiv->deriv2_classes[5][9][34] = int_stack + 224905;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 226060;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 226270;
 Libderiv->deriv2_classes[3][7][33] = int_stack + 226550;
 Libderiv->deriv2_classes[3][8][33] = int_stack + 226910;
 Libderiv->deriv2_classes[3][9][33] = int_stack + 227360;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 227910;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 228225;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 228645;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 229185;
 Libderiv->deriv2_classes[4][9][33] = int_stack + 229860;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 230685;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 231126;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 231714;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 232470;
 Libderiv->deriv2_classes[5][9][33] = int_stack + 233415;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 234570;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 234780;
 Libderiv->deriv2_classes[3][7][32] = int_stack + 235060;
 Libderiv->deriv2_classes[3][8][32] = int_stack + 235420;
 Libderiv->deriv2_classes[3][9][32] = int_stack + 235870;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 236420;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 236735;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 237155;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 237695;
 Libderiv->deriv2_classes[4][9][32] = int_stack + 238370;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 239195;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 239636;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 240224;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 240980;
 Libderiv->deriv2_classes[5][9][32] = int_stack + 241925;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 243080;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 243290;
 Libderiv->deriv2_classes[3][7][31] = int_stack + 243570;
 Libderiv->deriv2_classes[3][8][31] = int_stack + 243930;
 Libderiv->deriv2_classes[3][9][31] = int_stack + 244380;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 244930;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 245245;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 245665;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 246205;
 Libderiv->deriv2_classes[4][9][31] = int_stack + 246880;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 247705;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 248146;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 248734;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 249490;
 Libderiv->deriv2_classes[5][9][31] = int_stack + 250435;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 251590;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 251800;
 Libderiv->deriv2_classes[3][7][30] = int_stack + 252080;
 Libderiv->deriv2_classes[3][8][30] = int_stack + 252440;
 Libderiv->deriv2_classes[3][9][30] = int_stack + 252890;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 253440;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 253755;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 254175;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 254715;
 Libderiv->deriv2_classes[4][9][30] = int_stack + 255390;
 Libderiv->deriv_classes[5][5][2] = int_stack + 256215;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 256656;
 Libderiv->deriv_classes[5][6][2] = int_stack + 257097;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 257685;
 Libderiv->deriv_classes[5][7][2] = int_stack + 258273;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 259029;
 Libderiv->deriv_classes[5][8][2] = int_stack + 259785;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 260730;
 Libderiv->deriv2_classes[5][9][30] = int_stack + 261675;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 262830;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 263040;
 Libderiv->deriv2_classes[3][7][26] = int_stack + 263320;
 Libderiv->deriv2_classes[3][8][26] = int_stack + 263680;
 Libderiv->deriv2_classes[3][9][26] = int_stack + 264130;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 264680;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 264995;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 265415;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 265955;
 Libderiv->deriv2_classes[4][9][26] = int_stack + 266630;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 267455;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 267896;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 268484;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 269240;
 Libderiv->deriv2_classes[5][9][26] = int_stack + 270185;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 271340;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 271550;
 Libderiv->deriv2_classes[3][7][23] = int_stack + 271830;
 Libderiv->deriv2_classes[3][8][23] = int_stack + 272190;
 Libderiv->deriv2_classes[3][9][23] = int_stack + 272640;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 273190;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 273505;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 273925;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 274465;
 Libderiv->deriv2_classes[4][9][23] = int_stack + 275140;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 275965;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 276406;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 276994;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 277750;
 Libderiv->deriv2_classes[5][9][23] = int_stack + 278695;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 279850;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 280060;
 Libderiv->deriv2_classes[3][7][22] = int_stack + 280340;
 Libderiv->deriv2_classes[3][8][22] = int_stack + 280700;
 Libderiv->deriv2_classes[3][9][22] = int_stack + 281150;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 281700;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 282015;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 282435;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 282975;
 Libderiv->deriv2_classes[4][9][22] = int_stack + 283650;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 284475;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 284916;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 285504;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 286260;
 Libderiv->deriv2_classes[5][9][22] = int_stack + 287205;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 288360;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 288570;
 Libderiv->deriv2_classes[3][7][21] = int_stack + 288850;
 Libderiv->deriv2_classes[3][8][21] = int_stack + 289210;
 Libderiv->deriv2_classes[3][9][21] = int_stack + 289660;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 290210;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 290525;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 290945;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 291485;
 Libderiv->deriv2_classes[4][9][21] = int_stack + 292160;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 292985;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 293426;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 294014;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 294770;
 Libderiv->deriv2_classes[5][9][21] = int_stack + 295715;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 296870;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 297080;
 Libderiv->deriv2_classes[3][7][20] = int_stack + 297360;
 Libderiv->deriv2_classes[3][8][20] = int_stack + 297720;
 Libderiv->deriv2_classes[3][9][20] = int_stack + 298170;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 298720;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 299035;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 299455;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 299995;
 Libderiv->deriv2_classes[4][9][20] = int_stack + 300670;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 301495;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 301936;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 302524;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 303280;
 Libderiv->deriv2_classes[5][9][20] = int_stack + 304225;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 305380;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 305590;
 Libderiv->deriv2_classes[3][7][19] = int_stack + 305870;
 Libderiv->deriv2_classes[3][8][19] = int_stack + 306230;
 Libderiv->deriv2_classes[3][9][19] = int_stack + 306680;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 307230;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 307545;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 307965;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 308505;
 Libderiv->deriv2_classes[4][9][19] = int_stack + 309180;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 310005;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 310446;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 311034;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 311790;
 Libderiv->deriv2_classes[5][9][19] = int_stack + 312735;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 313890;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 314100;
 Libderiv->deriv2_classes[3][7][18] = int_stack + 314380;
 Libderiv->deriv2_classes[3][8][18] = int_stack + 314740;
 Libderiv->deriv2_classes[3][9][18] = int_stack + 315190;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 315740;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 316055;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 316475;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 317015;
 Libderiv->deriv2_classes[4][9][18] = int_stack + 317690;
 Libderiv->deriv_classes[5][5][1] = int_stack + 318515;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 318956;
 Libderiv->deriv_classes[5][6][1] = int_stack + 319397;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 319985;
 Libderiv->deriv_classes[5][7][1] = int_stack + 320573;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 321329;
 Libderiv->deriv_classes[5][8][1] = int_stack + 322085;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 323030;
 Libderiv->deriv2_classes[5][9][18] = int_stack + 323975;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 325130;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 325340;
 Libderiv->deriv2_classes[3][7][14] = int_stack + 325620;
 Libderiv->deriv2_classes[3][8][14] = int_stack + 325980;
 Libderiv->deriv2_classes[3][9][14] = int_stack + 326430;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 326980;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 327295;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 327715;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 328255;
 Libderiv->deriv2_classes[4][9][14] = int_stack + 328930;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 329755;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 330196;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 330784;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 331540;
 Libderiv->deriv2_classes[5][9][14] = int_stack + 332485;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 333640;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 333850;
 Libderiv->deriv2_classes[3][7][13] = int_stack + 334130;
 Libderiv->deriv2_classes[3][8][13] = int_stack + 334490;
 Libderiv->deriv2_classes[3][9][13] = int_stack + 334940;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 335490;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 335805;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 336225;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 336765;
 Libderiv->deriv2_classes[4][9][13] = int_stack + 337440;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 338265;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 338706;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 339294;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 340050;
 Libderiv->deriv2_classes[5][9][13] = int_stack + 340995;
 Libderiv->deriv_classes[3][5][11] = int_stack + 342150;
 Libderiv->deriv_classes[3][6][11] = int_stack + 342360;
 Libderiv->deriv_classes[3][7][11] = int_stack + 342640;
 Libderiv->deriv_classes[3][8][11] = int_stack + 343000;
 Libderiv->deriv_classes[3][9][11] = int_stack + 343450;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 344000;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 344210;
 Libderiv->deriv2_classes[3][7][11] = int_stack + 344490;
 Libderiv->deriv2_classes[3][8][11] = int_stack + 344850;
 Libderiv->deriv2_classes[3][9][11] = int_stack + 345300;
 Libderiv->deriv_classes[4][5][11] = int_stack + 345850;
 Libderiv->deriv_classes[4][6][11] = int_stack + 346165;
 Libderiv->deriv_classes[4][7][11] = int_stack + 346585;
 Libderiv->deriv_classes[4][8][11] = int_stack + 347125;
 Libderiv->deriv_classes[4][9][11] = int_stack + 347800;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 348625;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 348940;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 349360;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 349900;
 Libderiv->deriv2_classes[4][9][11] = int_stack + 350575;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 351400;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 351841;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 352429;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 353185;
 Libderiv->deriv2_classes[5][9][11] = int_stack + 354130;
 Libderiv->deriv_classes[3][5][10] = int_stack + 355285;
 Libderiv->deriv_classes[3][6][10] = int_stack + 355495;
 Libderiv->deriv_classes[3][7][10] = int_stack + 355775;
 Libderiv->deriv_classes[3][8][10] = int_stack + 356135;
 Libderiv->deriv_classes[3][9][10] = int_stack + 356585;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 357135;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 357345;
 Libderiv->deriv2_classes[3][7][10] = int_stack + 357625;
 Libderiv->deriv2_classes[3][8][10] = int_stack + 357985;
 Libderiv->deriv2_classes[3][9][10] = int_stack + 358435;
 Libderiv->deriv_classes[4][5][10] = int_stack + 358985;
 Libderiv->deriv_classes[4][6][10] = int_stack + 359300;
 Libderiv->deriv_classes[4][7][10] = int_stack + 359720;
 Libderiv->deriv_classes[4][8][10] = int_stack + 360260;
 Libderiv->deriv_classes[4][9][10] = int_stack + 360935;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 361760;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 362075;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 362495;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 363035;
 Libderiv->deriv2_classes[4][9][10] = int_stack + 363710;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 364535;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 364976;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 365564;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 366320;
 Libderiv->deriv2_classes[5][9][10] = int_stack + 367265;
 Libderiv->deriv_classes[3][5][9] = int_stack + 368420;
 Libderiv->deriv_classes[3][6][9] = int_stack + 368630;
 Libderiv->deriv_classes[3][7][9] = int_stack + 368910;
 Libderiv->deriv_classes[3][8][9] = int_stack + 369270;
 Libderiv->deriv_classes[3][9][9] = int_stack + 369720;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 370270;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 370480;
 Libderiv->deriv2_classes[3][7][9] = int_stack + 370760;
 Libderiv->deriv2_classes[3][8][9] = int_stack + 371120;
 Libderiv->deriv2_classes[3][9][9] = int_stack + 371570;
 Libderiv->deriv_classes[4][5][9] = int_stack + 372120;
 Libderiv->deriv_classes[4][6][9] = int_stack + 372435;
 Libderiv->deriv_classes[4][7][9] = int_stack + 372855;
 Libderiv->deriv_classes[4][8][9] = int_stack + 373395;
 Libderiv->deriv_classes[4][9][9] = int_stack + 374070;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 374895;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 375210;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 375630;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 376170;
 Libderiv->deriv2_classes[4][9][9] = int_stack + 376845;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 377670;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 378111;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 378699;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 379455;
 Libderiv->deriv2_classes[5][9][9] = int_stack + 380400;
 Libderiv->deriv_classes[3][5][8] = int_stack + 381555;
 Libderiv->deriv_classes[3][6][8] = int_stack + 381765;
 Libderiv->deriv_classes[3][7][8] = int_stack + 382045;
 Libderiv->deriv_classes[3][8][8] = int_stack + 382405;
 Libderiv->deriv_classes[3][9][8] = int_stack + 382855;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 383405;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 383615;
 Libderiv->deriv2_classes[3][7][8] = int_stack + 383895;
 Libderiv->deriv2_classes[3][8][8] = int_stack + 384255;
 Libderiv->deriv2_classes[3][9][8] = int_stack + 384705;
 Libderiv->deriv_classes[4][5][8] = int_stack + 385255;
 Libderiv->deriv_classes[4][6][8] = int_stack + 385570;
 Libderiv->deriv_classes[4][7][8] = int_stack + 385990;
 Libderiv->deriv_classes[4][8][8] = int_stack + 386530;
 Libderiv->deriv_classes[4][9][8] = int_stack + 387205;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 388030;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 388345;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 388765;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 389305;
 Libderiv->deriv2_classes[4][9][8] = int_stack + 389980;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 390805;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 391246;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 391834;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 392590;
 Libderiv->deriv2_classes[5][9][8] = int_stack + 393535;
 Libderiv->deriv_classes[3][5][7] = int_stack + 394690;
 Libderiv->deriv_classes[3][6][7] = int_stack + 394900;
 Libderiv->deriv_classes[3][7][7] = int_stack + 395180;
 Libderiv->deriv_classes[3][8][7] = int_stack + 395540;
 Libderiv->deriv_classes[3][9][7] = int_stack + 395990;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 396540;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 396750;
 Libderiv->deriv2_classes[3][7][7] = int_stack + 397030;
 Libderiv->deriv2_classes[3][8][7] = int_stack + 397390;
 Libderiv->deriv2_classes[3][9][7] = int_stack + 397840;
 Libderiv->deriv_classes[4][5][7] = int_stack + 398390;
 Libderiv->deriv_classes[4][6][7] = int_stack + 398705;
 Libderiv->deriv_classes[4][7][7] = int_stack + 399125;
 Libderiv->deriv_classes[4][8][7] = int_stack + 399665;
 Libderiv->deriv_classes[4][9][7] = int_stack + 400340;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 401165;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 401480;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 401900;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 402440;
 Libderiv->deriv2_classes[4][9][7] = int_stack + 403115;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 403940;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 404381;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 404969;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 405725;
 Libderiv->deriv2_classes[5][9][7] = int_stack + 406670;
 Libderiv->deriv_classes[3][5][6] = int_stack + 407825;
 Libderiv->deriv_classes[3][6][6] = int_stack + 408035;
 Libderiv->deriv_classes[3][7][6] = int_stack + 408315;
 Libderiv->deriv_classes[3][8][6] = int_stack + 408675;
 Libderiv->deriv_classes[3][9][6] = int_stack + 409125;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 409675;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 409885;
 Libderiv->deriv2_classes[3][7][6] = int_stack + 410165;
 Libderiv->deriv2_classes[3][8][6] = int_stack + 410525;
 Libderiv->deriv2_classes[3][9][6] = int_stack + 410975;
 Libderiv->dvrr_classes[4][5] = int_stack + 411525;
 Libderiv->deriv_classes[4][5][6] = int_stack + 411840;
 Libderiv->dvrr_classes[4][6] = int_stack + 412155;
 Libderiv->deriv_classes[4][6][6] = int_stack + 412575;
 Libderiv->dvrr_classes[4][7] = int_stack + 412995;
 Libderiv->deriv_classes[4][7][6] = int_stack + 413535;
 Libderiv->dvrr_classes[4][8] = int_stack + 414075;
 Libderiv->deriv_classes[4][8][6] = int_stack + 414750;
 Libderiv->deriv_classes[4][9][6] = int_stack + 415425;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 416250;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 416565;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 416985;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 417525;
 Libderiv->deriv2_classes[4][9][6] = int_stack + 418200;
 Libderiv->deriv_classes[5][5][0] = int_stack + 419025;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 419466;
 Libderiv->deriv_classes[5][6][0] = int_stack + 419907;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 420495;
 Libderiv->deriv_classes[5][7][0] = int_stack + 421083;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 421839;
 Libderiv->deriv_classes[5][8][0] = int_stack + 422595;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 423540;
 Libderiv->deriv2_classes[5][9][6] = int_stack + 424485;
 Libderiv->deriv_classes[3][5][2] = int_stack + 425640;
 Libderiv->deriv_classes[3][6][2] = int_stack + 425850;
 Libderiv->deriv_classes[3][7][2] = int_stack + 426130;
 Libderiv->deriv_classes[3][8][2] = int_stack + 426490;
 Libderiv->deriv_classes[3][9][2] = int_stack + 426940;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 427490;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 427700;
 Libderiv->deriv2_classes[3][7][2] = int_stack + 427980;
 Libderiv->deriv2_classes[3][8][2] = int_stack + 428340;
 Libderiv->deriv2_classes[3][9][2] = int_stack + 428790;
 Libderiv->deriv_classes[4][5][2] = int_stack + 429340;
 Libderiv->deriv_classes[4][6][2] = int_stack + 429655;
 Libderiv->deriv_classes[4][7][2] = int_stack + 430075;
 Libderiv->deriv_classes[4][8][2] = int_stack + 430615;
 Libderiv->deriv_classes[4][9][2] = int_stack + 431290;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 432115;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 432430;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 432850;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 433390;
 Libderiv->deriv2_classes[4][9][2] = int_stack + 434065;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 434890;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 435331;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 435919;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 436675;
 Libderiv->deriv2_classes[5][9][2] = int_stack + 437620;
 Libderiv->deriv_classes[3][5][1] = int_stack + 438775;
 Libderiv->deriv_classes[3][6][1] = int_stack + 438985;
 Libderiv->deriv_classes[3][7][1] = int_stack + 439265;
 Libderiv->deriv_classes[3][8][1] = int_stack + 439625;
 Libderiv->deriv_classes[3][9][1] = int_stack + 440075;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 440625;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 440835;
 Libderiv->deriv2_classes[3][7][1] = int_stack + 441115;
 Libderiv->deriv2_classes[3][8][1] = int_stack + 441475;
 Libderiv->deriv2_classes[3][9][1] = int_stack + 441925;
 Libderiv->deriv_classes[4][5][1] = int_stack + 442475;
 Libderiv->deriv_classes[4][6][1] = int_stack + 442790;
 Libderiv->deriv_classes[4][7][1] = int_stack + 443210;
 Libderiv->deriv_classes[4][8][1] = int_stack + 443750;
 Libderiv->deriv_classes[4][9][1] = int_stack + 444425;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 445250;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 445565;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 445985;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 446525;
 Libderiv->deriv2_classes[4][9][1] = int_stack + 447200;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 448025;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 448466;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 449054;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 449810;
 Libderiv->deriv2_classes[5][9][1] = int_stack + 450755;
 Libderiv->dvrr_classes[3][5] = int_stack + 451910;
 Libderiv->dvrr_classes[3][6] = int_stack + 452120;
 Libderiv->dvrr_classes[3][7] = int_stack + 452400;
 Libderiv->dvrr_classes[3][8] = int_stack + 452760;
 Libderiv->dvrr_classes[3][9] = int_stack + 453210;
 Libderiv->deriv_classes[3][5][0] = int_stack + 453760;
 Libderiv->deriv_classes[3][6][0] = int_stack + 453970;
 Libderiv->deriv_classes[3][7][0] = int_stack + 454250;
 Libderiv->deriv_classes[3][8][0] = int_stack + 454610;
 Libderiv->deriv_classes[3][9][0] = int_stack + 455060;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 455610;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 455820;
 Libderiv->deriv2_classes[3][7][0] = int_stack + 456100;
 Libderiv->deriv2_classes[3][8][0] = int_stack + 456460;
 Libderiv->deriv2_classes[3][9][0] = int_stack + 456910;
 Libderiv->deriv_classes[4][5][0] = int_stack + 457460;
 Libderiv->deriv_classes[4][6][0] = int_stack + 457775;
 Libderiv->deriv_classes[4][7][0] = int_stack + 458195;
 Libderiv->deriv_classes[4][8][0] = int_stack + 458735;
 Libderiv->deriv_classes[4][9][0] = int_stack + 459410;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 460235;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 460550;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 460970;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 461510;
 Libderiv->deriv2_classes[4][9][0] = int_stack + 462185;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 463010;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 463451;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 464039;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 464795;
 Libderiv->deriv2_classes[5][9][0] = int_stack + 465740;
 memset(int_stack,0,3735160);

 Libderiv->dvrr_stack = int_stack + 1508768;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fdhg(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+466895,int_stack+452120,int_stack+451910,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+467525,int_stack+452400,int_stack+452120,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+468365,int_stack+467525,int_stack+466895,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+469625,int_stack+452760,int_stack+452400,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+470705,int_stack+469625,int_stack+467525,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+472385,int_stack+470705,int_stack+468365,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+474485,int_stack+342360,int_stack+342150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+475115,int_stack+342640,int_stack+342360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452120,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+475955,int_stack+475115,int_stack+474485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466895,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+477215,int_stack+343000,int_stack+342640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452400,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+478295,int_stack+477215,int_stack+475115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467525,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+479975,int_stack+478295,int_stack+475955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468365,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+482075,int_stack+343450,int_stack+343000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452760,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+483425,int_stack+482075,int_stack+477215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469625,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+485585,int_stack+483425,int_stack+478295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470705,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+482075,int_stack+485585,int_stack+479975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472385,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+485225,int_stack+412155,int_stack+411525,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+486170,int_stack+412995,int_stack+412155,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+487430,int_stack+486170,int_stack+485225,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+489320,int_stack+414075,int_stack+412995,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+490940,int_stack+489320,int_stack+486170,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+493460,int_stack+490940,int_stack+487430,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+496610,int_stack+346165,int_stack+345850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411525,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+497555,int_stack+346585,int_stack+346165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412155,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+498815,int_stack+497555,int_stack+496610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485225,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500705,int_stack+347125,int_stack+346585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412995,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+502325,int_stack+500705,int_stack+497555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+486170,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+504845,int_stack+502325,int_stack+498815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487430,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+507995,int_stack+347800,int_stack+347125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414075,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+510020,int_stack+507995,int_stack+500705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489320,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+513260,int_stack+510020,int_stack+502325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+490940,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+507995,int_stack+513260,int_stack+504845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493460,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+512720,int_stack+507995,int_stack+482075,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+522170,int_stack+201963,int_stack+200640,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+523493,int_stack+203727,int_stack+201963,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+525257,int_stack+523493,int_stack+522170,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+527903,int_stack+5775,int_stack+203727,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+530171,int_stack+527903,int_stack+523493,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+533699,int_stack+530171,int_stack+525257,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+538109,int_stack+145322,int_stack+144440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200640,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+539432,int_stack+146498,int_stack+145322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201963,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+541196,int_stack+539432,int_stack+538109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522170,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+543842,int_stack+148010,int_stack+146498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203727,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+546110,int_stack+543842,int_stack+539432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+523493,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+549638,int_stack+546110,int_stack+541196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525257,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+554048,int_stack+0,int_stack+148010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+556883,int_stack+554048,int_stack+543842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527903,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+561419,int_stack+556883,int_stack+546110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530171,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+554048,int_stack+561419,int_stack+549638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533699,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+560663,int_stack+554048,int_stack+507995,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+554048,int_stack+355495,int_stack+355285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+554678,int_stack+355775,int_stack+355495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452120, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+555518,int_stack+554678,int_stack+554048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466895, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+556778,int_stack+356135,int_stack+355775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452400, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+557858,int_stack+556778,int_stack+554678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467525, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+557858,int_stack+555518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468365, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+576938,int_stack+356585,int_stack+356135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452760, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+578288,int_stack+576938,int_stack+556778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469625, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+580448,int_stack+578288,int_stack+557858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470705, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+576938,int_stack+580448,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472385, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580088,int_stack+359300,int_stack+358985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411525, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+581033,int_stack+359720,int_stack+359300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412155, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+582293,int_stack+581033,int_stack+580088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485225, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+584183,int_stack+360260,int_stack+359720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412995, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+585803,int_stack+584183,int_stack+581033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+486170, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+588323,int_stack+585803,int_stack+582293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487430, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+591473,int_stack+360935,int_stack+360260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414075, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+593498,int_stack+591473,int_stack+584183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489320, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+596738,int_stack+593498,int_stack+585803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+490940, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+591473,int_stack+596738,int_stack+588323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493460, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+596198,int_stack+591473,int_stack+576938,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+605648,int_stack+156562,int_stack+155680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200640, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+606971,int_stack+157738,int_stack+156562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201963, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+608735,int_stack+606971,int_stack+605648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522170, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+611381,int_stack+159250,int_stack+157738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203727, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+613649,int_stack+611381,int_stack+606971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+523493, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+617177,int_stack+613649,int_stack+608735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525257, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+621587,int_stack+1155,int_stack+159250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+624422,int_stack+621587,int_stack+611381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527903, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+628958,int_stack+624422,int_stack+613649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530171, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+621587,int_stack+628958,int_stack+617177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533699, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+628202,int_stack+621587,int_stack+591473,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+621587,int_stack+368630,int_stack+368420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+622217,int_stack+368910,int_stack+368630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452120, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+623057,int_stack+622217,int_stack+621587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+624317,int_stack+369270,int_stack+368910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452400, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+625397,int_stack+624317,int_stack+622217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467525, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+625397,int_stack+623057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468365, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+642377,int_stack+369720,int_stack+369270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452760, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+643727,int_stack+642377,int_stack+624317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469625, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+645887,int_stack+643727,int_stack+625397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470705, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+642377,int_stack+645887,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472385, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+645527,int_stack+372435,int_stack+372120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411525, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+646472,int_stack+372855,int_stack+372435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412155, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+647732,int_stack+646472,int_stack+645527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+649622,int_stack+373395,int_stack+372855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412995, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+651242,int_stack+649622,int_stack+646472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+486170, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+653762,int_stack+651242,int_stack+647732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487430, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+656912,int_stack+374070,int_stack+373395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414075, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+658937,int_stack+656912,int_stack+649622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489320, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+662177,int_stack+658937,int_stack+651242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+490940, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+656912,int_stack+662177,int_stack+653762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493460, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+661637,int_stack+656912,int_stack+642377,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+671087,int_stack+167802,int_stack+166920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200640, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+672410,int_stack+168978,int_stack+167802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201963, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+674174,int_stack+672410,int_stack+671087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522170, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+676820,int_stack+170490,int_stack+168978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203727, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+679088,int_stack+676820,int_stack+672410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+523493, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+682616,int_stack+679088,int_stack+674174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525257, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+687026,int_stack+2310,int_stack+170490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+689861,int_stack+687026,int_stack+676820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527903, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+694397,int_stack+689861,int_stack+679088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530171, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+687026,int_stack+694397,int_stack+682616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533699, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+693641,int_stack+687026,int_stack+656912,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+687026,int_stack+381765,int_stack+381555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+687656,int_stack+382045,int_stack+381765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+688496,int_stack+687656,int_stack+687026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+689756,int_stack+382405,int_stack+382045, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+690836,int_stack+689756,int_stack+687656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+707816,int_stack+690836,int_stack+688496, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2100,int_stack+382855,int_stack+382405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+709916,int_stack+2100,int_stack+689756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+712076,int_stack+709916,int_stack+690836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+714876,int_stack+712076,int_stack+707816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+709916,int_stack+385570,int_stack+385255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+710861,int_stack+385990,int_stack+385570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+712121,int_stack+710861,int_stack+709916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+718026,int_stack+386530,int_stack+385990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+719646,int_stack+718026,int_stack+710861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+486170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+722166,int_stack+719646,int_stack+712121, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+725316,int_stack+387205,int_stack+386530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+727341,int_stack+725316,int_stack+718026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+730581,int_stack+727341,int_stack+719646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+490940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+725316,int_stack+730581,int_stack+722166, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+730041,int_stack+725316,int_stack+714876,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2100,int_stack+179042,int_stack+178160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+739491,int_stack+180218,int_stack+179042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+741255,int_stack+739491,int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+743901,int_stack+181730,int_stack+180218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+746169,int_stack+743901,int_stack+739491, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+523493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+749697,int_stack+746169,int_stack+741255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+754107,int_stack+3465,int_stack+181730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+756942,int_stack+754107,int_stack+743901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+761478,int_stack+756942,int_stack+746169, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+754107,int_stack+761478,int_stack+749697, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+760722,int_stack+754107,int_stack+725316,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+754107,int_stack+394900,int_stack+394690, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+754737,int_stack+395180,int_stack+394900, 0.0, zero_stack, 1.0, int_stack+452120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+755577,int_stack+754737,int_stack+754107, 0.0, zero_stack, 1.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+756837,int_stack+395540,int_stack+395180, 0.0, zero_stack, 1.0, int_stack+452400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+757917,int_stack+756837,int_stack+754737, 0.0, zero_stack, 1.0, int_stack+467525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+774897,int_stack+757917,int_stack+755577, 0.0, zero_stack, 1.0, int_stack+468365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+776997,int_stack+395990,int_stack+395540, 0.0, zero_stack, 1.0, int_stack+452760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+778347,int_stack+776997,int_stack+756837, 0.0, zero_stack, 1.0, int_stack+469625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+780507,int_stack+778347,int_stack+757917, 0.0, zero_stack, 1.0, int_stack+470705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+776997,int_stack+780507,int_stack+774897, 0.0, zero_stack, 1.0, int_stack+472385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780147,int_stack+398705,int_stack+398390, 0.0, zero_stack, 1.0, int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+781092,int_stack+399125,int_stack+398705, 0.0, zero_stack, 1.0, int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+782352,int_stack+781092,int_stack+780147, 0.0, zero_stack, 1.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+784242,int_stack+399665,int_stack+399125, 0.0, zero_stack, 1.0, int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+785862,int_stack+784242,int_stack+781092, 0.0, zero_stack, 1.0, int_stack+486170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+788382,int_stack+785862,int_stack+782352, 0.0, zero_stack, 1.0, int_stack+487430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+791532,int_stack+400340,int_stack+399665, 0.0, zero_stack, 1.0, int_stack+414075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+793557,int_stack+791532,int_stack+784242, 0.0, zero_stack, 1.0, int_stack+489320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+796797,int_stack+793557,int_stack+785862, 0.0, zero_stack, 1.0, int_stack+490940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+791532,int_stack+796797,int_stack+788382, 0.0, zero_stack, 1.0, int_stack+493460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+796257,int_stack+791532,int_stack+776997,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+805707,int_stack+190282,int_stack+189400, 0.0, zero_stack, 1.0, int_stack+200640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+807030,int_stack+191458,int_stack+190282, 0.0, zero_stack, 1.0, int_stack+201963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+808794,int_stack+807030,int_stack+805707, 0.0, zero_stack, 1.0, int_stack+522170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+811440,int_stack+192970,int_stack+191458, 0.0, zero_stack, 1.0, int_stack+203727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+813708,int_stack+811440,int_stack+807030, 0.0, zero_stack, 1.0, int_stack+523493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+817236,int_stack+813708,int_stack+808794, 0.0, zero_stack, 1.0, int_stack+525257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+821646,int_stack+4620,int_stack+192970, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+824481,int_stack+821646,int_stack+811440, 0.0, zero_stack, 1.0, int_stack+527903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+829017,int_stack+824481,int_stack+813708, 0.0, zero_stack, 1.0, int_stack+530171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+821646,int_stack+829017,int_stack+817236, 0.0, zero_stack, 1.0, int_stack+533699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+828261,int_stack+821646,int_stack+791532,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+821646,int_stack+408035,int_stack+407825, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+822276,int_stack+408315,int_stack+408035, 1.0, int_stack+452120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+823116,int_stack+822276,int_stack+821646, 1.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+824376,int_stack+408675,int_stack+408315, 1.0, int_stack+452400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+825456,int_stack+824376,int_stack+822276, 1.0, int_stack+467525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3423,int_stack+825456,int_stack+823116, 1.0, int_stack+468365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+466895,int_stack+409125,int_stack+408675, 1.0, int_stack+452760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+842436,int_stack+466895,int_stack+824376, 1.0, int_stack+469625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+844596,int_stack+842436,int_stack+825456, 1.0, int_stack+470705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+847396,int_stack+844596,int_stack+3423, 1.0, int_stack+472385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+842436,int_stack+412575,int_stack+411840, 1.0, int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+843381,int_stack+413535,int_stack+412575, 1.0, int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+844641,int_stack+843381,int_stack+842436, 1.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+466895,int_stack+414750,int_stack+413535, 1.0, int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+850546,int_stack+466895,int_stack+843381, 1.0, int_stack+486170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+853066,int_stack+850546,int_stack+844641, 1.0, int_stack+487430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+485225,int_stack+415425,int_stack+414750, 1.0, int_stack+414075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+856216,int_stack+485225,int_stack+466895, 1.0, int_stack+489320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+859456,int_stack+856216,int_stack+850546, 1.0, int_stack+490940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+863656,int_stack+859456,int_stack+853066, 1.0, int_stack+493460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+868381,int_stack+863656,int_stack+847396,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+856216,int_stack+202551,int_stack+201081, 1.0, int_stack+200640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+857539,int_stack+204483,int_stack+202551, 1.0, int_stack+201963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+859303,int_stack+857539,int_stack+856216, 1.0, int_stack+522170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+485225,int_stack+205995,int_stack+204483, 1.0, int_stack+203727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+485225,int_stack+857539, 1.0, int_stack+523493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+859303, 1.0, int_stack+525257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+522170,int_stack+6720,int_stack+205995, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+885769,int_stack+522170,int_stack+485225, 1.0, int_stack+527903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+522170,int_stack+885769,int_stack+877831, 1.0, int_stack+530171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+885769,int_stack+522170,int_stack+881359, 1.0, int_stack+533699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+522170,int_stack+885769,int_stack+863656,315);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+885769,int_stack+453210,int_stack+452760,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+887119,int_stack+885769,int_stack+469625,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+889279,int_stack+887119,int_stack+470705,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+885769,int_stack+889279,int_stack+472385,10);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+888919,int_stack+10185,int_stack+414075,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+468515,int_stack+888919,int_stack+489320,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+888919,int_stack+468515,int_stack+490940,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+888919,int_stack+493460,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+888919,int_stack+468515,int_stack+885769,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+898369,int_stack+425850,int_stack+425640,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+473240,int_stack+426130,int_stack+425850,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+473240,int_stack+898369,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+861949,int_stack+426490,int_stack+426130,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+487493,int_stack+861949,int_stack+473240,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+489173,int_stack+487493,int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+491273,int_stack+426940,int_stack+426490,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+492623,int_stack+491273,int_stack+861949,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+898999,int_stack+492623,int_stack+487493,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+491273,int_stack+898999,int_stack+489173,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+898999,int_stack+429655,int_stack+429340,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+899944,int_stack+430075,int_stack+429655,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+494423,int_stack+899944,int_stack+898999,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+451910,int_stack+430615,int_stack+430075,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+901204,int_stack+451910,int_stack+899944,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+903724,int_stack+901204,int_stack+494423,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5523,int_stack+431290,int_stack+430615,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+906874,int_stack+5523,int_stack+451910,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+910114,int_stack+906874,int_stack+901204,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+914314,int_stack+910114,int_stack+903724,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+919039,int_stack+914314,int_stack+491273, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+906874,int_stack+257097,int_stack+256215,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+908197,int_stack+258273,int_stack+257097,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+909961,int_stack+908197,int_stack+906874,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5523,int_stack+259785,int_stack+258273,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+928489,int_stack+5523,int_stack+908197,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+932017,int_stack+928489,int_stack+909961,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+936427,int_stack+7875,int_stack+259785,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+939262,int_stack+936427,int_stack+5523,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+943798,int_stack+939262,int_stack+928489,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+936427,int_stack+943798,int_stack+932017,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+943042,int_stack+936427,int_stack+914314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+936427,int_stack+438985,int_stack+438775,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+937057,int_stack+439265,int_stack+438985,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+937897,int_stack+937057,int_stack+936427,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+939157,int_stack+439625,int_stack+439265,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+940237,int_stack+939157,int_stack+937057,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+957217,int_stack+940237,int_stack+937897,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+912607,int_stack+440075,int_stack+439625,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+959317,int_stack+912607,int_stack+939157,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+961477,int_stack+959317,int_stack+940237,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+964277,int_stack+961477,int_stack+957217,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+959317,int_stack+442790,int_stack+442475,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+960262,int_stack+443210,int_stack+442790,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+961522,int_stack+960262,int_stack+959317,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+912607,int_stack+443750,int_stack+443210,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+967427,int_stack+912607,int_stack+960262,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+969947,int_stack+967427,int_stack+961522,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+973097,int_stack+444425,int_stack+443750,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+975122,int_stack+973097,int_stack+912607,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+978362,int_stack+975122,int_stack+967427,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+973097,int_stack+978362,int_stack+969947,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+977822,int_stack+973097,int_stack+964277, 0.0, zero_stack, 1.0, int_stack+885769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+987272,int_stack+319397,int_stack+318515,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+988595,int_stack+320573,int_stack+319397,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+990359,int_stack+988595,int_stack+987272,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+993005,int_stack+322085,int_stack+320573,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+995273,int_stack+993005,int_stack+988595,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+998801,int_stack+995273,int_stack+990359,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1003211,int_stack+9030,int_stack+322085,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1006046,int_stack+1003211,int_stack+993005,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1010582,int_stack+1006046,int_stack+995273,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1003211,int_stack+1010582,int_stack+998801,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1009826,int_stack+1003211,int_stack+973097, 0.0, zero_stack, 1.0, int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1003211,int_stack+453970,int_stack+453760,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1003841,int_stack+454250,int_stack+453970,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1004681,int_stack+1003841,int_stack+1003211,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1005941,int_stack+454610,int_stack+454250,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1007021,int_stack+1005941,int_stack+1003841,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7791,int_stack+1007021,int_stack+1004681,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1024001,int_stack+455060,int_stack+454610,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1025351,int_stack+1024001,int_stack+1005941,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1027511,int_stack+1025351,int_stack+1007021,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1024001,int_stack+1027511,int_stack+7791,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1027151,int_stack+457775,int_stack+457460,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1028096,int_stack+458195,int_stack+457775,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1029356,int_stack+1028096,int_stack+1027151,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1031246,int_stack+458735,int_stack+458195,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1032866,int_stack+1031246,int_stack+1028096,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1035386,int_stack+1032866,int_stack+1029356,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1038536,int_stack+459410,int_stack+458735,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1040561,int_stack+1038536,int_stack+1031246,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1043801,int_stack+1040561,int_stack+1032866,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1038536,int_stack+1043801,int_stack+1035386,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1043261,int_stack+1038536,int_stack+1024001, 1.0, int_stack+885769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+885769,int_stack+419907,int_stack+419025,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+887092,int_stack+421083,int_stack+419907,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1052711,int_stack+887092,int_stack+885769,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1055357,int_stack+422595,int_stack+421083,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1057625,int_stack+1055357,int_stack+887092,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1061153,int_stack+1057625,int_stack+1052711,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+11010,int_stack+422595,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1068398,int_stack+1065563,int_stack+1055357,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1072934,int_stack+1068398,int_stack+1057625,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+1072934,int_stack+1061153,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1072178,int_stack+1065563,int_stack+1038536, 1.0, int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+12375,int_stack+12165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+342150,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+12655,int_stack+12375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+342360,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+474485,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+13015,int_stack+12655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+342640,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+471245,int_stack+469145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+475115,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1067243,int_stack+1065563,int_stack+469985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+475955,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+13465,int_stack+13015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+343000,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1069343,int_stack+468515,int_stack+471245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+477215,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1069343,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+478295,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9891,int_stack+468515,int_stack+1067243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+479975,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+14330,int_stack+14015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+345850,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469460,int_stack+14750,int_stack+14330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+346165,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+470720,int_stack+469460,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+496610,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+15290,int_stack+14750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+346585,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+469460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+497555,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1086353,int_stack+1067183,int_stack+470720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+498815,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+15965,int_stack+15290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+347125,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+13041,int_stack+468515,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+500705,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+13041,int_stack+1067183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+502325,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+468515,int_stack+1086353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+504845,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1086353,int_stack+1065563,int_stack+9891,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9891,int_stack+17231,int_stack+16790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+144440,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11214,int_stack+17819,int_stack+17231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+145322,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12978,int_stack+11214,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+538109,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468515,int_stack+18575,int_stack+17819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+146498,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1095803,int_stack+468515,int_stack+11214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+539432,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1099331,int_stack+1095803,int_stack+12978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+541196,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9891,int_stack+19520,int_stack+18575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+148010,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12726,int_stack+9891,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+543842,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1103741,int_stack+12726,int_stack+1095803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+546110,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9891,int_stack+1103741,int_stack+1099331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+549638,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1095803,int_stack+9891,int_stack+1065563,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+20885,int_stack+20675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342150, 1.0, int_stack+355285,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+21165,int_stack+20885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342360, 1.0, int_stack+355495,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474485, 1.0, int_stack+554048,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+21525,int_stack+21165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342640, 1.0, int_stack+355775,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475115, 1.0, int_stack+554678,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9891,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475955, 1.0, int_stack+555518,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+21975,int_stack+21525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343000, 1.0, int_stack+356135,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+11991,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477215, 1.0, int_stack+556778,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+11991,int_stack+1069373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478295, 1.0, int_stack+557858,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11991,int_stack+1065563,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479975, 1.0, int_stack+574838,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9891,int_stack+22840,int_stack+22525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345850, 1.0, int_stack+358985,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1065563,int_stack+23260,int_stack+22840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346165, 1.0, int_stack+359300,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1066823,int_stack+1065563,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496610, 1.0, int_stack+580088,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9891,int_stack+23800,int_stack+23260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346585, 1.0, int_stack+359720,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1068713,int_stack+9891,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497555, 1.0, int_stack+581033,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+15141,int_stack+1068713,int_stack+1066823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+498815, 1.0, int_stack+582293,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+24475,int_stack+23800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347125, 1.0, int_stack+360260,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+18291,int_stack+1065563,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500705, 1.0, int_stack+584183,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+18291,int_stack+1068713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+502325, 1.0, int_stack+585803,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+18291,int_stack+468515,int_stack+15141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504845, 1.0, int_stack+588323,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1109978,int_stack+18291,int_stack+11991,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+25741,int_stack+25300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144440, 1.0, int_stack+155680,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469838,int_stack+26329,int_stack+25741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145322, 1.0, int_stack+156562,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+23016,int_stack+469838,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538109, 1.0, int_stack+605648,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9891,int_stack+27085,int_stack+26329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146498, 1.0, int_stack+157738,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12159,int_stack+9891,int_stack+469838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+539432, 1.0, int_stack+606971,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+468515,int_stack+12159,int_stack+23016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541196, 1.0, int_stack+608735,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23016,int_stack+28030,int_stack+27085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148010, 1.0, int_stack+159250,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+23016,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543842, 1.0, int_stack+611381,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+23016,int_stack+1065563,int_stack+12159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+546110, 1.0, int_stack+613649,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+23016,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549638, 1.0, int_stack+617177,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1119428,int_stack+1065563,int_stack+18291,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+29395,int_stack+29185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+355285, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+29675,int_stack+29395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+355495, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+554048, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+30035,int_stack+29675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+355775, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+554678, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+468515,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+555518, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+30485,int_stack+30035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+356135, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+470615,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+556778, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+470615,int_stack+1069373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+557858, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1068363,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+574838, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+31350,int_stack+31035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+358985, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469460,int_stack+31770,int_stack+31350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+359300, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+470720,int_stack+469460,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+580088, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+32310,int_stack+31770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+359720, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9891,int_stack+1065563,int_stack+469460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+581033, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12411,int_stack+9891,int_stack+470720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+582293, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+32985,int_stack+32310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+360260, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15561,int_stack+468515,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+584183, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+15561,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+585803, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+15561,int_stack+468515,int_stack+12411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+588323, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+20286,int_stack+15561,int_stack+1068363,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+34251,int_stack+33810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+155680, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469838,int_stack+34839,int_stack+34251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+156562, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9891,int_stack+469838,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+605648, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12537,int_stack+35595,int_stack+34839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+157738, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29736,int_stack+12537,int_stack+469838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+606971, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+468515,int_stack+29736,int_stack+9891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+608735, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+36540,int_stack+35595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+159250, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1133603,int_stack+1065563,int_stack+12537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+611381, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+1133603,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+613649, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+29736,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+617177, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1133603,int_stack+29736,int_stack+15561,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29736,int_stack+37905,int_stack+37695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342150, 0.0, zero_stack, 1.0, int_stack+368420,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+30366,int_stack+38185,int_stack+37905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342360, 0.0, zero_stack, 1.0, int_stack+368630,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+31206,int_stack+30366,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474485, 0.0, zero_stack, 1.0, int_stack+621587,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+32466,int_stack+38545,int_stack+38185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342640, 0.0, zero_stack, 1.0, int_stack+368910,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33546,int_stack+32466,int_stack+30366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475115, 0.0, zero_stack, 1.0, int_stack+622217,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+35226,int_stack+33546,int_stack+31206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475955, 0.0, zero_stack, 1.0, int_stack+623057,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+29736,int_stack+38995,int_stack+38545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343000, 0.0, zero_stack, 1.0, int_stack+369270,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+37326,int_stack+29736,int_stack+32466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477215, 0.0, zero_stack, 1.0, int_stack+624317,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+29736,int_stack+37326,int_stack+33546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478295, 0.0, zero_stack, 1.0, int_stack+625397,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+29736,int_stack+35226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479975, 0.0, zero_stack, 1.0, int_stack+0,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29736,int_stack+39860,int_stack+39545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345850, 0.0, zero_stack, 1.0, int_stack+372120,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+30681,int_stack+40280,int_stack+39860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346165, 0.0, zero_stack, 1.0, int_stack+372435,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+31941,int_stack+30681,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496610, 0.0, zero_stack, 1.0, int_stack+645527,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+33831,int_stack+40820,int_stack+40280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346585, 0.0, zero_stack, 1.0, int_stack+372855,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35451,int_stack+33831,int_stack+30681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497555, 0.0, zero_stack, 1.0, int_stack+646472,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1065563,int_stack+35451,int_stack+31941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+498815, 0.0, zero_stack, 1.0, int_stack+647732,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+29736,int_stack+41495,int_stack+40820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347125, 0.0, zero_stack, 1.0, int_stack+373395,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+37971,int_stack+29736,int_stack+33831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500705, 0.0, zero_stack, 1.0, int_stack+649622,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+29736,int_stack+37971,int_stack+35451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+502325, 0.0, zero_stack, 1.0, int_stack+651242,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+33936,int_stack+29736,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504845, 0.0, zero_stack, 1.0, int_stack+653762,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+9891,int_stack+33936,int_stack+468515,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+42761,int_stack+42320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144440, 0.0, zero_stack, 1.0, int_stack+166920,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469838,int_stack+43349,int_stack+42761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145322, 0.0, zero_stack, 1.0, int_stack+167802,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065563,int_stack+469838,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538109, 0.0, zero_stack, 1.0, int_stack+671087,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068209,int_stack+44105,int_stack+43349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146498, 0.0, zero_stack, 1.0, int_stack+168978,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29736,int_stack+1068209,int_stack+469838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+539432, 0.0, zero_stack, 1.0, int_stack+672410,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+468515,int_stack+29736,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541196, 0.0, zero_stack, 1.0, int_stack+674174,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+38661,int_stack+45050,int_stack+44105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148010, 0.0, zero_stack, 1.0, int_stack+170490,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+41496,int_stack+38661,int_stack+1068209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543842, 0.0, zero_stack, 1.0, int_stack+676820,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+41496,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+546110, 0.0, zero_stack, 1.0, int_stack+679088,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+38661,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549638, 0.0, zero_stack, 1.0, int_stack+682616,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1147778,int_stack+38661,int_stack+33936,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+46415,int_stack+46205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355285, 1.0, int_stack+368420, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+46695,int_stack+46415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355495, 1.0, int_stack+368630, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554048, 1.0, int_stack+621587, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+47055,int_stack+46695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355775, 1.0, int_stack+368910, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+471245,int_stack+469145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554678, 1.0, int_stack+622217, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1067243,int_stack+1065563,int_stack+469985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+555518, 1.0, int_stack+623057, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+47505,int_stack+47055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+356135, 1.0, int_stack+369270, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1069343,int_stack+468515,int_stack+471245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+556778, 1.0, int_stack+624317, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1069343,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557858, 1.0, int_stack+625397, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+29736,int_stack+468515,int_stack+1067243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574838, 1.0, int_stack+0, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+48370,int_stack+48055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358985, 1.0, int_stack+372120, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+468515,int_stack+48790,int_stack+48370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359300, 1.0, int_stack+372435, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469775,int_stack+468515,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580088, 1.0, int_stack+645527, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+49330,int_stack+48790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359720, 1.0, int_stack+372855, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581033, 1.0, int_stack+646472, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+32886,int_stack+1067183,int_stack+469775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582293, 1.0, int_stack+647732, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+50005,int_stack+49330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360260, 1.0, int_stack+373395, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+36036,int_stack+468515,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584183, 1.0, int_stack+649622, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+36036,int_stack+1067183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+585803, 1.0, int_stack+651242, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+36036,int_stack+468515,int_stack+32886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588323, 1.0, int_stack+653762, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+40761,int_stack+36036,int_stack+29736,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29736,int_stack+51271,int_stack+50830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155680, 1.0, int_stack+166920, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+31059,int_stack+51859,int_stack+51271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156562, 1.0, int_stack+167802, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32823,int_stack+31059,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605648, 1.0, int_stack+671087, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468515,int_stack+52615,int_stack+51859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157738, 1.0, int_stack+168978, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+468515,int_stack+31059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606971, 1.0, int_stack+672410, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1161953,int_stack+1065563,int_stack+32823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608735, 1.0, int_stack+674174, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+29736,int_stack+53560,int_stack+52615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159250, 1.0, int_stack+170490, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1166363,int_stack+29736,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611381, 1.0, int_stack+676820, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+29736,int_stack+1166363,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613649, 1.0, int_stack+679088, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+29736,int_stack+1161953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+617177, 1.0, int_stack+682616, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1161953,int_stack+1065563,int_stack+36036,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+54925,int_stack+54715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+368420, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+55205,int_stack+54925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+368630, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+621587, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+55565,int_stack+55205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+368910, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+622217, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+29736,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+623057, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+56015,int_stack+55565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+369270, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+31836,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+624317, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+31836,int_stack+1069373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+625397, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+31836,int_stack+1065563,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+56880,int_stack+56565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+372120, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29736,int_stack+57300,int_stack+56880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+372435, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065563,int_stack+29736,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+645527, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1067453,int_stack+57840,int_stack+57300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+372855, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069073,int_stack+1067453,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+646472, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+34986,int_stack+1069073,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+647732, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+29736,int_stack+58515,int_stack+57840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+373395, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+468515,int_stack+29736,int_stack+1067453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+649622, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+50211,int_stack+468515,int_stack+1069073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+651242, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+50211,int_stack+34986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+653762, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1176128,int_stack+468515,int_stack+31836,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50211,int_stack+59781,int_stack+59340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+166920, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+51534,int_stack+60369,int_stack+59781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+167802, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+53298,int_stack+51534,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+671087, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+55944,int_stack+61125,int_stack+60369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+168978, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29736,int_stack+55944,int_stack+51534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+672410, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+33264,int_stack+29736,int_stack+53298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+674174, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+50211,int_stack+62070,int_stack+61125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+170490, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+58212,int_stack+50211,int_stack+55944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+676820, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+50211,int_stack+58212,int_stack+29736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+679088, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+50211,int_stack+33264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+682616, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1185578,int_stack+1065563,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+63435,int_stack+63225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381555,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+63715,int_stack+63435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381765,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687026,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+64075,int_stack+63715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+342640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382045,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+471245,int_stack+469145, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687656,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1067243,int_stack+1065563,int_stack+469985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688496,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+64525,int_stack+64075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382405,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1069343,int_stack+468515,int_stack+471245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689756,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1069343,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690836,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+50211,int_stack+468515,int_stack+1067243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707816,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+65390,int_stack+65075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385255,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+468515,int_stack+65810,int_stack+65390, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385570,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469775,int_stack+468515,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+709916,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+66350,int_stack+65810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385990,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710861,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+53361,int_stack+1067183,int_stack+469775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+498815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712121,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+67025,int_stack+66350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386530,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+56511,int_stack+468515,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718026,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+56511,int_stack+1067183, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+502325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719646,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+56511,int_stack+468515,int_stack+53361, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+722166,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+29736,int_stack+56511,int_stack+50211,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50211,int_stack+68291,int_stack+67850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178160,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+51534,int_stack+68879,int_stack+68291, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145322, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179042,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+53298,int_stack+51534,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538109, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2100,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468515,int_stack+69635,int_stack+68879, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146498, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180218,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+61236,int_stack+468515,int_stack+51534, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+539432, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+739491,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+64764,int_stack+61236,int_stack+53298, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541196, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741255,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+50211,int_stack+70580,int_stack+69635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181730,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+50211,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743901,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+50211,int_stack+1065563,int_stack+61236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+546110, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746169,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+50211,int_stack+64764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749697,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1199753,int_stack+1065563,int_stack+56511,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+71945,int_stack+71735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355285, 0.0, zero_stack, 1.0, int_stack+381555, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+72225,int_stack+71945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355495, 0.0, zero_stack, 1.0, int_stack+381765, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554048, 0.0, zero_stack, 1.0, int_stack+687026, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+72585,int_stack+72225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355775, 0.0, zero_stack, 1.0, int_stack+382045, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554678, 0.0, zero_stack, 1.0, int_stack+687656, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50211,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+555518, 0.0, zero_stack, 1.0, int_stack+688496, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+73035,int_stack+72585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+356135, 0.0, zero_stack, 1.0, int_stack+382405, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+52311,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+556778, 0.0, zero_stack, 1.0, int_stack+689756, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+52311,int_stack+1069373, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557858, 0.0, zero_stack, 1.0, int_stack+690836, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+52311,int_stack+1065563,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574838, 0.0, zero_stack, 1.0, int_stack+707816, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+73900,int_stack+73585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358985, 0.0, zero_stack, 1.0, int_stack+385255, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+50211,int_stack+74320,int_stack+73900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359300, 0.0, zero_stack, 1.0, int_stack+385570, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065563,int_stack+50211,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580088, 0.0, zero_stack, 1.0, int_stack+709916, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1067453,int_stack+74860,int_stack+74320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359720, 0.0, zero_stack, 1.0, int_stack+385990, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069073,int_stack+1067453,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581033, 0.0, zero_stack, 1.0, int_stack+710861, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+55461,int_stack+1069073,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582293, 0.0, zero_stack, 1.0, int_stack+712121, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+50211,int_stack+75535,int_stack+74860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360260, 0.0, zero_stack, 1.0, int_stack+386530, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+58611,int_stack+50211,int_stack+1067453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+584183, 0.0, zero_stack, 1.0, int_stack+718026, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61851,int_stack+58611,int_stack+1069073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+585803, 0.0, zero_stack, 1.0, int_stack+719646, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+61851,int_stack+55461, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588323, 0.0, zero_stack, 1.0, int_stack+722166, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+55461,int_stack+468515,int_stack+52311,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+64911,int_stack+76801,int_stack+76360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155680, 0.0, zero_stack, 1.0, int_stack+178160, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+66234,int_stack+77389,int_stack+76801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156562, 0.0, zero_stack, 1.0, int_stack+179042, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+67998,int_stack+66234,int_stack+64911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605648, 0.0, zero_stack, 1.0, int_stack+2100, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+70644,int_stack+78145,int_stack+77389, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157738, 0.0, zero_stack, 1.0, int_stack+180218, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72912,int_stack+70644,int_stack+66234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606971, 0.0, zero_stack, 1.0, int_stack+739491, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50211,int_stack+72912,int_stack+67998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608735, 0.0, zero_stack, 1.0, int_stack+741255, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+64911,int_stack+79090,int_stack+78145, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159250, 0.0, zero_stack, 1.0, int_stack+181730, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+64911,int_stack+70644, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611381, 0.0, zero_stack, 1.0, int_stack+743901, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+64911,int_stack+1065563,int_stack+72912, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613649, 0.0, zero_stack, 1.0, int_stack+746169, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+64911,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+617177, 0.0, zero_stack, 1.0, int_stack+749697, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+64911,int_stack+1065563,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+80455,int_stack+80245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368420, 1.0, int_stack+381555, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+80735,int_stack+80455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368630, 1.0, int_stack+381765, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621587, 1.0, int_stack+687026, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+81095,int_stack+80735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368910, 1.0, int_stack+382045, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+471245,int_stack+469145, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622217, 1.0, int_stack+687656, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1067243,int_stack+1065563,int_stack+469985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623057, 1.0, int_stack+688496, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+81545,int_stack+81095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369270, 1.0, int_stack+382405, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1069343,int_stack+468515,int_stack+471245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624317, 1.0, int_stack+689756, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1069343,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625397, 1.0, int_stack+690836, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+50211,int_stack+468515,int_stack+1067243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+707816, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+82410,int_stack+82095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372120, 1.0, int_stack+385255, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+468515,int_stack+82830,int_stack+82410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372435, 1.0, int_stack+385570, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469775,int_stack+468515,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645527, 1.0, int_stack+709916, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+83370,int_stack+82830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372855, 1.0, int_stack+385990, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+646472, 1.0, int_stack+710861, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+79086,int_stack+1067183,int_stack+469775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647732, 1.0, int_stack+712121, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+84045,int_stack+83370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373395, 1.0, int_stack+386530, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1213928,int_stack+468515,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+649622, 1.0, int_stack+718026, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1213928,int_stack+1067183, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651242, 1.0, int_stack+719646, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+468515,int_stack+79086, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653762, 1.0, int_stack+722166, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1213928,int_stack+1065563,int_stack+50211,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50211,int_stack+85311,int_stack+84870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166920, 1.0, int_stack+178160, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+51534,int_stack+85899,int_stack+85311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167802, 1.0, int_stack+179042, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+79086,int_stack+51534,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671087, 1.0, int_stack+2100, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+81732,int_stack+86655,int_stack+85899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168978, 1.0, int_stack+180218, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+468515,int_stack+81732,int_stack+51534, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672410, 1.0, int_stack+739491, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50211,int_stack+468515,int_stack+79086, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674174, 1.0, int_stack+741255, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1223378,int_stack+87600,int_stack+86655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170490, 1.0, int_stack+181730, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+84000,int_stack+1223378,int_stack+81732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676820, 1.0, int_stack+743901, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1223378,int_stack+84000,int_stack+468515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679088, 1.0, int_stack+746169, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+79086,int_stack+1223378,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682616, 1.0, int_stack+749697, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1223378,int_stack+79086,int_stack+1065563,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+88965,int_stack+88755, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+381555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+89245,int_stack+88965, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+381765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+687026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+89605,int_stack+89245, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+382045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+687656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+79086,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+688496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+90055,int_stack+89605, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+382405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+81186,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+689756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+81186,int_stack+1069373, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+690836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+81186,int_stack+1065563,int_stack+79086, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+707816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+90920,int_stack+90605, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+385255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+79086,int_stack+91340,int_stack+90920, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+385570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065563,int_stack+79086,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+709916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1067453,int_stack+91880,int_stack+91340, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+385990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069073,int_stack+1067453,int_stack+79086, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+710861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+84336,int_stack+1069073,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+712121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+79086,int_stack+92555,int_stack+91880, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+386530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+87486,int_stack+79086,int_stack+1067453, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+718026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+50211,int_stack+87486,int_stack+1069073, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+719646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+50211,int_stack+84336, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+722166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1237553,int_stack+468515,int_stack+81186,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50211,int_stack+93821,int_stack+93380, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+178160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+51534,int_stack+94409,int_stack+93821, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+179042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+79086,int_stack+51534,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+81732,int_stack+95165,int_stack+94409, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+180218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+84000,int_stack+81732,int_stack+51534, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+739491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50211,int_stack+84000,int_stack+79086, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+741255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+87528,int_stack+96110,int_stack+95165, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+181730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+90363,int_stack+87528,int_stack+81732, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+743901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+90363,int_stack+84000, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+746169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+79086,int_stack+1065563,int_stack+50211, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+749697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1247003,int_stack+79086,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+97475,int_stack+97265, 0.0, zero_stack, 1.0, int_stack+342150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394690,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+97755,int_stack+97475, 0.0, zero_stack, 1.0, int_stack+342360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394900,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+474485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754107,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+98115,int_stack+97755, 0.0, zero_stack, 1.0, int_stack+342640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395180,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+79086,int_stack+471245,int_stack+469145, 0.0, zero_stack, 1.0, int_stack+475115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754737,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+80766,int_stack+79086,int_stack+469985, 0.0, zero_stack, 1.0, int_stack+475955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755577,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+98565,int_stack+98115, 0.0, zero_stack, 1.0, int_stack+343000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395540,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+82866,int_stack+468515,int_stack+471245, 0.0, zero_stack, 1.0, int_stack+477215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756837,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+82866,int_stack+79086, 0.0, zero_stack, 1.0, int_stack+478295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+757917,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+82866,int_stack+468515,int_stack+80766, 0.0, zero_stack, 1.0, int_stack+479975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774897,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+99430,int_stack+99115, 0.0, zero_stack, 1.0, int_stack+345850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398390,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+468515,int_stack+99850,int_stack+99430, 0.0, zero_stack, 1.0, int_stack+346165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398705,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469775,int_stack+468515,int_stack+19341, 0.0, zero_stack, 1.0, int_stack+496610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780147,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+79086,int_stack+100390,int_stack+99850, 0.0, zero_stack, 1.0, int_stack+346585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399125,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86016,int_stack+79086,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+497555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781092,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+88536,int_stack+86016,int_stack+469775, 0.0, zero_stack, 1.0, int_stack+498815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782352,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+101065,int_stack+100390, 0.0, zero_stack, 1.0, int_stack+347125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399665,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+91686,int_stack+468515,int_stack+79086, 0.0, zero_stack, 1.0, int_stack+500705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784242,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+91686,int_stack+86016, 0.0, zero_stack, 1.0, int_stack+502325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785862,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+91686,int_stack+468515,int_stack+88536, 0.0, zero_stack, 1.0, int_stack+504845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788382,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1261178,int_stack+91686,int_stack+82866,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+102331,int_stack+101890, 0.0, zero_stack, 1.0, int_stack+144440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189400,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469838,int_stack+102919,int_stack+102331, 0.0, zero_stack, 1.0, int_stack+145322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190282,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+96411,int_stack+469838,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+538109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+805707,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+99057,int_stack+103675,int_stack+102919, 0.0, zero_stack, 1.0, int_stack+146498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191458,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+79086,int_stack+99057,int_stack+469838, 0.0, zero_stack, 1.0, int_stack+539432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807030,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+468515,int_stack+79086,int_stack+96411, 0.0, zero_stack, 1.0, int_stack+541196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808794,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82614,int_stack+104620,int_stack+103675, 0.0, zero_stack, 1.0, int_stack+148010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192970,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+85449,int_stack+82614,int_stack+99057, 0.0, zero_stack, 1.0, int_stack+543842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811440,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+96411,int_stack+85449,int_stack+79086, 0.0, zero_stack, 1.0, int_stack+546110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+813708,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+96411,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+549638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+817236,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1270628,int_stack+1065563,int_stack+91686,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+105985,int_stack+105775, 0.0, zero_stack, 1.0, int_stack+355285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394690, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+106265,int_stack+105985, 0.0, zero_stack, 1.0, int_stack+355495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394900, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+554048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754107, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+106625,int_stack+106265, 0.0, zero_stack, 1.0, int_stack+355775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395180, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 1.0, int_stack+554678, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754737, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+468515,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 1.0, int_stack+555518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755577, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+107075,int_stack+106625, 0.0, zero_stack, 1.0, int_stack+356135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395540, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+470615,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 1.0, int_stack+556778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756837, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+470615,int_stack+1069373, 0.0, zero_stack, 1.0, int_stack+557858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+757917, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1068363,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774897, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+107940,int_stack+107625, 0.0, zero_stack, 1.0, int_stack+358985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398390, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+468515,int_stack+108360,int_stack+107940, 0.0, zero_stack, 1.0, int_stack+359300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398705, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469775,int_stack+468515,int_stack+19341, 0.0, zero_stack, 1.0, int_stack+580088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780147, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+108900,int_stack+108360, 0.0, zero_stack, 1.0, int_stack+359720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399125, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+79086,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+581033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781092, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+81606,int_stack+79086,int_stack+469775, 0.0, zero_stack, 1.0, int_stack+582293, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782352, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+109575,int_stack+108900, 0.0, zero_stack, 1.0, int_stack+360260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399665, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+84756,int_stack+468515,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+584183, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784242, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+84756,int_stack+79086, 0.0, zero_stack, 1.0, int_stack+585803, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+785862, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+84756,int_stack+468515,int_stack+81606, 0.0, zero_stack, 1.0, int_stack+588323, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788382, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+89481,int_stack+84756,int_stack+1068363,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+110841,int_stack+110400, 0.0, zero_stack, 1.0, int_stack+155680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189400, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469838,int_stack+111429,int_stack+110841, 0.0, zero_stack, 1.0, int_stack+156562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190282, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+79086,int_stack+469838,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+605648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+805707, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+81732,int_stack+112185,int_stack+111429, 0.0, zero_stack, 1.0, int_stack+157738, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191458, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+98931,int_stack+81732,int_stack+469838, 0.0, zero_stack, 1.0, int_stack+606971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807030, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+468515,int_stack+98931,int_stack+79086, 0.0, zero_stack, 1.0, int_stack+608735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808794, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102459,int_stack+113130,int_stack+112185, 0.0, zero_stack, 1.0, int_stack+159250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192970, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+105294,int_stack+102459,int_stack+81732, 0.0, zero_stack, 1.0, int_stack+611381, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811440, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+105294,int_stack+98931, 0.0, zero_stack, 1.0, int_stack+613649, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+813708, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+98931,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+617177, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+817236, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1284803,int_stack+98931,int_stack+84756,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+98931,int_stack+114495,int_stack+114285, 0.0, zero_stack, 1.0, int_stack+368420, 0.0, zero_stack, 1.0, int_stack+394690, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+99561,int_stack+114775,int_stack+114495, 0.0, zero_stack, 1.0, int_stack+368630, 0.0, zero_stack, 1.0, int_stack+394900, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+100401,int_stack+99561,int_stack+98931, 0.0, zero_stack, 1.0, int_stack+621587, 0.0, zero_stack, 1.0, int_stack+754107, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+101661,int_stack+115135,int_stack+114775, 0.0, zero_stack, 1.0, int_stack+368910, 0.0, zero_stack, 1.0, int_stack+395180, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+102741,int_stack+101661,int_stack+99561, 0.0, zero_stack, 1.0, int_stack+622217, 0.0, zero_stack, 1.0, int_stack+754737, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+104421,int_stack+102741,int_stack+100401, 0.0, zero_stack, 1.0, int_stack+623057, 0.0, zero_stack, 1.0, int_stack+755577, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+98931,int_stack+115585,int_stack+115135, 0.0, zero_stack, 1.0, int_stack+369270, 0.0, zero_stack, 1.0, int_stack+395540, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+106521,int_stack+98931,int_stack+101661, 0.0, zero_stack, 1.0, int_stack+624317, 0.0, zero_stack, 1.0, int_stack+756837, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+98931,int_stack+106521,int_stack+102741, 0.0, zero_stack, 1.0, int_stack+625397, 0.0, zero_stack, 1.0, int_stack+757917, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+106521,int_stack+98931,int_stack+104421, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+774897, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+116450,int_stack+116135, 0.0, zero_stack, 1.0, int_stack+372120, 0.0, zero_stack, 1.0, int_stack+398390, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+98931,int_stack+116870,int_stack+116450, 0.0, zero_stack, 1.0, int_stack+372435, 0.0, zero_stack, 1.0, int_stack+398705, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+100191,int_stack+98931,int_stack+19341, 0.0, zero_stack, 1.0, int_stack+645527, 0.0, zero_stack, 1.0, int_stack+780147, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+102081,int_stack+117410,int_stack+116870, 0.0, zero_stack, 1.0, int_stack+372855, 0.0, zero_stack, 1.0, int_stack+399125, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+103701,int_stack+102081,int_stack+98931, 0.0, zero_stack, 1.0, int_stack+646472, 0.0, zero_stack, 1.0, int_stack+781092, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+109671,int_stack+103701,int_stack+100191, 0.0, zero_stack, 1.0, int_stack+647732, 0.0, zero_stack, 1.0, int_stack+782352, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+98931,int_stack+118085,int_stack+117410, 0.0, zero_stack, 1.0, int_stack+373395, 0.0, zero_stack, 1.0, int_stack+399665, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+112821,int_stack+98931,int_stack+102081, 0.0, zero_stack, 1.0, int_stack+649622, 0.0, zero_stack, 1.0, int_stack+784242, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+98931,int_stack+112821,int_stack+103701, 0.0, zero_stack, 1.0, int_stack+651242, 0.0, zero_stack, 1.0, int_stack+785862, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+98931,int_stack+109671, 0.0, zero_stack, 1.0, int_stack+653762, 0.0, zero_stack, 1.0, int_stack+788382, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+79086,int_stack+468515,int_stack+106521,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+98931,int_stack+119351,int_stack+118910, 0.0, zero_stack, 1.0, int_stack+166920, 0.0, zero_stack, 1.0, int_stack+189400, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+100254,int_stack+119939,int_stack+119351, 0.0, zero_stack, 1.0, int_stack+167802, 0.0, zero_stack, 1.0, int_stack+190282, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+102018,int_stack+100254,int_stack+98931, 0.0, zero_stack, 1.0, int_stack+671087, 0.0, zero_stack, 1.0, int_stack+805707, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+104664,int_stack+120695,int_stack+119939, 0.0, zero_stack, 1.0, int_stack+168978, 0.0, zero_stack, 1.0, int_stack+191458, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+106932,int_stack+104664,int_stack+100254, 0.0, zero_stack, 1.0, int_stack+672410, 0.0, zero_stack, 1.0, int_stack+807030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+110460,int_stack+106932,int_stack+102018, 0.0, zero_stack, 1.0, int_stack+674174, 0.0, zero_stack, 1.0, int_stack+808794, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+98931,int_stack+121640,int_stack+120695, 0.0, zero_stack, 1.0, int_stack+170490, 0.0, zero_stack, 1.0, int_stack+192970, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+114870,int_stack+98931,int_stack+104664, 0.0, zero_stack, 1.0, int_stack+676820, 0.0, zero_stack, 1.0, int_stack+811440, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+98931,int_stack+114870,int_stack+106932, 0.0, zero_stack, 1.0, int_stack+679088, 0.0, zero_stack, 1.0, int_stack+813708, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+98931,int_stack+110460, 0.0, zero_stack, 1.0, int_stack+682616, 0.0, zero_stack, 1.0, int_stack+817236, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+98931,int_stack+1065563,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+123005,int_stack+122795, 0.0, zero_stack, 1.0, int_stack+381555, 1.0, int_stack+394690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+123285,int_stack+123005, 0.0, zero_stack, 1.0, int_stack+381765, 1.0, int_stack+394900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+687026, 1.0, int_stack+754107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+123645,int_stack+123285, 0.0, zero_stack, 1.0, int_stack+382045, 1.0, int_stack+395180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+471245,int_stack+469145, 0.0, zero_stack, 1.0, int_stack+687656, 1.0, int_stack+754737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1067243,int_stack+1065563,int_stack+469985, 0.0, zero_stack, 1.0, int_stack+688496, 1.0, int_stack+755577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+124095,int_stack+123645, 0.0, zero_stack, 1.0, int_stack+382405, 1.0, int_stack+395540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1069343,int_stack+468515,int_stack+471245, 0.0, zero_stack, 1.0, int_stack+689756, 1.0, int_stack+756837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1069343,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+690836, 1.0, int_stack+757917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+113106,int_stack+468515,int_stack+1067243, 0.0, zero_stack, 1.0, int_stack+707816, 1.0, int_stack+774897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+124960,int_stack+124645, 0.0, zero_stack, 1.0, int_stack+385255, 1.0, int_stack+398390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+468515,int_stack+125380,int_stack+124960, 0.0, zero_stack, 1.0, int_stack+385570, 1.0, int_stack+398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469775,int_stack+468515,int_stack+19341, 0.0, zero_stack, 1.0, int_stack+709916, 1.0, int_stack+780147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+125920,int_stack+125380, 0.0, zero_stack, 1.0, int_stack+385990, 1.0, int_stack+399125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+710861, 1.0, int_stack+781092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+116256,int_stack+1067183,int_stack+469775, 0.0, zero_stack, 1.0, int_stack+712121, 1.0, int_stack+782352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+126595,int_stack+125920, 0.0, zero_stack, 1.0, int_stack+386530, 1.0, int_stack+399665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+119406,int_stack+468515,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+718026, 1.0, int_stack+784242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+119406,int_stack+1067183, 0.0, zero_stack, 1.0, int_stack+719646, 1.0, int_stack+785862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+119406,int_stack+468515,int_stack+116256, 0.0, zero_stack, 1.0, int_stack+722166, 1.0, int_stack+788382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1298978,int_stack+119406,int_stack+113106,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+113106,int_stack+127861,int_stack+127420, 0.0, zero_stack, 1.0, int_stack+178160, 1.0, int_stack+189400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+114429,int_stack+128449,int_stack+127861, 0.0, zero_stack, 1.0, int_stack+179042, 1.0, int_stack+190282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116193,int_stack+114429,int_stack+113106, 0.0, zero_stack, 1.0, int_stack+2100, 1.0, int_stack+805707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468515,int_stack+129205,int_stack+128449, 0.0, zero_stack, 1.0, int_stack+180218, 1.0, int_stack+191458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+124131,int_stack+468515,int_stack+114429, 0.0, zero_stack, 1.0, int_stack+739491, 1.0, int_stack+807030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1065563,int_stack+124131,int_stack+116193, 0.0, zero_stack, 1.0, int_stack+741255, 1.0, int_stack+808794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+113106,int_stack+130150,int_stack+129205, 0.0, zero_stack, 1.0, int_stack+181730, 1.0, int_stack+192970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+50211,int_stack+113106,int_stack+468515, 0.0, zero_stack, 1.0, int_stack+743901, 1.0, int_stack+811440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+113106,int_stack+50211,int_stack+124131, 0.0, zero_stack, 1.0, int_stack+746169, 1.0, int_stack+813708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+124131,int_stack+113106,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+749697, 1.0, int_stack+817236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1308428,int_stack+124131,int_stack+119406,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+131515,int_stack+131305, 0.0, zero_stack, 2.0, int_stack+394690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+131795,int_stack+131515, 0.0, zero_stack, 2.0, int_stack+394900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 2.0, int_stack+754107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+132155,int_stack+131795, 0.0, zero_stack, 2.0, int_stack+395180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 2.0, int_stack+754737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+113106,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 2.0, int_stack+755577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+132605,int_stack+132155, 0.0, zero_stack, 2.0, int_stack+395540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+115206,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 2.0, int_stack+756837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+115206,int_stack+1069373, 0.0, zero_stack, 2.0, int_stack+757917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+115206,int_stack+1065563,int_stack+113106, 0.0, zero_stack, 2.0, int_stack+774897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+133470,int_stack+133155, 0.0, zero_stack, 2.0, int_stack+398390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+113106,int_stack+133890,int_stack+133470, 0.0, zero_stack, 2.0, int_stack+398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065563,int_stack+113106,int_stack+19341, 0.0, zero_stack, 2.0, int_stack+780147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1067453,int_stack+134430,int_stack+133890, 0.0, zero_stack, 2.0, int_stack+399125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069073,int_stack+1067453,int_stack+113106, 0.0, zero_stack, 2.0, int_stack+781092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+118356,int_stack+1069073,int_stack+1065563, 0.0, zero_stack, 2.0, int_stack+782352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+113106,int_stack+135105,int_stack+134430, 0.0, zero_stack, 2.0, int_stack+399665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+121506,int_stack+113106,int_stack+1067453, 0.0, zero_stack, 2.0, int_stack+784242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+124746,int_stack+121506,int_stack+1069073, 0.0, zero_stack, 2.0, int_stack+785862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+124746,int_stack+118356, 0.0, zero_stack, 2.0, int_stack+788382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+118356,int_stack+468515,int_stack+115206,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+136371,int_stack+135930, 0.0, zero_stack, 2.0, int_stack+189400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+129129,int_stack+136959,int_stack+136371, 0.0, zero_stack, 2.0, int_stack+190282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+130893,int_stack+129129,int_stack+127806, 0.0, zero_stack, 2.0, int_stack+805707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+133539,int_stack+137715,int_stack+136959, 0.0, zero_stack, 2.0, int_stack+191458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+113106,int_stack+133539,int_stack+129129, 0.0, zero_stack, 2.0, int_stack+807030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1065563,int_stack+113106,int_stack+130893, 0.0, zero_stack, 2.0, int_stack+808794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+138660,int_stack+137715, 0.0, zero_stack, 2.0, int_stack+192970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+50211,int_stack+127806,int_stack+133539, 0.0, zero_stack, 2.0, int_stack+811440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+50211,int_stack+113106, 0.0, zero_stack, 2.0, int_stack+813708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+1065563, 0.0, zero_stack, 2.0, int_stack+817236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1329218,int_stack+1322603,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+140025,int_stack+139815, 1.0, int_stack+342150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407825,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+140305,int_stack+140025, 1.0, int_stack+342360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408035,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 1.0, int_stack+474485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821646,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+140665,int_stack+140305, 1.0, int_stack+342640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408315,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+471245,int_stack+469145, 1.0, int_stack+475115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822276,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1324283,int_stack+1322603,int_stack+469985, 1.0, int_stack+475955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823116,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+141115,int_stack+140665, 1.0, int_stack+343000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408675,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1326383,int_stack+468515,int_stack+471245, 1.0, int_stack+477215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824376,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1326383,int_stack+1322603, 1.0, int_stack+478295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825456,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+468515,int_stack+1324283, 1.0, int_stack+479975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3423,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+141980,int_stack+141665, 1.0, int_stack+345850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411840,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+468515,int_stack+142400,int_stack+141980, 1.0, int_stack+346165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412575,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469775,int_stack+468515,int_stack+19341, 1.0, int_stack+496610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+842436,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+142940,int_stack+142400, 1.0, int_stack+346585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+413535,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+468515, 1.0, int_stack+497555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+843381,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1068713,int_stack+1324223,int_stack+469775, 1.0, int_stack+498815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+844641,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+143615,int_stack+142940, 1.0, int_stack+347125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414750,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+127806,int_stack+468515,int_stack+1322603, 1.0, int_stack+500705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466895,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+127806,int_stack+1324223, 1.0, int_stack+502325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+850546,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+468515,int_stack+1068713, 1.0, int_stack+504845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853066,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+132531,int_stack+127806,int_stack+1065563,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+145910,int_stack+144881, 1.0, int_stack+144440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201081,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066886,int_stack+147254,int_stack+145910, 1.0, int_stack+145322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202551,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1068650,int_stack+1066886,int_stack+1065563, 1.0, int_stack+538109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856216,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468515,int_stack+148955,int_stack+147254, 1.0, int_stack+146498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204483,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+141981,int_stack+468515,int_stack+1066886, 1.0, int_stack+539432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857539,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1322603,int_stack+141981,int_stack+1068650, 1.0, int_stack+541196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859303,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+149900,int_stack+148955, 1.0, int_stack+148010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205995,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+145509,int_stack+1065563,int_stack+468515, 1.0, int_stack+543842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485225,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+145509,int_stack+141981, 1.0, int_stack+546110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877831,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+141981,int_stack+1065563,int_stack+1322603, 1.0, int_stack+549638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881359,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+537605,int_stack+141981,int_stack+127806,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+151265,int_stack+151055, 1.0, int_stack+355285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407825, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+151545,int_stack+151265, 1.0, int_stack+355495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408035, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+129276,int_stack+128436,int_stack+127806, 1.0, int_stack+554048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821646, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+130536,int_stack+151905,int_stack+151545, 1.0, int_stack+355775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408315, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+141981,int_stack+130536,int_stack+128436, 1.0, int_stack+554678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822276, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+143661,int_stack+141981,int_stack+129276, 1.0, int_stack+555518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823116, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+152355,int_stack+151905, 1.0, int_stack+356135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408675, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+145761,int_stack+127806,int_stack+130536, 1.0, int_stack+556778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824376, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+145761,int_stack+141981, 1.0, int_stack+557858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825456, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+145761,int_stack+127806,int_stack+143661, 1.0, int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3423, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+153220,int_stack+152905, 1.0, int_stack+358985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411840, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+574838,int_stack+153640,int_stack+153220, 1.0, int_stack+359300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412575, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127806,int_stack+574838,int_stack+19341, 1.0, int_stack+580088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+842436, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129696,int_stack+154180,int_stack+153640, 1.0, int_stack+359720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+413535, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+141981,int_stack+129696,int_stack+574838, 1.0, int_stack+581033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+843381, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+148911,int_stack+141981,int_stack+127806, 1.0, int_stack+582293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+844641, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+154855,int_stack+154180, 1.0, int_stack+360260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414750, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+580088,int_stack+574838,int_stack+129696, 1.0, int_stack+584183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466895, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+580088,int_stack+141981, 1.0, int_stack+585803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+850546, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+127806,int_stack+148911, 1.0, int_stack+588323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853066, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+580088,int_stack+468515,int_stack+145761,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+157150,int_stack+156121, 1.0, int_stack+155680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201081, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+129129,int_stack+158494,int_stack+157150, 1.0, int_stack+156562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202551, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+141981,int_stack+129129,int_stack+127806, 1.0, int_stack+605648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856216, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+144627,int_stack+160195,int_stack+158494, 1.0, int_stack+157738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204483, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+146895,int_stack+144627,int_stack+129129, 1.0, int_stack+606971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857539, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127806,int_stack+146895,int_stack+141981, 1.0, int_stack+608735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859303, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+605648,int_stack+161140,int_stack+160195, 1.0, int_stack+159250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205995, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+150423,int_stack+605648,int_stack+144627, 1.0, int_stack+611381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485225, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+605648,int_stack+150423,int_stack+146895, 1.0, int_stack+613649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877831, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+605648,int_stack+127806, 1.0, int_stack+617177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881359, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+605648,int_stack+1322603,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+162505,int_stack+162295, 1.0, int_stack+368420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+162785,int_stack+162505, 1.0, int_stack+368630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408035, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 1.0, int_stack+621587, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821646, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+163145,int_stack+162785, 1.0, int_stack+368910, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408315, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+471245,int_stack+469145, 1.0, int_stack+622217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822276, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1322603,int_stack+469985, 1.0, int_stack+623057, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823116, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+163595,int_stack+163145, 1.0, int_stack+369270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408675, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1324283,int_stack+468515,int_stack+471245, 1.0, int_stack+624317, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824376, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1324283,int_stack+1322603, 1.0, int_stack+625397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825456, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+468515,int_stack+574838, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3423, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+164460,int_stack+164145, 1.0, int_stack+372120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411840, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+164880,int_stack+164460, 1.0, int_stack+372435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412575, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+0,int_stack+19341, 1.0, int_stack+645527, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+842436, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468515,int_stack+165420,int_stack+164880, 1.0, int_stack+372855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+413535, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470135,int_stack+468515,int_stack+0, 1.0, int_stack+646472, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+843381, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1325753,int_stack+470135,int_stack+574838, 1.0, int_stack+647732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+844641, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+166095,int_stack+165420, 1.0, int_stack+373395, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414750, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+645527,int_stack+574838,int_stack+468515, 1.0, int_stack+649622, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+645527,int_stack+470135, 1.0, int_stack+651242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+850546, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+127806,int_stack+1325753, 1.0, int_stack+653762, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853066, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+645527,int_stack+468515,int_stack+1322603,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+168390,int_stack+167361, 1.0, int_stack+166920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201081, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323926,int_stack+169734,int_stack+168390, 1.0, int_stack+167802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202551, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1325690,int_stack+1323926,int_stack+1322603, 1.0, int_stack+671087, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856216, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+127806,int_stack+171435,int_stack+169734, 1.0, int_stack+168978, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204483, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+619823,int_stack+127806,int_stack+1323926, 1.0, int_stack+672410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857539, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+623351,int_stack+619823,int_stack+1325690, 1.0, int_stack+674174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859303, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+671087,int_stack+172380,int_stack+171435, 1.0, int_stack+170490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205995, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+671087,int_stack+127806, 1.0, int_stack+676820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+671087,int_stack+1322603,int_stack+619823, 1.0, int_stack+679088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877831, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+671087,int_stack+623351, 1.0, int_stack+682616, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881359, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+671087,int_stack+1322603,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+173745,int_stack+173535, 1.0, int_stack+381555, 0.0, zero_stack, 1.0, int_stack+407825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+174025,int_stack+173745, 1.0, int_stack+381765, 0.0, zero_stack, 1.0, int_stack+408035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 1.0, int_stack+687026, 0.0, zero_stack, 1.0, int_stack+821646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+174385,int_stack+174025, 1.0, int_stack+382045, 0.0, zero_stack, 1.0, int_stack+408315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+471245,int_stack+469145, 1.0, int_stack+687656, 0.0, zero_stack, 1.0, int_stack+822276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1322603,int_stack+469985, 1.0, int_stack+688496, 0.0, zero_stack, 1.0, int_stack+823116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+174835,int_stack+174385, 1.0, int_stack+382405, 0.0, zero_stack, 1.0, int_stack+408675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1324283,int_stack+468515,int_stack+471245, 1.0, int_stack+689756, 0.0, zero_stack, 1.0, int_stack+824376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1324283,int_stack+1322603, 1.0, int_stack+690836, 0.0, zero_stack, 1.0, int_stack+825456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+468515,int_stack+574838, 1.0, int_stack+707816, 0.0, zero_stack, 1.0, int_stack+3423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+175700,int_stack+175385, 1.0, int_stack+385255, 0.0, zero_stack, 1.0, int_stack+411840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+707816,int_stack+176120,int_stack+175700, 1.0, int_stack+385570, 0.0, zero_stack, 1.0, int_stack+412575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+707816,int_stack+19341, 1.0, int_stack+709916, 0.0, zero_stack, 1.0, int_stack+842436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+709076,int_stack+176660,int_stack+176120, 1.0, int_stack+385990, 0.0, zero_stack, 1.0, int_stack+413535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+468515,int_stack+709076,int_stack+707816, 1.0, int_stack+710861, 0.0, zero_stack, 1.0, int_stack+843381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1325753,int_stack+468515,int_stack+574838, 1.0, int_stack+712121, 0.0, zero_stack, 1.0, int_stack+844641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+177335,int_stack+176660, 1.0, int_stack+386530, 0.0, zero_stack, 1.0, int_stack+414750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+710696,int_stack+574838,int_stack+709076, 1.0, int_stack+718026, 0.0, zero_stack, 1.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+685262,int_stack+710696,int_stack+468515, 1.0, int_stack+719646, 0.0, zero_stack, 1.0, int_stack+850546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+685262,int_stack+1325753, 1.0, int_stack+722166, 0.0, zero_stack, 1.0, int_stack+853066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+141981,int_stack+468515,int_stack+1322603,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+179630,int_stack+178601, 1.0, int_stack+178160, 0.0, zero_stack, 1.0, int_stack+201081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323926,int_stack+180974,int_stack+179630, 1.0, int_stack+179042, 0.0, zero_stack, 1.0, int_stack+202551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1325690,int_stack+1323926,int_stack+1322603, 1.0, int_stack+2100, 0.0, zero_stack, 1.0, int_stack+856216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+685262,int_stack+182675,int_stack+180974, 1.0, int_stack+180218, 0.0, zero_stack, 1.0, int_stack+204483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+687530,int_stack+685262,int_stack+1323926, 1.0, int_stack+739491, 0.0, zero_stack, 1.0, int_stack+857539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+718026,int_stack+687530,int_stack+1325690, 1.0, int_stack+741255, 0.0, zero_stack, 1.0, int_stack+859303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+739491,int_stack+183620,int_stack+182675, 1.0, int_stack+181730, 0.0, zero_stack, 1.0, int_stack+205995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+739491,int_stack+685262, 1.0, int_stack+743901, 0.0, zero_stack, 1.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+739491,int_stack+1322603,int_stack+687530, 1.0, int_stack+746169, 0.0, zero_stack, 1.0, int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+739491,int_stack+718026, 1.0, int_stack+749697, 0.0, zero_stack, 1.0, int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+739491,int_stack+1322603,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+184985,int_stack+184775, 1.0, int_stack+394690, 1.0, int_stack+407825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+185265,int_stack+184985, 1.0, int_stack+394900, 1.0, int_stack+408035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 1.0, int_stack+754107, 1.0, int_stack+821646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+185625,int_stack+185265, 1.0, int_stack+395180, 1.0, int_stack+408315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+471245,int_stack+469145, 1.0, int_stack+754737, 1.0, int_stack+822276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1322603,int_stack+469985, 1.0, int_stack+755577, 1.0, int_stack+823116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+186075,int_stack+185625, 1.0, int_stack+395540, 1.0, int_stack+408675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1324283,int_stack+468515,int_stack+471245, 1.0, int_stack+756837, 1.0, int_stack+824376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1324283,int_stack+1322603, 1.0, int_stack+757917, 1.0, int_stack+825456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+468515,int_stack+574838, 1.0, int_stack+774897, 1.0, int_stack+3423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+186940,int_stack+186625, 1.0, int_stack+398390, 1.0, int_stack+411840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+774897,int_stack+187360,int_stack+186940, 1.0, int_stack+398705, 1.0, int_stack+412575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+774897,int_stack+19341, 1.0, int_stack+780147, 1.0, int_stack+842436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468515,int_stack+187900,int_stack+187360, 1.0, int_stack+399125, 1.0, int_stack+413535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470135,int_stack+468515,int_stack+774897, 1.0, int_stack+781092, 1.0, int_stack+843381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1325753,int_stack+470135,int_stack+574838, 1.0, int_stack+782352, 1.0, int_stack+844641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+188575,int_stack+187900, 1.0, int_stack+399665, 1.0, int_stack+414750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+780147,int_stack+574838,int_stack+468515, 1.0, int_stack+784242, 1.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+718026,int_stack+780147,int_stack+470135, 1.0, int_stack+785862, 1.0, int_stack+850546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+468515,int_stack+718026,int_stack+1325753, 1.0, int_stack+788382, 1.0, int_stack+853066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+780147,int_stack+468515,int_stack+1322603,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+190870,int_stack+189841, 1.0, int_stack+189400, 1.0, int_stack+201081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323926,int_stack+192214,int_stack+190870, 1.0, int_stack+190282, 1.0, int_stack+202551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1325690,int_stack+1323926,int_stack+1322603, 1.0, int_stack+805707, 1.0, int_stack+856216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+718026,int_stack+193915,int_stack+192214, 1.0, int_stack+191458, 1.0, int_stack+204483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+720294,int_stack+718026,int_stack+1323926, 1.0, int_stack+807030, 1.0, int_stack+857539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+753666,int_stack+720294,int_stack+1325690, 1.0, int_stack+808794, 1.0, int_stack+859303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+805707,int_stack+194860,int_stack+193915, 1.0, int_stack+192970, 1.0, int_stack+205995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+805707,int_stack+718026, 1.0, int_stack+811440, 1.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+805707,int_stack+1322603,int_stack+720294, 1.0, int_stack+813708, 1.0, int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+805707,int_stack+753666, 1.0, int_stack+817236, 1.0, int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+805707,int_stack+1322603,int_stack+468515,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+468515,int_stack+196225,int_stack+196015, 2.0, int_stack+407825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+469145,int_stack+196505,int_stack+196225, 2.0, int_stack+408035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+469985,int_stack+469145,int_stack+468515, 2.0, int_stack+821646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471245,int_stack+196865,int_stack+196505, 2.0, int_stack+408315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+471245,int_stack+469145, 2.0, int_stack+822276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1322603,int_stack+469985, 2.0, int_stack+823116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+468515,int_stack+197315,int_stack+196865, 2.0, int_stack+408675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1324283,int_stack+468515,int_stack+471245, 2.0, int_stack+824376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+468515,int_stack+1324283,int_stack+1322603, 2.0, int_stack+825456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+468515,int_stack+574838, 2.0, int_stack+3423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+198180,int_stack+197865, 2.0, int_stack+411840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+574838,int_stack+198600,int_stack+198180, 2.0, int_stack+412575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+468515,int_stack+574838,int_stack+19341, 2.0, int_stack+842436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470405,int_stack+199140,int_stack+198600, 2.0, int_stack+413535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1325753,int_stack+470405,int_stack+574838, 2.0, int_stack+843381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+753666,int_stack+1325753,int_stack+468515, 2.0, int_stack+844641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+199815,int_stack+199140, 2.0, int_stack+414750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+842436,int_stack+574838,int_stack+470405, 2.0, int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+466895,int_stack+842436,int_stack+1325753, 2.0, int_stack+850546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+466895,int_stack+753666, 2.0, int_stack+853066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+151431,int_stack+127806,int_stack+1322603,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+203139,int_stack+201522, 2.0, int_stack+201081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323926,int_stack+205239,int_stack+203139, 2.0, int_stack+202551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1325690,int_stack+1323926,int_stack+1322603, 2.0, int_stack+856216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+753666,int_stack+206940,int_stack+205239, 2.0, int_stack+204483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+755934,int_stack+753666,int_stack+1323926, 2.0, int_stack+857539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+466895,int_stack+755934,int_stack+1325690, 2.0, int_stack+859303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1322603,int_stack+207885,int_stack+206940, 2.0, int_stack+205995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+850546,int_stack+1322603,int_stack+753666, 2.0, int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+850546,int_stack+755934, 2.0, int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+466895, 2.0, int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+160881,int_stack+1065563,int_stack+127806,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+209250,int_stack+209040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425640,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+209530,int_stack+209250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425850,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+129276,int_stack+128436,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898369,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+130536,int_stack+209890,int_stack+209530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426130,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+130536,int_stack+128436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473240,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1065563,int_stack+129276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+210340,int_stack+209890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426490,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1067243,int_stack+127806,int_stack+130536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+861949,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+1067243,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487493,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+127806,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489173,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+211205,int_stack+210890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429340,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+574838,int_stack+211625,int_stack+211205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429655,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127806,int_stack+574838,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898999,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129696,int_stack+212165,int_stack+211625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430075,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1068713,int_stack+129696,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899944,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+466895,int_stack+1068713,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494423,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+212840,int_stack+212165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430615,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+574838,int_stack+129696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+1322603,int_stack+1068713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901204,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+127806,int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+903724,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+850546,int_stack+411525,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+214106,int_stack+213665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256215,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066886,int_stack+214694,int_stack+214106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257097,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1068650,int_stack+1066886,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+906874,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+485225,int_stack+215450,int_stack+214694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258273,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+466895,int_stack+485225,int_stack+1066886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+908197,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127806,int_stack+466895,int_stack+1068650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909961,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+216395,int_stack+215450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259785,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+1065563,int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5523,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928489,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+1065563,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932017,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+175056,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+217760,int_stack+217550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425640, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+218040,int_stack+217760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425850, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+412995,int_stack+412155,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898369, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+414255,int_stack+218400,int_stack+218040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426130, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+414255,int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473240, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1322603,int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536345, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+218850,int_stack+218400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426490, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1324283,int_stack+411525,int_stack+414255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+861949, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+411525,int_stack+1324283,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487493, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489173, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+219715,int_stack+219400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429340, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+574838,int_stack+220135,int_stack+219715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429655, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+411525,int_stack+574838,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898999, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+413415,int_stack+220675,int_stack+220135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430075, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1325753,int_stack+413415,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899944, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127806,int_stack+1325753,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494423, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+221350,int_stack+220675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430615, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+574838,int_stack+413415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+411525,int_stack+1065563,int_stack+1325753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901204, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+411525,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+903724, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+189231,int_stack+1065563,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+576938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+222616,int_stack+222175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256215, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323926,int_stack+223204,int_stack+222616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257097, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1325690,int_stack+1323926,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+906874, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+485225,int_stack+223960,int_stack+223204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258273, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+127806,int_stack+485225,int_stack+1323926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+908197, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+411525,int_stack+127806,int_stack+1325690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909961, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1322603,int_stack+224905,int_stack+223960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259785, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+466895,int_stack+1322603,int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5523, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+466895,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928489, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+877831,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932017, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+198681,int_stack+877831,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+591473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+226270,int_stack+226060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425640, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066193,int_stack+226550,int_stack+226270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425850, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1067033,int_stack+1066193,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898369, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068293,int_stack+226910,int_stack+226550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426130, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069373,int_stack+1068293,int_stack+1066193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473240, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1069373,int_stack+1067033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536345, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+227360,int_stack+226910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426490, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+877831,int_stack+1065563,int_stack+1068293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+861949, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+877831,int_stack+1069373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487493, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+877831,int_stack+1065563,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489173, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+228225,int_stack+227910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429340, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+574838,int_stack+228645,int_stack+228225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429655, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065563,int_stack+574838,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898999, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1067453,int_stack+229185,int_stack+228645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430075, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1069073,int_stack+1067453,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899944, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+880981,int_stack+1069073,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494423, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+229860,int_stack+229185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430615, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+411525,int_stack+574838,int_stack+1067453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+1069073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901204, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+1322603,int_stack+880981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+903724, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+212856,int_stack+411525,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+877831,int_stack+231126,int_stack+230685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256215, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+879154,int_stack+231714,int_stack+231126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257097, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+880918,int_stack+879154,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+906874, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+485225,int_stack+232470,int_stack+231714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258273, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+485225,int_stack+879154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+908197, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+880918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909961, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+877831,int_stack+233415,int_stack+232470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259785, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+880666,int_stack+877831,int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5523, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+466895,int_stack+880666,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928489, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+466895,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932017, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1343393,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+234780,int_stack+234570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+235060,int_stack+234780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+412995,int_stack+412155,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+414255,int_stack+235420,int_stack+235060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+414255,int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1322603,int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+235870,int_stack+235420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1324283,int_stack+411525,int_stack+414255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+861949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+411525,int_stack+1324283,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+236735,int_stack+236420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+574838,int_stack+237155,int_stack+236735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+411525,int_stack+574838,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+413415,int_stack+237695,int_stack+237155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1325753,int_stack+413415,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1065563,int_stack+1325753,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+238370,int_stack+237695, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1068713,int_stack+574838,int_stack+413415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+411525,int_stack+1068713,int_stack+1325753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+411525,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+903724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+222306,int_stack+127806,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+239636,int_stack+239195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323926,int_stack+240224,int_stack+239636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1325690,int_stack+1323926,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+906874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+485225,int_stack+240980,int_stack+240224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+485225,int_stack+1323926, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+908197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+411525,int_stack+1065563,int_stack+1325690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1322603,int_stack+241925,int_stack+240980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+466895,int_stack+1322603,int_stack+485225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+466895,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1357568,int_stack+1065563,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+243290,int_stack+243080, 0.0, zero_stack, 1.0, int_stack+425640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+243570,int_stack+243290, 0.0, zero_stack, 1.0, int_stack+425850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+129276,int_stack+128436,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+898369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+130536,int_stack+243930,int_stack+243570, 0.0, zero_stack, 1.0, int_stack+426130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1065563,int_stack+130536,int_stack+128436, 0.0, zero_stack, 1.0, int_stack+473240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1065563,int_stack+129276, 0.0, zero_stack, 1.0, int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+244380,int_stack+243930, 0.0, zero_stack, 1.0, int_stack+426490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1067243,int_stack+127806,int_stack+130536, 0.0, zero_stack, 1.0, int_stack+861949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+1067243,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+487493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+127806,int_stack+574838, 0.0, zero_stack, 1.0, int_stack+489173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+245245,int_stack+244930, 0.0, zero_stack, 1.0, int_stack+429340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+574838,int_stack+245665,int_stack+245245, 0.0, zero_stack, 1.0, int_stack+429655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127806,int_stack+574838,int_stack+19341, 0.0, zero_stack, 1.0, int_stack+898999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129696,int_stack+246205,int_stack+245665, 0.0, zero_stack, 1.0, int_stack+430075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1068713,int_stack+129696,int_stack+574838, 0.0, zero_stack, 1.0, int_stack+899944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+411525,int_stack+1068713,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+494423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+246880,int_stack+246205, 0.0, zero_stack, 1.0, int_stack+430615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+574838,int_stack+129696, 0.0, zero_stack, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+1322603,int_stack+1068713, 0.0, zero_stack, 1.0, int_stack+901204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+903724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+231756,int_stack+1322603,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1065563,int_stack+248146,int_stack+247705, 0.0, zero_stack, 1.0, int_stack+256215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1066886,int_stack+248734,int_stack+248146, 0.0, zero_stack, 1.0, int_stack+257097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1068650,int_stack+1066886,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+906874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+485225,int_stack+249490,int_stack+248734, 0.0, zero_stack, 1.0, int_stack+258273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+411525,int_stack+485225,int_stack+1066886, 0.0, zero_stack, 1.0, int_stack+908197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127806,int_stack+411525,int_stack+1068650, 0.0, zero_stack, 1.0, int_stack+909961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1065563,int_stack+250435,int_stack+249490, 0.0, zero_stack, 1.0, int_stack+259785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+466895,int_stack+1065563,int_stack+485225, 0.0, zero_stack, 1.0, int_stack+5523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+466895,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+877831,int_stack+1065563,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+932017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1371743,int_stack+877831,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+251800,int_stack+251590, 1.0, int_stack+425640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323233,int_stack+252080,int_stack+251800, 1.0, int_stack+425850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1324073,int_stack+1323233,int_stack+1322603, 1.0, int_stack+898369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1325333,int_stack+252440,int_stack+252080, 1.0, int_stack+426130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1326413,int_stack+1325333,int_stack+1323233, 1.0, int_stack+473240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+1326413,int_stack+1324073, 1.0, int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1322603,int_stack+252890,int_stack+252440, 1.0, int_stack+426490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+877831,int_stack+1322603,int_stack+1325333, 1.0, int_stack+861949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+877831,int_stack+1326413, 1.0, int_stack+487493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+877831,int_stack+1322603,int_stack+574838, 1.0, int_stack+489173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+253755,int_stack+253440, 1.0, int_stack+429340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+254175,int_stack+253755, 1.0, int_stack+429655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 1.0, int_stack+898999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+254715,int_stack+254175, 1.0, int_stack+430075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345, 1.0, int_stack+899944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+880981,int_stack+1324223,int_stack+574838, 1.0, int_stack+494423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+494423,int_stack+255390,int_stack+254715, 1.0, int_stack+430615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+496448,int_stack+494423,int_stack+1322603, 1.0, int_stack+451910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+499688,int_stack+496448,int_stack+1324223, 1.0, int_stack+901204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+499688,int_stack+880981, 1.0, int_stack+903724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+494423,int_stack+127806,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+847396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+877831,int_stack+257685,int_stack+256656, 1.0, int_stack+256215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+879154,int_stack+259029,int_stack+257685, 1.0, int_stack+257097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+880918,int_stack+879154,int_stack+877831, 1.0, int_stack+906874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+260730,int_stack+259029, 1.0, int_stack+258273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324871,int_stack+1322603,int_stack+879154, 1.0, int_stack+908197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+898369,int_stack+1324871,int_stack+880918, 1.0, int_stack+909961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+877831,int_stack+261675,int_stack+260730, 1.0, int_stack+259785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+880666,int_stack+877831,int_stack+1322603, 1.0, int_stack+5523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+902779,int_stack+880666,int_stack+1324871, 1.0, int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+902779,int_stack+898369, 1.0, int_stack+932017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+898369,int_stack+1322603,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+863656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+263040,int_stack+262830,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+263320,int_stack+263040,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+263680,int_stack+263320,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+130356,int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+264130,int_stack+263680,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+129276,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+130356,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1324763,int_stack+574838,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+264995,int_stack+264680,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+265415,int_stack+264995,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+265955,int_stack+265415,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+928489,int_stack+1324223,int_stack+574838,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+266630,int_stack+265955,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+931639,int_stack+574838,int_stack+1322603,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+931639,int_stack+1324223,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+877831,int_stack+928489,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+466895,int_stack+411525,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+491273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+267896,int_stack+267455,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+129129,int_stack+268484,int_stack+267896,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+928489,int_stack+129129,int_stack+127806,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+931135,int_stack+269240,int_stack+268484,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+931135,int_stack+129129,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+928489,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+270185,int_stack+269240,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+931135,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+928489,int_stack+1322603,int_stack+877831,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+928489,int_stack+881359,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+241206,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+914314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+271550,int_stack+271340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438775,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+271830,int_stack+271550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438985,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+412155,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936427,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412995,int_stack+272190,int_stack+271830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439265,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414075,int_stack+412995,int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937057,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+414075,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937897,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+272640,int_stack+272190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439625,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+939157,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+414075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940237,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+1324763,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957217,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+273505,int_stack+273190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442475,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+273925,int_stack+273505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442790,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+959317,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+274465,int_stack+273925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443210,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960262,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+928489,int_stack+1324223,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961522,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+275140,int_stack+274465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443750,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+931639,int_stack+574838,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912607,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+931639,int_stack+1324223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967427,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969947,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+255381,int_stack+127806,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+482075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+276406,int_stack+275965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318515,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412848,int_stack+276994,int_stack+276406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319397,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+928489,int_stack+412848,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987272,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+931135,int_stack+277750,int_stack+276994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320573,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+931135,int_stack+412848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+988595,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+990359,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+278695,int_stack+277750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322085,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+931135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+993005,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+928489,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+995273,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+928489,int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+998801,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+264831,int_stack+1322603,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+507995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+280060,int_stack+279850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438775, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+280340,int_stack+280060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438985, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936427, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+280700,int_stack+280340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439265, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937057, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+130356,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937897, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+281150,int_stack+280700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439625, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+129276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+939157, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+130356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940237, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1324763,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957217, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+282015,int_stack+281700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442475, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+282435,int_stack+282015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442790, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+959317, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+282975,int_stack+282435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443210, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960262, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+928489,int_stack+1324223,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961522, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+283650,int_stack+282975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443750, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+931639,int_stack+574838,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912607, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+931639,int_stack+1324223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967427, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969947, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1385918,int_stack+411525,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+576938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+284916,int_stack+284475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318515, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+129129,int_stack+285504,int_stack+284916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319397, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+928489,int_stack+129129,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987272, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+931135,int_stack+286260,int_stack+285504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320573, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+931135,int_stack+129129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+988595, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+990359, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+287205,int_stack+286260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322085, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+931135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+993005, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+928489,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+995273, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+928489,int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+998801, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1395368,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+591473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+288570,int_stack+288360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438775, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+288850,int_stack+288570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438985, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+412155,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936427, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412995,int_stack+289210,int_stack+288850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439265, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414075,int_stack+412995,int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937057, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+414075,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937897, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+289660,int_stack+289210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439625, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+939157, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+414075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940237, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+1324763,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957217, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+290525,int_stack+290210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442475, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+290945,int_stack+290525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442790, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+959317, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+291485,int_stack+290945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443210, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960262, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+928489,int_stack+1324223,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961522, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+292160,int_stack+291485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443750, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+931639,int_stack+574838,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912607, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+931639,int_stack+1324223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967427, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969947, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+279006,int_stack+127806,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+642377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+293426,int_stack+292985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412848,int_stack+294014,int_stack+293426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319397, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+928489,int_stack+412848,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987272, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+931135,int_stack+294770,int_stack+294014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320573, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+931135,int_stack+412848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+988595, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+990359, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+295715,int_stack+294770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322085, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+931135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+993005, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+928489,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+995273, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+928489,int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+998801, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1409543,int_stack+1322603,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+656912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+297080,int_stack+296870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+297360,int_stack+297080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+297720,int_stack+297360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+130356,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+298170,int_stack+297720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+129276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+939157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+130356, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1324763,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+299035,int_stack+298720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+299455,int_stack+299035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+959317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+299995,int_stack+299455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+928489,int_stack+1324223,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+300670,int_stack+299995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+931639,int_stack+574838,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+931639,int_stack+1324223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+288456,int_stack+411525,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+714876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+301936,int_stack+301495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+129129,int_stack+302524,int_stack+301936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+928489,int_stack+129129,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+931135,int_stack+303280,int_stack+302524, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+931135,int_stack+129129, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+988595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+928489, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+990359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+304225,int_stack+303280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+931135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+993005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+928489,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+995273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+928489,int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+998801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1423718,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+725316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+305590,int_stack+305380, 0.0, zero_stack, 1.0, int_stack+438775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+305870,int_stack+305590, 0.0, zero_stack, 1.0, int_stack+438985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+412155,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+936427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412995,int_stack+306230,int_stack+305870, 0.0, zero_stack, 1.0, int_stack+439265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414075,int_stack+412995,int_stack+412155, 0.0, zero_stack, 1.0, int_stack+937057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+414075,int_stack+536345, 0.0, zero_stack, 1.0, int_stack+937897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+306680,int_stack+306230, 0.0, zero_stack, 1.0, int_stack+439625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+412995, 0.0, zero_stack, 1.0, int_stack+939157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+414075, 0.0, zero_stack, 1.0, int_stack+940237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+1324763,int_stack+574838, 0.0, zero_stack, 1.0, int_stack+957217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+307545,int_stack+307230, 0.0, zero_stack, 1.0, int_stack+442475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+307965,int_stack+307545, 0.0, zero_stack, 1.0, int_stack+442790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 0.0, zero_stack, 1.0, int_stack+959317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+308505,int_stack+307965, 0.0, zero_stack, 1.0, int_stack+443210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345, 0.0, zero_stack, 1.0, int_stack+960262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+928489,int_stack+1324223,int_stack+574838, 0.0, zero_stack, 1.0, int_stack+961522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+309180,int_stack+308505, 0.0, zero_stack, 1.0, int_stack+443750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+931639,int_stack+574838,int_stack+1322603, 0.0, zero_stack, 1.0, int_stack+912607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+931639,int_stack+1324223, 0.0, zero_stack, 1.0, int_stack+967427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+877831,int_stack+928489, 0.0, zero_stack, 1.0, int_stack+969947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+297906,int_stack+127806,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+776997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+310446,int_stack+310005, 0.0, zero_stack, 1.0, int_stack+318515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412848,int_stack+311034,int_stack+310446, 0.0, zero_stack, 1.0, int_stack+319397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+928489,int_stack+412848,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+987272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+931135,int_stack+311790,int_stack+311034, 0.0, zero_stack, 1.0, int_stack+320573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+931135,int_stack+412848, 0.0, zero_stack, 1.0, int_stack+988595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+928489, 0.0, zero_stack, 1.0, int_stack+990359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+312735,int_stack+311790, 0.0, zero_stack, 1.0, int_stack+322085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+931135, 0.0, zero_stack, 1.0, int_stack+993005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+928489,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 1.0, int_stack+995273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+928489,int_stack+881359, 0.0, zero_stack, 1.0, int_stack+998801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1437893,int_stack+1322603,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+791532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+314100,int_stack+313890, 1.0, int_stack+438775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+314380,int_stack+314100, 1.0, int_stack+438985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806, 1.0, int_stack+936427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+314740,int_stack+314380, 1.0, int_stack+439265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436, 1.0, int_stack+937057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+130356,int_stack+536345, 1.0, int_stack+937897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+315190,int_stack+314740, 1.0, int_stack+439625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+129276, 1.0, int_stack+939157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+130356, 1.0, int_stack+940237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1324763,int_stack+574838, 1.0, int_stack+957217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+316055,int_stack+315740, 1.0, int_stack+442475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+316475,int_stack+316055, 1.0, int_stack+442790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+957217,int_stack+536345,int_stack+19341, 1.0, int_stack+959317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+574838,int_stack+317015,int_stack+316475, 1.0, int_stack+443210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+574838,int_stack+536345, 1.0, int_stack+960262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1325123,int_stack+1322603,int_stack+957217, 1.0, int_stack+961522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+957217,int_stack+317690,int_stack+317015, 1.0, int_stack+443750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+959242,int_stack+957217,int_stack+574838, 1.0, int_stack+912607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+928489,int_stack+959242,int_stack+1322603, 1.0, int_stack+967427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+928489,int_stack+1325123, 1.0, int_stack+969947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+928489,int_stack+411525,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+847396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+319985,int_stack+318956, 1.0, int_stack+318515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+129129,int_stack+321329,int_stack+319985, 1.0, int_stack+319397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+937939,int_stack+129129,int_stack+127806, 1.0, int_stack+987272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+940585,int_stack+323030,int_stack+321329, 1.0, int_stack+320573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+967427,int_stack+940585,int_stack+129129, 1.0, int_stack+988595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127806,int_stack+967427,int_stack+937939, 1.0, int_stack+990359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+987272,int_stack+323975,int_stack+323030, 1.0, int_stack+322085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+987272,int_stack+940585, 1.0, int_stack+993005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+987272,int_stack+1322603,int_stack+967427, 1.0, int_stack+995273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+987272,int_stack+127806, 1.0, int_stack+998801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+987272,int_stack+1322603,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+863656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+325340,int_stack+325130,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+325620,int_stack+325340,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+412155,int_stack+411525,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+412995,int_stack+325980,int_stack+325620,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+414075,int_stack+412995,int_stack+412155,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+414075,int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+326430,int_stack+325980,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+412995,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+414075,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+1324763,int_stack+574838,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+327295,int_stack+326980,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+327715,int_stack+327295,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+328255,int_stack+327715,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+127806,int_stack+1324223,int_stack+574838,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+328930,int_stack+328255,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+967427,int_stack+574838,int_stack+1322603,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+937939,int_stack+967427,int_stack+1324223,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+967427,int_stack+937939,int_stack+127806,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+307356,int_stack+967427,int_stack+411525, 0.0, zero_stack, 1.0, int_stack+491273, 1.0, int_stack+964277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+330196,int_stack+329755,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1001447,int_stack+330784,int_stack+330196,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+412848,int_stack+1001447,int_stack+411525,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+127806,int_stack+331540,int_stack+330784,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+937939,int_stack+127806,int_stack+1001447,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1322603,int_stack+937939,int_stack+412848,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+332485,int_stack+331540,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+957217,int_stack+411525,int_stack+127806,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+957217,int_stack+937939,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+877831,int_stack+1322603,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+316806,int_stack+1065563,int_stack+967427, 0.0, zero_stack, 1.0, int_stack+914314, 1.0, int_stack+973097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+967427,int_stack+333850,int_stack+333640,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+968057,int_stack+334130,int_stack+333850,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+968057,int_stack+967427,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+968897,int_stack+334490,int_stack+334130,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+969977,int_stack+968897,int_stack+968057,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+969977,int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+967427,int_stack+334940,int_stack+334490,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+967427,int_stack+968897,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1067723,int_stack+1065563,int_stack+969977,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+967427,int_stack+1067723,int_stack+574838,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+335805,int_stack+335490,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+336225,int_stack+335805,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+336765,int_stack+336225,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+970577,int_stack+1065563,int_stack+536345,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1067183,int_stack+970577,int_stack+574838,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+337440,int_stack+336765,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+574838,int_stack+1065563,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+1322603,int_stack+970577,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+877831,int_stack+1067183,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1452068,int_stack+127806,int_stack+967427, 0.0, zero_stack, 2.0, int_stack+964277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+967427,int_stack+338706,int_stack+338265,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1001447,int_stack+339294,int_stack+338706,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+968750,int_stack+1001447,int_stack+967427,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+877831,int_stack+340050,int_stack+339294,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+880099,int_stack+877831,int_stack+1001447,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1322603,int_stack+880099,int_stack+968750,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+967427,int_stack+340995,int_stack+340050,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+967427,int_stack+877831,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+957217,int_stack+1065563,int_stack+880099,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+957217,int_stack+1322603,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1461518,int_stack+1065563,int_stack+127806, 0.0, zero_stack, 2.0, int_stack+973097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+344210,int_stack+344000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453760,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+344490,int_stack+344210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453970,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003211,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+344850,int_stack+344490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454250,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003841,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+130356,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004681,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+345300,int_stack+344850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454610,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+127806,int_stack+129276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1005941,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1067723,int_stack+1065563,int_stack+130356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1007021,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1067723,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7791,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+348940,int_stack+348625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457460,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+349360,int_stack+348940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457775,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1027151,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+349900,int_stack+349360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458195,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1028096,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1322603,int_stack+1067183,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1029356,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+350575,int_stack+349900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1325753,int_stack+574838,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1031246,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+957217,int_stack+1325753,int_stack+1067183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1032866,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+957217,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1035386,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+330981,int_stack+411525,int_stack+127806, 1.0, int_stack+482075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+351841,int_stack+351400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419025,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1001447,int_stack+352429,int_stack+351841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419907,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+129129,int_stack+1001447,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885769,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+353185,int_stack+352429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421083,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324871,int_stack+1322603,int_stack+1001447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887092,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+957217,int_stack+1324871,int_stack+129129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052711,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+354130,int_stack+353185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422595,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+127806,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1055357,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+1065563,int_stack+1324871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057625,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+877831,int_stack+957217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061153,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+476345,int_stack+1065563,int_stack+411525, 1.0, int_stack+507995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+357345,int_stack+357135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453760, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+357625,int_stack+357345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453970, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+412155,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003211, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412995,int_stack+357985,int_stack+357625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454250, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414075,int_stack+412995,int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003841, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574838,int_stack+414075,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004681, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+358435,int_stack+357985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454610, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+411525,int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1005941, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1067723,int_stack+1065563,int_stack+414075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1007021, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+1067723,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7791, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+362075,int_stack+361760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457460, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+362495,int_stack+362075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457775, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+574838,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1027151, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+363035,int_stack+362495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458195, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1028096, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+957217,int_stack+1067183,int_stack+574838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1029356, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+574838,int_stack+363710,int_stack+363035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+960367,int_stack+574838,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1031246, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+960367,int_stack+1067183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1032866, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+877831,int_stack+957217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1035386, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+340431,int_stack+127806,int_stack+411525, 1.0, int_stack+576938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+364976,int_stack+364535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419025, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1001447,int_stack+365564,int_stack+364976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419907, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+412848,int_stack+1001447,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885769, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+957217,int_stack+366320,int_stack+365564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421083, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+959485,int_stack+957217,int_stack+1001447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887092, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+877831,int_stack+959485,int_stack+412848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052711, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+367265,int_stack+366320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422595, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+411525,int_stack+957217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1055357, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+1065563,int_stack+959485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057625, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061153, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+349881,int_stack+1065563,int_stack+127806, 1.0, int_stack+591473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+370480,int_stack+370270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453760, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+370760,int_stack+370480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453970, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003211, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+371120,int_stack+370760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454250, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003841, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+774897,int_stack+130356,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004681, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+371570,int_stack+371120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454610, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+127806,int_stack+129276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1005941, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1067723,int_stack+1065563,int_stack+130356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1007021, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1067723,int_stack+774897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7791, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+375210,int_stack+374895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457460, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+375630,int_stack+375210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457775, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+774897,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1027151, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+376170,int_stack+375630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458195, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1028096, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+877831,int_stack+1067183,int_stack+774897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1029356, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+774897,int_stack+376845,int_stack+376170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+880981,int_stack+774897,int_stack+1065563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1031246, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+880981,int_stack+1067183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1032866, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1035386, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+364056,int_stack+411525,int_stack+127806, 1.0, int_stack+642377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+642377,int_stack+378111,int_stack+377670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419025, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1001447,int_stack+378699,int_stack+378111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419907, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127806,int_stack+1001447,int_stack+642377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885769, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+642377,int_stack+379455,int_stack+378699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421083, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+642377,int_stack+1001447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887092, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+127806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052711, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+380400,int_stack+379455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422595, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+642377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1055357, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057625, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+1065563,int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061153, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1475693,int_stack+1322603,int_stack+411525, 1.0, int_stack+656912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+383615,int_stack+383405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+383895,int_stack+383615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+412155,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412995,int_stack+384255,int_stack+383895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414075,int_stack+412995,int_stack+412155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1003841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+774897,int_stack+414075,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+384705,int_stack+384255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+411525,int_stack+412995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1005941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1324763,int_stack+1322603,int_stack+414075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1007021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+642377,int_stack+1324763,int_stack+774897, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+388345,int_stack+388030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+388765,int_stack+388345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+774897,int_stack+536345,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1027151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1322603,int_stack+389305,int_stack+388765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1324223,int_stack+1322603,int_stack+536345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1028096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+411525,int_stack+1324223,int_stack+774897, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1029356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+774897,int_stack+389980,int_stack+389305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+774897,int_stack+1322603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1031246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+1065563,int_stack+1324223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1032866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+877831,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1035386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+373506,int_stack+127806,int_stack+642377, 1.0, int_stack+714876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+642377,int_stack+391246,int_stack+390805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1001447,int_stack+391834,int_stack+391246, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+411525,int_stack+1001447,int_stack+642377, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+642377,int_stack+392590,int_stack+391834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+642377,int_stack+1001447, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+411525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+393535,int_stack+392590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+411525,int_stack+642377, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1055357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1322603,int_stack+1065563,int_stack+877831, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+881359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+707816,int_stack+1065563,int_stack+127806, 1.0, int_stack+725316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+396750,int_stack+396540, 0.0, zero_stack, 1.0, int_stack+453760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+397030,int_stack+396750, 0.0, zero_stack, 1.0, int_stack+453970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+1003211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+397390,int_stack+397030, 0.0, zero_stack, 1.0, int_stack+454250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436, 0.0, zero_stack, 1.0, int_stack+1003841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+774897,int_stack+130356,int_stack+536345, 0.0, zero_stack, 1.0, int_stack+1004681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+397840,int_stack+397390, 0.0, zero_stack, 1.0, int_stack+454610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065563,int_stack+127806,int_stack+129276, 0.0, zero_stack, 1.0, int_stack+1005941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1067723,int_stack+1065563,int_stack+130356, 0.0, zero_stack, 1.0, int_stack+1007021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+642377,int_stack+1067723,int_stack+774897, 0.0, zero_stack, 1.0, int_stack+7791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+401480,int_stack+401165, 0.0, zero_stack, 1.0, int_stack+457460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+401900,int_stack+401480, 0.0, zero_stack, 1.0, int_stack+457775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+774897,int_stack+536345,int_stack+19341, 0.0, zero_stack, 1.0, int_stack+1027151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1065563,int_stack+402440,int_stack+401900, 0.0, zero_stack, 1.0, int_stack+458195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1067183,int_stack+1065563,int_stack+536345, 0.0, zero_stack, 1.0, int_stack+1028096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127806,int_stack+1067183,int_stack+774897, 0.0, zero_stack, 1.0, int_stack+1029356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+774897,int_stack+403115,int_stack+402440, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+774897,int_stack+1065563, 0.0, zero_stack, 1.0, int_stack+1031246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+1322603,int_stack+1067183, 0.0, zero_stack, 1.0, int_stack+1032866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411525,int_stack+877831,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+1035386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+382956,int_stack+411525,int_stack+642377, 1.0, int_stack+776997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+642377,int_stack+404381,int_stack+403940, 0.0, zero_stack, 1.0, int_stack+419025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1001447,int_stack+404969,int_stack+404381, 0.0, zero_stack, 1.0, int_stack+419907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127806,int_stack+1001447,int_stack+642377, 0.0, zero_stack, 1.0, int_stack+885769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+642377,int_stack+405725,int_stack+404969, 0.0, zero_stack, 1.0, int_stack+421083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877831,int_stack+642377,int_stack+1001447, 0.0, zero_stack, 1.0, int_stack+887092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881359,int_stack+877831,int_stack+127806, 0.0, zero_stack, 1.0, int_stack+1052711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+406670,int_stack+405725, 0.0, zero_stack, 1.0, int_stack+422595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+642377, 0.0, zero_stack, 1.0, int_stack+1055357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+1322603,int_stack+877831, 0.0, zero_stack, 1.0, int_stack+1057625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+1065563,int_stack+881359, 0.0, zero_stack, 1.0, int_stack+1061153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+392406,int_stack+1322603,int_stack+411525, 1.0, int_stack+791532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411525,int_stack+409885,int_stack+409675, 1.0, int_stack+453760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412155,int_stack+410165,int_stack+409885, 1.0, int_stack+453970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+412155,int_stack+411525, 1.0, int_stack+1003211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412995,int_stack+410525,int_stack+410165, 1.0, int_stack+454250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414075,int_stack+412995,int_stack+412155, 1.0, int_stack+1003841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1322603,int_stack+414075,int_stack+536345, 1.0, int_stack+1004681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411525,int_stack+410975,int_stack+410525, 1.0, int_stack+454610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1324703,int_stack+411525,int_stack+412995, 1.0, int_stack+1005941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+1324703,int_stack+414075, 1.0, int_stack+1007021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+642377,int_stack+1065563,int_stack+1322603, 1.0, int_stack+7791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+416565,int_stack+416250, 1.0, int_stack+457460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+416985,int_stack+416565, 1.0, int_stack+457775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1322603,int_stack+536345,int_stack+19341, 1.0, int_stack+1027151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1324493,int_stack+417525,int_stack+416985, 1.0, int_stack+458195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1326113,int_stack+1324493,int_stack+536345, 1.0, int_stack+1028096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1065563,int_stack+1326113,int_stack+1322603, 1.0, int_stack+1029356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1027151,int_stack+418200,int_stack+417525, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1068713,int_stack+1027151,int_stack+1324493, 1.0, int_stack+1031246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1027151,int_stack+1068713,int_stack+1326113, 1.0, int_stack+1032866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1027151,int_stack+1065563, 1.0, int_stack+1035386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1027151,int_stack+127806,int_stack+642377, 1.0, int_stack+847396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+642377,int_stack+420495,int_stack+419466, 1.0, int_stack+419025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+643700,int_stack+421839,int_stack+420495, 1.0, int_stack+419907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065563,int_stack+643700,int_stack+642377, 1.0, int_stack+885769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068209,int_stack+423540,int_stack+421839, 1.0, int_stack+421083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+1068209,int_stack+643700, 1.0, int_stack+887092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+877831,int_stack+1322603,int_stack+1065563, 1.0, int_stack+1052711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+642377,int_stack+424485,int_stack+423540, 1.0, int_stack+422595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+882241,int_stack+642377,int_stack+1068209, 1.0, int_stack+1055357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1065563,int_stack+882241,int_stack+1322603, 1.0, int_stack+1057625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+1065563,int_stack+877831, 1.0, int_stack+1061153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1052711,int_stack+1322603,int_stack+127806, 1.0, int_stack+863656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+427700,int_stack+427490,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+427980,int_stack+427700,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+428340,int_stack+427980,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1322603,int_stack+130356,int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+428790,int_stack+428340,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1324703,int_stack+127806,int_stack+129276,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+877831,int_stack+1324703,int_stack+130356,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+642377,int_stack+877831,int_stack+1322603,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+432430,int_stack+432115,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+432850,int_stack+432430,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1322603,int_stack+536345,int_stack+19341,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1324493,int_stack+433390,int_stack+432850,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1326113,int_stack+1324493,int_stack+536345,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+877831,int_stack+1326113,int_stack+1322603,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+880981,int_stack+434065,int_stack+433390,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+883006,int_stack+880981,int_stack+1324493,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+127806,int_stack+883006,int_stack+1326113,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+880981,int_stack+127806,int_stack+877831,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+0,int_stack+880981,int_stack+642377, 1.0, int_stack+491273, 0.0, zero_stack, 1.0, int_stack+1024001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+642377,int_stack+435331,int_stack+434890,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+643700,int_stack+435919,int_stack+435331,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+877831,int_stack+643700,int_stack+642377,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+127806,int_stack+436675,int_stack+435919,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+127806,int_stack+643700,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1066886,int_stack+1322603,int_stack+877831,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+877831,int_stack+437620,int_stack+436675,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1001447,int_stack+877831,int_stack+127806,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+957217,int_stack+1001447,int_stack+1322603,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+957217,int_stack+1066886,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+406581,int_stack+1322603,int_stack+880981, 1.0, int_stack+914314, 0.0, zero_stack, 1.0, int_stack+1038536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1322603,int_stack+440835,int_stack+440625,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1323233,int_stack+441115,int_stack+440835,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+1323233,int_stack+1322603,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1324073,int_stack+441475,int_stack+441115,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1325153,int_stack+1324073,int_stack+1323233,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1326833,int_stack+1325153,int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1322603,int_stack+441925,int_stack+441475,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1066886,int_stack+1322603,int_stack+1324073,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1069046,int_stack+1066886,int_stack+1325153,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+642377,int_stack+1069046,int_stack+1326833,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+445565,int_stack+445250,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+445985,int_stack+445565,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1066886,int_stack+536345,int_stack+19341,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1068776,int_stack+446525,int_stack+445985,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+1068776,int_stack+536345,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1325123,int_stack+1322603,int_stack+1066886,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+957217,int_stack+447200,int_stack+446525,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+959242,int_stack+957217,int_stack+1068776,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1066886,int_stack+959242,int_stack+1322603,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1066886,int_stack+1325123,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+877831,int_stack+127806,int_stack+642377, 1.0, int_stack+964277, 1.0, int_stack+1024001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+642377,int_stack+448466,int_stack+448025,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+643700,int_stack+449054,int_stack+448466,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1066886,int_stack+643700,int_stack+642377,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1069532,int_stack+449810,int_stack+449054,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1322603,int_stack+1069532,int_stack+643700,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+957217,int_stack+1322603,int_stack+1066886,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+642377,int_stack+450755,int_stack+449810,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+961627,int_stack+642377,int_stack+1069532,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+966163,int_stack+961627,int_stack+1322603,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+966163,int_stack+957217,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+957217,int_stack+1322603,int_stack+127806, 1.0, int_stack+973097, 1.0, int_stack+1038536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+127806,int_stack+455820,int_stack+455610,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+128436,int_stack+456100,int_stack+455820,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+536345,int_stack+128436,int_stack+127806,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+129276,int_stack+456460,int_stack+456100,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+130356,int_stack+129276,int_stack+128436,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1322603,int_stack+130356,int_stack+536345,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+127806,int_stack+456910,int_stack+456460,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1324703,int_stack+127806,int_stack+129276,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+971392,int_stack+1324703,int_stack+130356,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+642377,int_stack+971392,int_stack+1322603,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19341,int_stack+460550,int_stack+460235,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+536345,int_stack+460970,int_stack+460550,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1322603,int_stack+536345,int_stack+19341,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1324493,int_stack+461510,int_stack+460970,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1326113,int_stack+1324493,int_stack+536345,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+971392,int_stack+1326113,int_stack+1322603,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+974542,int_stack+462185,int_stack+461510,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+127806,int_stack+974542,int_stack+1324493,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1066886,int_stack+127806,int_stack+1326113,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+127806,int_stack+1066886,int_stack+971392,15);
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+420756,int_stack+127806,int_stack+642377, 2.0, int_stack+1024001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1024001,int_stack+463451,int_stack+463010,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1025324,int_stack+464039,int_stack+463451,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+642377,int_stack+1025324,int_stack+1024001,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+971392,int_stack+464795,int_stack+464039,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+973660,int_stack+971392,int_stack+1025324,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1066886,int_stack+973660,int_stack+642377,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+642377,int_stack+465740,int_stack+464795,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1322603,int_stack+642377,int_stack+971392,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1001447,int_stack+1322603,int_stack+973660,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1322603,int_stack+1001447,int_stack+1066886,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+430206,int_stack+1322603,int_stack+127806, 2.0, int_stack+1038536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+444381,int_stack+560663,int_stack+512720,315);
     Libderiv->ABCD[11] = int_stack + 444381;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+551780,int_stack+628202,int_stack+596198,315);
     Libderiv->ABCD[10] = int_stack + 551780;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+619823,int_stack+693641,int_stack+661637,315);
     Libderiv->ABCD[9] = int_stack + 619823;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+685262,int_stack+760722,int_stack+730041,315);
     Libderiv->ABCD[8] = int_stack + 685262;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+753666,int_stack+828261,int_stack+796257,315);
     Libderiv->ABCD[7] = int_stack + 753666;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+819882,int_stack+522170,int_stack+868381,315);
     Libderiv->ABCD[6] = int_stack + 819882;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1489868,int_stack+943042,int_stack+919039, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+888919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[2] = int_stack + 1489868;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+937939,int_stack+1009826,int_stack+977822, 0.0, zero_stack, 1.0, int_stack+888919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[1] = int_stack + 937939;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1001447,int_stack+1072178,int_stack+1043261, 1.0, int_stack+888919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[0] = int_stack + 1001447;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1066886,int_stack+1095803,int_stack+1086353,315);
     Libderiv->ABCD[155] = int_stack + 1066886;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1085786,int_stack+1119428,int_stack+1109978,315);
     Libderiv->ABCD[143] = int_stack + 1085786;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1104686,int_stack+1133603,int_stack+20286,315);
     Libderiv->ABCD[142] = int_stack + 1104686;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1123586,int_stack+1147778,int_stack+9891,315);
     Libderiv->ABCD[131] = int_stack + 1123586;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1142486,int_stack+1161953,int_stack+40761,315);
     Libderiv->ABCD[130] = int_stack + 1142486;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+9450,int_stack+1185578,int_stack+1176128,315);
     Libderiv->ABCD[129] = int_stack + 9450;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1161386,int_stack+1199753,int_stack+29736,315);
     Libderiv->ABCD[119] = int_stack + 1161386;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1180286,int_stack+64911,int_stack+55461,315);
     Libderiv->ABCD[118] = int_stack + 1180286;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+28350,int_stack+1223378,int_stack+1213928,315);
     Libderiv->ABCD[117] = int_stack + 28350;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1199186,int_stack+1247003,int_stack+1237553,315);
     Libderiv->ABCD[116] = int_stack + 1199186;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1218086,int_stack+1270628,int_stack+1261178,315);
     Libderiv->ABCD[107] = int_stack + 1218086;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1236986,int_stack+1284803,int_stack+89481,315);
     Libderiv->ABCD[106] = int_stack + 1236986;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1255886,int_stack+98931,int_stack+79086,315);
     Libderiv->ABCD[105] = int_stack + 1255886;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1274786,int_stack+1308428,int_stack+1298978,315);
     Libderiv->ABCD[104] = int_stack + 1274786;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1293686,int_stack+1329218,int_stack+118356,315);
     Libderiv->ABCD[103] = int_stack + 1293686;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1312586,int_stack+537605,int_stack+132531,315);
     Libderiv->ABCD[95] = int_stack + 1312586;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+522170,int_stack+605648,int_stack+580088,315);
     Libderiv->ABCD[94] = int_stack + 522170;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+47250,int_stack+671087,int_stack+645527,315);
     Libderiv->ABCD[93] = int_stack + 47250;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+638723,int_stack+739491,int_stack+141981,315);
     Libderiv->ABCD[92] = int_stack + 638723;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+66150,int_stack+805707,int_stack+780147,315);
     Libderiv->ABCD[91] = int_stack + 66150;
 /*--- compute (fd|hg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+772566,int_stack+160881,int_stack+151431,315);
     Libderiv->ABCD[90] = int_stack + 772566;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+85050,int_stack+175056,int_stack+850546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[47] = int_stack + 85050;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+838782,int_stack+198681,int_stack+189231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[46] = int_stack + 838782;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+103950,int_stack+1343393,int_stack+212856, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[45] = int_stack + 103950;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1331486,int_stack+1357568,int_stack+222306, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[44] = int_stack + 1331486;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1350386,int_stack+1371743,int_stack+231756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[43] = int_stack + 1350386;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+122850,int_stack+898369,int_stack+494423, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+868381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[42] = int_stack + 122850;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+887281,int_stack+241206,int_stack+466895, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+919039, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[38] = int_stack + 887281;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+490520,int_stack+264831,int_stack+255381, 0.0, zero_stack, 1.0, int_stack+512720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[35] = int_stack + 490520;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+141750,int_stack+1395368,int_stack+1385918, 0.0, zero_stack, 1.0, int_stack+596198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[34] = int_stack + 141750;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1369286,int_stack+1409543,int_stack+279006, 0.0, zero_stack, 1.0, int_stack+661637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[33] = int_stack + 1369286;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1388186,int_stack+1423718,int_stack+288456, 0.0, zero_stack, 1.0, int_stack+730041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[32] = int_stack + 1388186;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1407086,int_stack+1437893,int_stack+297906, 0.0, zero_stack, 1.0, int_stack+796257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[31] = int_stack + 1407086;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1425986,int_stack+987272,int_stack+928489, 0.0, zero_stack, 1.0, int_stack+868381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[30] = int_stack + 1425986;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+160650,int_stack+316806,int_stack+307356, 0.0, zero_stack, 1.0, int_stack+919039, 1.0, int_stack+977822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[26] = int_stack + 160650;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+179550,int_stack+1461518,int_stack+1452068, 0.0, zero_stack, 2.0, int_stack+977822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[25] = int_stack + 179550;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1444886,int_stack+476345,int_stack+330981, 1.0, int_stack+512720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[23] = int_stack + 1444886;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+198450,int_stack+349881,int_stack+340431, 1.0, int_stack+596198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[22] = int_stack + 198450;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+217350,int_stack+1475693,int_stack+364056, 1.0, int_stack+661637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[21] = int_stack + 217350;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1463786,int_stack+707816,int_stack+373506, 1.0, int_stack+730041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[20] = int_stack + 1463786;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+704162,int_stack+392406,int_stack+382956, 1.0, int_stack+796257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[19] = int_stack + 704162;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+791466,int_stack+1052711,int_stack+1027151, 1.0, int_stack+868381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[18] = int_stack + 791466;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1020347,int_stack+406581,int_stack+0, 1.0, int_stack+919039, 0.0, zero_stack, 1.0, int_stack+1043261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[14] = int_stack + 1020347;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+906181,int_stack+957217,int_stack+877831, 1.0, int_stack+977822, 1.0, int_stack+1043261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[13] = int_stack + 906181;
 /*--- compute (fd|hg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+956839,int_stack+430206,int_stack+420756, 2.0, int_stack+1043261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[12] = int_stack + 956839;

}
