/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fphh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fp|hh) integrals */

void d12hrr_order_fphh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][10][11] = int_stack + 0;
 Libderiv->deriv_classes[4][10][10] = int_stack + 990;
 Libderiv->deriv_classes[4][10][9] = int_stack + 1980;
 Libderiv->deriv_classes[4][10][8] = int_stack + 2970;
 Libderiv->deriv_classes[4][10][7] = int_stack + 3960;
 Libderiv->dvrr_classes[4][9] = int_stack + 4950;
 Libderiv->deriv_classes[4][10][6] = int_stack + 5775;
 Libderiv->deriv_classes[4][10][2] = int_stack + 6765;
 Libderiv->deriv_classes[4][10][1] = int_stack + 7755;
 Libderiv->dvrr_classes[3][10] = int_stack + 8745;
 Libderiv->deriv_classes[4][10][0] = int_stack + 9405;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 10395;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 10605;
 Libderiv->deriv2_classes[3][7][143] = int_stack + 10885;
 Libderiv->deriv2_classes[3][8][143] = int_stack + 11245;
 Libderiv->deriv2_classes[3][9][143] = int_stack + 11695;
 Libderiv->deriv2_classes[3][10][143] = int_stack + 12245;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 12905;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 13220;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 13640;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 14180;
 Libderiv->deriv2_classes[4][9][143] = int_stack + 14855;
 Libderiv->deriv2_classes[4][10][143] = int_stack + 15680;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 16670;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 16880;
 Libderiv->deriv2_classes[3][7][131] = int_stack + 17160;
 Libderiv->deriv2_classes[3][8][131] = int_stack + 17520;
 Libderiv->deriv2_classes[3][9][131] = int_stack + 17970;
 Libderiv->deriv2_classes[3][10][131] = int_stack + 18520;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 19180;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 19495;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 19915;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 20455;
 Libderiv->deriv2_classes[4][9][131] = int_stack + 21130;
 Libderiv->deriv2_classes[4][10][131] = int_stack + 21955;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 22945;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 23155;
 Libderiv->deriv2_classes[3][7][130] = int_stack + 23435;
 Libderiv->deriv2_classes[3][8][130] = int_stack + 23795;
 Libderiv->deriv2_classes[3][9][130] = int_stack + 24245;
 Libderiv->deriv2_classes[3][10][130] = int_stack + 24795;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 25455;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 25770;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 26190;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 26730;
 Libderiv->deriv2_classes[4][9][130] = int_stack + 27405;
 Libderiv->deriv2_classes[4][10][130] = int_stack + 28230;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 29220;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 29430;
 Libderiv->deriv2_classes[3][7][119] = int_stack + 29710;
 Libderiv->deriv2_classes[3][8][119] = int_stack + 30070;
 Libderiv->deriv2_classes[3][9][119] = int_stack + 30520;
 Libderiv->deriv2_classes[3][10][119] = int_stack + 31070;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 31730;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 32045;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 32465;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 33005;
 Libderiv->deriv2_classes[4][9][119] = int_stack + 33680;
 Libderiv->deriv2_classes[4][10][119] = int_stack + 34505;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 35495;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 35705;
 Libderiv->deriv2_classes[3][7][118] = int_stack + 35985;
 Libderiv->deriv2_classes[3][8][118] = int_stack + 36345;
 Libderiv->deriv2_classes[3][9][118] = int_stack + 36795;
 Libderiv->deriv2_classes[3][10][118] = int_stack + 37345;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 38005;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 38320;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 38740;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 39280;
 Libderiv->deriv2_classes[4][9][118] = int_stack + 39955;
 Libderiv->deriv2_classes[4][10][118] = int_stack + 40780;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 41770;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 41980;
 Libderiv->deriv2_classes[3][7][117] = int_stack + 42260;
 Libderiv->deriv2_classes[3][8][117] = int_stack + 42620;
 Libderiv->deriv2_classes[3][9][117] = int_stack + 43070;
 Libderiv->deriv2_classes[3][10][117] = int_stack + 43620;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 44280;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 44595;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 45015;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 45555;
 Libderiv->deriv2_classes[4][9][117] = int_stack + 46230;
 Libderiv->deriv2_classes[4][10][117] = int_stack + 47055;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 48045;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 48255;
 Libderiv->deriv2_classes[3][7][107] = int_stack + 48535;
 Libderiv->deriv2_classes[3][8][107] = int_stack + 48895;
 Libderiv->deriv2_classes[3][9][107] = int_stack + 49345;
 Libderiv->deriv2_classes[3][10][107] = int_stack + 49895;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 50555;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 50870;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 51290;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 51830;
 Libderiv->deriv2_classes[4][9][107] = int_stack + 52505;
 Libderiv->deriv2_classes[4][10][107] = int_stack + 53330;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 54320;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 54530;
 Libderiv->deriv2_classes[3][7][106] = int_stack + 54810;
 Libderiv->deriv2_classes[3][8][106] = int_stack + 55170;
 Libderiv->deriv2_classes[3][9][106] = int_stack + 55620;
 Libderiv->deriv2_classes[3][10][106] = int_stack + 56170;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 56830;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 57145;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 57565;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 58105;
 Libderiv->deriv2_classes[4][9][106] = int_stack + 58780;
 Libderiv->deriv2_classes[4][10][106] = int_stack + 59605;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 60595;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 60805;
 Libderiv->deriv2_classes[3][7][105] = int_stack + 61085;
 Libderiv->deriv2_classes[3][8][105] = int_stack + 61445;
 Libderiv->deriv2_classes[3][9][105] = int_stack + 61895;
 Libderiv->deriv2_classes[3][10][105] = int_stack + 62445;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 63105;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 63420;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 63840;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 64380;
 Libderiv->deriv2_classes[4][9][105] = int_stack + 65055;
 Libderiv->deriv2_classes[4][10][105] = int_stack + 65880;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 66870;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 67080;
 Libderiv->deriv2_classes[3][7][104] = int_stack + 67360;
 Libderiv->deriv2_classes[3][8][104] = int_stack + 67720;
 Libderiv->deriv2_classes[3][9][104] = int_stack + 68170;
 Libderiv->deriv2_classes[3][10][104] = int_stack + 68720;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 69380;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 69695;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 70115;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 70655;
 Libderiv->deriv2_classes[4][9][104] = int_stack + 71330;
 Libderiv->deriv2_classes[4][10][104] = int_stack + 72155;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 73145;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 73355;
 Libderiv->deriv2_classes[3][7][95] = int_stack + 73635;
 Libderiv->deriv2_classes[3][8][95] = int_stack + 73995;
 Libderiv->deriv2_classes[3][9][95] = int_stack + 74445;
 Libderiv->deriv2_classes[3][10][95] = int_stack + 74995;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 75655;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 75970;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 76390;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 76930;
 Libderiv->deriv2_classes[4][9][95] = int_stack + 77605;
 Libderiv->deriv2_classes[4][10][95] = int_stack + 78430;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 79420;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 79630;
 Libderiv->deriv2_classes[3][7][94] = int_stack + 79910;
 Libderiv->deriv2_classes[3][8][94] = int_stack + 80270;
 Libderiv->deriv2_classes[3][9][94] = int_stack + 80720;
 Libderiv->deriv2_classes[3][10][94] = int_stack + 81270;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 81930;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 82245;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 82665;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 83205;
 Libderiv->deriv2_classes[4][9][94] = int_stack + 83880;
 Libderiv->deriv2_classes[4][10][94] = int_stack + 84705;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 85695;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 85905;
 Libderiv->deriv2_classes[3][7][93] = int_stack + 86185;
 Libderiv->deriv2_classes[3][8][93] = int_stack + 86545;
 Libderiv->deriv2_classes[3][9][93] = int_stack + 86995;
 Libderiv->deriv2_classes[3][10][93] = int_stack + 87545;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 88205;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 88520;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 88940;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 89480;
 Libderiv->deriv2_classes[4][9][93] = int_stack + 90155;
 Libderiv->deriv2_classes[4][10][93] = int_stack + 90980;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 91970;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 92180;
 Libderiv->deriv2_classes[3][7][92] = int_stack + 92460;
 Libderiv->deriv2_classes[3][8][92] = int_stack + 92820;
 Libderiv->deriv2_classes[3][9][92] = int_stack + 93270;
 Libderiv->deriv2_classes[3][10][92] = int_stack + 93820;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 94480;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 94795;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 95215;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 95755;
 Libderiv->deriv2_classes[4][9][92] = int_stack + 96430;
 Libderiv->deriv2_classes[4][10][92] = int_stack + 97255;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 98245;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 98455;
 Libderiv->deriv2_classes[3][7][91] = int_stack + 98735;
 Libderiv->deriv2_classes[3][8][91] = int_stack + 99095;
 Libderiv->deriv2_classes[3][9][91] = int_stack + 99545;
 Libderiv->deriv2_classes[3][10][91] = int_stack + 100095;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 100755;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 101070;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 101490;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 102030;
 Libderiv->deriv2_classes[4][9][91] = int_stack + 102705;
 Libderiv->deriv2_classes[4][10][91] = int_stack + 103530;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 104520;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 104730;
 Libderiv->deriv2_classes[3][7][83] = int_stack + 105010;
 Libderiv->deriv2_classes[3][8][83] = int_stack + 105370;
 Libderiv->deriv2_classes[3][9][83] = int_stack + 105820;
 Libderiv->deriv2_classes[3][10][83] = int_stack + 106370;
 Libderiv->deriv_classes[4][5][11] = int_stack + 107030;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 107345;
 Libderiv->deriv_classes[4][6][11] = int_stack + 107660;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 108080;
 Libderiv->deriv_classes[4][7][11] = int_stack + 108500;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 109040;
 Libderiv->deriv_classes[4][8][11] = int_stack + 109580;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 110255;
 Libderiv->deriv_classes[4][9][11] = int_stack + 110930;
 Libderiv->deriv2_classes[4][9][83] = int_stack + 111755;
 Libderiv->deriv2_classes[4][10][83] = int_stack + 112580;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 113570;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 113780;
 Libderiv->deriv2_classes[3][7][82] = int_stack + 114060;
 Libderiv->deriv2_classes[3][8][82] = int_stack + 114420;
 Libderiv->deriv2_classes[3][9][82] = int_stack + 114870;
 Libderiv->deriv2_classes[3][10][82] = int_stack + 115420;
 Libderiv->deriv_classes[4][5][10] = int_stack + 116080;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 116395;
 Libderiv->deriv_classes[4][6][10] = int_stack + 116710;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 117130;
 Libderiv->deriv_classes[4][7][10] = int_stack + 117550;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 118090;
 Libderiv->deriv_classes[4][8][10] = int_stack + 118630;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 119305;
 Libderiv->deriv_classes[4][9][10] = int_stack + 119980;
 Libderiv->deriv2_classes[4][9][82] = int_stack + 120805;
 Libderiv->deriv2_classes[4][10][82] = int_stack + 121630;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 122620;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 122830;
 Libderiv->deriv2_classes[3][7][81] = int_stack + 123110;
 Libderiv->deriv2_classes[3][8][81] = int_stack + 123470;
 Libderiv->deriv2_classes[3][9][81] = int_stack + 123920;
 Libderiv->deriv2_classes[3][10][81] = int_stack + 124470;
 Libderiv->deriv_classes[4][5][9] = int_stack + 125130;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 125445;
 Libderiv->deriv_classes[4][6][9] = int_stack + 125760;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 126180;
 Libderiv->deriv_classes[4][7][9] = int_stack + 126600;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 127140;
 Libderiv->deriv_classes[4][8][9] = int_stack + 127680;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 128355;
 Libderiv->deriv_classes[4][9][9] = int_stack + 129030;
 Libderiv->deriv2_classes[4][9][81] = int_stack + 129855;
 Libderiv->deriv2_classes[4][10][81] = int_stack + 130680;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 131670;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 131880;
 Libderiv->deriv2_classes[3][7][80] = int_stack + 132160;
 Libderiv->deriv2_classes[3][8][80] = int_stack + 132520;
 Libderiv->deriv2_classes[3][9][80] = int_stack + 132970;
 Libderiv->deriv2_classes[3][10][80] = int_stack + 133520;
 Libderiv->deriv_classes[4][5][8] = int_stack + 134180;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 134495;
 Libderiv->deriv_classes[4][6][8] = int_stack + 134810;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 135230;
 Libderiv->deriv_classes[4][7][8] = int_stack + 135650;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 136190;
 Libderiv->deriv_classes[4][8][8] = int_stack + 136730;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 137405;
 Libderiv->deriv_classes[4][9][8] = int_stack + 138080;
 Libderiv->deriv2_classes[4][9][80] = int_stack + 138905;
 Libderiv->deriv2_classes[4][10][80] = int_stack + 139730;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 140720;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 140930;
 Libderiv->deriv2_classes[3][7][79] = int_stack + 141210;
 Libderiv->deriv2_classes[3][8][79] = int_stack + 141570;
 Libderiv->deriv2_classes[3][9][79] = int_stack + 142020;
 Libderiv->deriv2_classes[3][10][79] = int_stack + 142570;
 Libderiv->deriv_classes[4][5][7] = int_stack + 143230;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 143545;
 Libderiv->deriv_classes[4][6][7] = int_stack + 143860;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 144280;
 Libderiv->deriv_classes[4][7][7] = int_stack + 144700;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 145240;
 Libderiv->deriv_classes[4][8][7] = int_stack + 145780;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 146455;
 Libderiv->deriv_classes[4][9][7] = int_stack + 147130;
 Libderiv->deriv2_classes[4][9][79] = int_stack + 147955;
 Libderiv->deriv2_classes[4][10][79] = int_stack + 148780;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 149770;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 149980;
 Libderiv->deriv2_classes[3][7][78] = int_stack + 150260;
 Libderiv->deriv2_classes[3][8][78] = int_stack + 150620;
 Libderiv->deriv2_classes[3][9][78] = int_stack + 151070;
 Libderiv->deriv2_classes[3][10][78] = int_stack + 151620;
 Libderiv->dvrr_classes[4][5] = int_stack + 152280;
 Libderiv->deriv_classes[4][5][6] = int_stack + 152595;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 152910;
 Libderiv->dvrr_classes[4][6] = int_stack + 153225;
 Libderiv->deriv_classes[4][6][6] = int_stack + 153645;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 154065;
 Libderiv->dvrr_classes[4][7] = int_stack + 154485;
 Libderiv->deriv_classes[4][7][6] = int_stack + 155025;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 155565;
 Libderiv->dvrr_classes[4][8] = int_stack + 156105;
 Libderiv->deriv_classes[4][8][6] = int_stack + 156780;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 157455;
 Libderiv->deriv_classes[4][9][6] = int_stack + 158130;
 Libderiv->deriv2_classes[4][9][78] = int_stack + 158955;
 Libderiv->deriv2_classes[4][10][78] = int_stack + 159780;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 160770;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 160980;
 Libderiv->deriv2_classes[3][7][35] = int_stack + 161260;
 Libderiv->deriv2_classes[3][8][35] = int_stack + 161620;
 Libderiv->deriv2_classes[3][9][35] = int_stack + 162070;
 Libderiv->deriv2_classes[3][10][35] = int_stack + 162620;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 163280;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 163595;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 164015;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 164555;
 Libderiv->deriv2_classes[4][9][35] = int_stack + 165230;
 Libderiv->deriv2_classes[4][10][35] = int_stack + 166055;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 167045;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 167255;
 Libderiv->deriv2_classes[3][7][34] = int_stack + 167535;
 Libderiv->deriv2_classes[3][8][34] = int_stack + 167895;
 Libderiv->deriv2_classes[3][9][34] = int_stack + 168345;
 Libderiv->deriv2_classes[3][10][34] = int_stack + 168895;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 169555;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 169870;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 170290;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 170830;
 Libderiv->deriv2_classes[4][9][34] = int_stack + 171505;
 Libderiv->deriv2_classes[4][10][34] = int_stack + 172330;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 173320;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 173530;
 Libderiv->deriv2_classes[3][7][33] = int_stack + 173810;
 Libderiv->deriv2_classes[3][8][33] = int_stack + 174170;
 Libderiv->deriv2_classes[3][9][33] = int_stack + 174620;
 Libderiv->deriv2_classes[3][10][33] = int_stack + 175170;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 175830;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 176145;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 176565;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 177105;
 Libderiv->deriv2_classes[4][9][33] = int_stack + 177780;
 Libderiv->deriv2_classes[4][10][33] = int_stack + 178605;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 179595;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 179805;
 Libderiv->deriv2_classes[3][7][32] = int_stack + 180085;
 Libderiv->deriv2_classes[3][8][32] = int_stack + 180445;
 Libderiv->deriv2_classes[3][9][32] = int_stack + 180895;
 Libderiv->deriv2_classes[3][10][32] = int_stack + 181445;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 182105;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 182420;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 182840;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 183380;
 Libderiv->deriv2_classes[4][9][32] = int_stack + 184055;
 Libderiv->deriv2_classes[4][10][32] = int_stack + 184880;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 185870;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 186080;
 Libderiv->deriv2_classes[3][7][31] = int_stack + 186360;
 Libderiv->deriv2_classes[3][8][31] = int_stack + 186720;
 Libderiv->deriv2_classes[3][9][31] = int_stack + 187170;
 Libderiv->deriv2_classes[3][10][31] = int_stack + 187720;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 188380;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 188695;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 189115;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 189655;
 Libderiv->deriv2_classes[4][9][31] = int_stack + 190330;
 Libderiv->deriv2_classes[4][10][31] = int_stack + 191155;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 192145;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 192355;
 Libderiv->deriv2_classes[3][7][30] = int_stack + 192635;
 Libderiv->deriv2_classes[3][8][30] = int_stack + 192995;
 Libderiv->deriv2_classes[3][9][30] = int_stack + 193445;
 Libderiv->deriv2_classes[3][10][30] = int_stack + 193995;
 Libderiv->deriv_classes[4][5][2] = int_stack + 194655;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 194970;
 Libderiv->deriv_classes[4][6][2] = int_stack + 195285;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 195705;
 Libderiv->deriv_classes[4][7][2] = int_stack + 196125;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 196665;
 Libderiv->deriv_classes[4][8][2] = int_stack + 197205;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 197880;
 Libderiv->deriv_classes[4][9][2] = int_stack + 198555;
 Libderiv->deriv2_classes[4][9][30] = int_stack + 199380;
 Libderiv->deriv2_classes[4][10][30] = int_stack + 200205;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 201195;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 201405;
 Libderiv->deriv2_classes[3][7][26] = int_stack + 201685;
 Libderiv->deriv2_classes[3][8][26] = int_stack + 202045;
 Libderiv->deriv2_classes[3][9][26] = int_stack + 202495;
 Libderiv->deriv2_classes[3][10][26] = int_stack + 203045;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 203705;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 204020;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 204440;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 204980;
 Libderiv->deriv2_classes[4][9][26] = int_stack + 205655;
 Libderiv->deriv2_classes[4][10][26] = int_stack + 206480;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 207470;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 207680;
 Libderiv->deriv2_classes[3][7][23] = int_stack + 207960;
 Libderiv->deriv2_classes[3][8][23] = int_stack + 208320;
 Libderiv->deriv2_classes[3][9][23] = int_stack + 208770;
 Libderiv->deriv2_classes[3][10][23] = int_stack + 209320;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 209980;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 210295;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 210715;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 211255;
 Libderiv->deriv2_classes[4][9][23] = int_stack + 211930;
 Libderiv->deriv2_classes[4][10][23] = int_stack + 212755;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 213745;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 213955;
 Libderiv->deriv2_classes[3][7][22] = int_stack + 214235;
 Libderiv->deriv2_classes[3][8][22] = int_stack + 214595;
 Libderiv->deriv2_classes[3][9][22] = int_stack + 215045;
 Libderiv->deriv2_classes[3][10][22] = int_stack + 215595;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 216255;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 216570;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 216990;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 217530;
 Libderiv->deriv2_classes[4][9][22] = int_stack + 218205;
 Libderiv->deriv2_classes[4][10][22] = int_stack + 219030;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 220020;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 220230;
 Libderiv->deriv2_classes[3][7][21] = int_stack + 220510;
 Libderiv->deriv2_classes[3][8][21] = int_stack + 220870;
 Libderiv->deriv2_classes[3][9][21] = int_stack + 221320;
 Libderiv->deriv2_classes[3][10][21] = int_stack + 221870;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 222530;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 222845;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 223265;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 223805;
 Libderiv->deriv2_classes[4][9][21] = int_stack + 224480;
 Libderiv->deriv2_classes[4][10][21] = int_stack + 225305;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 226295;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 226505;
 Libderiv->deriv2_classes[3][7][20] = int_stack + 226785;
 Libderiv->deriv2_classes[3][8][20] = int_stack + 227145;
 Libderiv->deriv2_classes[3][9][20] = int_stack + 227595;
 Libderiv->deriv2_classes[3][10][20] = int_stack + 228145;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 228805;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 229120;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 229540;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 230080;
 Libderiv->deriv2_classes[4][9][20] = int_stack + 230755;
 Libderiv->deriv2_classes[4][10][20] = int_stack + 231580;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 232570;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 232780;
 Libderiv->deriv2_classes[3][7][19] = int_stack + 233060;
 Libderiv->deriv2_classes[3][8][19] = int_stack + 233420;
 Libderiv->deriv2_classes[3][9][19] = int_stack + 233870;
 Libderiv->deriv2_classes[3][10][19] = int_stack + 234420;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 235080;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 235395;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 235815;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 236355;
 Libderiv->deriv2_classes[4][9][19] = int_stack + 237030;
 Libderiv->deriv2_classes[4][10][19] = int_stack + 237855;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 238845;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 239055;
 Libderiv->deriv2_classes[3][7][18] = int_stack + 239335;
 Libderiv->deriv2_classes[3][8][18] = int_stack + 239695;
 Libderiv->deriv2_classes[3][9][18] = int_stack + 240145;
 Libderiv->deriv2_classes[3][10][18] = int_stack + 240695;
 Libderiv->deriv_classes[4][5][1] = int_stack + 241355;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 241670;
 Libderiv->deriv_classes[4][6][1] = int_stack + 241985;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 242405;
 Libderiv->deriv_classes[4][7][1] = int_stack + 242825;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 243365;
 Libderiv->deriv_classes[4][8][1] = int_stack + 243905;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 244580;
 Libderiv->deriv_classes[4][9][1] = int_stack + 245255;
 Libderiv->deriv2_classes[4][9][18] = int_stack + 246080;
 Libderiv->deriv2_classes[4][10][18] = int_stack + 246905;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 247895;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 248105;
 Libderiv->deriv2_classes[3][7][14] = int_stack + 248385;
 Libderiv->deriv2_classes[3][8][14] = int_stack + 248745;
 Libderiv->deriv2_classes[3][9][14] = int_stack + 249195;
 Libderiv->deriv2_classes[3][10][14] = int_stack + 249745;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 250405;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 250720;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 251140;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 251680;
 Libderiv->deriv2_classes[4][9][14] = int_stack + 252355;
 Libderiv->deriv2_classes[4][10][14] = int_stack + 253180;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 254170;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 254380;
 Libderiv->deriv2_classes[3][7][13] = int_stack + 254660;
 Libderiv->deriv2_classes[3][8][13] = int_stack + 255020;
 Libderiv->deriv2_classes[3][9][13] = int_stack + 255470;
 Libderiv->deriv2_classes[3][10][13] = int_stack + 256020;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 256680;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 256995;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 257415;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 257955;
 Libderiv->deriv2_classes[4][9][13] = int_stack + 258630;
 Libderiv->deriv2_classes[4][10][13] = int_stack + 259455;
 Libderiv->deriv_classes[3][5][11] = int_stack + 260445;
 Libderiv->deriv_classes[3][6][11] = int_stack + 260655;
 Libderiv->deriv_classes[3][7][11] = int_stack + 260935;
 Libderiv->deriv_classes[3][8][11] = int_stack + 261295;
 Libderiv->deriv_classes[3][9][11] = int_stack + 261745;
 Libderiv->deriv_classes[3][10][11] = int_stack + 262295;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 262955;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 263165;
 Libderiv->deriv2_classes[3][7][11] = int_stack + 263445;
 Libderiv->deriv2_classes[3][8][11] = int_stack + 263805;
 Libderiv->deriv2_classes[3][9][11] = int_stack + 264255;
 Libderiv->deriv2_classes[3][10][11] = int_stack + 264805;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 265465;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 265780;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 266200;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 266740;
 Libderiv->deriv2_classes[4][9][11] = int_stack + 267415;
 Libderiv->deriv2_classes[4][10][11] = int_stack + 268240;
 Libderiv->deriv_classes[3][5][10] = int_stack + 269230;
 Libderiv->deriv_classes[3][6][10] = int_stack + 269440;
 Libderiv->deriv_classes[3][7][10] = int_stack + 269720;
 Libderiv->deriv_classes[3][8][10] = int_stack + 270080;
 Libderiv->deriv_classes[3][9][10] = int_stack + 270530;
 Libderiv->deriv_classes[3][10][10] = int_stack + 271080;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 271740;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 271950;
 Libderiv->deriv2_classes[3][7][10] = int_stack + 272230;
 Libderiv->deriv2_classes[3][8][10] = int_stack + 272590;
 Libderiv->deriv2_classes[3][9][10] = int_stack + 273040;
 Libderiv->deriv2_classes[3][10][10] = int_stack + 273590;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 274250;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 274565;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 274985;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 275525;
 Libderiv->deriv2_classes[4][9][10] = int_stack + 276200;
 Libderiv->deriv2_classes[4][10][10] = int_stack + 277025;
 Libderiv->deriv_classes[3][5][9] = int_stack + 278015;
 Libderiv->deriv_classes[3][6][9] = int_stack + 278225;
 Libderiv->deriv_classes[3][7][9] = int_stack + 278505;
 Libderiv->deriv_classes[3][8][9] = int_stack + 278865;
 Libderiv->deriv_classes[3][9][9] = int_stack + 279315;
 Libderiv->deriv_classes[3][10][9] = int_stack + 279865;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 280525;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 280735;
 Libderiv->deriv2_classes[3][7][9] = int_stack + 281015;
 Libderiv->deriv2_classes[3][8][9] = int_stack + 281375;
 Libderiv->deriv2_classes[3][9][9] = int_stack + 281825;
 Libderiv->deriv2_classes[3][10][9] = int_stack + 282375;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 283035;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 283350;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 283770;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 284310;
 Libderiv->deriv2_classes[4][9][9] = int_stack + 284985;
 Libderiv->deriv2_classes[4][10][9] = int_stack + 285810;
 Libderiv->deriv_classes[3][5][8] = int_stack + 286800;
 Libderiv->deriv_classes[3][6][8] = int_stack + 287010;
 Libderiv->deriv_classes[3][7][8] = int_stack + 287290;
 Libderiv->deriv_classes[3][8][8] = int_stack + 287650;
 Libderiv->deriv_classes[3][9][8] = int_stack + 288100;
 Libderiv->deriv_classes[3][10][8] = int_stack + 288650;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 289310;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 289520;
 Libderiv->deriv2_classes[3][7][8] = int_stack + 289800;
 Libderiv->deriv2_classes[3][8][8] = int_stack + 290160;
 Libderiv->deriv2_classes[3][9][8] = int_stack + 290610;
 Libderiv->deriv2_classes[3][10][8] = int_stack + 291160;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 291820;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 292135;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 292555;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 293095;
 Libderiv->deriv2_classes[4][9][8] = int_stack + 293770;
 Libderiv->deriv2_classes[4][10][8] = int_stack + 294595;
 Libderiv->deriv_classes[3][5][7] = int_stack + 295585;
 Libderiv->deriv_classes[3][6][7] = int_stack + 295795;
 Libderiv->deriv_classes[3][7][7] = int_stack + 296075;
 Libderiv->deriv_classes[3][8][7] = int_stack + 296435;
 Libderiv->deriv_classes[3][9][7] = int_stack + 296885;
 Libderiv->deriv_classes[3][10][7] = int_stack + 297435;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 298095;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 298305;
 Libderiv->deriv2_classes[3][7][7] = int_stack + 298585;
 Libderiv->deriv2_classes[3][8][7] = int_stack + 298945;
 Libderiv->deriv2_classes[3][9][7] = int_stack + 299395;
 Libderiv->deriv2_classes[3][10][7] = int_stack + 299945;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 300605;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 300920;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 301340;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 301880;
 Libderiv->deriv2_classes[4][9][7] = int_stack + 302555;
 Libderiv->deriv2_classes[4][10][7] = int_stack + 303380;
 Libderiv->dvrr_classes[3][5] = int_stack + 304370;
 Libderiv->deriv_classes[3][5][6] = int_stack + 304580;
 Libderiv->dvrr_classes[3][6] = int_stack + 304790;
 Libderiv->deriv_classes[3][6][6] = int_stack + 305070;
 Libderiv->dvrr_classes[3][7] = int_stack + 305350;
 Libderiv->deriv_classes[3][7][6] = int_stack + 305710;
 Libderiv->dvrr_classes[3][8] = int_stack + 306070;
 Libderiv->deriv_classes[3][8][6] = int_stack + 306520;
 Libderiv->dvrr_classes[3][9] = int_stack + 306970;
 Libderiv->deriv_classes[3][9][6] = int_stack + 307520;
 Libderiv->deriv_classes[3][10][6] = int_stack + 308070;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 308730;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 308940;
 Libderiv->deriv2_classes[3][7][6] = int_stack + 309220;
 Libderiv->deriv2_classes[3][8][6] = int_stack + 309580;
 Libderiv->deriv2_classes[3][9][6] = int_stack + 310030;
 Libderiv->deriv2_classes[3][10][6] = int_stack + 310580;
 Libderiv->deriv_classes[4][5][0] = int_stack + 311240;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 311555;
 Libderiv->deriv_classes[4][6][0] = int_stack + 311870;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 312290;
 Libderiv->deriv_classes[4][7][0] = int_stack + 312710;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 313250;
 Libderiv->deriv_classes[4][8][0] = int_stack + 313790;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 314465;
 Libderiv->deriv_classes[4][9][0] = int_stack + 315140;
 Libderiv->deriv2_classes[4][9][6] = int_stack + 315965;
 Libderiv->deriv2_classes[4][10][6] = int_stack + 316790;
 Libderiv->deriv_classes[3][5][2] = int_stack + 317780;
 Libderiv->deriv_classes[3][6][2] = int_stack + 317990;
 Libderiv->deriv_classes[3][7][2] = int_stack + 318270;
 Libderiv->deriv_classes[3][8][2] = int_stack + 318630;
 Libderiv->deriv_classes[3][9][2] = int_stack + 319080;
 Libderiv->deriv_classes[3][10][2] = int_stack + 319630;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 320290;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 320500;
 Libderiv->deriv2_classes[3][7][2] = int_stack + 320780;
 Libderiv->deriv2_classes[3][8][2] = int_stack + 321140;
 Libderiv->deriv2_classes[3][9][2] = int_stack + 321590;
 Libderiv->deriv2_classes[3][10][2] = int_stack + 322140;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 322800;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 323115;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 323535;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 324075;
 Libderiv->deriv2_classes[4][9][2] = int_stack + 324750;
 Libderiv->deriv2_classes[4][10][2] = int_stack + 325575;
 Libderiv->deriv_classes[3][5][1] = int_stack + 326565;
 Libderiv->deriv_classes[3][6][1] = int_stack + 326775;
 Libderiv->deriv_classes[3][7][1] = int_stack + 327055;
 Libderiv->deriv_classes[3][8][1] = int_stack + 327415;
 Libderiv->deriv_classes[3][9][1] = int_stack + 327865;
 Libderiv->deriv_classes[3][10][1] = int_stack + 328415;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 329075;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 329285;
 Libderiv->deriv2_classes[3][7][1] = int_stack + 329565;
 Libderiv->deriv2_classes[3][8][1] = int_stack + 329925;
 Libderiv->deriv2_classes[3][9][1] = int_stack + 330375;
 Libderiv->deriv2_classes[3][10][1] = int_stack + 330925;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 331585;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 331900;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 332320;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 332860;
 Libderiv->deriv2_classes[4][9][1] = int_stack + 333535;
 Libderiv->deriv2_classes[4][10][1] = int_stack + 334360;
 Libderiv->deriv_classes[3][5][0] = int_stack + 335350;
 Libderiv->deriv_classes[3][6][0] = int_stack + 335560;
 Libderiv->deriv_classes[3][7][0] = int_stack + 335840;
 Libderiv->deriv_classes[3][8][0] = int_stack + 336200;
 Libderiv->deriv_classes[3][9][0] = int_stack + 336650;
 Libderiv->deriv_classes[3][10][0] = int_stack + 337200;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 337860;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 338070;
 Libderiv->deriv2_classes[3][7][0] = int_stack + 338350;
 Libderiv->deriv2_classes[3][8][0] = int_stack + 338710;
 Libderiv->deriv2_classes[3][9][0] = int_stack + 339160;
 Libderiv->deriv2_classes[3][10][0] = int_stack + 339710;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 340370;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 340685;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 341105;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 341645;
 Libderiv->deriv2_classes[4][9][0] = int_stack + 342320;
 Libderiv->deriv2_classes[4][10][0] = int_stack + 343145;
 memset(int_stack,0,2753080);

 Libderiv->dvrr_stack = int_stack + 934760;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fphh(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+344135,int_stack+304790,int_stack+304370,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+344765,int_stack+305350,int_stack+304790,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+345605,int_stack+344765,int_stack+344135,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+346865,int_stack+306070,int_stack+305350,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+347945,int_stack+346865,int_stack+344765,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+349625,int_stack+347945,int_stack+345605,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+351725,int_stack+306970,int_stack+306070,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+353075,int_stack+351725,int_stack+346865,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+355235,int_stack+353075,int_stack+347945,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+358035,int_stack+355235,int_stack+349625,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+361185,int_stack+260655,int_stack+260445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304370,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+361815,int_stack+260935,int_stack+260655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304790,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+362655,int_stack+361815,int_stack+361185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344135,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+363915,int_stack+261295,int_stack+260935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305350,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+364995,int_stack+363915,int_stack+361815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344765,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+366675,int_stack+364995,int_stack+362655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345605,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+368775,int_stack+261745,int_stack+261295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306070,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+370125,int_stack+368775,int_stack+363915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346865,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+372285,int_stack+370125,int_stack+364995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347945,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+375085,int_stack+372285,int_stack+366675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349625,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+378235,int_stack+262295,int_stack+261745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306970,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+379885,int_stack+378235,int_stack+368775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351725,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+382585,int_stack+379885,int_stack+370125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353075,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+378235,int_stack+382585,int_stack+372285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355235,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+382435,int_stack+378235,int_stack+375085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358035,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+378235,int_stack+153225,int_stack+152280,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+379180,int_stack+154485,int_stack+153225,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+380440,int_stack+379180,int_stack+378235,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+386845,int_stack+156105,int_stack+154485,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+388465,int_stack+386845,int_stack+379180,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+390985,int_stack+388465,int_stack+380440,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+394135,int_stack+4950,int_stack+156105,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+396160,int_stack+394135,int_stack+386845,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+399400,int_stack+396160,int_stack+388465,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+403600,int_stack+399400,int_stack+390985,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+408325,int_stack+107660,int_stack+107030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152280,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+409270,int_stack+108500,int_stack+107660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153225,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+410530,int_stack+409270,int_stack+408325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378235,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412420,int_stack+109580,int_stack+108500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154485,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414040,int_stack+412420,int_stack+409270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379180,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+416560,int_stack+414040,int_stack+410530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380440,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+419710,int_stack+110930,int_stack+109580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156105,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+421735,int_stack+419710,int_stack+412420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+424975,int_stack+421735,int_stack+414040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388465,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+429175,int_stack+424975,int_stack+416560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390985,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+433900,int_stack+0,int_stack+110930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4950,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+436375,int_stack+433900,int_stack+419710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394135,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+440425,int_stack+436375,int_stack+421735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396160,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+433900,int_stack+440425,int_stack+424975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399400,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+440200,int_stack+433900,int_stack+429175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403600,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+433900,int_stack+269440,int_stack+269230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304370, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+434530,int_stack+269720,int_stack+269440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304790, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+435370,int_stack+434530,int_stack+433900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344135, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+436630,int_stack+270080,int_stack+269720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305350, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+437710,int_stack+436630,int_stack+434530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344765, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+437710,int_stack+435370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345605, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+448915,int_stack+270530,int_stack+270080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306070, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+450265,int_stack+448915,int_stack+436630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346865, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+452425,int_stack+450265,int_stack+437710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347945, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+455225,int_stack+452425,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349625, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+458375,int_stack+271080,int_stack+270530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306970, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+460025,int_stack+458375,int_stack+448915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351725, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+462725,int_stack+460025,int_stack+450265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353075, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+458375,int_stack+462725,int_stack+452425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355235, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+462575,int_stack+458375,int_stack+455225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358035, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+458375,int_stack+116710,int_stack+116080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152280, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+459320,int_stack+117550,int_stack+116710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153225, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+460580,int_stack+459320,int_stack+458375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378235, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+466985,int_stack+118630,int_stack+117550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154485, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+468605,int_stack+466985,int_stack+459320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379180, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+471125,int_stack+468605,int_stack+460580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380440, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+474275,int_stack+119980,int_stack+118630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156105, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+476300,int_stack+474275,int_stack+466985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+479540,int_stack+476300,int_stack+468605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388465, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+483740,int_stack+479540,int_stack+471125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390985, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+488465,int_stack+990,int_stack+119980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4950, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+490940,int_stack+488465,int_stack+474275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394135, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+494990,int_stack+490940,int_stack+476300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396160, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+488465,int_stack+494990,int_stack+479540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399400, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+494765,int_stack+488465,int_stack+483740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403600, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+488465,int_stack+278225,int_stack+278015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304370, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+489095,int_stack+278505,int_stack+278225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304790, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+489935,int_stack+489095,int_stack+488465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+491195,int_stack+278865,int_stack+278505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305350, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+492275,int_stack+491195,int_stack+489095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344765, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+501380,int_stack+492275,int_stack+489935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345605, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+279315,int_stack+278865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306070, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+503480,int_stack+0,int_stack+491195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346865, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+505640,int_stack+503480,int_stack+492275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347945, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+508440,int_stack+505640,int_stack+501380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349625, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+511590,int_stack+279865,int_stack+279315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306970, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+513240,int_stack+511590,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351725, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+515940,int_stack+513240,int_stack+503480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353075, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+511590,int_stack+515940,int_stack+505640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355235, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+515790,int_stack+511590,int_stack+508440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358035, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+511590,int_stack+125760,int_stack+125130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152280, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+512535,int_stack+126600,int_stack+125760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153225, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+513795,int_stack+512535,int_stack+511590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+520200,int_stack+127680,int_stack+126600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154485, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+521820,int_stack+520200,int_stack+512535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379180, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+524340,int_stack+521820,int_stack+513795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380440, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+527490,int_stack+129030,int_stack+127680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156105, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+529515,int_stack+527490,int_stack+520200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+532755,int_stack+529515,int_stack+521820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388465, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+536955,int_stack+532755,int_stack+524340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390985, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+541680,int_stack+1980,int_stack+129030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4950, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+544155,int_stack+541680,int_stack+527490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394135, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+548205,int_stack+544155,int_stack+529515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396160, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+541680,int_stack+548205,int_stack+532755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399400, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+547980,int_stack+541680,int_stack+536955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+541680,int_stack+287010,int_stack+286800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+542310,int_stack+287290,int_stack+287010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+543150,int_stack+542310,int_stack+541680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+544410,int_stack+287650,int_stack+287290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+545490,int_stack+544410,int_stack+542310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+554595,int_stack+545490,int_stack+543150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1350,int_stack+288100,int_stack+287650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+556695,int_stack+1350,int_stack+544410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+558855,int_stack+556695,int_stack+545490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+561655,int_stack+558855,int_stack+554595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+564805,int_stack+288650,int_stack+288100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+566455,int_stack+564805,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+569155,int_stack+566455,int_stack+556695, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+564805,int_stack+569155,int_stack+558855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+569005,int_stack+564805,int_stack+561655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+564805,int_stack+134810,int_stack+134180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+565750,int_stack+135650,int_stack+134810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+567010,int_stack+565750,int_stack+564805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+573415,int_stack+136730,int_stack+135650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+575035,int_stack+573415,int_stack+565750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+577555,int_stack+575035,int_stack+567010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+580705,int_stack+138080,int_stack+136730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+582730,int_stack+580705,int_stack+573415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+585970,int_stack+582730,int_stack+575035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+590170,int_stack+585970,int_stack+577555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+594895,int_stack+2970,int_stack+138080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+597370,int_stack+594895,int_stack+580705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+394135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+601420,int_stack+597370,int_stack+582730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+594895,int_stack+601420,int_stack+585970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+601195,int_stack+594895,int_stack+590170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+594895,int_stack+295795,int_stack+295585, 0.0, zero_stack, 1.0, int_stack+304370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+595525,int_stack+296075,int_stack+295795, 0.0, zero_stack, 1.0, int_stack+304790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2700,int_stack+595525,int_stack+594895, 0.0, zero_stack, 1.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+596365,int_stack+296435,int_stack+296075, 0.0, zero_stack, 1.0, int_stack+305350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+597445,int_stack+596365,int_stack+595525, 0.0, zero_stack, 1.0, int_stack+344765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+607810,int_stack+597445,int_stack+2700, 0.0, zero_stack, 1.0, int_stack+345605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+599125,int_stack+296885,int_stack+296435, 0.0, zero_stack, 1.0, int_stack+306070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+609910,int_stack+599125,int_stack+596365, 0.0, zero_stack, 1.0, int_stack+346865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+612070,int_stack+609910,int_stack+597445, 0.0, zero_stack, 1.0, int_stack+347945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+614870,int_stack+612070,int_stack+607810, 0.0, zero_stack, 1.0, int_stack+349625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+618020,int_stack+297435,int_stack+296885, 0.0, zero_stack, 1.0, int_stack+306970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+619670,int_stack+618020,int_stack+599125, 0.0, zero_stack, 1.0, int_stack+351725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+622370,int_stack+619670,int_stack+609910, 0.0, zero_stack, 1.0, int_stack+353075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+618020,int_stack+622370,int_stack+612070, 0.0, zero_stack, 1.0, int_stack+355235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+622220,int_stack+618020,int_stack+614870, 0.0, zero_stack, 1.0, int_stack+358035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+618020,int_stack+143860,int_stack+143230, 0.0, zero_stack, 1.0, int_stack+152280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+618965,int_stack+144700,int_stack+143860, 0.0, zero_stack, 1.0, int_stack+153225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+620225,int_stack+618965,int_stack+618020, 0.0, zero_stack, 1.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+145780,int_stack+144700, 0.0, zero_stack, 1.0, int_stack+154485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+618965, 0.0, zero_stack, 1.0, int_stack+379180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+630770,int_stack+628250,int_stack+620225, 0.0, zero_stack, 1.0, int_stack+380440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+633920,int_stack+147130,int_stack+145780, 0.0, zero_stack, 1.0, int_stack+156105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+635945,int_stack+633920,int_stack+626630, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+639185,int_stack+635945,int_stack+628250, 0.0, zero_stack, 1.0, int_stack+388465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+643385,int_stack+639185,int_stack+630770, 0.0, zero_stack, 1.0, int_stack+390985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+648110,int_stack+3960,int_stack+147130, 0.0, zero_stack, 1.0, int_stack+4950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+650585,int_stack+648110,int_stack+633920, 0.0, zero_stack, 1.0, int_stack+394135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+654635,int_stack+650585,int_stack+635945, 0.0, zero_stack, 1.0, int_stack+396160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+648110,int_stack+654635,int_stack+639185, 0.0, zero_stack, 1.0, int_stack+399400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+654410,int_stack+648110,int_stack+643385, 0.0, zero_stack, 1.0, int_stack+403600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+648110,int_stack+305070,int_stack+304580, 1.0, int_stack+304370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+648740,int_stack+305710,int_stack+305070, 1.0, int_stack+304790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+649580,int_stack+648740,int_stack+648110, 1.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+650840,int_stack+306520,int_stack+305710, 1.0, int_stack+305350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+651920,int_stack+650840,int_stack+648740, 1.0, int_stack+344765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+661025,int_stack+651920,int_stack+649580, 1.0, int_stack+345605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+344135,int_stack+307520,int_stack+306520, 1.0, int_stack+306070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+663125,int_stack+344135,int_stack+650840, 1.0, int_stack+346865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+665285,int_stack+663125,int_stack+651920, 1.0, int_stack+347945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+345485,int_stack+665285,int_stack+661025, 1.0, int_stack+349625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+348635,int_stack+308070,int_stack+307520, 1.0, int_stack+306970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+668085,int_stack+348635,int_stack+344135, 1.0, int_stack+351725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+670785,int_stack+668085,int_stack+663125, 1.0, int_stack+353075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+674385,int_stack+670785,int_stack+665285, 1.0, int_stack+355235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+668085,int_stack+674385,int_stack+345485, 1.0, int_stack+358035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+672495,int_stack+153645,int_stack+152595, 1.0, int_stack+152280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+673440,int_stack+155025,int_stack+153645, 1.0, int_stack+153225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+674700,int_stack+673440,int_stack+672495, 1.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+676590,int_stack+156780,int_stack+155025, 1.0, int_stack+154485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348635,int_stack+676590,int_stack+673440, 1.0, int_stack+379180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+678210,int_stack+348635,int_stack+674700, 1.0, int_stack+380440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+378235,int_stack+158130,int_stack+156780, 1.0, int_stack+156105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+681360,int_stack+378235,int_stack+676590, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+684600,int_stack+681360,int_stack+348635, 1.0, int_stack+388465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+688800,int_stack+684600,int_stack+678210, 1.0, int_stack+390985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+386845,int_stack+5775,int_stack+158130, 1.0, int_stack+4950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+389320,int_stack+386845,int_stack+378235, 1.0, int_stack+394135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+693525,int_stack+389320,int_stack+681360, 1.0, int_stack+396160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+386845,int_stack+693525,int_stack+684600, 1.0, int_stack+399400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+393145,int_stack+386845,int_stack+688800, 1.0, int_stack+403600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+386845,int_stack+8745,int_stack+306970,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+388495,int_stack+386845,int_stack+351725,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+693525,int_stack+388495,int_stack+353075,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+386845,int_stack+693525,int_stack+355235,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+693525,int_stack+386845,int_stack+358035,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+386845,int_stack+317990,int_stack+317780,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+387475,int_stack+318270,int_stack+317990,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+388315,int_stack+387475,int_stack+386845,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+389575,int_stack+318630,int_stack+318270,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+390655,int_stack+389575,int_stack+387475,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+399760,int_stack+390655,int_stack+388315,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+401860,int_stack+319080,int_stack+318630,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+403210,int_stack+401860,int_stack+389575,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+405370,int_stack+403210,int_stack+390655,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+351155,int_stack+405370,int_stack+399760,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+380260,int_stack+319630,int_stack+319080,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+354305,int_stack+380260,int_stack+401860,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+357005,int_stack+354305,int_stack+403210,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+697935,int_stack+357005,int_stack+405370,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+354305,int_stack+697935,int_stack+351155,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+697935,int_stack+195285,int_stack+194655,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+698880,int_stack+196125,int_stack+195285,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+700140,int_stack+698880,int_stack+697935,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+197205,int_stack+196125,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3960,int_stack+358715,int_stack+698880,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+702030,int_stack+3960,int_stack+700140,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+380260,int_stack+198555,int_stack+197205,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+705180,int_stack+380260,int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+708420,int_stack+705180,int_stack+3960,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+712620,int_stack+708420,int_stack+702030,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+717345,int_stack+6765,int_stack+198555,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+719820,int_stack+717345,int_stack+380260,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+723870,int_stack+719820,int_stack+705180,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+717345,int_stack+723870,int_stack+708420,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+723645,int_stack+717345,int_stack+712620,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+717345,int_stack+326775,int_stack+326565,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+717975,int_stack+327055,int_stack+326775,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+718815,int_stack+717975,int_stack+717345,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+720075,int_stack+327415,int_stack+327055,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+721155,int_stack+720075,int_stack+717975,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+730260,int_stack+721155,int_stack+718815,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+732360,int_stack+327865,int_stack+327415,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+733710,int_stack+732360,int_stack+720075,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+735870,int_stack+733710,int_stack+721155,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+738670,int_stack+735870,int_stack+730260,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+741820,int_stack+328415,int_stack+327865,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+743470,int_stack+741820,int_stack+732360,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+746170,int_stack+743470,int_stack+733710,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+741820,int_stack+746170,int_stack+735870,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+746020,int_stack+741820,int_stack+738670,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+741820,int_stack+241985,int_stack+241355,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+742765,int_stack+242825,int_stack+241985,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+744025,int_stack+742765,int_stack+741820,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+750430,int_stack+243905,int_stack+242825,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+752050,int_stack+750430,int_stack+742765,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+754570,int_stack+752050,int_stack+744025,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+757720,int_stack+245255,int_stack+243905,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+759745,int_stack+757720,int_stack+750430,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+762985,int_stack+759745,int_stack+752050,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+767185,int_stack+762985,int_stack+754570,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+771910,int_stack+7755,int_stack+245255,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+774385,int_stack+771910,int_stack+757720,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+778435,int_stack+774385,int_stack+759745,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+771910,int_stack+778435,int_stack+762985,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+778210,int_stack+771910,int_stack+767185,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+771910,int_stack+335560,int_stack+335350,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+772540,int_stack+335840,int_stack+335560,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+773380,int_stack+772540,int_stack+771910,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+774640,int_stack+336200,int_stack+335840,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+775720,int_stack+774640,int_stack+772540,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6480,int_stack+775720,int_stack+773380,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+784825,int_stack+336650,int_stack+336200,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+786175,int_stack+784825,int_stack+774640,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+788335,int_stack+786175,int_stack+775720,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+791135,int_stack+788335,int_stack+6480,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+794285,int_stack+337200,int_stack+336650,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+795935,int_stack+794285,int_stack+784825,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+798635,int_stack+795935,int_stack+786175,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+794285,int_stack+798635,int_stack+788335,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+798485,int_stack+794285,int_stack+791135,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+794285,int_stack+311870,int_stack+311240,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+795230,int_stack+312710,int_stack+311870,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+796490,int_stack+795230,int_stack+794285,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+802895,int_stack+313790,int_stack+312710,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+804515,int_stack+802895,int_stack+795230,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+807035,int_stack+804515,int_stack+796490,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+810185,int_stack+315140,int_stack+313790,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+812210,int_stack+810185,int_stack+802895,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+815450,int_stack+812210,int_stack+804515,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+819650,int_stack+815450,int_stack+807035,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+824375,int_stack+9405,int_stack+315140,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+826850,int_stack+824375,int_stack+810185,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+830900,int_stack+826850,int_stack+812210,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+824375,int_stack+830900,int_stack+815450,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+830675,int_stack+824375,int_stack+819650,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+824375,int_stack+10605,int_stack+10395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+260445,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+825005,int_stack+10885,int_stack+10605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+260655,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+825845,int_stack+825005,int_stack+824375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+361185,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+827105,int_stack+11245,int_stack+10885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+260935,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+828185,int_stack+827105,int_stack+825005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+361815,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8580,int_stack+828185,int_stack+825845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+362655,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+824375,int_stack+11695,int_stack+11245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261295,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+837290,int_stack+824375,int_stack+827105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+363915,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+839450,int_stack+837290,int_stack+828185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+364995,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+825725,int_stack+839450,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+366675,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+8580,int_stack+12245,int_stack+11695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261745,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+842250,int_stack+8580,int_stack+824375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+368775,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8580,int_stack+842250,int_stack+837290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+370125,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+842250,int_stack+8580,int_stack+839450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+372285,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+837290,int_stack+842250,int_stack+825725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+375085,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8580,int_stack+13220,int_stack+12905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+107030,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9525,int_stack+13640,int_stack+13220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+107660,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10785,int_stack+9525,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+408325,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+841700,int_stack+14180,int_stack+13640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+108500,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+843320,int_stack+841700,int_stack+9525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+409270,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+824375,int_stack+843320,int_stack+10785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+410530,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8580,int_stack+14855,int_stack+14180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+109580,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+10605,int_stack+8580,int_stack+841700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+412420,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+845840,int_stack+10605,int_stack+843320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+414040,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+850040,int_stack+845840,int_stack+824375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+416560,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+824375,int_stack+15680,int_stack+14855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+110930,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+841700,int_stack+824375,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+419710,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+824375,int_stack+841700,int_stack+10605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+421735,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8580,int_stack+824375,int_stack+845840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+424975,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+841700,int_stack+8580,int_stack+850040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+429175,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8580,int_stack+16880,int_stack+16670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260445, 1.0, int_stack+269230,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9210,int_stack+17160,int_stack+16880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260655, 1.0, int_stack+269440,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10050,int_stack+9210,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361185, 1.0, int_stack+433900,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11310,int_stack+17520,int_stack+17160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260935, 1.0, int_stack+269720,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12390,int_stack+11310,int_stack+9210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361815, 1.0, int_stack+434530,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+14070,int_stack+12390,int_stack+10050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362655, 1.0, int_stack+435370,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16170,int_stack+17970,int_stack+17520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261295, 1.0, int_stack+270080,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8580,int_stack+16170,int_stack+11310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363915, 1.0, int_stack+436630,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+824375,int_stack+8580,int_stack+12390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364995, 1.0, int_stack+437710,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+10740,int_stack+824375,int_stack+14070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+366675, 1.0, int_stack+446815,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13890,int_stack+18520,int_stack+17970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261745, 1.0, int_stack+270530,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+827175,int_stack+13890,int_stack+16170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368775, 1.0, int_stack+448915,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+13890,int_stack+827175,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370125, 1.0, int_stack+450265,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+848315,int_stack+13890,int_stack+824375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372285, 1.0, int_stack+452425,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+824375,int_stack+848315,int_stack+10740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375085, 1.0, int_stack+455225,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+848315,int_stack+19495,int_stack+19180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107030, 1.0, int_stack+116080,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+849260,int_stack+19915,int_stack+19495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107660, 1.0, int_stack+116710,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+828785,int_stack+849260,int_stack+848315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408325, 1.0, int_stack+458375,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+850520,int_stack+20455,int_stack+19915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108500, 1.0, int_stack+117550,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+852140,int_stack+850520,int_stack+849260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409270, 1.0, int_stack+459320,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8580,int_stack+852140,int_stack+828785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+410530, 1.0, int_stack+460580,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+848315,int_stack+21130,int_stack+20455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109580, 1.0, int_stack+118630,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+11730,int_stack+848315,int_stack+850520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412420, 1.0, int_stack+466985,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+14970,int_stack+11730,int_stack+852140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414040, 1.0, int_stack+468605,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+850340,int_stack+14970,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416560, 1.0, int_stack+471125,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+8580,int_stack+21955,int_stack+21130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110930, 1.0, int_stack+119980,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+855065,int_stack+8580,int_stack+848315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419710, 1.0, int_stack+474275,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+859115,int_stack+855065,int_stack+11730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421735, 1.0, int_stack+476300,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8580,int_stack+859115,int_stack+14970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424975, 1.0, int_stack+479540,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+855065,int_stack+8580,int_stack+850340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429175, 1.0, int_stack+483740,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8580,int_stack+23155,int_stack+22945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269230, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9210,int_stack+23435,int_stack+23155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269440, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10050,int_stack+9210,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+433900, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11310,int_stack+23795,int_stack+23435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269720, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12390,int_stack+11310,int_stack+9210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+434530, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+14070,int_stack+12390,int_stack+10050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+435370, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8580,int_stack+24245,int_stack+23795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+270080, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+16170,int_stack+8580,int_stack+11310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+436630, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+18330,int_stack+16170,int_stack+12390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+437710, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9930,int_stack+18330,int_stack+14070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+446815, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+13080,int_stack+24795,int_stack+24245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+270530, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+21130,int_stack+13080,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+448915, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+848315,int_stack+21130,int_stack+16170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+450265, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21130,int_stack+848315,int_stack+18330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+452425, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+848315,int_stack+21130,int_stack+9930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+455225, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+852725,int_stack+25770,int_stack+25455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+116080, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+853670,int_stack+26190,int_stack+25770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+116710, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+828785,int_stack+853670,int_stack+852725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+458375, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8580,int_stack+26730,int_stack+26190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+117550, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10200,int_stack+8580,int_stack+853670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+459320, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12720,int_stack+10200,int_stack+828785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+460580, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+852725,int_stack+27405,int_stack+26730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+118630, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15870,int_stack+852725,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+466985, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+19110,int_stack+15870,int_stack+10200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+468605, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+861680,int_stack+19110,int_stack+12720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+471125, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+8580,int_stack+28230,int_stack+27405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+119980, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+11055,int_stack+8580,int_stack+852725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+474275, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+23310,int_stack+11055,int_stack+15870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+476300, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8580,int_stack+23310,int_stack+19110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+479540, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+14880,int_stack+8580,int_stack+861680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+483740, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+861680,int_stack+29430,int_stack+29220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260445, 0.0, zero_stack, 1.0, int_stack+278015,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+862310,int_stack+29710,int_stack+29430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260655, 0.0, zero_stack, 1.0, int_stack+278225,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+863150,int_stack+862310,int_stack+861680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361185, 0.0, zero_stack, 1.0, int_stack+488465,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+864410,int_stack+30070,int_stack+29710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260935, 0.0, zero_stack, 1.0, int_stack+278505,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8580,int_stack+864410,int_stack+862310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361815, 0.0, zero_stack, 1.0, int_stack+489095,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10260,int_stack+8580,int_stack+863150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362655, 0.0, zero_stack, 1.0, int_stack+489935,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+861680,int_stack+30520,int_stack+30070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261295, 0.0, zero_stack, 1.0, int_stack+278865,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12360,int_stack+861680,int_stack+864410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363915, 0.0, zero_stack, 1.0, int_stack+491195,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+863030,int_stack+12360,int_stack+8580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364995, 0.0, zero_stack, 1.0, int_stack+492275,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+863030,int_stack+10260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+366675, 0.0, zero_stack, 1.0, int_stack+501380,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+8580,int_stack+31070,int_stack+30520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261745, 0.0, zero_stack, 1.0, int_stack+279315,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+24645,int_stack+8580,int_stack+861680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368775, 0.0, zero_stack, 1.0, int_stack+0,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8580,int_stack+24645,int_stack+12360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370125, 0.0, zero_stack, 1.0, int_stack+503480,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+24645,int_stack+8580,int_stack+863030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372285, 0.0, zero_stack, 1.0, int_stack+505640,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+8580,int_stack+24645,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375085, 0.0, zero_stack, 1.0, int_stack+508440,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+32045,int_stack+31730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107030, 0.0, zero_stack, 1.0, int_stack+125130,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22440,int_stack+32465,int_stack+32045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107660, 0.0, zero_stack, 1.0, int_stack+125760,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12990,int_stack+22440,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408325, 0.0, zero_stack, 1.0, int_stack+511590,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23700,int_stack+33005,int_stack+32465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108500, 0.0, zero_stack, 1.0, int_stack+126600,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+25320,int_stack+23700,int_stack+22440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409270, 0.0, zero_stack, 1.0, int_stack+512535,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+27840,int_stack+25320,int_stack+12990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+410530, 0.0, zero_stack, 1.0, int_stack+513795,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+33680,int_stack+33005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109580, 0.0, zero_stack, 1.0, int_stack+127680,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+861680,int_stack+21495,int_stack+23700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412420, 0.0, zero_stack, 1.0, int_stack+520200,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+864920,int_stack+861680,int_stack+25320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414040, 0.0, zero_stack, 1.0, int_stack+521820,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+869120,int_stack+864920,int_stack+27840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416560, 0.0, zero_stack, 1.0, int_stack+524340,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+23520,int_stack+34505,int_stack+33680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110930, 0.0, zero_stack, 1.0, int_stack+129030,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25995,int_stack+23520,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419710, 0.0, zero_stack, 1.0, int_stack+527490,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+30045,int_stack+25995,int_stack+861680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421735, 0.0, zero_stack, 1.0, int_stack+529515,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21495,int_stack+30045,int_stack+864920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424975, 0.0, zero_stack, 1.0, int_stack+532755,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+861680,int_stack+21495,int_stack+869120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429175, 0.0, zero_stack, 1.0, int_stack+536955,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+35705,int_stack+35495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269230, 1.0, int_stack+278015, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+35985,int_stack+35705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269440, 1.0, int_stack+278225, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433900, 1.0, int_stack+488465, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+36345,int_stack+35985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269720, 1.0, int_stack+278505, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+25305,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434530, 1.0, int_stack+489095, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26985,int_stack+25305,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435370, 1.0, int_stack+489935, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+36795,int_stack+36345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270080, 1.0, int_stack+278865, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+29085,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+436630, 1.0, int_stack+491195, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+31245,int_stack+29085,int_stack+25305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+437710, 1.0, int_stack+492275, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+22845,int_stack+31245,int_stack+26985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446815, 1.0, int_stack+501380, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+25995,int_stack+37345,int_stack+36795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270530, 1.0, int_stack+279315, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+34045,int_stack+25995,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448915, 1.0, int_stack+0, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+868295,int_stack+34045,int_stack+29085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450265, 1.0, int_stack+503480, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+25995,int_stack+868295,int_stack+31245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452425, 1.0, int_stack+505640, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+868295,int_stack+25995,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455225, 1.0, int_stack+508440, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+872705,int_stack+38320,int_stack+38005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116080, 1.0, int_stack+125130, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21495,int_stack+38740,int_stack+38320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116710, 1.0, int_stack+125760, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12990,int_stack+21495,int_stack+872705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458375, 1.0, int_stack+511590, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22755,int_stack+39280,int_stack+38740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117550, 1.0, int_stack+126600, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24375,int_stack+22755,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459320, 1.0, int_stack+512535, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26895,int_stack+24375,int_stack+12990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460580, 1.0, int_stack+513795, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+30045,int_stack+39955,int_stack+39280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118630, 1.0, int_stack+127680, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+32070,int_stack+30045,int_stack+22755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466985, 1.0, int_stack+520200, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+35310,int_stack+32070,int_stack+24375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468605, 1.0, int_stack+521820, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+35310,int_stack+26895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471125, 1.0, int_stack+524340, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+26220,int_stack+40780,int_stack+39955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119980, 1.0, int_stack+129030, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+872705,int_stack+26220,int_stack+30045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474275, 1.0, int_stack+527490, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+26220,int_stack+872705,int_stack+32070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476300, 1.0, int_stack+529515, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+872705,int_stack+26220,int_stack+35310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479540, 1.0, int_stack+532755, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+26220,int_stack+872705,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483740, 1.0, int_stack+536955, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+41980,int_stack+41770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+278015, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+42260,int_stack+41980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+278225, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+488465, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+42620,int_stack+42260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+278505, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+872705,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+489095, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+874385,int_stack+872705,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+489935, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+43070,int_stack+42620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+278865, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+876485,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+491195, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+876485,int_stack+872705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+492275, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+32835,int_stack+22845,int_stack+874385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+501380, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+872705,int_stack+43620,int_stack+43070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+279315, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+35985,int_stack+872705,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+872705,int_stack+35985,int_stack+876485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+503480, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+35985,int_stack+872705,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+505640, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+872705,int_stack+35985,int_stack+32835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+508440, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32835,int_stack+44595,int_stack+44280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+125130, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33780,int_stack+45015,int_stack+44595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+125760, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12990,int_stack+33780,int_stack+32835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+511590, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35040,int_stack+45555,int_stack+45015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+126600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36660,int_stack+35040,int_stack+33780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+512535, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+39180,int_stack+36660,int_stack+12990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+513795, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32835,int_stack+46230,int_stack+45555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+127680, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+42330,int_stack+32835,int_stack+35040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+520200, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21495,int_stack+42330,int_stack+36660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+521820, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+877115,int_stack+21495,int_stack+39180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+524340, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+34860,int_stack+47055,int_stack+46230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+129030, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+37335,int_stack+34860,int_stack+32835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+527490, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+881840,int_stack+37335,int_stack+42330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+529515, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+32835,int_stack+881840,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+532755, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+39135,int_stack+32835,int_stack+877115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+536955, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+877115,int_stack+48255,int_stack+48045, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+286800,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+877745,int_stack+48535,int_stack+48255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287010,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+878585,int_stack+877745,int_stack+877115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541680,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+879845,int_stack+48895,int_stack+48535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260935, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287290,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+880925,int_stack+879845,int_stack+877745, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542310,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+882605,int_stack+880925,int_stack+878585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543150,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+877115,int_stack+49345,int_stack+48895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287650,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+884705,int_stack+877115,int_stack+879845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544410,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+32835,int_stack+884705,int_stack+880925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+545490,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+878465,int_stack+32835,int_stack+882605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+366675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554595,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+881615,int_stack+49895,int_stack+49345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261745, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288100,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+35635,int_stack+881615,int_stack+877115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+21495,int_stack+35635,int_stack+884705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+556695,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+881615,int_stack+21495,int_stack+32835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558855,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+32835,int_stack+881615,int_stack+878465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561655,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37245,int_stack+50870,int_stack+50555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134180,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21495,int_stack+51290,int_stack+50870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134810,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12990,int_stack+21495,int_stack+37245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564805,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+37245,int_stack+51830,int_stack+51290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135650,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22755,int_stack+37245,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+565750,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+877115,int_stack+22755,int_stack+12990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+410530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+567010,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+880265,int_stack+52505,int_stack+51830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136730,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+882290,int_stack+880265,int_stack+37245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573415,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+45750,int_stack+882290,int_stack+22755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575035,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+45750,int_stack+877115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577555,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+877115,int_stack+53330,int_stack+52505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138080,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+49950,int_stack+877115,int_stack+880265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580705,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+885530,int_stack+49950,int_stack+882290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582730,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+877115,int_stack+885530,int_stack+45750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+585970,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+45750,int_stack+877115,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590170,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+54530,int_stack+54320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269230, 0.0, zero_stack, 1.0, int_stack+286800, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+54810,int_stack+54530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269440, 0.0, zero_stack, 1.0, int_stack+287010, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433900, 0.0, zero_stack, 1.0, int_stack+541680, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+55170,int_stack+54810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269720, 0.0, zero_stack, 1.0, int_stack+287290, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+877115,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434530, 0.0, zero_stack, 1.0, int_stack+542310, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+878795,int_stack+877115,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435370, 0.0, zero_stack, 1.0, int_stack+543150, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+55620,int_stack+55170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270080, 0.0, zero_stack, 1.0, int_stack+287650, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+880895,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+436630, 0.0, zero_stack, 1.0, int_stack+544410, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+880895,int_stack+877115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+437710, 0.0, zero_stack, 1.0, int_stack+545490, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+883055,int_stack+22845,int_stack+878795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446815, 0.0, zero_stack, 1.0, int_stack+554595, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+877115,int_stack+56170,int_stack+55620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270530, 0.0, zero_stack, 1.0, int_stack+288100, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+886205,int_stack+877115,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448915, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+877115,int_stack+886205,int_stack+880895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450265, 0.0, zero_stack, 1.0, int_stack+556695, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+886205,int_stack+877115,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452425, 0.0, zero_stack, 1.0, int_stack+558855, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+877115,int_stack+886205,int_stack+883055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455225, 0.0, zero_stack, 1.0, int_stack+561655, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+881525,int_stack+57145,int_stack+56830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116080, 0.0, zero_stack, 1.0, int_stack+134180, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+882470,int_stack+57565,int_stack+57145, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116710, 0.0, zero_stack, 1.0, int_stack+134810, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37245,int_stack+882470,int_stack+881525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458375, 0.0, zero_stack, 1.0, int_stack+564805, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+883730,int_stack+58105,int_stack+57565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117550, 0.0, zero_stack, 1.0, int_stack+135650, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+885350,int_stack+883730,int_stack+882470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459320, 0.0, zero_stack, 1.0, int_stack+565750, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21495,int_stack+885350,int_stack+37245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460580, 0.0, zero_stack, 1.0, int_stack+567010, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+881525,int_stack+58780,int_stack+58105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+118630, 0.0, zero_stack, 1.0, int_stack+136730, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+52365,int_stack+881525,int_stack+883730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466985, 0.0, zero_stack, 1.0, int_stack+573415, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+887870,int_stack+52365,int_stack+885350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468605, 0.0, zero_stack, 1.0, int_stack+575035, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+892070,int_stack+887870,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471125, 0.0, zero_stack, 1.0, int_stack+577555, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+21495,int_stack+59605,int_stack+58780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119980, 0.0, zero_stack, 1.0, int_stack+138080, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+883550,int_stack+21495,int_stack+881525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474275, 0.0, zero_stack, 1.0, int_stack+580705, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+896795,int_stack+883550,int_stack+52365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476300, 0.0, zero_stack, 1.0, int_stack+582730, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+52365,int_stack+896795,int_stack+887870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479540, 0.0, zero_stack, 1.0, int_stack+585970, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+881525,int_stack+52365,int_stack+892070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483740, 0.0, zero_stack, 1.0, int_stack+590170, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52365,int_stack+60805,int_stack+60595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278015, 1.0, int_stack+286800, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+52995,int_stack+61085,int_stack+60805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278225, 1.0, int_stack+287010, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+53835,int_stack+52995,int_stack+52365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488465, 1.0, int_stack+541680, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+55095,int_stack+61445,int_stack+61085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278505, 1.0, int_stack+287290, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+56175,int_stack+55095,int_stack+52995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489095, 1.0, int_stack+542310, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+57855,int_stack+56175,int_stack+53835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489935, 1.0, int_stack+543150, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+52365,int_stack+61895,int_stack+61445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278865, 1.0, int_stack+287650, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+888140,int_stack+52365,int_stack+55095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491195, 1.0, int_stack+544410, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+890300,int_stack+888140,int_stack+56175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492275, 1.0, int_stack+545490, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+53715,int_stack+890300,int_stack+57855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+501380, 1.0, int_stack+554595, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+56865,int_stack+62445,int_stack+61895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+279315, 1.0, int_stack+288100, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+58515,int_stack+56865,int_stack+52365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+893100,int_stack+58515,int_stack+888140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+503480, 1.0, int_stack+556695, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+56865,int_stack+893100,int_stack+890300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+505640, 1.0, int_stack+558855, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+888140,int_stack+56865,int_stack+53715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508440, 1.0, int_stack+561655, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+892550,int_stack+63420,int_stack+63105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125130, 1.0, int_stack+134180, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+893495,int_stack+63840,int_stack+63420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125760, 1.0, int_stack+134810, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37245,int_stack+893495,int_stack+892550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511590, 1.0, int_stack+564805, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+894755,int_stack+64380,int_stack+63840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126600, 1.0, int_stack+135650, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+896375,int_stack+894755,int_stack+893495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512535, 1.0, int_stack+565750, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+898895,int_stack+896375,int_stack+37245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513795, 1.0, int_stack+567010, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+892550,int_stack+65055,int_stack+64380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+127680, 1.0, int_stack+136730, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+52365,int_stack+892550,int_stack+894755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520200, 1.0, int_stack+573415, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+55605,int_stack+52365,int_stack+896375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521820, 1.0, int_stack+575035, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+55605,int_stack+898895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524340, 1.0, int_stack+577555, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+894575,int_stack+65880,int_stack+65055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129030, 1.0, int_stack+138080, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+897050,int_stack+894575,int_stack+892550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527490, 1.0, int_stack+580705, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+59805,int_stack+897050,int_stack+52365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529515, 1.0, int_stack+582730, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+892550,int_stack+59805,int_stack+55605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+532755, 1.0, int_stack+585970, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+52365,int_stack+892550,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536955, 1.0, int_stack+590170, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+67080,int_stack+66870, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+286800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+67360,int_stack+67080, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+287010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+541680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+67720,int_stack+67360, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+287290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+892550,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+542310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+894230,int_stack+892550,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+543150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+68170,int_stack+67720, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+287650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+896330,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+544410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+896330,int_stack+892550, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+545490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+898490,int_stack+22845,int_stack+894230, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+554595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+892550,int_stack+68720,int_stack+68170, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+288100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+58980,int_stack+892550,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+892550,int_stack+58980,int_stack+896330, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+556695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+892550,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+558855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+892550,int_stack+58980,int_stack+898490, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+561655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58980,int_stack+69695,int_stack+69380, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+134180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59925,int_stack+70115,int_stack+69695, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+134810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37245,int_stack+59925,int_stack+58980, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+564805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61185,int_stack+70655,int_stack+70115, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+135650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+62805,int_stack+61185,int_stack+59925, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+565750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+65325,int_stack+62805,int_stack+37245, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+567010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58980,int_stack+71330,int_stack+70655, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+136730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+896960,int_stack+58980,int_stack+61185, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+573415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21495,int_stack+896960,int_stack+62805, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+575035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+900200,int_stack+21495,int_stack+65325, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+577555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+61005,int_stack+72155,int_stack+71330, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+138080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+63480,int_stack+61005,int_stack+58980, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+580705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+67530,int_stack+63480,int_stack+896960, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+582730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+67530,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+585970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+65280,int_stack+58980,int_stack+900200, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+590170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58980,int_stack+73355,int_stack+73145, 0.0, zero_stack, 1.0, int_stack+260445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295585,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59610,int_stack+73635,int_stack+73355, 0.0, zero_stack, 1.0, int_stack+260655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295795,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+60450,int_stack+59610,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+361185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594895,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61710,int_stack+73995,int_stack+73635, 0.0, zero_stack, 1.0, int_stack+260935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296075,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+62790,int_stack+61710,int_stack+59610, 0.0, zero_stack, 1.0, int_stack+361815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595525,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+71895,int_stack+62790,int_stack+60450, 0.0, zero_stack, 1.0, int_stack+362655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2700,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58980,int_stack+74445,int_stack+73995, 0.0, zero_stack, 1.0, int_stack+261295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296435,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21495,int_stack+58980,int_stack+61710, 0.0, zero_stack, 1.0, int_stack+363915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596365,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+896960,int_stack+21495,int_stack+62790, 0.0, zero_stack, 1.0, int_stack+364995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597445,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+60330,int_stack+896960,int_stack+71895, 0.0, zero_stack, 1.0, int_stack+366675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607810,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+71895,int_stack+74995,int_stack+74445, 0.0, zero_stack, 1.0, int_stack+261745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296885,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+899760,int_stack+71895,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+368775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599125,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+71895,int_stack+899760,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+370125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609910,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21495,int_stack+71895,int_stack+896960, 0.0, zero_stack, 1.0, int_stack+372285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612070,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+896960,int_stack+21495,int_stack+60330, 0.0, zero_stack, 1.0, int_stack+375085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614870,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+75970,int_stack+75655, 0.0, zero_stack, 1.0, int_stack+107030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143230,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22440,int_stack+76390,int_stack+75970, 0.0, zero_stack, 1.0, int_stack+107660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143860,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37245,int_stack+22440,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+408325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618020,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23700,int_stack+76930,int_stack+76390, 0.0, zero_stack, 1.0, int_stack+108500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144700,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+901370,int_stack+23700,int_stack+22440, 0.0, zero_stack, 1.0, int_stack+409270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618965,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+71895,int_stack+901370,int_stack+37245, 0.0, zero_stack, 1.0, int_stack+410530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620225,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+77605,int_stack+76930, 0.0, zero_stack, 1.0, int_stack+109580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145780,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+58980,int_stack+21495,int_stack+23700, 0.0, zero_stack, 1.0, int_stack+412420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+626630,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+903890,int_stack+58980,int_stack+901370, 0.0, zero_stack, 1.0, int_stack+414040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628250,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+908090,int_stack+903890,int_stack+71895, 0.0, zero_stack, 1.0, int_stack+416560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630770,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+71895,int_stack+78430,int_stack+77605, 0.0, zero_stack, 1.0, int_stack+110930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147130,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+74370,int_stack+71895,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+419710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633920,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+912815,int_stack+74370,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+421735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635945,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+912815,int_stack+903890, 0.0, zero_stack, 1.0, int_stack+424975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639185,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+71895,int_stack+58980,int_stack+908090, 0.0, zero_stack, 1.0, int_stack+429175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643385,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58980,int_stack+79630,int_stack+79420, 0.0, zero_stack, 1.0, int_stack+269230, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295585, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59610,int_stack+79910,int_stack+79630, 0.0, zero_stack, 1.0, int_stack+269440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295795, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+60450,int_stack+59610,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+433900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594895, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61710,int_stack+80270,int_stack+79910, 0.0, zero_stack, 1.0, int_stack+269720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296075, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+62790,int_stack+61710,int_stack+59610, 0.0, zero_stack, 1.0, int_stack+434530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595525, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21495,int_stack+62790,int_stack+60450, 0.0, zero_stack, 1.0, int_stack+435370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2700, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58980,int_stack+80720,int_stack+80270, 0.0, zero_stack, 1.0, int_stack+270080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296435, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+23595,int_stack+58980,int_stack+61710, 0.0, zero_stack, 1.0, int_stack+436630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596365, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+901370,int_stack+23595,int_stack+62790, 0.0, zero_stack, 1.0, int_stack+437710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597445, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+60330,int_stack+901370,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607810, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+21495,int_stack+81270,int_stack+80720, 0.0, zero_stack, 1.0, int_stack+270530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296885, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+78510,int_stack+21495,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+448915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599125, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+904170,int_stack+78510,int_stack+23595, 0.0, zero_stack, 1.0, int_stack+450265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609910, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21495,int_stack+904170,int_stack+901370, 0.0, zero_stack, 1.0, int_stack+452425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612070, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+901370,int_stack+21495,int_stack+60330, 0.0, zero_stack, 1.0, int_stack+455225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614870, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+82245,int_stack+81930, 0.0, zero_stack, 1.0, int_stack+116080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143230, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22440,int_stack+82665,int_stack+82245, 0.0, zero_stack, 1.0, int_stack+116710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143860, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37245,int_stack+22440,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+458375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618020, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23700,int_stack+83205,int_stack+82665, 0.0, zero_stack, 1.0, int_stack+117550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144700, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+905780,int_stack+23700,int_stack+22440, 0.0, zero_stack, 1.0, int_stack+459320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618965, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+908300,int_stack+905780,int_stack+37245, 0.0, zero_stack, 1.0, int_stack+460580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620225, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+83880,int_stack+83205, 0.0, zero_stack, 1.0, int_stack+118630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145780, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+911450,int_stack+21495,int_stack+23700, 0.0, zero_stack, 1.0, int_stack+466985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+626630, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+914690,int_stack+911450,int_stack+905780, 0.0, zero_stack, 1.0, int_stack+468605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628250, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+78510,int_stack+914690,int_stack+908300, 0.0, zero_stack, 1.0, int_stack+471125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630770, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+905780,int_stack+84705,int_stack+83880, 0.0, zero_stack, 1.0, int_stack+119980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147130, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+58980,int_stack+905780,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+474275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633920, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+905780,int_stack+58980,int_stack+911450, 0.0, zero_stack, 1.0, int_stack+476300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635945, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+905780,int_stack+914690, 0.0, zero_stack, 1.0, int_stack+479540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639185, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+905780,int_stack+58980,int_stack+78510, 0.0, zero_stack, 1.0, int_stack+483740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643385, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+78510,int_stack+85905,int_stack+85695, 0.0, zero_stack, 1.0, int_stack+278015, 0.0, zero_stack, 1.0, int_stack+295585, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+79140,int_stack+86185,int_stack+85905, 0.0, zero_stack, 1.0, int_stack+278225, 0.0, zero_stack, 1.0, int_stack+295795, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+79980,int_stack+79140,int_stack+78510, 0.0, zero_stack, 1.0, int_stack+488465, 0.0, zero_stack, 1.0, int_stack+594895, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+81240,int_stack+86545,int_stack+86185, 0.0, zero_stack, 1.0, int_stack+278505, 0.0, zero_stack, 1.0, int_stack+296075, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+82320,int_stack+81240,int_stack+79140, 0.0, zero_stack, 1.0, int_stack+489095, 0.0, zero_stack, 1.0, int_stack+595525, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+84000,int_stack+82320,int_stack+79980, 0.0, zero_stack, 1.0, int_stack+489935, 0.0, zero_stack, 1.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+78510,int_stack+86995,int_stack+86545, 0.0, zero_stack, 1.0, int_stack+278865, 0.0, zero_stack, 1.0, int_stack+296435, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+58980,int_stack+78510,int_stack+81240, 0.0, zero_stack, 1.0, int_stack+491195, 0.0, zero_stack, 1.0, int_stack+596365, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61140,int_stack+58980,int_stack+82320, 0.0, zero_stack, 1.0, int_stack+492275, 0.0, zero_stack, 1.0, int_stack+597445, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+79860,int_stack+61140,int_stack+84000, 0.0, zero_stack, 1.0, int_stack+501380, 0.0, zero_stack, 1.0, int_stack+607810, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+83010,int_stack+87545,int_stack+86995, 0.0, zero_stack, 1.0, int_stack+279315, 0.0, zero_stack, 1.0, int_stack+296885, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+84660,int_stack+83010,int_stack+78510, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+599125, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+912395,int_stack+84660,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+503480, 0.0, zero_stack, 1.0, int_stack+609910, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+83010,int_stack+912395,int_stack+61140, 0.0, zero_stack, 1.0, int_stack+505640, 0.0, zero_stack, 1.0, int_stack+612070, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+912395,int_stack+83010,int_stack+79860, 0.0, zero_stack, 1.0, int_stack+508440, 0.0, zero_stack, 1.0, int_stack+614870, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+916805,int_stack+88520,int_stack+88205, 0.0, zero_stack, 1.0, int_stack+125130, 0.0, zero_stack, 1.0, int_stack+143230, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+58980,int_stack+88940,int_stack+88520, 0.0, zero_stack, 1.0, int_stack+125760, 0.0, zero_stack, 1.0, int_stack+143860, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+37245,int_stack+58980,int_stack+916805, 0.0, zero_stack, 1.0, int_stack+511590, 0.0, zero_stack, 1.0, int_stack+618020, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+916805,int_stack+89480,int_stack+88940, 0.0, zero_stack, 1.0, int_stack+126600, 0.0, zero_stack, 1.0, int_stack+144700, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+60240,int_stack+916805,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+512535, 0.0, zero_stack, 1.0, int_stack+618965, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+78510,int_stack+60240,int_stack+37245, 0.0, zero_stack, 1.0, int_stack+513795, 0.0, zero_stack, 1.0, int_stack+620225, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+62760,int_stack+90155,int_stack+89480, 0.0, zero_stack, 1.0, int_stack+127680, 0.0, zero_stack, 1.0, int_stack+145780, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+81660,int_stack+62760,int_stack+916805, 0.0, zero_stack, 1.0, int_stack+520200, 0.0, zero_stack, 1.0, int_stack+626630, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+84900,int_stack+81660,int_stack+60240, 0.0, zero_stack, 1.0, int_stack+521820, 0.0, zero_stack, 1.0, int_stack+628250, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+84900,int_stack+78510, 0.0, zero_stack, 1.0, int_stack+524340, 0.0, zero_stack, 1.0, int_stack+630770, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+78510,int_stack+90980,int_stack+90155, 0.0, zero_stack, 1.0, int_stack+129030, 0.0, zero_stack, 1.0, int_stack+147130, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+916805,int_stack+78510,int_stack+62760, 0.0, zero_stack, 1.0, int_stack+527490, 0.0, zero_stack, 1.0, int_stack+633920, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+58980,int_stack+916805,int_stack+81660, 0.0, zero_stack, 1.0, int_stack+529515, 0.0, zero_stack, 1.0, int_stack+635945, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+78510,int_stack+58980,int_stack+84900, 0.0, zero_stack, 1.0, int_stack+532755, 0.0, zero_stack, 1.0, int_stack+639185, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+84810,int_stack+78510,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+536955, 0.0, zero_stack, 1.0, int_stack+643385, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+92180,int_stack+91970, 0.0, zero_stack, 1.0, int_stack+286800, 1.0, int_stack+295585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+92460,int_stack+92180, 0.0, zero_stack, 1.0, int_stack+287010, 1.0, int_stack+295795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+541680, 1.0, int_stack+594895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+92820,int_stack+92460, 0.0, zero_stack, 1.0, int_stack+287290, 1.0, int_stack+296075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+78510,int_stack+24225,int_stack+22125, 0.0, zero_stack, 1.0, int_stack+542310, 1.0, int_stack+595525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+80190,int_stack+78510,int_stack+22965, 0.0, zero_stack, 1.0, int_stack+543150, 1.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+93270,int_stack+92820, 0.0, zero_stack, 1.0, int_stack+287650, 1.0, int_stack+296435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+82290,int_stack+21495,int_stack+24225, 0.0, zero_stack, 1.0, int_stack+544410, 1.0, int_stack+596365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+82290,int_stack+78510, 0.0, zero_stack, 1.0, int_stack+545490, 1.0, int_stack+597445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+58980,int_stack+22845,int_stack+80190, 0.0, zero_stack, 1.0, int_stack+554595, 1.0, int_stack+607810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+78510,int_stack+93820,int_stack+93270, 0.0, zero_stack, 1.0, int_stack+288100, 1.0, int_stack+296885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+62130,int_stack+78510,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+1350, 1.0, int_stack+599125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+78510,int_stack+62130,int_stack+82290, 0.0, zero_stack, 1.0, int_stack+556695, 1.0, int_stack+609910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+916805,int_stack+78510,int_stack+22845, 0.0, zero_stack, 1.0, int_stack+558855, 1.0, int_stack+612070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+78510,int_stack+916805,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+561655, 1.0, int_stack+614870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58980,int_stack+94795,int_stack+94480, 0.0, zero_stack, 1.0, int_stack+134180, 1.0, int_stack+143230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59925,int_stack+95215,int_stack+94795, 0.0, zero_stack, 1.0, int_stack+134810, 1.0, int_stack+143860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+59925,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+564805, 1.0, int_stack+618020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61185,int_stack+95755,int_stack+95215, 0.0, zero_stack, 1.0, int_stack+135650, 1.0, int_stack+144700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+916805,int_stack+61185,int_stack+59925, 0.0, zero_stack, 1.0, int_stack+565750, 1.0, int_stack+618965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21495,int_stack+916805,int_stack+82920, 0.0, zero_stack, 1.0, int_stack+567010, 1.0, int_stack+620225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58980,int_stack+96430,int_stack+95755, 0.0, zero_stack, 1.0, int_stack+136730, 1.0, int_stack+145780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+91425,int_stack+58980,int_stack+61185, 0.0, zero_stack, 1.0, int_stack+573415, 1.0, int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61005,int_stack+91425,int_stack+916805, 0.0, zero_stack, 1.0, int_stack+575035, 1.0, int_stack+628250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+916805,int_stack+61005,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+577555, 1.0, int_stack+630770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+21495,int_stack+97255,int_stack+96430, 0.0, zero_stack, 1.0, int_stack+138080, 1.0, int_stack+147130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+921530,int_stack+21495,int_stack+58980, 0.0, zero_stack, 1.0, int_stack+580705, 1.0, int_stack+633920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+925580,int_stack+921530,int_stack+91425, 0.0, zero_stack, 1.0, int_stack+582730, 1.0, int_stack+635945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+91425,int_stack+925580,int_stack+61005, 0.0, zero_stack, 1.0, int_stack+585970, 1.0, int_stack+639185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+921530,int_stack+91425,int_stack+916805, 0.0, zero_stack, 1.0, int_stack+590170, 1.0, int_stack+643385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+916805,int_stack+98455,int_stack+98245, 0.0, zero_stack, 2.0, int_stack+295585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+917435,int_stack+98735,int_stack+98455, 0.0, zero_stack, 2.0, int_stack+295795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+918275,int_stack+917435,int_stack+916805, 0.0, zero_stack, 2.0, int_stack+594895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+919535,int_stack+99095,int_stack+98735, 0.0, zero_stack, 2.0, int_stack+296075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+91425,int_stack+919535,int_stack+917435, 0.0, zero_stack, 2.0, int_stack+595525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+93105,int_stack+91425,int_stack+918275, 0.0, zero_stack, 2.0, int_stack+2700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+916805,int_stack+99545,int_stack+99095, 0.0, zero_stack, 2.0, int_stack+296435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+95205,int_stack+916805,int_stack+919535, 0.0, zero_stack, 2.0, int_stack+596365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+918155,int_stack+95205,int_stack+91425, 0.0, zero_stack, 2.0, int_stack+597445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+58980,int_stack+918155,int_stack+93105, 0.0, zero_stack, 2.0, int_stack+607810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+91425,int_stack+100095,int_stack+99545, 0.0, zero_stack, 2.0, int_stack+296885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+97365,int_stack+91425,int_stack+916805, 0.0, zero_stack, 2.0, int_stack+599125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+91425,int_stack+97365,int_stack+95205, 0.0, zero_stack, 2.0, int_stack+609910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+95025,int_stack+91425,int_stack+918155, 0.0, zero_stack, 2.0, int_stack+612070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+916805,int_stack+95025,int_stack+58980, 0.0, zero_stack, 2.0, int_stack+614870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58980,int_stack+101070,int_stack+100755, 0.0, zero_stack, 2.0, int_stack+143230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59925,int_stack+101490,int_stack+101070, 0.0, zero_stack, 2.0, int_stack+143860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+59925,int_stack+58980, 0.0, zero_stack, 2.0, int_stack+618020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61185,int_stack+102030,int_stack+101490, 0.0, zero_stack, 2.0, int_stack+144700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+91425,int_stack+61185,int_stack+59925, 0.0, zero_stack, 2.0, int_stack+618965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+93945,int_stack+91425,int_stack+82920, 0.0, zero_stack, 2.0, int_stack+620225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58980,int_stack+102705,int_stack+102030, 0.0, zero_stack, 2.0, int_stack+145780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+97095,int_stack+58980,int_stack+61185, 0.0, zero_stack, 2.0, int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61005,int_stack+97095,int_stack+91425, 0.0, zero_stack, 2.0, int_stack+628250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+61005,int_stack+93945, 0.0, zero_stack, 2.0, int_stack+630770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+91425,int_stack+103530,int_stack+102705, 0.0, zero_stack, 2.0, int_stack+147130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+100335,int_stack+91425,int_stack+58980, 0.0, zero_stack, 2.0, int_stack+633920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+91425,int_stack+100335,int_stack+97095, 0.0, zero_stack, 2.0, int_stack+635945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+96825,int_stack+91425,int_stack+61005, 0.0, zero_stack, 2.0, int_stack+639185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+928145,int_stack+96825,int_stack+21495, 0.0, zero_stack, 2.0, int_stack+643385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+104730,int_stack+104520, 1.0, int_stack+260445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304580,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+105010,int_stack+104730, 1.0, int_stack+260655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305070,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 1.0, int_stack+361185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648110,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+105370,int_stack+105010, 1.0, int_stack+260935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305710,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+91425,int_stack+24225,int_stack+22125, 1.0, int_stack+361815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648740,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+93105,int_stack+91425,int_stack+22965, 1.0, int_stack+362655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+649580,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+105820,int_stack+105370, 1.0, int_stack+261295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306520,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+95205,int_stack+21495,int_stack+24225, 1.0, int_stack+363915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650840,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+95205,int_stack+91425, 1.0, int_stack+364995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651920,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+97365,int_stack+22845,int_stack+93105, 1.0, int_stack+366675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661025,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+91425,int_stack+106370,int_stack+105820, 1.0, int_stack+261745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307520,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+100515,int_stack+91425,int_stack+21495, 1.0, int_stack+368775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344135,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+91425,int_stack+100515,int_stack+95205, 1.0, int_stack+370125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+663125,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+100515,int_stack+91425,int_stack+22845, 1.0, int_stack+372285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665285,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+91425,int_stack+100515,int_stack+97365, 1.0, int_stack+375085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345485,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+95835,int_stack+108080,int_stack+107345, 1.0, int_stack+107030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152595,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+96780,int_stack+109040,int_stack+108080, 1.0, int_stack+107660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153645,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+96780,int_stack+95835, 1.0, int_stack+408325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672495,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+98040,int_stack+110255,int_stack+109040, 1.0, int_stack+108500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155025,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+99660,int_stack+98040,int_stack+96780, 1.0, int_stack+409270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+673440,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+102180,int_stack+99660,int_stack+82920, 1.0, int_stack+410530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674700,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+95835,int_stack+111755,int_stack+110255, 1.0, int_stack+109580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156780,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+105330,int_stack+95835,int_stack+98040, 1.0, int_stack+412420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676590,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21495,int_stack+105330,int_stack+99660, 1.0, int_stack+414040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348635,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+58980,int_stack+21495,int_stack+102180, 1.0, int_stack+416560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678210,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+97860,int_stack+112580,int_stack+111755, 1.0, int_stack+110930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158130,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+100335,int_stack+97860,int_stack+95835, 1.0, int_stack+419710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378235,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+360335,int_stack+100335,int_stack+105330, 1.0, int_stack+421735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+681360,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+95835,int_stack+360335,int_stack+21495, 1.0, int_stack+424975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684600,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+360335,int_stack+95835,int_stack+58980, 1.0, int_stack+429175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688800,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58980,int_stack+113780,int_stack+113570, 1.0, int_stack+269230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304580, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59610,int_stack+114060,int_stack+113780, 1.0, int_stack+269440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305070, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+60450,int_stack+59610,int_stack+58980, 1.0, int_stack+433900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648110, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61710,int_stack+114420,int_stack+114060, 1.0, int_stack+269720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305710, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+62790,int_stack+61710,int_stack+59610, 1.0, int_stack+434530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648740, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+95835,int_stack+62790,int_stack+60450, 1.0, int_stack+435370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+649580, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58980,int_stack+114870,int_stack+114420, 1.0, int_stack+270080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306520, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+97935,int_stack+58980,int_stack+61710, 1.0, int_stack+436630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650840, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+100095,int_stack+97935,int_stack+62790, 1.0, int_stack+437710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651920, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+60330,int_stack+100095,int_stack+95835, 1.0, int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661025, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+115420,int_stack+114870, 1.0, int_stack+270530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307520, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+102895,int_stack+446815,int_stack+58980, 1.0, int_stack+448915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344135, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+105595,int_stack+102895,int_stack+97935, 1.0, int_stack+450265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+663125, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+446815,int_stack+105595,int_stack+100095, 1.0, int_stack+452425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665285, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+95835,int_stack+446815,int_stack+60330, 1.0, int_stack+455225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345485, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+117130,int_stack+116395, 1.0, int_stack+116080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152595, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+118090,int_stack+117130, 1.0, int_stack+116710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153645, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+447760,int_stack+446815, 1.0, int_stack+458375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672495, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+449020,int_stack+119305,int_stack+118090, 1.0, int_stack+117550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155025, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+450640,int_stack+449020,int_stack+447760, 1.0, int_stack+459320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+673440, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+453160,int_stack+450640,int_stack+82920, 1.0, int_stack+460580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674700, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+446815,int_stack+120805,int_stack+119305, 1.0, int_stack+118630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156780, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+456310,int_stack+446815,int_stack+449020, 1.0, int_stack+466985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676590, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+58980,int_stack+456310,int_stack+450640, 1.0, int_stack+468605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348635, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+58980,int_stack+453160, 1.0, int_stack+471125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678210, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+466985,int_stack+121630,int_stack+120805, 1.0, int_stack+119980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158130, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+469460,int_stack+466985,int_stack+446815, 1.0, int_stack+474275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378235, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+446815,int_stack+469460,int_stack+456310, 1.0, int_stack+476300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+681360, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+452215,int_stack+446815,int_stack+58980, 1.0, int_stack+479540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684600, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+466985,int_stack+452215,int_stack+21495, 1.0, int_stack+483740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688800, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+122830,int_stack+122620, 1.0, int_stack+278015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304580, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+123110,int_stack+122830, 1.0, int_stack+278225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305070, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 1.0, int_stack+488465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648110, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+123470,int_stack+123110, 1.0, int_stack+278505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305710, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+58980,int_stack+24225,int_stack+22125, 1.0, int_stack+489095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648740, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60660,int_stack+58980,int_stack+22965, 1.0, int_stack+489935, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+649580, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+123920,int_stack+123470, 1.0, int_stack+278865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306520, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+62760,int_stack+21495,int_stack+24225, 1.0, int_stack+491195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650840, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+62760,int_stack+58980, 1.0, int_stack+492275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651920, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+60660, 1.0, int_stack+501380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+661025, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+501380,int_stack+124470,int_stack+123920, 1.0, int_stack+279315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307520, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+58980,int_stack+501380,int_stack+21495, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+449965,int_stack+58980,int_stack+62760, 1.0, int_stack+503480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+663125, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+449965,int_stack+22845, 1.0, int_stack+505640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665285, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+449965,int_stack+58980,int_stack+446815, 1.0, int_stack+508440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345485, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+126180,int_stack+125445, 1.0, int_stack+125130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152595, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+127140,int_stack+126180, 1.0, int_stack+125760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153645, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+447760,int_stack+446815, 1.0, int_stack+511590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672495, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+58980,int_stack+128355,int_stack+127140, 1.0, int_stack+126600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155025, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+60600,int_stack+58980,int_stack+447760, 1.0, int_stack+512535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+673440, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+60600,int_stack+82920, 1.0, int_stack+513795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674700, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+63120,int_stack+129855,int_stack+128355, 1.0, int_stack+127680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156780, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+454375,int_stack+63120,int_stack+58980, 1.0, int_stack+520200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676590, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+457615,int_stack+454375,int_stack+60600, 1.0, int_stack+521820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348635, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+457615,int_stack+446815, 1.0, int_stack+524340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678210, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+130680,int_stack+129855, 1.0, int_stack+129030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158130, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+520200,int_stack+446815,int_stack+63120, 1.0, int_stack+527490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+58980,int_stack+520200,int_stack+454375, 1.0, int_stack+529515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+681360, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+520200,int_stack+58980,int_stack+457615, 1.0, int_stack+532755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+454375,int_stack+520200,int_stack+21495, 1.0, int_stack+536955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688800, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+131880,int_stack+131670, 1.0, int_stack+286800, 0.0, zero_stack, 1.0, int_stack+304580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+132160,int_stack+131880, 1.0, int_stack+287010, 0.0, zero_stack, 1.0, int_stack+305070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 1.0, int_stack+541680, 0.0, zero_stack, 1.0, int_stack+648110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+132520,int_stack+132160, 1.0, int_stack+287290, 0.0, zero_stack, 1.0, int_stack+305710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+520200,int_stack+24225,int_stack+22125, 1.0, int_stack+542310, 0.0, zero_stack, 1.0, int_stack+648740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+521880,int_stack+520200,int_stack+22965, 1.0, int_stack+543150, 0.0, zero_stack, 1.0, int_stack+649580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+132970,int_stack+132520, 1.0, int_stack+287650, 0.0, zero_stack, 1.0, int_stack+306520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21495,int_stack+0,int_stack+24225, 1.0, int_stack+544410, 0.0, zero_stack, 1.0, int_stack+650840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+523980,int_stack+21495,int_stack+520200, 1.0, int_stack+545490, 0.0, zero_stack, 1.0, int_stack+651920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+523980,int_stack+521880, 1.0, int_stack+554595, 0.0, zero_stack, 1.0, int_stack+661025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+554595,int_stack+133520,int_stack+132970, 1.0, int_stack+288100, 0.0, zero_stack, 1.0, int_stack+307520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+520200,int_stack+554595,int_stack+0, 1.0, int_stack+1350, 0.0, zero_stack, 1.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+526780,int_stack+520200,int_stack+21495, 1.0, int_stack+556695, 0.0, zero_stack, 1.0, int_stack+663125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21495,int_stack+526780,int_stack+523980, 1.0, int_stack+558855, 0.0, zero_stack, 1.0, int_stack+665285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+520200,int_stack+21495,int_stack+446815, 1.0, int_stack+561655, 0.0, zero_stack, 1.0, int_stack+345485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+135230,int_stack+134495, 1.0, int_stack+134180, 0.0, zero_stack, 1.0, int_stack+152595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+136190,int_stack+135230, 1.0, int_stack+134810, 0.0, zero_stack, 1.0, int_stack+153645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+447760,int_stack+446815, 1.0, int_stack+564805, 0.0, zero_stack, 1.0, int_stack+672495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21495,int_stack+137405,int_stack+136190, 1.0, int_stack+135650, 0.0, zero_stack, 1.0, int_stack+155025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+23115,int_stack+21495,int_stack+447760, 1.0, int_stack+565750, 0.0, zero_stack, 1.0, int_stack+673440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+23115,int_stack+82920, 1.0, int_stack+567010, 0.0, zero_stack, 1.0, int_stack+674700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+524610,int_stack+138905,int_stack+137405, 1.0, int_stack+136730, 0.0, zero_stack, 1.0, int_stack+156780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+526635,int_stack+524610,int_stack+21495, 1.0, int_stack+573415, 0.0, zero_stack, 1.0, int_stack+676590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+529875,int_stack+526635,int_stack+23115, 1.0, int_stack+575035, 0.0, zero_stack, 1.0, int_stack+348635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+529875,int_stack+446815, 1.0, int_stack+577555, 0.0, zero_stack, 1.0, int_stack+678210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+139730,int_stack+138905, 1.0, int_stack+138080, 0.0, zero_stack, 1.0, int_stack+158130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+573415,int_stack+446815,int_stack+524610, 1.0, int_stack+580705, 0.0, zero_stack, 1.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+534075,int_stack+573415,int_stack+526635, 1.0, int_stack+582730, 0.0, zero_stack, 1.0, int_stack+681360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+534075,int_stack+529875, 1.0, int_stack+585970, 0.0, zero_stack, 1.0, int_stack+684600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+573415,int_stack+58980,int_stack+21495, 1.0, int_stack+590170, 0.0, zero_stack, 1.0, int_stack+688800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+140930,int_stack+140720, 1.0, int_stack+295585, 1.0, int_stack+304580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+141210,int_stack+140930, 1.0, int_stack+295795, 1.0, int_stack+305070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 1.0, int_stack+594895, 1.0, int_stack+648110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+141570,int_stack+141210, 1.0, int_stack+296075, 1.0, int_stack+305710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+58980,int_stack+24225,int_stack+22125, 1.0, int_stack+595525, 1.0, int_stack+648740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60660,int_stack+58980,int_stack+22965, 1.0, int_stack+2700, 1.0, int_stack+649580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+142020,int_stack+141570, 1.0, int_stack+296435, 1.0, int_stack+306520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+62760,int_stack+21495,int_stack+24225, 1.0, int_stack+596365, 1.0, int_stack+650840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+62760,int_stack+58980, 1.0, int_stack+597445, 1.0, int_stack+651920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+60660, 1.0, int_stack+607810, 1.0, int_stack+661025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+607810,int_stack+142570,int_stack+142020, 1.0, int_stack+296885, 1.0, int_stack+307520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+58980,int_stack+607810,int_stack+21495, 1.0, int_stack+599125, 1.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+580030,int_stack+58980,int_stack+62760, 1.0, int_stack+609910, 1.0, int_stack+663125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+580030,int_stack+22845, 1.0, int_stack+612070, 1.0, int_stack+665285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+580030,int_stack+58980,int_stack+446815, 1.0, int_stack+614870, 1.0, int_stack+345485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+144280,int_stack+143545, 1.0, int_stack+143230, 1.0, int_stack+152595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+145240,int_stack+144280, 1.0, int_stack+143860, 1.0, int_stack+153645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+447760,int_stack+446815, 1.0, int_stack+618020, 1.0, int_stack+672495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+58980,int_stack+146455,int_stack+145240, 1.0, int_stack+144700, 1.0, int_stack+155025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+60600,int_stack+58980,int_stack+447760, 1.0, int_stack+618965, 1.0, int_stack+673440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+60600,int_stack+82920, 1.0, int_stack+620225, 1.0, int_stack+674700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+63120,int_stack+147955,int_stack+146455, 1.0, int_stack+145780, 1.0, int_stack+156780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+584440,int_stack+63120,int_stack+58980, 1.0, int_stack+626630, 1.0, int_stack+676590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+587680,int_stack+584440,int_stack+60600, 1.0, int_stack+628250, 1.0, int_stack+348635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+587680,int_stack+446815, 1.0, int_stack+630770, 1.0, int_stack+678210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+148780,int_stack+147955, 1.0, int_stack+147130, 1.0, int_stack+158130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+63120, 1.0, int_stack+633920, 1.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+58980,int_stack+626630,int_stack+584440, 1.0, int_stack+635945, 1.0, int_stack+681360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+58980,int_stack+587680, 1.0, int_stack+639185, 1.0, int_stack+684600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+584440,int_stack+626630,int_stack+21495, 1.0, int_stack+643385, 1.0, int_stack+688800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+149980,int_stack+149770, 2.0, int_stack+304580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+150260,int_stack+149980, 2.0, int_stack+305070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 2.0, int_stack+648110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+150620,int_stack+150260, 2.0, int_stack+305710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+24225,int_stack+22125, 2.0, int_stack+648740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+628310,int_stack+626630,int_stack+22965, 2.0, int_stack+649580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+151070,int_stack+150620, 2.0, int_stack+306520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+630410,int_stack+21495,int_stack+24225, 2.0, int_stack+650840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+630410,int_stack+626630, 2.0, int_stack+651920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+628310, 2.0, int_stack+661025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+661025,int_stack+151620,int_stack+151070, 2.0, int_stack+307520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+661025,int_stack+21495, 2.0, int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+632570,int_stack+626630,int_stack+630410, 2.0, int_stack+663125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+632570,int_stack+22845, 2.0, int_stack+665285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+630830,int_stack+626630,int_stack+446815, 2.0, int_stack+345485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+154065,int_stack+152910, 2.0, int_stack+152595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+155565,int_stack+154065, 2.0, int_stack+153645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82920,int_stack+447760,int_stack+446815, 2.0, int_stack+672495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+157455,int_stack+155565, 2.0, int_stack+155025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+447760, 2.0, int_stack+673440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+628250,int_stack+82920, 2.0, int_stack+674700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+672495,int_stack+158955,int_stack+157455, 2.0, int_stack+156780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+635240,int_stack+672495,int_stack+626630, 2.0, int_stack+676590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+638480,int_stack+635240,int_stack+628250, 2.0, int_stack+348635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+638480,int_stack+446815, 2.0, int_stack+678210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+159780,int_stack+158955, 2.0, int_stack+158130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+672495, 2.0, int_stack+378235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+672495,int_stack+626630,int_stack+635240, 2.0, int_stack+681360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+58980,int_stack+672495,int_stack+638480, 2.0, int_stack+684600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+672495,int_stack+58980,int_stack+21495, 2.0, int_stack+688800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+160980,int_stack+160770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317780,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+161260,int_stack+160980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317990,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+161620,int_stack+161260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318270,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+58980,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387475,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60660,int_stack+58980,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388315,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+162070,int_stack+161620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318630,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+62760,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389575,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+62760,int_stack+58980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390655,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399760,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+58980,int_stack+162620,int_stack+162070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319080,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+679110,int_stack+58980,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401860,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+58980,int_stack+679110,int_stack+62760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403210,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+58980,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405370,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+58980,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351155,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+163595,int_stack+163280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194655,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+164015,int_stack+163595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195285,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63390,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697935,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+164555,int_stack+164015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196125,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698880,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+628250,int_stack+63390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700140,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+679110,int_stack+165230,int_stack+164555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197205,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+681135,int_stack+679110,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+684375,int_stack+681135,int_stack+628250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3960,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+684375,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702030,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+166055,int_stack+165230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198555,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+679110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380260,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+635240,int_stack+626630,int_stack+681135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+640640,int_stack+635240,int_stack+684375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708420,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+679110,int_stack+640640,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712620,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+167255,int_stack+167045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317780, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+167535,int_stack+167255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317990, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+167895,int_stack+167535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318270, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+635240,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387475, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+636920,int_stack+635240,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388315, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+168345,int_stack+167895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318630, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+639020,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389575, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+639020,int_stack+635240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390655, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+636920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399760, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+635240,int_stack+168895,int_stack+168345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319080, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+641180,int_stack+635240,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401860, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+635240,int_stack+641180,int_stack+639020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403210, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+635240,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405370, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+635240,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351155, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+169870,int_stack+169555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194655, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+170290,int_stack+169870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195285, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63390,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697935, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+170830,int_stack+170290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196125, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698880, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+628250,int_stack+63390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700140, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+639650,int_stack+171505,int_stack+170830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197205, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+641675,int_stack+639650,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358715, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+644915,int_stack+641675,int_stack+628250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3960, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+644915,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702030, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+172330,int_stack+171505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198555, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+639650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380260, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+685725,int_stack+626630,int_stack+641675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+344135,int_stack+685725,int_stack+644915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708420, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+685725,int_stack+344135,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712620, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+173530,int_stack+173320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317780, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+173810,int_stack+173530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317990, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+174170,int_stack+173810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318270, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+344135,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387475, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+345815,int_stack+344135,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388315, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+174620,int_stack+174170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318630, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+347915,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389575, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+347915,int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390655, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+345815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399760, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+344135,int_stack+175170,int_stack+174620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319080, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+344135,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401860, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+344135,int_stack+626630,int_stack+347915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403210, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+344135,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405370, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+344135,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351155, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+176145,int_stack+175830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194655, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+176565,int_stack+176145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195285, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63390,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697935, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+177105,int_stack+176565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196125, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698880, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+628250,int_stack+63390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+348545,int_stack+177780,int_stack+177105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197205, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21495,int_stack+348545,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358715, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+639650,int_stack+21495,int_stack+628250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3960, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+643850,int_stack+639650,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702030, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+178605,int_stack+177780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198555, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+348545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380260, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+648575,int_stack+626630,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+661025,int_stack+648575,int_stack+639650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708420, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+591055,int_stack+661025,int_stack+643850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712620, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+661025,int_stack+179805,int_stack+179595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+661655,int_stack+180085,int_stack+179805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+662495,int_stack+661655,int_stack+661025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+663755,int_stack+180445,int_stack+180085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+664835,int_stack+663755,int_stack+661655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+639650,int_stack+664835,int_stack+662495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+661025,int_stack+180895,int_stack+180445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+641750,int_stack+661025,int_stack+663755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+643910,int_stack+641750,int_stack+664835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+643910,int_stack+639650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+639650,int_stack+181445,int_stack+180895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+662375,int_stack+639650,int_stack+661025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+646710,int_stack+662375,int_stack+641750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+646710,int_stack+643910, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+661025,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+182420,int_stack+182105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+182840,int_stack+182420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63390,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+183380,int_stack+182840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+698880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+628250,int_stack+63390, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+665435,int_stack+184055,int_stack+183380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+639650,int_stack+665435,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+642890,int_stack+639650,int_stack+628250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+642890,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+184880,int_stack+184055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+665435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+647090,int_stack+626630,int_stack+639650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+607810,int_stack+647090,int_stack+642890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+639650,int_stack+607810,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+186080,int_stack+185870, 0.0, zero_stack, 1.0, int_stack+317780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+186360,int_stack+186080, 0.0, zero_stack, 1.0, int_stack+317990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+186720,int_stack+186360, 0.0, zero_stack, 1.0, int_stack+318270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+607810,int_stack+24225,int_stack+22125, 0.0, zero_stack, 1.0, int_stack+387475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+609490,int_stack+607810,int_stack+22965, 0.0, zero_stack, 1.0, int_stack+388315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+187170,int_stack+186720, 0.0, zero_stack, 1.0, int_stack+318630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+611590,int_stack+21495,int_stack+24225, 0.0, zero_stack, 1.0, int_stack+389575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+611590,int_stack+607810, 0.0, zero_stack, 1.0, int_stack+390655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+609490, 0.0, zero_stack, 1.0, int_stack+399760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+607810,int_stack+187720,int_stack+187170, 0.0, zero_stack, 1.0, int_stack+319080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+613750,int_stack+607810,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+401860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+607810,int_stack+613750,int_stack+611590, 0.0, zero_stack, 1.0, int_stack+403210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+607810,int_stack+22845, 0.0, zero_stack, 1.0, int_stack+405370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+607810,int_stack+626630,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+351155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+188695,int_stack+188380, 0.0, zero_stack, 1.0, int_stack+194655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+189115,int_stack+188695, 0.0, zero_stack, 1.0, int_stack+195285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63390,int_stack+447760,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+697935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+189655,int_stack+189115, 0.0, zero_stack, 1.0, int_stack+196125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+447760, 0.0, zero_stack, 1.0, int_stack+698880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+628250,int_stack+63390, 0.0, zero_stack, 1.0, int_stack+700140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+612220,int_stack+190330,int_stack+189655, 0.0, zero_stack, 1.0, int_stack+197205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+614245,int_stack+612220,int_stack+626630, 0.0, zero_stack, 1.0, int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+617485,int_stack+614245,int_stack+628250, 0.0, zero_stack, 1.0, int_stack+3960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+617485,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+702030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+191155,int_stack+190330, 0.0, zero_stack, 1.0, int_stack+198555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+612220, 0.0, zero_stack, 1.0, int_stack+380260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+646265,int_stack+626630,int_stack+614245, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+524610,int_stack+646265,int_stack+617485, 0.0, zero_stack, 1.0, int_stack+708420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+646265,int_stack+524610,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+712620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+192355,int_stack+192145, 1.0, int_stack+317780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+192635,int_stack+192355, 1.0, int_stack+317990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 1.0, int_stack+386845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+192995,int_stack+192635, 1.0, int_stack+318270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+524610,int_stack+24225,int_stack+22125, 1.0, int_stack+387475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+526290,int_stack+524610,int_stack+22965, 1.0, int_stack+388315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+386845,int_stack+193445,int_stack+192995, 1.0, int_stack+318630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21495,int_stack+386845,int_stack+24225, 1.0, int_stack+389575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+528390,int_stack+21495,int_stack+524610, 1.0, int_stack+390655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+528390,int_stack+526290, 1.0, int_stack+399760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+399760,int_stack+193995,int_stack+193445, 1.0, int_stack+319080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+524610,int_stack+399760,int_stack+386845, 1.0, int_stack+401860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+386845,int_stack+524610,int_stack+21495, 1.0, int_stack+403210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+386845,int_stack+528390, 1.0, int_stack+405370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+386845,int_stack+626630,int_stack+446815, 1.0, int_stack+351155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+195705,int_stack+194970, 1.0, int_stack+194655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+196665,int_stack+195705, 1.0, int_stack+195285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 1.0, int_stack+697935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+626630,int_stack+197880,int_stack+196665, 1.0, int_stack+196125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628250,int_stack+626630,int_stack+447760, 1.0, int_stack+698880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+628250,int_stack+391255, 1.0, int_stack+700140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+697935,int_stack+199380,int_stack+197880, 1.0, int_stack+197205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21495,int_stack+697935,int_stack+626630, 1.0, int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+524610,int_stack+21495,int_stack+628250, 1.0, int_stack+3960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+528810,int_stack+524610,int_stack+446815, 1.0, int_stack+702030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+200205,int_stack+199380, 1.0, int_stack+198555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+697935, 1.0, int_stack+380260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+697935,int_stack+626630,int_stack+21495, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+533535,int_stack+697935,int_stack+524610, 1.0, int_stack+708420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+697935,int_stack+533535,int_stack+528810, 1.0, int_stack+712620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+524610,int_stack+201405,int_stack+201195,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+525240,int_stack+201685,int_stack+201405,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+526080,int_stack+525240,int_stack+524610,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+527340,int_stack+202045,int_stack+201685,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+528420,int_stack+527340,int_stack+525240,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+530100,int_stack+528420,int_stack+526080,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+524610,int_stack+202495,int_stack+202045,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+532200,int_stack+524610,int_stack+527340,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+534360,int_stack+532200,int_stack+528420,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+534360,int_stack+530100,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+525960,int_stack+203045,int_stack+202495,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+527610,int_stack+525960,int_stack+524610,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+537160,int_stack+527610,int_stack+532200,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+537160,int_stack+534360,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+524610,int_stack+626630,int_stack+446815,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+204020,int_stack+203705,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+204440,int_stack+204020,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+204980,int_stack+204440,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+529020,int_stack+205655,int_stack+204980,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+531045,int_stack+529020,int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+534285,int_stack+531045,int_stack+626630,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+534285,int_stack+446815,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+206480,int_stack+205655,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+529020,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+538485,int_stack+626630,int_stack+531045,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+704550,int_stack+538485,int_stack+534285,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+529020,int_stack+704550,int_stack+21495,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+207680,int_stack+207470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326565,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+207960,int_stack+207680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326775,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717345,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+208320,int_stack+207960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327055,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+704550,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717975,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+706230,int_stack+704550,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718815,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+208770,int_stack+208320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327415,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+708330,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720075,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+708330,int_stack+704550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721155,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+706230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730260,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+704550,int_stack+209320,int_stack+208770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327865,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+710490,int_stack+704550,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732360,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+704550,int_stack+710490,int_stack+708330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+733710,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+704550,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735870,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+704550,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738670,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+210295,int_stack+209980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241355,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+210715,int_stack+210295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241985,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741820,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+211255,int_stack+210715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242825,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742765,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744025,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+708960,int_stack+211930,int_stack+211255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243905,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+710985,int_stack+708960,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750430,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21495,int_stack+710985,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+752050,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+535635,int_stack+21495,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754570,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+212755,int_stack+211930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245255,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+708960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+757720,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+540360,int_stack+626630,int_stack+710985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759745,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+708960,int_stack+540360,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762985,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+540360,int_stack+708960,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767185,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+535635,int_stack+213955,int_stack+213745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326565, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536265,int_stack+214235,int_stack+213955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326775, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+537105,int_stack+536265,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717345, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+538365,int_stack+214595,int_stack+214235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327055, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+708960,int_stack+538365,int_stack+536265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717975, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+710640,int_stack+708960,int_stack+537105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718815, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+535635,int_stack+215045,int_stack+214595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327415, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+712740,int_stack+535635,int_stack+538365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720075, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+536985,int_stack+712740,int_stack+708960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721155, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+536985,int_stack+710640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730260, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+708960,int_stack+215595,int_stack+215045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327865, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+21495,int_stack+708960,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732360, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+708960,int_stack+21495,int_stack+712740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+733710, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+708960,int_stack+536985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735870, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+708960,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738670, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+216570,int_stack+216255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241355, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+216990,int_stack+216570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241985, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741820, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+217530,int_stack+216990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242825, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742765, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744025, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+713370,int_stack+218205,int_stack+217530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243905, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21495,int_stack+713370,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750430, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+535635,int_stack+21495,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+752050, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+399760,int_stack+535635,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754570, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+219030,int_stack+218205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245255, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+713370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+757720, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+404485,int_stack+626630,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759745, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+409885,int_stack+404485,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762985, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+416185,int_stack+409885,int_stack+399760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767185, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+399760,int_stack+220230,int_stack+220020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326565, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+400390,int_stack+220510,int_stack+220230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326775, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+401230,int_stack+400390,int_stack+399760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717345, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+402490,int_stack+220870,int_stack+220510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327055, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+403570,int_stack+402490,int_stack+400390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717975, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+405250,int_stack+403570,int_stack+401230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718815, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+399760,int_stack+221320,int_stack+220870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327415, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+407350,int_stack+399760,int_stack+402490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720075, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+409510,int_stack+407350,int_stack+403570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721155, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+409510,int_stack+405250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730260, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+401110,int_stack+221870,int_stack+221320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327865, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+402760,int_stack+401110,int_stack+399760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732360, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+412310,int_stack+402760,int_stack+407350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+733710, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+412310,int_stack+409510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735870, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+399760,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738670, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+222845,int_stack+222530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241355, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+223265,int_stack+222845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241985, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741820, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+223805,int_stack+223265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242825, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742765, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744025, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+404170,int_stack+224480,int_stack+223805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243905, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+406195,int_stack+404170,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750430, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+409435,int_stack+406195,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+752050, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+535635,int_stack+409435,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754570, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+225305,int_stack+224480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245255, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+404170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+757720, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+422800,int_stack+626630,int_stack+406195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759745, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+428200,int_stack+422800,int_stack+409435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762985, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+404170,int_stack+428200,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767185, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+535635,int_stack+226505,int_stack+226295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536265,int_stack+226785,int_stack+226505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+537105,int_stack+536265,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+538365,int_stack+227145,int_stack+226785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+422800,int_stack+538365,int_stack+536265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+424480,int_stack+422800,int_stack+537105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+535635,int_stack+227595,int_stack+227145, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+426580,int_stack+535635,int_stack+538365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+536985,int_stack+426580,int_stack+422800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+536985,int_stack+424480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+422800,int_stack+228145,int_stack+227595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+428740,int_stack+422800,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+422800,int_stack+428740,int_stack+426580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+733710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+422800,int_stack+536985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+735870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+422800,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+229120,int_stack+228805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+229540,int_stack+229120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+741820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+230080,int_stack+229540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+427210,int_stack+230755,int_stack+230080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+429235,int_stack+427210,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+432475,int_stack+429235,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+752050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+535635,int_stack+432475,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+231580,int_stack+230755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+427210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+757720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+410785,int_stack+626630,int_stack+429235, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+612220,int_stack+410785,int_stack+432475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+762985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+427210,int_stack+612220,int_stack+535635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+535635,int_stack+232780,int_stack+232570, 0.0, zero_stack, 1.0, int_stack+326565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+536265,int_stack+233060,int_stack+232780, 0.0, zero_stack, 1.0, int_stack+326775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+537105,int_stack+536265,int_stack+535635, 0.0, zero_stack, 1.0, int_stack+717345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+538365,int_stack+233420,int_stack+233060, 0.0, zero_stack, 1.0, int_stack+327055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+612220,int_stack+538365,int_stack+536265, 0.0, zero_stack, 1.0, int_stack+717975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+613900,int_stack+612220,int_stack+537105, 0.0, zero_stack, 1.0, int_stack+718815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+535635,int_stack+233870,int_stack+233420, 0.0, zero_stack, 1.0, int_stack+327415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+616000,int_stack+535635,int_stack+538365, 0.0, zero_stack, 1.0, int_stack+720075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+536985,int_stack+616000,int_stack+612220, 0.0, zero_stack, 1.0, int_stack+721155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+536985,int_stack+613900, 0.0, zero_stack, 1.0, int_stack+730260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+612220,int_stack+234420,int_stack+233870, 0.0, zero_stack, 1.0, int_stack+327865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+618160,int_stack+612220,int_stack+535635, 0.0, zero_stack, 1.0, int_stack+732360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+612220,int_stack+618160,int_stack+616000, 0.0, zero_stack, 1.0, int_stack+733710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+612220,int_stack+536985, 0.0, zero_stack, 1.0, int_stack+735870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+612220,int_stack+626630,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+738670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+235395,int_stack+235080, 0.0, zero_stack, 1.0, int_stack+241355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+235815,int_stack+235395, 0.0, zero_stack, 1.0, int_stack+241985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+741820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+236355,int_stack+235815, 0.0, zero_stack, 1.0, int_stack+242825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 1.0, int_stack+742765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 1.0, int_stack+744025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+616630,int_stack+237030,int_stack+236355, 0.0, zero_stack, 1.0, int_stack+243905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+618655,int_stack+616630,int_stack+358715, 0.0, zero_stack, 1.0, int_stack+750430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+535635,int_stack+618655,int_stack+626630, 0.0, zero_stack, 1.0, int_stack+752050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+535635,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+754570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+237855,int_stack+237030, 0.0, zero_stack, 1.0, int_stack+245255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+616630, 0.0, zero_stack, 1.0, int_stack+757720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+410785,int_stack+626630,int_stack+618655, 0.0, zero_stack, 1.0, int_stack+759745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+433825,int_stack+410785,int_stack+535635, 0.0, zero_stack, 1.0, int_stack+762985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+554595,int_stack+433825,int_stack+21495, 0.0, zero_stack, 1.0, int_stack+767185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+239055,int_stack+238845, 1.0, int_stack+326565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+239335,int_stack+239055, 1.0, int_stack+326775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 1.0, int_stack+717345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+239695,int_stack+239335, 1.0, int_stack+327055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+433825,int_stack+24225,int_stack+22125, 1.0, int_stack+717975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+435505,int_stack+433825,int_stack+22965, 1.0, int_stack+718815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+240145,int_stack+239695, 1.0, int_stack+327415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+437605,int_stack+21495,int_stack+24225, 1.0, int_stack+720075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+437605,int_stack+433825, 1.0, int_stack+721155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+435505, 1.0, int_stack+730260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+730260,int_stack+240695,int_stack+240145, 1.0, int_stack+327865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+433825,int_stack+730260,int_stack+21495, 1.0, int_stack+732360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+535635,int_stack+433825,int_stack+437605, 1.0, int_stack+733710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+535635,int_stack+22845, 1.0, int_stack+735870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+535635,int_stack+626630,int_stack+446815, 1.0, int_stack+738670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+242405,int_stack+241670, 1.0, int_stack+241355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+243365,int_stack+242405, 1.0, int_stack+241985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 1.0, int_stack+741820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+244580,int_stack+243365, 1.0, int_stack+242825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 1.0, int_stack+742765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 1.0, int_stack+744025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+433825,int_stack+246080,int_stack+244580, 1.0, int_stack+243905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+435850,int_stack+433825,int_stack+358715, 1.0, int_stack+750430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21495,int_stack+435850,int_stack+626630, 1.0, int_stack+752050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+730260,int_stack+21495,int_stack+446815, 1.0, int_stack+754570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+246905,int_stack+246080, 1.0, int_stack+245255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+433825, 1.0, int_stack+757720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+410785,int_stack+626630,int_stack+435850, 1.0, int_stack+759745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+433825,int_stack+410785,int_stack+21495, 1.0, int_stack+762985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+750430,int_stack+433825,int_stack+730260, 1.0, int_stack+767185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+730260,int_stack+248105,int_stack+247895,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+730890,int_stack+248385,int_stack+248105,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+731730,int_stack+730890,int_stack+730260,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+732990,int_stack+248745,int_stack+248385,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+734070,int_stack+732990,int_stack+730890,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+735750,int_stack+734070,int_stack+731730,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+730260,int_stack+249195,int_stack+248745,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+737850,int_stack+730260,int_stack+732990,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+740010,int_stack+737850,int_stack+734070,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+740010,int_stack+735750,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+731610,int_stack+249745,int_stack+249195,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+733260,int_stack+731610,int_stack+730260,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+433825,int_stack+733260,int_stack+737850,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+433825,int_stack+740010,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+433825,int_stack+626630,int_stack+446815,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+250720,int_stack+250405,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+251140,int_stack+250720,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+251680,int_stack+251140,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+730260,int_stack+252355,int_stack+251680,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+732285,int_stack+730260,int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+735525,int_stack+732285,int_stack+626630,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+735525,int_stack+446815,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+253180,int_stack+252355,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+730260,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+410785,int_stack+626630,int_stack+732285,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+757045,int_stack+410785,int_stack+735525,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+730260,int_stack+757045,int_stack+21495,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+254380,int_stack+254170,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+254660,int_stack+254380,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+255020,int_stack+254660,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+757045,int_stack+24225,int_stack+22125,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+758725,int_stack+757045,int_stack+22965,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+255470,int_stack+255020,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+760825,int_stack+21495,int_stack+24225,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+760825,int_stack+757045,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+758725,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+757045,int_stack+256020,int_stack+255470,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+762985,int_stack+757045,int_stack+21495,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+757045,int_stack+762985,int_stack+760825,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+757045,int_stack+22845,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+757045,int_stack+626630,int_stack+446815,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+256995,int_stack+256680,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+257415,int_stack+256995,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+257955,int_stack+257415,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+761455,int_stack+258630,int_stack+257955,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+763480,int_stack+761455,int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+766720,int_stack+763480,int_stack+626630,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+766720,int_stack+446815,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+259455,int_stack+258630,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+761455,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+410785,int_stack+626630,int_stack+763480,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+736875,int_stack+410785,int_stack+766720,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+761455,int_stack+736875,int_stack+21495,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+263165,int_stack+262955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335350,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+263445,int_stack+263165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335560,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+771910,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+263805,int_stack+263445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335840,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+736875,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772540,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+738555,int_stack+736875,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773380,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+264255,int_stack+263805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336200,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+740655,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774640,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+740655,int_stack+736875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775720,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+738555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6480,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+736875,int_stack+264805,int_stack+264255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336650,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+742815,int_stack+736875,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784825,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+736875,int_stack+742815,int_stack+740655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+786175,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+736875,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788335,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+736875,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791135,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+265780,int_stack+265465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311240,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+266200,int_stack+265780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311870,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+794285,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+266740,int_stack+266200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312710,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795230,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796490,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+741285,int_stack+267415,int_stack+266740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313790,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21495,int_stack+741285,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802895,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+410785,int_stack+21495,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804515,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+616630,int_stack+410785,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807035,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+268240,int_stack+267415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315140,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+741285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810185,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+713370,int_stack+626630,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812210,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+713370,int_stack+410785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815450,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+713370,int_stack+0,int_stack+616630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819650,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+616630,int_stack+271950,int_stack+271740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335350, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+617260,int_stack+272230,int_stack+271950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335560, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+618100,int_stack+617260,int_stack+616630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+771910, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+619360,int_stack+272590,int_stack+272230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335840, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+620440,int_stack+619360,int_stack+617260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772540, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+620440,int_stack+618100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773380, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+616630,int_stack+273040,int_stack+272590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336200, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2100,int_stack+616630,int_stack+619360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774640, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+410785,int_stack+2100,int_stack+620440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775720, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+410785,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6480, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+273590,int_stack+273040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336650, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+617980,int_stack+0,int_stack+616630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784825, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+719985,int_stack+617980,int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+786175, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+719985,int_stack+410785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788335, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+410785,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791135, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+274565,int_stack+274250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311240, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+274985,int_stack+274565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311870, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+794285, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+275525,int_stack+274985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312710, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795230, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796490, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+719985,int_stack+276200,int_stack+275525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313790, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+616630,int_stack+719985,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802895, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+616630,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804515, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21495,int_stack+0,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807035, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+277025,int_stack+276200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315140, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+719985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810185, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+348545,int_stack+626630,int_stack+616630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812210, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+561210,int_stack+348545,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815450, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+501380,int_stack+561210,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819650, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21495,int_stack+280735,int_stack+280525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335350, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+22125,int_stack+281015,int_stack+280735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335560, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22965,int_stack+22125,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+771910, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24225,int_stack+281375,int_stack+281015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335840, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+561210,int_stack+24225,int_stack+22125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772540, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+562890,int_stack+561210,int_stack+22965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773380, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21495,int_stack+281825,int_stack+281375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336200, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+564990,int_stack+21495,int_stack+24225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774640, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22845,int_stack+564990,int_stack+561210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775720, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+22845,int_stack+562890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+561210,int_stack+282375,int_stack+281825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336650, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+561210,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+561210,int_stack+0,int_stack+564990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+786175, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+561210,int_stack+22845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788335, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+561210,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791135, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+283350,int_stack+283035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311240, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+283770,int_stack+283350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311870, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+794285, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+284310,int_stack+283770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312710, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795230, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796490, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+565620,int_stack+284985,int_stack+284310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313790, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+565620,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802895, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21495,int_stack+0,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804515, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+348545,int_stack+21495,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807035, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+285810,int_stack+284985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+565620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810185, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+616630,int_stack+626630,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812210, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+616630,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815450, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+507995,int_stack+0,int_stack+348545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819650, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+348545,int_stack+289520,int_stack+289310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+349175,int_stack+289800,int_stack+289520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+350015,int_stack+349175,int_stack+348545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+771910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+351275,int_stack+290160,int_stack+289800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+352355,int_stack+351275,int_stack+349175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+352355,int_stack+350015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+348545,int_stack+290610,int_stack+290160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2100,int_stack+348545,int_stack+351275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21495,int_stack+2100,int_stack+352355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+21495,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+291160,int_stack+290610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+349895,int_stack+0,int_stack+348545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+616630,int_stack+349895,int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+786175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+616630,int_stack+21495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+21495,int_stack+626630,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+292135,int_stack+291820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+292555,int_stack+292135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+794285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+293095,int_stack+292555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+616630,int_stack+293770,int_stack+293095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+618655,int_stack+616630,int_stack+358715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+348545,int_stack+618655,int_stack+626630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+348545,int_stack+446815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+294595,int_stack+293770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+616630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+473600,int_stack+626630,int_stack+618655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+479000,int_stack+473600,int_stack+348545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+485300,int_stack+479000,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+298305,int_stack+298095, 0.0, zero_stack, 1.0, int_stack+335350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+630,int_stack+298585,int_stack+298305, 0.0, zero_stack, 1.0, int_stack+335560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1470,int_stack+630,int_stack+0, 0.0, zero_stack, 1.0, int_stack+771910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2730,int_stack+298945,int_stack+298585, 0.0, zero_stack, 1.0, int_stack+335840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3810,int_stack+2730,int_stack+630, 0.0, zero_stack, 1.0, int_stack+772540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+348545,int_stack+3810,int_stack+1470, 0.0, zero_stack, 1.0, int_stack+773380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+299395,int_stack+298945, 0.0, zero_stack, 1.0, int_stack+336200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+350645,int_stack+0,int_stack+2730, 0.0, zero_stack, 1.0, int_stack+774640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+473600,int_stack+350645,int_stack+3810, 0.0, zero_stack, 1.0, int_stack+775720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+473600,int_stack+348545, 0.0, zero_stack, 1.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+348545,int_stack+299945,int_stack+299395, 0.0, zero_stack, 1.0, int_stack+336650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1350,int_stack+348545,int_stack+0, 0.0, zero_stack, 1.0, int_stack+784825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+476400,int_stack+1350,int_stack+350645, 0.0, zero_stack, 1.0, int_stack+786175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+476400,int_stack+473600, 0.0, zero_stack, 1.0, int_stack+788335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+473600,int_stack+626630,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+791135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+300920,int_stack+300605, 0.0, zero_stack, 1.0, int_stack+311240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+301340,int_stack+300920, 0.0, zero_stack, 1.0, int_stack+311870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+794285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+301880,int_stack+301340, 0.0, zero_stack, 1.0, int_stack+312710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 0.0, zero_stack, 1.0, int_stack+795230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 0.0, zero_stack, 1.0, int_stack+796490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+478010,int_stack+302555,int_stack+301880, 0.0, zero_stack, 1.0, int_stack+313790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+480035,int_stack+478010,int_stack+358715, 0.0, zero_stack, 1.0, int_stack+802895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+480035,int_stack+626630, 0.0, zero_stack, 1.0, int_stack+804515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+348545,int_stack+0,int_stack+446815, 0.0, zero_stack, 1.0, int_stack+807035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+303380,int_stack+302555, 0.0, zero_stack, 1.0, int_stack+315140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+478010, 0.0, zero_stack, 1.0, int_stack+810185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+616630,int_stack+626630,int_stack+480035, 0.0, zero_stack, 1.0, int_stack+812210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+478010,int_stack+616630,int_stack+0, 0.0, zero_stack, 1.0, int_stack+815450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+100245,int_stack+478010,int_stack+348545, 0.0, zero_stack, 1.0, int_stack+819650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+348545,int_stack+308940,int_stack+308730, 1.0, int_stack+335350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+349175,int_stack+309220,int_stack+308940, 1.0, int_stack+335560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+350015,int_stack+349175,int_stack+348545, 1.0, int_stack+771910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+351275,int_stack+309580,int_stack+309220, 1.0, int_stack+335840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+352355,int_stack+351275,int_stack+349175, 1.0, int_stack+772540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+478010,int_stack+352355,int_stack+350015, 1.0, int_stack+773380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+348545,int_stack+310030,int_stack+309580, 1.0, int_stack+336200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+480110,int_stack+348545,int_stack+351275, 1.0, int_stack+774640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+482270,int_stack+480110,int_stack+352355, 1.0, int_stack+775720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+482270,int_stack+478010, 1.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+478010,int_stack+310580,int_stack+310030, 1.0, int_stack+336650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+349895,int_stack+478010,int_stack+348545, 1.0, int_stack+784825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+349895,int_stack+480110, 1.0, int_stack+786175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+0,int_stack+482270, 1.0, int_stack+788335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+0,int_stack+626630,int_stack+446815, 1.0, int_stack+791135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+312290,int_stack+311555, 1.0, int_stack+311240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+313250,int_stack+312290, 1.0, int_stack+311870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815, 1.0, int_stack+794285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+314465,int_stack+313250, 1.0, int_stack+312710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760, 1.0, int_stack+795230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255, 1.0, int_stack+796490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4410,int_stack+315965,int_stack+314465, 1.0, int_stack+313790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+784825,int_stack+4410,int_stack+358715, 1.0, int_stack+802895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+788065,int_stack+784825,int_stack+626630, 1.0, int_stack+804515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+792265,int_stack+788065,int_stack+446815, 1.0, int_stack+807035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+316790,int_stack+315965, 1.0, int_stack+315140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+4410, 1.0, int_stack+810185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+802895,int_stack+626630,int_stack+784825, 1.0, int_stack+812210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+808295,int_stack+802895,int_stack+788065, 1.0, int_stack+815450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+784825,int_stack+808295,int_stack+792265, 1.0, int_stack+819650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+802895,int_stack+320500,int_stack+320290,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+803525,int_stack+320780,int_stack+320500,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+804365,int_stack+803525,int_stack+802895,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+805625,int_stack+321140,int_stack+320780,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+806705,int_stack+805625,int_stack+803525,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+808385,int_stack+806705,int_stack+804365,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+802895,int_stack+321590,int_stack+321140,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+810485,int_stack+802895,int_stack+805625,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+812645,int_stack+810485,int_stack+806705,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+812645,int_stack+808385,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+804245,int_stack+322140,int_stack+321590,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+805895,int_stack+804245,int_stack+802895,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+815445,int_stack+805895,int_stack+810485,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+815445,int_stack+812645,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+802895,int_stack+626630,int_stack+446815,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+323115,int_stack+322800,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+323535,int_stack+323115,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+324075,int_stack+323535,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+807305,int_stack+324750,int_stack+324075,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+809330,int_stack+807305,int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+812570,int_stack+809330,int_stack+626630,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+816770,int_stack+812570,int_stack+446815,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+325575,int_stack+324750,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+807305,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+791440,int_stack+626630,int_stack+809330,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+478010,int_stack+791440,int_stack+812570,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+791440,int_stack+478010,int_stack+816770,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+478010,int_stack+329285,int_stack+329075,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+478640,int_stack+329565,int_stack+329285,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+479480,int_stack+478640,int_stack+478010,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+480740,int_stack+329925,int_stack+329565,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+481820,int_stack+480740,int_stack+478640,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+626630,int_stack+481820,int_stack+479480,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+478010,int_stack+330375,int_stack+329925,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+807305,int_stack+478010,int_stack+480740,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+809465,int_stack+807305,int_stack+481820,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+809465,int_stack+626630,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+626630,int_stack+330925,int_stack+330375,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+479360,int_stack+626630,int_stack+478010,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+626630,int_stack+479360,int_stack+807305,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+478010,int_stack+626630,int_stack+809465,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+807305,int_stack+478010,int_stack+446815,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+331900,int_stack+331585,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+332320,int_stack+331900,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+332860,int_stack+332320,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+478010,int_stack+358715,int_stack+447760,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+478010,int_stack+391255,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+480530,int_stack+333535,int_stack+332860,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+626630,int_stack+480530,int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+811715,int_stack+626630,int_stack+478010,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+815915,int_stack+811715,int_stack+446815,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+334360,int_stack+333535,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4410,int_stack+446815,int_stack+480530,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+478010,int_stack+4410,int_stack+626630,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+768070,int_stack+478010,int_stack+811715,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+478010,int_stack+768070,int_stack+815915,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+768070,int_stack+338070,int_stack+337860,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+768700,int_stack+338350,int_stack+338070,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+769540,int_stack+768700,int_stack+768070,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+770800,int_stack+338710,int_stack+338350,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+771880,int_stack+770800,int_stack+768700,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+773560,int_stack+771880,int_stack+769540,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+768070,int_stack+339160,int_stack+338710,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+775660,int_stack+768070,int_stack+770800,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+811715,int_stack+775660,int_stack+771880,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+446815,int_stack+811715,int_stack+773560,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+769420,int_stack+339710,int_stack+339160,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+771070,int_stack+769420,int_stack+768070,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+814515,int_stack+771070,int_stack+775660,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+626630,int_stack+814515,int_stack+811715,10);
 /*--- compute (f0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+811715,int_stack+626630,int_stack+446815,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+446815,int_stack+340685,int_stack+340370,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+447760,int_stack+341105,int_stack+340685,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+391255,int_stack+447760,int_stack+446815,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358715,int_stack+341645,int_stack+341105,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+626630,int_stack+358715,int_stack+447760,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+446815,int_stack+626630,int_stack+391255,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+816125,int_stack+342320,int_stack+341645,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+818150,int_stack+816125,int_stack+358715,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+768070,int_stack+818150,int_stack+626630,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+772270,int_stack+768070,int_stack+446815,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+446815,int_stack+343145,int_stack+342320,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+626630,int_stack+446815,int_stack+816125,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+348545,int_stack+626630,int_stack+818150,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+816125,int_stack+348545,int_stack+768070,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+106860,int_stack+816125,int_stack+772270,15);
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+113475,int_stack+440200,int_stack+382435,441);
     Libderiv->ABCD[11] = int_stack + 113475;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+126705,int_stack+494765,int_stack+462575,441);
     Libderiv->ABCD[10] = int_stack + 126705;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+139935,int_stack+547980,int_stack+515790,441);
     Libderiv->ABCD[9] = int_stack + 139935;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+153165,int_stack+601195,int_stack+569005,441);
     Libderiv->ABCD[8] = int_stack + 153165;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+166395,int_stack+654410,int_stack+622220,441);
     Libderiv->ABCD[7] = int_stack + 166395;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+179625,int_stack+393145,int_stack+668085,441);
     Libderiv->ABCD[6] = int_stack + 179625;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+192855,int_stack+723645,int_stack+354305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 192855;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+206085,int_stack+778210,int_stack+746020, 0.0, zero_stack, 1.0, int_stack+693525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 206085;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+768070,int_stack+830675,int_stack+798485, 1.0, int_stack+693525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 768070;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+219315,int_stack+841700,int_stack+837290,441);
     Libderiv->ABCD[155] = int_stack + 219315;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+232545,int_stack+855065,int_stack+824375,441);
     Libderiv->ABCD[143] = int_stack + 232545;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+816125,int_stack+14880,int_stack+848315,441);
     Libderiv->ABCD[142] = int_stack + 816125;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+829355,int_stack+861680,int_stack+8580,441);
     Libderiv->ABCD[131] = int_stack + 829355;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+842585,int_stack+26220,int_stack+868295,441);
     Libderiv->ABCD[130] = int_stack + 842585;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+855815,int_stack+39135,int_stack+872705,441);
     Libderiv->ABCD[129] = int_stack + 855815;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4410,int_stack+45750,int_stack+32835,441);
     Libderiv->ABCD[119] = int_stack + 4410;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+25905,int_stack+881525,int_stack+877115,441);
     Libderiv->ABCD[118] = int_stack + 25905;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+39135,int_stack+52365,int_stack+888140,441);
     Libderiv->ABCD[117] = int_stack + 39135;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+869045,int_stack+65280,int_stack+892550,441);
     Libderiv->ABCD[116] = int_stack + 869045;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+882275,int_stack+71895,int_stack+896960,441);
     Libderiv->ABCD[107] = int_stack + 882275;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+63390,int_stack+905780,int_stack+901370,441);
     Libderiv->ABCD[106] = int_stack + 63390;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+895505,int_stack+84810,int_stack+912395,441);
     Libderiv->ABCD[105] = int_stack + 895505;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+245775,int_stack+921530,int_stack+78510,441);
     Libderiv->ABCD[104] = int_stack + 245775;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+76620,int_stack+928145,int_stack+916805,441);
     Libderiv->ABCD[103] = int_stack + 76620;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+908735,int_stack+360335,int_stack+91425,441);
     Libderiv->ABCD[95] = int_stack + 908735;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+358715,int_stack+466985,int_stack+95835,441);
     Libderiv->ABCD[94] = int_stack + 358715;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+259005,int_stack+454375,int_stack+449965,441);
     Libderiv->ABCD[93] = int_stack + 259005;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+438235,int_stack+573415,int_stack+520200,441);
     Libderiv->ABCD[92] = int_stack + 438235;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+272235,int_stack+584440,int_stack+580030,441);
     Libderiv->ABCD[91] = int_stack + 272235;
 /*--- compute (fp|hh) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+573415,int_stack+672495,int_stack+630830,441);
     Libderiv->ABCD[90] = int_stack + 573415;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+285465,int_stack+679110,int_stack+58980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[47] = int_stack + 285465;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+672495,int_stack+685725,int_stack+635240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[46] = int_stack + 672495;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+298695,int_stack+591055,int_stack+344135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+515790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[45] = int_stack + 298695;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+586645,int_stack+639650,int_stack+661025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[44] = int_stack + 586645;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+626630,int_stack+646265,int_stack+607810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[43] = int_stack + 626630;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+639860,int_stack+697935,int_stack+386845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[42] = int_stack + 639860;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+685725,int_stack+529020,int_stack+524610, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+354305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[38] = int_stack + 685725;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+520200,int_stack+540360,int_stack+704550, 0.0, zero_stack, 1.0, int_stack+382435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[35] = int_stack + 520200;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+653090,int_stack+416185,int_stack+708960, 0.0, zero_stack, 1.0, int_stack+462575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[34] = int_stack + 653090;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+698955,int_stack+404170,int_stack+399760, 0.0, zero_stack, 1.0, int_stack+515790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[33] = int_stack + 698955;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+386845,int_stack+427210,int_stack+422800, 0.0, zero_stack, 1.0, int_stack+569005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[32] = int_stack + 386845;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+415195,int_stack+554595,int_stack+612220, 0.0, zero_stack, 1.0, int_stack+622220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[31] = int_stack + 415195;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+599875,int_stack+750430,int_stack+535635, 0.0, zero_stack, 1.0, int_stack+668085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[30] = int_stack + 599875;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+533430,int_stack+730260,int_stack+433825, 0.0, zero_stack, 1.0, int_stack+354305, 1.0, int_stack+746020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[26] = int_stack + 533430;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+546660,int_stack+761455,int_stack+757045, 0.0, zero_stack, 2.0, int_stack+746020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[25] = int_stack + 546660;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+750430,int_stack+713370,int_stack+736875, 1.0, int_stack+382435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[23] = int_stack + 750430;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+712185,int_stack+501380,int_stack+410785, 1.0, int_stack+462575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[22] = int_stack + 712185;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+400075,int_stack+507995,int_stack+561210, 1.0, int_stack+515790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[21] = int_stack + 400075;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+725415,int_stack+485300,int_stack+21495, 1.0, int_stack+569005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[20] = int_stack + 725415;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+559890,int_stack+100245,int_stack+473600, 1.0, int_stack+622220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[19] = int_stack + 559890;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+613105,int_stack+784825,int_stack+0, 1.0, int_stack+668085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[18] = int_stack + 613105;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+371945,int_stack+791440,int_stack+802895, 1.0, int_stack+354305, 0.0, zero_stack, 1.0, int_stack+798485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[14] = int_stack + 371945;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+781300,int_stack+478010,int_stack+807305, 1.0, int_stack+746020, 1.0, int_stack+798485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[13] = int_stack + 781300;
 /*--- compute (fp|hh) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+451465,int_stack+106860,int_stack+811715, 2.0, int_stack+798485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[12] = int_stack + 451465;

}
