/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_gdhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gd|hh) integrals */

void d12hrr_order_gdhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][10][11] = int_stack + 0;
 Libderiv->deriv_classes[6][10][10] = int_stack + 1848;
 Libderiv->deriv_classes[6][10][9] = int_stack + 3696;
 Libderiv->deriv_classes[6][10][8] = int_stack + 5544;
 Libderiv->deriv_classes[6][10][7] = int_stack + 7392;
 Libderiv->dvrr_classes[6][9] = int_stack + 9240;
 Libderiv->deriv_classes[6][10][6] = int_stack + 10780;
 Libderiv->deriv_classes[6][10][2] = int_stack + 12628;
 Libderiv->deriv_classes[6][10][1] = int_stack + 14476;
 Libderiv->dvrr_classes[5][10] = int_stack + 16324;
 Libderiv->deriv_classes[6][10][0] = int_stack + 17710;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 19558;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 19873;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 20293;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 20833;
 Libderiv->deriv2_classes[4][9][143] = int_stack + 21508;
 Libderiv->deriv2_classes[4][10][143] = int_stack + 22333;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 23323;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 23764;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 24352;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 25108;
 Libderiv->deriv2_classes[5][9][143] = int_stack + 26053;
 Libderiv->deriv2_classes[5][10][143] = int_stack + 27208;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 28594;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 29182;
 Libderiv->deriv2_classes[6][7][143] = int_stack + 29966;
 Libderiv->deriv2_classes[6][8][143] = int_stack + 30974;
 Libderiv->deriv2_classes[6][9][143] = int_stack + 32234;
 Libderiv->deriv2_classes[6][10][143] = int_stack + 33774;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 35622;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 35937;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 36357;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 36897;
 Libderiv->deriv2_classes[4][9][131] = int_stack + 37572;
 Libderiv->deriv2_classes[4][10][131] = int_stack + 38397;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 39387;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 39828;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 40416;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 41172;
 Libderiv->deriv2_classes[5][9][131] = int_stack + 42117;
 Libderiv->deriv2_classes[5][10][131] = int_stack + 43272;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 44658;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 45246;
 Libderiv->deriv2_classes[6][7][131] = int_stack + 46030;
 Libderiv->deriv2_classes[6][8][131] = int_stack + 47038;
 Libderiv->deriv2_classes[6][9][131] = int_stack + 48298;
 Libderiv->deriv2_classes[6][10][131] = int_stack + 49838;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 51686;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 52001;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 52421;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 52961;
 Libderiv->deriv2_classes[4][9][130] = int_stack + 53636;
 Libderiv->deriv2_classes[4][10][130] = int_stack + 54461;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 55451;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 55892;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 56480;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 57236;
 Libderiv->deriv2_classes[5][9][130] = int_stack + 58181;
 Libderiv->deriv2_classes[5][10][130] = int_stack + 59336;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 60722;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 61310;
 Libderiv->deriv2_classes[6][7][130] = int_stack + 62094;
 Libderiv->deriv2_classes[6][8][130] = int_stack + 63102;
 Libderiv->deriv2_classes[6][9][130] = int_stack + 64362;
 Libderiv->deriv2_classes[6][10][130] = int_stack + 65902;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 67750;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 68065;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 68485;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 69025;
 Libderiv->deriv2_classes[4][9][119] = int_stack + 69700;
 Libderiv->deriv2_classes[4][10][119] = int_stack + 70525;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 71515;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 71956;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 72544;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 73300;
 Libderiv->deriv2_classes[5][9][119] = int_stack + 74245;
 Libderiv->deriv2_classes[5][10][119] = int_stack + 75400;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 76786;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 77374;
 Libderiv->deriv2_classes[6][7][119] = int_stack + 78158;
 Libderiv->deriv2_classes[6][8][119] = int_stack + 79166;
 Libderiv->deriv2_classes[6][9][119] = int_stack + 80426;
 Libderiv->deriv2_classes[6][10][119] = int_stack + 81966;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 83814;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 84129;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 84549;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 85089;
 Libderiv->deriv2_classes[4][9][118] = int_stack + 85764;
 Libderiv->deriv2_classes[4][10][118] = int_stack + 86589;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 87579;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 88020;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 88608;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 89364;
 Libderiv->deriv2_classes[5][9][118] = int_stack + 90309;
 Libderiv->deriv2_classes[5][10][118] = int_stack + 91464;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 92850;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 93438;
 Libderiv->deriv2_classes[6][7][118] = int_stack + 94222;
 Libderiv->deriv2_classes[6][8][118] = int_stack + 95230;
 Libderiv->deriv2_classes[6][9][118] = int_stack + 96490;
 Libderiv->deriv2_classes[6][10][118] = int_stack + 98030;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 99878;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 100193;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 100613;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 101153;
 Libderiv->deriv2_classes[4][9][117] = int_stack + 101828;
 Libderiv->deriv2_classes[4][10][117] = int_stack + 102653;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 103643;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 104084;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 104672;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 105428;
 Libderiv->deriv2_classes[5][9][117] = int_stack + 106373;
 Libderiv->deriv2_classes[5][10][117] = int_stack + 107528;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 108914;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 109502;
 Libderiv->deriv2_classes[6][7][117] = int_stack + 110286;
 Libderiv->deriv2_classes[6][8][117] = int_stack + 111294;
 Libderiv->deriv2_classes[6][9][117] = int_stack + 112554;
 Libderiv->deriv2_classes[6][10][117] = int_stack + 114094;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 115942;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 116257;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 116677;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 117217;
 Libderiv->deriv2_classes[4][9][107] = int_stack + 117892;
 Libderiv->deriv2_classes[4][10][107] = int_stack + 118717;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 119707;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 120148;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 120736;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 121492;
 Libderiv->deriv2_classes[5][9][107] = int_stack + 122437;
 Libderiv->deriv2_classes[5][10][107] = int_stack + 123592;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 124978;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 125566;
 Libderiv->deriv2_classes[6][7][107] = int_stack + 126350;
 Libderiv->deriv2_classes[6][8][107] = int_stack + 127358;
 Libderiv->deriv2_classes[6][9][107] = int_stack + 128618;
 Libderiv->deriv2_classes[6][10][107] = int_stack + 130158;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 132006;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 132321;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 132741;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 133281;
 Libderiv->deriv2_classes[4][9][106] = int_stack + 133956;
 Libderiv->deriv2_classes[4][10][106] = int_stack + 134781;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 135771;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 136212;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 136800;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 137556;
 Libderiv->deriv2_classes[5][9][106] = int_stack + 138501;
 Libderiv->deriv2_classes[5][10][106] = int_stack + 139656;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 141042;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 141630;
 Libderiv->deriv2_classes[6][7][106] = int_stack + 142414;
 Libderiv->deriv2_classes[6][8][106] = int_stack + 143422;
 Libderiv->deriv2_classes[6][9][106] = int_stack + 144682;
 Libderiv->deriv2_classes[6][10][106] = int_stack + 146222;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 148070;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 148385;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 148805;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 149345;
 Libderiv->deriv2_classes[4][9][105] = int_stack + 150020;
 Libderiv->deriv2_classes[4][10][105] = int_stack + 150845;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 151835;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 152276;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 152864;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 153620;
 Libderiv->deriv2_classes[5][9][105] = int_stack + 154565;
 Libderiv->deriv2_classes[5][10][105] = int_stack + 155720;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 157106;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 157694;
 Libderiv->deriv2_classes[6][7][105] = int_stack + 158478;
 Libderiv->deriv2_classes[6][8][105] = int_stack + 159486;
 Libderiv->deriv2_classes[6][9][105] = int_stack + 160746;
 Libderiv->deriv2_classes[6][10][105] = int_stack + 162286;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 164134;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 164449;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 164869;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 165409;
 Libderiv->deriv2_classes[4][9][104] = int_stack + 166084;
 Libderiv->deriv2_classes[4][10][104] = int_stack + 166909;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 167899;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 168340;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 168928;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 169684;
 Libderiv->deriv2_classes[5][9][104] = int_stack + 170629;
 Libderiv->deriv2_classes[5][10][104] = int_stack + 171784;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 173170;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 173758;
 Libderiv->deriv2_classes[6][7][104] = int_stack + 174542;
 Libderiv->deriv2_classes[6][8][104] = int_stack + 175550;
 Libderiv->deriv2_classes[6][9][104] = int_stack + 176810;
 Libderiv->deriv2_classes[6][10][104] = int_stack + 178350;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 180198;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 180513;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 180933;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 181473;
 Libderiv->deriv2_classes[4][9][95] = int_stack + 182148;
 Libderiv->deriv2_classes[4][10][95] = int_stack + 182973;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 183963;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 184404;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 184992;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 185748;
 Libderiv->deriv2_classes[5][9][95] = int_stack + 186693;
 Libderiv->deriv2_classes[5][10][95] = int_stack + 187848;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 189234;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 189822;
 Libderiv->deriv2_classes[6][7][95] = int_stack + 190606;
 Libderiv->deriv2_classes[6][8][95] = int_stack + 191614;
 Libderiv->deriv2_classes[6][9][95] = int_stack + 192874;
 Libderiv->deriv2_classes[6][10][95] = int_stack + 194414;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 196262;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 196577;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 196997;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 197537;
 Libderiv->deriv2_classes[4][9][94] = int_stack + 198212;
 Libderiv->deriv2_classes[4][10][94] = int_stack + 199037;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 200027;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 200468;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 201056;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 201812;
 Libderiv->deriv2_classes[5][9][94] = int_stack + 202757;
 Libderiv->deriv2_classes[5][10][94] = int_stack + 203912;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 205298;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 205886;
 Libderiv->deriv2_classes[6][7][94] = int_stack + 206670;
 Libderiv->deriv2_classes[6][8][94] = int_stack + 207678;
 Libderiv->deriv2_classes[6][9][94] = int_stack + 208938;
 Libderiv->deriv2_classes[6][10][94] = int_stack + 210478;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 212326;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 212641;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 213061;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 213601;
 Libderiv->deriv2_classes[4][9][93] = int_stack + 214276;
 Libderiv->deriv2_classes[4][10][93] = int_stack + 215101;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 216091;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 216532;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 217120;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 217876;
 Libderiv->deriv2_classes[5][9][93] = int_stack + 218821;
 Libderiv->deriv2_classes[5][10][93] = int_stack + 219976;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 221362;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 221950;
 Libderiv->deriv2_classes[6][7][93] = int_stack + 222734;
 Libderiv->deriv2_classes[6][8][93] = int_stack + 223742;
 Libderiv->deriv2_classes[6][9][93] = int_stack + 225002;
 Libderiv->deriv2_classes[6][10][93] = int_stack + 226542;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 228390;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 228705;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 229125;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 229665;
 Libderiv->deriv2_classes[4][9][92] = int_stack + 230340;
 Libderiv->deriv2_classes[4][10][92] = int_stack + 231165;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 232155;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 232596;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 233184;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 233940;
 Libderiv->deriv2_classes[5][9][92] = int_stack + 234885;
 Libderiv->deriv2_classes[5][10][92] = int_stack + 236040;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 237426;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 238014;
 Libderiv->deriv2_classes[6][7][92] = int_stack + 238798;
 Libderiv->deriv2_classes[6][8][92] = int_stack + 239806;
 Libderiv->deriv2_classes[6][9][92] = int_stack + 241066;
 Libderiv->deriv2_classes[6][10][92] = int_stack + 242606;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 244454;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 244769;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 245189;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 245729;
 Libderiv->deriv2_classes[4][9][91] = int_stack + 246404;
 Libderiv->deriv2_classes[4][10][91] = int_stack + 247229;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 248219;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 248660;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 249248;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 250004;
 Libderiv->deriv2_classes[5][9][91] = int_stack + 250949;
 Libderiv->deriv2_classes[5][10][91] = int_stack + 252104;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 253490;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 254078;
 Libderiv->deriv2_classes[6][7][91] = int_stack + 254862;
 Libderiv->deriv2_classes[6][8][91] = int_stack + 255870;
 Libderiv->deriv2_classes[6][9][91] = int_stack + 257130;
 Libderiv->deriv2_classes[6][10][91] = int_stack + 258670;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 260518;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 260833;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 261253;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 261793;
 Libderiv->deriv2_classes[4][9][83] = int_stack + 262468;
 Libderiv->deriv2_classes[4][10][83] = int_stack + 263293;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 264283;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 264724;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 265312;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 266068;
 Libderiv->deriv2_classes[5][9][83] = int_stack + 267013;
 Libderiv->deriv2_classes[5][10][83] = int_stack + 268168;
 Libderiv->deriv_classes[6][5][11] = int_stack + 269554;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 270142;
 Libderiv->deriv_classes[6][6][11] = int_stack + 270730;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 271514;
 Libderiv->deriv_classes[6][7][11] = int_stack + 272298;
 Libderiv->deriv2_classes[6][7][83] = int_stack + 273306;
 Libderiv->deriv_classes[6][8][11] = int_stack + 274314;
 Libderiv->deriv2_classes[6][8][83] = int_stack + 275574;
 Libderiv->deriv_classes[6][9][11] = int_stack + 276834;
 Libderiv->deriv2_classes[6][9][83] = int_stack + 278374;
 Libderiv->deriv2_classes[6][10][83] = int_stack + 279914;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 281762;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 282077;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 282497;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 283037;
 Libderiv->deriv2_classes[4][9][82] = int_stack + 283712;
 Libderiv->deriv2_classes[4][10][82] = int_stack + 284537;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 285527;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 285968;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 286556;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 287312;
 Libderiv->deriv2_classes[5][9][82] = int_stack + 288257;
 Libderiv->deriv2_classes[5][10][82] = int_stack + 289412;
 Libderiv->deriv_classes[6][5][10] = int_stack + 290798;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 291386;
 Libderiv->deriv_classes[6][6][10] = int_stack + 291974;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 292758;
 Libderiv->deriv_classes[6][7][10] = int_stack + 293542;
 Libderiv->deriv2_classes[6][7][82] = int_stack + 294550;
 Libderiv->deriv_classes[6][8][10] = int_stack + 295558;
 Libderiv->deriv2_classes[6][8][82] = int_stack + 296818;
 Libderiv->deriv_classes[6][9][10] = int_stack + 298078;
 Libderiv->deriv2_classes[6][9][82] = int_stack + 299618;
 Libderiv->deriv2_classes[6][10][82] = int_stack + 301158;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 303006;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 303321;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 303741;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 304281;
 Libderiv->deriv2_classes[4][9][81] = int_stack + 304956;
 Libderiv->deriv2_classes[4][10][81] = int_stack + 305781;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 306771;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 307212;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 307800;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 308556;
 Libderiv->deriv2_classes[5][9][81] = int_stack + 309501;
 Libderiv->deriv2_classes[5][10][81] = int_stack + 310656;
 Libderiv->deriv_classes[6][5][9] = int_stack + 312042;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 312630;
 Libderiv->deriv_classes[6][6][9] = int_stack + 313218;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 314002;
 Libderiv->deriv_classes[6][7][9] = int_stack + 314786;
 Libderiv->deriv2_classes[6][7][81] = int_stack + 315794;
 Libderiv->deriv_classes[6][8][9] = int_stack + 316802;
 Libderiv->deriv2_classes[6][8][81] = int_stack + 318062;
 Libderiv->deriv_classes[6][9][9] = int_stack + 319322;
 Libderiv->deriv2_classes[6][9][81] = int_stack + 320862;
 Libderiv->deriv2_classes[6][10][81] = int_stack + 322402;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 324250;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 324565;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 324985;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 325525;
 Libderiv->deriv2_classes[4][9][80] = int_stack + 326200;
 Libderiv->deriv2_classes[4][10][80] = int_stack + 327025;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 328015;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 328456;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 329044;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 329800;
 Libderiv->deriv2_classes[5][9][80] = int_stack + 330745;
 Libderiv->deriv2_classes[5][10][80] = int_stack + 331900;
 Libderiv->deriv_classes[6][5][8] = int_stack + 333286;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 333874;
 Libderiv->deriv_classes[6][6][8] = int_stack + 334462;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 335246;
 Libderiv->deriv_classes[6][7][8] = int_stack + 336030;
 Libderiv->deriv2_classes[6][7][80] = int_stack + 337038;
 Libderiv->deriv_classes[6][8][8] = int_stack + 338046;
 Libderiv->deriv2_classes[6][8][80] = int_stack + 339306;
 Libderiv->deriv_classes[6][9][8] = int_stack + 340566;
 Libderiv->deriv2_classes[6][9][80] = int_stack + 342106;
 Libderiv->deriv2_classes[6][10][80] = int_stack + 343646;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 345494;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 345809;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 346229;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 346769;
 Libderiv->deriv2_classes[4][9][79] = int_stack + 347444;
 Libderiv->deriv2_classes[4][10][79] = int_stack + 348269;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 349259;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 349700;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 350288;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 351044;
 Libderiv->deriv2_classes[5][9][79] = int_stack + 351989;
 Libderiv->deriv2_classes[5][10][79] = int_stack + 353144;
 Libderiv->deriv_classes[6][5][7] = int_stack + 354530;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 355118;
 Libderiv->deriv_classes[6][6][7] = int_stack + 355706;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 356490;
 Libderiv->deriv_classes[6][7][7] = int_stack + 357274;
 Libderiv->deriv2_classes[6][7][79] = int_stack + 358282;
 Libderiv->deriv_classes[6][8][7] = int_stack + 359290;
 Libderiv->deriv2_classes[6][8][79] = int_stack + 360550;
 Libderiv->deriv_classes[6][9][7] = int_stack + 361810;
 Libderiv->deriv2_classes[6][9][79] = int_stack + 363350;
 Libderiv->deriv2_classes[6][10][79] = int_stack + 364890;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 366738;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 367053;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 367473;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 368013;
 Libderiv->deriv2_classes[4][9][78] = int_stack + 368688;
 Libderiv->deriv2_classes[4][10][78] = int_stack + 369513;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 370503;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 370944;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 371532;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 372288;
 Libderiv->deriv2_classes[5][9][78] = int_stack + 373233;
 Libderiv->deriv2_classes[5][10][78] = int_stack + 374388;
 Libderiv->dvrr_classes[6][5] = int_stack + 375774;
 Libderiv->deriv_classes[6][5][6] = int_stack + 376362;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 376950;
 Libderiv->dvrr_classes[6][6] = int_stack + 377538;
 Libderiv->deriv_classes[6][6][6] = int_stack + 378322;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 379106;
 Libderiv->dvrr_classes[6][7] = int_stack + 379890;
 Libderiv->deriv_classes[6][7][6] = int_stack + 380898;
 Libderiv->deriv2_classes[6][7][78] = int_stack + 381906;
 Libderiv->dvrr_classes[6][8] = int_stack + 382914;
 Libderiv->deriv_classes[6][8][6] = int_stack + 384174;
 Libderiv->deriv2_classes[6][8][78] = int_stack + 385434;
 Libderiv->deriv_classes[6][9][6] = int_stack + 386694;
 Libderiv->deriv2_classes[6][9][78] = int_stack + 388234;
 Libderiv->deriv2_classes[6][10][78] = int_stack + 389774;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 391622;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 391937;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 392357;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 392897;
 Libderiv->deriv2_classes[4][9][35] = int_stack + 393572;
 Libderiv->deriv2_classes[4][10][35] = int_stack + 394397;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 395387;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 395828;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 396416;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 397172;
 Libderiv->deriv2_classes[5][9][35] = int_stack + 398117;
 Libderiv->deriv2_classes[5][10][35] = int_stack + 399272;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 400658;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 401246;
 Libderiv->deriv2_classes[6][7][35] = int_stack + 402030;
 Libderiv->deriv2_classes[6][8][35] = int_stack + 403038;
 Libderiv->deriv2_classes[6][9][35] = int_stack + 404298;
 Libderiv->deriv2_classes[6][10][35] = int_stack + 405838;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 407686;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 408001;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 408421;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 408961;
 Libderiv->deriv2_classes[4][9][34] = int_stack + 409636;
 Libderiv->deriv2_classes[4][10][34] = int_stack + 410461;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 411451;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 411892;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 412480;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 413236;
 Libderiv->deriv2_classes[5][9][34] = int_stack + 414181;
 Libderiv->deriv2_classes[5][10][34] = int_stack + 415336;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 416722;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 417310;
 Libderiv->deriv2_classes[6][7][34] = int_stack + 418094;
 Libderiv->deriv2_classes[6][8][34] = int_stack + 419102;
 Libderiv->deriv2_classes[6][9][34] = int_stack + 420362;
 Libderiv->deriv2_classes[6][10][34] = int_stack + 421902;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 423750;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 424065;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 424485;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 425025;
 Libderiv->deriv2_classes[4][9][33] = int_stack + 425700;
 Libderiv->deriv2_classes[4][10][33] = int_stack + 426525;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 427515;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 427956;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 428544;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 429300;
 Libderiv->deriv2_classes[5][9][33] = int_stack + 430245;
 Libderiv->deriv2_classes[5][10][33] = int_stack + 431400;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 432786;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 433374;
 Libderiv->deriv2_classes[6][7][33] = int_stack + 434158;
 Libderiv->deriv2_classes[6][8][33] = int_stack + 435166;
 Libderiv->deriv2_classes[6][9][33] = int_stack + 436426;
 Libderiv->deriv2_classes[6][10][33] = int_stack + 437966;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 439814;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 440129;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 440549;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 441089;
 Libderiv->deriv2_classes[4][9][32] = int_stack + 441764;
 Libderiv->deriv2_classes[4][10][32] = int_stack + 442589;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 443579;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 444020;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 444608;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 445364;
 Libderiv->deriv2_classes[5][9][32] = int_stack + 446309;
 Libderiv->deriv2_classes[5][10][32] = int_stack + 447464;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 448850;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 449438;
 Libderiv->deriv2_classes[6][7][32] = int_stack + 450222;
 Libderiv->deriv2_classes[6][8][32] = int_stack + 451230;
 Libderiv->deriv2_classes[6][9][32] = int_stack + 452490;
 Libderiv->deriv2_classes[6][10][32] = int_stack + 454030;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 455878;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 456193;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 456613;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 457153;
 Libderiv->deriv2_classes[4][9][31] = int_stack + 457828;
 Libderiv->deriv2_classes[4][10][31] = int_stack + 458653;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 459643;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 460084;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 460672;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 461428;
 Libderiv->deriv2_classes[5][9][31] = int_stack + 462373;
 Libderiv->deriv2_classes[5][10][31] = int_stack + 463528;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 464914;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 465502;
 Libderiv->deriv2_classes[6][7][31] = int_stack + 466286;
 Libderiv->deriv2_classes[6][8][31] = int_stack + 467294;
 Libderiv->deriv2_classes[6][9][31] = int_stack + 468554;
 Libderiv->deriv2_classes[6][10][31] = int_stack + 470094;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 471942;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 472257;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 472677;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 473217;
 Libderiv->deriv2_classes[4][9][30] = int_stack + 473892;
 Libderiv->deriv2_classes[4][10][30] = int_stack + 474717;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 475707;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 476148;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 476736;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 477492;
 Libderiv->deriv2_classes[5][9][30] = int_stack + 478437;
 Libderiv->deriv2_classes[5][10][30] = int_stack + 479592;
 Libderiv->deriv_classes[6][5][2] = int_stack + 480978;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 481566;
 Libderiv->deriv_classes[6][6][2] = int_stack + 482154;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 482938;
 Libderiv->deriv_classes[6][7][2] = int_stack + 483722;
 Libderiv->deriv2_classes[6][7][30] = int_stack + 484730;
 Libderiv->deriv_classes[6][8][2] = int_stack + 485738;
 Libderiv->deriv2_classes[6][8][30] = int_stack + 486998;
 Libderiv->deriv_classes[6][9][2] = int_stack + 488258;
 Libderiv->deriv2_classes[6][9][30] = int_stack + 489798;
 Libderiv->deriv2_classes[6][10][30] = int_stack + 491338;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 493186;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 493501;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 493921;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 494461;
 Libderiv->deriv2_classes[4][9][26] = int_stack + 495136;
 Libderiv->deriv2_classes[4][10][26] = int_stack + 495961;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 496951;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 497392;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 497980;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 498736;
 Libderiv->deriv2_classes[5][9][26] = int_stack + 499681;
 Libderiv->deriv2_classes[5][10][26] = int_stack + 500836;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 502222;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 502810;
 Libderiv->deriv2_classes[6][7][26] = int_stack + 503594;
 Libderiv->deriv2_classes[6][8][26] = int_stack + 504602;
 Libderiv->deriv2_classes[6][9][26] = int_stack + 505862;
 Libderiv->deriv2_classes[6][10][26] = int_stack + 507402;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 509250;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 509565;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 509985;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 510525;
 Libderiv->deriv2_classes[4][9][23] = int_stack + 511200;
 Libderiv->deriv2_classes[4][10][23] = int_stack + 512025;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 513015;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 513456;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 514044;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 514800;
 Libderiv->deriv2_classes[5][9][23] = int_stack + 515745;
 Libderiv->deriv2_classes[5][10][23] = int_stack + 516900;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 518286;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 518874;
 Libderiv->deriv2_classes[6][7][23] = int_stack + 519658;
 Libderiv->deriv2_classes[6][8][23] = int_stack + 520666;
 Libderiv->deriv2_classes[6][9][23] = int_stack + 521926;
 Libderiv->deriv2_classes[6][10][23] = int_stack + 523466;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 525314;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 525629;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 526049;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 526589;
 Libderiv->deriv2_classes[4][9][22] = int_stack + 527264;
 Libderiv->deriv2_classes[4][10][22] = int_stack + 528089;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 529079;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 529520;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 530108;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 530864;
 Libderiv->deriv2_classes[5][9][22] = int_stack + 531809;
 Libderiv->deriv2_classes[5][10][22] = int_stack + 532964;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 534350;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 534938;
 Libderiv->deriv2_classes[6][7][22] = int_stack + 535722;
 Libderiv->deriv2_classes[6][8][22] = int_stack + 536730;
 Libderiv->deriv2_classes[6][9][22] = int_stack + 537990;
 Libderiv->deriv2_classes[6][10][22] = int_stack + 539530;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 541378;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 541693;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 542113;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 542653;
 Libderiv->deriv2_classes[4][9][21] = int_stack + 543328;
 Libderiv->deriv2_classes[4][10][21] = int_stack + 544153;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 545143;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 545584;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 546172;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 546928;
 Libderiv->deriv2_classes[5][9][21] = int_stack + 547873;
 Libderiv->deriv2_classes[5][10][21] = int_stack + 549028;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 550414;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 551002;
 Libderiv->deriv2_classes[6][7][21] = int_stack + 551786;
 Libderiv->deriv2_classes[6][8][21] = int_stack + 552794;
 Libderiv->deriv2_classes[6][9][21] = int_stack + 554054;
 Libderiv->deriv2_classes[6][10][21] = int_stack + 555594;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 557442;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 557757;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 558177;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 558717;
 Libderiv->deriv2_classes[4][9][20] = int_stack + 559392;
 Libderiv->deriv2_classes[4][10][20] = int_stack + 560217;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 561207;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 561648;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 562236;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 562992;
 Libderiv->deriv2_classes[5][9][20] = int_stack + 563937;
 Libderiv->deriv2_classes[5][10][20] = int_stack + 565092;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 566478;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 567066;
 Libderiv->deriv2_classes[6][7][20] = int_stack + 567850;
 Libderiv->deriv2_classes[6][8][20] = int_stack + 568858;
 Libderiv->deriv2_classes[6][9][20] = int_stack + 570118;
 Libderiv->deriv2_classes[6][10][20] = int_stack + 571658;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 573506;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 573821;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 574241;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 574781;
 Libderiv->deriv2_classes[4][9][19] = int_stack + 575456;
 Libderiv->deriv2_classes[4][10][19] = int_stack + 576281;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 577271;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 577712;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 578300;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 579056;
 Libderiv->deriv2_classes[5][9][19] = int_stack + 580001;
 Libderiv->deriv2_classes[5][10][19] = int_stack + 581156;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 582542;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 583130;
 Libderiv->deriv2_classes[6][7][19] = int_stack + 583914;
 Libderiv->deriv2_classes[6][8][19] = int_stack + 584922;
 Libderiv->deriv2_classes[6][9][19] = int_stack + 586182;
 Libderiv->deriv2_classes[6][10][19] = int_stack + 587722;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 589570;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 589885;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 590305;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 590845;
 Libderiv->deriv2_classes[4][9][18] = int_stack + 591520;
 Libderiv->deriv2_classes[4][10][18] = int_stack + 592345;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 593335;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 593776;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 594364;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 595120;
 Libderiv->deriv2_classes[5][9][18] = int_stack + 596065;
 Libderiv->deriv2_classes[5][10][18] = int_stack + 597220;
 Libderiv->deriv_classes[6][5][1] = int_stack + 598606;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 599194;
 Libderiv->deriv_classes[6][6][1] = int_stack + 599782;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 600566;
 Libderiv->deriv_classes[6][7][1] = int_stack + 601350;
 Libderiv->deriv2_classes[6][7][18] = int_stack + 602358;
 Libderiv->deriv_classes[6][8][1] = int_stack + 603366;
 Libderiv->deriv2_classes[6][8][18] = int_stack + 604626;
 Libderiv->deriv_classes[6][9][1] = int_stack + 605886;
 Libderiv->deriv2_classes[6][9][18] = int_stack + 607426;
 Libderiv->deriv2_classes[6][10][18] = int_stack + 608966;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 610814;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 611129;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 611549;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 612089;
 Libderiv->deriv2_classes[4][9][14] = int_stack + 612764;
 Libderiv->deriv2_classes[4][10][14] = int_stack + 613589;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 614579;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 615020;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 615608;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 616364;
 Libderiv->deriv2_classes[5][9][14] = int_stack + 617309;
 Libderiv->deriv2_classes[5][10][14] = int_stack + 618464;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 619850;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 620438;
 Libderiv->deriv2_classes[6][7][14] = int_stack + 621222;
 Libderiv->deriv2_classes[6][8][14] = int_stack + 622230;
 Libderiv->deriv2_classes[6][9][14] = int_stack + 623490;
 Libderiv->deriv2_classes[6][10][14] = int_stack + 625030;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 626878;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 627193;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 627613;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 628153;
 Libderiv->deriv2_classes[4][9][13] = int_stack + 628828;
 Libderiv->deriv2_classes[4][10][13] = int_stack + 629653;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 630643;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 631084;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 631672;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 632428;
 Libderiv->deriv2_classes[5][9][13] = int_stack + 633373;
 Libderiv->deriv2_classes[5][10][13] = int_stack + 634528;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 635914;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 636502;
 Libderiv->deriv2_classes[6][7][13] = int_stack + 637286;
 Libderiv->deriv2_classes[6][8][13] = int_stack + 638294;
 Libderiv->deriv2_classes[6][9][13] = int_stack + 639554;
 Libderiv->deriv2_classes[6][10][13] = int_stack + 641094;
 Libderiv->deriv_classes[4][5][11] = int_stack + 642942;
 Libderiv->deriv_classes[4][6][11] = int_stack + 643257;
 Libderiv->deriv_classes[4][7][11] = int_stack + 643677;
 Libderiv->deriv_classes[4][8][11] = int_stack + 644217;
 Libderiv->deriv_classes[4][9][11] = int_stack + 644892;
 Libderiv->deriv_classes[4][10][11] = int_stack + 645717;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 646707;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 647022;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 647442;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 647982;
 Libderiv->deriv2_classes[4][9][11] = int_stack + 648657;
 Libderiv->deriv2_classes[4][10][11] = int_stack + 649482;
 Libderiv->deriv_classes[5][5][11] = int_stack + 650472;
 Libderiv->deriv_classes[5][6][11] = int_stack + 650913;
 Libderiv->deriv_classes[5][7][11] = int_stack + 651501;
 Libderiv->deriv_classes[5][8][11] = int_stack + 652257;
 Libderiv->deriv_classes[5][9][11] = int_stack + 653202;
 Libderiv->deriv_classes[5][10][11] = int_stack + 654357;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 655743;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 656184;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 656772;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 657528;
 Libderiv->deriv2_classes[5][9][11] = int_stack + 658473;
 Libderiv->deriv2_classes[5][10][11] = int_stack + 659628;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 661014;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 661602;
 Libderiv->deriv2_classes[6][7][11] = int_stack + 662386;
 Libderiv->deriv2_classes[6][8][11] = int_stack + 663394;
 Libderiv->deriv2_classes[6][9][11] = int_stack + 664654;
 Libderiv->deriv2_classes[6][10][11] = int_stack + 666194;
 Libderiv->deriv_classes[4][5][10] = int_stack + 668042;
 Libderiv->deriv_classes[4][6][10] = int_stack + 668357;
 Libderiv->deriv_classes[4][7][10] = int_stack + 668777;
 Libderiv->deriv_classes[4][8][10] = int_stack + 669317;
 Libderiv->deriv_classes[4][9][10] = int_stack + 669992;
 Libderiv->deriv_classes[4][10][10] = int_stack + 670817;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 671807;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 672122;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 672542;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 673082;
 Libderiv->deriv2_classes[4][9][10] = int_stack + 673757;
 Libderiv->deriv2_classes[4][10][10] = int_stack + 674582;
 Libderiv->deriv_classes[5][5][10] = int_stack + 675572;
 Libderiv->deriv_classes[5][6][10] = int_stack + 676013;
 Libderiv->deriv_classes[5][7][10] = int_stack + 676601;
 Libderiv->deriv_classes[5][8][10] = int_stack + 677357;
 Libderiv->deriv_classes[5][9][10] = int_stack + 678302;
 Libderiv->deriv_classes[5][10][10] = int_stack + 679457;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 680843;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 681284;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 681872;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 682628;
 Libderiv->deriv2_classes[5][9][10] = int_stack + 683573;
 Libderiv->deriv2_classes[5][10][10] = int_stack + 684728;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 686114;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 686702;
 Libderiv->deriv2_classes[6][7][10] = int_stack + 687486;
 Libderiv->deriv2_classes[6][8][10] = int_stack + 688494;
 Libderiv->deriv2_classes[6][9][10] = int_stack + 689754;
 Libderiv->deriv2_classes[6][10][10] = int_stack + 691294;
 Libderiv->deriv_classes[4][5][9] = int_stack + 693142;
 Libderiv->deriv_classes[4][6][9] = int_stack + 693457;
 Libderiv->deriv_classes[4][7][9] = int_stack + 693877;
 Libderiv->deriv_classes[4][8][9] = int_stack + 694417;
 Libderiv->deriv_classes[4][9][9] = int_stack + 695092;
 Libderiv->deriv_classes[4][10][9] = int_stack + 695917;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 696907;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 697222;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 697642;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 698182;
 Libderiv->deriv2_classes[4][9][9] = int_stack + 698857;
 Libderiv->deriv2_classes[4][10][9] = int_stack + 699682;
 Libderiv->deriv_classes[5][5][9] = int_stack + 700672;
 Libderiv->deriv_classes[5][6][9] = int_stack + 701113;
 Libderiv->deriv_classes[5][7][9] = int_stack + 701701;
 Libderiv->deriv_classes[5][8][9] = int_stack + 702457;
 Libderiv->deriv_classes[5][9][9] = int_stack + 703402;
 Libderiv->deriv_classes[5][10][9] = int_stack + 704557;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 705943;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 706384;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 706972;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 707728;
 Libderiv->deriv2_classes[5][9][9] = int_stack + 708673;
 Libderiv->deriv2_classes[5][10][9] = int_stack + 709828;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 711214;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 711802;
 Libderiv->deriv2_classes[6][7][9] = int_stack + 712586;
 Libderiv->deriv2_classes[6][8][9] = int_stack + 713594;
 Libderiv->deriv2_classes[6][9][9] = int_stack + 714854;
 Libderiv->deriv2_classes[6][10][9] = int_stack + 716394;
 Libderiv->deriv_classes[4][5][8] = int_stack + 718242;
 Libderiv->deriv_classes[4][6][8] = int_stack + 718557;
 Libderiv->deriv_classes[4][7][8] = int_stack + 718977;
 Libderiv->deriv_classes[4][8][8] = int_stack + 719517;
 Libderiv->deriv_classes[4][9][8] = int_stack + 720192;
 Libderiv->deriv_classes[4][10][8] = int_stack + 721017;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 722007;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 722322;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 722742;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 723282;
 Libderiv->deriv2_classes[4][9][8] = int_stack + 723957;
 Libderiv->deriv2_classes[4][10][8] = int_stack + 724782;
 Libderiv->deriv_classes[5][5][8] = int_stack + 725772;
 Libderiv->deriv_classes[5][6][8] = int_stack + 726213;
 Libderiv->deriv_classes[5][7][8] = int_stack + 726801;
 Libderiv->deriv_classes[5][8][8] = int_stack + 727557;
 Libderiv->deriv_classes[5][9][8] = int_stack + 728502;
 Libderiv->deriv_classes[5][10][8] = int_stack + 729657;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 731043;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 731484;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 732072;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 732828;
 Libderiv->deriv2_classes[5][9][8] = int_stack + 733773;
 Libderiv->deriv2_classes[5][10][8] = int_stack + 734928;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 736314;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 736902;
 Libderiv->deriv2_classes[6][7][8] = int_stack + 737686;
 Libderiv->deriv2_classes[6][8][8] = int_stack + 738694;
 Libderiv->deriv2_classes[6][9][8] = int_stack + 739954;
 Libderiv->deriv2_classes[6][10][8] = int_stack + 741494;
 Libderiv->deriv_classes[4][5][7] = int_stack + 743342;
 Libderiv->deriv_classes[4][6][7] = int_stack + 743657;
 Libderiv->deriv_classes[4][7][7] = int_stack + 744077;
 Libderiv->deriv_classes[4][8][7] = int_stack + 744617;
 Libderiv->deriv_classes[4][9][7] = int_stack + 745292;
 Libderiv->deriv_classes[4][10][7] = int_stack + 746117;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 747107;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 747422;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 747842;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 748382;
 Libderiv->deriv2_classes[4][9][7] = int_stack + 749057;
 Libderiv->deriv2_classes[4][10][7] = int_stack + 749882;
 Libderiv->deriv_classes[5][5][7] = int_stack + 750872;
 Libderiv->deriv_classes[5][6][7] = int_stack + 751313;
 Libderiv->deriv_classes[5][7][7] = int_stack + 751901;
 Libderiv->deriv_classes[5][8][7] = int_stack + 752657;
 Libderiv->deriv_classes[5][9][7] = int_stack + 753602;
 Libderiv->deriv_classes[5][10][7] = int_stack + 754757;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 756143;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 756584;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 757172;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 757928;
 Libderiv->deriv2_classes[5][9][7] = int_stack + 758873;
 Libderiv->deriv2_classes[5][10][7] = int_stack + 760028;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 761414;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 762002;
 Libderiv->deriv2_classes[6][7][7] = int_stack + 762786;
 Libderiv->deriv2_classes[6][8][7] = int_stack + 763794;
 Libderiv->deriv2_classes[6][9][7] = int_stack + 765054;
 Libderiv->deriv2_classes[6][10][7] = int_stack + 766594;
 Libderiv->deriv_classes[4][5][6] = int_stack + 768442;
 Libderiv->deriv_classes[4][6][6] = int_stack + 768757;
 Libderiv->deriv_classes[4][7][6] = int_stack + 769177;
 Libderiv->deriv_classes[4][8][6] = int_stack + 769717;
 Libderiv->deriv_classes[4][9][6] = int_stack + 770392;
 Libderiv->deriv_classes[4][10][6] = int_stack + 771217;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 772207;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 772522;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 772942;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 773482;
 Libderiv->deriv2_classes[4][9][6] = int_stack + 774157;
 Libderiv->deriv2_classes[4][10][6] = int_stack + 774982;
 Libderiv->dvrr_classes[5][5] = int_stack + 775972;
 Libderiv->deriv_classes[5][5][6] = int_stack + 776413;
 Libderiv->dvrr_classes[5][6] = int_stack + 776854;
 Libderiv->deriv_classes[5][6][6] = int_stack + 777442;
 Libderiv->dvrr_classes[5][7] = int_stack + 778030;
 Libderiv->deriv_classes[5][7][6] = int_stack + 778786;
 Libderiv->dvrr_classes[5][8] = int_stack + 779542;
 Libderiv->deriv_classes[5][8][6] = int_stack + 780487;
 Libderiv->dvrr_classes[5][9] = int_stack + 781432;
 Libderiv->deriv_classes[5][9][6] = int_stack + 782587;
 Libderiv->deriv_classes[5][10][6] = int_stack + 783742;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 785128;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 785569;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 786157;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 786913;
 Libderiv->deriv2_classes[5][9][6] = int_stack + 787858;
 Libderiv->deriv2_classes[5][10][6] = int_stack + 789013;
 Libderiv->deriv_classes[6][5][0] = int_stack + 790399;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 790987;
 Libderiv->deriv_classes[6][6][0] = int_stack + 791575;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 792359;
 Libderiv->deriv_classes[6][7][0] = int_stack + 793143;
 Libderiv->deriv2_classes[6][7][6] = int_stack + 794151;
 Libderiv->deriv_classes[6][8][0] = int_stack + 795159;
 Libderiv->deriv2_classes[6][8][6] = int_stack + 796419;
 Libderiv->deriv_classes[6][9][0] = int_stack + 797679;
 Libderiv->deriv2_classes[6][9][6] = int_stack + 799219;
 Libderiv->deriv2_classes[6][10][6] = int_stack + 800759;
 Libderiv->deriv_classes[4][5][2] = int_stack + 802607;
 Libderiv->deriv_classes[4][6][2] = int_stack + 802922;
 Libderiv->deriv_classes[4][7][2] = int_stack + 803342;
 Libderiv->deriv_classes[4][8][2] = int_stack + 803882;
 Libderiv->deriv_classes[4][9][2] = int_stack + 804557;
 Libderiv->deriv_classes[4][10][2] = int_stack + 805382;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 806372;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 806687;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 807107;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 807647;
 Libderiv->deriv2_classes[4][9][2] = int_stack + 808322;
 Libderiv->deriv2_classes[4][10][2] = int_stack + 809147;
 Libderiv->deriv_classes[5][5][2] = int_stack + 810137;
 Libderiv->deriv_classes[5][6][2] = int_stack + 810578;
 Libderiv->deriv_classes[5][7][2] = int_stack + 811166;
 Libderiv->deriv_classes[5][8][2] = int_stack + 811922;
 Libderiv->deriv_classes[5][9][2] = int_stack + 812867;
 Libderiv->deriv_classes[5][10][2] = int_stack + 814022;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 815408;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 815849;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 816437;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 817193;
 Libderiv->deriv2_classes[5][9][2] = int_stack + 818138;
 Libderiv->deriv2_classes[5][10][2] = int_stack + 819293;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 820679;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 821267;
 Libderiv->deriv2_classes[6][7][2] = int_stack + 822051;
 Libderiv->deriv2_classes[6][8][2] = int_stack + 823059;
 Libderiv->deriv2_classes[6][9][2] = int_stack + 824319;
 Libderiv->deriv2_classes[6][10][2] = int_stack + 825859;
 Libderiv->deriv_classes[4][5][1] = int_stack + 827707;
 Libderiv->deriv_classes[4][6][1] = int_stack + 828022;
 Libderiv->deriv_classes[4][7][1] = int_stack + 828442;
 Libderiv->deriv_classes[4][8][1] = int_stack + 828982;
 Libderiv->deriv_classes[4][9][1] = int_stack + 829657;
 Libderiv->deriv_classes[4][10][1] = int_stack + 830482;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 831472;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 831787;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 832207;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 832747;
 Libderiv->deriv2_classes[4][9][1] = int_stack + 833422;
 Libderiv->deriv2_classes[4][10][1] = int_stack + 834247;
 Libderiv->deriv_classes[5][5][1] = int_stack + 835237;
 Libderiv->deriv_classes[5][6][1] = int_stack + 835678;
 Libderiv->deriv_classes[5][7][1] = int_stack + 836266;
 Libderiv->deriv_classes[5][8][1] = int_stack + 837022;
 Libderiv->deriv_classes[5][9][1] = int_stack + 837967;
 Libderiv->deriv_classes[5][10][1] = int_stack + 839122;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 840508;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 840949;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 841537;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 842293;
 Libderiv->deriv2_classes[5][9][1] = int_stack + 843238;
 Libderiv->deriv2_classes[5][10][1] = int_stack + 844393;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 845779;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 846367;
 Libderiv->deriv2_classes[6][7][1] = int_stack + 847151;
 Libderiv->deriv2_classes[6][8][1] = int_stack + 848159;
 Libderiv->deriv2_classes[6][9][1] = int_stack + 849419;
 Libderiv->deriv2_classes[6][10][1] = int_stack + 850959;
 Libderiv->dvrr_classes[4][5] = int_stack + 852807;
 Libderiv->dvrr_classes[4][6] = int_stack + 853122;
 Libderiv->dvrr_classes[4][7] = int_stack + 853542;
 Libderiv->dvrr_classes[4][8] = int_stack + 854082;
 Libderiv->dvrr_classes[4][9] = int_stack + 854757;
 Libderiv->dvrr_classes[4][10] = int_stack + 855582;
 Libderiv->deriv_classes[4][5][0] = int_stack + 856572;
 Libderiv->deriv_classes[4][6][0] = int_stack + 856887;
 Libderiv->deriv_classes[4][7][0] = int_stack + 857307;
 Libderiv->deriv_classes[4][8][0] = int_stack + 857847;
 Libderiv->deriv_classes[4][9][0] = int_stack + 858522;
 Libderiv->deriv_classes[4][10][0] = int_stack + 859347;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 860337;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 860652;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 861072;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 861612;
 Libderiv->deriv2_classes[4][9][0] = int_stack + 862287;
 Libderiv->deriv2_classes[4][10][0] = int_stack + 863112;
 Libderiv->deriv_classes[5][5][0] = int_stack + 864102;
 Libderiv->deriv_classes[5][6][0] = int_stack + 864543;
 Libderiv->deriv_classes[5][7][0] = int_stack + 865131;
 Libderiv->deriv_classes[5][8][0] = int_stack + 865887;
 Libderiv->deriv_classes[5][9][0] = int_stack + 866832;
 Libderiv->deriv_classes[5][10][0] = int_stack + 867987;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 869373;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 869814;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 870402;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 871158;
 Libderiv->deriv2_classes[5][9][0] = int_stack + 872103;
 Libderiv->deriv2_classes[5][10][0] = int_stack + 873258;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 874644;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 875232;
 Libderiv->deriv2_classes[6][7][0] = int_stack + 876016;
 Libderiv->deriv2_classes[6][8][0] = int_stack + 877024;
 Libderiv->deriv2_classes[6][9][0] = int_stack + 878284;
 Libderiv->deriv2_classes[6][10][0] = int_stack + 879824;
 memset(int_stack,0,7053376);

 Libderiv->dvrr_stack = int_stack + 3187749;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_gdhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+881672,int_stack+853122,int_stack+852807,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+882617,int_stack+853542,int_stack+853122,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+883877,int_stack+882617,int_stack+881672,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+885767,int_stack+854082,int_stack+853542,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+887387,int_stack+885767,int_stack+882617,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+889907,int_stack+887387,int_stack+883877,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+893057,int_stack+854757,int_stack+854082,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+895082,int_stack+893057,int_stack+885767,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+898322,int_stack+895082,int_stack+887387,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+902522,int_stack+898322,int_stack+889907,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+907247,int_stack+643257,int_stack+642942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+908192,int_stack+643677,int_stack+643257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853122,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+909452,int_stack+908192,int_stack+907247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881672,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+911342,int_stack+644217,int_stack+643677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853542,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+912962,int_stack+911342,int_stack+908192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+882617,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+915482,int_stack+912962,int_stack+909452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883877,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+918632,int_stack+644892,int_stack+644217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854082,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+920657,int_stack+918632,int_stack+911342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885767,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+923897,int_stack+920657,int_stack+912962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887387,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+928097,int_stack+923897,int_stack+915482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+889907,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+932822,int_stack+645717,int_stack+644892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854757,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+935297,int_stack+932822,int_stack+918632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+893057,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+939347,int_stack+935297,int_stack+920657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895082,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+932822,int_stack+939347,int_stack+923897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898322,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+939122,int_stack+932822,int_stack+928097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+902522,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+932822,int_stack+776854,int_stack+775972,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+934145,int_stack+778030,int_stack+776854,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+935909,int_stack+934145,int_stack+932822,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+945737,int_stack+779542,int_stack+778030,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+948005,int_stack+945737,int_stack+934145,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+951533,int_stack+948005,int_stack+935909,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+955943,int_stack+781432,int_stack+779542,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+958778,int_stack+955943,int_stack+945737,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+963314,int_stack+958778,int_stack+948005,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+969194,int_stack+963314,int_stack+951533,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+975809,int_stack+650913,int_stack+650472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775972,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+977132,int_stack+651501,int_stack+650913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776854,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+978896,int_stack+977132,int_stack+975809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932822,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+981542,int_stack+652257,int_stack+651501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778030,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+983810,int_stack+981542,int_stack+977132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934145,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+987338,int_stack+983810,int_stack+978896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935909,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+991748,int_stack+653202,int_stack+652257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+994583,int_stack+991748,int_stack+981542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945737,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+999119,int_stack+994583,int_stack+983810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948005,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1004999,int_stack+999119,int_stack+987338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951533,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1011614,int_stack+654357,int_stack+653202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781432,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1015079,int_stack+1011614,int_stack+991748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+955943,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1020749,int_stack+1015079,int_stack+994583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958778,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1011614,int_stack+1020749,int_stack+999119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+963314,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1020434,int_stack+1011614,int_stack+1004999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969194,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1029695,int_stack+1020434,int_stack+939122,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1011614,int_stack+377538,int_stack+375774,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1013378,int_stack+379890,int_stack+377538,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1015730,int_stack+1013378,int_stack+1011614,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1049540,int_stack+382914,int_stack+379890,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1052564,int_stack+1049540,int_stack+1013378,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1057268,int_stack+1052564,int_stack+1015730,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1063148,int_stack+9240,int_stack+382914,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1066928,int_stack+1063148,int_stack+1049540,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1072976,int_stack+1066928,int_stack+1052564,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1080816,int_stack+1072976,int_stack+1057268,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1089636,int_stack+270730,int_stack+269554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375774,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1091400,int_stack+272298,int_stack+270730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377538,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1093752,int_stack+1091400,int_stack+1089636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011614,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1097280,int_stack+274314,int_stack+272298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379890,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1100304,int_stack+1097280,int_stack+1091400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1013378,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1105008,int_stack+1100304,int_stack+1093752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015730,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1110888,int_stack+276834,int_stack+274314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1114668,int_stack+1110888,int_stack+1097280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1120716,int_stack+1114668,int_stack+1100304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052564,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1128556,int_stack+1120716,int_stack+1105008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057268,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1137376,int_stack+0,int_stack+276834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1141996,int_stack+1137376,int_stack+1110888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1063148,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1149556,int_stack+1141996,int_stack+1114668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1066928,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1137376,int_stack+1149556,int_stack+1120716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1072976,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1149136,int_stack+1137376,int_stack+1128556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080816,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1161484,int_stack+1149136,int_stack+1020434,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1137376,int_stack+668357,int_stack+668042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1138321,int_stack+668777,int_stack+668357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853122, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1139581,int_stack+1138321,int_stack+1137376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881672, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1141471,int_stack+669317,int_stack+668777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853542, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1143091,int_stack+1141471,int_stack+1138321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+882617, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1145611,int_stack+1143091,int_stack+1139581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883877, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1148761,int_stack+669992,int_stack+669317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854082, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1150786,int_stack+1148761,int_stack+1141471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885767, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1154026,int_stack+1150786,int_stack+1143091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887387, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1189267,int_stack+1154026,int_stack+1145611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+889907, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1158226,int_stack+670817,int_stack+669992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854757, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1193992,int_stack+1158226,int_stack+1148761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+893057, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1198042,int_stack+1193992,int_stack+1150786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895082, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1203442,int_stack+1198042,int_stack+1154026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898322, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1193992,int_stack+1203442,int_stack+1189267, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+902522, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1200607,int_stack+676013,int_stack+675572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775972, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1201930,int_stack+676601,int_stack+676013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776854, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1203694,int_stack+1201930,int_stack+1200607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932822, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1206340,int_stack+677357,int_stack+676601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778030, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1208608,int_stack+1206340,int_stack+1201930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934145, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1212136,int_stack+1208608,int_stack+1203694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935909, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1158226,int_stack+678302,int_stack+677357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1216546,int_stack+1158226,int_stack+1206340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945737, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1221082,int_stack+1216546,int_stack+1208608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948005, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1226962,int_stack+1221082,int_stack+1212136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951533, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1233577,int_stack+679457,int_stack+678302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781432, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1237042,int_stack+1233577,int_stack+1158226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+955943, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1242712,int_stack+1237042,int_stack+1216546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958778, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1233577,int_stack+1242712,int_stack+1221082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+963314, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1242397,int_stack+1233577,int_stack+1226962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969194, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1251658,int_stack+1242397,int_stack+1193992,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1233577,int_stack+291974,int_stack+290798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375774, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1235341,int_stack+293542,int_stack+291974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377538, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1237693,int_stack+1235341,int_stack+1233577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011614, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1271503,int_stack+295558,int_stack+293542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379890, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1274527,int_stack+1271503,int_stack+1235341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1013378, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1279231,int_stack+1274527,int_stack+1237693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015730, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1285111,int_stack+298078,int_stack+295558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1288891,int_stack+1285111,int_stack+1271503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1294939,int_stack+1288891,int_stack+1274527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052564, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1302779,int_stack+1294939,int_stack+1279231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057268, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1311599,int_stack+1848,int_stack+298078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1316219,int_stack+1311599,int_stack+1285111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1063148, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1323779,int_stack+1316219,int_stack+1288891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1066928, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1311599,int_stack+1323779,int_stack+1294939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1072976, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1323359,int_stack+1311599,int_stack+1302779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080816, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1335707,int_stack+1323359,int_stack+1242397,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1311599,int_stack+693457,int_stack+693142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1312544,int_stack+693877,int_stack+693457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853122, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1313804,int_stack+1312544,int_stack+1311599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1315694,int_stack+694417,int_stack+693877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853542, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1317314,int_stack+1315694,int_stack+1312544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+882617, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1319834,int_stack+1317314,int_stack+1313804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883877, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1322984,int_stack+695092,int_stack+694417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854082, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1325009,int_stack+1322984,int_stack+1315694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885767, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1328249,int_stack+1325009,int_stack+1317314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887387, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1363490,int_stack+1328249,int_stack+1319834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+889907, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1332449,int_stack+695917,int_stack+695092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854757, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1368215,int_stack+1332449,int_stack+1322984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+893057, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1372265,int_stack+1368215,int_stack+1325009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895082, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1377665,int_stack+1372265,int_stack+1328249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898322, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1368215,int_stack+1377665,int_stack+1363490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+902522, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+701113,int_stack+700672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775972, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1376153,int_stack+701701,int_stack+701113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776854, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377917,int_stack+1376153,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1380563,int_stack+702457,int_stack+701701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+1380563,int_stack+1376153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934145, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1382831,int_stack+0,int_stack+1377917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935909, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1332449,int_stack+703402,int_stack+702457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1387241,int_stack+1332449,int_stack+1380563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1391777,int_stack+1387241,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948005, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1397657,int_stack+1391777,int_stack+1382831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951533, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1404272,int_stack+704557,int_stack+703402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781432, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1407737,int_stack+1404272,int_stack+1332449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+955943, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1413407,int_stack+1407737,int_stack+1387241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958778, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1404272,int_stack+1413407,int_stack+1391777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+963314, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1413092,int_stack+1404272,int_stack+1397657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969194, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1422353,int_stack+1413092,int_stack+1368215,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1404272,int_stack+313218,int_stack+312042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375774, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1406036,int_stack+314786,int_stack+313218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377538, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1408388,int_stack+1406036,int_stack+1404272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1442198,int_stack+316802,int_stack+314786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379890, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1445222,int_stack+1442198,int_stack+1406036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1013378, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1449926,int_stack+1445222,int_stack+1408388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015730, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1455806,int_stack+319322,int_stack+316802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1459586,int_stack+1455806,int_stack+1442198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1465634,int_stack+1459586,int_stack+1445222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052564, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1473474,int_stack+1465634,int_stack+1449926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057268, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1482294,int_stack+3696,int_stack+319322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1486914,int_stack+1482294,int_stack+1455806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1063148, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1494474,int_stack+1486914,int_stack+1459586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1066928, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1482294,int_stack+1494474,int_stack+1465634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1072976, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1494054,int_stack+1482294,int_stack+1473474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080816, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1506402,int_stack+1494054,int_stack+1413092,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1482294,int_stack+718557,int_stack+718242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1483239,int_stack+718977,int_stack+718557, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1484499,int_stack+1483239,int_stack+1482294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1486389,int_stack+719517,int_stack+718977, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1488009,int_stack+1486389,int_stack+1483239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+882617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1490529,int_stack+1488009,int_stack+1484499, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1493679,int_stack+720192,int_stack+719517, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1495704,int_stack+1493679,int_stack+1486389, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1498944,int_stack+1495704,int_stack+1488009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+887387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1534185,int_stack+1498944,int_stack+1490529, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+889907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1503144,int_stack+721017,int_stack+720192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1538910,int_stack+1503144,int_stack+1493679, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+893057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1542960,int_stack+1538910,int_stack+1495704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1548360,int_stack+1542960,int_stack+1498944, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+898322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1538910,int_stack+1548360,int_stack+1534185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+902522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1545525,int_stack+726213,int_stack+725772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+775972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1546848,int_stack+726801,int_stack+726213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1548612,int_stack+1546848,int_stack+1545525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1551258,int_stack+727557,int_stack+726801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1553526,int_stack+1551258,int_stack+1546848, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1557054,int_stack+1553526,int_stack+1548612, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1503144,int_stack+728502,int_stack+727557, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1561464,int_stack+1503144,int_stack+1551258, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1566000,int_stack+1561464,int_stack+1553526, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1571880,int_stack+1566000,int_stack+1557054, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1578495,int_stack+729657,int_stack+728502, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1581960,int_stack+1578495,int_stack+1503144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+955943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1587630,int_stack+1581960,int_stack+1561464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1578495,int_stack+1587630,int_stack+1566000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+963314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1587315,int_stack+1578495,int_stack+1571880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1596576,int_stack+1587315,int_stack+1538910,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1578495,int_stack+334462,int_stack+333286, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1580259,int_stack+336030,int_stack+334462, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1582611,int_stack+1580259,int_stack+1578495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1616421,int_stack+338046,int_stack+336030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1619445,int_stack+1616421,int_stack+1580259, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1013378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1624149,int_stack+1619445,int_stack+1582611, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1630029,int_stack+340566,int_stack+338046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1633809,int_stack+1630029,int_stack+1616421, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1639857,int_stack+1633809,int_stack+1619445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1052564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1647697,int_stack+1639857,int_stack+1624149, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1057268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1656517,int_stack+5544,int_stack+340566, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1661137,int_stack+1656517,int_stack+1630029, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1063148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1668697,int_stack+1661137,int_stack+1633809, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1066928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1656517,int_stack+1668697,int_stack+1639857, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1072976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1668277,int_stack+1656517,int_stack+1647697, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1680625,int_stack+1668277,int_stack+1587315,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1656517,int_stack+743657,int_stack+743342, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1657462,int_stack+744077,int_stack+743657, 0.0, zero_stack, 1.0, int_stack+853122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1658722,int_stack+1657462,int_stack+1656517, 0.0, zero_stack, 1.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1660612,int_stack+744617,int_stack+744077, 0.0, zero_stack, 1.0, int_stack+853542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1662232,int_stack+1660612,int_stack+1657462, 0.0, zero_stack, 1.0, int_stack+882617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1664752,int_stack+1662232,int_stack+1658722, 0.0, zero_stack, 1.0, int_stack+883877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1667902,int_stack+745292,int_stack+744617, 0.0, zero_stack, 1.0, int_stack+854082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1669927,int_stack+1667902,int_stack+1660612, 0.0, zero_stack, 1.0, int_stack+885767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1673167,int_stack+1669927,int_stack+1662232, 0.0, zero_stack, 1.0, int_stack+887387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1673167,int_stack+1664752, 0.0, zero_stack, 1.0, int_stack+889907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1677367,int_stack+746117,int_stack+745292, 0.0, zero_stack, 1.0, int_stack+854757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1713133,int_stack+1677367,int_stack+1667902, 0.0, zero_stack, 1.0, int_stack+893057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1717183,int_stack+1713133,int_stack+1669927, 0.0, zero_stack, 1.0, int_stack+895082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1722583,int_stack+1717183,int_stack+1673167, 0.0, zero_stack, 1.0, int_stack+898322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1713133,int_stack+1722583,int_stack+1708408, 0.0, zero_stack, 1.0, int_stack+902522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1719748,int_stack+751313,int_stack+750872, 0.0, zero_stack, 1.0, int_stack+775972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1721071,int_stack+751901,int_stack+751313, 0.0, zero_stack, 1.0, int_stack+776854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1722835,int_stack+1721071,int_stack+1719748, 0.0, zero_stack, 1.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1725481,int_stack+752657,int_stack+751901, 0.0, zero_stack, 1.0, int_stack+778030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3528,int_stack+1725481,int_stack+1721071, 0.0, zero_stack, 1.0, int_stack+934145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1727749,int_stack+3528,int_stack+1722835, 0.0, zero_stack, 1.0, int_stack+935909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1677367,int_stack+753602,int_stack+752657, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1732159,int_stack+1677367,int_stack+1725481, 0.0, zero_stack, 1.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1736695,int_stack+1732159,int_stack+3528, 0.0, zero_stack, 1.0, int_stack+948005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1742575,int_stack+1736695,int_stack+1727749, 0.0, zero_stack, 1.0, int_stack+951533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1749190,int_stack+754757,int_stack+753602, 0.0, zero_stack, 1.0, int_stack+781432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1752655,int_stack+1749190,int_stack+1677367, 0.0, zero_stack, 1.0, int_stack+955943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1758325,int_stack+1752655,int_stack+1732159, 0.0, zero_stack, 1.0, int_stack+958778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1749190,int_stack+1758325,int_stack+1736695, 0.0, zero_stack, 1.0, int_stack+963314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1758010,int_stack+1749190,int_stack+1742575, 0.0, zero_stack, 1.0, int_stack+969194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1767271,int_stack+1758010,int_stack+1713133,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1749190,int_stack+355706,int_stack+354530, 0.0, zero_stack, 1.0, int_stack+375774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1750954,int_stack+357274,int_stack+355706, 0.0, zero_stack, 1.0, int_stack+377538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1753306,int_stack+1750954,int_stack+1749190, 0.0, zero_stack, 1.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1787116,int_stack+359290,int_stack+357274, 0.0, zero_stack, 1.0, int_stack+379890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1790140,int_stack+1787116,int_stack+1750954, 0.0, zero_stack, 1.0, int_stack+1013378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1794844,int_stack+1790140,int_stack+1753306, 0.0, zero_stack, 1.0, int_stack+1015730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1800724,int_stack+361810,int_stack+359290, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1804504,int_stack+1800724,int_stack+1787116, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1810552,int_stack+1804504,int_stack+1790140, 0.0, zero_stack, 1.0, int_stack+1052564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1818392,int_stack+1810552,int_stack+1794844, 0.0, zero_stack, 1.0, int_stack+1057268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1827212,int_stack+7392,int_stack+361810, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1831832,int_stack+1827212,int_stack+1800724, 0.0, zero_stack, 1.0, int_stack+1063148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1839392,int_stack+1831832,int_stack+1804504, 0.0, zero_stack, 1.0, int_stack+1066928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1827212,int_stack+1839392,int_stack+1810552, 0.0, zero_stack, 1.0, int_stack+1072976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1838972,int_stack+1827212,int_stack+1818392, 0.0, zero_stack, 1.0, int_stack+1080816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1851320,int_stack+1838972,int_stack+1758010,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1827212,int_stack+768757,int_stack+768442, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1828157,int_stack+769177,int_stack+768757, 1.0, int_stack+853122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1829417,int_stack+1828157,int_stack+1827212, 1.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1831307,int_stack+769717,int_stack+769177, 1.0, int_stack+853542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1832927,int_stack+1831307,int_stack+1828157, 1.0, int_stack+882617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1835447,int_stack+1832927,int_stack+1829417, 1.0, int_stack+883877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+881672,int_stack+770392,int_stack+769717, 1.0, int_stack+854082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1838597,int_stack+881672,int_stack+1831307, 1.0, int_stack+885767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1841837,int_stack+1838597,int_stack+1832927, 1.0, int_stack+887387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+883697,int_stack+1841837,int_stack+1835447, 1.0, int_stack+889907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+888422,int_stack+771217,int_stack+770392, 1.0, int_stack+854757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1846037,int_stack+888422,int_stack+881672, 1.0, int_stack+893057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1879103,int_stack+1846037,int_stack+1838597, 1.0, int_stack+895082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1884503,int_stack+1879103,int_stack+1841837, 1.0, int_stack+898322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1890803,int_stack+1884503,int_stack+883697, 1.0, int_stack+902522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1879103,int_stack+777442,int_stack+776413, 1.0, int_stack+775972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1880426,int_stack+778786,int_stack+777442, 1.0, int_stack+776854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1882190,int_stack+1880426,int_stack+1879103, 1.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1884836,int_stack+780487,int_stack+778786, 1.0, int_stack+778030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1887104,int_stack+1884836,int_stack+1880426, 1.0, int_stack+934145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1846037,int_stack+1887104,int_stack+1882190, 1.0, int_stack+935909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+932822,int_stack+782587,int_stack+780487, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+888422,int_stack+932822,int_stack+1884836, 1.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1897418,int_stack+888422,int_stack+1887104, 1.0, int_stack+948005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1903298,int_stack+1897418,int_stack+1846037, 1.0, int_stack+951533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+935657,int_stack+783742,int_stack+782587, 1.0, int_stack+781432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+945737,int_stack+935657,int_stack+932822, 1.0, int_stack+955943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1909913,int_stack+945737,int_stack+888422, 1.0, int_stack+958778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+945737,int_stack+1909913,int_stack+1897418, 1.0, int_stack+963314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1909913,int_stack+945737,int_stack+1903298, 1.0, int_stack+969194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1919174,int_stack+1909913,int_stack+1890803,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945737,int_stack+378322,int_stack+376362, 1.0, int_stack+375774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+947501,int_stack+380898,int_stack+378322, 1.0, int_stack+377538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+949853,int_stack+947501,int_stack+945737, 1.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+935657,int_stack+384174,int_stack+380898, 1.0, int_stack+379890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1939019,int_stack+935657,int_stack+947501, 1.0, int_stack+1013378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1943723,int_stack+1939019,int_stack+949853, 1.0, int_stack+1015730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1011614,int_stack+386694,int_stack+384174, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1949603,int_stack+1011614,int_stack+935657, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1955651,int_stack+1949603,int_stack+1939019, 1.0, int_stack+1052564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1963491,int_stack+1955651,int_stack+1943723, 1.0, int_stack+1057268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1049540,int_stack+10780,int_stack+386694, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1054160,int_stack+1049540,int_stack+1011614, 1.0, int_stack+1063148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1972311,int_stack+1054160,int_stack+1949603, 1.0, int_stack+1066928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1049540,int_stack+1972311,int_stack+1955651, 1.0, int_stack+1072976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1061300,int_stack+1049540,int_stack+1963491, 1.0, int_stack+1080816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1972311,int_stack+1061300,int_stack+1909913,441);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1049540,int_stack+855582,int_stack+854757,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1052015,int_stack+1049540,int_stack+893057,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1056065,int_stack+1052015,int_stack+895082,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1049540,int_stack+1056065,int_stack+898322,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1055840,int_stack+1049540,int_stack+902522,15);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1049540,int_stack+16324,int_stack+781432,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1062455,int_stack+1049540,int_stack+955943,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1068125,int_stack+1062455,int_stack+958778,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1075685,int_stack+1068125,int_stack+963314,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1062455,int_stack+1075685,int_stack+969194,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+953381,int_stack+1062455,int_stack+1055840,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+779542,int_stack+802922,int_stack+802607,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+382914,int_stack+803342,int_stack+802922,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1071716,int_stack+382914,int_stack+779542,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1073606,int_stack+803882,int_stack+803342,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1075226,int_stack+1073606,int_stack+382914,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1077746,int_stack+1075226,int_stack+1071716,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1080896,int_stack+804557,int_stack+803882,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1082921,int_stack+1080896,int_stack+1073606,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+1082921,int_stack+1075226,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1015394,int_stack+1049540,int_stack+1077746,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1086161,int_stack+805382,int_stack+804557,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+892958,int_stack+1086161,int_stack+1080896,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+897008,int_stack+892958,int_stack+1082921,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2000094,int_stack+897008,int_stack+1049540,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+892958,int_stack+2000094,int_stack+1015394,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2000094,int_stack+810578,int_stack+810137,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2001417,int_stack+811166,int_stack+810578,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2003181,int_stack+2001417,int_stack+2000094,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+899573,int_stack+811922,int_stack+811166,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+901841,int_stack+899573,int_stack+2001417,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7056,int_stack+901841,int_stack+2003181,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1086161,int_stack+812867,int_stack+811922,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2005827,int_stack+1086161,int_stack+899573,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2010363,int_stack+2005827,int_stack+901841,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2016243,int_stack+2010363,int_stack+7056,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+852807,int_stack+814022,int_stack+812867,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2022858,int_stack+852807,int_stack+1086161,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2028528,int_stack+2022858,int_stack+2005827,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2036088,int_stack+2028528,int_stack+2010363,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2022858,int_stack+2036088,int_stack+2016243,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2032119,int_stack+2022858,int_stack+892958, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1055840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+852807,int_stack+482154,int_stack+480978,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+973226,int_stack+483722,int_stack+482154,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2051964,int_stack+973226,int_stack+852807,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2055492,int_stack+485738,int_stack+483722,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2058516,int_stack+2055492,int_stack+973226,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2063220,int_stack+2058516,int_stack+2051964,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2069100,int_stack+488258,int_stack+485738,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2072880,int_stack+2069100,int_stack+2055492,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2078928,int_stack+2072880,int_stack+2058516,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2086768,int_stack+2078928,int_stack+2063220,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2095588,int_stack+12628,int_stack+488258,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2100208,int_stack+2095588,int_stack+2069100,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2107768,int_stack+2100208,int_stack+2072880,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2095588,int_stack+2107768,int_stack+2078928,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2107348,int_stack+2095588,int_stack+2086768,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2119696,int_stack+2107348,int_stack+2022858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1062455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2095588,int_stack+828022,int_stack+827707,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2096533,int_stack+828442,int_stack+828022,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2097793,int_stack+2096533,int_stack+2095588,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2099683,int_stack+828982,int_stack+828442,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2101303,int_stack+2099683,int_stack+2096533,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2103823,int_stack+2101303,int_stack+2097793,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2106973,int_stack+829657,int_stack+828982,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2108998,int_stack+2106973,int_stack+2099683,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2112238,int_stack+2108998,int_stack+2101303,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+2112238,int_stack+2103823,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2116438,int_stack+830482,int_stack+829657,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2152204,int_stack+2116438,int_stack+2106973,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2156254,int_stack+2152204,int_stack+2108998,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2161654,int_stack+2156254,int_stack+2112238,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2152204,int_stack+2161654,int_stack+2147479,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2158819,int_stack+835678,int_stack+835237,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2160142,int_stack+836266,int_stack+835678,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2161906,int_stack+2160142,int_stack+2158819,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2164552,int_stack+837022,int_stack+836266,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2166820,int_stack+2164552,int_stack+2160142,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2170348,int_stack+2166820,int_stack+2161906,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2116438,int_stack+837967,int_stack+837022,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2174758,int_stack+2116438,int_stack+2164552,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2179294,int_stack+2174758,int_stack+2166820,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2185174,int_stack+2179294,int_stack+2170348,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2191789,int_stack+839122,int_stack+837967,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2195254,int_stack+2191789,int_stack+2116438,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2200924,int_stack+2195254,int_stack+2174758,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2191789,int_stack+2200924,int_stack+2179294,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2200609,int_stack+2191789,int_stack+2185174,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2209870,int_stack+2200609,int_stack+2152204, 0.0, zero_stack, 1.0, int_stack+1055840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2191789,int_stack+599782,int_stack+598606,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2193553,int_stack+601350,int_stack+599782,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2195905,int_stack+2193553,int_stack+2191789,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2229715,int_stack+603366,int_stack+601350,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2232739,int_stack+2229715,int_stack+2193553,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2237443,int_stack+2232739,int_stack+2195905,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2243323,int_stack+605886,int_stack+603366,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2247103,int_stack+2243323,int_stack+2229715,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2253151,int_stack+2247103,int_stack+2232739,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2260991,int_stack+2253151,int_stack+2237443,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2269811,int_stack+14476,int_stack+605886,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2274431,int_stack+2269811,int_stack+2243323,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2281991,int_stack+2274431,int_stack+2247103,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2269811,int_stack+2281991,int_stack+2253151,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2281571,int_stack+2269811,int_stack+2260991,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2293919,int_stack+2281571,int_stack+2200609, 0.0, zero_stack, 1.0, int_stack+1062455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2269811,int_stack+856887,int_stack+856572,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2270756,int_stack+857307,int_stack+856887,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2272016,int_stack+2270756,int_stack+2269811,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2273906,int_stack+857847,int_stack+857307,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2275526,int_stack+2273906,int_stack+2270756,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2278046,int_stack+2275526,int_stack+2272016,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2281196,int_stack+858522,int_stack+857847,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2283221,int_stack+2281196,int_stack+2273906,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2286461,int_stack+2283221,int_stack+2275526,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+11466,int_stack+2286461,int_stack+2278046,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2290661,int_stack+859347,int_stack+858522,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2321702,int_stack+2290661,int_stack+2281196,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2325752,int_stack+2321702,int_stack+2283221,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2331152,int_stack+2325752,int_stack+2286461,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2321702,int_stack+2331152,int_stack+11466,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2328317,int_stack+864543,int_stack+864102,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2329640,int_stack+865131,int_stack+864543,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2331404,int_stack+2329640,int_stack+2328317,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2334050,int_stack+865887,int_stack+865131,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2336318,int_stack+2334050,int_stack+2329640,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2339846,int_stack+2336318,int_stack+2331404,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2290661,int_stack+866832,int_stack+865887,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2344256,int_stack+2290661,int_stack+2334050,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2348792,int_stack+2344256,int_stack+2336318,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2354672,int_stack+2348792,int_stack+2339846,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2361287,int_stack+867987,int_stack+866832,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2364752,int_stack+2361287,int_stack+2290661,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2370422,int_stack+2364752,int_stack+2344256,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2361287,int_stack+2370422,int_stack+2348792,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2370107,int_stack+2361287,int_stack+2354672,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2379368,int_stack+2370107,int_stack+2321702, 1.0, int_stack+1055840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2361287,int_stack+791575,int_stack+790399,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2363051,int_stack+793143,int_stack+791575,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2365403,int_stack+2363051,int_stack+2361287,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1053740,int_stack+795159,int_stack+793143,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1056764,int_stack+1053740,int_stack+2363051,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2399213,int_stack+1056764,int_stack+2365403,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2405093,int_stack+797679,int_stack+795159,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2408873,int_stack+2405093,int_stack+1053740,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2414921,int_stack+2408873,int_stack+1056764,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2422761,int_stack+2414921,int_stack+2399213,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2431581,int_stack+17710,int_stack+797679,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2436201,int_stack+2431581,int_stack+2405093,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2443761,int_stack+2436201,int_stack+2408873,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2431581,int_stack+2443761,int_stack+2414921,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2443341,int_stack+2431581,int_stack+2422761,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2455689,int_stack+2443341,int_stack+2370107, 1.0, int_stack+1062455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2431581,int_stack+19873,int_stack+19558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+642942,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2432526,int_stack+20293,int_stack+19873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+643257,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2433786,int_stack+2432526,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+907247,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2435676,int_stack+20833,int_stack+20293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+643677,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2437296,int_stack+2435676,int_stack+2432526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+908192,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2439816,int_stack+2437296,int_stack+2433786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+909452,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2431581,int_stack+21508,int_stack+20833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+644217,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2442966,int_stack+2431581,int_stack+2435676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+911342,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2446206,int_stack+2442966,int_stack+2437296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+912962,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2433606,int_stack+2446206,int_stack+2439816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+915482,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2438331,int_stack+22333,int_stack+21508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+644892,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2450406,int_stack+2438331,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+918632,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+2450406,int_stack+2442966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+920657,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2438331,int_stack+1061468,int_stack+2446206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+923897,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1061468,int_stack+2438331,int_stack+2433606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+928097,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1068083,int_stack+23764,int_stack+23323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+650472,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1069406,int_stack+24352,int_stack+23764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+650913,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2431581,int_stack+1069406,int_stack+1068083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+975809,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2434227,int_stack+25108,int_stack+24352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+651501,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2436495,int_stack+2434227,int_stack+1069406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+977132,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2440023,int_stack+2436495,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+978896,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1068083,int_stack+26053,int_stack+25108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+652257,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2444433,int_stack+1068083,int_stack+2434227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+981542,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2448969,int_stack+2444433,int_stack+2436495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+983810,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2431581,int_stack+2448969,int_stack+2440023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+987338,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2438196,int_stack+27208,int_stack+26053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+653202,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+16191,int_stack+2438196,int_stack+1068083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+991748,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2483472,int_stack+16191,int_stack+2444433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+994583,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+16191,int_stack+2483472,int_stack+2448969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+999119,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2438196,int_stack+16191,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1004999,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2483472,int_stack+2438196,int_stack+1061468,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1061468,int_stack+29182,int_stack+28594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269554,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1063232,int_stack+29966,int_stack+29182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+270730,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065584,int_stack+1063232,int_stack+1061468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1089636,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2431581,int_stack+30974,int_stack+29966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+272298,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16191,int_stack+2431581,int_stack+1063232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1091400,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20895,int_stack+16191,int_stack+1065584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1093752,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1061468,int_stack+32234,int_stack+30974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+274314,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1065248,int_stack+1061468,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1097280,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2447457,int_stack+1065248,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1100304,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2503317,int_stack+2447457,int_stack+20895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1105008,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+33774,int_stack+32234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+276834,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+20811,int_stack+16191,int_stack+1061468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1110888,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2512137,int_stack+20811,int_stack+1065248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1114668,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+16191,int_stack+2512137,int_stack+2447457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1120716,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2512137,int_stack+16191,int_stack+2503317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1128556,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2524485,int_stack+2512137,int_stack+2438196,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2503317,int_stack+35937,int_stack+35622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642942, 1.0, int_stack+668042,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2504262,int_stack+36357,int_stack+35937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643257, 1.0, int_stack+668357,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2505522,int_stack+2504262,int_stack+2503317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+907247, 1.0, int_stack+1137376,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2507412,int_stack+36897,int_stack+36357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643677, 1.0, int_stack+668777,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2509032,int_stack+2507412,int_stack+2504262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+908192, 1.0, int_stack+1138321,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2511552,int_stack+2509032,int_stack+2505522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909452, 1.0, int_stack+1139581,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2503317,int_stack+37572,int_stack+36897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644217, 1.0, int_stack+669317,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2514702,int_stack+2503317,int_stack+2507412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+911342, 1.0, int_stack+1141471,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2517942,int_stack+2514702,int_stack+2509032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912962, 1.0, int_stack+1143091,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2505342,int_stack+2517942,int_stack+2511552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915482, 1.0, int_stack+1145611,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2510067,int_stack+38397,int_stack+37572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644892, 1.0, int_stack+669992,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+16191,int_stack+2510067,int_stack+2503317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918632, 1.0, int_stack+1148761,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+20241,int_stack+16191,int_stack+2514702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+920657, 1.0, int_stack+1150786,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2510067,int_stack+20241,int_stack+2517942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923897, 1.0, int_stack+1154026,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2510067,int_stack+2505342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928097, 1.0, int_stack+1189267,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22806,int_stack+39828,int_stack+39387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650472, 1.0, int_stack+675572,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+24129,int_stack+40416,int_stack+39828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650913, 1.0, int_stack+676013,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25893,int_stack+24129,int_stack+22806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+975809, 1.0, int_stack+1200607,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+28539,int_stack+41172,int_stack+40416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651501, 1.0, int_stack+676601,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+30807,int_stack+28539,int_stack+24129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+977132, 1.0, int_stack+1201930,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+34335,int_stack+30807,int_stack+25893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+978896, 1.0, int_stack+1203694,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+22806,int_stack+42117,int_stack+41172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652257, 1.0, int_stack+677357,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2503317,int_stack+22806,int_stack+28539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+981542, 1.0, int_stack+1206340,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2507853,int_stack+2503317,int_stack+30807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+983810, 1.0, int_stack+1208608,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25641,int_stack+2507853,int_stack+34335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987338, 1.0, int_stack+1212136,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+32256,int_stack+43272,int_stack+42117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653202, 1.0, int_stack+678302,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+35721,int_stack+32256,int_stack+22806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+991748, 1.0, int_stack+1158226,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2513733,int_stack+35721,int_stack+2503317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+994583, 1.0, int_stack+1216546,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+32256,int_stack+2513733,int_stack+2507853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+999119, 1.0, int_stack+1221082,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2503317,int_stack+32256,int_stack+25641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004999, 1.0, int_stack+1226962,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+22806,int_stack+2503317,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+45246,int_stack+44658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269554, 1.0, int_stack+290798,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+46030,int_stack+45246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270730, 1.0, int_stack+291974,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2512578,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1089636, 1.0, int_stack+1233577,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2516106,int_stack+47038,int_stack+46030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272298, 1.0, int_stack+293542,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2519130,int_stack+2516106,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091400, 1.0, int_stack+1235341,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2519130,int_stack+2512578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1093752, 1.0, int_stack+1237693,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+42651,int_stack+48298,int_stack+47038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274314, 1.0, int_stack+295558,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1061468,int_stack+42651,int_stack+2516106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1097280, 1.0, int_stack+1271503,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2431581,int_stack+1061468,int_stack+2519130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100304, 1.0, int_stack+1274527,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2512578,int_stack+2431581,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1105008, 1.0, int_stack+1279231,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+49838,int_stack+48298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276834, 1.0, int_stack+298078,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2439421,int_stack+16191,int_stack+42651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110888, 1.0, int_stack+1285111,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+2439421,int_stack+1061468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1114668, 1.0, int_stack+1288891,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2439421,int_stack+2552268,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1120716, 1.0, int_stack+1294939,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2439421,int_stack+2512578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128556, 1.0, int_stack+1302779,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2564616,int_stack+2552268,int_stack+2503317,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2503317,int_stack+52001,int_stack+51686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+668042, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2504262,int_stack+52421,int_stack+52001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+668357, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2505522,int_stack+2504262,int_stack+2503317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1137376, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2507412,int_stack+52961,int_stack+52421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+668777, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2509032,int_stack+2507412,int_stack+2504262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1138321, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2511552,int_stack+2509032,int_stack+2505522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1139581, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2503317,int_stack+53636,int_stack+52961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+669317, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2514702,int_stack+2503317,int_stack+2507412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1141471, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2517942,int_stack+2514702,int_stack+2509032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1143091, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2505342,int_stack+2517942,int_stack+2511552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1145611, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2510067,int_stack+54461,int_stack+53636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+669992, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+2510067,int_stack+2503317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1148761, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2556318,int_stack+2552268,int_stack+2514702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1150786, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2510067,int_stack+2556318,int_stack+2517942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1154026, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2510067,int_stack+2505342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1189267, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+55892,int_stack+55451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+675572, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2553591,int_stack+56480,int_stack+55892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+676013, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2555355,int_stack+2553591,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1200607, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2558001,int_stack+57236,int_stack+56480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+676601, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2560269,int_stack+2558001,int_stack+2553591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1201930, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2503317,int_stack+2560269,int_stack+2555355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1203694, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+58181,int_stack+57236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+677357, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2507727,int_stack+2552268,int_stack+2558001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1206340, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2512263,int_stack+2507727,int_stack+2560269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1208608, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2555103,int_stack+2512263,int_stack+2503317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1212136, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2503317,int_stack+59336,int_stack+58181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+678302, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2518143,int_stack+2503317,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1158226, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2431581,int_stack+2518143,int_stack+2507727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1216546, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2503317,int_stack+2431581,int_stack+2512263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1221082, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2431581,int_stack+2503317,int_stack+2555103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1226962, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2503317,int_stack+2431581,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+61310,int_stack+60722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+290798, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+62094,int_stack+61310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+291974, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2440842,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1233577, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2444370,int_stack+63102,int_stack+62094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+293542, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2447394,int_stack+2444370,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1235341, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2447394,int_stack+2440842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1237693, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+64362,int_stack+63102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+295558, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556048,int_stack+2552268,int_stack+2444370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1271503, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1061468,int_stack+2556048,int_stack+2447394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1274527, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2440842,int_stack+1061468,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1279231, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+65902,int_stack+64362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+298078, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+42651,int_stack+16191,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1285111, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+50211,int_stack+42651,int_stack+2556048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1288891, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+50211,int_stack+1061468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1294939, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+42651,int_stack+2552268,int_stack+2440842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1302779, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2592399,int_stack+42651,int_stack+2431581,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2431581,int_stack+68065,int_stack+67750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642942, 0.0, zero_stack, 1.0, int_stack+693142,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2432526,int_stack+68485,int_stack+68065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643257, 0.0, zero_stack, 1.0, int_stack+693457,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2433786,int_stack+2432526,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+907247, 0.0, zero_stack, 1.0, int_stack+1311599,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2435676,int_stack+69025,int_stack+68485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643677, 0.0, zero_stack, 1.0, int_stack+693877,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2437296,int_stack+2435676,int_stack+2432526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+908192, 0.0, zero_stack, 1.0, int_stack+1312544,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2439816,int_stack+2437296,int_stack+2433786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909452, 0.0, zero_stack, 1.0, int_stack+1313804,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2431581,int_stack+69700,int_stack+69025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644217, 0.0, zero_stack, 1.0, int_stack+694417,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2442966,int_stack+2431581,int_stack+2435676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+911342, 0.0, zero_stack, 1.0, int_stack+1315694,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2446206,int_stack+2442966,int_stack+2437296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912962, 0.0, zero_stack, 1.0, int_stack+1317314,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2433606,int_stack+2446206,int_stack+2439816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915482, 0.0, zero_stack, 1.0, int_stack+1319834,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2438331,int_stack+70525,int_stack+69700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644892, 0.0, zero_stack, 1.0, int_stack+695092,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2450406,int_stack+2438331,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918632, 0.0, zero_stack, 1.0, int_stack+1322984,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+42651,int_stack+2450406,int_stack+2442966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+920657, 0.0, zero_stack, 1.0, int_stack+1325009,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2438331,int_stack+42651,int_stack+2446206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923897, 0.0, zero_stack, 1.0, int_stack+1328249,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2438331,int_stack+2433606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928097, 0.0, zero_stack, 1.0, int_stack+1363490,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+71956,int_stack+71515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650472, 0.0, zero_stack, 1.0, int_stack+700672,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42651,int_stack+72544,int_stack+71956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650913, 0.0, zero_stack, 1.0, int_stack+701113,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+44415,int_stack+42651,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+975809, 0.0, zero_stack, 1.0, int_stack+1374830,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+47061,int_stack+73300,int_stack+72544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651501, 0.0, zero_stack, 1.0, int_stack+701701,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+49329,int_stack+47061,int_stack+42651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+977132, 0.0, zero_stack, 1.0, int_stack+1376153,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+52857,int_stack+49329,int_stack+44415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+978896, 0.0, zero_stack, 1.0, int_stack+1377917,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+42651,int_stack+74245,int_stack+73300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652257, 0.0, zero_stack, 1.0, int_stack+702457,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+57267,int_stack+42651,int_stack+47061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+981542, 0.0, zero_stack, 1.0, int_stack+1380563,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61803,int_stack+57267,int_stack+49329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+983810, 0.0, zero_stack, 1.0, int_stack+0,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+45486,int_stack+61803,int_stack+52857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987338, 0.0, zero_stack, 1.0, int_stack+1382831,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+52101,int_stack+75400,int_stack+74245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653202, 0.0, zero_stack, 1.0, int_stack+703402,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+67683,int_stack+52101,int_stack+42651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+991748, 0.0, zero_stack, 1.0, int_stack+1332449,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2431581,int_stack+67683,int_stack+57267, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+994583, 0.0, zero_stack, 1.0, int_stack+1387241,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+67683,int_stack+2431581,int_stack+61803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+999119, 0.0, zero_stack, 1.0, int_stack+1391777,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2431581,int_stack+67683,int_stack+45486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004999, 0.0, zero_stack, 1.0, int_stack+1397657,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+42651,int_stack+2431581,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+77374,int_stack+76786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269554, 0.0, zero_stack, 1.0, int_stack+312042,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+78158,int_stack+77374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270730, 0.0, zero_stack, 1.0, int_stack+313218,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2440842,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1089636, 0.0, zero_stack, 1.0, int_stack+1404272,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2444370,int_stack+79166,int_stack+78158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272298, 0.0, zero_stack, 1.0, int_stack+314786,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2447394,int_stack+2444370,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091400, 0.0, zero_stack, 1.0, int_stack+1406036,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2447394,int_stack+2440842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1093752, 0.0, zero_stack, 1.0, int_stack+1408388,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+62496,int_stack+80426,int_stack+79166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274314, 0.0, zero_stack, 1.0, int_stack+316802,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+66276,int_stack+62496,int_stack+2444370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1097280, 0.0, zero_stack, 1.0, int_stack+1442198,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+72324,int_stack+66276,int_stack+2447394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100304, 0.0, zero_stack, 1.0, int_stack+1445222,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2440842,int_stack+72324,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1105008, 0.0, zero_stack, 1.0, int_stack+1449926,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+81966,int_stack+80426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276834, 0.0, zero_stack, 1.0, int_stack+319322,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+16191,int_stack+62496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110888, 0.0, zero_stack, 1.0, int_stack+1455806,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+2552268,int_stack+66276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1114668, 0.0, zero_stack, 1.0, int_stack+1459586,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1061468,int_stack+72324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1120716, 0.0, zero_stack, 1.0, int_stack+1465634,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+62496,int_stack+2552268,int_stack+2440842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128556, 0.0, zero_stack, 1.0, int_stack+1473474,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2620182,int_stack+62496,int_stack+2431581,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2431581,int_stack+84129,int_stack+83814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668042, 1.0, int_stack+693142, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2432526,int_stack+84549,int_stack+84129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668357, 1.0, int_stack+693457, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2433786,int_stack+2432526,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1137376, 1.0, int_stack+1311599, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2435676,int_stack+85089,int_stack+84549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668777, 1.0, int_stack+693877, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2437296,int_stack+2435676,int_stack+2432526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1138321, 1.0, int_stack+1312544, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2439816,int_stack+2437296,int_stack+2433786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1139581, 1.0, int_stack+1313804, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2431581,int_stack+85764,int_stack+85089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669317, 1.0, int_stack+694417, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2442966,int_stack+2431581,int_stack+2435676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1141471, 1.0, int_stack+1315694, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2446206,int_stack+2442966,int_stack+2437296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1143091, 1.0, int_stack+1317314, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2433606,int_stack+2446206,int_stack+2439816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1145611, 1.0, int_stack+1319834, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2438331,int_stack+86589,int_stack+85764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669992, 1.0, int_stack+695092, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2450406,int_stack+2438331,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1148761, 1.0, int_stack+1322984, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+62496,int_stack+2450406,int_stack+2442966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1150786, 1.0, int_stack+1325009, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2438331,int_stack+62496,int_stack+2446206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1154026, 1.0, int_stack+1328249, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2438331,int_stack+2433606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1189267, 1.0, int_stack+1363490, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+88020,int_stack+87579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675572, 1.0, int_stack+700672, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+62496,int_stack+88608,int_stack+88020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676013, 1.0, int_stack+701113, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+64260,int_stack+62496,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1200607, 1.0, int_stack+1374830, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+66906,int_stack+89364,int_stack+88608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676601, 1.0, int_stack+701701, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+69174,int_stack+66906,int_stack+62496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1201930, 1.0, int_stack+1376153, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+72702,int_stack+69174,int_stack+64260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1203694, 1.0, int_stack+1377917, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+62496,int_stack+90309,int_stack+89364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677357, 1.0, int_stack+702457, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+77112,int_stack+62496,int_stack+66906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1206340, 1.0, int_stack+1380563, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+81648,int_stack+77112,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1208608, 1.0, int_stack+0, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+65331,int_stack+81648,int_stack+72702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1212136, 1.0, int_stack+1382831, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+71946,int_stack+91464,int_stack+90309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678302, 1.0, int_stack+703402, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2431581,int_stack+71946,int_stack+62496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1158226, 1.0, int_stack+1332449, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2437251,int_stack+2431581,int_stack+77112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1216546, 1.0, int_stack+1387241, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+71946,int_stack+2437251,int_stack+81648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1221082, 1.0, int_stack+1391777, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2431581,int_stack+71946,int_stack+65331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1226962, 1.0, int_stack+1397657, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+62496,int_stack+2431581,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+93438,int_stack+92850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290798, 1.0, int_stack+312042, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+94222,int_stack+93438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291974, 1.0, int_stack+313218, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2440842,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1233577, 1.0, int_stack+1404272, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2444370,int_stack+95230,int_stack+94222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293542, 1.0, int_stack+314786, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2447394,int_stack+2444370,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1235341, 1.0, int_stack+1406036, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2447394,int_stack+2440842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1237693, 1.0, int_stack+1408388, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82341,int_stack+96490,int_stack+95230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295558, 1.0, int_stack+316802, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+86121,int_stack+82341,int_stack+2444370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1271503, 1.0, int_stack+1442198, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2552268,int_stack+86121,int_stack+2447394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1274527, 1.0, int_stack+1445222, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2440842,int_stack+2552268,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279231, 1.0, int_stack+1449926, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+98030,int_stack+96490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298078, 1.0, int_stack+319322, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+92169,int_stack+16191,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1285111, 1.0, int_stack+1455806, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+92169,int_stack+86121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1288891, 1.0, int_stack+1459586, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+82341,int_stack+1061468,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1294939, 1.0, int_stack+1465634, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+82341,int_stack+2440842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1302779, 1.0, int_stack+1473474, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2647965,int_stack+2552268,int_stack+2431581,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2431581,int_stack+100193,int_stack+99878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+693142, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2432526,int_stack+100613,int_stack+100193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+693457, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2433786,int_stack+2432526,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1311599, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2435676,int_stack+101153,int_stack+100613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+693877, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2437296,int_stack+2435676,int_stack+2432526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1312544, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2439816,int_stack+2437296,int_stack+2433786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1313804, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2431581,int_stack+101828,int_stack+101153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+694417, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2442966,int_stack+2431581,int_stack+2435676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1315694, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2446206,int_stack+2442966,int_stack+2437296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1317314, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2433606,int_stack+2446206,int_stack+2439816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1319834, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2438331,int_stack+102653,int_stack+101828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+695092, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2450406,int_stack+2438331,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1322984, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+2450406,int_stack+2442966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1325009, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2438331,int_stack+2552268,int_stack+2446206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1328249, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2438331,int_stack+2433606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1363490, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+104084,int_stack+103643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+700672, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2552268,int_stack+104672,int_stack+104084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+701113, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554032,int_stack+2552268,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556678,int_stack+105428,int_stack+104672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+701701, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2558946,int_stack+2556678,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1376153, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2431581,int_stack+2558946,int_stack+2554032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1377917, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+106373,int_stack+105428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+702457, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2435991,int_stack+2552268,int_stack+2556678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1380563, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2440527,int_stack+2435991,int_stack+2558946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2555103,int_stack+2440527,int_stack+2431581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1382831, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2431581,int_stack+107528,int_stack+106373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+703402, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2446407,int_stack+2431581,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1332449, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+82341,int_stack+2446407,int_stack+2435991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1387241, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2446407,int_stack+82341,int_stack+2440527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1391777, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+82341,int_stack+2446407,int_stack+2555103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1397657, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2431581,int_stack+82341,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+109502,int_stack+108914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+312042, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+110286,int_stack+109502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+313218, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+91602,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1404272, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+95130,int_stack+111294,int_stack+110286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+314786, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+98154,int_stack+95130,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1406036, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+98154,int_stack+91602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1408388, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102858,int_stack+112554,int_stack+111294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+316802, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+102858,int_stack+95130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1442198, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1061468,int_stack+2552268,int_stack+98154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1445222, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+91602,int_stack+1061468,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1449926, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+114094,int_stack+112554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+319322, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+106638,int_stack+16191,int_stack+102858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1455806, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2675748,int_stack+106638,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1459586, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2675748,int_stack+1061468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1465634, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+100422,int_stack+2552268,int_stack+91602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1473474, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2675748,int_stack+100422,int_stack+82341,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82341,int_stack+116257,int_stack+115942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718242,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83286,int_stack+116677,int_stack+116257, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643257, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718557,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+84546,int_stack+83286,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+907247, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482294,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86436,int_stack+117217,int_stack+116677, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643677, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718977,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88056,int_stack+86436,int_stack+83286, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+908192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1483239,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+90576,int_stack+88056,int_stack+84546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909452, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1484499,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82341,int_stack+117892,int_stack+117217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719517,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+93726,int_stack+82341,int_stack+86436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+911342, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1486389,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+96966,int_stack+93726,int_stack+88056, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1488009,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+84366,int_stack+96966,int_stack+90576, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+915482, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1490529,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+89091,int_stack+118717,int_stack+117892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+644892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720192,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+101166,int_stack+89091,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1493679,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+105216,int_stack+101166,int_stack+93726, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+920657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495704,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+89091,int_stack+105216,int_stack+96966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923897, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1498944,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+89091,int_stack+84366, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534185,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+120148,int_stack+119707, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650472, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725772,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82341,int_stack+120736,int_stack+120148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650913, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726213,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+84105,int_stack+82341,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+975809, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1545525,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86751,int_stack+121492,int_stack+120736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+651501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726801,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+89019,int_stack+86751,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+977132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1546848,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+92547,int_stack+89019,int_stack+84105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+978896, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548612,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82341,int_stack+122437,int_stack+121492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652257, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+727557,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+96957,int_stack+82341,int_stack+86751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+981542, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1551258,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+101493,int_stack+96957,int_stack+89019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+983810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1553526,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+85176,int_stack+101493,int_stack+92547, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987338, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1557054,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+91791,int_stack+123592,int_stack+122437, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653202, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+728502,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+107373,int_stack+91791,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+991748, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503144,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+113043,int_stack+107373,int_stack+96957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+994583, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1561464,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+91791,int_stack+113043,int_stack+101493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+999119, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1566000,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+100611,int_stack+91791,int_stack+85176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004999, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1571880,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2703531,int_stack+100611,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+125566,int_stack+124978, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333286,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+126350,int_stack+125566, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334462,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82341,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1089636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1578495,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+85869,int_stack+127358,int_stack+126350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272298, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336030,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88893,int_stack+85869,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1091400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580259,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+88893,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1093752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1582611,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+93597,int_stack+128618,int_stack+127358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338046,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+109872,int_stack+93597,int_stack+85869, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1097280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1616421,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+115920,int_stack+109872,int_stack+88893, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100304, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619445,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+82341,int_stack+115920,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1105008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1624149,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+130158,int_stack+128618, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340566,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+123760,int_stack+16191,int_stack+93597, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110888, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630029,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+123760,int_stack+109872, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1114668, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1633809,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2723376,int_stack+2552268,int_stack+115920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1120716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1639857,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2723376,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1647697,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2723376,int_stack+2552268,int_stack+100611,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+132321,int_stack+132006, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668042, 0.0, zero_stack, 1.0, int_stack+718242, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2553213,int_stack+132741,int_stack+132321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668357, 0.0, zero_stack, 1.0, int_stack+718557, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554473,int_stack+2553213,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1137376, 0.0, zero_stack, 1.0, int_stack+1482294, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556363,int_stack+133281,int_stack+132741, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668777, 0.0, zero_stack, 1.0, int_stack+718977, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2557983,int_stack+2556363,int_stack+2553213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1138321, 0.0, zero_stack, 1.0, int_stack+1483239, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2560503,int_stack+2557983,int_stack+2554473, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1139581, 0.0, zero_stack, 1.0, int_stack+1484499, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+133956,int_stack+133281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669317, 0.0, zero_stack, 1.0, int_stack+719517, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+82341,int_stack+2552268,int_stack+2556363, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1141471, 0.0, zero_stack, 1.0, int_stack+1486389, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+85581,int_stack+82341,int_stack+2557983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1143091, 0.0, zero_stack, 1.0, int_stack+1488009, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2554293,int_stack+85581,int_stack+2560503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1145611, 0.0, zero_stack, 1.0, int_stack+1490529, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2559018,int_stack+134781,int_stack+133956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669992, 0.0, zero_stack, 1.0, int_stack+720192, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+89781,int_stack+2559018,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1148761, 0.0, zero_stack, 1.0, int_stack+1493679, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2559018,int_stack+89781,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1150786, 0.0, zero_stack, 1.0, int_stack+1495704, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+89781,int_stack+2559018,int_stack+85581, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1154026, 0.0, zero_stack, 1.0, int_stack+1498944, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+89781,int_stack+2554293, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1189267, 0.0, zero_stack, 1.0, int_stack+1534185, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+136212,int_stack+135771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675572, 0.0, zero_stack, 1.0, int_stack+725772, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82341,int_stack+136800,int_stack+136212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676013, 0.0, zero_stack, 1.0, int_stack+726213, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+84105,int_stack+82341,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1200607, 0.0, zero_stack, 1.0, int_stack+1545525, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86751,int_stack+137556,int_stack+136800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676601, 0.0, zero_stack, 1.0, int_stack+726801, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+89019,int_stack+86751,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1201930, 0.0, zero_stack, 1.0, int_stack+1546848, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+92547,int_stack+89019,int_stack+84105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1203694, 0.0, zero_stack, 1.0, int_stack+1548612, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82341,int_stack+138501,int_stack+137556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677357, 0.0, zero_stack, 1.0, int_stack+727557, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+96957,int_stack+82341,int_stack+86751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1206340, 0.0, zero_stack, 1.0, int_stack+1551258, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+101493,int_stack+96957,int_stack+89019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1208608, 0.0, zero_stack, 1.0, int_stack+1553526, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+85176,int_stack+101493,int_stack+92547, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1212136, 0.0, zero_stack, 1.0, int_stack+1557054, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+91791,int_stack+139656,int_stack+138501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678302, 0.0, zero_stack, 1.0, int_stack+728502, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+107373,int_stack+91791,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1158226, 0.0, zero_stack, 1.0, int_stack+1503144, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+113043,int_stack+107373,int_stack+96957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1216546, 0.0, zero_stack, 1.0, int_stack+1561464, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+91791,int_stack+113043,int_stack+101493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1221082, 0.0, zero_stack, 1.0, int_stack+1566000, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+100611,int_stack+91791,int_stack+85176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1226962, 0.0, zero_stack, 1.0, int_stack+1571880, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+109872,int_stack+100611,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+141630,int_stack+141042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290798, 0.0, zero_stack, 1.0, int_stack+333286, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+142414,int_stack+141630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291974, 0.0, zero_stack, 1.0, int_stack+334462, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82341,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1233577, 0.0, zero_stack, 1.0, int_stack+1578495, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+85869,int_stack+143422,int_stack+142414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293542, 0.0, zero_stack, 1.0, int_stack+336030, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88893,int_stack+85869,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1235341, 0.0, zero_stack, 1.0, int_stack+1580259, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+88893,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1237693, 0.0, zero_stack, 1.0, int_stack+1582611, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+93597,int_stack+144682,int_stack+143422, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295558, 0.0, zero_stack, 1.0, int_stack+338046, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+129717,int_stack+93597,int_stack+85869, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1271503, 0.0, zero_stack, 1.0, int_stack+1616421, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+135765,int_stack+129717,int_stack+88893, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1274527, 0.0, zero_stack, 1.0, int_stack+1619445, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+82341,int_stack+135765,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279231, 0.0, zero_stack, 1.0, int_stack+1624149, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+146222,int_stack+144682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298078, 0.0, zero_stack, 1.0, int_stack+340566, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+16191,int_stack+93597, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1285111, 0.0, zero_stack, 1.0, int_stack+1630029, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+2552268,int_stack+129717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1288891, 0.0, zero_stack, 1.0, int_stack+1633809, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1061468,int_stack+135765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1294939, 0.0, zero_stack, 1.0, int_stack+1639857, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+129717,int_stack+2552268,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1302779, 0.0, zero_stack, 1.0, int_stack+1647697, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2751159,int_stack+129717,int_stack+100611,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+129717,int_stack+148385,int_stack+148070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693142, 1.0, int_stack+718242, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+130662,int_stack+148805,int_stack+148385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693457, 1.0, int_stack+718557, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+131922,int_stack+130662,int_stack+129717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311599, 1.0, int_stack+1482294, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+133812,int_stack+149345,int_stack+148805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693877, 1.0, int_stack+718977, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+135432,int_stack+133812,int_stack+130662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1312544, 1.0, int_stack+1483239, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+137952,int_stack+135432,int_stack+131922, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1313804, 1.0, int_stack+1484499, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+129717,int_stack+150020,int_stack+149345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694417, 1.0, int_stack+719517, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+141102,int_stack+129717,int_stack+133812, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1315694, 1.0, int_stack+1486389, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+144342,int_stack+141102,int_stack+135432, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317314, 1.0, int_stack+1488009, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+131742,int_stack+144342,int_stack+137952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1319834, 1.0, int_stack+1490529, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+136467,int_stack+150845,int_stack+150020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695092, 1.0, int_stack+720192, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+82341,int_stack+136467,int_stack+129717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1322984, 1.0, int_stack+1493679, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+86391,int_stack+82341,int_stack+141102, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1325009, 1.0, int_stack+1495704, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+136467,int_stack+86391,int_stack+144342, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1328249, 1.0, int_stack+1498944, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+136467,int_stack+131742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1363490, 1.0, int_stack+1534185, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+152276,int_stack+151835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700672, 1.0, int_stack+725772, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82341,int_stack+152864,int_stack+152276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701113, 1.0, int_stack+726213, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+84105,int_stack+82341,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1374830, 1.0, int_stack+1545525, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86751,int_stack+153620,int_stack+152864, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701701, 1.0, int_stack+726801, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+89019,int_stack+86751,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1376153, 1.0, int_stack+1546848, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+92547,int_stack+89019,int_stack+84105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1377917, 1.0, int_stack+1548612, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+82341,int_stack+154565,int_stack+153620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702457, 1.0, int_stack+727557, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+96957,int_stack+82341,int_stack+86751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1380563, 1.0, int_stack+1551258, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+101493,int_stack+96957,int_stack+89019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+1553526, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+85176,int_stack+101493,int_stack+92547, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1382831, 1.0, int_stack+1557054, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+91791,int_stack+155720,int_stack+154565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703402, 1.0, int_stack+728502, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+129717,int_stack+91791,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1332449, 1.0, int_stack+1503144, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+135387,int_stack+129717,int_stack+96957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1387241, 1.0, int_stack+1561464, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+91791,int_stack+135387,int_stack+101493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1391777, 1.0, int_stack+1566000, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+100611,int_stack+91791,int_stack+85176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397657, 1.0, int_stack+1571880, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+129717,int_stack+100611,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+157694,int_stack+157106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312042, 1.0, int_stack+333286, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+158478,int_stack+157694, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313218, 1.0, int_stack+334462, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+149562,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1404272, 1.0, int_stack+1578495, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153090,int_stack+159486,int_stack+158478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314786, 1.0, int_stack+336030, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+82341,int_stack+153090,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406036, 1.0, int_stack+1580259, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+82341,int_stack+149562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408388, 1.0, int_stack+1582611, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+87045,int_stack+160746,int_stack+159486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316802, 1.0, int_stack+338046, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+90825,int_stack+87045,int_stack+153090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1442198, 1.0, int_stack+1616421, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+149562,int_stack+90825,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1445222, 1.0, int_stack+1619445, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2552268,int_stack+149562,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1449926, 1.0, int_stack+1624149, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+162286,int_stack+160746, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319322, 1.0, int_stack+340566, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1061468,int_stack+16191,int_stack+87045, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455806, 1.0, int_stack+1630029, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2778942,int_stack+1061468,int_stack+90825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1459586, 1.0, int_stack+1633809, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+82341,int_stack+2778942,int_stack+149562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1465634, 1.0, int_stack+1639857, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+149562,int_stack+82341,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1473474, 1.0, int_stack+1647697, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2778942,int_stack+149562,int_stack+100611,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149562,int_stack+164449,int_stack+164134, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+718242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+150507,int_stack+164869,int_stack+164449, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+718557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151767,int_stack+150507,int_stack+149562, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1482294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153657,int_stack+165409,int_stack+164869, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+718977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+155277,int_stack+153657,int_stack+150507, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1483239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+157797,int_stack+155277,int_stack+151767, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1484499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+149562,int_stack+166084,int_stack+165409, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+719517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+160947,int_stack+149562,int_stack+153657, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1486389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2552268,int_stack+160947,int_stack+155277, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1488009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+151587,int_stack+2552268,int_stack+157797, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1490529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+156312,int_stack+166909,int_stack+166084, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+720192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2556468,int_stack+156312,int_stack+149562, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1493679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+82341,int_stack+2556468,int_stack+160947, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1495704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2556468,int_stack+82341,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1498944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2556468,int_stack+151587, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1534185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+168340,int_stack+167899, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+725772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2552268,int_stack+168928,int_stack+168340, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+726213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554032,int_stack+2552268,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1545525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556678,int_stack+169684,int_stack+168928, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+726801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2558946,int_stack+2556678,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1546848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82341,int_stack+2558946,int_stack+2554032, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1548612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+170629,int_stack+169684, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+727557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+86751,int_stack+2552268,int_stack+2556678, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1551258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+91287,int_stack+86751,int_stack+2558946, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1553526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2555103,int_stack+91287,int_stack+82341, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1557054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+82341,int_stack+171784,int_stack+170629, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+728502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+97167,int_stack+82341,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1503144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+149562,int_stack+97167,int_stack+86751, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1561464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+97167,int_stack+149562,int_stack+91287, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1566000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+149562,int_stack+97167,int_stack+2555103, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1571880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+82341,int_stack+149562,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+173758,int_stack+173170, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+333286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+174542,int_stack+173758, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+334462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+158823,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1578495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+162351,int_stack+175550,int_stack+174542, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+336030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+165375,int_stack+162351,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1580259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+165375,int_stack+158823, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1582611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+170079,int_stack+176810,int_stack+175550, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+338046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+170079,int_stack+162351, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1616421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1061468,int_stack+2552268,int_stack+165375, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1619445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+158823,int_stack+1061468,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1624149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+178350,int_stack+176810, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+340566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+102186,int_stack+16191,int_stack+170079, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1630029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+167643,int_stack+102186,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1633809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+167643,int_stack+1061468, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1639857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+167643,int_stack+2552268,int_stack+158823, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1647697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2806725,int_stack+167643,int_stack+149562,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149562,int_stack+180513,int_stack+180198, 0.0, zero_stack, 1.0, int_stack+642942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743342,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+150507,int_stack+180933,int_stack+180513, 0.0, zero_stack, 1.0, int_stack+643257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743657,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151767,int_stack+150507,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+907247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1656517,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153657,int_stack+181473,int_stack+180933, 0.0, zero_stack, 1.0, int_stack+643677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744077,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+155277,int_stack+153657,int_stack+150507, 0.0, zero_stack, 1.0, int_stack+908192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1657462,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+157797,int_stack+155277,int_stack+151767, 0.0, zero_stack, 1.0, int_stack+909452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1658722,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+149562,int_stack+182148,int_stack+181473, 0.0, zero_stack, 1.0, int_stack+644217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744617,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+160947,int_stack+149562,int_stack+153657, 0.0, zero_stack, 1.0, int_stack+911342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1660612,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+164187,int_stack+160947,int_stack+155277, 0.0, zero_stack, 1.0, int_stack+912962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1662232,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+151587,int_stack+164187,int_stack+157797, 0.0, zero_stack, 1.0, int_stack+915482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1664752,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+156312,int_stack+182973,int_stack+182148, 0.0, zero_stack, 1.0, int_stack+644892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+745292,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+168387,int_stack+156312,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+918632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1667902,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+172437,int_stack+168387,int_stack+160947, 0.0, zero_stack, 1.0, int_stack+920657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669927,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+156312,int_stack+172437,int_stack+164187, 0.0, zero_stack, 1.0, int_stack+923897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1673167,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+156312,int_stack+151587, 0.0, zero_stack, 1.0, int_stack+928097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1708408,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+184404,int_stack+183963, 0.0, zero_stack, 1.0, int_stack+650472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750872,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+149562,int_stack+184992,int_stack+184404, 0.0, zero_stack, 1.0, int_stack+650913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751313,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151326,int_stack+149562,int_stack+2523162, 0.0, zero_stack, 1.0, int_stack+975809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1719748,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153972,int_stack+185748,int_stack+184992, 0.0, zero_stack, 1.0, int_stack+651501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751901,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156240,int_stack+153972,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+977132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1721071,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159768,int_stack+156240,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+978896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1722835,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+149562,int_stack+186693,int_stack+185748, 0.0, zero_stack, 1.0, int_stack+652257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+752657,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+164178,int_stack+149562,int_stack+153972, 0.0, zero_stack, 1.0, int_stack+981542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725481,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+168714,int_stack+164178,int_stack+156240, 0.0, zero_stack, 1.0, int_stack+983810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3528,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+152397,int_stack+168714,int_stack+159768, 0.0, zero_stack, 1.0, int_stack+987338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1727749,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+159012,int_stack+187848,int_stack+186693, 0.0, zero_stack, 1.0, int_stack+653202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753602,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+174594,int_stack+159012,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+991748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1677367,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+180264,int_stack+174594,int_stack+164178, 0.0, zero_stack, 1.0, int_stack+994583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732159,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+159012,int_stack+180264,int_stack+168714, 0.0, zero_stack, 1.0, int_stack+999119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1736695,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+167832,int_stack+159012,int_stack+152397, 0.0, zero_stack, 1.0, int_stack+1004999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1742575,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2834508,int_stack+167832,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+189822,int_stack+189234, 0.0, zero_stack, 1.0, int_stack+269554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354530,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+190606,int_stack+189822, 0.0, zero_stack, 1.0, int_stack+270730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355706,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+149562,int_stack+17955,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1089636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1749190,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153090,int_stack+191614,int_stack+190606, 0.0, zero_stack, 1.0, int_stack+272298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357274,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156114,int_stack+153090,int_stack+17955, 0.0, zero_stack, 1.0, int_stack+1091400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1750954,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+156114,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1093752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1753306,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+160818,int_stack+192874,int_stack+191614, 0.0, zero_stack, 1.0, int_stack+274314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359290,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+177093,int_stack+160818,int_stack+153090, 0.0, zero_stack, 1.0, int_stack+1097280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1787116,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+183141,int_stack+177093,int_stack+156114, 0.0, zero_stack, 1.0, int_stack+1100304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1790140,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+149562,int_stack+183141,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1105008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1794844,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+194414,int_stack+192874, 0.0, zero_stack, 1.0, int_stack+276834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361810,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+16191,int_stack+160818, 0.0, zero_stack, 1.0, int_stack+1110888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1800724,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+2552268,int_stack+177093, 0.0, zero_stack, 1.0, int_stack+1114668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1804504,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1061468,int_stack+183141, 0.0, zero_stack, 1.0, int_stack+1120716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810552,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+177093,int_stack+2552268,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1128556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1818392,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2854353,int_stack+177093,int_stack+167832,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149562,int_stack+196577,int_stack+196262, 0.0, zero_stack, 1.0, int_stack+668042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743342, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+150507,int_stack+196997,int_stack+196577, 0.0, zero_stack, 1.0, int_stack+668357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743657, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151767,int_stack+150507,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1137376, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1656517, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153657,int_stack+197537,int_stack+196997, 0.0, zero_stack, 1.0, int_stack+668777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744077, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+155277,int_stack+153657,int_stack+150507, 0.0, zero_stack, 1.0, int_stack+1138321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1657462, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+157797,int_stack+155277,int_stack+151767, 0.0, zero_stack, 1.0, int_stack+1139581, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1658722, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+149562,int_stack+198212,int_stack+197537, 0.0, zero_stack, 1.0, int_stack+669317, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744617, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+160947,int_stack+149562,int_stack+153657, 0.0, zero_stack, 1.0, int_stack+1141471, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1660612, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+164187,int_stack+160947,int_stack+155277, 0.0, zero_stack, 1.0, int_stack+1143091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1662232, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+151587,int_stack+164187,int_stack+157797, 0.0, zero_stack, 1.0, int_stack+1145611, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1664752, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+156312,int_stack+199037,int_stack+198212, 0.0, zero_stack, 1.0, int_stack+669992, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+745292, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+168387,int_stack+156312,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1148761, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1667902, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+172437,int_stack+168387,int_stack+160947, 0.0, zero_stack, 1.0, int_stack+1150786, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669927, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+156312,int_stack+172437,int_stack+164187, 0.0, zero_stack, 1.0, int_stack+1154026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1673167, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+156312,int_stack+151587, 0.0, zero_stack, 1.0, int_stack+1189267, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1708408, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+200468,int_stack+200027, 0.0, zero_stack, 1.0, int_stack+675572, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750872, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+149562,int_stack+201056,int_stack+200468, 0.0, zero_stack, 1.0, int_stack+676013, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751313, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151326,int_stack+149562,int_stack+2523162, 0.0, zero_stack, 1.0, int_stack+1200607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1719748, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153972,int_stack+201812,int_stack+201056, 0.0, zero_stack, 1.0, int_stack+676601, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751901, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156240,int_stack+153972,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1201930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1721071, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159768,int_stack+156240,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1203694, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1722835, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+149562,int_stack+202757,int_stack+201812, 0.0, zero_stack, 1.0, int_stack+677357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+752657, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+164178,int_stack+149562,int_stack+153972, 0.0, zero_stack, 1.0, int_stack+1206340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725481, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+168714,int_stack+164178,int_stack+156240, 0.0, zero_stack, 1.0, int_stack+1208608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3528, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+152397,int_stack+168714,int_stack+159768, 0.0, zero_stack, 1.0, int_stack+1212136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1727749, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+159012,int_stack+203912,int_stack+202757, 0.0, zero_stack, 1.0, int_stack+678302, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753602, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+174594,int_stack+159012,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1158226, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1677367, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+180264,int_stack+174594,int_stack+164178, 0.0, zero_stack, 1.0, int_stack+1216546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732159, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+159012,int_stack+180264,int_stack+168714, 0.0, zero_stack, 1.0, int_stack+1221082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1736695, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+167832,int_stack+159012,int_stack+152397, 0.0, zero_stack, 1.0, int_stack+1226962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1742575, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+177093,int_stack+167832,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+205886,int_stack+205298, 0.0, zero_stack, 1.0, int_stack+290798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354530, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+206670,int_stack+205886, 0.0, zero_stack, 1.0, int_stack+291974, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355706, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+149562,int_stack+17955,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1233577, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1749190, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153090,int_stack+207678,int_stack+206670, 0.0, zero_stack, 1.0, int_stack+293542, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357274, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156114,int_stack+153090,int_stack+17955, 0.0, zero_stack, 1.0, int_stack+1235341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1750954, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+156114,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1237693, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1753306, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+160818,int_stack+208938,int_stack+207678, 0.0, zero_stack, 1.0, int_stack+295558, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359290, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+196938,int_stack+160818,int_stack+153090, 0.0, zero_stack, 1.0, int_stack+1271503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1787116, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2552268,int_stack+196938,int_stack+156114, 0.0, zero_stack, 1.0, int_stack+1274527, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1790140, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+149562,int_stack+2552268,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1279231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1794844, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+210478,int_stack+208938, 0.0, zero_stack, 1.0, int_stack+298078, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361810, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+202986,int_stack+16191,int_stack+160818, 0.0, zero_stack, 1.0, int_stack+1285111, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1800724, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+202986,int_stack+196938, 0.0, zero_stack, 1.0, int_stack+1288891, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1804504, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+196938,int_stack+1061468,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+1294939, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810552, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+196938,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1302779, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1818392, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2882136,int_stack+2552268,int_stack+167832,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+212641,int_stack+212326, 0.0, zero_stack, 1.0, int_stack+693142, 0.0, zero_stack, 1.0, int_stack+743342, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2553213,int_stack+213061,int_stack+212641, 0.0, zero_stack, 1.0, int_stack+693457, 0.0, zero_stack, 1.0, int_stack+743657, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554473,int_stack+2553213,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+1311599, 0.0, zero_stack, 1.0, int_stack+1656517, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556363,int_stack+213601,int_stack+213061, 0.0, zero_stack, 1.0, int_stack+693877, 0.0, zero_stack, 1.0, int_stack+744077, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2557983,int_stack+2556363,int_stack+2553213, 0.0, zero_stack, 1.0, int_stack+1312544, 0.0, zero_stack, 1.0, int_stack+1657462, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2560503,int_stack+2557983,int_stack+2554473, 0.0, zero_stack, 1.0, int_stack+1313804, 0.0, zero_stack, 1.0, int_stack+1658722, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+214276,int_stack+213601, 0.0, zero_stack, 1.0, int_stack+694417, 0.0, zero_stack, 1.0, int_stack+744617, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+149562,int_stack+2552268,int_stack+2556363, 0.0, zero_stack, 1.0, int_stack+1315694, 0.0, zero_stack, 1.0, int_stack+1660612, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+152802,int_stack+149562,int_stack+2557983, 0.0, zero_stack, 1.0, int_stack+1317314, 0.0, zero_stack, 1.0, int_stack+1662232, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2554293,int_stack+152802,int_stack+2560503, 0.0, zero_stack, 1.0, int_stack+1319834, 0.0, zero_stack, 1.0, int_stack+1664752, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2559018,int_stack+215101,int_stack+214276, 0.0, zero_stack, 1.0, int_stack+695092, 0.0, zero_stack, 1.0, int_stack+745292, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+157002,int_stack+2559018,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+1322984, 0.0, zero_stack, 1.0, int_stack+1667902, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2559018,int_stack+157002,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1325009, 0.0, zero_stack, 1.0, int_stack+1669927, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+157002,int_stack+2559018,int_stack+152802, 0.0, zero_stack, 1.0, int_stack+1328249, 0.0, zero_stack, 1.0, int_stack+1673167, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+157002,int_stack+2554293, 0.0, zero_stack, 1.0, int_stack+1363490, 0.0, zero_stack, 1.0, int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+216532,int_stack+216091, 0.0, zero_stack, 1.0, int_stack+700672, 0.0, zero_stack, 1.0, int_stack+750872, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+149562,int_stack+217120,int_stack+216532, 0.0, zero_stack, 1.0, int_stack+701113, 0.0, zero_stack, 1.0, int_stack+751313, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+151326,int_stack+149562,int_stack+2523162, 0.0, zero_stack, 1.0, int_stack+1374830, 0.0, zero_stack, 1.0, int_stack+1719748, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+153972,int_stack+217876,int_stack+217120, 0.0, zero_stack, 1.0, int_stack+701701, 0.0, zero_stack, 1.0, int_stack+751901, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+156240,int_stack+153972,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1376153, 0.0, zero_stack, 1.0, int_stack+1721071, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+159768,int_stack+156240,int_stack+151326, 0.0, zero_stack, 1.0, int_stack+1377917, 0.0, zero_stack, 1.0, int_stack+1722835, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+149562,int_stack+218821,int_stack+217876, 0.0, zero_stack, 1.0, int_stack+702457, 0.0, zero_stack, 1.0, int_stack+752657, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+164178,int_stack+149562,int_stack+153972, 0.0, zero_stack, 1.0, int_stack+1380563, 0.0, zero_stack, 1.0, int_stack+1725481, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+168714,int_stack+164178,int_stack+156240, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+3528, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+152397,int_stack+168714,int_stack+159768, 0.0, zero_stack, 1.0, int_stack+1382831, 0.0, zero_stack, 1.0, int_stack+1727749, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+159012,int_stack+219976,int_stack+218821, 0.0, zero_stack, 1.0, int_stack+703402, 0.0, zero_stack, 1.0, int_stack+753602, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+159012,int_stack+149562, 0.0, zero_stack, 1.0, int_stack+1332449, 0.0, zero_stack, 1.0, int_stack+1677367, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+196938,int_stack+2552268,int_stack+164178, 0.0, zero_stack, 1.0, int_stack+1387241, 0.0, zero_stack, 1.0, int_stack+1732159, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+196938,int_stack+168714, 0.0, zero_stack, 1.0, int_stack+1391777, 0.0, zero_stack, 1.0, int_stack+1736695, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+196938,int_stack+2552268,int_stack+152397, 0.0, zero_stack, 1.0, int_stack+1397657, 0.0, zero_stack, 1.0, int_stack+1742575, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+149562,int_stack+196938,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+221950,int_stack+221362, 0.0, zero_stack, 1.0, int_stack+312042, 0.0, zero_stack, 1.0, int_stack+354530, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+222734,int_stack+221950, 0.0, zero_stack, 1.0, int_stack+313218, 0.0, zero_stack, 1.0, int_stack+355706, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2552268,int_stack+17955,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1404272, 0.0, zero_stack, 1.0, int_stack+1749190, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2555796,int_stack+223742,int_stack+222734, 0.0, zero_stack, 1.0, int_stack+314786, 0.0, zero_stack, 1.0, int_stack+357274, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2558820,int_stack+2555796,int_stack+17955, 0.0, zero_stack, 1.0, int_stack+1406036, 0.0, zero_stack, 1.0, int_stack+1750954, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2558820,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+1408388, 0.0, zero_stack, 1.0, int_stack+1753306, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+206199,int_stack+225002,int_stack+223742, 0.0, zero_stack, 1.0, int_stack+316802, 0.0, zero_stack, 1.0, int_stack+359290, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209979,int_stack+206199,int_stack+2555796, 0.0, zero_stack, 1.0, int_stack+1442198, 0.0, zero_stack, 1.0, int_stack+1787116, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+216027,int_stack+209979,int_stack+2558820, 0.0, zero_stack, 1.0, int_stack+1445222, 0.0, zero_stack, 1.0, int_stack+1790140, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2552268,int_stack+216027,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1449926, 0.0, zero_stack, 1.0, int_stack+1794844, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+226542,int_stack+225002, 0.0, zero_stack, 1.0, int_stack+319322, 0.0, zero_stack, 1.0, int_stack+361810, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+169407,int_stack+16191,int_stack+206199, 0.0, zero_stack, 1.0, int_stack+1455806, 0.0, zero_stack, 1.0, int_stack+1800724, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+169407,int_stack+209979, 0.0, zero_stack, 1.0, int_stack+1459586, 0.0, zero_stack, 1.0, int_stack+1804504, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2909919,int_stack+1061468,int_stack+216027, 0.0, zero_stack, 1.0, int_stack+1465634, 0.0, zero_stack, 1.0, int_stack+1810552, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+206199,int_stack+2909919,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+1473474, 0.0, zero_stack, 1.0, int_stack+1818392, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2909919,int_stack+206199,int_stack+196938,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+196938,int_stack+228705,int_stack+228390, 0.0, zero_stack, 1.0, int_stack+718242, 1.0, int_stack+743342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+197883,int_stack+229125,int_stack+228705, 0.0, zero_stack, 1.0, int_stack+718557, 1.0, int_stack+743657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+199143,int_stack+197883,int_stack+196938, 0.0, zero_stack, 1.0, int_stack+1482294, 1.0, int_stack+1656517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+201033,int_stack+229665,int_stack+229125, 0.0, zero_stack, 1.0, int_stack+718977, 1.0, int_stack+744077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+202653,int_stack+201033,int_stack+197883, 0.0, zero_stack, 1.0, int_stack+1483239, 1.0, int_stack+1657462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+205173,int_stack+202653,int_stack+199143, 0.0, zero_stack, 1.0, int_stack+1484499, 1.0, int_stack+1658722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+196938,int_stack+230340,int_stack+229665, 0.0, zero_stack, 1.0, int_stack+719517, 1.0, int_stack+744617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+208323,int_stack+196938,int_stack+201033, 0.0, zero_stack, 1.0, int_stack+1486389, 1.0, int_stack+1660612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+211563,int_stack+208323,int_stack+202653, 0.0, zero_stack, 1.0, int_stack+1488009, 1.0, int_stack+1662232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+198963,int_stack+211563,int_stack+205173, 0.0, zero_stack, 1.0, int_stack+1490529, 1.0, int_stack+1664752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+203688,int_stack+231165,int_stack+230340, 0.0, zero_stack, 1.0, int_stack+720192, 1.0, int_stack+745292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+215763,int_stack+203688,int_stack+196938, 0.0, zero_stack, 1.0, int_stack+1493679, 1.0, int_stack+1667902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+219813,int_stack+215763,int_stack+208323, 0.0, zero_stack, 1.0, int_stack+1495704, 1.0, int_stack+1669927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+203688,int_stack+219813,int_stack+211563, 0.0, zero_stack, 1.0, int_stack+1498944, 1.0, int_stack+1673167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+203688,int_stack+198963, 0.0, zero_stack, 1.0, int_stack+1534185, 1.0, int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+232596,int_stack+232155, 0.0, zero_stack, 1.0, int_stack+725772, 1.0, int_stack+750872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+196938,int_stack+233184,int_stack+232596, 0.0, zero_stack, 1.0, int_stack+726213, 1.0, int_stack+751313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198702,int_stack+196938,int_stack+2523162, 0.0, zero_stack, 1.0, int_stack+1545525, 1.0, int_stack+1719748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+201348,int_stack+233940,int_stack+233184, 0.0, zero_stack, 1.0, int_stack+726801, 1.0, int_stack+751901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203616,int_stack+201348,int_stack+196938, 0.0, zero_stack, 1.0, int_stack+1546848, 1.0, int_stack+1721071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+207144,int_stack+203616,int_stack+198702, 0.0, zero_stack, 1.0, int_stack+1548612, 1.0, int_stack+1722835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+196938,int_stack+234885,int_stack+233940, 0.0, zero_stack, 1.0, int_stack+727557, 1.0, int_stack+752657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+211554,int_stack+196938,int_stack+201348, 0.0, zero_stack, 1.0, int_stack+1551258, 1.0, int_stack+1725481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+216090,int_stack+211554,int_stack+203616, 0.0, zero_stack, 1.0, int_stack+1553526, 1.0, int_stack+3528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+199773,int_stack+216090,int_stack+207144, 0.0, zero_stack, 1.0, int_stack+1557054, 1.0, int_stack+1727749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+206388,int_stack+236040,int_stack+234885, 0.0, zero_stack, 1.0, int_stack+728502, 1.0, int_stack+753602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+221970,int_stack+206388,int_stack+196938, 0.0, zero_stack, 1.0, int_stack+1503144, 1.0, int_stack+1677367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+227640,int_stack+221970,int_stack+211554, 0.0, zero_stack, 1.0, int_stack+1561464, 1.0, int_stack+1732159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+206388,int_stack+227640,int_stack+216090, 0.0, zero_stack, 1.0, int_stack+1566000, 1.0, int_stack+1736695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+215208,int_stack+206388,int_stack+199773, 0.0, zero_stack, 1.0, int_stack+1571880, 1.0, int_stack+1742575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2937702,int_stack+215208,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+238014,int_stack+237426, 0.0, zero_stack, 1.0, int_stack+333286, 1.0, int_stack+354530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+238798,int_stack+238014, 0.0, zero_stack, 1.0, int_stack+334462, 1.0, int_stack+355706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+196938,int_stack+17955,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1578495, 1.0, int_stack+1749190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+200466,int_stack+239806,int_stack+238798, 0.0, zero_stack, 1.0, int_stack+336030, 1.0, int_stack+357274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203490,int_stack+200466,int_stack+17955, 0.0, zero_stack, 1.0, int_stack+1580259, 1.0, int_stack+1750954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+203490,int_stack+196938, 0.0, zero_stack, 1.0, int_stack+1582611, 1.0, int_stack+1753306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+208194,int_stack+241066,int_stack+239806, 0.0, zero_stack, 1.0, int_stack+338046, 1.0, int_stack+359290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+224469,int_stack+208194,int_stack+200466, 0.0, zero_stack, 1.0, int_stack+1616421, 1.0, int_stack+1787116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+230517,int_stack+224469,int_stack+203490, 0.0, zero_stack, 1.0, int_stack+1619445, 1.0, int_stack+1790140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+196938,int_stack+230517,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1624149, 1.0, int_stack+1794844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+242606,int_stack+241066, 0.0, zero_stack, 1.0, int_stack+340566, 1.0, int_stack+361810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+16191,int_stack+208194, 0.0, zero_stack, 1.0, int_stack+1630029, 1.0, int_stack+1800724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+2552268,int_stack+224469, 0.0, zero_stack, 1.0, int_stack+1633809, 1.0, int_stack+1804504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1061468,int_stack+230517, 0.0, zero_stack, 1.0, int_stack+1639857, 1.0, int_stack+1810552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+224469,int_stack+2552268,int_stack+196938, 0.0, zero_stack, 1.0, int_stack+1647697, 1.0, int_stack+1818392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2957547,int_stack+224469,int_stack+215208,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+196938,int_stack+244769,int_stack+244454, 0.0, zero_stack, 2.0, int_stack+743342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+197883,int_stack+245189,int_stack+244769, 0.0, zero_stack, 2.0, int_stack+743657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+199143,int_stack+197883,int_stack+196938, 0.0, zero_stack, 2.0, int_stack+1656517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+201033,int_stack+245729,int_stack+245189, 0.0, zero_stack, 2.0, int_stack+744077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+202653,int_stack+201033,int_stack+197883, 0.0, zero_stack, 2.0, int_stack+1657462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+205173,int_stack+202653,int_stack+199143, 0.0, zero_stack, 2.0, int_stack+1658722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+196938,int_stack+246404,int_stack+245729, 0.0, zero_stack, 2.0, int_stack+744617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+208323,int_stack+196938,int_stack+201033, 0.0, zero_stack, 2.0, int_stack+1660612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+211563,int_stack+208323,int_stack+202653, 0.0, zero_stack, 2.0, int_stack+1662232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+198963,int_stack+211563,int_stack+205173, 0.0, zero_stack, 2.0, int_stack+1664752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+203688,int_stack+247229,int_stack+246404, 0.0, zero_stack, 2.0, int_stack+745292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+215763,int_stack+203688,int_stack+196938, 0.0, zero_stack, 2.0, int_stack+1667902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+219813,int_stack+215763,int_stack+208323, 0.0, zero_stack, 2.0, int_stack+1669927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+203688,int_stack+219813,int_stack+211563, 0.0, zero_stack, 2.0, int_stack+1673167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+203688,int_stack+198963, 0.0, zero_stack, 2.0, int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+248660,int_stack+248219, 0.0, zero_stack, 2.0, int_stack+750872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+196938,int_stack+249248,int_stack+248660, 0.0, zero_stack, 2.0, int_stack+751313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198702,int_stack+196938,int_stack+2523162, 0.0, zero_stack, 2.0, int_stack+1719748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+201348,int_stack+250004,int_stack+249248, 0.0, zero_stack, 2.0, int_stack+751901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203616,int_stack+201348,int_stack+196938, 0.0, zero_stack, 2.0, int_stack+1721071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+207144,int_stack+203616,int_stack+198702, 0.0, zero_stack, 2.0, int_stack+1722835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+196938,int_stack+250949,int_stack+250004, 0.0, zero_stack, 2.0, int_stack+752657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+211554,int_stack+196938,int_stack+201348, 0.0, zero_stack, 2.0, int_stack+1725481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+216090,int_stack+211554,int_stack+203616, 0.0, zero_stack, 2.0, int_stack+3528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+199773,int_stack+216090,int_stack+207144, 0.0, zero_stack, 2.0, int_stack+1727749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+206388,int_stack+252104,int_stack+250949, 0.0, zero_stack, 2.0, int_stack+753602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+221970,int_stack+206388,int_stack+196938, 0.0, zero_stack, 2.0, int_stack+1677367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+227640,int_stack+221970,int_stack+211554, 0.0, zero_stack, 2.0, int_stack+1732159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+206388,int_stack+227640,int_stack+216090, 0.0, zero_stack, 2.0, int_stack+1736695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+215208,int_stack+206388,int_stack+199773, 0.0, zero_stack, 2.0, int_stack+1742575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+224469,int_stack+215208,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+254078,int_stack+253490, 0.0, zero_stack, 2.0, int_stack+354530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+254862,int_stack+254078, 0.0, zero_stack, 2.0, int_stack+355706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+196938,int_stack+17955,int_stack+16191, 0.0, zero_stack, 2.0, int_stack+1749190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+200466,int_stack+255870,int_stack+254862, 0.0, zero_stack, 2.0, int_stack+357274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203490,int_stack+200466,int_stack+17955, 0.0, zero_stack, 2.0, int_stack+1750954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+203490,int_stack+196938, 0.0, zero_stack, 2.0, int_stack+1753306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+208194,int_stack+257130,int_stack+255870, 0.0, zero_stack, 2.0, int_stack+359290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+244314,int_stack+208194,int_stack+200466, 0.0, zero_stack, 2.0, int_stack+1787116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2552268,int_stack+244314,int_stack+203490, 0.0, zero_stack, 2.0, int_stack+1790140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+196938,int_stack+2552268,int_stack+16191, 0.0, zero_stack, 2.0, int_stack+1794844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+258670,int_stack+257130, 0.0, zero_stack, 2.0, int_stack+361810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+250362,int_stack+16191,int_stack+208194, 0.0, zero_stack, 2.0, int_stack+1800724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+250362,int_stack+244314, 0.0, zero_stack, 2.0, int_stack+1804504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+244314,int_stack+1061468,int_stack+2552268, 0.0, zero_stack, 2.0, int_stack+1810552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+244314,int_stack+196938, 0.0, zero_stack, 2.0, int_stack+1818392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2985330,int_stack+2552268,int_stack+215208,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+260833,int_stack+260518, 1.0, int_stack+642942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+768442,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2553213,int_stack+261253,int_stack+260833, 1.0, int_stack+643257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+768757,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554473,int_stack+2553213,int_stack+2552268, 1.0, int_stack+907247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827212,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556363,int_stack+261793,int_stack+261253, 1.0, int_stack+643677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769177,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2557983,int_stack+2556363,int_stack+2553213, 1.0, int_stack+908192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1828157,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2560503,int_stack+2557983,int_stack+2554473, 1.0, int_stack+909452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1829417,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+262468,int_stack+261793, 1.0, int_stack+644217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769717,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+196938,int_stack+2552268,int_stack+2556363, 1.0, int_stack+911342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1831307,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+200178,int_stack+196938,int_stack+2557983, 1.0, int_stack+912962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1832927,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2554293,int_stack+200178,int_stack+2560503, 1.0, int_stack+915482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835447,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2559018,int_stack+263293,int_stack+262468, 1.0, int_stack+644892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770392,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+204378,int_stack+2559018,int_stack+2552268, 1.0, int_stack+918632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881672,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2559018,int_stack+204378,int_stack+196938, 1.0, int_stack+920657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1838597,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+204378,int_stack+2559018,int_stack+200178, 1.0, int_stack+923897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1841837,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+204378,int_stack+2554293, 1.0, int_stack+928097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883697,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+264724,int_stack+264283, 1.0, int_stack+650472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776413,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+196938,int_stack+265312,int_stack+264724, 1.0, int_stack+650913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777442,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198702,int_stack+196938,int_stack+2523162, 1.0, int_stack+975809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1879103,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+201348,int_stack+266068,int_stack+265312, 1.0, int_stack+651501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778786,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203616,int_stack+201348,int_stack+196938, 1.0, int_stack+977132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1880426,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+207144,int_stack+203616,int_stack+198702, 1.0, int_stack+978896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1882190,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+196938,int_stack+267013,int_stack+266068, 1.0, int_stack+652257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780487,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+211554,int_stack+196938,int_stack+201348, 1.0, int_stack+981542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1884836,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+216090,int_stack+211554,int_stack+203616, 1.0, int_stack+983810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1887104,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+199773,int_stack+216090,int_stack+207144, 1.0, int_stack+987338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1846037,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+206388,int_stack+268168,int_stack+267013, 1.0, int_stack+653202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782587,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+206388,int_stack+196938, 1.0, int_stack+991748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932822,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+244314,int_stack+2552268,int_stack+211554, 1.0, int_stack+994583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+888422,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+244314,int_stack+216090, 1.0, int_stack+999119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1897418,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+244314,int_stack+2552268,int_stack+199773, 1.0, int_stack+1004999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1903298,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+196938,int_stack+244314,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+271514,int_stack+270142, 1.0, int_stack+269554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376362,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+273306,int_stack+271514, 1.0, int_stack+270730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378322,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2552268,int_stack+17955,int_stack+16191, 1.0, int_stack+1089636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945737,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2555796,int_stack+275574,int_stack+273306, 1.0, int_stack+272298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380898,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2558820,int_stack+2555796,int_stack+17955, 1.0, int_stack+1091400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+947501,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2558820,int_stack+2552268, 1.0, int_stack+1093752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+949853,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+253575,int_stack+278374,int_stack+275574, 1.0, int_stack+274314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384174,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+257355,int_stack+253575,int_stack+2555796, 1.0, int_stack+1097280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935657,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+263403,int_stack+257355,int_stack+2558820, 1.0, int_stack+1100304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1939019,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2552268,int_stack+263403,int_stack+16191, 1.0, int_stack+1105008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1943723,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+279914,int_stack+278374, 1.0, int_stack+276834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386694,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+271243,int_stack+16191,int_stack+253575, 1.0, int_stack+1110888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011614,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1061468,int_stack+271243,int_stack+257355, 1.0, int_stack+1114668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1949603,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+905369,int_stack+1061468,int_stack+263403, 1.0, int_stack+1120716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1955651,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+253575,int_stack+905369,int_stack+2552268, 1.0, int_stack+1128556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1963491,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1088996,int_stack+253575,int_stack+244314,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+244314,int_stack+282077,int_stack+281762, 1.0, int_stack+668042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+768442, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+245259,int_stack+282497,int_stack+282077, 1.0, int_stack+668357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+768757, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+246519,int_stack+245259,int_stack+244314, 1.0, int_stack+1137376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827212, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+248409,int_stack+283037,int_stack+282497, 1.0, int_stack+668777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769177, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+250029,int_stack+248409,int_stack+245259, 1.0, int_stack+1138321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1828157, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+252549,int_stack+250029,int_stack+246519, 1.0, int_stack+1139581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1829417, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+244314,int_stack+283712,int_stack+283037, 1.0, int_stack+669317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769717, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+255699,int_stack+244314,int_stack+248409, 1.0, int_stack+1141471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1831307, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+258939,int_stack+255699,int_stack+250029, 1.0, int_stack+1143091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1832927, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+246339,int_stack+258939,int_stack+252549, 1.0, int_stack+1145611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835447, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+251064,int_stack+284537,int_stack+283712, 1.0, int_stack+669992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770392, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+263139,int_stack+251064,int_stack+244314, 1.0, int_stack+1148761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881672, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+267189,int_stack+263139,int_stack+255699, 1.0, int_stack+1150786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1838597, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+251064,int_stack+267189,int_stack+258939, 1.0, int_stack+1154026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1841837, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+251064,int_stack+246339, 1.0, int_stack+1189267, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883697, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+285968,int_stack+285527, 1.0, int_stack+675572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776413, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1189267,int_stack+286556,int_stack+285968, 1.0, int_stack+676013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777442, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1191031,int_stack+1189267,int_stack+2523162, 1.0, int_stack+1200607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1879103, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+244314,int_stack+287312,int_stack+286556, 1.0, int_stack+676601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778786, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+246582,int_stack+244314,int_stack+1189267, 1.0, int_stack+1201930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1880426, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+250110,int_stack+246582,int_stack+1191031, 1.0, int_stack+1203694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1882190, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1189267,int_stack+288257,int_stack+287312, 1.0, int_stack+677357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780487, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1200607,int_stack+1189267,int_stack+244314, 1.0, int_stack+1206340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1884836, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+254520,int_stack+1200607,int_stack+246582, 1.0, int_stack+1208608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1887104, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1205143,int_stack+254520,int_stack+250110, 1.0, int_stack+1212136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1846037, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+244314,int_stack+289412,int_stack+288257, 1.0, int_stack+678302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782587, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+247779,int_stack+244314,int_stack+1189267, 1.0, int_stack+1158226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932822, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+260400,int_stack+247779,int_stack+1200607, 1.0, int_stack+1216546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+888422, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+244314,int_stack+260400,int_stack+254520, 1.0, int_stack+1221082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1897418, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+253134,int_stack+244314,int_stack+1205143, 1.0, int_stack+1226962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1903298, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1200607,int_stack+253134,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+292758,int_stack+291386, 1.0, int_stack+290798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376362, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+294550,int_stack+292758, 1.0, int_stack+291974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378322, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+244314,int_stack+17955,int_stack+16191, 1.0, int_stack+1233577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945737, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+247842,int_stack+296818,int_stack+294550, 1.0, int_stack+293542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380898, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1220452,int_stack+247842,int_stack+17955, 1.0, int_stack+1235341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+947501, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1220452,int_stack+244314, 1.0, int_stack+1237693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+949853, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1225156,int_stack+299618,int_stack+296818, 1.0, int_stack+295558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384174, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1228936,int_stack+1225156,int_stack+247842, 1.0, int_stack+1271503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935657, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+244314,int_stack+1228936,int_stack+1220452, 1.0, int_stack+1274527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1939019, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+262395,int_stack+244314,int_stack+16191, 1.0, int_stack+1279231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1943723, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+301158,int_stack+299618, 1.0, int_stack+298078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386694, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1271503,int_stack+16191,int_stack+1225156, 1.0, int_stack+1285111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011614, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+271215,int_stack+1271503,int_stack+1228936, 1.0, int_stack+1288891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1949603, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1271503,int_stack+271215,int_stack+244314, 1.0, int_stack+1294939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1955651, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+1271503,int_stack+262395, 1.0, int_stack+1302779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1963491, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+262395,int_stack+2552268,int_stack+253134,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+303321,int_stack+303006, 1.0, int_stack+693142, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+768442, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2553213,int_stack+303741,int_stack+303321, 1.0, int_stack+693457, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+768757, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554473,int_stack+2553213,int_stack+2552268, 1.0, int_stack+1311599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827212, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556363,int_stack+304281,int_stack+303741, 1.0, int_stack+693877, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769177, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2557983,int_stack+2556363,int_stack+2553213, 1.0, int_stack+1312544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1828157, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2560503,int_stack+2557983,int_stack+2554473, 1.0, int_stack+1313804, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1829417, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+304956,int_stack+304281, 1.0, int_stack+694417, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769717, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+290178,int_stack+2552268,int_stack+2556363, 1.0, int_stack+1315694, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1831307, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+293418,int_stack+290178,int_stack+2557983, 1.0, int_stack+1317314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1832927, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1189267,int_stack+293418,int_stack+2560503, 1.0, int_stack+1319834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835447, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2554293,int_stack+305781,int_stack+304956, 1.0, int_stack+695092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770392, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2556768,int_stack+2554293,int_stack+2552268, 1.0, int_stack+1322984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+297618,int_stack+2556768,int_stack+290178, 1.0, int_stack+1325009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1838597, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+297618,int_stack+293418, 1.0, int_stack+1328249, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1841837, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1189267, 1.0, int_stack+1363490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883697, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+307212,int_stack+306771, 1.0, int_stack+700672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776413, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1363490,int_stack+307800,int_stack+307212, 1.0, int_stack+701113, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777442, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1365254,int_stack+1363490,int_stack+2523162, 1.0, int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1879103, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1189267,int_stack+308556,int_stack+307800, 1.0, int_stack+701701, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+778786, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1189267,int_stack+1363490, 1.0, int_stack+1376153, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1880426, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2555796,int_stack+2552268,int_stack+1365254, 1.0, int_stack+1377917, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1882190, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1363490,int_stack+309501,int_stack+308556, 1.0, int_stack+702457, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780487, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1374830,int_stack+1363490,int_stack+1189267, 1.0, int_stack+1380563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1884836, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+290178,int_stack+1374830,int_stack+2552268, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1887104, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+296058,int_stack+290178,int_stack+2555796, 1.0, int_stack+1382831, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1846037, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+310656,int_stack+309501, 1.0, int_stack+703402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782587, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+0,int_stack+1363490, 1.0, int_stack+1332449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1379366,int_stack+2552268,int_stack+1374830, 1.0, int_stack+1387241, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+888422, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1379366,int_stack+290178, 1.0, int_stack+1391777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+296058, 1.0, int_stack+1397657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1903298, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+290178,int_stack+1374830,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+314002,int_stack+312630, 1.0, int_stack+312042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376362, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+315794,int_stack+314002, 1.0, int_stack+313218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378322, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+17955,int_stack+16191, 1.0, int_stack+1404272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2552268,int_stack+318062,int_stack+315794, 1.0, int_stack+314786, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380898, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2555292,int_stack+2552268,int_stack+17955, 1.0, int_stack+1406036, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+947501, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2555292,int_stack+0, 1.0, int_stack+1408388, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+949853, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2559996,int_stack+320862,int_stack+318062, 1.0, int_stack+316802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384174, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+310023,int_stack+2559996,int_stack+2552268, 1.0, int_stack+1442198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935657, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1384091,int_stack+310023,int_stack+2555292, 1.0, int_stack+1445222, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1939019, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1391931,int_stack+1384091,int_stack+16191, 1.0, int_stack+1449926, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1943723, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+322402,int_stack+320862, 1.0, int_stack+319322, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386694, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1442198,int_stack+16191,int_stack+2559996, 1.0, int_stack+1455806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+1442198,int_stack+310023, 1.0, int_stack+1459586, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1949603, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+310023,int_stack+2552268,int_stack+1384091, 1.0, int_stack+1465634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1955651, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+310023,int_stack+1391931, 1.0, int_stack+1473474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1963491, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1384091,int_stack+2552268,int_stack+1374830,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+324565,int_stack+324250, 1.0, int_stack+718242, 0.0, zero_stack, 1.0, int_stack+768442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+324985,int_stack+324565, 1.0, int_stack+718557, 0.0, zero_stack, 1.0, int_stack+768757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 1.0, int_stack+1482294, 0.0, zero_stack, 1.0, int_stack+1827212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+325525,int_stack+324985, 1.0, int_stack+718977, 0.0, zero_stack, 1.0, int_stack+769177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 1.0, int_stack+1483239, 0.0, zero_stack, 1.0, int_stack+1828157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1380545,int_stack+1377035, 1.0, int_stack+1484499, 0.0, zero_stack, 1.0, int_stack+1829417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+326200,int_stack+325525, 1.0, int_stack+719517, 0.0, zero_stack, 1.0, int_stack+769717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1374830,int_stack+1378925, 1.0, int_stack+1486389, 0.0, zero_stack, 1.0, int_stack+1831307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2558658,int_stack+2555418,int_stack+1380545, 1.0, int_stack+1488009, 0.0, zero_stack, 1.0, int_stack+1832927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1363490,int_stack+2558658,int_stack+2552268, 1.0, int_stack+1490529, 0.0, zero_stack, 1.0, int_stack+1835447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+327025,int_stack+326200, 1.0, int_stack+720192, 0.0, zero_stack, 1.0, int_stack+770392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+2552268,int_stack+1374830, 1.0, int_stack+1493679, 0.0, zero_stack, 1.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+310023,int_stack+1376855,int_stack+2555418, 1.0, int_stack+1495704, 0.0, zero_stack, 1.0, int_stack+1838597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+310023,int_stack+2558658, 1.0, int_stack+1498944, 0.0, zero_stack, 1.0, int_stack+1841837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1363490, 1.0, int_stack+1534185, 0.0, zero_stack, 1.0, int_stack+883697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+328456,int_stack+328015, 1.0, int_stack+725772, 0.0, zero_stack, 1.0, int_stack+776413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1534185,int_stack+329044,int_stack+328456, 1.0, int_stack+726213, 0.0, zero_stack, 1.0, int_stack+777442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1535949,int_stack+1534185,int_stack+2523162, 1.0, int_stack+1545525, 0.0, zero_stack, 1.0, int_stack+1879103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1363490,int_stack+329800,int_stack+329044, 1.0, int_stack+726801, 0.0, zero_stack, 1.0, int_stack+778786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+1363490,int_stack+1534185, 1.0, int_stack+1546848, 0.0, zero_stack, 1.0, int_stack+1880426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1374830,int_stack+0,int_stack+1535949, 1.0, int_stack+1548612, 0.0, zero_stack, 1.0, int_stack+1882190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1534185,int_stack+330745,int_stack+329800, 1.0, int_stack+727557, 0.0, zero_stack, 1.0, int_stack+780487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1545525,int_stack+1534185,int_stack+1363490, 1.0, int_stack+1551258, 0.0, zero_stack, 1.0, int_stack+1884836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+310023,int_stack+1545525,int_stack+0, 1.0, int_stack+1553526, 0.0, zero_stack, 1.0, int_stack+1887104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1550061,int_stack+310023,int_stack+1374830, 1.0, int_stack+1557054, 0.0, zero_stack, 1.0, int_stack+1846037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1374830,int_stack+331900,int_stack+330745, 1.0, int_stack+728502, 0.0, zero_stack, 1.0, int_stack+782587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1378295,int_stack+1374830,int_stack+1534185, 1.0, int_stack+1503144, 0.0, zero_stack, 1.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+315903,int_stack+1378295,int_stack+1545525, 1.0, int_stack+1561464, 0.0, zero_stack, 1.0, int_stack+888422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+315903,int_stack+310023, 1.0, int_stack+1566000, 0.0, zero_stack, 1.0, int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+310023,int_stack+1374830,int_stack+1550061, 1.0, int_stack+1571880, 0.0, zero_stack, 1.0, int_stack+1903298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1545525,int_stack+310023,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+335246,int_stack+333874, 1.0, int_stack+333286, 0.0, zero_stack, 1.0, int_stack+376362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+337038,int_stack+335246, 1.0, int_stack+334462, 0.0, zero_stack, 1.0, int_stack+378322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+17955,int_stack+16191, 1.0, int_stack+1578495, 0.0, zero_stack, 1.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+339306,int_stack+337038, 1.0, int_stack+336030, 0.0, zero_stack, 1.0, int_stack+380898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377854,int_stack+1374830,int_stack+17955, 1.0, int_stack+1580259, 0.0, zero_stack, 1.0, int_stack+947501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1377854,int_stack+0, 1.0, int_stack+1582611, 0.0, zero_stack, 1.0, int_stack+949853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+319284,int_stack+342106,int_stack+339306, 1.0, int_stack+338046, 0.0, zero_stack, 1.0, int_stack+384174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+323064,int_stack+319284,int_stack+1374830, 1.0, int_stack+1616421, 0.0, zero_stack, 1.0, int_stack+935657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+329112,int_stack+323064,int_stack+1377854, 1.0, int_stack+1619445, 0.0, zero_stack, 1.0, int_stack+1939019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1374830,int_stack+329112,int_stack+16191, 1.0, int_stack+1624149, 0.0, zero_stack, 1.0, int_stack+1943723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+343646,int_stack+342106, 1.0, int_stack+340566, 0.0, zero_stack, 1.0, int_stack+386694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1616421,int_stack+16191,int_stack+319284, 1.0, int_stack+1630029, 0.0, zero_stack, 1.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1565370,int_stack+1616421,int_stack+323064, 1.0, int_stack+1633809, 0.0, zero_stack, 1.0, int_stack+1949603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1616421,int_stack+1565370,int_stack+329112, 1.0, int_stack+1639857, 0.0, zero_stack, 1.0, int_stack+1955651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+1616421,int_stack+1374830, 1.0, int_stack+1647697, 0.0, zero_stack, 1.0, int_stack+1963491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1616421,int_stack+2552268,int_stack+310023,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+310023,int_stack+345809,int_stack+345494, 1.0, int_stack+743342, 1.0, int_stack+768442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+310968,int_stack+346229,int_stack+345809, 1.0, int_stack+743657, 1.0, int_stack+768757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+312228,int_stack+310968,int_stack+310023, 1.0, int_stack+1656517, 1.0, int_stack+1827212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314118,int_stack+346769,int_stack+346229, 1.0, int_stack+744077, 1.0, int_stack+769177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+315738,int_stack+314118,int_stack+310968, 1.0, int_stack+1657462, 1.0, int_stack+1828157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+318258,int_stack+315738,int_stack+312228, 1.0, int_stack+1658722, 1.0, int_stack+1829417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+310023,int_stack+347444,int_stack+346769, 1.0, int_stack+744617, 1.0, int_stack+769717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+321408,int_stack+310023,int_stack+314118, 1.0, int_stack+1660612, 1.0, int_stack+1831307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+324648,int_stack+321408,int_stack+315738, 1.0, int_stack+1662232, 1.0, int_stack+1832927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1534185,int_stack+324648,int_stack+318258, 1.0, int_stack+1664752, 1.0, int_stack+1835447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+312048,int_stack+348269,int_stack+347444, 1.0, int_stack+745292, 1.0, int_stack+770392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+314523,int_stack+312048,int_stack+310023, 1.0, int_stack+1667902, 1.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+328848,int_stack+314523,int_stack+321408, 1.0, int_stack+1669927, 1.0, int_stack+1838597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+310023,int_stack+328848,int_stack+324648, 1.0, int_stack+1673167, 1.0, int_stack+1841837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+310023,int_stack+1534185, 1.0, int_stack+1708408, 1.0, int_stack+883697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+349700,int_stack+349259, 1.0, int_stack+750872, 1.0, int_stack+776413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+350288,int_stack+349700, 1.0, int_stack+751313, 1.0, int_stack+777442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 1.0, int_stack+1719748, 1.0, int_stack+1879103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1534185,int_stack+351044,int_stack+350288, 1.0, int_stack+751901, 1.0, int_stack+778786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+1534185,int_stack+1708408, 1.0, int_stack+1721071, 1.0, int_stack+1880426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+310023,int_stack+0,int_stack+1710172, 1.0, int_stack+1722835, 1.0, int_stack+1882190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+351989,int_stack+351044, 1.0, int_stack+752657, 1.0, int_stack+780487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1719748,int_stack+1708408,int_stack+1534185, 1.0, int_stack+1725481, 1.0, int_stack+1884836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+314433,int_stack+1719748,int_stack+0, 1.0, int_stack+3528, 1.0, int_stack+1887104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+314433,int_stack+310023, 1.0, int_stack+1727749, 1.0, int_stack+1846037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+310023,int_stack+353144,int_stack+351989, 1.0, int_stack+753602, 1.0, int_stack+782587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1724284,int_stack+310023,int_stack+1708408, 1.0, int_stack+1677367, 1.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+320313,int_stack+1724284,int_stack+1719748, 1.0, int_stack+1732159, 1.0, int_stack+888422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1719748,int_stack+320313,int_stack+314433, 1.0, int_stack+1736695, 1.0, int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+1719748,int_stack+0, 1.0, int_stack+1742575, 1.0, int_stack+1903298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1719748,int_stack+1374830,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+356490,int_stack+355118, 1.0, int_stack+354530, 1.0, int_stack+376362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+358282,int_stack+356490, 1.0, int_stack+355706, 1.0, int_stack+378322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+17955,int_stack+16191, 1.0, int_stack+1749190, 1.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3528,int_stack+360550,int_stack+358282, 1.0, int_stack+357274, 1.0, int_stack+380898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1739593,int_stack+3528,int_stack+17955, 1.0, int_stack+1750954, 1.0, int_stack+947501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1739593,int_stack+0, 1.0, int_stack+1753306, 1.0, int_stack+949853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1744297,int_stack+363350,int_stack+360550, 1.0, int_stack+359290, 1.0, int_stack+384174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1748077,int_stack+1744297,int_stack+3528, 1.0, int_stack+1787116, 1.0, int_stack+935657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+310023,int_stack+1748077,int_stack+1739593, 1.0, int_stack+1790140, 1.0, int_stack+1939019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+317863,int_stack+310023,int_stack+16191, 1.0, int_stack+1794844, 1.0, int_stack+1943723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+364890,int_stack+363350, 1.0, int_stack+361810, 1.0, int_stack+386694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1787116,int_stack+16191,int_stack+1744297, 1.0, int_stack+1800724, 1.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+326683,int_stack+1787116,int_stack+1748077, 1.0, int_stack+1804504, 1.0, int_stack+1949603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1787116,int_stack+326683,int_stack+310023, 1.0, int_stack+1810552, 1.0, int_stack+1955651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+1787116,int_stack+317863, 1.0, int_stack+1818392, 1.0, int_stack+1963491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1787116,int_stack+2552268,int_stack+1374830,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+367053,int_stack+366738, 2.0, int_stack+768442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+367473,int_stack+367053, 2.0, int_stack+768757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 2.0, int_stack+1827212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+368013,int_stack+367473, 2.0, int_stack+769177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 2.0, int_stack+1828157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1380545,int_stack+1377035, 2.0, int_stack+1829417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+368688,int_stack+368013, 2.0, int_stack+769717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1374830,int_stack+1378925, 2.0, int_stack+1831307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2558658,int_stack+2555418,int_stack+1380545, 2.0, int_stack+1832927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+2558658,int_stack+2552268, 2.0, int_stack+1835447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+369513,int_stack+368688, 2.0, int_stack+770392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+2552268,int_stack+1374830, 2.0, int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1814899,int_stack+1376855,int_stack+2555418, 2.0, int_stack+1838597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+1814899,int_stack+2558658, 2.0, int_stack+1841837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408, 2.0, int_stack+883697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+370944,int_stack+370503, 2.0, int_stack+776413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+371532,int_stack+370944, 2.0, int_stack+777442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 2.0, int_stack+1879103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+372288,int_stack+371532, 2.0, int_stack+778786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+1708408, 2.0, int_stack+1880426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1814899,int_stack+1377098,int_stack+1710172, 2.0, int_stack+1882190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+373233,int_stack+372288, 2.0, int_stack+780487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1879103,int_stack+1708408,int_stack+1374830, 2.0, int_stack+1884836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1819309,int_stack+1879103,int_stack+1377098, 2.0, int_stack+1887104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1374830,int_stack+1819309,int_stack+1814899, 2.0, int_stack+1846037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1814899,int_stack+374388,int_stack+373233, 2.0, int_stack+782587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1883639,int_stack+1814899,int_stack+1708408, 2.0, int_stack+932822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1825189,int_stack+1883639,int_stack+1879103, 2.0, int_stack+888422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1879103,int_stack+1825189,int_stack+1819309, 2.0, int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+1879103,int_stack+1374830, 2.0, int_stack+1903298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1824160,int_stack+1814899,int_stack+16191,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+379106,int_stack+376950, 2.0, int_stack+376362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+381906,int_stack+379106, 2.0, int_stack+378322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191, 2.0, int_stack+945737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+385434,int_stack+381906, 2.0, int_stack+380898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1879103,int_stack+1378358,int_stack+17955, 2.0, int_stack+947501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1879103,int_stack+1374830, 2.0, int_stack+949853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+945737,int_stack+388234,int_stack+385434, 2.0, int_stack+384174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1883807,int_stack+945737,int_stack+1378358, 2.0, int_stack+935657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+1883807,int_stack+1879103, 2.0, int_stack+1939019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1897418,int_stack+1374830,int_stack+16191, 2.0, int_stack+1943723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+389774,int_stack+388234, 2.0, int_stack+386694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1939019,int_stack+16191,int_stack+945737, 2.0, int_stack+1011614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+881672,int_stack+1939019,int_stack+1883807, 2.0, int_stack+1949603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1939019,int_stack+881672,int_stack+1374830, 2.0, int_stack+1955651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+1939019,int_stack+1897418, 2.0, int_stack+1963491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1939019,int_stack+2552268,int_stack+1814899,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+391937,int_stack+391622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802607,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+392357,int_stack+391937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802922,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+392897,int_stack+392357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803342,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1071716,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+393572,int_stack+392897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803882,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1073606,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2558658,int_stack+2555418,int_stack+1820614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1075226,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+2558658,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1077746,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+394397,int_stack+393572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804557,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080896,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1897418,int_stack+1816924,int_stack+2555418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1082921,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+1897418,int_stack+2558658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015394,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+395828,int_stack+395387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810137,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+396416,int_stack+395828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810578,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000094,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+397172,int_stack+396416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811166,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2001417,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1897418,int_stack+1817167,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2003181,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+398117,int_stack+397172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811922,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1901828,int_stack+1708408,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899573,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2552268,int_stack+1901828,int_stack+1817167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901841,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7056,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1897418,int_stack+399272,int_stack+398117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812867,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2558148,int_stack+1897418,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1086161,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1374830,int_stack+2558148,int_stack+1901828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2005827,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1897418,int_stack+1374830,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2010363,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2016243,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+310023,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+939122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+401246,int_stack+400658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480978,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+402030,int_stack+401246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482154,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+403038,int_stack+402030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483722,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1897418,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+973226,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051964,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1902122,int_stack+404298,int_stack+403038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485738,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+1902122,int_stack+1818427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2055492,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058516,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+881672,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2063220,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+405838,int_stack+404298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488258,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+945737,int_stack+16191,int_stack+1902122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2069100,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1897418,int_stack+945737,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2072880,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078928,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1897418,int_stack+2552268,int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2086768,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+329868,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1020434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+408001,int_stack+407686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802607, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+408421,int_stack+408001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802922, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+408961,int_stack+408421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803342, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1897418,int_stack+1380545,int_stack+1377035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1071716, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+409636,int_stack+408961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803882, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1900568,int_stack+1374830,int_stack+1378925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1073606, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1903808,int_stack+1900568,int_stack+1380545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1075226, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1903808,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1077746, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1897418,int_stack+410461,int_stack+409636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804557, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080896, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+881672,int_stack+1376855,int_stack+1900568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1082921, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+881672,int_stack+1903808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015394, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+411892,int_stack+411451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810137, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+412480,int_stack+411892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810578, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000094, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+413236,int_stack+412480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811166, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2001417, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881672,int_stack+1377098,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2003181, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+414181,int_stack+413236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811922, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+886082,int_stack+1708408,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899573, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1897418,int_stack+886082,int_stack+1377098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901841, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1903298,int_stack+1897418,int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7056, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+881672,int_stack+415336,int_stack+414181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812867, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1374830,int_stack+881672,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1086161, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+1374830,int_stack+886082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2005827, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2010363, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+1374830,int_stack+1903298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2016243, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+384174,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1193992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+417310,int_stack+416722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480978, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+418094,int_stack+417310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482154, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+419102,int_stack+418094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483722, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1897418,int_stack+1378358,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+973226, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051964, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1902122,int_stack+420362,int_stack+419102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485738, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+1902122,int_stack+1378358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2055492, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058516, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+881672,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2063220, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+421902,int_stack+420362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488258, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+945737,int_stack+16191,int_stack+1902122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2069100, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1897418,int_stack+945737,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2072880, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078928, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1897418,int_stack+2552268,int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2086768, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1644204,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1242397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+424065,int_stack+423750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802607, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+424485,int_stack+424065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802922, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+425025,int_stack+424485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803342, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1897418,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1071716, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+425700,int_stack+425025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803882, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1900568,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1073606, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1903808,int_stack+1900568,int_stack+1820614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1075226, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1903808,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1077746, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1897418,int_stack+426525,int_stack+425700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804557, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080896, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+881672,int_stack+1816924,int_stack+1900568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1082921, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+881672,int_stack+1903808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015394, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+427956,int_stack+427515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810137, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+428544,int_stack+427956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810578, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000094, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+429300,int_stack+428544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811166, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2001417, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881672,int_stack+1817167,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2003181, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+430245,int_stack+429300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811922, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+886082,int_stack+1708408,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899573, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1897418,int_stack+886082,int_stack+1817167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901841, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1903298,int_stack+1897418,int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7056, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+881672,int_stack+431400,int_stack+430245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812867, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814899,int_stack+881672,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1086161, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+1814899,int_stack+886082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2005827, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2010363, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+1814899,int_stack+1903298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2016243, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+404019,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1368215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+433374,int_stack+432786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480978, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+434158,int_stack+433374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482154, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+435166,int_stack+434158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483722, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1897418,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+973226, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051964, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1902122,int_stack+436426,int_stack+435166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485738, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+1902122,int_stack+1818427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2055492, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058516, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+881672,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2063220, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+437966,int_stack+436426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488258, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+945737,int_stack+16191,int_stack+1902122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2069100, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1897418,int_stack+945737,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2072880, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078928, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1897418,int_stack+2552268,int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2086768, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1442198,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+440129,int_stack+439814, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+440549,int_stack+440129, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+441089,int_stack+440549, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1897418,int_stack+1380545,int_stack+1377035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1071716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+441764,int_stack+441089, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1900568,int_stack+1374830,int_stack+1378925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1073606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1903808,int_stack+1900568,int_stack+1380545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1075226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1903808,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1077746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1897418,int_stack+442589,int_stack+441764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+881672,int_stack+1376855,int_stack+1900568, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1082921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+881672,int_stack+1903808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+444020,int_stack+443579, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+444608,int_stack+444020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+445364,int_stack+444608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2001417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881672,int_stack+1377098,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2003181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+446309,int_stack+445364, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+886082,int_stack+1708408,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+899573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1897418,int_stack+886082,int_stack+1377098, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+901841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1903298,int_stack+1897418,int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+881672,int_stack+447464,int_stack+446309, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1374830,int_stack+881672,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1086161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+1374830,int_stack+886082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2005827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2010363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+1374830,int_stack+1903298, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2016243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+423864,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1538910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+449438,int_stack+448850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+450222,int_stack+449438, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+451230,int_stack+450222, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1897418,int_stack+1378358,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+973226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1902122,int_stack+452490,int_stack+451230, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+1902122,int_stack+1378358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2055492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+881672,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2063220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+454030,int_stack+452490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+945737,int_stack+16191,int_stack+1902122, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2069100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1897418,int_stack+945737,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2072880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1897418,int_stack+2552268,int_stack+881672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2086768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1469981,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1587315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+456193,int_stack+455878, 0.0, zero_stack, 1.0, int_stack+802607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+456613,int_stack+456193, 0.0, zero_stack, 1.0, int_stack+802922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+457153,int_stack+456613, 0.0, zero_stack, 1.0, int_stack+803342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1897418,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 1.0, int_stack+1071716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+457828,int_stack+457153, 0.0, zero_stack, 1.0, int_stack+803882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1900568,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 1.0, int_stack+1073606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1903808,int_stack+1900568,int_stack+1820614, 0.0, zero_stack, 1.0, int_stack+1075226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1903808,int_stack+1897418, 0.0, zero_stack, 1.0, int_stack+1077746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1897418,int_stack+458653,int_stack+457828, 0.0, zero_stack, 1.0, int_stack+804557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+1080896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+881672,int_stack+1816924,int_stack+1900568, 0.0, zero_stack, 1.0, int_stack+1082921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+881672,int_stack+1903808, 0.0, zero_stack, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 1.0, int_stack+1015394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+460084,int_stack+459643, 0.0, zero_stack, 1.0, int_stack+810137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+460672,int_stack+460084, 0.0, zero_stack, 1.0, int_stack+810578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 1.0, int_stack+2000094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+461428,int_stack+460672, 0.0, zero_stack, 1.0, int_stack+811166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 1.0, int_stack+2001417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881672,int_stack+1817167,int_stack+1710172, 0.0, zero_stack, 1.0, int_stack+2003181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+462373,int_stack+461428, 0.0, zero_stack, 1.0, int_stack+811922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+886082,int_stack+1708408,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+899573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1897418,int_stack+886082,int_stack+1817167, 0.0, zero_stack, 1.0, int_stack+901841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1903298,int_stack+1897418,int_stack+881672, 0.0, zero_stack, 1.0, int_stack+7056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+881672,int_stack+463528,int_stack+462373, 0.0, zero_stack, 1.0, int_stack+812867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1814899,int_stack+881672,int_stack+1708408, 0.0, zero_stack, 1.0, int_stack+1086161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+1814899,int_stack+886082, 0.0, zero_stack, 1.0, int_stack+2005827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 1.0, int_stack+2010363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+1814899,int_stack+1903298, 0.0, zero_stack, 1.0, int_stack+2016243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+443709,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1713133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+465502,int_stack+464914, 0.0, zero_stack, 1.0, int_stack+480978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+466286,int_stack+465502, 0.0, zero_stack, 1.0, int_stack+482154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+467294,int_stack+466286, 0.0, zero_stack, 1.0, int_stack+483722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1897418,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 1.0, int_stack+973226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2051964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1902122,int_stack+468554,int_stack+467294, 0.0, zero_stack, 1.0, int_stack+485738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+1902122,int_stack+1818427, 0.0, zero_stack, 1.0, int_stack+2055492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1897418, 0.0, zero_stack, 1.0, int_stack+2058516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+881672,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+2063220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+470094,int_stack+468554, 0.0, zero_stack, 1.0, int_stack+488258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+945737,int_stack+16191,int_stack+1902122, 0.0, zero_stack, 1.0, int_stack+2069100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1897418,int_stack+945737,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+2072880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1897418,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2078928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1897418,int_stack+2552268,int_stack+881672, 0.0, zero_stack, 1.0, int_stack+2086768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1271503,int_stack+1897418,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1758010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+472257,int_stack+471942, 1.0, int_stack+802607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+472677,int_stack+472257, 1.0, int_stack+802922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 1.0, int_stack+779542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+473217,int_stack+472677, 1.0, int_stack+803342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 1.0, int_stack+382914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1897418,int_stack+1380545,int_stack+1377035, 1.0, int_stack+1071716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+473892,int_stack+473217, 1.0, int_stack+803882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1900568,int_stack+1374830,int_stack+1378925, 1.0, int_stack+1073606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1903808,int_stack+1900568,int_stack+1380545, 1.0, int_stack+1075226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1903808,int_stack+1897418, 1.0, int_stack+1077746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1897418,int_stack+474717,int_stack+473892, 1.0, int_stack+804557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+1897418,int_stack+1374830, 1.0, int_stack+1080896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+881672,int_stack+1376855,int_stack+1900568, 1.0, int_stack+1082921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+881672,int_stack+1903808, 1.0, int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408, 1.0, int_stack+1015394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+476148,int_stack+475707, 1.0, int_stack+810137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+476736,int_stack+476148, 1.0, int_stack+810578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 1.0, int_stack+2000094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+477492,int_stack+476736, 1.0, int_stack+811166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+1708408, 1.0, int_stack+2001417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+881672,int_stack+1377098,int_stack+1710172, 1.0, int_stack+2003181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+478437,int_stack+477492, 1.0, int_stack+811922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2000094,int_stack+1708408,int_stack+1374830, 1.0, int_stack+899573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+886082,int_stack+2000094,int_stack+1377098, 1.0, int_stack+901841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+899573,int_stack+886082,int_stack+881672, 1.0, int_stack+7056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+881672,int_stack+479592,int_stack+478437, 1.0, int_stack+812867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+906188,int_stack+881672,int_stack+1708408, 1.0, int_stack+1086161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+911858,int_stack+906188,int_stack+2000094, 1.0, int_stack+2005827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2000094,int_stack+911858,int_stack+886082, 1.0, int_stack+2010363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2000094,int_stack+899573, 1.0, int_stack+2016243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+899573,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1890803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+482938,int_stack+481566, 1.0, int_stack+480978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+484730,int_stack+482938, 1.0, int_stack+482154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+919418,int_stack+17955,int_stack+16191, 1.0, int_stack+852807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+852807,int_stack+486998,int_stack+484730, 1.0, int_stack+483722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+922946,int_stack+852807,int_stack+17955, 1.0, int_stack+973226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+973226,int_stack+922946,int_stack+919418, 1.0, int_stack+2051964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+979106,int_stack+489798,int_stack+486998, 1.0, int_stack+485738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+982886,int_stack+979106,int_stack+852807, 1.0, int_stack+2055492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+988934,int_stack+982886,int_stack+922946, 1.0, int_stack+2058516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2051964,int_stack+988934,int_stack+973226, 1.0, int_stack+2063220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+973226,int_stack+491338,int_stack+489798, 1.0, int_stack+488258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2060784,int_stack+973226,int_stack+979106, 1.0, int_stack+2069100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+919418,int_stack+2060784,int_stack+982886, 1.0, int_stack+2072880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2060784,int_stack+919418,int_stack+988934, 1.0, int_stack+2078928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2060784,int_stack+2051964, 1.0, int_stack+2086768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2051964,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1909913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+493501,int_stack+493186,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+493921,int_stack+493501,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+494461,int_stack+493921,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1380545,int_stack+1377035,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+495136,int_stack+494461,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1374830,int_stack+1378925,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1380545,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1049540,int_stack+2552268,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+495961,int_stack+495136,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+2552268,int_stack+1374830,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1376855,int_stack+2555418,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+2558658,int_stack+1049540,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+497392,int_stack+496951,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+497980,int_stack+497392,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+498736,int_stack+497980,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+1708408,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1377098,int_stack+1710172,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+499681,int_stack+498736,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+1708408,int_stack+1374830,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2079747,int_stack+2556678,int_stack+1377098,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1374830,int_stack+2079747,int_stack+2552268,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+500836,int_stack+499681,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2085627,int_stack+2552268,int_stack+1708408,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+919418,int_stack+2085627,int_stack+2556678,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2085627,int_stack+919418,int_stack+2079747,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+2085627,int_stack+1374830,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+973226,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+892958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+502810,int_stack+502222,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+503594,int_stack+502810,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+504602,int_stack+503594,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2079747,int_stack+1378358,int_stack+17955,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2079747,int_stack+1374830,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2084451,int_stack+505862,int_stack+504602,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2088231,int_stack+2084451,int_stack+1378358,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+2088231,int_stack+2079747,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+919418,int_stack+1374830,int_stack+16191,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+507402,int_stack+505862,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+928238,int_stack+16191,int_stack+2084451,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+928238,int_stack+2088231,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2079747,int_stack+2552268,int_stack+1374830,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2079747,int_stack+919418,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+463554,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2022858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+509565,int_stack+509250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827707,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+509985,int_stack+509565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828022,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2095588,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+510525,int_stack+509985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828442,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2096533,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2097793,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+511200,int_stack+510525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828982,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2099683,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1820614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2101303,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1049540,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2103823,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+512025,int_stack+511200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829657,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2106973,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1816924,int_stack+2555418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2108998,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+2558658,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2112238,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2147479,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+513456,int_stack+513015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835237,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+514044,int_stack+513456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835678,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2158819,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+514800,int_stack+514044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+836266,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2160142,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1817167,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161906,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+515745,int_stack+514800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837022,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+1708408,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2164552,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+919418,int_stack+2556678,int_stack+1817167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2166820,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+919418,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2170348,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+516900,int_stack+515745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837967,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+925298,int_stack+2552268,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2116438,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+930968,int_stack+925298,int_stack+2556678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2174758,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+930968,int_stack+919418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2179294,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2185174,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+993071,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+939122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+518874,int_stack+518286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598606,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+519658,int_stack+518874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599782,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2191789,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+520666,int_stack+519658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601350,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2193553,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2195905,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2556972,int_stack+521926,int_stack+520666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603366,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+919418,int_stack+2556972,int_stack+1818427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2229715,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+919418,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2232739,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+925466,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2237443,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+523466,int_stack+521926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605886,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2079747,int_stack+16191,int_stack+2556972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2243323,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+2079747,int_stack+919418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247103,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2079747,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2253151,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2079747,int_stack+925466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260991,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+491337,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 1.0, int_stack+1020434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+525629,int_stack+525314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827707, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+526049,int_stack+525629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828022, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2095588, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+526589,int_stack+526049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828442, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2096533, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1380545,int_stack+1377035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2097793, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+527264,int_stack+526589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828982, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1374830,int_stack+1378925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2099683, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1380545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2101303, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1049540,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2103823, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+528089,int_stack+527264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829657, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2106973, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1376855,int_stack+2555418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2108998, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+2558658,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2112238, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2147479, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+529520,int_stack+529079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835237, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+530108,int_stack+529520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835678, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2158819, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+530864,int_stack+530108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+836266, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2160142, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1377098,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161906, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+531809,int_stack+530864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837022, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+1708408,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2164552, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2079747,int_stack+2556678,int_stack+1377098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2166820, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1374830,int_stack+2079747,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2170348, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+532964,int_stack+531809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837967, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2085627,int_stack+2552268,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2116438, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1814899,int_stack+2085627,int_stack+2556678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2174758, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2085627,int_stack+1814899,int_stack+2079747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2179294, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+2085627,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2185174, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2000094,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1193992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+534938,int_stack+534350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598606, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+535722,int_stack+534938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599782, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2191789, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+536730,int_stack+535722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601350, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2079747,int_stack+1378358,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2193553, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2079747,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2195905, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2084451,int_stack+537990,int_stack+536730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603366, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2088231,int_stack+2084451,int_stack+1378358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2229715, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+2088231,int_stack+2079747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2232739, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2552268,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2237443, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+539530,int_stack+537990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605886, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+919418,int_stack+16191,int_stack+2084451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2243323, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+926978,int_stack+919418,int_stack+2088231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247103, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2079747,int_stack+926978,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2253151, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+919418,int_stack+2079747,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260991, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1299286,int_stack+919418,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+1242397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+541693,int_stack+541378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827707, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+542113,int_stack+541693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828022, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2095588, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+542653,int_stack+542113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828442, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2096533, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+919418,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2097793, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+543328,int_stack+542653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828982, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+922568,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2099683, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+922568,int_stack+1820614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2101303, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1049540,int_stack+919418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2103823, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+919418,int_stack+544153,int_stack+543328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829657, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+919418,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2106973, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+925808,int_stack+1816924,int_stack+922568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2108998, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+925808,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2112238, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+545584,int_stack+545143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835237, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+546172,int_stack+545584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835678, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2158819, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+546928,int_stack+546172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+836266, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2160142, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+919418,int_stack+1817167,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161906, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+547873,int_stack+546928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837022, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+923828,int_stack+1708408,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2164552, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+928364,int_stack+923828,int_stack+1817167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2166820, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+928364,int_stack+919418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2170348, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+919418,int_stack+549028,int_stack+547873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837967, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+919418,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2116438, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2079747,int_stack+2552268,int_stack+923828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2174758, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2079747,int_stack+928364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2179294, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2185174, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+519120,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1368215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+551002,int_stack+550414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598606, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+551786,int_stack+551002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599782, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2191789, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+552794,int_stack+551786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601350, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2193553, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2195905, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2556972,int_stack+554054,int_stack+552794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603366, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2079747,int_stack+2556972,int_stack+1818427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2229715, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2079747,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2232739, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2085795,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2237443, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+555594,int_stack+554054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605886, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+919418,int_stack+16191,int_stack+2556972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2243323, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+919418,int_stack+2079747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247103, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+919418,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2253151, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+919418,int_stack+2085795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260991, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1116779,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 1.0, int_stack+1413092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+557757,int_stack+557442, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+558177,int_stack+557757, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2095588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+558717,int_stack+558177, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2096533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1380545,int_stack+1377035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2097793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+559392,int_stack+558717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1374830,int_stack+1378925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2099683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1380545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2101303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1049540,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2103823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+560217,int_stack+559392, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2106973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1376855,int_stack+2555418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2108998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+2558658,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2112238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+561648,int_stack+561207, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+562236,int_stack+561648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2158819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+562992,int_stack+562236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+836266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2160142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1377098,int_stack+1710172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+563937,int_stack+562992, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+1708408,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2164552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+919418,int_stack+2556678,int_stack+1377098, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2166820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1374830,int_stack+919418,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2170348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+565092,int_stack+563937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+837967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+925298,int_stack+2552268,int_stack+1708408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2116438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+930968,int_stack+925298,int_stack+2556678, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2174758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+930968,int_stack+919418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2179294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2185174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+538965,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1538910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+567066,int_stack+566478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+567850,int_stack+567066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2191789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+568858,int_stack+567850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1378358,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2193553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2195905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2556972,int_stack+570118,int_stack+568858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+919418,int_stack+2556972,int_stack+1378358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2229715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+919418,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2232739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+925466,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2237443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+571658,int_stack+570118, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2079747,int_stack+16191,int_stack+2556972, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2243323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+2079747,int_stack+919418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2079747,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2253151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2079747,int_stack+925466, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+3013113,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+1587315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+573821,int_stack+573506, 0.0, zero_stack, 1.0, int_stack+827707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+574241,int_stack+573821, 0.0, zero_stack, 1.0, int_stack+828022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2095588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+574781,int_stack+574241, 0.0, zero_stack, 1.0, int_stack+828442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 1.0, int_stack+2096533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 1.0, int_stack+2097793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+575456,int_stack+574781, 0.0, zero_stack, 1.0, int_stack+828982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 1.0, int_stack+2099683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1820614, 0.0, zero_stack, 1.0, int_stack+2101303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1049540,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+2103823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+576281,int_stack+575456, 0.0, zero_stack, 1.0, int_stack+829657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2106973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1816924,int_stack+2555418, 0.0, zero_stack, 1.0, int_stack+2108998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+2558658,int_stack+1049540, 0.0, zero_stack, 1.0, int_stack+2112238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 1.0, int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+577712,int_stack+577271, 0.0, zero_stack, 1.0, int_stack+835237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708408,int_stack+578300,int_stack+577712, 0.0, zero_stack, 1.0, int_stack+835678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1710172,int_stack+1708408,int_stack+2523162, 0.0, zero_stack, 1.0, int_stack+2158819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+579056,int_stack+578300, 0.0, zero_stack, 1.0, int_stack+836266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+1708408, 0.0, zero_stack, 1.0, int_stack+2160142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1817167,int_stack+1710172, 0.0, zero_stack, 1.0, int_stack+2161906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708408,int_stack+580001,int_stack+579056, 0.0, zero_stack, 1.0, int_stack+837022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+1708408,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2164552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2079747,int_stack+2556678,int_stack+1817167, 0.0, zero_stack, 1.0, int_stack+2166820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+2079747,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+2170348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+581156,int_stack+580001, 0.0, zero_stack, 1.0, int_stack+837967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2085627,int_stack+2552268,int_stack+1708408, 0.0, zero_stack, 1.0, int_stack+2116438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1374830,int_stack+2085627,int_stack+2556678, 0.0, zero_stack, 1.0, int_stack+2174758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2085627,int_stack+1374830,int_stack+2079747, 0.0, zero_stack, 1.0, int_stack+2179294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2085627,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2185174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+558810,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1713133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+583130,int_stack+582542, 0.0, zero_stack, 1.0, int_stack+598606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+583914,int_stack+583130, 0.0, zero_stack, 1.0, int_stack+599782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+2191789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+584922,int_stack+583914, 0.0, zero_stack, 1.0, int_stack+601350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2079747,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 1.0, int_stack+2193553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2079747,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2195905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2084451,int_stack+586182,int_stack+584922, 0.0, zero_stack, 1.0, int_stack+603366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2088231,int_stack+2084451,int_stack+1818427, 0.0, zero_stack, 1.0, int_stack+2229715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2088231,int_stack+2079747, 0.0, zero_stack, 1.0, int_stack+2232739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2552268,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+2237443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+587722,int_stack+586182, 0.0, zero_stack, 1.0, int_stack+605886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+919418,int_stack+16191,int_stack+2084451, 0.0, zero_stack, 1.0, int_stack+2243323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+926978,int_stack+919418,int_stack+2088231, 0.0, zero_stack, 1.0, int_stack+2247103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2079747,int_stack+926978,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2253151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+919418,int_stack+2079747,int_stack+2552268, 0.0, zero_stack, 1.0, int_stack+2260991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+3040896,int_stack+919418,int_stack+1374830, 0.0, zero_stack, 1.0, int_stack+1758010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+589885,int_stack+589570, 1.0, int_stack+827707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+590305,int_stack+589885, 1.0, int_stack+828022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 1.0, int_stack+2095588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+590845,int_stack+590305, 1.0, int_stack+828442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 1.0, int_stack+2096533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+919418,int_stack+1380545,int_stack+1377035, 1.0, int_stack+2097793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+591520,int_stack+590845, 1.0, int_stack+828982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+922568,int_stack+1374830,int_stack+1378925, 1.0, int_stack+2099683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+922568,int_stack+1380545, 1.0, int_stack+2101303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1708408,int_stack+1049540,int_stack+919418, 1.0, int_stack+2103823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+919418,int_stack+592345,int_stack+591520, 1.0, int_stack+829657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+919418,int_stack+1374830, 1.0, int_stack+2106973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+925808,int_stack+1376855,int_stack+922568, 1.0, int_stack+2108998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+925808,int_stack+1049540, 1.0, int_stack+2112238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+1708408, 1.0, int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+593776,int_stack+593335, 1.0, int_stack+835237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+594364,int_stack+593776, 1.0, int_stack+835678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162, 1.0, int_stack+2158819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1708408,int_stack+595120,int_stack+594364, 1.0, int_stack+836266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1374830,int_stack+1708408,int_stack+2147479, 1.0, int_stack+2160142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1378358,int_stack+1374830,int_stack+2149243, 1.0, int_stack+2161906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+596065,int_stack+595120, 1.0, int_stack+837022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2158819,int_stack+2147479,int_stack+1708408, 1.0, int_stack+2164552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+919418,int_stack+2158819,int_stack+1374830, 1.0, int_stack+2166820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2163355,int_stack+919418,int_stack+1378358, 1.0, int_stack+2170348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1374830,int_stack+597220,int_stack+596065, 1.0, int_stack+837967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1378295,int_stack+1374830,int_stack+2147479, 1.0, int_stack+2116438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+925298,int_stack+1378295,int_stack+2158819, 1.0, int_stack+2174758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+925298,int_stack+919418, 1.0, int_stack+2179294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+1374830,int_stack+2163355, 1.0, int_stack+2185174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2158819,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+1890803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+600566,int_stack+599194, 1.0, int_stack+598606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+602358,int_stack+600566, 1.0, int_stack+599782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191, 1.0, int_stack+2191789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+604626,int_stack+602358, 1.0, int_stack+601350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+919418,int_stack+1378358,int_stack+17955, 1.0, int_stack+2193553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+919418,int_stack+1374830, 1.0, int_stack+2195905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+924122,int_stack+607426,int_stack+604626, 1.0, int_stack+603366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+927902,int_stack+924122,int_stack+1378358, 1.0, int_stack+2229715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+927902,int_stack+919418, 1.0, int_stack+2232739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2178664,int_stack+1374830,int_stack+16191, 1.0, int_stack+2237443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+608966,int_stack+607426, 1.0, int_stack+605886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2229715,int_stack+16191,int_stack+924122, 1.0, int_stack+2243323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2187484,int_stack+2229715,int_stack+927902, 1.0, int_stack+2247103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2229715,int_stack+2187484,int_stack+1374830, 1.0, int_stack+2253151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2229715,int_stack+2178664, 1.0, int_stack+2260991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2229715,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+1909913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+611129,int_stack+610814,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+611549,int_stack+611129,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+612089,int_stack+611549,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1820614,int_stack+1817104,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+612764,int_stack+612089,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1814899,int_stack+1818994,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1820614,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+2552268,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+613589,int_stack+612764,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+2552268,int_stack+1814899,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1816924,int_stack+2555418,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+2558658,int_stack+1049540,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+2147479,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+615020,int_stack+614579,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+615608,int_stack+615020,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+616364,int_stack+615608,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+2147479,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1817167,int_stack+2149243,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+617309,int_stack+616364,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+2147479,int_stack+1814899,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2178664,int_stack+2556678,int_stack+1817167,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+2178664,int_stack+2552268,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+618464,int_stack+617309,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2184544,int_stack+2552268,int_stack+2147479,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2190214,int_stack+2184544,int_stack+2556678,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2190214,int_stack+2178664,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1814899,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2178664,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+892958, 1.0, int_stack+2152204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+620438,int_stack+619850,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+621222,int_stack+620438,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+622230,int_stack+621222,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1818427,int_stack+17955,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1814899,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2556972,int_stack+623490,int_stack+622230,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2257498,int_stack+2556972,int_stack+1818427,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2257498,int_stack+2552268,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+919418,int_stack+1814899,int_stack+16191,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+625030,int_stack+623490,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+928238,int_stack+16191,int_stack+2556972,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+928238,int_stack+2257498,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2257498,int_stack+2552268,int_stack+1814899,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2257498,int_stack+919418,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2079747,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 1.0, int_stack+2022858, 1.0, int_stack+2200609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+627193,int_stack+626878,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+627613,int_stack+627193,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+628153,int_stack+627613,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1380545,int_stack+1377035,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+628828,int_stack+628153,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1374830,int_stack+1378925,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1380545,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+2552268,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+629653,int_stack+628828,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+2552268,int_stack+1374830,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1376855,int_stack+2555418,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+2558658,int_stack+1049540,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+2147479,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+631084,int_stack+630643,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+631672,int_stack+631084,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+632428,int_stack+631672,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+2147479,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1377098,int_stack+2149243,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+633373,int_stack+632428,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+2147479,int_stack+1374830,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+919418,int_stack+2556678,int_stack+1377098,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1374830,int_stack+919418,int_stack+2552268,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+634528,int_stack+633373,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+925298,int_stack+2552268,int_stack+2147479,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+930968,int_stack+925298,int_stack+2556678,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+930968,int_stack+919418,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1374830,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+578655,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 2.0, int_stack+2152204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+636502,int_stack+635914,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+637286,int_stack+636502,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+638294,int_stack+637286,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1378358,int_stack+17955,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1374830,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2556972,int_stack+639554,int_stack+638294,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+919418,int_stack+2556972,int_stack+1378358,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+919418,int_stack+2552268,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+925466,int_stack+1374830,int_stack+16191,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+641094,int_stack+639554,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2257498,int_stack+16191,int_stack+2556972,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+2257498,int_stack+919418,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2257498,int_stack+2552268,int_stack+1374830,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2257498,int_stack+925466,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+598500,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 2.0, int_stack+2200609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+647022,int_stack+646707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856572,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+647442,int_stack+647022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856887,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269811,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+647982,int_stack+647442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857307,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270756,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2272016,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+648657,int_stack+647982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857847,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2273906,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1820614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2275526,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2278046,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+649482,int_stack+648657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858522,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2281196,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1816924,int_stack+2555418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2283221,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+2558658,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2286461,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11466,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+656184,int_stack+655743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864102,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+656772,int_stack+656184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864543,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2328317,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+657528,int_stack+656772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865131,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2329640,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1817167,int_stack+2149243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331404,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+658473,int_stack+657528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865887,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+2147479,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2334050,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2257498,int_stack+2556678,int_stack+1817167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2336318,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+2257498,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339846,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+659628,int_stack+658473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866832,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2263378,int_stack+2552268,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2290661,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1374830,int_stack+2263378,int_stack+2556678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344256,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1374830,int_stack+2257498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2348792,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2354672,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+626283,int_stack+1374830,int_stack+16191, 1.0, int_stack+939122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+661602,int_stack+661014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790399,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+662386,int_stack+661602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791575,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2361287,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+663394,int_stack+662386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+793143,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2363051,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2365403,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2556972,int_stack+664654,int_stack+663394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795159,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2257498,int_stack+2556972,int_stack+1818427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1053740,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2257498,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1056764,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+919418,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2399213,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+666194,int_stack+664654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797679,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+928238,int_stack+16191,int_stack+2556972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2405093,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+928238,int_stack+2257498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2408873,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2257498,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2414921,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2257498,int_stack+919418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422761,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+919418,int_stack+2552268,int_stack+1374830, 1.0, int_stack+1020434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1374830,int_stack+672122,int_stack+671807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856572, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1375775,int_stack+672542,int_stack+672122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856887, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1377035,int_stack+1375775,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269811, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378925,int_stack+673082,int_stack+672542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857307, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1380545,int_stack+1378925,int_stack+1375775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270756, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1380545,int_stack+1377035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2272016, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1374830,int_stack+673757,int_stack+673082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857847, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1374830,int_stack+1378925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2273906, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+2555418,int_stack+1380545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2275526, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2278046, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+674582,int_stack+673757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858522, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1376855,int_stack+2552268,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2281196, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2558658,int_stack+1376855,int_stack+2555418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2283221, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1374830,int_stack+2558658,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2286461, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1374830,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11466, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+681284,int_stack+680843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864102, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+681872,int_stack+681284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864543, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2328317, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1374830,int_stack+682628,int_stack+681872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865131, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1377098,int_stack+1374830,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2329640, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1377098,int_stack+2149243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331404, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+683573,int_stack+682628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865887, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556678,int_stack+2147479,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2334050, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+947201,int_stack+2556678,int_stack+1377098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2336318, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1374830,int_stack+947201,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339846, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+684728,int_stack+683573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866832, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2257498,int_stack+2552268,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2290661, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1814899,int_stack+2257498,int_stack+2556678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344256, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2257498,int_stack+1814899,int_stack+947201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2348792, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+2257498,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2354672, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+646128,int_stack+1814899,int_stack+16191, 1.0, int_stack+1193992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+686702,int_stack+686114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790399, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+687486,int_stack+686702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791575, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1374830,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2361287, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1378358,int_stack+688494,int_stack+687486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+793143, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2257498,int_stack+1378358,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2363051, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2257498,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2365403, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2262202,int_stack+689754,int_stack+688494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795159, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+947201,int_stack+2262202,int_stack+1378358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1053740, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1374830,int_stack+947201,int_stack+2257498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1056764, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2552268,int_stack+1374830,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2399213, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+691294,int_stack+689754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797679, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2107530,int_stack+16191,int_stack+2262202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2405093, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2257498,int_stack+2107530,int_stack+947201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2408873, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2107530,int_stack+2257498,int_stack+1374830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2414921, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1012916,int_stack+2107530,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422761, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+665973,int_stack+1012916,int_stack+1814899, 1.0, int_stack+1242397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+697222,int_stack+696907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856572, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+697642,int_stack+697222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856887, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269811, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+698182,int_stack+697642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857307, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270756, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1012916,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2272016, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+698857,int_stack+698182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857847, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1016066,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2273906, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+1016066,int_stack+1820614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2275526, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+1012916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2278046, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1012916,int_stack+699682,int_stack+698857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858522, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+1012916,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2281196, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1019306,int_stack+1816924,int_stack+1016066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2283221, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+1019306,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2286461, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11466, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+706384,int_stack+705943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864102, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+706972,int_stack+706384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864543, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2328317, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+707728,int_stack+706972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865131, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2329640, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1012916,int_stack+1817167,int_stack+2149243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331404, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+708673,int_stack+707728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865887, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1017326,int_stack+2147479,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2334050, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1021862,int_stack+1017326,int_stack+1817167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2336318, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+1021862,int_stack+1012916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339846, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1012916,int_stack+709828,int_stack+708673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866832, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2552268,int_stack+1012916,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2290661, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2107530,int_stack+2552268,int_stack+1017326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344256, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2107530,int_stack+1021862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2348792, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1374830,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2354672, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+357651,int_stack+1374830,int_stack+16191, 1.0, int_stack+1368215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+711802,int_stack+711214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790399, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+712586,int_stack+711802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791575, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2361287, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+713594,int_stack+712586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+793143, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2552268,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2363051, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2365403, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2556972,int_stack+714854,int_stack+713594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795159, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2107530,int_stack+2556972,int_stack+1818427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1053740, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+2107530,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1056764, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1012916,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2399213, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+716394,int_stack+714854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797679, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1021736,int_stack+16191,int_stack+2556972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2405093, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+1021736,int_stack+2107530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2408873, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2107530,int_stack+2552268,int_stack+1814899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2414921, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2107530,int_stack+1012916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422761, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+693756,int_stack+2552268,int_stack+1374830, 1.0, int_stack+1413092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+722322,int_stack+722007, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2553213,int_stack+722742,int_stack+722322, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+856887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554473,int_stack+2553213,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556363,int_stack+723282,int_stack+722742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2557983,int_stack+2556363,int_stack+2553213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2560503,int_stack+2557983,int_stack+2554473, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2272016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+723957,int_stack+723282, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1012916,int_stack+2552268,int_stack+2556363, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2273906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+1012916,int_stack+2557983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2275526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+2560503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2278046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2554293,int_stack+724782,int_stack+723957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2556768,int_stack+2554293,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2281196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1016156,int_stack+2556768,int_stack+1012916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2283221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1016156,int_stack+1049540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2286461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+731484,int_stack+731043, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+732072,int_stack+731484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+864543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2328317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2552268,int_stack+732828,int_stack+732072, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2554536,int_stack+2552268,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2329640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2558064,int_stack+2554536,int_stack+2149243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+733773,int_stack+732828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1012916,int_stack+2147479,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2334050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1017452,int_stack+1012916,int_stack+2554536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2336318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2107530,int_stack+1017452,int_stack+2558064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+734928,int_stack+733773, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2555733,int_stack+2552268,int_stack+2147479, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2290661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1814899,int_stack+2555733,int_stack+1012916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1814899,int_stack+1017452, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2348792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+2107530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2354672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1565370,int_stack+1814899,int_stack+16191, 1.0, int_stack+1538910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+736902,int_stack+736314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+737686,int_stack+736902, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+791575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2107530,int_stack+17955,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2361287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2111058,int_stack+738694,int_stack+737686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+793143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2114082,int_stack+2111058,int_stack+17955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2363051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2114082,int_stack+2107530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2365403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+739954,int_stack+738694, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2556048,int_stack+2552268,int_stack+2111058, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1053740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1012916,int_stack+2556048,int_stack+2114082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1056764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2107530,int_stack+1012916,int_stack+16191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2399213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+741494,int_stack+739954, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1020756,int_stack+16191,int_stack+2552268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2405093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2257498,int_stack+1020756,int_stack+2556048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2408873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2257498,int_stack+1012916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2414921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1012916,int_stack+2552268,int_stack+2107530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1220452,int_stack+1012916,int_stack+1814899, 1.0, int_stack+1587315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+747422,int_stack+747107, 0.0, zero_stack, 1.0, int_stack+856572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+747842,int_stack+747422, 0.0, zero_stack, 1.0, int_stack+856887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2269811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+748382,int_stack+747842, 0.0, zero_stack, 1.0, int_stack+857307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844, 0.0, zero_stack, 1.0, int_stack+2270756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1012916,int_stack+1820614,int_stack+1817104, 0.0, zero_stack, 1.0, int_stack+2272016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+749057,int_stack+748382, 0.0, zero_stack, 1.0, int_stack+857847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1016066,int_stack+1814899,int_stack+1818994, 0.0, zero_stack, 1.0, int_stack+2273906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+1016066,int_stack+1820614, 0.0, zero_stack, 1.0, int_stack+2275526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+1012916, 0.0, zero_stack, 1.0, int_stack+2278046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1012916,int_stack+749882,int_stack+749057, 0.0, zero_stack, 1.0, int_stack+858522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+1012916,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2281196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1019306,int_stack+1816924,int_stack+1016066, 0.0, zero_stack, 1.0, int_stack+2283221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+1019306,int_stack+1049540, 0.0, zero_stack, 1.0, int_stack+2286461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+1814899,int_stack+2147479, 0.0, zero_stack, 1.0, int_stack+11466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+756584,int_stack+756143, 0.0, zero_stack, 1.0, int_stack+864102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+757172,int_stack+756584, 0.0, zero_stack, 1.0, int_stack+864543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162, 0.0, zero_stack, 1.0, int_stack+2328317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+757928,int_stack+757172, 0.0, zero_stack, 1.0, int_stack+865131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+2147479, 0.0, zero_stack, 1.0, int_stack+2329640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1012916,int_stack+1817167,int_stack+2149243, 0.0, zero_stack, 1.0, int_stack+2331404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+758873,int_stack+757928, 0.0, zero_stack, 1.0, int_stack+865887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1017326,int_stack+2147479,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2334050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1021862,int_stack+1017326,int_stack+1817167, 0.0, zero_stack, 1.0, int_stack+2336318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+1021862,int_stack+1012916, 0.0, zero_stack, 1.0, int_stack+2339846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1012916,int_stack+760028,int_stack+758873, 0.0, zero_stack, 1.0, int_stack+866832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2107530,int_stack+1012916,int_stack+2147479, 0.0, zero_stack, 1.0, int_stack+2290661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2552268,int_stack+2107530,int_stack+1017326, 0.0, zero_stack, 1.0, int_stack+2344256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2107530,int_stack+2552268,int_stack+1021862, 0.0, zero_stack, 1.0, int_stack+2348792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2107530,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2354672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+721539,int_stack+2552268,int_stack+16191, 1.0, int_stack+1713133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16191,int_stack+762002,int_stack+761414, 0.0, zero_stack, 1.0, int_stack+790399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17955,int_stack+762786,int_stack+762002, 0.0, zero_stack, 1.0, int_stack+791575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814899,int_stack+17955,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+2361287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1818427,int_stack+763794,int_stack+762786, 0.0, zero_stack, 1.0, int_stack+793143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2107530,int_stack+1818427,int_stack+17955, 0.0, zero_stack, 1.0, int_stack+2363051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16191,int_stack+2107530,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2365403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2112234,int_stack+765054,int_stack+763794, 0.0, zero_stack, 1.0, int_stack+795159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1012916,int_stack+2112234,int_stack+1818427, 0.0, zero_stack, 1.0, int_stack+1053740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1814899,int_stack+1012916,int_stack+2107530, 0.0, zero_stack, 1.0, int_stack+1056764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1018964,int_stack+1814899,int_stack+16191, 0.0, zero_stack, 1.0, int_stack+2399213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16191,int_stack+766594,int_stack+765054, 0.0, zero_stack, 1.0, int_stack+797679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2257498,int_stack+16191,int_stack+2112234, 0.0, zero_stack, 1.0, int_stack+2405093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2107530,int_stack+2257498,int_stack+1012916, 0.0, zero_stack, 1.0, int_stack+2408873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2257498,int_stack+2107530,int_stack+1814899, 0.0, zero_stack, 1.0, int_stack+2414921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1897418,int_stack+2257498,int_stack+1018964, 0.0, zero_stack, 1.0, int_stack+2422761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+741384,int_stack+1897418,int_stack+2552268, 1.0, int_stack+1758010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+772522,int_stack+772207, 1.0, int_stack+856572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2553213,int_stack+772942,int_stack+772522, 1.0, int_stack+856887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2554473,int_stack+2553213,int_stack+2552268, 1.0, int_stack+2269811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2556363,int_stack+773482,int_stack+772942, 1.0, int_stack+857307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2557983,int_stack+2556363,int_stack+2553213, 1.0, int_stack+2270756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2560503,int_stack+2557983,int_stack+2554473, 1.0, int_stack+2272016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+774157,int_stack+773482, 1.0, int_stack+857847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1897418,int_stack+2552268,int_stack+2556363, 1.0, int_stack+2273906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1049540,int_stack+1897418,int_stack+2557983, 1.0, int_stack+2275526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+1049540,int_stack+2560503, 1.0, int_stack+2278046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2554293,int_stack+774982,int_stack+774157, 1.0, int_stack+858522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2556768,int_stack+2554293,int_stack+2552268, 1.0, int_stack+2281196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1900658,int_stack+2556768,int_stack+1897418, 1.0, int_stack+2283221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+1900658,int_stack+1049540, 1.0, int_stack+2286461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16191,int_stack+2552268,int_stack+2147479, 1.0, int_stack+11466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+785569,int_stack+785128, 1.0, int_stack+864102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+786157,int_stack+785569, 1.0, int_stack+864543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162, 1.0, int_stack+2328317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2552268,int_stack+786913,int_stack+786157, 1.0, int_stack+865131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2554536,int_stack+2552268,int_stack+2147479, 1.0, int_stack+2329640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2558064,int_stack+2554536,int_stack+2149243, 1.0, int_stack+2331404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+787858,int_stack+786913, 1.0, int_stack+865887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2328317,int_stack+2147479,int_stack+2552268, 1.0, int_stack+2334050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1897418,int_stack+2328317,int_stack+2554536, 1.0, int_stack+2336318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1903298,int_stack+1897418,int_stack+2558064, 1.0, int_stack+2339846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+789013,int_stack+787858, 1.0, int_stack+866832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2555733,int_stack+2552268,int_stack+2147479, 1.0, int_stack+2290661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2332853,int_stack+2555733,int_stack+2328317, 1.0, int_stack+2344256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2332853,int_stack+1897418, 1.0, int_stack+2348792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+2552268,int_stack+1903298, 1.0, int_stack+2354672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2328317,int_stack+1814899,int_stack+16191, 1.0, int_stack+1890803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+792359,int_stack+790987, 1.0, int_stack+790399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2554032,int_stack+794151,int_stack+792359, 1.0, int_stack+791575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2556384,int_stack+2554032,int_stack+2552268, 1.0, int_stack+2361287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2559912,int_stack+796419,int_stack+794151, 1.0, int_stack+793143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2348162,int_stack+2559912,int_stack+2554032, 1.0, int_stack+2363051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2352866,int_stack+2348162,int_stack+2556384, 1.0, int_stack+2365403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+799219,int_stack+796419, 1.0, int_stack+795159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2358746,int_stack+2552268,int_stack+2559912, 1.0, int_stack+1053740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2556048,int_stack+2358746,int_stack+2348162, 1.0, int_stack+1056764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1049540,int_stack+2556048,int_stack+2352866, 1.0, int_stack+2399213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2399213,int_stack+800759,int_stack+799219, 1.0, int_stack+797679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2348162,int_stack+2399213,int_stack+2552268, 1.0, int_stack+2405093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1058360,int_stack+2348162,int_stack+2358746, 1.0, int_stack+2408873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2348162,int_stack+1058360,int_stack+2556048, 1.0, int_stack+2414921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2348162,int_stack+1049540, 1.0, int_stack+2422761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1049540,int_stack+2552268,int_stack+1814899, 1.0, int_stack+1909913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1814899,int_stack+806687,int_stack+806372,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1815844,int_stack+807107,int_stack+806687,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1817104,int_stack+1815844,int_stack+1814899,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1818994,int_stack+807647,int_stack+807107,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1820614,int_stack+1818994,int_stack+1815844,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2552268,int_stack+1820614,int_stack+1817104,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1814899,int_stack+808322,int_stack+807647,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2555418,int_stack+1814899,int_stack+1818994,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2558658,int_stack+2555418,int_stack+1820614,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+2558658,int_stack+2552268,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+809147,int_stack+808322,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1816924,int_stack+2552268,int_stack+1814899,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1077323,int_stack+1816924,int_stack+2555418,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1814899,int_stack+1077323,int_stack+2558658,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1077323,int_stack+1814899,int_stack+2147479,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+815849,int_stack+815408,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+816437,int_stack+815849,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1814899,int_stack+817193,int_stack+816437,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1817167,int_stack+1814899,int_stack+2147479,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1083938,int_stack+1817167,int_stack+2149243,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+818138,int_stack+817193,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+2147479,int_stack+1814899,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2556804,int_stack+2552268,int_stack+1817167,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+2556804,int_stack+1083938,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1083938,int_stack+819293,int_stack+818138,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2348162,int_stack+1083938,int_stack+2147479,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2353832,int_stack+2348162,int_stack+2552268,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2399213,int_stack+2353832,int_stack+2556804,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2399213,int_stack+1814899,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2399213,int_stack+2552268,int_stack+1077323, 1.0, int_stack+892958, 0.0, zero_stack, 1.0, int_stack+2321702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1077323,int_stack+821267,int_stack+820679,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1079087,int_stack+822051,int_stack+821267,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1081439,int_stack+1079087,int_stack+1077323,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1084967,int_stack+823059,int_stack+822051,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1814899,int_stack+1084967,int_stack+1079087,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2419058,int_stack+1814899,int_stack+1081439,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1077323,int_stack+824319,int_stack+823059,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2424938,int_stack+1077323,int_stack+1084967,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1081103,int_stack+2424938,int_stack+1814899,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+1081103,int_stack+2419058,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2419058,int_stack+825859,int_stack+824319,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2348162,int_stack+2419058,int_stack+1077323,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2355722,int_stack+2348162,int_stack+2424938,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2419058,int_stack+2355722,int_stack+1081103,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2348162,int_stack+2419058,int_stack+1814899,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2257498,int_stack+2348162,int_stack+2552268, 1.0, int_stack+2022858, 0.0, zero_stack, 1.0, int_stack+2370107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2552268,int_stack+831787,int_stack+831472,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2553213,int_stack+832207,int_stack+831787,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2554473,int_stack+2553213,int_stack+2552268,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2556363,int_stack+832747,int_stack+832207,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2557983,int_stack+2556363,int_stack+2553213,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2560503,int_stack+2557983,int_stack+2554473,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2552268,int_stack+833422,int_stack+832747,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2348162,int_stack+2552268,int_stack+2556363,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2351402,int_stack+2348162,int_stack+2557983,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2147479,int_stack+2351402,int_stack+2560503,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2554293,int_stack+834247,int_stack+833422,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2556768,int_stack+2554293,int_stack+2552268,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2355602,int_stack+2556768,int_stack+2348162,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2355602,int_stack+2351402,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2348162,int_stack+2552268,int_stack+2147479,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+840949,int_stack+840508,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2147479,int_stack+841537,int_stack+840949,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2149243,int_stack+2147479,int_stack+2523162,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2552268,int_stack+842293,int_stack+841537,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2554536,int_stack+2552268,int_stack+2147479,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2558064,int_stack+2554536,int_stack+2149243,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2147479,int_stack+843238,int_stack+842293,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2354777,int_stack+2147479,int_stack+2552268,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2359313,int_stack+2354777,int_stack+2554536,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1814899,int_stack+2359313,int_stack+2558064,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2552268,int_stack+844393,int_stack+843238,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2555733,int_stack+2552268,int_stack+2147479,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2419058,int_stack+2555733,int_stack+2354777,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2552268,int_stack+2419058,int_stack+2359313,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2419058,int_stack+2552268,int_stack+1814899,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1879103,int_stack+2419058,int_stack+2348162, 1.0, int_stack+2152204, 1.0, int_stack+2321702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2348162,int_stack+846367,int_stack+845779,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2349926,int_stack+847151,int_stack+846367,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2352278,int_stack+2349926,int_stack+2348162,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2355806,int_stack+848159,int_stack+847151,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2358830,int_stack+2355806,int_stack+2349926,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2363534,int_stack+2358830,int_stack+2352278,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2348162,int_stack+849419,int_stack+848159,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1814899,int_stack+2348162,int_stack+2355806,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2552268,int_stack+1814899,int_stack+2358830,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2351942,int_stack+2552268,int_stack+2363534,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2360762,int_stack+850959,int_stack+849419,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2147479,int_stack+2360762,int_stack+2348162,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1077323,int_stack+2147479,int_stack+1814899,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2107530,int_stack+1077323,int_stack+2552268,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2107530,int_stack+2351942,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+769167,int_stack+2552268,int_stack+2419058, 1.0, int_stack+2200609, 1.0, int_stack+2370107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2419058,int_stack+860652,int_stack+860337,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2420003,int_stack+861072,int_stack+860652,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2421263,int_stack+2420003,int_stack+2419058,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2423153,int_stack+861612,int_stack+861072,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2424773,int_stack+2423153,int_stack+2420003,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2427293,int_stack+2424773,int_stack+2421263,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2419058,int_stack+862287,int_stack+861612,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2552268,int_stack+2419058,int_stack+2423153,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2555508,int_stack+2552268,int_stack+2424773,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2421083,int_stack+2555508,int_stack+2427293,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2425808,int_stack+863112,int_stack+862287,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2559708,int_stack+2425808,int_stack+2419058,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2425808,int_stack+2559708,int_stack+2552268,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2107530,int_stack+2425808,int_stack+2555508,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2552268,int_stack+2107530,int_stack+2421083,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2523162,int_stack+869814,int_stack+869373,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2107530,int_stack+870402,int_stack+869814,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2109294,int_stack+2107530,int_stack+2523162,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2111940,int_stack+871158,int_stack+870402,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2114208,int_stack+2111940,int_stack+2107530,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2558883,int_stack+2114208,int_stack+2109294,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2107530,int_stack+872103,int_stack+871158,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2419058,int_stack+2107530,int_stack+2111940,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2423594,int_stack+2419058,int_stack+2114208,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2110365,int_stack+2423594,int_stack+2558883,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2558883,int_stack+873258,int_stack+872103,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1077323,int_stack+2558883,int_stack+2107530,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1814899,int_stack+1077323,int_stack+2419058,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1077323,int_stack+1814899,int_stack+2423594,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1814899,int_stack+1077323,int_stack+2110365,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2348162,int_stack+1814899,int_stack+2552268, 2.0, int_stack+2321702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2321702,int_stack+875232,int_stack+874644,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2323466,int_stack+876016,int_stack+875232,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2552268,int_stack+2323466,int_stack+2321702,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2555796,int_stack+877024,int_stack+876016,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2558820,int_stack+2555796,int_stack+2323466,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2321702,int_stack+2558820,int_stack+2552268,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1077323,int_stack+878284,int_stack+877024,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1081103,int_stack+1077323,int_stack+2555796,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2419058,int_stack+1081103,int_stack+2558820,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2552268,int_stack+2419058,int_stack+2321702,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2321702,int_stack+879824,int_stack+878284,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2107530,int_stack+2321702,int_stack+1077323,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2147479,int_stack+2107530,int_stack+1081103,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2107530,int_stack+2147479,int_stack+2419058,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2419058,int_stack+2107530,int_stack+2552268,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+796950,int_stack+2419058,int_stack+1814899, 2.0, int_stack+2370107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+824733,int_stack+1161484,int_stack+1029695,441);
     Libderiv->ABCD[11] = int_stack + 824733;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1144562,int_stack+1335707,int_stack+1251658,441);
     Libderiv->ABCD[10] = int_stack + 1144562;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1327069,int_stack+1506402,int_stack+1422353,441);
     Libderiv->ABCD[9] = int_stack + 1327069;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1497764,int_stack+1680625,int_stack+1596576,441);
     Libderiv->ABCD[8] = int_stack + 1497764;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1671987,int_stack+1851320,int_stack+1767271,441);
     Libderiv->ABCD[7] = int_stack + 1671987;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+3068679,int_stack+1972311,int_stack+1919174,441);
     Libderiv->ABCD[6] = int_stack + 3068679;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+3108369,int_stack+2119696,int_stack+2032119, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+953381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 3108369;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2107530,int_stack+2293919,int_stack+2209870, 0.0, zero_stack, 1.0, int_stack+953381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 2107530;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2285281,int_stack+2455689,int_stack+2379368, 1.0, int_stack+953381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 2285281;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+3148059,int_stack+2524485,int_stack+2483472,441);
     Libderiv->ABCD[155] = int_stack + 3148059;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2523162,int_stack+2564616,int_stack+22806,441);
     Libderiv->ABCD[143] = int_stack + 2523162;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+0,int_stack+2592399,int_stack+2503317,441);
     Libderiv->ABCD[142] = int_stack + 0;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2562852,int_stack+2620182,int_stack+42651,441);
     Libderiv->ABCD[131] = int_stack + 2562852;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2602542,int_stack+2647965,int_stack+62496,441);
     Libderiv->ABCD[130] = int_stack + 2602542;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+39690,int_stack+2675748,int_stack+2431581,441);
     Libderiv->ABCD[129] = int_stack + 39690;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2419058,int_stack+2723376,int_stack+2703531,441);
     Libderiv->ABCD[119] = int_stack + 2419058;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2458748,int_stack+2751159,int_stack+109872,441);
     Libderiv->ABCD[118] = int_stack + 2458748;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2642232,int_stack+2778942,int_stack+129717,441);
     Libderiv->ABCD[117] = int_stack + 2642232;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2681922,int_stack+2806725,int_stack+82341,441);
     Libderiv->ABCD[116] = int_stack + 2681922;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2721612,int_stack+2854353,int_stack+2834508,441);
     Libderiv->ABCD[107] = int_stack + 2721612;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2761302,int_stack+2882136,int_stack+177093,441);
     Libderiv->ABCD[106] = int_stack + 2761302;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2800992,int_stack+2909919,int_stack+149562,441);
     Libderiv->ABCD[105] = int_stack + 2800992;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2840682,int_stack+2957547,int_stack+2937702,441);
     Libderiv->ABCD[104] = int_stack + 2840682;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2880372,int_stack+2985330,int_stack+224469,441);
     Libderiv->ABCD[103] = int_stack + 2880372;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2920062,int_stack+1088996,int_stack+196938,441);
     Libderiv->ABCD[95] = int_stack + 2920062;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2959752,int_stack+262395,int_stack+1200607,441);
     Libderiv->ABCD[94] = int_stack + 2959752;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+79380,int_stack+1384091,int_stack+290178,441);
     Libderiv->ABCD[93] = int_stack + 79380;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+119070,int_stack+1616421,int_stack+1545525,441);
     Libderiv->ABCD[92] = int_stack + 119070;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+158760,int_stack+1787116,int_stack+1719748,441);
     Libderiv->ABCD[91] = int_stack + 158760;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+198450,int_stack+1939019,int_stack+1824160,441);
     Libderiv->ABCD[90] = int_stack + 198450;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1939019,int_stack+329868,int_stack+310023, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1029695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[47] = int_stack + 1939019;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1787116,int_stack+1644204,int_stack+384174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1251658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[46] = int_stack + 1787116;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1826806,int_stack+1442198,int_stack+404019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1422353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[45] = int_stack + 1826806;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1616421,int_stack+1469981,int_stack+423864, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[44] = int_stack + 1616421;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1442198,int_stack+1271503,int_stack+443709, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1767271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[43] = int_stack + 1442198;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+377496,int_stack+2051964,int_stack+899573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1919174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[42] = int_stack + 377496;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+864423,int_stack+463554,int_stack+973226, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2032119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[38] = int_stack + 864423;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+947201,int_stack+491337,int_stack+993071, 0.0, zero_stack, 1.0, int_stack+1029695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[35] = int_stack + 947201;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+986891,int_stack+1299286,int_stack+2000094, 0.0, zero_stack, 1.0, int_stack+1251658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[34] = int_stack + 986891;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1271503,int_stack+1116779,int_stack+519120, 0.0, zero_stack, 1.0, int_stack+1422353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[33] = int_stack + 1271503;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1978709,int_stack+3013113,int_stack+538965, 0.0, zero_stack, 1.0, int_stack+1596576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[32] = int_stack + 1978709;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1077323,int_stack+3040896,int_stack+558810, 0.0, zero_stack, 1.0, int_stack+1767271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[31] = int_stack + 1077323;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2999442,int_stack+2229715,int_stack+2158819, 0.0, zero_stack, 1.0, int_stack+1919174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[30] = int_stack + 2999442;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+417186,int_stack+2079747,int_stack+2178664, 0.0, zero_stack, 1.0, int_stack+2032119, 1.0, int_stack+2209870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[26] = int_stack + 417186;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2051964,int_stack+598500,int_stack+578655, 0.0, zero_stack, 2.0, int_stack+2209870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[25] = int_stack + 2051964;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2147220,int_stack+919418,int_stack+626283, 1.0, int_stack+1029695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[23] = int_stack + 2147220;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+904113,int_stack+665973,int_stack+646128, 1.0, int_stack+1251658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[22] = int_stack + 904113;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+456876,int_stack+693756,int_stack+357651, 1.0, int_stack+1422353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[21] = int_stack + 456876;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+496566,int_stack+1220452,int_stack+1565370, 1.0, int_stack+1596576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[20] = int_stack + 496566;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+536256,int_stack+741384,int_stack+721539, 1.0, int_stack+1767271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[19] = int_stack + 536256;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+575946,int_stack+1049540,int_stack+2328317, 1.0, int_stack+1919174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[18] = int_stack + 575946;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1026581,int_stack+2257498,int_stack+2399213, 1.0, int_stack+2032119, 0.0, zero_stack, 1.0, int_stack+2379368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[14] = int_stack + 1026581;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2229715,int_stack+769167,int_stack+1879103, 1.0, int_stack+2209870, 1.0, int_stack+2379368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[13] = int_stack + 2229715;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1866496,int_stack+796950,int_stack+2348162, 2.0, int_stack+2379368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[12] = int_stack + 1866496;

}
