/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_hfhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hf|hh) integrals */

void d12hrr_order_hfhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[8][10][11] = int_stack + 0;
 Libderiv->deriv_classes[8][10][10] = int_stack + 2970;
 Libderiv->deriv_classes[8][10][9] = int_stack + 5940;
 Libderiv->deriv_classes[8][10][8] = int_stack + 8910;
 Libderiv->deriv_classes[8][10][7] = int_stack + 11880;
 Libderiv->dvrr_classes[8][9] = int_stack + 14850;
 Libderiv->deriv_classes[8][10][6] = int_stack + 17325;
 Libderiv->deriv_classes[8][10][2] = int_stack + 20295;
 Libderiv->deriv_classes[8][10][1] = int_stack + 23265;
 Libderiv->dvrr_classes[7][10] = int_stack + 26235;
 Libderiv->deriv_classes[8][10][0] = int_stack + 28611;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 31581;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 32022;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 32610;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 33366;
 Libderiv->deriv2_classes[5][9][143] = int_stack + 34311;
 Libderiv->deriv2_classes[5][10][143] = int_stack + 35466;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 36852;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 37440;
 Libderiv->deriv2_classes[6][7][143] = int_stack + 38224;
 Libderiv->deriv2_classes[6][8][143] = int_stack + 39232;
 Libderiv->deriv2_classes[6][9][143] = int_stack + 40492;
 Libderiv->deriv2_classes[6][10][143] = int_stack + 42032;
 Libderiv->deriv2_classes[7][5][143] = int_stack + 43880;
 Libderiv->deriv2_classes[7][6][143] = int_stack + 44636;
 Libderiv->deriv2_classes[7][7][143] = int_stack + 45644;
 Libderiv->deriv2_classes[7][8][143] = int_stack + 46940;
 Libderiv->deriv2_classes[7][9][143] = int_stack + 48560;
 Libderiv->deriv2_classes[7][10][143] = int_stack + 50540;
 Libderiv->deriv2_classes[8][5][143] = int_stack + 52916;
 Libderiv->deriv2_classes[8][6][143] = int_stack + 53861;
 Libderiv->deriv2_classes[8][7][143] = int_stack + 55121;
 Libderiv->deriv2_classes[8][8][143] = int_stack + 56741;
 Libderiv->deriv2_classes[8][9][143] = int_stack + 58766;
 Libderiv->deriv2_classes[8][10][143] = int_stack + 61241;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 64211;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 64652;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 65240;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 65996;
 Libderiv->deriv2_classes[5][9][131] = int_stack + 66941;
 Libderiv->deriv2_classes[5][10][131] = int_stack + 68096;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 69482;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 70070;
 Libderiv->deriv2_classes[6][7][131] = int_stack + 70854;
 Libderiv->deriv2_classes[6][8][131] = int_stack + 71862;
 Libderiv->deriv2_classes[6][9][131] = int_stack + 73122;
 Libderiv->deriv2_classes[6][10][131] = int_stack + 74662;
 Libderiv->deriv2_classes[7][5][131] = int_stack + 76510;
 Libderiv->deriv2_classes[7][6][131] = int_stack + 77266;
 Libderiv->deriv2_classes[7][7][131] = int_stack + 78274;
 Libderiv->deriv2_classes[7][8][131] = int_stack + 79570;
 Libderiv->deriv2_classes[7][9][131] = int_stack + 81190;
 Libderiv->deriv2_classes[7][10][131] = int_stack + 83170;
 Libderiv->deriv2_classes[8][5][131] = int_stack + 85546;
 Libderiv->deriv2_classes[8][6][131] = int_stack + 86491;
 Libderiv->deriv2_classes[8][7][131] = int_stack + 87751;
 Libderiv->deriv2_classes[8][8][131] = int_stack + 89371;
 Libderiv->deriv2_classes[8][9][131] = int_stack + 91396;
 Libderiv->deriv2_classes[8][10][131] = int_stack + 93871;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 96841;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 97282;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 97870;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 98626;
 Libderiv->deriv2_classes[5][9][130] = int_stack + 99571;
 Libderiv->deriv2_classes[5][10][130] = int_stack + 100726;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 102112;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 102700;
 Libderiv->deriv2_classes[6][7][130] = int_stack + 103484;
 Libderiv->deriv2_classes[6][8][130] = int_stack + 104492;
 Libderiv->deriv2_classes[6][9][130] = int_stack + 105752;
 Libderiv->deriv2_classes[6][10][130] = int_stack + 107292;
 Libderiv->deriv2_classes[7][5][130] = int_stack + 109140;
 Libderiv->deriv2_classes[7][6][130] = int_stack + 109896;
 Libderiv->deriv2_classes[7][7][130] = int_stack + 110904;
 Libderiv->deriv2_classes[7][8][130] = int_stack + 112200;
 Libderiv->deriv2_classes[7][9][130] = int_stack + 113820;
 Libderiv->deriv2_classes[7][10][130] = int_stack + 115800;
 Libderiv->deriv2_classes[8][5][130] = int_stack + 118176;
 Libderiv->deriv2_classes[8][6][130] = int_stack + 119121;
 Libderiv->deriv2_classes[8][7][130] = int_stack + 120381;
 Libderiv->deriv2_classes[8][8][130] = int_stack + 122001;
 Libderiv->deriv2_classes[8][9][130] = int_stack + 124026;
 Libderiv->deriv2_classes[8][10][130] = int_stack + 126501;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 129471;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 129912;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 130500;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 131256;
 Libderiv->deriv2_classes[5][9][119] = int_stack + 132201;
 Libderiv->deriv2_classes[5][10][119] = int_stack + 133356;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 134742;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 135330;
 Libderiv->deriv2_classes[6][7][119] = int_stack + 136114;
 Libderiv->deriv2_classes[6][8][119] = int_stack + 137122;
 Libderiv->deriv2_classes[6][9][119] = int_stack + 138382;
 Libderiv->deriv2_classes[6][10][119] = int_stack + 139922;
 Libderiv->deriv2_classes[7][5][119] = int_stack + 141770;
 Libderiv->deriv2_classes[7][6][119] = int_stack + 142526;
 Libderiv->deriv2_classes[7][7][119] = int_stack + 143534;
 Libderiv->deriv2_classes[7][8][119] = int_stack + 144830;
 Libderiv->deriv2_classes[7][9][119] = int_stack + 146450;
 Libderiv->deriv2_classes[7][10][119] = int_stack + 148430;
 Libderiv->deriv2_classes[8][5][119] = int_stack + 150806;
 Libderiv->deriv2_classes[8][6][119] = int_stack + 151751;
 Libderiv->deriv2_classes[8][7][119] = int_stack + 153011;
 Libderiv->deriv2_classes[8][8][119] = int_stack + 154631;
 Libderiv->deriv2_classes[8][9][119] = int_stack + 156656;
 Libderiv->deriv2_classes[8][10][119] = int_stack + 159131;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 162101;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 162542;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 163130;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 163886;
 Libderiv->deriv2_classes[5][9][118] = int_stack + 164831;
 Libderiv->deriv2_classes[5][10][118] = int_stack + 165986;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 167372;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 167960;
 Libderiv->deriv2_classes[6][7][118] = int_stack + 168744;
 Libderiv->deriv2_classes[6][8][118] = int_stack + 169752;
 Libderiv->deriv2_classes[6][9][118] = int_stack + 171012;
 Libderiv->deriv2_classes[6][10][118] = int_stack + 172552;
 Libderiv->deriv2_classes[7][5][118] = int_stack + 174400;
 Libderiv->deriv2_classes[7][6][118] = int_stack + 175156;
 Libderiv->deriv2_classes[7][7][118] = int_stack + 176164;
 Libderiv->deriv2_classes[7][8][118] = int_stack + 177460;
 Libderiv->deriv2_classes[7][9][118] = int_stack + 179080;
 Libderiv->deriv2_classes[7][10][118] = int_stack + 181060;
 Libderiv->deriv2_classes[8][5][118] = int_stack + 183436;
 Libderiv->deriv2_classes[8][6][118] = int_stack + 184381;
 Libderiv->deriv2_classes[8][7][118] = int_stack + 185641;
 Libderiv->deriv2_classes[8][8][118] = int_stack + 187261;
 Libderiv->deriv2_classes[8][9][118] = int_stack + 189286;
 Libderiv->deriv2_classes[8][10][118] = int_stack + 191761;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 194731;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 195172;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 195760;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 196516;
 Libderiv->deriv2_classes[5][9][117] = int_stack + 197461;
 Libderiv->deriv2_classes[5][10][117] = int_stack + 198616;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 200002;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 200590;
 Libderiv->deriv2_classes[6][7][117] = int_stack + 201374;
 Libderiv->deriv2_classes[6][8][117] = int_stack + 202382;
 Libderiv->deriv2_classes[6][9][117] = int_stack + 203642;
 Libderiv->deriv2_classes[6][10][117] = int_stack + 205182;
 Libderiv->deriv2_classes[7][5][117] = int_stack + 207030;
 Libderiv->deriv2_classes[7][6][117] = int_stack + 207786;
 Libderiv->deriv2_classes[7][7][117] = int_stack + 208794;
 Libderiv->deriv2_classes[7][8][117] = int_stack + 210090;
 Libderiv->deriv2_classes[7][9][117] = int_stack + 211710;
 Libderiv->deriv2_classes[7][10][117] = int_stack + 213690;
 Libderiv->deriv2_classes[8][5][117] = int_stack + 216066;
 Libderiv->deriv2_classes[8][6][117] = int_stack + 217011;
 Libderiv->deriv2_classes[8][7][117] = int_stack + 218271;
 Libderiv->deriv2_classes[8][8][117] = int_stack + 219891;
 Libderiv->deriv2_classes[8][9][117] = int_stack + 221916;
 Libderiv->deriv2_classes[8][10][117] = int_stack + 224391;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 227361;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 227802;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 228390;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 229146;
 Libderiv->deriv2_classes[5][9][107] = int_stack + 230091;
 Libderiv->deriv2_classes[5][10][107] = int_stack + 231246;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 232632;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 233220;
 Libderiv->deriv2_classes[6][7][107] = int_stack + 234004;
 Libderiv->deriv2_classes[6][8][107] = int_stack + 235012;
 Libderiv->deriv2_classes[6][9][107] = int_stack + 236272;
 Libderiv->deriv2_classes[6][10][107] = int_stack + 237812;
 Libderiv->deriv2_classes[7][5][107] = int_stack + 239660;
 Libderiv->deriv2_classes[7][6][107] = int_stack + 240416;
 Libderiv->deriv2_classes[7][7][107] = int_stack + 241424;
 Libderiv->deriv2_classes[7][8][107] = int_stack + 242720;
 Libderiv->deriv2_classes[7][9][107] = int_stack + 244340;
 Libderiv->deriv2_classes[7][10][107] = int_stack + 246320;
 Libderiv->deriv2_classes[8][5][107] = int_stack + 248696;
 Libderiv->deriv2_classes[8][6][107] = int_stack + 249641;
 Libderiv->deriv2_classes[8][7][107] = int_stack + 250901;
 Libderiv->deriv2_classes[8][8][107] = int_stack + 252521;
 Libderiv->deriv2_classes[8][9][107] = int_stack + 254546;
 Libderiv->deriv2_classes[8][10][107] = int_stack + 257021;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 259991;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 260432;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 261020;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 261776;
 Libderiv->deriv2_classes[5][9][106] = int_stack + 262721;
 Libderiv->deriv2_classes[5][10][106] = int_stack + 263876;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 265262;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 265850;
 Libderiv->deriv2_classes[6][7][106] = int_stack + 266634;
 Libderiv->deriv2_classes[6][8][106] = int_stack + 267642;
 Libderiv->deriv2_classes[6][9][106] = int_stack + 268902;
 Libderiv->deriv2_classes[6][10][106] = int_stack + 270442;
 Libderiv->deriv2_classes[7][5][106] = int_stack + 272290;
 Libderiv->deriv2_classes[7][6][106] = int_stack + 273046;
 Libderiv->deriv2_classes[7][7][106] = int_stack + 274054;
 Libderiv->deriv2_classes[7][8][106] = int_stack + 275350;
 Libderiv->deriv2_classes[7][9][106] = int_stack + 276970;
 Libderiv->deriv2_classes[7][10][106] = int_stack + 278950;
 Libderiv->deriv2_classes[8][5][106] = int_stack + 281326;
 Libderiv->deriv2_classes[8][6][106] = int_stack + 282271;
 Libderiv->deriv2_classes[8][7][106] = int_stack + 283531;
 Libderiv->deriv2_classes[8][8][106] = int_stack + 285151;
 Libderiv->deriv2_classes[8][9][106] = int_stack + 287176;
 Libderiv->deriv2_classes[8][10][106] = int_stack + 289651;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 292621;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 293062;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 293650;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 294406;
 Libderiv->deriv2_classes[5][9][105] = int_stack + 295351;
 Libderiv->deriv2_classes[5][10][105] = int_stack + 296506;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 297892;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 298480;
 Libderiv->deriv2_classes[6][7][105] = int_stack + 299264;
 Libderiv->deriv2_classes[6][8][105] = int_stack + 300272;
 Libderiv->deriv2_classes[6][9][105] = int_stack + 301532;
 Libderiv->deriv2_classes[6][10][105] = int_stack + 303072;
 Libderiv->deriv2_classes[7][5][105] = int_stack + 304920;
 Libderiv->deriv2_classes[7][6][105] = int_stack + 305676;
 Libderiv->deriv2_classes[7][7][105] = int_stack + 306684;
 Libderiv->deriv2_classes[7][8][105] = int_stack + 307980;
 Libderiv->deriv2_classes[7][9][105] = int_stack + 309600;
 Libderiv->deriv2_classes[7][10][105] = int_stack + 311580;
 Libderiv->deriv2_classes[8][5][105] = int_stack + 313956;
 Libderiv->deriv2_classes[8][6][105] = int_stack + 314901;
 Libderiv->deriv2_classes[8][7][105] = int_stack + 316161;
 Libderiv->deriv2_classes[8][8][105] = int_stack + 317781;
 Libderiv->deriv2_classes[8][9][105] = int_stack + 319806;
 Libderiv->deriv2_classes[8][10][105] = int_stack + 322281;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 325251;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 325692;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 326280;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 327036;
 Libderiv->deriv2_classes[5][9][104] = int_stack + 327981;
 Libderiv->deriv2_classes[5][10][104] = int_stack + 329136;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 330522;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 331110;
 Libderiv->deriv2_classes[6][7][104] = int_stack + 331894;
 Libderiv->deriv2_classes[6][8][104] = int_stack + 332902;
 Libderiv->deriv2_classes[6][9][104] = int_stack + 334162;
 Libderiv->deriv2_classes[6][10][104] = int_stack + 335702;
 Libderiv->deriv2_classes[7][5][104] = int_stack + 337550;
 Libderiv->deriv2_classes[7][6][104] = int_stack + 338306;
 Libderiv->deriv2_classes[7][7][104] = int_stack + 339314;
 Libderiv->deriv2_classes[7][8][104] = int_stack + 340610;
 Libderiv->deriv2_classes[7][9][104] = int_stack + 342230;
 Libderiv->deriv2_classes[7][10][104] = int_stack + 344210;
 Libderiv->deriv2_classes[8][5][104] = int_stack + 346586;
 Libderiv->deriv2_classes[8][6][104] = int_stack + 347531;
 Libderiv->deriv2_classes[8][7][104] = int_stack + 348791;
 Libderiv->deriv2_classes[8][8][104] = int_stack + 350411;
 Libderiv->deriv2_classes[8][9][104] = int_stack + 352436;
 Libderiv->deriv2_classes[8][10][104] = int_stack + 354911;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 357881;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 358322;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 358910;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 359666;
 Libderiv->deriv2_classes[5][9][95] = int_stack + 360611;
 Libderiv->deriv2_classes[5][10][95] = int_stack + 361766;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 363152;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 363740;
 Libderiv->deriv2_classes[6][7][95] = int_stack + 364524;
 Libderiv->deriv2_classes[6][8][95] = int_stack + 365532;
 Libderiv->deriv2_classes[6][9][95] = int_stack + 366792;
 Libderiv->deriv2_classes[6][10][95] = int_stack + 368332;
 Libderiv->deriv2_classes[7][5][95] = int_stack + 370180;
 Libderiv->deriv2_classes[7][6][95] = int_stack + 370936;
 Libderiv->deriv2_classes[7][7][95] = int_stack + 371944;
 Libderiv->deriv2_classes[7][8][95] = int_stack + 373240;
 Libderiv->deriv2_classes[7][9][95] = int_stack + 374860;
 Libderiv->deriv2_classes[7][10][95] = int_stack + 376840;
 Libderiv->deriv2_classes[8][5][95] = int_stack + 379216;
 Libderiv->deriv2_classes[8][6][95] = int_stack + 380161;
 Libderiv->deriv2_classes[8][7][95] = int_stack + 381421;
 Libderiv->deriv2_classes[8][8][95] = int_stack + 383041;
 Libderiv->deriv2_classes[8][9][95] = int_stack + 385066;
 Libderiv->deriv2_classes[8][10][95] = int_stack + 387541;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 390511;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 390952;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 391540;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 392296;
 Libderiv->deriv2_classes[5][9][94] = int_stack + 393241;
 Libderiv->deriv2_classes[5][10][94] = int_stack + 394396;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 395782;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 396370;
 Libderiv->deriv2_classes[6][7][94] = int_stack + 397154;
 Libderiv->deriv2_classes[6][8][94] = int_stack + 398162;
 Libderiv->deriv2_classes[6][9][94] = int_stack + 399422;
 Libderiv->deriv2_classes[6][10][94] = int_stack + 400962;
 Libderiv->deriv2_classes[7][5][94] = int_stack + 402810;
 Libderiv->deriv2_classes[7][6][94] = int_stack + 403566;
 Libderiv->deriv2_classes[7][7][94] = int_stack + 404574;
 Libderiv->deriv2_classes[7][8][94] = int_stack + 405870;
 Libderiv->deriv2_classes[7][9][94] = int_stack + 407490;
 Libderiv->deriv2_classes[7][10][94] = int_stack + 409470;
 Libderiv->deriv2_classes[8][5][94] = int_stack + 411846;
 Libderiv->deriv2_classes[8][6][94] = int_stack + 412791;
 Libderiv->deriv2_classes[8][7][94] = int_stack + 414051;
 Libderiv->deriv2_classes[8][8][94] = int_stack + 415671;
 Libderiv->deriv2_classes[8][9][94] = int_stack + 417696;
 Libderiv->deriv2_classes[8][10][94] = int_stack + 420171;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 423141;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 423582;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 424170;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 424926;
 Libderiv->deriv2_classes[5][9][93] = int_stack + 425871;
 Libderiv->deriv2_classes[5][10][93] = int_stack + 427026;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 428412;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 429000;
 Libderiv->deriv2_classes[6][7][93] = int_stack + 429784;
 Libderiv->deriv2_classes[6][8][93] = int_stack + 430792;
 Libderiv->deriv2_classes[6][9][93] = int_stack + 432052;
 Libderiv->deriv2_classes[6][10][93] = int_stack + 433592;
 Libderiv->deriv2_classes[7][5][93] = int_stack + 435440;
 Libderiv->deriv2_classes[7][6][93] = int_stack + 436196;
 Libderiv->deriv2_classes[7][7][93] = int_stack + 437204;
 Libderiv->deriv2_classes[7][8][93] = int_stack + 438500;
 Libderiv->deriv2_classes[7][9][93] = int_stack + 440120;
 Libderiv->deriv2_classes[7][10][93] = int_stack + 442100;
 Libderiv->deriv2_classes[8][5][93] = int_stack + 444476;
 Libderiv->deriv2_classes[8][6][93] = int_stack + 445421;
 Libderiv->deriv2_classes[8][7][93] = int_stack + 446681;
 Libderiv->deriv2_classes[8][8][93] = int_stack + 448301;
 Libderiv->deriv2_classes[8][9][93] = int_stack + 450326;
 Libderiv->deriv2_classes[8][10][93] = int_stack + 452801;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 455771;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 456212;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 456800;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 457556;
 Libderiv->deriv2_classes[5][9][92] = int_stack + 458501;
 Libderiv->deriv2_classes[5][10][92] = int_stack + 459656;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 461042;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 461630;
 Libderiv->deriv2_classes[6][7][92] = int_stack + 462414;
 Libderiv->deriv2_classes[6][8][92] = int_stack + 463422;
 Libderiv->deriv2_classes[6][9][92] = int_stack + 464682;
 Libderiv->deriv2_classes[6][10][92] = int_stack + 466222;
 Libderiv->deriv2_classes[7][5][92] = int_stack + 468070;
 Libderiv->deriv2_classes[7][6][92] = int_stack + 468826;
 Libderiv->deriv2_classes[7][7][92] = int_stack + 469834;
 Libderiv->deriv2_classes[7][8][92] = int_stack + 471130;
 Libderiv->deriv2_classes[7][9][92] = int_stack + 472750;
 Libderiv->deriv2_classes[7][10][92] = int_stack + 474730;
 Libderiv->deriv2_classes[8][5][92] = int_stack + 477106;
 Libderiv->deriv2_classes[8][6][92] = int_stack + 478051;
 Libderiv->deriv2_classes[8][7][92] = int_stack + 479311;
 Libderiv->deriv2_classes[8][8][92] = int_stack + 480931;
 Libderiv->deriv2_classes[8][9][92] = int_stack + 482956;
 Libderiv->deriv2_classes[8][10][92] = int_stack + 485431;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 488401;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 488842;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 489430;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 490186;
 Libderiv->deriv2_classes[5][9][91] = int_stack + 491131;
 Libderiv->deriv2_classes[5][10][91] = int_stack + 492286;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 493672;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 494260;
 Libderiv->deriv2_classes[6][7][91] = int_stack + 495044;
 Libderiv->deriv2_classes[6][8][91] = int_stack + 496052;
 Libderiv->deriv2_classes[6][9][91] = int_stack + 497312;
 Libderiv->deriv2_classes[6][10][91] = int_stack + 498852;
 Libderiv->deriv2_classes[7][5][91] = int_stack + 500700;
 Libderiv->deriv2_classes[7][6][91] = int_stack + 501456;
 Libderiv->deriv2_classes[7][7][91] = int_stack + 502464;
 Libderiv->deriv2_classes[7][8][91] = int_stack + 503760;
 Libderiv->deriv2_classes[7][9][91] = int_stack + 505380;
 Libderiv->deriv2_classes[7][10][91] = int_stack + 507360;
 Libderiv->deriv2_classes[8][5][91] = int_stack + 509736;
 Libderiv->deriv2_classes[8][6][91] = int_stack + 510681;
 Libderiv->deriv2_classes[8][7][91] = int_stack + 511941;
 Libderiv->deriv2_classes[8][8][91] = int_stack + 513561;
 Libderiv->deriv2_classes[8][9][91] = int_stack + 515586;
 Libderiv->deriv2_classes[8][10][91] = int_stack + 518061;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 521031;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 521472;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 522060;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 522816;
 Libderiv->deriv2_classes[5][9][83] = int_stack + 523761;
 Libderiv->deriv2_classes[5][10][83] = int_stack + 524916;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 526302;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 526890;
 Libderiv->deriv2_classes[6][7][83] = int_stack + 527674;
 Libderiv->deriv2_classes[6][8][83] = int_stack + 528682;
 Libderiv->deriv2_classes[6][9][83] = int_stack + 529942;
 Libderiv->deriv2_classes[6][10][83] = int_stack + 531482;
 Libderiv->deriv2_classes[7][5][83] = int_stack + 533330;
 Libderiv->deriv2_classes[7][6][83] = int_stack + 534086;
 Libderiv->deriv2_classes[7][7][83] = int_stack + 535094;
 Libderiv->deriv2_classes[7][8][83] = int_stack + 536390;
 Libderiv->deriv2_classes[7][9][83] = int_stack + 538010;
 Libderiv->deriv2_classes[7][10][83] = int_stack + 539990;
 Libderiv->deriv_classes[8][5][11] = int_stack + 542366;
 Libderiv->deriv2_classes[8][5][83] = int_stack + 543311;
 Libderiv->deriv_classes[8][6][11] = int_stack + 544256;
 Libderiv->deriv2_classes[8][6][83] = int_stack + 545516;
 Libderiv->deriv_classes[8][7][11] = int_stack + 546776;
 Libderiv->deriv2_classes[8][7][83] = int_stack + 548396;
 Libderiv->deriv_classes[8][8][11] = int_stack + 550016;
 Libderiv->deriv2_classes[8][8][83] = int_stack + 552041;
 Libderiv->deriv_classes[8][9][11] = int_stack + 554066;
 Libderiv->deriv2_classes[8][9][83] = int_stack + 556541;
 Libderiv->deriv2_classes[8][10][83] = int_stack + 559016;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 561986;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 562427;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 563015;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 563771;
 Libderiv->deriv2_classes[5][9][82] = int_stack + 564716;
 Libderiv->deriv2_classes[5][10][82] = int_stack + 565871;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 567257;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 567845;
 Libderiv->deriv2_classes[6][7][82] = int_stack + 568629;
 Libderiv->deriv2_classes[6][8][82] = int_stack + 569637;
 Libderiv->deriv2_classes[6][9][82] = int_stack + 570897;
 Libderiv->deriv2_classes[6][10][82] = int_stack + 572437;
 Libderiv->deriv2_classes[7][5][82] = int_stack + 574285;
 Libderiv->deriv2_classes[7][6][82] = int_stack + 575041;
 Libderiv->deriv2_classes[7][7][82] = int_stack + 576049;
 Libderiv->deriv2_classes[7][8][82] = int_stack + 577345;
 Libderiv->deriv2_classes[7][9][82] = int_stack + 578965;
 Libderiv->deriv2_classes[7][10][82] = int_stack + 580945;
 Libderiv->deriv_classes[8][5][10] = int_stack + 583321;
 Libderiv->deriv2_classes[8][5][82] = int_stack + 584266;
 Libderiv->deriv_classes[8][6][10] = int_stack + 585211;
 Libderiv->deriv2_classes[8][6][82] = int_stack + 586471;
 Libderiv->deriv_classes[8][7][10] = int_stack + 587731;
 Libderiv->deriv2_classes[8][7][82] = int_stack + 589351;
 Libderiv->deriv_classes[8][8][10] = int_stack + 590971;
 Libderiv->deriv2_classes[8][8][82] = int_stack + 592996;
 Libderiv->deriv_classes[8][9][10] = int_stack + 595021;
 Libderiv->deriv2_classes[8][9][82] = int_stack + 597496;
 Libderiv->deriv2_classes[8][10][82] = int_stack + 599971;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 602941;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 603382;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 603970;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 604726;
 Libderiv->deriv2_classes[5][9][81] = int_stack + 605671;
 Libderiv->deriv2_classes[5][10][81] = int_stack + 606826;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 608212;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 608800;
 Libderiv->deriv2_classes[6][7][81] = int_stack + 609584;
 Libderiv->deriv2_classes[6][8][81] = int_stack + 610592;
 Libderiv->deriv2_classes[6][9][81] = int_stack + 611852;
 Libderiv->deriv2_classes[6][10][81] = int_stack + 613392;
 Libderiv->deriv2_classes[7][5][81] = int_stack + 615240;
 Libderiv->deriv2_classes[7][6][81] = int_stack + 615996;
 Libderiv->deriv2_classes[7][7][81] = int_stack + 617004;
 Libderiv->deriv2_classes[7][8][81] = int_stack + 618300;
 Libderiv->deriv2_classes[7][9][81] = int_stack + 619920;
 Libderiv->deriv2_classes[7][10][81] = int_stack + 621900;
 Libderiv->deriv_classes[8][5][9] = int_stack + 624276;
 Libderiv->deriv2_classes[8][5][81] = int_stack + 625221;
 Libderiv->deriv_classes[8][6][9] = int_stack + 626166;
 Libderiv->deriv2_classes[8][6][81] = int_stack + 627426;
 Libderiv->deriv_classes[8][7][9] = int_stack + 628686;
 Libderiv->deriv2_classes[8][7][81] = int_stack + 630306;
 Libderiv->deriv_classes[8][8][9] = int_stack + 631926;
 Libderiv->deriv2_classes[8][8][81] = int_stack + 633951;
 Libderiv->deriv_classes[8][9][9] = int_stack + 635976;
 Libderiv->deriv2_classes[8][9][81] = int_stack + 638451;
 Libderiv->deriv2_classes[8][10][81] = int_stack + 640926;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 643896;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 644337;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 644925;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 645681;
 Libderiv->deriv2_classes[5][9][80] = int_stack + 646626;
 Libderiv->deriv2_classes[5][10][80] = int_stack + 647781;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 649167;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 649755;
 Libderiv->deriv2_classes[6][7][80] = int_stack + 650539;
 Libderiv->deriv2_classes[6][8][80] = int_stack + 651547;
 Libderiv->deriv2_classes[6][9][80] = int_stack + 652807;
 Libderiv->deriv2_classes[6][10][80] = int_stack + 654347;
 Libderiv->deriv2_classes[7][5][80] = int_stack + 656195;
 Libderiv->deriv2_classes[7][6][80] = int_stack + 656951;
 Libderiv->deriv2_classes[7][7][80] = int_stack + 657959;
 Libderiv->deriv2_classes[7][8][80] = int_stack + 659255;
 Libderiv->deriv2_classes[7][9][80] = int_stack + 660875;
 Libderiv->deriv2_classes[7][10][80] = int_stack + 662855;
 Libderiv->deriv_classes[8][5][8] = int_stack + 665231;
 Libderiv->deriv2_classes[8][5][80] = int_stack + 666176;
 Libderiv->deriv_classes[8][6][8] = int_stack + 667121;
 Libderiv->deriv2_classes[8][6][80] = int_stack + 668381;
 Libderiv->deriv_classes[8][7][8] = int_stack + 669641;
 Libderiv->deriv2_classes[8][7][80] = int_stack + 671261;
 Libderiv->deriv_classes[8][8][8] = int_stack + 672881;
 Libderiv->deriv2_classes[8][8][80] = int_stack + 674906;
 Libderiv->deriv_classes[8][9][8] = int_stack + 676931;
 Libderiv->deriv2_classes[8][9][80] = int_stack + 679406;
 Libderiv->deriv2_classes[8][10][80] = int_stack + 681881;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 684851;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 685292;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 685880;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 686636;
 Libderiv->deriv2_classes[5][9][79] = int_stack + 687581;
 Libderiv->deriv2_classes[5][10][79] = int_stack + 688736;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 690122;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 690710;
 Libderiv->deriv2_classes[6][7][79] = int_stack + 691494;
 Libderiv->deriv2_classes[6][8][79] = int_stack + 692502;
 Libderiv->deriv2_classes[6][9][79] = int_stack + 693762;
 Libderiv->deriv2_classes[6][10][79] = int_stack + 695302;
 Libderiv->deriv2_classes[7][5][79] = int_stack + 697150;
 Libderiv->deriv2_classes[7][6][79] = int_stack + 697906;
 Libderiv->deriv2_classes[7][7][79] = int_stack + 698914;
 Libderiv->deriv2_classes[7][8][79] = int_stack + 700210;
 Libderiv->deriv2_classes[7][9][79] = int_stack + 701830;
 Libderiv->deriv2_classes[7][10][79] = int_stack + 703810;
 Libderiv->deriv_classes[8][5][7] = int_stack + 706186;
 Libderiv->deriv2_classes[8][5][79] = int_stack + 707131;
 Libderiv->deriv_classes[8][6][7] = int_stack + 708076;
 Libderiv->deriv2_classes[8][6][79] = int_stack + 709336;
 Libderiv->deriv_classes[8][7][7] = int_stack + 710596;
 Libderiv->deriv2_classes[8][7][79] = int_stack + 712216;
 Libderiv->deriv_classes[8][8][7] = int_stack + 713836;
 Libderiv->deriv2_classes[8][8][79] = int_stack + 715861;
 Libderiv->deriv_classes[8][9][7] = int_stack + 717886;
 Libderiv->deriv2_classes[8][9][79] = int_stack + 720361;
 Libderiv->deriv2_classes[8][10][79] = int_stack + 722836;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 725806;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 726247;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 726835;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 727591;
 Libderiv->deriv2_classes[5][9][78] = int_stack + 728536;
 Libderiv->deriv2_classes[5][10][78] = int_stack + 729691;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 731077;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 731665;
 Libderiv->deriv2_classes[6][7][78] = int_stack + 732449;
 Libderiv->deriv2_classes[6][8][78] = int_stack + 733457;
 Libderiv->deriv2_classes[6][9][78] = int_stack + 734717;
 Libderiv->deriv2_classes[6][10][78] = int_stack + 736257;
 Libderiv->deriv2_classes[7][5][78] = int_stack + 738105;
 Libderiv->deriv2_classes[7][6][78] = int_stack + 738861;
 Libderiv->deriv2_classes[7][7][78] = int_stack + 739869;
 Libderiv->deriv2_classes[7][8][78] = int_stack + 741165;
 Libderiv->deriv2_classes[7][9][78] = int_stack + 742785;
 Libderiv->deriv2_classes[7][10][78] = int_stack + 744765;
 Libderiv->dvrr_classes[8][5] = int_stack + 747141;
 Libderiv->deriv_classes[8][5][6] = int_stack + 748086;
 Libderiv->deriv2_classes[8][5][78] = int_stack + 749031;
 Libderiv->dvrr_classes[8][6] = int_stack + 749976;
 Libderiv->deriv_classes[8][6][6] = int_stack + 751236;
 Libderiv->deriv2_classes[8][6][78] = int_stack + 752496;
 Libderiv->dvrr_classes[8][7] = int_stack + 753756;
 Libderiv->deriv_classes[8][7][6] = int_stack + 755376;
 Libderiv->deriv2_classes[8][7][78] = int_stack + 756996;
 Libderiv->dvrr_classes[8][8] = int_stack + 758616;
 Libderiv->deriv_classes[8][8][6] = int_stack + 760641;
 Libderiv->deriv2_classes[8][8][78] = int_stack + 762666;
 Libderiv->deriv_classes[8][9][6] = int_stack + 764691;
 Libderiv->deriv2_classes[8][9][78] = int_stack + 767166;
 Libderiv->deriv2_classes[8][10][78] = int_stack + 769641;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 772611;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 773052;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 773640;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 774396;
 Libderiv->deriv2_classes[5][9][35] = int_stack + 775341;
 Libderiv->deriv2_classes[5][10][35] = int_stack + 776496;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 777882;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 778470;
 Libderiv->deriv2_classes[6][7][35] = int_stack + 779254;
 Libderiv->deriv2_classes[6][8][35] = int_stack + 780262;
 Libderiv->deriv2_classes[6][9][35] = int_stack + 781522;
 Libderiv->deriv2_classes[6][10][35] = int_stack + 783062;
 Libderiv->deriv2_classes[7][5][35] = int_stack + 784910;
 Libderiv->deriv2_classes[7][6][35] = int_stack + 785666;
 Libderiv->deriv2_classes[7][7][35] = int_stack + 786674;
 Libderiv->deriv2_classes[7][8][35] = int_stack + 787970;
 Libderiv->deriv2_classes[7][9][35] = int_stack + 789590;
 Libderiv->deriv2_classes[7][10][35] = int_stack + 791570;
 Libderiv->deriv2_classes[8][5][35] = int_stack + 793946;
 Libderiv->deriv2_classes[8][6][35] = int_stack + 794891;
 Libderiv->deriv2_classes[8][7][35] = int_stack + 796151;
 Libderiv->deriv2_classes[8][8][35] = int_stack + 797771;
 Libderiv->deriv2_classes[8][9][35] = int_stack + 799796;
 Libderiv->deriv2_classes[8][10][35] = int_stack + 802271;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 805241;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 805682;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 806270;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 807026;
 Libderiv->deriv2_classes[5][9][34] = int_stack + 807971;
 Libderiv->deriv2_classes[5][10][34] = int_stack + 809126;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 810512;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 811100;
 Libderiv->deriv2_classes[6][7][34] = int_stack + 811884;
 Libderiv->deriv2_classes[6][8][34] = int_stack + 812892;
 Libderiv->deriv2_classes[6][9][34] = int_stack + 814152;
 Libderiv->deriv2_classes[6][10][34] = int_stack + 815692;
 Libderiv->deriv2_classes[7][5][34] = int_stack + 817540;
 Libderiv->deriv2_classes[7][6][34] = int_stack + 818296;
 Libderiv->deriv2_classes[7][7][34] = int_stack + 819304;
 Libderiv->deriv2_classes[7][8][34] = int_stack + 820600;
 Libderiv->deriv2_classes[7][9][34] = int_stack + 822220;
 Libderiv->deriv2_classes[7][10][34] = int_stack + 824200;
 Libderiv->deriv2_classes[8][5][34] = int_stack + 826576;
 Libderiv->deriv2_classes[8][6][34] = int_stack + 827521;
 Libderiv->deriv2_classes[8][7][34] = int_stack + 828781;
 Libderiv->deriv2_classes[8][8][34] = int_stack + 830401;
 Libderiv->deriv2_classes[8][9][34] = int_stack + 832426;
 Libderiv->deriv2_classes[8][10][34] = int_stack + 834901;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 837871;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 838312;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 838900;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 839656;
 Libderiv->deriv2_classes[5][9][33] = int_stack + 840601;
 Libderiv->deriv2_classes[5][10][33] = int_stack + 841756;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 843142;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 843730;
 Libderiv->deriv2_classes[6][7][33] = int_stack + 844514;
 Libderiv->deriv2_classes[6][8][33] = int_stack + 845522;
 Libderiv->deriv2_classes[6][9][33] = int_stack + 846782;
 Libderiv->deriv2_classes[6][10][33] = int_stack + 848322;
 Libderiv->deriv2_classes[7][5][33] = int_stack + 850170;
 Libderiv->deriv2_classes[7][6][33] = int_stack + 850926;
 Libderiv->deriv2_classes[7][7][33] = int_stack + 851934;
 Libderiv->deriv2_classes[7][8][33] = int_stack + 853230;
 Libderiv->deriv2_classes[7][9][33] = int_stack + 854850;
 Libderiv->deriv2_classes[7][10][33] = int_stack + 856830;
 Libderiv->deriv2_classes[8][5][33] = int_stack + 859206;
 Libderiv->deriv2_classes[8][6][33] = int_stack + 860151;
 Libderiv->deriv2_classes[8][7][33] = int_stack + 861411;
 Libderiv->deriv2_classes[8][8][33] = int_stack + 863031;
 Libderiv->deriv2_classes[8][9][33] = int_stack + 865056;
 Libderiv->deriv2_classes[8][10][33] = int_stack + 867531;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 870501;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 870942;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 871530;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 872286;
 Libderiv->deriv2_classes[5][9][32] = int_stack + 873231;
 Libderiv->deriv2_classes[5][10][32] = int_stack + 874386;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 875772;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 876360;
 Libderiv->deriv2_classes[6][7][32] = int_stack + 877144;
 Libderiv->deriv2_classes[6][8][32] = int_stack + 878152;
 Libderiv->deriv2_classes[6][9][32] = int_stack + 879412;
 Libderiv->deriv2_classes[6][10][32] = int_stack + 880952;
 Libderiv->deriv2_classes[7][5][32] = int_stack + 882800;
 Libderiv->deriv2_classes[7][6][32] = int_stack + 883556;
 Libderiv->deriv2_classes[7][7][32] = int_stack + 884564;
 Libderiv->deriv2_classes[7][8][32] = int_stack + 885860;
 Libderiv->deriv2_classes[7][9][32] = int_stack + 887480;
 Libderiv->deriv2_classes[7][10][32] = int_stack + 889460;
 Libderiv->deriv2_classes[8][5][32] = int_stack + 891836;
 Libderiv->deriv2_classes[8][6][32] = int_stack + 892781;
 Libderiv->deriv2_classes[8][7][32] = int_stack + 894041;
 Libderiv->deriv2_classes[8][8][32] = int_stack + 895661;
 Libderiv->deriv2_classes[8][9][32] = int_stack + 897686;
 Libderiv->deriv2_classes[8][10][32] = int_stack + 900161;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 903131;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 903572;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 904160;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 904916;
 Libderiv->deriv2_classes[5][9][31] = int_stack + 905861;
 Libderiv->deriv2_classes[5][10][31] = int_stack + 907016;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 908402;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 908990;
 Libderiv->deriv2_classes[6][7][31] = int_stack + 909774;
 Libderiv->deriv2_classes[6][8][31] = int_stack + 910782;
 Libderiv->deriv2_classes[6][9][31] = int_stack + 912042;
 Libderiv->deriv2_classes[6][10][31] = int_stack + 913582;
 Libderiv->deriv2_classes[7][5][31] = int_stack + 915430;
 Libderiv->deriv2_classes[7][6][31] = int_stack + 916186;
 Libderiv->deriv2_classes[7][7][31] = int_stack + 917194;
 Libderiv->deriv2_classes[7][8][31] = int_stack + 918490;
 Libderiv->deriv2_classes[7][9][31] = int_stack + 920110;
 Libderiv->deriv2_classes[7][10][31] = int_stack + 922090;
 Libderiv->deriv2_classes[8][5][31] = int_stack + 924466;
 Libderiv->deriv2_classes[8][6][31] = int_stack + 925411;
 Libderiv->deriv2_classes[8][7][31] = int_stack + 926671;
 Libderiv->deriv2_classes[8][8][31] = int_stack + 928291;
 Libderiv->deriv2_classes[8][9][31] = int_stack + 930316;
 Libderiv->deriv2_classes[8][10][31] = int_stack + 932791;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 935761;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 936202;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 936790;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 937546;
 Libderiv->deriv2_classes[5][9][30] = int_stack + 938491;
 Libderiv->deriv2_classes[5][10][30] = int_stack + 939646;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 941032;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 941620;
 Libderiv->deriv2_classes[6][7][30] = int_stack + 942404;
 Libderiv->deriv2_classes[6][8][30] = int_stack + 943412;
 Libderiv->deriv2_classes[6][9][30] = int_stack + 944672;
 Libderiv->deriv2_classes[6][10][30] = int_stack + 946212;
 Libderiv->deriv2_classes[7][5][30] = int_stack + 948060;
 Libderiv->deriv2_classes[7][6][30] = int_stack + 948816;
 Libderiv->deriv2_classes[7][7][30] = int_stack + 949824;
 Libderiv->deriv2_classes[7][8][30] = int_stack + 951120;
 Libderiv->deriv2_classes[7][9][30] = int_stack + 952740;
 Libderiv->deriv2_classes[7][10][30] = int_stack + 954720;
 Libderiv->deriv_classes[8][5][2] = int_stack + 957096;
 Libderiv->deriv2_classes[8][5][30] = int_stack + 958041;
 Libderiv->deriv_classes[8][6][2] = int_stack + 958986;
 Libderiv->deriv2_classes[8][6][30] = int_stack + 960246;
 Libderiv->deriv_classes[8][7][2] = int_stack + 961506;
 Libderiv->deriv2_classes[8][7][30] = int_stack + 963126;
 Libderiv->deriv_classes[8][8][2] = int_stack + 964746;
 Libderiv->deriv2_classes[8][8][30] = int_stack + 966771;
 Libderiv->deriv_classes[8][9][2] = int_stack + 968796;
 Libderiv->deriv2_classes[8][9][30] = int_stack + 971271;
 Libderiv->deriv2_classes[8][10][30] = int_stack + 973746;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 976716;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 977157;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 977745;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 978501;
 Libderiv->deriv2_classes[5][9][26] = int_stack + 979446;
 Libderiv->deriv2_classes[5][10][26] = int_stack + 980601;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 981987;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 982575;
 Libderiv->deriv2_classes[6][7][26] = int_stack + 983359;
 Libderiv->deriv2_classes[6][8][26] = int_stack + 984367;
 Libderiv->deriv2_classes[6][9][26] = int_stack + 985627;
 Libderiv->deriv2_classes[6][10][26] = int_stack + 987167;
 Libderiv->deriv2_classes[7][5][26] = int_stack + 989015;
 Libderiv->deriv2_classes[7][6][26] = int_stack + 989771;
 Libderiv->deriv2_classes[7][7][26] = int_stack + 990779;
 Libderiv->deriv2_classes[7][8][26] = int_stack + 992075;
 Libderiv->deriv2_classes[7][9][26] = int_stack + 993695;
 Libderiv->deriv2_classes[7][10][26] = int_stack + 995675;
 Libderiv->deriv2_classes[8][5][26] = int_stack + 998051;
 Libderiv->deriv2_classes[8][6][26] = int_stack + 998996;
 Libderiv->deriv2_classes[8][7][26] = int_stack + 1000256;
 Libderiv->deriv2_classes[8][8][26] = int_stack + 1001876;
 Libderiv->deriv2_classes[8][9][26] = int_stack + 1003901;
 Libderiv->deriv2_classes[8][10][26] = int_stack + 1006376;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 1009346;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 1009787;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 1010375;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 1011131;
 Libderiv->deriv2_classes[5][9][23] = int_stack + 1012076;
 Libderiv->deriv2_classes[5][10][23] = int_stack + 1013231;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 1014617;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 1015205;
 Libderiv->deriv2_classes[6][7][23] = int_stack + 1015989;
 Libderiv->deriv2_classes[6][8][23] = int_stack + 1016997;
 Libderiv->deriv2_classes[6][9][23] = int_stack + 1018257;
 Libderiv->deriv2_classes[6][10][23] = int_stack + 1019797;
 Libderiv->deriv2_classes[7][5][23] = int_stack + 1021645;
 Libderiv->deriv2_classes[7][6][23] = int_stack + 1022401;
 Libderiv->deriv2_classes[7][7][23] = int_stack + 1023409;
 Libderiv->deriv2_classes[7][8][23] = int_stack + 1024705;
 Libderiv->deriv2_classes[7][9][23] = int_stack + 1026325;
 Libderiv->deriv2_classes[7][10][23] = int_stack + 1028305;
 Libderiv->deriv2_classes[8][5][23] = int_stack + 1030681;
 Libderiv->deriv2_classes[8][6][23] = int_stack + 1031626;
 Libderiv->deriv2_classes[8][7][23] = int_stack + 1032886;
 Libderiv->deriv2_classes[8][8][23] = int_stack + 1034506;
 Libderiv->deriv2_classes[8][9][23] = int_stack + 1036531;
 Libderiv->deriv2_classes[8][10][23] = int_stack + 1039006;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 1041976;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 1042417;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 1043005;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 1043761;
 Libderiv->deriv2_classes[5][9][22] = int_stack + 1044706;
 Libderiv->deriv2_classes[5][10][22] = int_stack + 1045861;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 1047247;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 1047835;
 Libderiv->deriv2_classes[6][7][22] = int_stack + 1048619;
 Libderiv->deriv2_classes[6][8][22] = int_stack + 1049627;
 Libderiv->deriv2_classes[6][9][22] = int_stack + 1050887;
 Libderiv->deriv2_classes[6][10][22] = int_stack + 1052427;
 Libderiv->deriv2_classes[7][5][22] = int_stack + 1054275;
 Libderiv->deriv2_classes[7][6][22] = int_stack + 1055031;
 Libderiv->deriv2_classes[7][7][22] = int_stack + 1056039;
 Libderiv->deriv2_classes[7][8][22] = int_stack + 1057335;
 Libderiv->deriv2_classes[7][9][22] = int_stack + 1058955;
 Libderiv->deriv2_classes[7][10][22] = int_stack + 1060935;
 Libderiv->deriv2_classes[8][5][22] = int_stack + 1063311;
 Libderiv->deriv2_classes[8][6][22] = int_stack + 1064256;
 Libderiv->deriv2_classes[8][7][22] = int_stack + 1065516;
 Libderiv->deriv2_classes[8][8][22] = int_stack + 1067136;
 Libderiv->deriv2_classes[8][9][22] = int_stack + 1069161;
 Libderiv->deriv2_classes[8][10][22] = int_stack + 1071636;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 1074606;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 1075047;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 1075635;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 1076391;
 Libderiv->deriv2_classes[5][9][21] = int_stack + 1077336;
 Libderiv->deriv2_classes[5][10][21] = int_stack + 1078491;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 1079877;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 1080465;
 Libderiv->deriv2_classes[6][7][21] = int_stack + 1081249;
 Libderiv->deriv2_classes[6][8][21] = int_stack + 1082257;
 Libderiv->deriv2_classes[6][9][21] = int_stack + 1083517;
 Libderiv->deriv2_classes[6][10][21] = int_stack + 1085057;
 Libderiv->deriv2_classes[7][5][21] = int_stack + 1086905;
 Libderiv->deriv2_classes[7][6][21] = int_stack + 1087661;
 Libderiv->deriv2_classes[7][7][21] = int_stack + 1088669;
 Libderiv->deriv2_classes[7][8][21] = int_stack + 1089965;
 Libderiv->deriv2_classes[7][9][21] = int_stack + 1091585;
 Libderiv->deriv2_classes[7][10][21] = int_stack + 1093565;
 Libderiv->deriv2_classes[8][5][21] = int_stack + 1095941;
 Libderiv->deriv2_classes[8][6][21] = int_stack + 1096886;
 Libderiv->deriv2_classes[8][7][21] = int_stack + 1098146;
 Libderiv->deriv2_classes[8][8][21] = int_stack + 1099766;
 Libderiv->deriv2_classes[8][9][21] = int_stack + 1101791;
 Libderiv->deriv2_classes[8][10][21] = int_stack + 1104266;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 1107236;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 1107677;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 1108265;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 1109021;
 Libderiv->deriv2_classes[5][9][20] = int_stack + 1109966;
 Libderiv->deriv2_classes[5][10][20] = int_stack + 1111121;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 1112507;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 1113095;
 Libderiv->deriv2_classes[6][7][20] = int_stack + 1113879;
 Libderiv->deriv2_classes[6][8][20] = int_stack + 1114887;
 Libderiv->deriv2_classes[6][9][20] = int_stack + 1116147;
 Libderiv->deriv2_classes[6][10][20] = int_stack + 1117687;
 Libderiv->deriv2_classes[7][5][20] = int_stack + 1119535;
 Libderiv->deriv2_classes[7][6][20] = int_stack + 1120291;
 Libderiv->deriv2_classes[7][7][20] = int_stack + 1121299;
 Libderiv->deriv2_classes[7][8][20] = int_stack + 1122595;
 Libderiv->deriv2_classes[7][9][20] = int_stack + 1124215;
 Libderiv->deriv2_classes[7][10][20] = int_stack + 1126195;
 Libderiv->deriv2_classes[8][5][20] = int_stack + 1128571;
 Libderiv->deriv2_classes[8][6][20] = int_stack + 1129516;
 Libderiv->deriv2_classes[8][7][20] = int_stack + 1130776;
 Libderiv->deriv2_classes[8][8][20] = int_stack + 1132396;
 Libderiv->deriv2_classes[8][9][20] = int_stack + 1134421;
 Libderiv->deriv2_classes[8][10][20] = int_stack + 1136896;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 1139866;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 1140307;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 1140895;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 1141651;
 Libderiv->deriv2_classes[5][9][19] = int_stack + 1142596;
 Libderiv->deriv2_classes[5][10][19] = int_stack + 1143751;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 1145137;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 1145725;
 Libderiv->deriv2_classes[6][7][19] = int_stack + 1146509;
 Libderiv->deriv2_classes[6][8][19] = int_stack + 1147517;
 Libderiv->deriv2_classes[6][9][19] = int_stack + 1148777;
 Libderiv->deriv2_classes[6][10][19] = int_stack + 1150317;
 Libderiv->deriv2_classes[7][5][19] = int_stack + 1152165;
 Libderiv->deriv2_classes[7][6][19] = int_stack + 1152921;
 Libderiv->deriv2_classes[7][7][19] = int_stack + 1153929;
 Libderiv->deriv2_classes[7][8][19] = int_stack + 1155225;
 Libderiv->deriv2_classes[7][9][19] = int_stack + 1156845;
 Libderiv->deriv2_classes[7][10][19] = int_stack + 1158825;
 Libderiv->deriv2_classes[8][5][19] = int_stack + 1161201;
 Libderiv->deriv2_classes[8][6][19] = int_stack + 1162146;
 Libderiv->deriv2_classes[8][7][19] = int_stack + 1163406;
 Libderiv->deriv2_classes[8][8][19] = int_stack + 1165026;
 Libderiv->deriv2_classes[8][9][19] = int_stack + 1167051;
 Libderiv->deriv2_classes[8][10][19] = int_stack + 1169526;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 1172496;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 1172937;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 1173525;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 1174281;
 Libderiv->deriv2_classes[5][9][18] = int_stack + 1175226;
 Libderiv->deriv2_classes[5][10][18] = int_stack + 1176381;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 1177767;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 1178355;
 Libderiv->deriv2_classes[6][7][18] = int_stack + 1179139;
 Libderiv->deriv2_classes[6][8][18] = int_stack + 1180147;
 Libderiv->deriv2_classes[6][9][18] = int_stack + 1181407;
 Libderiv->deriv2_classes[6][10][18] = int_stack + 1182947;
 Libderiv->deriv2_classes[7][5][18] = int_stack + 1184795;
 Libderiv->deriv2_classes[7][6][18] = int_stack + 1185551;
 Libderiv->deriv2_classes[7][7][18] = int_stack + 1186559;
 Libderiv->deriv2_classes[7][8][18] = int_stack + 1187855;
 Libderiv->deriv2_classes[7][9][18] = int_stack + 1189475;
 Libderiv->deriv2_classes[7][10][18] = int_stack + 1191455;
 Libderiv->deriv_classes[8][5][1] = int_stack + 1193831;
 Libderiv->deriv2_classes[8][5][18] = int_stack + 1194776;
 Libderiv->deriv_classes[8][6][1] = int_stack + 1195721;
 Libderiv->deriv2_classes[8][6][18] = int_stack + 1196981;
 Libderiv->deriv_classes[8][7][1] = int_stack + 1198241;
 Libderiv->deriv2_classes[8][7][18] = int_stack + 1199861;
 Libderiv->deriv_classes[8][8][1] = int_stack + 1201481;
 Libderiv->deriv2_classes[8][8][18] = int_stack + 1203506;
 Libderiv->deriv_classes[8][9][1] = int_stack + 1205531;
 Libderiv->deriv2_classes[8][9][18] = int_stack + 1208006;
 Libderiv->deriv2_classes[8][10][18] = int_stack + 1210481;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 1213451;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 1213892;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 1214480;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 1215236;
 Libderiv->deriv2_classes[5][9][14] = int_stack + 1216181;
 Libderiv->deriv2_classes[5][10][14] = int_stack + 1217336;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 1218722;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 1219310;
 Libderiv->deriv2_classes[6][7][14] = int_stack + 1220094;
 Libderiv->deriv2_classes[6][8][14] = int_stack + 1221102;
 Libderiv->deriv2_classes[6][9][14] = int_stack + 1222362;
 Libderiv->deriv2_classes[6][10][14] = int_stack + 1223902;
 Libderiv->deriv2_classes[7][5][14] = int_stack + 1225750;
 Libderiv->deriv2_classes[7][6][14] = int_stack + 1226506;
 Libderiv->deriv2_classes[7][7][14] = int_stack + 1227514;
 Libderiv->deriv2_classes[7][8][14] = int_stack + 1228810;
 Libderiv->deriv2_classes[7][9][14] = int_stack + 1230430;
 Libderiv->deriv2_classes[7][10][14] = int_stack + 1232410;
 Libderiv->deriv2_classes[8][5][14] = int_stack + 1234786;
 Libderiv->deriv2_classes[8][6][14] = int_stack + 1235731;
 Libderiv->deriv2_classes[8][7][14] = int_stack + 1236991;
 Libderiv->deriv2_classes[8][8][14] = int_stack + 1238611;
 Libderiv->deriv2_classes[8][9][14] = int_stack + 1240636;
 Libderiv->deriv2_classes[8][10][14] = int_stack + 1243111;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 1246081;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 1246522;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 1247110;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 1247866;
 Libderiv->deriv2_classes[5][9][13] = int_stack + 1248811;
 Libderiv->deriv2_classes[5][10][13] = int_stack + 1249966;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 1251352;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 1251940;
 Libderiv->deriv2_classes[6][7][13] = int_stack + 1252724;
 Libderiv->deriv2_classes[6][8][13] = int_stack + 1253732;
 Libderiv->deriv2_classes[6][9][13] = int_stack + 1254992;
 Libderiv->deriv2_classes[6][10][13] = int_stack + 1256532;
 Libderiv->deriv2_classes[7][5][13] = int_stack + 1258380;
 Libderiv->deriv2_classes[7][6][13] = int_stack + 1259136;
 Libderiv->deriv2_classes[7][7][13] = int_stack + 1260144;
 Libderiv->deriv2_classes[7][8][13] = int_stack + 1261440;
 Libderiv->deriv2_classes[7][9][13] = int_stack + 1263060;
 Libderiv->deriv2_classes[7][10][13] = int_stack + 1265040;
 Libderiv->deriv2_classes[8][5][13] = int_stack + 1267416;
 Libderiv->deriv2_classes[8][6][13] = int_stack + 1268361;
 Libderiv->deriv2_classes[8][7][13] = int_stack + 1269621;
 Libderiv->deriv2_classes[8][8][13] = int_stack + 1271241;
 Libderiv->deriv2_classes[8][9][13] = int_stack + 1273266;
 Libderiv->deriv2_classes[8][10][13] = int_stack + 1275741;
 Libderiv->deriv_classes[5][5][11] = int_stack + 1278711;
 Libderiv->deriv_classes[5][6][11] = int_stack + 1279152;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1279740;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1280496;
 Libderiv->deriv_classes[5][9][11] = int_stack + 1281441;
 Libderiv->deriv_classes[5][10][11] = int_stack + 1282596;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 1283982;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 1284423;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 1285011;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 1285767;
 Libderiv->deriv2_classes[5][9][11] = int_stack + 1286712;
 Libderiv->deriv2_classes[5][10][11] = int_stack + 1287867;
 Libderiv->deriv_classes[6][5][11] = int_stack + 1289253;
 Libderiv->deriv_classes[6][6][11] = int_stack + 1289841;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1290625;
 Libderiv->deriv_classes[6][8][11] = int_stack + 1291633;
 Libderiv->deriv_classes[6][9][11] = int_stack + 1292893;
 Libderiv->deriv_classes[6][10][11] = int_stack + 1294433;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 1296281;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 1296869;
 Libderiv->deriv2_classes[6][7][11] = int_stack + 1297653;
 Libderiv->deriv2_classes[6][8][11] = int_stack + 1298661;
 Libderiv->deriv2_classes[6][9][11] = int_stack + 1299921;
 Libderiv->deriv2_classes[6][10][11] = int_stack + 1301461;
 Libderiv->deriv_classes[7][5][11] = int_stack + 1303309;
 Libderiv->deriv_classes[7][6][11] = int_stack + 1304065;
 Libderiv->deriv_classes[7][7][11] = int_stack + 1305073;
 Libderiv->deriv_classes[7][8][11] = int_stack + 1306369;
 Libderiv->deriv_classes[7][9][11] = int_stack + 1307989;
 Libderiv->deriv_classes[7][10][11] = int_stack + 1309969;
 Libderiv->deriv2_classes[7][5][11] = int_stack + 1312345;
 Libderiv->deriv2_classes[7][6][11] = int_stack + 1313101;
 Libderiv->deriv2_classes[7][7][11] = int_stack + 1314109;
 Libderiv->deriv2_classes[7][8][11] = int_stack + 1315405;
 Libderiv->deriv2_classes[7][9][11] = int_stack + 1317025;
 Libderiv->deriv2_classes[7][10][11] = int_stack + 1319005;
 Libderiv->deriv2_classes[8][5][11] = int_stack + 1321381;
 Libderiv->deriv2_classes[8][6][11] = int_stack + 1322326;
 Libderiv->deriv2_classes[8][7][11] = int_stack + 1323586;
 Libderiv->deriv2_classes[8][8][11] = int_stack + 1325206;
 Libderiv->deriv2_classes[8][9][11] = int_stack + 1327231;
 Libderiv->deriv2_classes[8][10][11] = int_stack + 1329706;
 Libderiv->deriv_classes[5][5][10] = int_stack + 1332676;
 Libderiv->deriv_classes[5][6][10] = int_stack + 1333117;
 Libderiv->deriv_classes[5][7][10] = int_stack + 1333705;
 Libderiv->deriv_classes[5][8][10] = int_stack + 1334461;
 Libderiv->deriv_classes[5][9][10] = int_stack + 1335406;
 Libderiv->deriv_classes[5][10][10] = int_stack + 1336561;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 1337947;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 1338388;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 1338976;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 1339732;
 Libderiv->deriv2_classes[5][9][10] = int_stack + 1340677;
 Libderiv->deriv2_classes[5][10][10] = int_stack + 1341832;
 Libderiv->deriv_classes[6][5][10] = int_stack + 1343218;
 Libderiv->deriv_classes[6][6][10] = int_stack + 1343806;
 Libderiv->deriv_classes[6][7][10] = int_stack + 1344590;
 Libderiv->deriv_classes[6][8][10] = int_stack + 1345598;
 Libderiv->deriv_classes[6][9][10] = int_stack + 1346858;
 Libderiv->deriv_classes[6][10][10] = int_stack + 1348398;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 1350246;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 1350834;
 Libderiv->deriv2_classes[6][7][10] = int_stack + 1351618;
 Libderiv->deriv2_classes[6][8][10] = int_stack + 1352626;
 Libderiv->deriv2_classes[6][9][10] = int_stack + 1353886;
 Libderiv->deriv2_classes[6][10][10] = int_stack + 1355426;
 Libderiv->deriv_classes[7][5][10] = int_stack + 1357274;
 Libderiv->deriv_classes[7][6][10] = int_stack + 1358030;
 Libderiv->deriv_classes[7][7][10] = int_stack + 1359038;
 Libderiv->deriv_classes[7][8][10] = int_stack + 1360334;
 Libderiv->deriv_classes[7][9][10] = int_stack + 1361954;
 Libderiv->deriv_classes[7][10][10] = int_stack + 1363934;
 Libderiv->deriv2_classes[7][5][10] = int_stack + 1366310;
 Libderiv->deriv2_classes[7][6][10] = int_stack + 1367066;
 Libderiv->deriv2_classes[7][7][10] = int_stack + 1368074;
 Libderiv->deriv2_classes[7][8][10] = int_stack + 1369370;
 Libderiv->deriv2_classes[7][9][10] = int_stack + 1370990;
 Libderiv->deriv2_classes[7][10][10] = int_stack + 1372970;
 Libderiv->deriv2_classes[8][5][10] = int_stack + 1375346;
 Libderiv->deriv2_classes[8][6][10] = int_stack + 1376291;
 Libderiv->deriv2_classes[8][7][10] = int_stack + 1377551;
 Libderiv->deriv2_classes[8][8][10] = int_stack + 1379171;
 Libderiv->deriv2_classes[8][9][10] = int_stack + 1381196;
 Libderiv->deriv2_classes[8][10][10] = int_stack + 1383671;
 Libderiv->deriv_classes[5][5][9] = int_stack + 1386641;
 Libderiv->deriv_classes[5][6][9] = int_stack + 1387082;
 Libderiv->deriv_classes[5][7][9] = int_stack + 1387670;
 Libderiv->deriv_classes[5][8][9] = int_stack + 1388426;
 Libderiv->deriv_classes[5][9][9] = int_stack + 1389371;
 Libderiv->deriv_classes[5][10][9] = int_stack + 1390526;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 1391912;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 1392353;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 1392941;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 1393697;
 Libderiv->deriv2_classes[5][9][9] = int_stack + 1394642;
 Libderiv->deriv2_classes[5][10][9] = int_stack + 1395797;
 Libderiv->deriv_classes[6][5][9] = int_stack + 1397183;
 Libderiv->deriv_classes[6][6][9] = int_stack + 1397771;
 Libderiv->deriv_classes[6][7][9] = int_stack + 1398555;
 Libderiv->deriv_classes[6][8][9] = int_stack + 1399563;
 Libderiv->deriv_classes[6][9][9] = int_stack + 1400823;
 Libderiv->deriv_classes[6][10][9] = int_stack + 1402363;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 1404211;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 1404799;
 Libderiv->deriv2_classes[6][7][9] = int_stack + 1405583;
 Libderiv->deriv2_classes[6][8][9] = int_stack + 1406591;
 Libderiv->deriv2_classes[6][9][9] = int_stack + 1407851;
 Libderiv->deriv2_classes[6][10][9] = int_stack + 1409391;
 Libderiv->deriv_classes[7][5][9] = int_stack + 1411239;
 Libderiv->deriv_classes[7][6][9] = int_stack + 1411995;
 Libderiv->deriv_classes[7][7][9] = int_stack + 1413003;
 Libderiv->deriv_classes[7][8][9] = int_stack + 1414299;
 Libderiv->deriv_classes[7][9][9] = int_stack + 1415919;
 Libderiv->deriv_classes[7][10][9] = int_stack + 1417899;
 Libderiv->deriv2_classes[7][5][9] = int_stack + 1420275;
 Libderiv->deriv2_classes[7][6][9] = int_stack + 1421031;
 Libderiv->deriv2_classes[7][7][9] = int_stack + 1422039;
 Libderiv->deriv2_classes[7][8][9] = int_stack + 1423335;
 Libderiv->deriv2_classes[7][9][9] = int_stack + 1424955;
 Libderiv->deriv2_classes[7][10][9] = int_stack + 1426935;
 Libderiv->deriv2_classes[8][5][9] = int_stack + 1429311;
 Libderiv->deriv2_classes[8][6][9] = int_stack + 1430256;
 Libderiv->deriv2_classes[8][7][9] = int_stack + 1431516;
 Libderiv->deriv2_classes[8][8][9] = int_stack + 1433136;
 Libderiv->deriv2_classes[8][9][9] = int_stack + 1435161;
 Libderiv->deriv2_classes[8][10][9] = int_stack + 1437636;
 Libderiv->deriv_classes[5][5][8] = int_stack + 1440606;
 Libderiv->deriv_classes[5][6][8] = int_stack + 1441047;
 Libderiv->deriv_classes[5][7][8] = int_stack + 1441635;
 Libderiv->deriv_classes[5][8][8] = int_stack + 1442391;
 Libderiv->deriv_classes[5][9][8] = int_stack + 1443336;
 Libderiv->deriv_classes[5][10][8] = int_stack + 1444491;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 1445877;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 1446318;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 1446906;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 1447662;
 Libderiv->deriv2_classes[5][9][8] = int_stack + 1448607;
 Libderiv->deriv2_classes[5][10][8] = int_stack + 1449762;
 Libderiv->deriv_classes[6][5][8] = int_stack + 1451148;
 Libderiv->deriv_classes[6][6][8] = int_stack + 1451736;
 Libderiv->deriv_classes[6][7][8] = int_stack + 1452520;
 Libderiv->deriv_classes[6][8][8] = int_stack + 1453528;
 Libderiv->deriv_classes[6][9][8] = int_stack + 1454788;
 Libderiv->deriv_classes[6][10][8] = int_stack + 1456328;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 1458176;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 1458764;
 Libderiv->deriv2_classes[6][7][8] = int_stack + 1459548;
 Libderiv->deriv2_classes[6][8][8] = int_stack + 1460556;
 Libderiv->deriv2_classes[6][9][8] = int_stack + 1461816;
 Libderiv->deriv2_classes[6][10][8] = int_stack + 1463356;
 Libderiv->deriv_classes[7][5][8] = int_stack + 1465204;
 Libderiv->deriv_classes[7][6][8] = int_stack + 1465960;
 Libderiv->deriv_classes[7][7][8] = int_stack + 1466968;
 Libderiv->deriv_classes[7][8][8] = int_stack + 1468264;
 Libderiv->deriv_classes[7][9][8] = int_stack + 1469884;
 Libderiv->deriv_classes[7][10][8] = int_stack + 1471864;
 Libderiv->deriv2_classes[7][5][8] = int_stack + 1474240;
 Libderiv->deriv2_classes[7][6][8] = int_stack + 1474996;
 Libderiv->deriv2_classes[7][7][8] = int_stack + 1476004;
 Libderiv->deriv2_classes[7][8][8] = int_stack + 1477300;
 Libderiv->deriv2_classes[7][9][8] = int_stack + 1478920;
 Libderiv->deriv2_classes[7][10][8] = int_stack + 1480900;
 Libderiv->deriv2_classes[8][5][8] = int_stack + 1483276;
 Libderiv->deriv2_classes[8][6][8] = int_stack + 1484221;
 Libderiv->deriv2_classes[8][7][8] = int_stack + 1485481;
 Libderiv->deriv2_classes[8][8][8] = int_stack + 1487101;
 Libderiv->deriv2_classes[8][9][8] = int_stack + 1489126;
 Libderiv->deriv2_classes[8][10][8] = int_stack + 1491601;
 Libderiv->deriv_classes[5][5][7] = int_stack + 1494571;
 Libderiv->deriv_classes[5][6][7] = int_stack + 1495012;
 Libderiv->deriv_classes[5][7][7] = int_stack + 1495600;
 Libderiv->deriv_classes[5][8][7] = int_stack + 1496356;
 Libderiv->deriv_classes[5][9][7] = int_stack + 1497301;
 Libderiv->deriv_classes[5][10][7] = int_stack + 1498456;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 1499842;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 1500283;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 1500871;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 1501627;
 Libderiv->deriv2_classes[5][9][7] = int_stack + 1502572;
 Libderiv->deriv2_classes[5][10][7] = int_stack + 1503727;
 Libderiv->deriv_classes[6][5][7] = int_stack + 1505113;
 Libderiv->deriv_classes[6][6][7] = int_stack + 1505701;
 Libderiv->deriv_classes[6][7][7] = int_stack + 1506485;
 Libderiv->deriv_classes[6][8][7] = int_stack + 1507493;
 Libderiv->deriv_classes[6][9][7] = int_stack + 1508753;
 Libderiv->deriv_classes[6][10][7] = int_stack + 1510293;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 1512141;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 1512729;
 Libderiv->deriv2_classes[6][7][7] = int_stack + 1513513;
 Libderiv->deriv2_classes[6][8][7] = int_stack + 1514521;
 Libderiv->deriv2_classes[6][9][7] = int_stack + 1515781;
 Libderiv->deriv2_classes[6][10][7] = int_stack + 1517321;
 Libderiv->deriv_classes[7][5][7] = int_stack + 1519169;
 Libderiv->deriv_classes[7][6][7] = int_stack + 1519925;
 Libderiv->deriv_classes[7][7][7] = int_stack + 1520933;
 Libderiv->deriv_classes[7][8][7] = int_stack + 1522229;
 Libderiv->deriv_classes[7][9][7] = int_stack + 1523849;
 Libderiv->deriv_classes[7][10][7] = int_stack + 1525829;
 Libderiv->deriv2_classes[7][5][7] = int_stack + 1528205;
 Libderiv->deriv2_classes[7][6][7] = int_stack + 1528961;
 Libderiv->deriv2_classes[7][7][7] = int_stack + 1529969;
 Libderiv->deriv2_classes[7][8][7] = int_stack + 1531265;
 Libderiv->deriv2_classes[7][9][7] = int_stack + 1532885;
 Libderiv->deriv2_classes[7][10][7] = int_stack + 1534865;
 Libderiv->deriv2_classes[8][5][7] = int_stack + 1537241;
 Libderiv->deriv2_classes[8][6][7] = int_stack + 1538186;
 Libderiv->deriv2_classes[8][7][7] = int_stack + 1539446;
 Libderiv->deriv2_classes[8][8][7] = int_stack + 1541066;
 Libderiv->deriv2_classes[8][9][7] = int_stack + 1543091;
 Libderiv->deriv2_classes[8][10][7] = int_stack + 1545566;
 Libderiv->deriv_classes[5][5][6] = int_stack + 1548536;
 Libderiv->deriv_classes[5][6][6] = int_stack + 1548977;
 Libderiv->deriv_classes[5][7][6] = int_stack + 1549565;
 Libderiv->deriv_classes[5][8][6] = int_stack + 1550321;
 Libderiv->deriv_classes[5][9][6] = int_stack + 1551266;
 Libderiv->deriv_classes[5][10][6] = int_stack + 1552421;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 1553807;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 1554248;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 1554836;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 1555592;
 Libderiv->deriv2_classes[5][9][6] = int_stack + 1556537;
 Libderiv->deriv2_classes[5][10][6] = int_stack + 1557692;
 Libderiv->deriv_classes[6][5][6] = int_stack + 1559078;
 Libderiv->deriv_classes[6][6][6] = int_stack + 1559666;
 Libderiv->deriv_classes[6][7][6] = int_stack + 1560450;
 Libderiv->deriv_classes[6][8][6] = int_stack + 1561458;
 Libderiv->deriv_classes[6][9][6] = int_stack + 1562718;
 Libderiv->deriv_classes[6][10][6] = int_stack + 1564258;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 1566106;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 1566694;
 Libderiv->deriv2_classes[6][7][6] = int_stack + 1567478;
 Libderiv->deriv2_classes[6][8][6] = int_stack + 1568486;
 Libderiv->deriv2_classes[6][9][6] = int_stack + 1569746;
 Libderiv->deriv2_classes[6][10][6] = int_stack + 1571286;
 Libderiv->dvrr_classes[7][5] = int_stack + 1573134;
 Libderiv->deriv_classes[7][5][6] = int_stack + 1573890;
 Libderiv->dvrr_classes[7][6] = int_stack + 1574646;
 Libderiv->deriv_classes[7][6][6] = int_stack + 1575654;
 Libderiv->dvrr_classes[7][7] = int_stack + 1576662;
 Libderiv->deriv_classes[7][7][6] = int_stack + 1577958;
 Libderiv->dvrr_classes[7][8] = int_stack + 1579254;
 Libderiv->deriv_classes[7][8][6] = int_stack + 1580874;
 Libderiv->dvrr_classes[7][9] = int_stack + 1582494;
 Libderiv->deriv_classes[7][9][6] = int_stack + 1584474;
 Libderiv->deriv_classes[7][10][6] = int_stack + 1586454;
 Libderiv->deriv2_classes[7][5][6] = int_stack + 1588830;
 Libderiv->deriv2_classes[7][6][6] = int_stack + 1589586;
 Libderiv->deriv2_classes[7][7][6] = int_stack + 1590594;
 Libderiv->deriv2_classes[7][8][6] = int_stack + 1591890;
 Libderiv->deriv2_classes[7][9][6] = int_stack + 1593510;
 Libderiv->deriv2_classes[7][10][6] = int_stack + 1595490;
 Libderiv->deriv_classes[8][5][0] = int_stack + 1597866;
 Libderiv->deriv2_classes[8][5][6] = int_stack + 1598811;
 Libderiv->deriv_classes[8][6][0] = int_stack + 1599756;
 Libderiv->deriv2_classes[8][6][6] = int_stack + 1601016;
 Libderiv->deriv_classes[8][7][0] = int_stack + 1602276;
 Libderiv->deriv2_classes[8][7][6] = int_stack + 1603896;
 Libderiv->deriv_classes[8][8][0] = int_stack + 1605516;
 Libderiv->deriv2_classes[8][8][6] = int_stack + 1607541;
 Libderiv->deriv_classes[8][9][0] = int_stack + 1609566;
 Libderiv->deriv2_classes[8][9][6] = int_stack + 1612041;
 Libderiv->deriv2_classes[8][10][6] = int_stack + 1614516;
 Libderiv->deriv_classes[5][5][2] = int_stack + 1617486;
 Libderiv->deriv_classes[5][6][2] = int_stack + 1617927;
 Libderiv->deriv_classes[5][7][2] = int_stack + 1618515;
 Libderiv->deriv_classes[5][8][2] = int_stack + 1619271;
 Libderiv->deriv_classes[5][9][2] = int_stack + 1620216;
 Libderiv->deriv_classes[5][10][2] = int_stack + 1621371;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 1622757;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 1623198;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 1623786;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 1624542;
 Libderiv->deriv2_classes[5][9][2] = int_stack + 1625487;
 Libderiv->deriv2_classes[5][10][2] = int_stack + 1626642;
 Libderiv->deriv_classes[6][5][2] = int_stack + 1628028;
 Libderiv->deriv_classes[6][6][2] = int_stack + 1628616;
 Libderiv->deriv_classes[6][7][2] = int_stack + 1629400;
 Libderiv->deriv_classes[6][8][2] = int_stack + 1630408;
 Libderiv->deriv_classes[6][9][2] = int_stack + 1631668;
 Libderiv->deriv_classes[6][10][2] = int_stack + 1633208;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 1635056;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 1635644;
 Libderiv->deriv2_classes[6][7][2] = int_stack + 1636428;
 Libderiv->deriv2_classes[6][8][2] = int_stack + 1637436;
 Libderiv->deriv2_classes[6][9][2] = int_stack + 1638696;
 Libderiv->deriv2_classes[6][10][2] = int_stack + 1640236;
 Libderiv->deriv_classes[7][5][2] = int_stack + 1642084;
 Libderiv->deriv_classes[7][6][2] = int_stack + 1642840;
 Libderiv->deriv_classes[7][7][2] = int_stack + 1643848;
 Libderiv->deriv_classes[7][8][2] = int_stack + 1645144;
 Libderiv->deriv_classes[7][9][2] = int_stack + 1646764;
 Libderiv->deriv_classes[7][10][2] = int_stack + 1648744;
 Libderiv->deriv2_classes[7][5][2] = int_stack + 1651120;
 Libderiv->deriv2_classes[7][6][2] = int_stack + 1651876;
 Libderiv->deriv2_classes[7][7][2] = int_stack + 1652884;
 Libderiv->deriv2_classes[7][8][2] = int_stack + 1654180;
 Libderiv->deriv2_classes[7][9][2] = int_stack + 1655800;
 Libderiv->deriv2_classes[7][10][2] = int_stack + 1657780;
 Libderiv->deriv2_classes[8][5][2] = int_stack + 1660156;
 Libderiv->deriv2_classes[8][6][2] = int_stack + 1661101;
 Libderiv->deriv2_classes[8][7][2] = int_stack + 1662361;
 Libderiv->deriv2_classes[8][8][2] = int_stack + 1663981;
 Libderiv->deriv2_classes[8][9][2] = int_stack + 1666006;
 Libderiv->deriv2_classes[8][10][2] = int_stack + 1668481;
 Libderiv->deriv_classes[5][5][1] = int_stack + 1671451;
 Libderiv->deriv_classes[5][6][1] = int_stack + 1671892;
 Libderiv->deriv_classes[5][7][1] = int_stack + 1672480;
 Libderiv->deriv_classes[5][8][1] = int_stack + 1673236;
 Libderiv->deriv_classes[5][9][1] = int_stack + 1674181;
 Libderiv->deriv_classes[5][10][1] = int_stack + 1675336;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 1676722;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 1677163;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 1677751;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 1678507;
 Libderiv->deriv2_classes[5][9][1] = int_stack + 1679452;
 Libderiv->deriv2_classes[5][10][1] = int_stack + 1680607;
 Libderiv->deriv_classes[6][5][1] = int_stack + 1681993;
 Libderiv->deriv_classes[6][6][1] = int_stack + 1682581;
 Libderiv->deriv_classes[6][7][1] = int_stack + 1683365;
 Libderiv->deriv_classes[6][8][1] = int_stack + 1684373;
 Libderiv->deriv_classes[6][9][1] = int_stack + 1685633;
 Libderiv->deriv_classes[6][10][1] = int_stack + 1687173;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 1689021;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 1689609;
 Libderiv->deriv2_classes[6][7][1] = int_stack + 1690393;
 Libderiv->deriv2_classes[6][8][1] = int_stack + 1691401;
 Libderiv->deriv2_classes[6][9][1] = int_stack + 1692661;
 Libderiv->deriv2_classes[6][10][1] = int_stack + 1694201;
 Libderiv->deriv_classes[7][5][1] = int_stack + 1696049;
 Libderiv->deriv_classes[7][6][1] = int_stack + 1696805;
 Libderiv->deriv_classes[7][7][1] = int_stack + 1697813;
 Libderiv->deriv_classes[7][8][1] = int_stack + 1699109;
 Libderiv->deriv_classes[7][9][1] = int_stack + 1700729;
 Libderiv->deriv_classes[7][10][1] = int_stack + 1702709;
 Libderiv->deriv2_classes[7][5][1] = int_stack + 1705085;
 Libderiv->deriv2_classes[7][6][1] = int_stack + 1705841;
 Libderiv->deriv2_classes[7][7][1] = int_stack + 1706849;
 Libderiv->deriv2_classes[7][8][1] = int_stack + 1708145;
 Libderiv->deriv2_classes[7][9][1] = int_stack + 1709765;
 Libderiv->deriv2_classes[7][10][1] = int_stack + 1711745;
 Libderiv->deriv2_classes[8][5][1] = int_stack + 1714121;
 Libderiv->deriv2_classes[8][6][1] = int_stack + 1715066;
 Libderiv->deriv2_classes[8][7][1] = int_stack + 1716326;
 Libderiv->deriv2_classes[8][8][1] = int_stack + 1717946;
 Libderiv->deriv2_classes[8][9][1] = int_stack + 1719971;
 Libderiv->deriv2_classes[8][10][1] = int_stack + 1722446;
 Libderiv->dvrr_classes[5][5] = int_stack + 1725416;
 Libderiv->dvrr_classes[5][6] = int_stack + 1725857;
 Libderiv->dvrr_classes[5][7] = int_stack + 1726445;
 Libderiv->dvrr_classes[5][8] = int_stack + 1727201;
 Libderiv->dvrr_classes[5][9] = int_stack + 1728146;
 Libderiv->dvrr_classes[5][10] = int_stack + 1729301;
 Libderiv->deriv_classes[5][5][0] = int_stack + 1730687;
 Libderiv->deriv_classes[5][6][0] = int_stack + 1731128;
 Libderiv->deriv_classes[5][7][0] = int_stack + 1731716;
 Libderiv->deriv_classes[5][8][0] = int_stack + 1732472;
 Libderiv->deriv_classes[5][9][0] = int_stack + 1733417;
 Libderiv->deriv_classes[5][10][0] = int_stack + 1734572;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 1735958;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 1736399;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 1736987;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 1737743;
 Libderiv->deriv2_classes[5][9][0] = int_stack + 1738688;
 Libderiv->deriv2_classes[5][10][0] = int_stack + 1739843;
 Libderiv->dvrr_classes[6][5] = int_stack + 1741229;
 Libderiv->dvrr_classes[6][6] = int_stack + 1741817;
 Libderiv->dvrr_classes[6][7] = int_stack + 1742601;
 Libderiv->dvrr_classes[6][8] = int_stack + 1743609;
 Libderiv->dvrr_classes[6][9] = int_stack + 1744869;
 Libderiv->dvrr_classes[6][10] = int_stack + 1746409;
 Libderiv->deriv_classes[6][5][0] = int_stack + 1748257;
 Libderiv->deriv_classes[6][6][0] = int_stack + 1748845;
 Libderiv->deriv_classes[6][7][0] = int_stack + 1749629;
 Libderiv->deriv_classes[6][8][0] = int_stack + 1750637;
 Libderiv->deriv_classes[6][9][0] = int_stack + 1751897;
 Libderiv->deriv_classes[6][10][0] = int_stack + 1753437;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 1755285;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 1755873;
 Libderiv->deriv2_classes[6][7][0] = int_stack + 1756657;
 Libderiv->deriv2_classes[6][8][0] = int_stack + 1757665;
 Libderiv->deriv2_classes[6][9][0] = int_stack + 1758925;
 Libderiv->deriv2_classes[6][10][0] = int_stack + 1760465;
 Libderiv->deriv_classes[7][5][0] = int_stack + 1762313;
 Libderiv->deriv_classes[7][6][0] = int_stack + 1763069;
 Libderiv->deriv_classes[7][7][0] = int_stack + 1764077;
 Libderiv->deriv_classes[7][8][0] = int_stack + 1765373;
 Libderiv->deriv_classes[7][9][0] = int_stack + 1766993;
 Libderiv->deriv_classes[7][10][0] = int_stack + 1768973;
 Libderiv->deriv2_classes[7][5][0] = int_stack + 1771349;
 Libderiv->deriv2_classes[7][6][0] = int_stack + 1772105;
 Libderiv->deriv2_classes[7][7][0] = int_stack + 1773113;
 Libderiv->deriv2_classes[7][8][0] = int_stack + 1774409;
 Libderiv->deriv2_classes[7][9][0] = int_stack + 1776029;
 Libderiv->deriv2_classes[7][10][0] = int_stack + 1778009;
 Libderiv->deriv2_classes[8][5][0] = int_stack + 1780385;
 Libderiv->deriv2_classes[8][6][0] = int_stack + 1781330;
 Libderiv->deriv2_classes[8][7][0] = int_stack + 1782590;
 Libderiv->deriv2_classes[8][8][0] = int_stack + 1784210;
 Libderiv->deriv2_classes[8][9][0] = int_stack + 1786235;
 Libderiv->deriv2_classes[8][10][0] = int_stack + 1788710;
 memset(int_stack,0,14333440);

 Libderiv->dvrr_stack = int_stack + 8696272;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_hfhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1791680,int_stack+1725857,int_stack+1725416,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1793003,int_stack+1726445,int_stack+1725857,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1794767,int_stack+1793003,int_stack+1791680,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1797413,int_stack+1727201,int_stack+1726445,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1799681,int_stack+1797413,int_stack+1793003,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1803209,int_stack+1799681,int_stack+1794767,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1807619,int_stack+1728146,int_stack+1727201,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1810454,int_stack+1807619,int_stack+1797413,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1814990,int_stack+1810454,int_stack+1799681,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1820870,int_stack+1814990,int_stack+1803209,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1827485,int_stack+1279152,int_stack+1278711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1828808,int_stack+1279740,int_stack+1279152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725857,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1830572,int_stack+1828808,int_stack+1827485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1791680,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1833218,int_stack+1280496,int_stack+1279740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1726445,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1835486,int_stack+1833218,int_stack+1828808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1793003,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1839014,int_stack+1835486,int_stack+1830572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1794767,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1843424,int_stack+1281441,int_stack+1280496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1727201,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1846259,int_stack+1843424,int_stack+1833218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1797413,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1850795,int_stack+1846259,int_stack+1835486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1799681,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1856675,int_stack+1850795,int_stack+1839014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1803209,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1863290,int_stack+1282596,int_stack+1281441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1728146,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1866755,int_stack+1863290,int_stack+1843424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1807619,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1872425,int_stack+1866755,int_stack+1846259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810454,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1863290,int_stack+1872425,int_stack+1850795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814990,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1872110,int_stack+1863290,int_stack+1856675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1820870,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1863290,int_stack+1741817,int_stack+1741229,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1865054,int_stack+1742601,int_stack+1741817,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1867406,int_stack+1865054,int_stack+1863290,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1881371,int_stack+1743609,int_stack+1742601,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1884395,int_stack+1881371,int_stack+1865054,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1889099,int_stack+1884395,int_stack+1867406,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1894979,int_stack+1744869,int_stack+1743609,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1898759,int_stack+1894979,int_stack+1881371,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1904807,int_stack+1898759,int_stack+1884395,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1912647,int_stack+1904807,int_stack+1889099,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1921467,int_stack+1289841,int_stack+1289253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1923231,int_stack+1290625,int_stack+1289841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741817,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1925583,int_stack+1923231,int_stack+1921467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1863290,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1929111,int_stack+1291633,int_stack+1290625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1742601,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1932135,int_stack+1929111,int_stack+1923231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1865054,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1936839,int_stack+1932135,int_stack+1925583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867406,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1942719,int_stack+1292893,int_stack+1291633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1743609,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1946499,int_stack+1942719,int_stack+1929111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1881371,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1952547,int_stack+1946499,int_stack+1932135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1884395,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1960387,int_stack+1952547,int_stack+1936839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889099,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1969207,int_stack+1294433,int_stack+1292893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744869,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1973827,int_stack+1969207,int_stack+1942719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1894979,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1981387,int_stack+1973827,int_stack+1946499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898759,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1969207,int_stack+1981387,int_stack+1952547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1904807,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1980967,int_stack+1969207,int_stack+1960387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1912647,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1993315,int_stack+1980967,int_stack+1872110,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1969207,int_stack+1574646,int_stack+1573134,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1971475,int_stack+1576662,int_stack+1574646,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1974499,int_stack+1971475,int_stack+1969207,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2021098,int_stack+1579254,int_stack+1576662,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2024986,int_stack+2021098,int_stack+1971475,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2031034,int_stack+2024986,int_stack+1974499,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2038594,int_stack+1582494,int_stack+1579254,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2043454,int_stack+2038594,int_stack+2021098,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2051230,int_stack+2043454,int_stack+2024986,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2061310,int_stack+2051230,int_stack+2031034,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2072650,int_stack+1304065,int_stack+1303309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573134,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2074918,int_stack+1305073,int_stack+1304065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1574646,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2077942,int_stack+2074918,int_stack+2072650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969207,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2082478,int_stack+1306369,int_stack+1305073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576662,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2086366,int_stack+2082478,int_stack+2074918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1971475,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2092414,int_stack+2086366,int_stack+2077942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974499,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2099974,int_stack+1307989,int_stack+1306369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1579254,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2104834,int_stack+2099974,int_stack+2082478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2021098,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2112610,int_stack+2104834,int_stack+2086366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024986,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2122690,int_stack+2112610,int_stack+2092414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2031034,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2134030,int_stack+1309969,int_stack+1307989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1582494,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2139970,int_stack+2134030,int_stack+2099974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2038594,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2149690,int_stack+2139970,int_stack+2104834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043454,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2134030,int_stack+2149690,int_stack+2112610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051230,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2149150,int_stack+2134030,int_stack+2122690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2061310,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2165026,int_stack+2149150,int_stack+1980967,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2202070,int_stack+2165026,int_stack+1993315,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2134030,int_stack+749976,int_stack+747141,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2136865,int_stack+753756,int_stack+749976,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2140645,int_stack+2136865,int_stack+2134030,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2257636,int_stack+758616,int_stack+753756,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2262496,int_stack+2257636,int_stack+2136865,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2270056,int_stack+2262496,int_stack+2140645,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2279506,int_stack+14850,int_stack+758616,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2285581,int_stack+2279506,int_stack+2257636,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2295301,int_stack+2285581,int_stack+2262496,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2307901,int_stack+2295301,int_stack+2270056,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2146315,int_stack+544256,int_stack+542366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747141,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2322076,int_stack+546776,int_stack+544256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749976,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2325856,int_stack+2322076,int_stack+2146315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134030,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2331526,int_stack+550016,int_stack+546776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753756,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2336386,int_stack+2331526,int_stack+2322076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2136865,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2343946,int_stack+2336386,int_stack+2325856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140645,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2353396,int_stack+554066,int_stack+550016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758616,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2359471,int_stack+2353396,int_stack+2331526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2369191,int_stack+2359471,int_stack+2336386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2262496,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2381791,int_stack+2369191,int_stack+2343946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270056,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2395966,int_stack+0,int_stack+554066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14850,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2403391,int_stack+2395966,int_stack+2353396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2279506,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2415541,int_stack+2403391,int_stack+2359471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285581,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2395966,int_stack+2415541,int_stack+2369191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2295301,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2414866,int_stack+2395966,int_stack+2381791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2307901,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+2434711,int_stack+2414866,int_stack+2149150,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2482339,int_stack+2434711,int_stack+2165026,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2395966,int_stack+1333117,int_stack+1332676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2397289,int_stack+1333705,int_stack+1333117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725857, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2399053,int_stack+2397289,int_stack+2395966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1791680, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2401699,int_stack+1334461,int_stack+1333705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1726445, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2403967,int_stack+2401699,int_stack+2397289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1793003, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2407495,int_stack+2403967,int_stack+2399053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1794767, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2411905,int_stack+1335406,int_stack+1334461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1727201, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2414740,int_stack+2411905,int_stack+2401699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1797413, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2419276,int_stack+2414740,int_stack+2403967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1799681, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2425156,int_stack+2419276,int_stack+2407495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1803209, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2431771,int_stack+1336561,int_stack+1335406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1728146, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2435236,int_stack+2431771,int_stack+2411905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1807619, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2440906,int_stack+2435236,int_stack+2414740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810454, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2431771,int_stack+2440906,int_stack+2419276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814990, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2440591,int_stack+2431771,int_stack+2425156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1820870, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2431771,int_stack+1343806,int_stack+1343218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2433535,int_stack+1344590,int_stack+1343806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741817, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2435887,int_stack+2433535,int_stack+2431771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1863290, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2449852,int_stack+1345598,int_stack+1344590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1742601, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2452876,int_stack+2449852,int_stack+2433535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1865054, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2457580,int_stack+2452876,int_stack+2435887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867406, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2463460,int_stack+1346858,int_stack+1345598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1743609, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2467240,int_stack+2463460,int_stack+2449852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1881371, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2473288,int_stack+2467240,int_stack+2452876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1884395, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2556427,int_stack+2473288,int_stack+2457580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889099, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2565247,int_stack+1348398,int_stack+1346858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744869, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2569867,int_stack+2565247,int_stack+2463460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1894979, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2577427,int_stack+2569867,int_stack+2467240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898759, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2565247,int_stack+2577427,int_stack+2473288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1904807, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2577007,int_stack+2565247,int_stack+2556427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1912647, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2589355,int_stack+2577007,int_stack+2440591,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2565247,int_stack+1358030,int_stack+1357274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573134, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2567515,int_stack+1359038,int_stack+1358030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1574646, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2570539,int_stack+2567515,int_stack+2565247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969207, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2617138,int_stack+1360334,int_stack+1359038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576662, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2621026,int_stack+2617138,int_stack+2567515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1971475, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2627074,int_stack+2621026,int_stack+2570539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974499, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2634634,int_stack+1361954,int_stack+1360334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1579254, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2639494,int_stack+2634634,int_stack+2617138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2021098, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2647270,int_stack+2639494,int_stack+2621026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024986, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2657350,int_stack+2647270,int_stack+2627074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2031034, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2668690,int_stack+1363934,int_stack+1361954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1582494, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2674630,int_stack+2668690,int_stack+2634634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2038594, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2684350,int_stack+2674630,int_stack+2639494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043454, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2668690,int_stack+2684350,int_stack+2647270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051230, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2683810,int_stack+2668690,int_stack+2657350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2061310, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2699686,int_stack+2683810,int_stack+2577007,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2736730,int_stack+2699686,int_stack+2589355,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2668690,int_stack+585211,int_stack+583321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747141, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2671525,int_stack+587731,int_stack+585211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749976, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2675305,int_stack+2671525,int_stack+2668690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134030, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2792296,int_stack+590971,int_stack+587731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753756, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2797156,int_stack+2792296,int_stack+2671525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2136865, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2804716,int_stack+2797156,int_stack+2675305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140645, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2814166,int_stack+595021,int_stack+590971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758616, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2820241,int_stack+2814166,int_stack+2792296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2829961,int_stack+2820241,int_stack+2797156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2262496, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2842561,int_stack+2829961,int_stack+2804716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270056, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2856736,int_stack+2970,int_stack+595021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14850, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2864161,int_stack+2856736,int_stack+2814166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2279506, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2876311,int_stack+2864161,int_stack+2820241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285581, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2856736,int_stack+2876311,int_stack+2829961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2295301, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2875636,int_stack+2856736,int_stack+2842561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2307901, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+2895481,int_stack+2875636,int_stack+2683810,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2943109,int_stack+2895481,int_stack+2699686,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2856736,int_stack+1387082,int_stack+1386641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2858059,int_stack+1387670,int_stack+1387082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725857, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2859823,int_stack+2858059,int_stack+2856736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2862469,int_stack+1388426,int_stack+1387670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1726445, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2864737,int_stack+2862469,int_stack+2858059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1793003, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2868265,int_stack+2864737,int_stack+2859823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1794767, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2680975,int_stack+1389371,int_stack+1388426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1727201, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2872675,int_stack+2680975,int_stack+2862469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1797413, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2877211,int_stack+2872675,int_stack+2864737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1799681, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2883091,int_stack+2877211,int_stack+2868265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1803209, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2889706,int_stack+1390526,int_stack+1389371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1728146, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2893171,int_stack+2889706,int_stack+2680975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1807619, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2898841,int_stack+2893171,int_stack+2872675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810454, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2889706,int_stack+2898841,int_stack+2877211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814990, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2898526,int_stack+2889706,int_stack+2883091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1820870, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2889706,int_stack+1397771,int_stack+1397183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2891470,int_stack+1398555,int_stack+1397771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741817, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2893822,int_stack+2891470,int_stack+2889706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2907787,int_stack+1399563,int_stack+1398555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1742601, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2910811,int_stack+2907787,int_stack+2891470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1865054, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2915515,int_stack+2910811,int_stack+2893822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867406, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2921395,int_stack+1400823,int_stack+1399563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1743609, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2925175,int_stack+2921395,int_stack+2907787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2931223,int_stack+2925175,int_stack+2910811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1884395, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+2931223,int_stack+2915515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889099, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+1402363,int_stack+1400823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744869, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3026017,int_stack+0,int_stack+2921395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3033577,int_stack+3026017,int_stack+2925175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898759, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3043657,int_stack+3033577,int_stack+2931223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1904807, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3026017,int_stack+3043657,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1912647, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+3038365,int_stack+3026017,int_stack+2898526,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+1411995,int_stack+1411239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573134, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+1413003,int_stack+1411995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1574646, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3066148,int_stack+2268,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2939063,int_stack+1414299,int_stack+1413003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576662, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3070684,int_stack+2939063,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1971475, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3076732,int_stack+3070684,int_stack+3066148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974499, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3084292,int_stack+1415919,int_stack+1414299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1579254, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3089152,int_stack+3084292,int_stack+2939063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3096928,int_stack+3089152,int_stack+3070684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024986, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3107008,int_stack+3096928,int_stack+3076732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2031034, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3118348,int_stack+1417899,int_stack+1415919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1582494, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3124288,int_stack+3118348,int_stack+3084292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2038594, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3134008,int_stack+3124288,int_stack+3089152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043454, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3118348,int_stack+3134008,int_stack+3096928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051230, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3133468,int_stack+3118348,int_stack+3107008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2061310, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3149344,int_stack+3133468,int_stack+3026017,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+3186388,int_stack+3149344,int_stack+3038365,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3118348,int_stack+626166,int_stack+624276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747141, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3121183,int_stack+628686,int_stack+626166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749976, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3124963,int_stack+3121183,int_stack+3118348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3241954,int_stack+631926,int_stack+628686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753756, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3246814,int_stack+3241954,int_stack+3121183, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2136865, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3254374,int_stack+3246814,int_stack+3124963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140645, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3263824,int_stack+635976,int_stack+631926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758616, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3269899,int_stack+3263824,int_stack+3241954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3279619,int_stack+3269899,int_stack+3246814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2262496, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3292219,int_stack+3279619,int_stack+3254374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270056, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3306394,int_stack+5940,int_stack+635976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14850, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3313819,int_stack+3306394,int_stack+3263824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2279506, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3325969,int_stack+3313819,int_stack+3269899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285581, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3306394,int_stack+3325969,int_stack+3279619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2295301, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3325294,int_stack+3306394,int_stack+3292219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2307901, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+3345139,int_stack+3325294,int_stack+3133468,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+3392767,int_stack+3345139,int_stack+3149344,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3306394,int_stack+1441047,int_stack+1440606, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3307717,int_stack+1441635,int_stack+1441047, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3309481,int_stack+3307717,int_stack+3306394, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3312127,int_stack+1442391,int_stack+1441635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1726445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3314395,int_stack+3312127,int_stack+3307717, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1793003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3317923,int_stack+3314395,int_stack+3309481, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1794767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3130633,int_stack+1443336,int_stack+1442391, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1727201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3322333,int_stack+3130633,int_stack+3312127, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1797413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3326869,int_stack+3322333,int_stack+3314395, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1799681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3332749,int_stack+3326869,int_stack+3317923, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1803209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3339364,int_stack+1444491,int_stack+1443336, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1728146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3342829,int_stack+3339364,int_stack+3130633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1807619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3348499,int_stack+3342829,int_stack+3322333, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3339364,int_stack+3348499,int_stack+3326869, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3348184,int_stack+3339364,int_stack+3332749, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1820870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3339364,int_stack+1451736,int_stack+1451148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3341128,int_stack+1452520,int_stack+1451736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3343480,int_stack+3341128,int_stack+3339364, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3357445,int_stack+1453528,int_stack+1452520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1742601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3360469,int_stack+3357445,int_stack+3341128, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1865054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3365173,int_stack+3360469,int_stack+3343480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3371053,int_stack+1454788,int_stack+1453528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1743609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3374833,int_stack+3371053,int_stack+3357445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3380881,int_stack+3374833,int_stack+3360469, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1884395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3466855,int_stack+3380881,int_stack+3365173, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3475675,int_stack+1456328,int_stack+1454788, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3480295,int_stack+3475675,int_stack+3371053, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3487855,int_stack+3480295,int_stack+3374833, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3475675,int_stack+3487855,int_stack+3380881, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1904807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3487435,int_stack+3475675,int_stack+3466855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1912647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+3499783,int_stack+3487435,int_stack+3348184,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3475675,int_stack+1465960,int_stack+1465204, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3477943,int_stack+1466968,int_stack+1465960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1574646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3480967,int_stack+3477943,int_stack+3475675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3388721,int_stack+1468264,int_stack+1466968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3527566,int_stack+3388721,int_stack+3477943, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1971475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3533614,int_stack+3527566,int_stack+3480967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3541174,int_stack+1469884,int_stack+1468264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1579254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3546034,int_stack+3541174,int_stack+3388721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3553810,int_stack+3546034,int_stack+3527566, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3563890,int_stack+3553810,int_stack+3533614, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2031034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3575230,int_stack+1471864,int_stack+1469884, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1582494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3581170,int_stack+3575230,int_stack+3541174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2038594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3590890,int_stack+3581170,int_stack+3546034, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3575230,int_stack+3590890,int_stack+3553810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2051230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3590350,int_stack+3575230,int_stack+3563890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2061310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3606226,int_stack+3590350,int_stack+3487435,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+3643270,int_stack+3606226,int_stack+3499783,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3575230,int_stack+667121,int_stack+665231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3578065,int_stack+669641,int_stack+667121, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3581845,int_stack+3578065,int_stack+3575230, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3698836,int_stack+672881,int_stack+669641, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3703696,int_stack+3698836,int_stack+3578065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2136865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3711256,int_stack+3703696,int_stack+3581845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3720706,int_stack+676931,int_stack+672881, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+758616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3726781,int_stack+3720706,int_stack+3698836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3736501,int_stack+3726781,int_stack+3703696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2262496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3749101,int_stack+3736501,int_stack+3711256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2270056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3763276,int_stack+8910,int_stack+676931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3770701,int_stack+3763276,int_stack+3720706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2279506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3782851,int_stack+3770701,int_stack+3726781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3763276,int_stack+3782851,int_stack+3736501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2295301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3782176,int_stack+3763276,int_stack+3749101, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2307901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+3802021,int_stack+3782176,int_stack+3590350,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+3849649,int_stack+3802021,int_stack+3606226,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3763276,int_stack+1495012,int_stack+1494571, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3764599,int_stack+1495600,int_stack+1495012, 0.0, zero_stack, 1.0, int_stack+1725857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3766363,int_stack+3764599,int_stack+3763276, 0.0, zero_stack, 1.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3769009,int_stack+1496356,int_stack+1495600, 0.0, zero_stack, 1.0, int_stack+1726445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3771277,int_stack+3769009,int_stack+3764599, 0.0, zero_stack, 1.0, int_stack+1793003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3774805,int_stack+3771277,int_stack+3766363, 0.0, zero_stack, 1.0, int_stack+1794767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3587515,int_stack+1497301,int_stack+1496356, 0.0, zero_stack, 1.0, int_stack+1727201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3779215,int_stack+3587515,int_stack+3769009, 0.0, zero_stack, 1.0, int_stack+1797413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3783751,int_stack+3779215,int_stack+3771277, 0.0, zero_stack, 1.0, int_stack+1799681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3789631,int_stack+3783751,int_stack+3774805, 0.0, zero_stack, 1.0, int_stack+1803209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3796246,int_stack+1498456,int_stack+1497301, 0.0, zero_stack, 1.0, int_stack+1728146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3799711,int_stack+3796246,int_stack+3587515, 0.0, zero_stack, 1.0, int_stack+1807619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3805381,int_stack+3799711,int_stack+3779215, 0.0, zero_stack, 1.0, int_stack+1810454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3796246,int_stack+3805381,int_stack+3783751, 0.0, zero_stack, 1.0, int_stack+1814990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3805066,int_stack+3796246,int_stack+3789631, 0.0, zero_stack, 1.0, int_stack+1820870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3796246,int_stack+1505701,int_stack+1505113, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3798010,int_stack+1506485,int_stack+1505701, 0.0, zero_stack, 1.0, int_stack+1741817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3800362,int_stack+3798010,int_stack+3796246, 0.0, zero_stack, 1.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3814327,int_stack+1507493,int_stack+1506485, 0.0, zero_stack, 1.0, int_stack+1742601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3817351,int_stack+3814327,int_stack+3798010, 0.0, zero_stack, 1.0, int_stack+1865054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3822055,int_stack+3817351,int_stack+3800362, 0.0, zero_stack, 1.0, int_stack+1867406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3827935,int_stack+1508753,int_stack+1507493, 0.0, zero_stack, 1.0, int_stack+1743609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3831715,int_stack+3827935,int_stack+3814327, 0.0, zero_stack, 1.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3837763,int_stack+3831715,int_stack+3817351, 0.0, zero_stack, 1.0, int_stack+1884395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+3837763,int_stack+3822055, 0.0, zero_stack, 1.0, int_stack+1889099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5292,int_stack+1510293,int_stack+1508753, 0.0, zero_stack, 1.0, int_stack+1744869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3932557,int_stack+5292,int_stack+3827935, 0.0, zero_stack, 1.0, int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3940117,int_stack+3932557,int_stack+3831715, 0.0, zero_stack, 1.0, int_stack+1898759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3950197,int_stack+3940117,int_stack+3837763, 0.0, zero_stack, 1.0, int_stack+1904807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3932557,int_stack+3950197,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+1912647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+3944905,int_stack+3932557,int_stack+3805066,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5292,int_stack+1519925,int_stack+1519169, 0.0, zero_stack, 1.0, int_stack+1573134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7560,int_stack+1520933,int_stack+1519925, 0.0, zero_stack, 1.0, int_stack+1574646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3972688,int_stack+7560,int_stack+5292, 0.0, zero_stack, 1.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3845603,int_stack+1522229,int_stack+1520933, 0.0, zero_stack, 1.0, int_stack+1576662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3977224,int_stack+3845603,int_stack+7560, 0.0, zero_stack, 1.0, int_stack+1971475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3983272,int_stack+3977224,int_stack+3972688, 0.0, zero_stack, 1.0, int_stack+1974499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3990832,int_stack+1523849,int_stack+1522229, 0.0, zero_stack, 1.0, int_stack+1579254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3995692,int_stack+3990832,int_stack+3845603, 0.0, zero_stack, 1.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4003468,int_stack+3995692,int_stack+3977224, 0.0, zero_stack, 1.0, int_stack+2024986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4013548,int_stack+4003468,int_stack+3983272, 0.0, zero_stack, 1.0, int_stack+2031034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4024888,int_stack+1525829,int_stack+1523849, 0.0, zero_stack, 1.0, int_stack+1582494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4030828,int_stack+4024888,int_stack+3990832, 0.0, zero_stack, 1.0, int_stack+2038594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4040548,int_stack+4030828,int_stack+3995692, 0.0, zero_stack, 1.0, int_stack+2043454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4024888,int_stack+4040548,int_stack+4003468, 0.0, zero_stack, 1.0, int_stack+2051230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4040008,int_stack+4024888,int_stack+4013548, 0.0, zero_stack, 1.0, int_stack+2061310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+4055884,int_stack+4040008,int_stack+3932557,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+4092928,int_stack+4055884,int_stack+3944905,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4024888,int_stack+708076,int_stack+706186, 0.0, zero_stack, 1.0, int_stack+747141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4027723,int_stack+710596,int_stack+708076, 0.0, zero_stack, 1.0, int_stack+749976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4031503,int_stack+4027723,int_stack+4024888, 0.0, zero_stack, 1.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4148494,int_stack+713836,int_stack+710596, 0.0, zero_stack, 1.0, int_stack+753756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4153354,int_stack+4148494,int_stack+4027723, 0.0, zero_stack, 1.0, int_stack+2136865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4160914,int_stack+4153354,int_stack+4031503, 0.0, zero_stack, 1.0, int_stack+2140645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4170364,int_stack+717886,int_stack+713836, 0.0, zero_stack, 1.0, int_stack+758616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4176439,int_stack+4170364,int_stack+4148494, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4186159,int_stack+4176439,int_stack+4153354, 0.0, zero_stack, 1.0, int_stack+2262496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4198759,int_stack+4186159,int_stack+4160914, 0.0, zero_stack, 1.0, int_stack+2270056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4212934,int_stack+11880,int_stack+717886, 0.0, zero_stack, 1.0, int_stack+14850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4220359,int_stack+4212934,int_stack+4170364, 0.0, zero_stack, 1.0, int_stack+2279506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4232509,int_stack+4220359,int_stack+4176439, 0.0, zero_stack, 1.0, int_stack+2285581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4212934,int_stack+4232509,int_stack+4186159, 0.0, zero_stack, 1.0, int_stack+2295301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4231834,int_stack+4212934,int_stack+4198759, 0.0, zero_stack, 1.0, int_stack+2307901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+4251679,int_stack+4231834,int_stack+4040008,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+4299307,int_stack+4251679,int_stack+4055884,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4212934,int_stack+1548977,int_stack+1548536, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4214257,int_stack+1549565,int_stack+1548977, 1.0, int_stack+1725857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4216021,int_stack+4214257,int_stack+4212934, 1.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4218667,int_stack+1550321,int_stack+1549565, 1.0, int_stack+1726445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4220935,int_stack+4218667,int_stack+4214257, 1.0, int_stack+1793003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4224463,int_stack+4220935,int_stack+4216021, 1.0, int_stack+1794767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4037173,int_stack+1551266,int_stack+1550321, 1.0, int_stack+1727201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1791680,int_stack+4037173,int_stack+4218667, 1.0, int_stack+1797413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4228873,int_stack+1791680,int_stack+4220935, 1.0, int_stack+1799681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1796216,int_stack+4228873,int_stack+4224463, 1.0, int_stack+1803209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1802831,int_stack+1552421,int_stack+1551266, 1.0, int_stack+1728146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4234753,int_stack+1802831,int_stack+4037173, 1.0, int_stack+1807619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4240423,int_stack+4234753,int_stack+1791680, 1.0, int_stack+1810454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4247983,int_stack+4240423,int_stack+4228873, 1.0, int_stack+1814990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4234753,int_stack+4247983,int_stack+1796216, 1.0, int_stack+1820870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4244014,int_stack+1559666,int_stack+1559078, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4245778,int_stack+1560450,int_stack+1559666, 1.0, int_stack+1741817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4248130,int_stack+4245778,int_stack+4244014, 1.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4251658,int_stack+1561458,int_stack+1560450, 1.0, int_stack+1742601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4254682,int_stack+4251658,int_stack+4245778, 1.0, int_stack+1865054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4259386,int_stack+4254682,int_stack+4248130, 1.0, int_stack+1867406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1863290,int_stack+1562718,int_stack+1561458, 1.0, int_stack+1743609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4265266,int_stack+1863290,int_stack+4251658, 1.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4271314,int_stack+4265266,int_stack+4254682, 1.0, int_stack+1884395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4279154,int_stack+4271314,int_stack+4259386, 1.0, int_stack+1889099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1881371,int_stack+1564258,int_stack+1562718, 1.0, int_stack+1744869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1885991,int_stack+1881371,int_stack+1863290, 1.0, int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4287974,int_stack+1885991,int_stack+4265266, 1.0, int_stack+1898759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1881371,int_stack+4287974,int_stack+4271314, 1.0, int_stack+1904807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4373395,int_stack+1881371,int_stack+4279154, 1.0, int_stack+1912647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+4385743,int_stack+4373395,int_stack+4234753,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1881371,int_stack+1575654,int_stack+1573890, 1.0, int_stack+1573134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1883639,int_stack+1577958,int_stack+1575654, 1.0, int_stack+1574646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1886663,int_stack+1883639,int_stack+1881371, 1.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4287974,int_stack+1580874,int_stack+1577958, 1.0, int_stack+1576662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4291862,int_stack+4287974,int_stack+1883639, 1.0, int_stack+1971475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4413526,int_stack+4291862,int_stack+1886663, 1.0, int_stack+1974499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1969207,int_stack+1584474,int_stack+1580874, 1.0, int_stack+1579254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4421086,int_stack+1969207,int_stack+4287974, 1.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4428862,int_stack+4421086,int_stack+4291862, 1.0, int_stack+2024986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4438942,int_stack+4428862,int_stack+4413526, 1.0, int_stack+2031034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2021098,int_stack+1586454,int_stack+1584474, 1.0, int_stack+1582494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2027038,int_stack+2021098,int_stack+1969207, 1.0, int_stack+2038594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4450282,int_stack+2027038,int_stack+4421086, 1.0, int_stack+2043454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2021098,int_stack+4450282,int_stack+4428862, 1.0, int_stack+2051230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4450282,int_stack+2021098,int_stack+4438942, 1.0, int_stack+2061310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+4466158,int_stack+4450282,int_stack+4373395,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+4503202,int_stack+4466158,int_stack+4385743,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2021098,int_stack+751236,int_stack+748086, 1.0, int_stack+747141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1891199,int_stack+755376,int_stack+751236, 1.0, int_stack+749976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2023933,int_stack+1891199,int_stack+2021098, 1.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2029603,int_stack+760641,int_stack+755376, 1.0, int_stack+753756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4558768,int_stack+2029603,int_stack+1891199, 1.0, int_stack+2136865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4566328,int_stack+4558768,int_stack+2023933, 1.0, int_stack+2140645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2134030,int_stack+764691,int_stack+760641, 1.0, int_stack+758616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4575778,int_stack+2134030,int_stack+2029603, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4585498,int_stack+4575778,int_stack+4558768, 1.0, int_stack+2262496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4598098,int_stack+4585498,int_stack+4566328, 1.0, int_stack+2270056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2257636,int_stack+17325,int_stack+764691, 1.0, int_stack+14850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2265061,int_stack+2257636,int_stack+2134030, 1.0, int_stack+2279506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4612273,int_stack+2265061,int_stack+4575778, 1.0, int_stack+2285581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2257636,int_stack+4612273,int_stack+4585498, 1.0, int_stack+2295301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2276536,int_stack+2257636,int_stack+4598098, 1.0, int_stack+2307901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+4612273,int_stack+2276536,int_stack+4450282,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+4659901,int_stack+4612273,int_stack+4466158,441);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4612273,int_stack+1729301,int_stack+1728146,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4615738,int_stack+4612273,int_stack+1807619,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4621408,int_stack+4615738,int_stack+1810454,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4612273,int_stack+4621408,int_stack+1814990,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4621093,int_stack+4612273,int_stack+1820870,21);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4612273,int_stack+1746409,int_stack+1744869,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4630354,int_stack+4612273,int_stack+1894979,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4637914,int_stack+4630354,int_stack+1898759,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4647994,int_stack+4637914,int_stack+1904807,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4630354,int_stack+4647994,int_stack+1912647,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2257636,int_stack+4630354,int_stack+4621093,441);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4642702,int_stack+26235,int_stack+1582494,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4648642,int_stack+4642702,int_stack+2038594,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1894979,int_stack+4648642,int_stack+2043454,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4642702,int_stack+1894979,int_stack+2051230,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+4642702,int_stack+2061310,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2034463,int_stack+1894979,int_stack+4630354,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+4733989,int_stack+2034463,int_stack+2257636,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4642702,int_stack+1617927,int_stack+1617486,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4644025,int_stack+1618515,int_stack+1617927,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4645789,int_stack+4644025,int_stack+4642702,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4648435,int_stack+1619271,int_stack+1618515,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4650703,int_stack+4648435,int_stack+4644025,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4654231,int_stack+4650703,int_stack+4645789,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1910855,int_stack+1620216,int_stack+1619271,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1913690,int_stack+1910855,int_stack+4648435,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4612273,int_stack+1913690,int_stack+4650703,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2285419,int_stack+4612273,int_stack+4654231,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2292034,int_stack+1621371,int_stack+1620216,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2295499,int_stack+2292034,int_stack+1910855,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2301169,int_stack+2295499,int_stack+1913690,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2292034,int_stack+2301169,int_stack+4612273,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2300854,int_stack+2292034,int_stack+2285419,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2292034,int_stack+1628616,int_stack+1628028,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2293798,int_stack+1629400,int_stack+1628616,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2296150,int_stack+2293798,int_stack+2292034,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2310115,int_stack+1630408,int_stack+1629400,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2313139,int_stack+2310115,int_stack+2293798,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2140105,int_stack+2313139,int_stack+2296150,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2317843,int_stack+1631668,int_stack+1630408,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1974067,int_stack+2317843,int_stack+2310115,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1802831,int_stack+1974067,int_stack+2313139,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1810671,int_stack+1802831,int_stack+2140105,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1867070,int_stack+1633208,int_stack+1631668,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1819491,int_stack+1867070,int_stack+2317843,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4789555,int_stack+1819491,int_stack+1974067,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4799635,int_stack+4789555,int_stack+1802831,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4811395,int_stack+4799635,int_stack+1810671,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+4823743,int_stack+4811395,int_stack+2300854, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4621093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4789555,int_stack+1642840,int_stack+1642084,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4791823,int_stack+1643848,int_stack+1642840,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4794847,int_stack+4791823,int_stack+4789555,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4799383,int_stack+1645144,int_stack+1643848,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4803271,int_stack+4799383,int_stack+4791823,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1819491,int_stack+4803271,int_stack+4794847,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1867070,int_stack+1646764,int_stack+1645144,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+10584,int_stack+1867070,int_stack+4799383,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4851526,int_stack+10584,int_stack+4803271,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+4861606,int_stack+4851526,int_stack+1819491,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1741229,int_stack+1648744,int_stack+1646764,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4872946,int_stack+1741229,int_stack+1867070,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+4882666,int_stack+4872946,int_stack+10584,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4895626,int_stack+4882666,int_stack+4851526,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+4872946,int_stack+4895626,int_stack+4861606,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+4888822,int_stack+4872946,int_stack+4811395, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4630354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+4925866,int_stack+4888822,int_stack+4823743, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1741229,int_stack+958986,int_stack+957096,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1744064,int_stack+961506,int_stack+958986,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4981432,int_stack+1744064,int_stack+1741229,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1725416,int_stack+964746,int_stack+961506,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4987102,int_stack+1725416,int_stack+1744064,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+4994662,int_stack+4987102,int_stack+4981432,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5004112,int_stack+968796,int_stack+964746,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5010187,int_stack+5004112,int_stack+1725416,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5019907,int_stack+5010187,int_stack+4987102,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5032507,int_stack+5019907,int_stack+4994662,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5046682,int_stack+20295,int_stack+968796,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5054107,int_stack+5046682,int_stack+5004112,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5066257,int_stack+5054107,int_stack+5010187,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5046682,int_stack+5066257,int_stack+5019907,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5065582,int_stack+5046682,int_stack+5032507,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+5085427,int_stack+5065582,int_stack+4872946, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+5133055,int_stack+5085427,int_stack+4888822, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5046682,int_stack+1671892,int_stack+1671451,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5048005,int_stack+1672480,int_stack+1671892,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5049769,int_stack+5048005,int_stack+5046682,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5052415,int_stack+1673236,int_stack+1672480,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5054683,int_stack+5052415,int_stack+5048005,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5058211,int_stack+5054683,int_stack+5049769,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5062621,int_stack+1674181,int_stack+1673236,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5065456,int_stack+5062621,int_stack+5052415,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5069992,int_stack+5065456,int_stack+5054683,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5075872,int_stack+5069992,int_stack+5058211,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5082487,int_stack+1675336,int_stack+1674181,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5085952,int_stack+5082487,int_stack+5062621,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5091622,int_stack+5085952,int_stack+5065456,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5082487,int_stack+5091622,int_stack+5069992,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5091307,int_stack+5082487,int_stack+5075872,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5082487,int_stack+1682581,int_stack+1681993,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5084251,int_stack+1683365,int_stack+1682581,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5086603,int_stack+5084251,int_stack+5082487,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5100568,int_stack+1684373,int_stack+1683365,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5103592,int_stack+5100568,int_stack+5084251,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5108296,int_stack+5103592,int_stack+5086603,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5114176,int_stack+1685633,int_stack+1684373,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5117956,int_stack+5114176,int_stack+5100568,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5124004,int_stack+5117956,int_stack+5103592,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5207143,int_stack+5124004,int_stack+5108296,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+18360,int_stack+1687173,int_stack+1685633,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5215963,int_stack+18360,int_stack+5114176,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5223523,int_stack+5215963,int_stack+5117956,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5233603,int_stack+5223523,int_stack+5124004,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5215963,int_stack+5233603,int_stack+5207143,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+5228311,int_stack+5215963,int_stack+5091307, 0.0, zero_stack, 1.0, int_stack+4621093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+18360,int_stack+1696805,int_stack+1696049,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1918226,int_stack+1697813,int_stack+1696805,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5256094,int_stack+1918226,int_stack+18360,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5260630,int_stack+1699109,int_stack+1697813,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5264518,int_stack+5260630,int_stack+1918226,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5270566,int_stack+5264518,int_stack+5256094,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5278126,int_stack+1700729,int_stack+1699109,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5282986,int_stack+5278126,int_stack+5260630,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5290762,int_stack+5282986,int_stack+5264518,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5300842,int_stack+5290762,int_stack+5270566,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5312182,int_stack+1702709,int_stack+1700729,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5318122,int_stack+5312182,int_stack+5278126,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5327842,int_stack+5318122,int_stack+5282986,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5312182,int_stack+5327842,int_stack+5290762,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5327302,int_stack+5312182,int_stack+5300842,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+5343178,int_stack+5327302,int_stack+5215963, 0.0, zero_stack, 1.0, int_stack+4630354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+5380222,int_stack+5343178,int_stack+5228311, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5312182,int_stack+1195721,int_stack+1193831,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5315017,int_stack+1198241,int_stack+1195721,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5318797,int_stack+5315017,int_stack+5312182,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5435788,int_stack+1201481,int_stack+1198241,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5440648,int_stack+5435788,int_stack+5315017,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5448208,int_stack+5440648,int_stack+5318797,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5457658,int_stack+1205531,int_stack+1201481,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5463733,int_stack+5457658,int_stack+5435788,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5473453,int_stack+5463733,int_stack+5440648,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5486053,int_stack+5473453,int_stack+5448208,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5500228,int_stack+23265,int_stack+1205531,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5507653,int_stack+5500228,int_stack+5457658,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5519803,int_stack+5507653,int_stack+5463733,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5500228,int_stack+5519803,int_stack+5473453,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5519128,int_stack+5500228,int_stack+5486053,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+5538973,int_stack+5519128,int_stack+5327302, 0.0, zero_stack, 1.0, int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+5586601,int_stack+5538973,int_stack+5343178, 0.0, zero_stack, 1.0, int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5500228,int_stack+1731128,int_stack+1730687,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5501551,int_stack+1731716,int_stack+1731128,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5503315,int_stack+5501551,int_stack+5500228,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5505961,int_stack+1732472,int_stack+1731716,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5508229,int_stack+5505961,int_stack+5501551,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5511757,int_stack+5508229,int_stack+5503315,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5324467,int_stack+1733417,int_stack+1732472,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5516167,int_stack+5324467,int_stack+5505961,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5520703,int_stack+5516167,int_stack+5508229,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5526583,int_stack+5520703,int_stack+5511757,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5533198,int_stack+1734572,int_stack+1733417,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5536663,int_stack+5533198,int_stack+5324467,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5542333,int_stack+5536663,int_stack+5516167,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5533198,int_stack+5542333,int_stack+5520703,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5542018,int_stack+5533198,int_stack+5526583,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5533198,int_stack+1748845,int_stack+1748257,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5534962,int_stack+1749629,int_stack+1748845,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5537314,int_stack+5534962,int_stack+5533198,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5551279,int_stack+1750637,int_stack+1749629,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5554303,int_stack+5551279,int_stack+5534962,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5559007,int_stack+5554303,int_stack+5537314,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5564887,int_stack+1751897,int_stack+1750637,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5568667,int_stack+5564887,int_stack+5551279,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5574715,int_stack+5568667,int_stack+5554303,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5660689,int_stack+5574715,int_stack+5559007,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+20628,int_stack+1753437,int_stack+1751897,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5669509,int_stack+20628,int_stack+5564887,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5677069,int_stack+5669509,int_stack+5568667,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5687149,int_stack+5677069,int_stack+5574715,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5669509,int_stack+5687149,int_stack+5660689,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+5681857,int_stack+5669509,int_stack+5542018, 1.0, int_stack+4621093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+20628,int_stack+1763069,int_stack+1762313,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+22896,int_stack+1764077,int_stack+1763069,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4618153,int_stack+22896,int_stack+20628,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5582555,int_stack+1765373,int_stack+1764077,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4622689,int_stack+5582555,int_stack+22896,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5709640,int_stack+4622689,int_stack+4618153,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5717200,int_stack+1766993,int_stack+1765373,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5722060,int_stack+5717200,int_stack+5582555,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5729836,int_stack+5722060,int_stack+4622689,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5739916,int_stack+5729836,int_stack+5709640,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5751256,int_stack+1768973,int_stack+1766993,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5757196,int_stack+5751256,int_stack+5717200,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5766916,int_stack+5757196,int_stack+5722060,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5751256,int_stack+5766916,int_stack+5729836,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5766376,int_stack+5751256,int_stack+5739916,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+5782252,int_stack+5766376,int_stack+5669509, 1.0, int_stack+4630354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+5819296,int_stack+5782252,int_stack+5681857, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2257636,int_stack+1599756,int_stack+1597866,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2260471,int_stack+1602276,int_stack+1599756,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2264251,int_stack+2260471,int_stack+2257636,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2269921,int_stack+1605516,int_stack+1602276,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2274781,int_stack+2269921,int_stack+2260471,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5751256,int_stack+2274781,int_stack+2264251,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4628737,int_stack+1609566,int_stack+1605516,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5874862,int_stack+4628737,int_stack+2269921,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5884582,int_stack+5874862,int_stack+2274781,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5897182,int_stack+5884582,int_stack+5751256,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4634812,int_stack+28611,int_stack+1609566,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5911357,int_stack+4634812,int_stack+4628737,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5923507,int_stack+5911357,int_stack+5874862,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5939707,int_stack+5923507,int_stack+5884582,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5911357,int_stack+5939707,int_stack+5897182,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+5931202,int_stack+5911357,int_stack+5766376, 1.0, int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+5978830,int_stack+5931202,int_stack+5782252, 1.0, int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2034463,int_stack+32022,int_stack+31581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1278711,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2035786,int_stack+32610,int_stack+32022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1279152,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2037550,int_stack+2035786,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1827485,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2040196,int_stack+33366,int_stack+32610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1279740,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2042464,int_stack+2040196,int_stack+2035786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1828808,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2045992,int_stack+2042464,int_stack+2037550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1830572,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2034463,int_stack+34311,int_stack+33366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1280496,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2050402,int_stack+2034463,int_stack+2040196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1833218,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2054938,int_stack+2050402,int_stack+2042464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1835486,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2037298,int_stack+2054938,int_stack+2045992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1839014,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2043913,int_stack+35466,int_stack+34311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1281441,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+2043913,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1843424,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2060818,int_stack+5760706,int_stack+2050402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1846259,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2043913,int_stack+2060818,int_stack+2054938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1850795,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2052733,int_stack+2043913,int_stack+2037298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1856675,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+37440,int_stack+36852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1289253,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+38224,int_stack+37440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1289841,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2034463,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1921467,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2037991,int_stack+39232,int_stack+38224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1290625,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2041015,int_stack+2037991,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1923231,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2045719,int_stack+2041015,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1925583,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+40492,int_stack+39232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1291633,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2061994,int_stack+5760706,int_stack+2037991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1929111,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1894979,int_stack+2061994,int_stack+2041015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1932135,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2034463,int_stack+1894979,int_stack+2045719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1936839,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2043283,int_stack+42032,int_stack+40492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1292893,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1902819,int_stack+2043283,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1942719,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+5911357,int_stack+1902819,int_stack+2061994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1946499,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5921437,int_stack+5911357,int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1952547,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+5921437,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1960387,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+5911357,int_stack+1894979,int_stack+2052733,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2034463,int_stack+44636,int_stack+43880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1303309,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2036731,int_stack+45644,int_stack+44636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1304065,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2039755,int_stack+2036731,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2072650,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2044291,int_stack+46940,int_stack+45644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1305073,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2048179,int_stack+2044291,int_stack+2036731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2074918,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2054227,int_stack+2048179,int_stack+2039755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2077942,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2034463,int_stack+48560,int_stack+46940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1306369,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2061787,int_stack+2034463,int_stack+2044291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2082478,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5939140,int_stack+2061787,int_stack+2048179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2086366,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2039323,int_stack+5939140,int_stack+2054227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2092414,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2050663,int_stack+50540,int_stack+48560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1307989,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5949220,int_stack+2050663,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2099974,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+5958940,int_stack+5949220,int_stack+2061787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2104834,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2050663,int_stack+5958940,int_stack+5939140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2112610,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+5939140,int_stack+2050663,int_stack+2039323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2122690,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2034463,int_stack+5939140,int_stack+1894979,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+6052918,int_stack+2034463,int_stack+5911357,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5911357,int_stack+53861,int_stack+52916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+542366,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5914192,int_stack+55121,int_stack+53861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+544256,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+5914192,int_stack+5911357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2146315,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5917972,int_stack+56741,int_stack+55121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+546776,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5922832,int_stack+5917972,int_stack+5914192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2322076,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1894979,int_stack+5922832,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2325856,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5911357,int_stack+58766,int_stack+56741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+550016,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5955016,int_stack+5911357,int_stack+5917972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2331526,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5964736,int_stack+5955016,int_stack+5922832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2336386,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5917432,int_stack+5964736,int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2343946,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1894979,int_stack+61241,int_stack+58766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+554066,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25920,int_stack+1894979,int_stack+5911357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2353396,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+38070,int_stack+25920,int_stack+5955016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2359471,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+38070,int_stack+5964736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2369191,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+5955016,int_stack+6108484,int_stack+5917432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2381791,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+5955016,int_stack+5939140,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+6156112,int_stack+6108484,int_stack+2034463,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2034463,int_stack+64652,int_stack+64211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1278711, 1.0, int_stack+1332676,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2035786,int_stack+65240,int_stack+64652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279152, 1.0, int_stack+1333117,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2037550,int_stack+2035786,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827485, 1.0, int_stack+2395966,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2040196,int_stack+65996,int_stack+65240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279740, 1.0, int_stack+1333705,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2042464,int_stack+2040196,int_stack+2035786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1828808, 1.0, int_stack+2397289,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2045992,int_stack+2042464,int_stack+2037550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1830572, 1.0, int_stack+2399053,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2034463,int_stack+66941,int_stack+65996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1280496, 1.0, int_stack+1334461,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2050402,int_stack+2034463,int_stack+2040196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1833218, 1.0, int_stack+2401699,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2054938,int_stack+2050402,int_stack+2042464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835486, 1.0, int_stack+2403967,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2037298,int_stack+2054938,int_stack+2045992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1839014, 1.0, int_stack+2407495,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2043913,int_stack+68096,int_stack+66941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1281441, 1.0, int_stack+1335406,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+2043913,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1843424, 1.0, int_stack+2411905,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2060818,int_stack+5760706,int_stack+2050402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1846259, 1.0, int_stack+2414740,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2043913,int_stack+2060818,int_stack+2054938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1850795, 1.0, int_stack+2419276,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2052733,int_stack+2043913,int_stack+2037298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1856675, 1.0, int_stack+2425156,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+70070,int_stack+69482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1289253, 1.0, int_stack+1343218,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+70854,int_stack+70070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1289841, 1.0, int_stack+1343806,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2034463,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1921467, 1.0, int_stack+2431771,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2037991,int_stack+71862,int_stack+70854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1290625, 1.0, int_stack+1344590,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2041015,int_stack+2037991,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1923231, 1.0, int_stack+2433535,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2045719,int_stack+2041015,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1925583, 1.0, int_stack+2435887,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+73122,int_stack+71862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1291633, 1.0, int_stack+1345598,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2061994,int_stack+5760706,int_stack+2037991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1929111, 1.0, int_stack+2449852,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6108484,int_stack+2061994,int_stack+2041015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1932135, 1.0, int_stack+2452876,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2034463,int_stack+6108484,int_stack+2045719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1936839, 1.0, int_stack+2457580,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2043283,int_stack+74662,int_stack+73122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1292893, 1.0, int_stack+1346858,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6116324,int_stack+2043283,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942719, 1.0, int_stack+2463460,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6123884,int_stack+6116324,int_stack+2061994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1946499, 1.0, int_stack+2467240,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6133964,int_stack+6123884,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1952547, 1.0, int_stack+2473288,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+6133964,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1960387, 1.0, int_stack+2556427,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6120832,int_stack+6108484,int_stack+2052733,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2034463,int_stack+77266,int_stack+76510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1303309, 1.0, int_stack+1357274,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2036731,int_stack+78274,int_stack+77266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304065, 1.0, int_stack+1358030,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2039755,int_stack+2036731,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2072650, 1.0, int_stack+2565247,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2044291,int_stack+79570,int_stack+78274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1305073, 1.0, int_stack+1359038,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2048179,int_stack+2044291,int_stack+2036731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2074918, 1.0, int_stack+2567515,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2054227,int_stack+2048179,int_stack+2039755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2077942, 1.0, int_stack+2570539,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2034463,int_stack+81190,int_stack+79570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1306369, 1.0, int_stack+1360334,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2061787,int_stack+2034463,int_stack+2044291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2082478, 1.0, int_stack+2617138,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25920,int_stack+2061787,int_stack+2048179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2086366, 1.0, int_stack+2621026,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2039323,int_stack+25920,int_stack+2054227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2092414, 1.0, int_stack+2627074,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2050663,int_stack+83170,int_stack+81190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1307989, 1.0, int_stack+1361954,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+36000,int_stack+2050663,int_stack+2034463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2099974, 1.0, int_stack+2634634,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+45720,int_stack+36000,int_stack+2061787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2104834, 1.0, int_stack+2639494,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2050663,int_stack+45720,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2112610, 1.0, int_stack+2647270,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+2050663,int_stack+2039323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2122690, 1.0, int_stack+2657350,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+25920,int_stack+1894979,int_stack+6108484,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+5911357,int_stack+25920,int_stack+6120832,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+86491,int_stack+85546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542366, 1.0, int_stack+583321,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6111319,int_stack+87751,int_stack+86491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544256, 1.0, int_stack+585211,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6111319,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2146315, 1.0, int_stack+2668690,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6115099,int_stack+89371,int_stack+87751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+546776, 1.0, int_stack+587731,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6119959,int_stack+6115099,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2322076, 1.0, int_stack+2671525,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6127519,int_stack+6119959,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2325856, 1.0, int_stack+2675305,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+91396,int_stack+89371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550016, 1.0, int_stack+590971,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136969,int_stack+6108484,int_stack+6115099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331526, 1.0, int_stack+2792296,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+62964,int_stack+6136969,int_stack+6119959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2336386, 1.0, int_stack+2797156,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+75564,int_stack+62964,int_stack+6127519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2343946, 1.0, int_stack+2804716,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6114559,int_stack+93871,int_stack+91396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554066, 1.0, int_stack+595021,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6121984,int_stack+6114559,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2353396, 1.0, int_stack+2814166,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2034463,int_stack+6121984,int_stack+6136969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2359471, 1.0, int_stack+2820241,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+2034463,int_stack+62964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2369191, 1.0, int_stack+2829961,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2034463,int_stack+6108484,int_stack+75564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2381791, 1.0, int_stack+2842561,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+2034463,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+6230200,int_stack+6108484,int_stack+25920,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25920,int_stack+97282,int_stack+96841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1332676, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+27243,int_stack+97870,int_stack+97282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1333117, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+29007,int_stack+27243,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2395966, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31653,int_stack+98626,int_stack+97870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1333705, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33921,int_stack+31653,int_stack+27243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2397289, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+37449,int_stack+33921,int_stack+29007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2399053, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+25920,int_stack+99571,int_stack+98626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1334461, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+41859,int_stack+25920,int_stack+31653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2401699, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+46395,int_stack+41859,int_stack+33921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2403967, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+28755,int_stack+46395,int_stack+37449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2407495, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+35370,int_stack+100726,int_stack+99571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1335406, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+35370,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2411905, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+52275,int_stack+5760706,int_stack+41859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2414740, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+35370,int_stack+52275,int_stack+46395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2419276, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+44190,int_stack+35370,int_stack+28755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2425156, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+102700,int_stack+102112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1343218, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+103484,int_stack+102700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1343806, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25920,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2431771, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29448,int_stack+104492,int_stack+103484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1344590, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32472,int_stack+29448,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2433535, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+37176,int_stack+32472,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2435887, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+105752,int_stack+104492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1345598, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+53451,int_stack+5760706,int_stack+29448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2449852, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+59499,int_stack+53451,int_stack+32472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2452876, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25920,int_stack+59499,int_stack+37176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2457580, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+34740,int_stack+107292,int_stack+105752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1346858, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+67339,int_stack+34740,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2463460, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+74899,int_stack+67339,int_stack+53451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2467240, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+84979,int_stack+74899,int_stack+59499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2473288, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+53451,int_stack+84979,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2556427, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+65799,int_stack+53451,int_stack+44190,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25920,int_stack+109896,int_stack+109140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1357274, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28188,int_stack+110904,int_stack+109896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1358030, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+31212,int_stack+28188,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2565247, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+35748,int_stack+112200,int_stack+110904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1359038, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+39636,int_stack+35748,int_stack+28188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2567515, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+45684,int_stack+39636,int_stack+31212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2570539, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+25920,int_stack+113820,int_stack+112200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1360334, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+93582,int_stack+25920,int_stack+35748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2617138, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+101358,int_stack+93582,int_stack+39636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2621026, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+30780,int_stack+101358,int_stack+45684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2627074, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+42120,int_stack+115800,int_stack+113820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1361954, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6108484,int_stack+42120,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2634634, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6118204,int_stack+6108484,int_stack+93582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2639494, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6131164,int_stack+6118204,int_stack+101358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2647270, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+6131164,int_stack+30780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2657350, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+1894979,int_stack+53451,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+6304288,int_stack+6108484,int_stack+65799,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6145528,int_stack+119121,int_stack+118176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+583321, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6148363,int_stack+120381,int_stack+119121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+585211, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6148363,int_stack+6145528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2668690, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+25920,int_stack+122001,int_stack+120381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+587731, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+30780,int_stack+25920,int_stack+6148363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2671525, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6145528,int_stack+30780,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2675305, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+38340,int_stack+124026,int_stack+122001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+590971, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+44415,int_stack+38340,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2792296, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54135,int_stack+44415,int_stack+30780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2797156, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+66735,int_stack+54135,int_stack+6145528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2804716, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6145528,int_stack+126501,int_stack+124026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+595021, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25920,int_stack+6145528,int_stack+38340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2814166, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+80910,int_stack+25920,int_stack+44415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2820241, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+25920,int_stack+80910,int_stack+54135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2829961, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+80910,int_stack+25920,int_stack+66735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2842561, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+25920,int_stack+80910,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+6359854,int_stack+25920,int_stack+6108484,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+129912,int_stack+129471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1278711, 0.0, zero_stack, 1.0, int_stack+1386641,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+130500,int_stack+129912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279152, 0.0, zero_stack, 1.0, int_stack+1387082,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827485, 0.0, zero_stack, 1.0, int_stack+2856736,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+131256,int_stack+130500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279740, 0.0, zero_stack, 1.0, int_stack+1387670,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1828808, 0.0, zero_stack, 1.0, int_stack+2858059,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1830572, 0.0, zero_stack, 1.0, int_stack+2859823,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+132201,int_stack+131256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1280496, 0.0, zero_stack, 1.0, int_stack+1388426,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1833218, 0.0, zero_stack, 1.0, int_stack+2862469,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835486, 0.0, zero_stack, 1.0, int_stack+2864737,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1839014, 0.0, zero_stack, 1.0, int_stack+2868265,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+133356,int_stack+132201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1281441, 0.0, zero_stack, 1.0, int_stack+1389371,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1843424, 0.0, zero_stack, 1.0, int_stack+2680975,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1846259, 0.0, zero_stack, 1.0, int_stack+2872675,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6117934,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1850795, 0.0, zero_stack, 1.0, int_stack+2877211,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6126754,int_stack+6117934,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1856675, 0.0, zero_stack, 1.0, int_stack+2883091,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+135330,int_stack+134742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1289253, 0.0, zero_stack, 1.0, int_stack+1397183,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+136114,int_stack+135330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1289841, 0.0, zero_stack, 1.0, int_stack+1397771,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1921467, 0.0, zero_stack, 1.0, int_stack+2889706,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6112012,int_stack+137122,int_stack+136114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1290625, 0.0, zero_stack, 1.0, int_stack+1398555,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6115036,int_stack+6112012,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1923231, 0.0, zero_stack, 1.0, int_stack+2891470,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6119740,int_stack+6115036,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1925583, 0.0, zero_stack, 1.0, int_stack+2893822,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+138382,int_stack+137122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1291633, 0.0, zero_stack, 1.0, int_stack+1399563,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136015,int_stack+5760706,int_stack+6112012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1929111, 0.0, zero_stack, 1.0, int_stack+2907787,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6142063,int_stack+6136015,int_stack+6115036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1932135, 0.0, zero_stack, 1.0, int_stack+2910811,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6142063,int_stack+6119740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1936839, 0.0, zero_stack, 1.0, int_stack+2915515,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117304,int_stack+139922,int_stack+138382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1292893, 0.0, zero_stack, 1.0, int_stack+1400823,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25920,int_stack+6117304,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942719, 0.0, zero_stack, 1.0, int_stack+2921395,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+33480,int_stack+25920,int_stack+6136015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1946499, 0.0, zero_stack, 1.0, int_stack+2925175,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+43560,int_stack+33480,int_stack+6142063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1952547, 0.0, zero_stack, 1.0, int_stack+2931223,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6136015,int_stack+43560,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1960387, 0.0, zero_stack, 1.0, int_stack+3017197,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+25920,int_stack+6136015,int_stack+6126754,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+142526,int_stack+141770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1303309, 0.0, zero_stack, 1.0, int_stack+1411239,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6110752,int_stack+143534,int_stack+142526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304065, 0.0, zero_stack, 1.0, int_stack+1411995,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6113776,int_stack+6110752,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2072650, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6118312,int_stack+144830,int_stack+143534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1305073, 0.0, zero_stack, 1.0, int_stack+1413003,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6122200,int_stack+6118312,int_stack+6110752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2074918, 0.0, zero_stack, 1.0, int_stack+2268,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6128248,int_stack+6122200,int_stack+6113776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2077942, 0.0, zero_stack, 1.0, int_stack+3066148,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+146450,int_stack+144830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1306369, 0.0, zero_stack, 1.0, int_stack+1414299,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+53703,int_stack+6108484,int_stack+6118312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2082478, 0.0, zero_stack, 1.0, int_stack+2939063,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61479,int_stack+53703,int_stack+6122200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2086366, 0.0, zero_stack, 1.0, int_stack+3070684,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6113344,int_stack+61479,int_stack+6128248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2092414, 0.0, zero_stack, 1.0, int_stack+3076732,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6124684,int_stack+148430,int_stack+146450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1307989, 0.0, zero_stack, 1.0, int_stack+1415919,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+71559,int_stack+6124684,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2099974, 0.0, zero_stack, 1.0, int_stack+3084292,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+81279,int_stack+71559,int_stack+53703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2104834, 0.0, zero_stack, 1.0, int_stack+3089152,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+94239,int_stack+81279,int_stack+61479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2112610, 0.0, zero_stack, 1.0, int_stack+3096928,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+94239,int_stack+6113344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2122690, 0.0, zero_stack, 1.0, int_stack+3107008,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+53703,int_stack+1894979,int_stack+6136015,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+90747,int_stack+53703,int_stack+25920,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25920,int_stack+151751,int_stack+150806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542366, 0.0, zero_stack, 1.0, int_stack+624276,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+28755,int_stack+153011,int_stack+151751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544256, 0.0, zero_stack, 1.0, int_stack+626166,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+28755,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2146315, 0.0, zero_stack, 1.0, int_stack+3118348,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+32535,int_stack+154631,int_stack+153011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+546776, 0.0, zero_stack, 1.0, int_stack+628686,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+37395,int_stack+32535,int_stack+28755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2322076, 0.0, zero_stack, 1.0, int_stack+3121183,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6108484,int_stack+37395,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2325856, 0.0, zero_stack, 1.0, int_stack+3124963,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+25920,int_stack+156656,int_stack+154631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550016, 0.0, zero_stack, 1.0, int_stack+631926,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+146313,int_stack+25920,int_stack+32535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331526, 0.0, zero_stack, 1.0, int_stack+3241954,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6117934,int_stack+146313,int_stack+37395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2336386, 0.0, zero_stack, 1.0, int_stack+3246814,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+31995,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2343946, 0.0, zero_stack, 1.0, int_stack+3254374,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+159131,int_stack+156656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554066, 0.0, zero_stack, 1.0, int_stack+635976,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6130534,int_stack+6108484,int_stack+25920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2353396, 0.0, zero_stack, 1.0, int_stack+3263824,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2034463,int_stack+6130534,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2359471, 0.0, zero_stack, 1.0, int_stack+3269899,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6130534,int_stack+2034463,int_stack+6117934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2369191, 0.0, zero_stack, 1.0, int_stack+3279619,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2034463,int_stack+6130534,int_stack+31995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2381791, 0.0, zero_stack, 1.0, int_stack+3292219,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+2034463,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+6433942,int_stack+6108484,int_stack+53703,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+162542,int_stack+162101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1332676, 1.0, int_stack+1386641, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+163130,int_stack+162542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1333117, 1.0, int_stack+1387082, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2395966, 1.0, int_stack+2856736, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+163886,int_stack+163130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1333705, 1.0, int_stack+1387670, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2397289, 1.0, int_stack+2858059, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2399053, 1.0, int_stack+2859823, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+164831,int_stack+163886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1334461, 1.0, int_stack+1388426, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2401699, 1.0, int_stack+2862469, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2403967, 1.0, int_stack+2864737, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2407495, 1.0, int_stack+2868265, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+165986,int_stack+164831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1335406, 1.0, int_stack+1389371, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2411905, 1.0, int_stack+2680975, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2414740, 1.0, int_stack+2872675, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6117934,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2419276, 1.0, int_stack+2877211, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6126754,int_stack+6117934,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2425156, 1.0, int_stack+2883091, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+167960,int_stack+167372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1343218, 1.0, int_stack+1397183, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+168744,int_stack+167960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1343806, 1.0, int_stack+1397771, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2431771, 1.0, int_stack+2889706, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6112012,int_stack+169752,int_stack+168744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1344590, 1.0, int_stack+1398555, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6115036,int_stack+6112012,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2433535, 1.0, int_stack+2891470, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6119740,int_stack+6115036,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2435887, 1.0, int_stack+2893822, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+171012,int_stack+169752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1345598, 1.0, int_stack+1399563, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136015,int_stack+5760706,int_stack+6112012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2449852, 1.0, int_stack+2907787, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6142063,int_stack+6136015,int_stack+6115036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2452876, 1.0, int_stack+2910811, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6142063,int_stack+6119740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2457580, 1.0, int_stack+2915515, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117304,int_stack+172552,int_stack+171012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1346858, 1.0, int_stack+1400823, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1894979,int_stack+6117304,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2463460, 1.0, int_stack+2921395, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2034463,int_stack+1894979,int_stack+6136015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2467240, 1.0, int_stack+2925175, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1894979,int_stack+2034463,int_stack+6142063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2473288, 1.0, int_stack+2931223, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2034463,int_stack+1894979,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2556427, 1.0, int_stack+3017197, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+146313,int_stack+2034463,int_stack+6126754,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+175156,int_stack+174400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357274, 1.0, int_stack+1411239, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6110752,int_stack+176164,int_stack+175156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1358030, 1.0, int_stack+1411995, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6113776,int_stack+6110752,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2565247, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6118312,int_stack+177460,int_stack+176164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1359038, 1.0, int_stack+1413003, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6122200,int_stack+6118312,int_stack+6110752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2567515, 1.0, int_stack+2268, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6128248,int_stack+6122200,int_stack+6113776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2570539, 1.0, int_stack+3066148, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+179080,int_stack+177460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360334, 1.0, int_stack+1414299, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6135808,int_stack+6108484,int_stack+6118312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2617138, 1.0, int_stack+2939063, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6143584,int_stack+6135808,int_stack+6122200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2621026, 1.0, int_stack+3070684, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6113344,int_stack+6143584,int_stack+6128248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2627074, 1.0, int_stack+3076732, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6124684,int_stack+181060,int_stack+179080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1361954, 1.0, int_stack+1415919, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1894979,int_stack+6124684,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2634634, 1.0, int_stack+3084292, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2046811,int_stack+1894979,int_stack+6135808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2639494, 1.0, int_stack+3089152, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1894979,int_stack+2046811,int_stack+6143584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2647270, 1.0, int_stack+3096928, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2046811,int_stack+1894979,int_stack+6113344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2657350, 1.0, int_stack+3107008, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+2046811,int_stack+2034463,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+25920,int_stack+6108484,int_stack+146313,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+146313,int_stack+184381,int_stack+183436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583321, 1.0, int_stack+624276, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+149148,int_stack+185641,int_stack+184381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+585211, 1.0, int_stack+626166, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+149148,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2668690, 1.0, int_stack+3118348, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+152928,int_stack+187261,int_stack+185641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+587731, 1.0, int_stack+628686, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157788,int_stack+152928,int_stack+149148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2671525, 1.0, int_stack+3121183, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+165348,int_stack+157788,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2675305, 1.0, int_stack+3124963, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+146313,int_stack+189286,int_stack+187261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590971, 1.0, int_stack+631926, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+174798,int_stack+146313,int_stack+152928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2792296, 1.0, int_stack+3241954, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1894979,int_stack+174798,int_stack+157788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2797156, 1.0, int_stack+3246814, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6508030,int_stack+1894979,int_stack+165348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2804716, 1.0, int_stack+3254374, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+152388,int_stack+191761,int_stack+189286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595021, 1.0, int_stack+635976, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+159813,int_stack+152388,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2814166, 1.0, int_stack+3263824, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6522205,int_stack+159813,int_stack+174798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2820241, 1.0, int_stack+3269899, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+146313,int_stack+6522205,int_stack+1894979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2829961, 1.0, int_stack+3279619, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+165213,int_stack+146313,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2842561, 1.0, int_stack+3292219, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+165213,int_stack+2046811,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+6555658,int_stack+6508030,int_stack+6108484,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+195172,int_stack+194731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1386641, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+195760,int_stack+195172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1387082, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2856736, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+196516,int_stack+195760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1387670, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2858059, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2859823, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+197461,int_stack+196516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1388426, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2862469, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2864737, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2868265, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+198616,int_stack+197461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1389371, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2680975, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2872675, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6117934,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2877211, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+6117934,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2883091, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+200590,int_stack+200002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1397183, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+201374,int_stack+200590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1397771, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2889706, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6112012,int_stack+202382,int_stack+201374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1398555, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6115036,int_stack+6112012,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2891470, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6119740,int_stack+6115036,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2893822, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+203642,int_stack+202382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1399563, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6125620,int_stack+5760706,int_stack+6112012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2907787, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6131668,int_stack+6125620,int_stack+6115036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2910811, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6131668,int_stack+6119740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2915515, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117304,int_stack+205182,int_stack+203642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1400823, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6139508,int_stack+6117304,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2921395, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6125620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2925175, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6139508,int_stack+6508030,int_stack+6131668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2931223, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6108484,int_stack+6508030,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+207786,int_stack+207030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1411239, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+208794,int_stack+207786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1411995, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6136267,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+210090,int_stack+208794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1413003, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6140803,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6146851,int_stack+6140803,int_stack+6136267, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3066148, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+211710,int_stack+210090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1414299, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6520378,int_stack+81486,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2939063, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528154,int_stack+6520378,int_stack+6140803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3070684, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6538234,int_stack+6528154,int_stack+6146851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3076732, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6136267,int_stack+213690,int_stack+211710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1415919, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6142207,int_stack+6136267,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3084292, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+146313,int_stack+6142207,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3089152, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6136267,int_stack+146313,int_stack+6528154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3096928, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+6136267,int_stack+6538234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3107008, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+146313,int_stack+1894979,int_stack+6508030,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+6629746,int_stack+146313,int_stack+6108484,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+217011,int_stack+216066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+624276, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6111319,int_stack+218271,int_stack+217011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+626166, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6111319,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3118348, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6115099,int_stack+219891,int_stack+218271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+628686, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6119959,int_stack+6115099,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3121183, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6127519,int_stack+6119959,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3124963, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+221916,int_stack+219891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+631926, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136969,int_stack+6108484,int_stack+6115099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3241954, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6508030,int_stack+6136969,int_stack+6119959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3246814, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6520630,int_stack+6508030,int_stack+6127519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3254374, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6114559,int_stack+224391,int_stack+221916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+635976, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6121984,int_stack+6114559,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3263824, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534805,int_stack+6121984,int_stack+6136969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3269899, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+6534805,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3279619, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6534805,int_stack+6108484,int_stack+6520630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3292219, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+6534805,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+6685312,int_stack+6108484,int_stack+146313,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+146313,int_stack+227802,int_stack+227361, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1278711, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1440606,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+147636,int_stack+228390,int_stack+227802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1441047,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+149400,int_stack+147636,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3306394,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+152046,int_stack+229146,int_stack+228390, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1441635,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+154314,int_stack+152046,int_stack+147636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1828808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3307717,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+157842,int_stack+154314,int_stack+149400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1830572, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3309481,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+146313,int_stack+230091,int_stack+229146, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1280496, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1442391,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+162252,int_stack+146313,int_stack+152046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1833218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3312127,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+166788,int_stack+162252,int_stack+154314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3314395,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+149148,int_stack+166788,int_stack+157842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1839014, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3317923,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+155763,int_stack+231246,int_stack+230091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1281441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1443336,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+155763,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1843424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3130633,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+172668,int_stack+5760706,int_stack+162252, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1846259, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3322333,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+155763,int_stack+172668,int_stack+166788, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1850795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3326869,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+155763,int_stack+149148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1856675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3332749,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+233220,int_stack+232632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1289253, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1451148,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+234004,int_stack+233220, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1289841, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1451736,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+146313,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1921467, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3339364,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+149841,int_stack+235012,int_stack+234004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1290625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1452520,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+152865,int_stack+149841,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1923231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3341128,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+157569,int_stack+152865,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1925583, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3343480,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+236272,int_stack+235012, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1291633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1453528,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+163449,int_stack+5760706,int_stack+149841, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1929111, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3357445,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+169497,int_stack+163449,int_stack+152865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1932135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3360469,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+146313,int_stack+169497,int_stack+157569, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1936839, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3365173,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+155133,int_stack+237812,int_stack+236272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1292893, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1454788,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+177337,int_stack+155133,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942719, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3371053,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+184897,int_stack+177337,int_stack+163449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1946499, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3374833,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+155133,int_stack+184897,int_stack+169497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1952547, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3380881,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+166893,int_stack+155133,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1960387, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3466855,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+179241,int_stack+166893,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+240416,int_stack+239660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1303309, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1465204,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+241424,int_stack+240416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1465960,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+146313,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2072650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3475675,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+242720,int_stack+241424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1305073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1466968,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+150849,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2074918, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3477943,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+156897,int_stack+150849,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2077942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3480967,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+244340,int_stack+242720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1306369, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1468264,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+207024,int_stack+81486,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2082478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3388721,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+214800,int_stack+207024,int_stack+150849, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2086366, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3527566,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+224880,int_stack+214800,int_stack+156897, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2092414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3533614,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+146313,int_stack+246320,int_stack+244340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1307989, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1469884,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+152253,int_stack+146313,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2099974, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3541174,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+152253,int_stack+207024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2104834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3546034,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+146313,int_stack+6108484,int_stack+214800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2112610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3553810,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+146313,int_stack+224880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2122690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3563890,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+1894979,int_stack+166893,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+6759400,int_stack+6108484,int_stack+179241,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+146313,int_stack+249641,int_stack+248696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542366, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665231,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+149148,int_stack+250901,int_stack+249641, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667121,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+149148,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2146315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3575230,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+152928,int_stack+252521,int_stack+250901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+546776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669641,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157788,int_stack+152928,int_stack+149148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2322076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3578065,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+165348,int_stack+157788,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2325856, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3581845,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+146313,int_stack+254546,int_stack+252521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+672881,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+174798,int_stack+146313,int_stack+152928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331526, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3698836,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+184518,int_stack+174798,int_stack+157788, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2336386, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3703696,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+197118,int_stack+184518,int_stack+165348, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2343946, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3711256,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+152388,int_stack+257021,int_stack+254546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676931,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+159813,int_stack+152388,int_stack+146313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2353396, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3720706,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+211293,int_stack+159813,int_stack+174798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2359471, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3726781,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+146313,int_stack+211293,int_stack+184518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2369191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3736501,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+211293,int_stack+146313,int_stack+197118, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2381791, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3749101,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+211293,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+146313,int_stack+6508030,int_stack+6108484,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+260432,int_stack+259991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1332676, 0.0, zero_stack, 1.0, int_stack+1440606, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+261020,int_stack+260432, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1333117, 0.0, zero_stack, 1.0, int_stack+1441047, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2395966, 0.0, zero_stack, 1.0, int_stack+3306394, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+261776,int_stack+261020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1333705, 0.0, zero_stack, 1.0, int_stack+1441635, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2397289, 0.0, zero_stack, 1.0, int_stack+3307717, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2399053, 0.0, zero_stack, 1.0, int_stack+3309481, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+262721,int_stack+261776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1334461, 0.0, zero_stack, 1.0, int_stack+1442391, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2401699, 0.0, zero_stack, 1.0, int_stack+3312127, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2403967, 0.0, zero_stack, 1.0, int_stack+3314395, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2407495, 0.0, zero_stack, 1.0, int_stack+3317923, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+263876,int_stack+262721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1335406, 0.0, zero_stack, 1.0, int_stack+1443336, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2411905, 0.0, zero_stack, 1.0, int_stack+3130633, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2414740, 0.0, zero_stack, 1.0, int_stack+3322333, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6117934,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2419276, 0.0, zero_stack, 1.0, int_stack+3326869, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+6117934,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2425156, 0.0, zero_stack, 1.0, int_stack+3332749, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+265850,int_stack+265262, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1343218, 0.0, zero_stack, 1.0, int_stack+1451148, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+266634,int_stack+265850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1343806, 0.0, zero_stack, 1.0, int_stack+1451736, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2431771, 0.0, zero_stack, 1.0, int_stack+3339364, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6112012,int_stack+267642,int_stack+266634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1344590, 0.0, zero_stack, 1.0, int_stack+1452520, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6115036,int_stack+6112012,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2433535, 0.0, zero_stack, 1.0, int_stack+3341128, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6119740,int_stack+6115036,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2435887, 0.0, zero_stack, 1.0, int_stack+3343480, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+268902,int_stack+267642, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1345598, 0.0, zero_stack, 1.0, int_stack+1453528, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6125620,int_stack+5760706,int_stack+6112012, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2449852, 0.0, zero_stack, 1.0, int_stack+3357445, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6131668,int_stack+6125620,int_stack+6115036, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2452876, 0.0, zero_stack, 1.0, int_stack+3360469, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6131668,int_stack+6119740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2457580, 0.0, zero_stack, 1.0, int_stack+3365173, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117304,int_stack+270442,int_stack+268902, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1346858, 0.0, zero_stack, 1.0, int_stack+1454788, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6139508,int_stack+6117304,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2463460, 0.0, zero_stack, 1.0, int_stack+3371053, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6125620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2467240, 0.0, zero_stack, 1.0, int_stack+3374833, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6139508,int_stack+6508030,int_stack+6131668, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2473288, 0.0, zero_stack, 1.0, int_stack+3380881, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2556427, 0.0, zero_stack, 1.0, int_stack+3466855, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6108484,int_stack+6508030,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+273046,int_stack+272290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357274, 0.0, zero_stack, 1.0, int_stack+1465204, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+274054,int_stack+273046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1358030, 0.0, zero_stack, 1.0, int_stack+1465960, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6136267,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2565247, 0.0, zero_stack, 1.0, int_stack+3475675, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+275350,int_stack+274054, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1359038, 0.0, zero_stack, 1.0, int_stack+1466968, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6140803,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2567515, 0.0, zero_stack, 1.0, int_stack+3477943, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6146851,int_stack+6140803,int_stack+6136267, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2570539, 0.0, zero_stack, 1.0, int_stack+3480967, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+276970,int_stack+275350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360334, 0.0, zero_stack, 1.0, int_stack+1468264, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6520378,int_stack+81486,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2617138, 0.0, zero_stack, 1.0, int_stack+3388721, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528154,int_stack+6520378,int_stack+6140803, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2621026, 0.0, zero_stack, 1.0, int_stack+3527566, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6538234,int_stack+6528154,int_stack+6146851, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2627074, 0.0, zero_stack, 1.0, int_stack+3533614, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6136267,int_stack+278950,int_stack+276970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1361954, 0.0, zero_stack, 1.0, int_stack+1469884, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6142207,int_stack+6136267,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2634634, 0.0, zero_stack, 1.0, int_stack+3541174, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1894979,int_stack+6142207,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2639494, 0.0, zero_stack, 1.0, int_stack+3546034, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6136267,int_stack+1894979,int_stack+6528154, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2647270, 0.0, zero_stack, 1.0, int_stack+3553810, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+6136267,int_stack+6538234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2657350, 0.0, zero_stack, 1.0, int_stack+3563890, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+220401,int_stack+1894979,int_stack+6508030,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+6814966,int_stack+220401,int_stack+6108484,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+282271,int_stack+281326, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583321, 0.0, zero_stack, 1.0, int_stack+665231, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6111319,int_stack+283531,int_stack+282271, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+585211, 0.0, zero_stack, 1.0, int_stack+667121, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6111319,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2668690, 0.0, zero_stack, 1.0, int_stack+3575230, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6115099,int_stack+285151,int_stack+283531, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+587731, 0.0, zero_stack, 1.0, int_stack+669641, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6119959,int_stack+6115099,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2671525, 0.0, zero_stack, 1.0, int_stack+3578065, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6127519,int_stack+6119959,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2675305, 0.0, zero_stack, 1.0, int_stack+3581845, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+287176,int_stack+285151, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590971, 0.0, zero_stack, 1.0, int_stack+672881, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136969,int_stack+6108484,int_stack+6115099, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2792296, 0.0, zero_stack, 1.0, int_stack+3698836, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6508030,int_stack+6136969,int_stack+6119959, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2797156, 0.0, zero_stack, 1.0, int_stack+3703696, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6520630,int_stack+6508030,int_stack+6127519, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2804716, 0.0, zero_stack, 1.0, int_stack+3711256, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6114559,int_stack+289651,int_stack+287176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595021, 0.0, zero_stack, 1.0, int_stack+676931, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6121984,int_stack+6114559,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2814166, 0.0, zero_stack, 1.0, int_stack+3720706, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534805,int_stack+6121984,int_stack+6136969, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2820241, 0.0, zero_stack, 1.0, int_stack+3726781, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+6534805,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2829961, 0.0, zero_stack, 1.0, int_stack+3736501, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6534805,int_stack+6108484,int_stack+6520630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2842561, 0.0, zero_stack, 1.0, int_stack+3749101, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+6534805,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+6870532,int_stack+6108484,int_stack+220401,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+220401,int_stack+293062,int_stack+292621, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1386641, 1.0, int_stack+1440606, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+221724,int_stack+293650,int_stack+293062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1387082, 1.0, int_stack+1441047, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+223488,int_stack+221724,int_stack+220401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2856736, 1.0, int_stack+3306394, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+226134,int_stack+294406,int_stack+293650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1387670, 1.0, int_stack+1441635, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+228402,int_stack+226134,int_stack+221724, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2858059, 1.0, int_stack+3307717, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+231930,int_stack+228402,int_stack+223488, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2859823, 1.0, int_stack+3309481, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+220401,int_stack+295351,int_stack+294406, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1388426, 1.0, int_stack+1442391, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+236340,int_stack+220401,int_stack+226134, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2862469, 1.0, int_stack+3312127, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+240876,int_stack+236340,int_stack+228402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2864737, 1.0, int_stack+3314395, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+223236,int_stack+240876,int_stack+231930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2868265, 1.0, int_stack+3317923, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+229851,int_stack+296506,int_stack+295351, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1389371, 1.0, int_stack+1443336, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+229851,int_stack+220401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2680975, 1.0, int_stack+3130633, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+246756,int_stack+5760706,int_stack+236340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2872675, 1.0, int_stack+3322333, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+229851,int_stack+246756,int_stack+240876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877211, 1.0, int_stack+3326869, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+229851,int_stack+223236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2883091, 1.0, int_stack+3332749, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+298480,int_stack+297892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397183, 1.0, int_stack+1451148, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+299264,int_stack+298480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397771, 1.0, int_stack+1451736, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+220401,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2889706, 1.0, int_stack+3339364, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+223929,int_stack+300272,int_stack+299264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1398555, 1.0, int_stack+1452520, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+226953,int_stack+223929,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2891470, 1.0, int_stack+3341128, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+231657,int_stack+226953,int_stack+220401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2893822, 1.0, int_stack+3343480, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+301532,int_stack+300272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1399563, 1.0, int_stack+1453528, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+237537,int_stack+5760706,int_stack+223929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2907787, 1.0, int_stack+3357445, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+243585,int_stack+237537,int_stack+226953, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2910811, 1.0, int_stack+3360469, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+220401,int_stack+243585,int_stack+231657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2915515, 1.0, int_stack+3365173, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+229221,int_stack+303072,int_stack+301532, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1400823, 1.0, int_stack+1454788, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+251425,int_stack+229221,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2921395, 1.0, int_stack+3371053, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+258985,int_stack+251425,int_stack+237537, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2925175, 1.0, int_stack+3374833, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+229221,int_stack+258985,int_stack+243585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2931223, 1.0, int_stack+3380881, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+240981,int_stack+229221,int_stack+220401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3017197, 1.0, int_stack+3466855, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+253329,int_stack+240981,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+305676,int_stack+304920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411239, 1.0, int_stack+1465204, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+306684,int_stack+305676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411995, 1.0, int_stack+1465960, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+220401,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+3475675, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+307980,int_stack+306684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413003, 1.0, int_stack+1466968, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+224937,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268, 1.0, int_stack+3477943, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+230985,int_stack+224937,int_stack+220401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3066148, 1.0, int_stack+3480967, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+309600,int_stack+307980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1414299, 1.0, int_stack+1468264, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+281112,int_stack+81486,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2939063, 1.0, int_stack+3388721, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+288888,int_stack+281112,int_stack+224937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3070684, 1.0, int_stack+3527566, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+288888,int_stack+230985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3076732, 1.0, int_stack+3533614, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+220401,int_stack+311580,int_stack+309600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1415919, 1.0, int_stack+1469884, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+226341,int_stack+220401,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3084292, 1.0, int_stack+3541174, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+298968,int_stack+226341,int_stack+281112, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3089152, 1.0, int_stack+3546034, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+220401,int_stack+298968,int_stack+288888, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3096928, 1.0, int_stack+3553810, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+220401,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3107008, 1.0, int_stack+3563890, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+1894979,int_stack+240981,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+6944620,int_stack+6108484,int_stack+253329,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6145528,int_stack+314901,int_stack+313956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624276, 1.0, int_stack+665231, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6148363,int_stack+316161,int_stack+314901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+626166, 1.0, int_stack+667121, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6148363,int_stack+6145528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3118348, 1.0, int_stack+3575230, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+220401,int_stack+317781,int_stack+316161, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628686, 1.0, int_stack+669641, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+225261,int_stack+220401,int_stack+6148363, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3121183, 1.0, int_stack+3578065, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6145528,int_stack+225261,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3124963, 1.0, int_stack+3581845, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+232821,int_stack+319806,int_stack+317781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631926, 1.0, int_stack+672881, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+238896,int_stack+232821,int_stack+220401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3241954, 1.0, int_stack+3698836, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+248616,int_stack+238896,int_stack+225261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3246814, 1.0, int_stack+3703696, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+261216,int_stack+248616,int_stack+6145528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3254374, 1.0, int_stack+3711256, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6145528,int_stack+322281,int_stack+319806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635976, 1.0, int_stack+676931, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+220401,int_stack+6145528,int_stack+232821, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3263824, 1.0, int_stack+3720706, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+275391,int_stack+220401,int_stack+238896, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3269899, 1.0, int_stack+3726781, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+220401,int_stack+275391,int_stack+248616, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3279619, 1.0, int_stack+3736501, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+275391,int_stack+220401,int_stack+261216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3292219, 1.0, int_stack+3749101, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+275391,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+220401,int_stack+6508030,int_stack+6108484,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+325692,int_stack+325251, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1440606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+326280,int_stack+325692, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1441047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3306394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+327036,int_stack+326280, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1441635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3307717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3309481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+327981,int_stack+327036, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1442391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3312127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3314395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3317923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+329136,int_stack+327981, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1443336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3130633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3322333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6117934,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3326869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+6117934,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3332749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+331110,int_stack+330522, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1451148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+331894,int_stack+331110, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1451736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3339364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6112012,int_stack+332902,int_stack+331894, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1452520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6115036,int_stack+6112012,int_stack+5762470, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3341128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6119740,int_stack+6115036,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3343480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+334162,int_stack+332902, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1453528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6125620,int_stack+5760706,int_stack+6112012, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3357445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6131668,int_stack+6125620,int_stack+6115036, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3360469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6131668,int_stack+6119740, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3365173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117304,int_stack+335702,int_stack+334162, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1454788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6139508,int_stack+6117304,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3371053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6125620, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3374833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6139508,int_stack+6508030,int_stack+6131668, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3380881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3466855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6108484,int_stack+6508030,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+338306,int_stack+337550, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1465204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+339314,int_stack+338306, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1465960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6136267,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3475675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+340610,int_stack+339314, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1466968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6140803,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3477943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6146851,int_stack+6140803,int_stack+6136267, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3480967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+342230,int_stack+340610, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1468264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6520378,int_stack+81486,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3388721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528154,int_stack+6520378,int_stack+6140803, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3527566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6538234,int_stack+6528154,int_stack+6146851, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3533614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6136267,int_stack+344210,int_stack+342230, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1469884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6142207,int_stack+6136267,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3541174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1894979,int_stack+6142207,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3546034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6136267,int_stack+1894979,int_stack+6528154, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3553810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+6136267,int_stack+6538234, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3563890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+294489,int_stack+1894979,int_stack+6508030,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+7000186,int_stack+294489,int_stack+6108484,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+347531,int_stack+346586, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+665231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6111319,int_stack+348791,int_stack+347531, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+667121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6111319,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3575230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6115099,int_stack+350411,int_stack+348791, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+669641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6119959,int_stack+6115099,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3578065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6127519,int_stack+6119959,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3581845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+352436,int_stack+350411, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+672881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136969,int_stack+6108484,int_stack+6115099, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3698836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6508030,int_stack+6136969,int_stack+6119959, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3703696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6520630,int_stack+6508030,int_stack+6127519, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3711256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6114559,int_stack+354911,int_stack+352436, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+676931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6121984,int_stack+6114559,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3720706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534805,int_stack+6121984,int_stack+6136969, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3726781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+6534805,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3736501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6534805,int_stack+6108484,int_stack+6520630, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3749101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+6534805,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+7055752,int_stack+6108484,int_stack+294489,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294489,int_stack+358322,int_stack+357881, 0.0, zero_stack, 1.0, int_stack+1278711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1494571,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+295812,int_stack+358910,int_stack+358322, 0.0, zero_stack, 1.0, int_stack+1279152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495012,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+297576,int_stack+295812,int_stack+294489, 0.0, zero_stack, 1.0, int_stack+1827485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3763276,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+300222,int_stack+359666,int_stack+358910, 0.0, zero_stack, 1.0, int_stack+1279740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495600,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+302490,int_stack+300222,int_stack+295812, 0.0, zero_stack, 1.0, int_stack+1828808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3764599,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+306018,int_stack+302490,int_stack+297576, 0.0, zero_stack, 1.0, int_stack+1830572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3766363,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+294489,int_stack+360611,int_stack+359666, 0.0, zero_stack, 1.0, int_stack+1280496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1496356,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+310428,int_stack+294489,int_stack+300222, 0.0, zero_stack, 1.0, int_stack+1833218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3769009,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+314964,int_stack+310428,int_stack+302490, 0.0, zero_stack, 1.0, int_stack+1835486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3771277,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+297324,int_stack+314964,int_stack+306018, 0.0, zero_stack, 1.0, int_stack+1839014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3774805,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+303939,int_stack+361766,int_stack+360611, 0.0, zero_stack, 1.0, int_stack+1281441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497301,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+303939,int_stack+294489, 0.0, zero_stack, 1.0, int_stack+1843424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3587515,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+320844,int_stack+5760706,int_stack+310428, 0.0, zero_stack, 1.0, int_stack+1846259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3779215,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+303939,int_stack+320844,int_stack+314964, 0.0, zero_stack, 1.0, int_stack+1850795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3783751,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+303939,int_stack+297324, 0.0, zero_stack, 1.0, int_stack+1856675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3789631,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+363740,int_stack+363152, 0.0, zero_stack, 1.0, int_stack+1289253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505113,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+364524,int_stack+363740, 0.0, zero_stack, 1.0, int_stack+1289841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505701,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+294489,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+1921467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3796246,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+298017,int_stack+365532,int_stack+364524, 0.0, zero_stack, 1.0, int_stack+1290625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1506485,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+301041,int_stack+298017,int_stack+5762470, 0.0, zero_stack, 1.0, int_stack+1923231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3798010,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+305745,int_stack+301041,int_stack+294489, 0.0, zero_stack, 1.0, int_stack+1925583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3800362,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+366792,int_stack+365532, 0.0, zero_stack, 1.0, int_stack+1291633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1507493,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+311625,int_stack+5760706,int_stack+298017, 0.0, zero_stack, 1.0, int_stack+1929111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3814327,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+317673,int_stack+311625,int_stack+301041, 0.0, zero_stack, 1.0, int_stack+1932135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3817351,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+294489,int_stack+317673,int_stack+305745, 0.0, zero_stack, 1.0, int_stack+1936839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3822055,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+303309,int_stack+368332,int_stack+366792, 0.0, zero_stack, 1.0, int_stack+1292893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1508753,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+325513,int_stack+303309,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+1942719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3827935,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+333073,int_stack+325513,int_stack+311625, 0.0, zero_stack, 1.0, int_stack+1946499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3831715,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+303309,int_stack+333073,int_stack+317673, 0.0, zero_stack, 1.0, int_stack+1952547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3837763,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+315069,int_stack+303309,int_stack+294489, 0.0, zero_stack, 1.0, int_stack+1960387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3923737,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+327417,int_stack+315069,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+370936,int_stack+370180, 0.0, zero_stack, 1.0, int_stack+1303309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1519169,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+371944,int_stack+370936, 0.0, zero_stack, 1.0, int_stack+1304065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1519925,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+294489,int_stack+83754,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+2072650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5292,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+373240,int_stack+371944, 0.0, zero_stack, 1.0, int_stack+1305073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1520933,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+299025,int_stack+86778,int_stack+83754, 0.0, zero_stack, 1.0, int_stack+2074918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7560,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+305073,int_stack+299025,int_stack+294489, 0.0, zero_stack, 1.0, int_stack+2077942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3972688,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+374860,int_stack+373240, 0.0, zero_stack, 1.0, int_stack+1306369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1522229,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+355200,int_stack+81486,int_stack+86778, 0.0, zero_stack, 1.0, int_stack+2082478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3845603,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+362976,int_stack+355200,int_stack+299025, 0.0, zero_stack, 1.0, int_stack+2086366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3977224,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+362976,int_stack+305073, 0.0, zero_stack, 1.0, int_stack+2092414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3983272,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+294489,int_stack+376840,int_stack+374860, 0.0, zero_stack, 1.0, int_stack+1307989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1523849,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+300429,int_stack+294489,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+2099974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3990832,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6119824,int_stack+300429,int_stack+355200, 0.0, zero_stack, 1.0, int_stack+2104834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3995692,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+294489,int_stack+6119824,int_stack+362976, 0.0, zero_stack, 1.0, int_stack+2112610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4003468,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+294489,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+2122690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4013548,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+1894979,int_stack+315069,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+7129840,int_stack+6108484,int_stack+327417,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6145528,int_stack+380161,int_stack+379216, 0.0, zero_stack, 1.0, int_stack+542366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706186,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6148363,int_stack+381421,int_stack+380161, 0.0, zero_stack, 1.0, int_stack+544256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708076,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6148363,int_stack+6145528, 0.0, zero_stack, 1.0, int_stack+2146315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4024888,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+294489,int_stack+383041,int_stack+381421, 0.0, zero_stack, 1.0, int_stack+546776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710596,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+299349,int_stack+294489,int_stack+6148363, 0.0, zero_stack, 1.0, int_stack+2322076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4027723,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6145528,int_stack+299349,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2325856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4031503,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+306909,int_stack+385066,int_stack+383041, 0.0, zero_stack, 1.0, int_stack+550016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713836,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+312984,int_stack+306909,int_stack+294489, 0.0, zero_stack, 1.0, int_stack+2331526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4148494,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+322704,int_stack+312984,int_stack+299349, 0.0, zero_stack, 1.0, int_stack+2336386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4153354,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+335304,int_stack+322704,int_stack+6145528, 0.0, zero_stack, 1.0, int_stack+2343946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4160914,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6145528,int_stack+387541,int_stack+385066, 0.0, zero_stack, 1.0, int_stack+554066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717886,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+294489,int_stack+6145528,int_stack+306909, 0.0, zero_stack, 1.0, int_stack+2353396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4170364,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+349479,int_stack+294489,int_stack+312984, 0.0, zero_stack, 1.0, int_stack+2359471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4176439,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+294489,int_stack+349479,int_stack+322704, 0.0, zero_stack, 1.0, int_stack+2369191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4186159,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+349479,int_stack+294489,int_stack+335304, 0.0, zero_stack, 1.0, int_stack+2381791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4198759,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+349479,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+294489,int_stack+6508030,int_stack+6108484,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+390952,int_stack+390511, 0.0, zero_stack, 1.0, int_stack+1332676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1494571, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+391540,int_stack+390952, 0.0, zero_stack, 1.0, int_stack+1333117, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495012, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+2395966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3763276, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+392296,int_stack+391540, 0.0, zero_stack, 1.0, int_stack+1333705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495600, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 1.0, int_stack+2397289, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3764599, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 1.0, int_stack+2399053, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3766363, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+393241,int_stack+392296, 0.0, zero_stack, 1.0, int_stack+1334461, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1496356, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 1.0, int_stack+2401699, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3769009, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 1.0, int_stack+2403967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3771277, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 1.0, int_stack+2407495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3774805, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+394396,int_stack+393241, 0.0, zero_stack, 1.0, int_stack+1335406, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497301, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+2411905, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3587515, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 1.0, int_stack+2414740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3779215, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6117934,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 1.0, int_stack+2419276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3783751, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+6117934,int_stack+6111319, 0.0, zero_stack, 1.0, int_stack+2425156, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3789631, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+396370,int_stack+395782, 0.0, zero_stack, 1.0, int_stack+1343218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505113, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+397154,int_stack+396370, 0.0, zero_stack, 1.0, int_stack+1343806, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1505701, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2431771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3796246, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6112012,int_stack+398162,int_stack+397154, 0.0, zero_stack, 1.0, int_stack+1344590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1506485, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6115036,int_stack+6112012,int_stack+5762470, 0.0, zero_stack, 1.0, int_stack+2433535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3798010, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6119740,int_stack+6115036,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+2435887, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3800362, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+399422,int_stack+398162, 0.0, zero_stack, 1.0, int_stack+1345598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1507493, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6125620,int_stack+5760706,int_stack+6112012, 0.0, zero_stack, 1.0, int_stack+2449852, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3814327, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6131668,int_stack+6125620,int_stack+6115036, 0.0, zero_stack, 1.0, int_stack+2452876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3817351, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6131668,int_stack+6119740, 0.0, zero_stack, 1.0, int_stack+2457580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3822055, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117304,int_stack+400962,int_stack+399422, 0.0, zero_stack, 1.0, int_stack+1346858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1508753, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6139508,int_stack+6117304,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2463460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3827935, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6125620, 0.0, zero_stack, 1.0, int_stack+2467240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3831715, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6139508,int_stack+6508030,int_stack+6131668, 0.0, zero_stack, 1.0, int_stack+2473288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3837763, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+2556427, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3923737, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6108484,int_stack+6508030,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+403566,int_stack+402810, 0.0, zero_stack, 1.0, int_stack+1357274, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1519169, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+404574,int_stack+403566, 0.0, zero_stack, 1.0, int_stack+1358030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1519925, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6136267,int_stack+83754,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+2565247, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5292, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+405870,int_stack+404574, 0.0, zero_stack, 1.0, int_stack+1359038, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1520933, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6140803,int_stack+86778,int_stack+83754, 0.0, zero_stack, 1.0, int_stack+2567515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7560, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6146851,int_stack+6140803,int_stack+6136267, 0.0, zero_stack, 1.0, int_stack+2570539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3972688, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+407490,int_stack+405870, 0.0, zero_stack, 1.0, int_stack+1360334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1522229, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6520378,int_stack+81486,int_stack+86778, 0.0, zero_stack, 1.0, int_stack+2617138, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3845603, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528154,int_stack+6520378,int_stack+6140803, 0.0, zero_stack, 1.0, int_stack+2621026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3977224, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6538234,int_stack+6528154,int_stack+6146851, 0.0, zero_stack, 1.0, int_stack+2627074, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3983272, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6136267,int_stack+409470,int_stack+407490, 0.0, zero_stack, 1.0, int_stack+1361954, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1523849, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6142207,int_stack+6136267,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+2634634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3990832, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1894979,int_stack+6142207,int_stack+6520378, 0.0, zero_stack, 1.0, int_stack+2639494, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3995692, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6136267,int_stack+1894979,int_stack+6528154, 0.0, zero_stack, 1.0, int_stack+2647270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4003468, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+6136267,int_stack+6538234, 0.0, zero_stack, 1.0, int_stack+2657350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4013548, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+368577,int_stack+1894979,int_stack+6508030,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+7185406,int_stack+368577,int_stack+6108484,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+412791,int_stack+411846, 0.0, zero_stack, 1.0, int_stack+583321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706186, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6111319,int_stack+414051,int_stack+412791, 0.0, zero_stack, 1.0, int_stack+585211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708076, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6111319,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+2668690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4024888, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6115099,int_stack+415671,int_stack+414051, 0.0, zero_stack, 1.0, int_stack+587731, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710596, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6119959,int_stack+6115099,int_stack+6111319, 0.0, zero_stack, 1.0, int_stack+2671525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4027723, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6127519,int_stack+6119959,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2675305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4031503, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+417696,int_stack+415671, 0.0, zero_stack, 1.0, int_stack+590971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713836, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136969,int_stack+6108484,int_stack+6115099, 0.0, zero_stack, 1.0, int_stack+2792296, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4148494, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6508030,int_stack+6136969,int_stack+6119959, 0.0, zero_stack, 1.0, int_stack+2797156, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4153354, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6520630,int_stack+6508030,int_stack+6127519, 0.0, zero_stack, 1.0, int_stack+2804716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4160914, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6114559,int_stack+420171,int_stack+417696, 0.0, zero_stack, 1.0, int_stack+595021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+717886, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6121984,int_stack+6114559,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+2814166, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4170364, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534805,int_stack+6121984,int_stack+6136969, 0.0, zero_stack, 1.0, int_stack+2820241, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4176439, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+6534805,int_stack+6508030, 0.0, zero_stack, 1.0, int_stack+2829961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4186159, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6534805,int_stack+6108484,int_stack+6520630, 0.0, zero_stack, 1.0, int_stack+2842561, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4198759, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+6534805,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+7240972,int_stack+6108484,int_stack+368577,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+368577,int_stack+423582,int_stack+423141, 0.0, zero_stack, 1.0, int_stack+1386641, 0.0, zero_stack, 1.0, int_stack+1494571, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+369900,int_stack+424170,int_stack+423582, 0.0, zero_stack, 1.0, int_stack+1387082, 0.0, zero_stack, 1.0, int_stack+1495012, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+371664,int_stack+369900,int_stack+368577, 0.0, zero_stack, 1.0, int_stack+2856736, 0.0, zero_stack, 1.0, int_stack+3763276, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+374310,int_stack+424926,int_stack+424170, 0.0, zero_stack, 1.0, int_stack+1387670, 0.0, zero_stack, 1.0, int_stack+1495600, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+376578,int_stack+374310,int_stack+369900, 0.0, zero_stack, 1.0, int_stack+2858059, 0.0, zero_stack, 1.0, int_stack+3764599, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+380106,int_stack+376578,int_stack+371664, 0.0, zero_stack, 1.0, int_stack+2859823, 0.0, zero_stack, 1.0, int_stack+3766363, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+368577,int_stack+425871,int_stack+424926, 0.0, zero_stack, 1.0, int_stack+1388426, 0.0, zero_stack, 1.0, int_stack+1496356, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+384516,int_stack+368577,int_stack+374310, 0.0, zero_stack, 1.0, int_stack+2862469, 0.0, zero_stack, 1.0, int_stack+3769009, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+389052,int_stack+384516,int_stack+376578, 0.0, zero_stack, 1.0, int_stack+2864737, 0.0, zero_stack, 1.0, int_stack+3771277, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+371412,int_stack+389052,int_stack+380106, 0.0, zero_stack, 1.0, int_stack+2868265, 0.0, zero_stack, 1.0, int_stack+3774805, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+378027,int_stack+427026,int_stack+425871, 0.0, zero_stack, 1.0, int_stack+1389371, 0.0, zero_stack, 1.0, int_stack+1497301, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+378027,int_stack+368577, 0.0, zero_stack, 1.0, int_stack+2680975, 0.0, zero_stack, 1.0, int_stack+3587515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+394932,int_stack+5760706,int_stack+384516, 0.0, zero_stack, 1.0, int_stack+2872675, 0.0, zero_stack, 1.0, int_stack+3779215, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+378027,int_stack+394932,int_stack+389052, 0.0, zero_stack, 1.0, int_stack+2877211, 0.0, zero_stack, 1.0, int_stack+3783751, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+378027,int_stack+371412, 0.0, zero_stack, 1.0, int_stack+2883091, 0.0, zero_stack, 1.0, int_stack+3789631, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+429000,int_stack+428412, 0.0, zero_stack, 1.0, int_stack+1397183, 0.0, zero_stack, 1.0, int_stack+1505113, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+429784,int_stack+429000, 0.0, zero_stack, 1.0, int_stack+1397771, 0.0, zero_stack, 1.0, int_stack+1505701, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+368577,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2889706, 0.0, zero_stack, 1.0, int_stack+3796246, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+372105,int_stack+430792,int_stack+429784, 0.0, zero_stack, 1.0, int_stack+1398555, 0.0, zero_stack, 1.0, int_stack+1506485, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+375129,int_stack+372105,int_stack+5762470, 0.0, zero_stack, 1.0, int_stack+2891470, 0.0, zero_stack, 1.0, int_stack+3798010, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+379833,int_stack+375129,int_stack+368577, 0.0, zero_stack, 1.0, int_stack+2893822, 0.0, zero_stack, 1.0, int_stack+3800362, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+432052,int_stack+430792, 0.0, zero_stack, 1.0, int_stack+1399563, 0.0, zero_stack, 1.0, int_stack+1507493, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+385713,int_stack+5760706,int_stack+372105, 0.0, zero_stack, 1.0, int_stack+2907787, 0.0, zero_stack, 1.0, int_stack+3814327, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+391761,int_stack+385713,int_stack+375129, 0.0, zero_stack, 1.0, int_stack+2910811, 0.0, zero_stack, 1.0, int_stack+3817351, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+368577,int_stack+391761,int_stack+379833, 0.0, zero_stack, 1.0, int_stack+2915515, 0.0, zero_stack, 1.0, int_stack+3822055, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+377397,int_stack+433592,int_stack+432052, 0.0, zero_stack, 1.0, int_stack+1400823, 0.0, zero_stack, 1.0, int_stack+1508753, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+399601,int_stack+377397,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2921395, 0.0, zero_stack, 1.0, int_stack+3827935, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+407161,int_stack+399601,int_stack+385713, 0.0, zero_stack, 1.0, int_stack+2925175, 0.0, zero_stack, 1.0, int_stack+3831715, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+377397,int_stack+407161,int_stack+391761, 0.0, zero_stack, 1.0, int_stack+2931223, 0.0, zero_stack, 1.0, int_stack+3837763, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+389157,int_stack+377397,int_stack+368577, 0.0, zero_stack, 1.0, int_stack+3017197, 0.0, zero_stack, 1.0, int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+401505,int_stack+389157,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+436196,int_stack+435440, 0.0, zero_stack, 1.0, int_stack+1411239, 0.0, zero_stack, 1.0, int_stack+1519169, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+437204,int_stack+436196, 0.0, zero_stack, 1.0, int_stack+1411995, 0.0, zero_stack, 1.0, int_stack+1519925, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+368577,int_stack+83754,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+438500,int_stack+437204, 0.0, zero_stack, 1.0, int_stack+1413003, 0.0, zero_stack, 1.0, int_stack+1520933, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+373113,int_stack+86778,int_stack+83754, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack, 1.0, int_stack+7560, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+379161,int_stack+373113,int_stack+368577, 0.0, zero_stack, 1.0, int_stack+3066148, 0.0, zero_stack, 1.0, int_stack+3972688, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+440120,int_stack+438500, 0.0, zero_stack, 1.0, int_stack+1414299, 0.0, zero_stack, 1.0, int_stack+1522229, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+429288,int_stack+81486,int_stack+86778, 0.0, zero_stack, 1.0, int_stack+2939063, 0.0, zero_stack, 1.0, int_stack+3845603, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6108484,int_stack+429288,int_stack+373113, 0.0, zero_stack, 1.0, int_stack+3070684, 0.0, zero_stack, 1.0, int_stack+3977224, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6118564,int_stack+6108484,int_stack+379161, 0.0, zero_stack, 1.0, int_stack+3076732, 0.0, zero_stack, 1.0, int_stack+3983272, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+368577,int_stack+442100,int_stack+440120, 0.0, zero_stack, 1.0, int_stack+1415919, 0.0, zero_stack, 1.0, int_stack+1523849, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+374517,int_stack+368577,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+3084292, 0.0, zero_stack, 1.0, int_stack+3990832, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6129904,int_stack+374517,int_stack+429288, 0.0, zero_stack, 1.0, int_stack+3089152, 0.0, zero_stack, 1.0, int_stack+3995692, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+429288,int_stack+6129904,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3096928, 0.0, zero_stack, 1.0, int_stack+4003468, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+429288,int_stack+6118564, 0.0, zero_stack, 1.0, int_stack+3107008, 0.0, zero_stack, 1.0, int_stack+4013548, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+1894979,int_stack+389157,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+7315060,int_stack+6108484,int_stack+401505,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6145528,int_stack+445421,int_stack+444476, 0.0, zero_stack, 1.0, int_stack+624276, 0.0, zero_stack, 1.0, int_stack+706186, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6148363,int_stack+446681,int_stack+445421, 0.0, zero_stack, 1.0, int_stack+626166, 0.0, zero_stack, 1.0, int_stack+708076, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6148363,int_stack+6145528, 0.0, zero_stack, 1.0, int_stack+3118348, 0.0, zero_stack, 1.0, int_stack+4024888, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+81486,int_stack+448301,int_stack+446681, 0.0, zero_stack, 1.0, int_stack+628686, 0.0, zero_stack, 1.0, int_stack+710596, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+368577,int_stack+81486,int_stack+6148363, 0.0, zero_stack, 1.0, int_stack+3121183, 0.0, zero_stack, 1.0, int_stack+4027723, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6145528,int_stack+368577,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+3124963, 0.0, zero_stack, 1.0, int_stack+4031503, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+376137,int_stack+450326,int_stack+448301, 0.0, zero_stack, 1.0, int_stack+631926, 0.0, zero_stack, 1.0, int_stack+713836, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+382212,int_stack+376137,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+3241954, 0.0, zero_stack, 1.0, int_stack+4148494, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+391932,int_stack+382212,int_stack+368577, 0.0, zero_stack, 1.0, int_stack+3246814, 0.0, zero_stack, 1.0, int_stack+4153354, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+404532,int_stack+391932,int_stack+6145528, 0.0, zero_stack, 1.0, int_stack+3254374, 0.0, zero_stack, 1.0, int_stack+4160914, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6145528,int_stack+452801,int_stack+450326, 0.0, zero_stack, 1.0, int_stack+635976, 0.0, zero_stack, 1.0, int_stack+717886, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+418707,int_stack+6145528,int_stack+376137, 0.0, zero_stack, 1.0, int_stack+3263824, 0.0, zero_stack, 1.0, int_stack+4170364, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+430857,int_stack+418707,int_stack+382212, 0.0, zero_stack, 1.0, int_stack+3269899, 0.0, zero_stack, 1.0, int_stack+4176439, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+368577,int_stack+430857,int_stack+391932, 0.0, zero_stack, 1.0, int_stack+3279619, 0.0, zero_stack, 1.0, int_stack+4186159, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+418707,int_stack+368577,int_stack+404532, 0.0, zero_stack, 1.0, int_stack+3292219, 0.0, zero_stack, 1.0, int_stack+4198759, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+418707,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+368577,int_stack+6508030,int_stack+6108484,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+456212,int_stack+455771, 0.0, zero_stack, 1.0, int_stack+1440606, 1.0, int_stack+1494571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+456800,int_stack+456212, 0.0, zero_stack, 1.0, int_stack+1441047, 1.0, int_stack+1495012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3306394, 1.0, int_stack+3763276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+457556,int_stack+456800, 0.0, zero_stack, 1.0, int_stack+1441635, 1.0, int_stack+1495600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 1.0, int_stack+3307717, 1.0, int_stack+3764599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 1.0, int_stack+3309481, 1.0, int_stack+3766363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+458501,int_stack+457556, 0.0, zero_stack, 1.0, int_stack+1442391, 1.0, int_stack+1496356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 1.0, int_stack+3312127, 1.0, int_stack+3769009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 1.0, int_stack+3314395, 1.0, int_stack+3771277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 1.0, int_stack+3317923, 1.0, int_stack+3774805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+459656,int_stack+458501, 0.0, zero_stack, 1.0, int_stack+1443336, 1.0, int_stack+1497301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3130633, 1.0, int_stack+3587515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 1.0, int_stack+3322333, 1.0, int_stack+3779215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6117934,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 1.0, int_stack+3326869, 1.0, int_stack+3783751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+6117934,int_stack+6111319, 0.0, zero_stack, 1.0, int_stack+3332749, 1.0, int_stack+3789631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+461630,int_stack+461042, 0.0, zero_stack, 1.0, int_stack+1451148, 1.0, int_stack+1505113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+462414,int_stack+461630, 0.0, zero_stack, 1.0, int_stack+1451736, 1.0, int_stack+1505701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+3339364, 1.0, int_stack+3796246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6112012,int_stack+463422,int_stack+462414, 0.0, zero_stack, 1.0, int_stack+1452520, 1.0, int_stack+1506485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6115036,int_stack+6112012,int_stack+5762470, 0.0, zero_stack, 1.0, int_stack+3341128, 1.0, int_stack+3798010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6119740,int_stack+6115036,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3343480, 1.0, int_stack+3800362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+464682,int_stack+463422, 0.0, zero_stack, 1.0, int_stack+1453528, 1.0, int_stack+1507493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6125620,int_stack+5760706,int_stack+6112012, 0.0, zero_stack, 1.0, int_stack+3357445, 1.0, int_stack+3814327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6131668,int_stack+6125620,int_stack+6115036, 0.0, zero_stack, 1.0, int_stack+3360469, 1.0, int_stack+3817351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6131668,int_stack+6119740, 0.0, zero_stack, 1.0, int_stack+3365173, 1.0, int_stack+3822055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117304,int_stack+466222,int_stack+464682, 0.0, zero_stack, 1.0, int_stack+1454788, 1.0, int_stack+1508753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6139508,int_stack+6117304,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+3371053, 1.0, int_stack+3827935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6125620, 0.0, zero_stack, 1.0, int_stack+3374833, 1.0, int_stack+3831715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6139508,int_stack+6508030,int_stack+6131668, 0.0, zero_stack, 1.0, int_stack+3380881, 1.0, int_stack+3837763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6139508,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3466855, 1.0, int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6108484,int_stack+6508030,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+468826,int_stack+468070, 0.0, zero_stack, 1.0, int_stack+1465204, 1.0, int_stack+1519169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+469834,int_stack+468826, 0.0, zero_stack, 1.0, int_stack+1465960, 1.0, int_stack+1519925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6136267,int_stack+83754,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+3475675, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+471130,int_stack+469834, 0.0, zero_stack, 1.0, int_stack+1466968, 1.0, int_stack+1520933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6140803,int_stack+86778,int_stack+83754, 0.0, zero_stack, 1.0, int_stack+3477943, 1.0, int_stack+7560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6146851,int_stack+6140803,int_stack+6136267, 0.0, zero_stack, 1.0, int_stack+3480967, 1.0, int_stack+3972688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+472750,int_stack+471130, 0.0, zero_stack, 1.0, int_stack+1468264, 1.0, int_stack+1522229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6520378,int_stack+81486,int_stack+86778, 0.0, zero_stack, 1.0, int_stack+3388721, 1.0, int_stack+3845603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528154,int_stack+6520378,int_stack+6140803, 0.0, zero_stack, 1.0, int_stack+3527566, 1.0, int_stack+3977224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6538234,int_stack+6528154,int_stack+6146851, 0.0, zero_stack, 1.0, int_stack+3533614, 1.0, int_stack+3983272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6136267,int_stack+474730,int_stack+472750, 0.0, zero_stack, 1.0, int_stack+1469884, 1.0, int_stack+1523849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6142207,int_stack+6136267,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+3541174, 1.0, int_stack+3990832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1894979,int_stack+6142207,int_stack+6520378, 0.0, zero_stack, 1.0, int_stack+3546034, 1.0, int_stack+3995692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6136267,int_stack+1894979,int_stack+6528154, 0.0, zero_stack, 1.0, int_stack+3553810, 1.0, int_stack+4003468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+6136267,int_stack+6538234, 0.0, zero_stack, 1.0, int_stack+3563890, 1.0, int_stack+4013548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2034463,int_stack+1894979,int_stack+6508030,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+7370626,int_stack+2034463,int_stack+6108484,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+478051,int_stack+477106, 0.0, zero_stack, 1.0, int_stack+665231, 1.0, int_stack+706186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6111319,int_stack+479311,int_stack+478051, 0.0, zero_stack, 1.0, int_stack+667121, 1.0, int_stack+708076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6111319,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3575230, 1.0, int_stack+4024888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6115099,int_stack+480931,int_stack+479311, 0.0, zero_stack, 1.0, int_stack+669641, 1.0, int_stack+710596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6119959,int_stack+6115099,int_stack+6111319, 0.0, zero_stack, 1.0, int_stack+3578065, 1.0, int_stack+4027723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6127519,int_stack+6119959,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+3581845, 1.0, int_stack+4031503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+482956,int_stack+480931, 0.0, zero_stack, 1.0, int_stack+672881, 1.0, int_stack+713836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6136969,int_stack+6108484,int_stack+6115099, 0.0, zero_stack, 1.0, int_stack+3698836, 1.0, int_stack+4148494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6508030,int_stack+6136969,int_stack+6119959, 0.0, zero_stack, 1.0, int_stack+3703696, 1.0, int_stack+4153354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6520630,int_stack+6508030,int_stack+6127519, 0.0, zero_stack, 1.0, int_stack+3711256, 1.0, int_stack+4160914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6114559,int_stack+485431,int_stack+482956, 0.0, zero_stack, 1.0, int_stack+676931, 1.0, int_stack+717886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6121984,int_stack+6114559,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3720706, 1.0, int_stack+4170364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534805,int_stack+6121984,int_stack+6136969, 0.0, zero_stack, 1.0, int_stack+3726781, 1.0, int_stack+4176439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+6534805,int_stack+6508030, 0.0, zero_stack, 1.0, int_stack+3736501, 1.0, int_stack+4186159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6534805,int_stack+6108484,int_stack+6520630, 0.0, zero_stack, 1.0, int_stack+3749101, 1.0, int_stack+4198759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+6534805,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+7426192,int_stack+6108484,int_stack+2034463,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2034463,int_stack+488842,int_stack+488401, 0.0, zero_stack, 2.0, int_stack+1494571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2035786,int_stack+489430,int_stack+488842, 0.0, zero_stack, 2.0, int_stack+1495012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2037550,int_stack+2035786,int_stack+2034463, 0.0, zero_stack, 2.0, int_stack+3763276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2040196,int_stack+490186,int_stack+489430, 0.0, zero_stack, 2.0, int_stack+1495600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2042464,int_stack+2040196,int_stack+2035786, 0.0, zero_stack, 2.0, int_stack+3764599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2045992,int_stack+2042464,int_stack+2037550, 0.0, zero_stack, 2.0, int_stack+3766363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2034463,int_stack+491131,int_stack+490186, 0.0, zero_stack, 2.0, int_stack+1496356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2050402,int_stack+2034463,int_stack+2040196, 0.0, zero_stack, 2.0, int_stack+3769009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2054938,int_stack+2050402,int_stack+2042464, 0.0, zero_stack, 2.0, int_stack+3771277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2037298,int_stack+2054938,int_stack+2045992, 0.0, zero_stack, 2.0, int_stack+3774805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2043913,int_stack+492286,int_stack+491131, 0.0, zero_stack, 2.0, int_stack+1497301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+2043913,int_stack+2034463, 0.0, zero_stack, 2.0, int_stack+3587515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2060818,int_stack+5760706,int_stack+2050402, 0.0, zero_stack, 2.0, int_stack+3779215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2043913,int_stack+2060818,int_stack+2054938, 0.0, zero_stack, 2.0, int_stack+3783751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+2043913,int_stack+2037298, 0.0, zero_stack, 2.0, int_stack+3789631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+494260,int_stack+493672, 0.0, zero_stack, 2.0, int_stack+1505113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+495044,int_stack+494260, 0.0, zero_stack, 2.0, int_stack+1505701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2034463,int_stack+5762470,int_stack+5760706, 0.0, zero_stack, 2.0, int_stack+3796246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2037991,int_stack+496052,int_stack+495044, 0.0, zero_stack, 2.0, int_stack+1506485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2041015,int_stack+2037991,int_stack+5762470, 0.0, zero_stack, 2.0, int_stack+3798010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2045719,int_stack+2041015,int_stack+2034463, 0.0, zero_stack, 2.0, int_stack+3800362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+497312,int_stack+496052, 0.0, zero_stack, 2.0, int_stack+1507493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2051599,int_stack+5760706,int_stack+2037991, 0.0, zero_stack, 2.0, int_stack+3814327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2057647,int_stack+2051599,int_stack+2041015, 0.0, zero_stack, 2.0, int_stack+3817351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2034463,int_stack+2057647,int_stack+2045719, 0.0, zero_stack, 2.0, int_stack+3822055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2043283,int_stack+498852,int_stack+497312, 0.0, zero_stack, 2.0, int_stack+1508753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6108484,int_stack+2043283,int_stack+5760706, 0.0, zero_stack, 2.0, int_stack+3827935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6116044,int_stack+6108484,int_stack+2051599, 0.0, zero_stack, 2.0, int_stack+3831715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2043283,int_stack+6116044,int_stack+2057647, 0.0, zero_stack, 2.0, int_stack+3837763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+2043283,int_stack+2034463, 0.0, zero_stack, 2.0, int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2034463,int_stack+6108484,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+501456,int_stack+500700, 0.0, zero_stack, 2.0, int_stack+1519169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+502464,int_stack+501456, 0.0, zero_stack, 2.0, int_stack+1519925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2062246,int_stack+83754,int_stack+81486, 0.0, zero_stack, 2.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+503760,int_stack+502464, 0.0, zero_stack, 2.0, int_stack+1520933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6120832,int_stack+86778,int_stack+83754, 0.0, zero_stack, 2.0, int_stack+7560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6126880,int_stack+6120832,int_stack+2062246, 0.0, zero_stack, 2.0, int_stack+3972688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2062246,int_stack+505380,int_stack+503760, 0.0, zero_stack, 2.0, int_stack+1522229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6134440,int_stack+2062246,int_stack+86778, 0.0, zero_stack, 2.0, int_stack+3845603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6142216,int_stack+6134440,int_stack+6120832, 0.0, zero_stack, 2.0, int_stack+3977224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1894979,int_stack+6142216,int_stack+6126880, 0.0, zero_stack, 2.0, int_stack+3983272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6120832,int_stack+507360,int_stack+505380, 0.0, zero_stack, 2.0, int_stack+1523849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6508030,int_stack+6120832,int_stack+2062246, 0.0, zero_stack, 2.0, int_stack+3990832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6120832,int_stack+6508030,int_stack+6134440, 0.0, zero_stack, 2.0, int_stack+3995692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6508030,int_stack+6120832,int_stack+6142216, 0.0, zero_stack, 2.0, int_stack+4003468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6120832,int_stack+6508030,int_stack+1894979, 0.0, zero_stack, 2.0, int_stack+4013548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+6120832,int_stack+6108484,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+442665,int_stack+6508030,int_stack+2034463,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2034463,int_stack+510681,int_stack+509736, 0.0, zero_stack, 2.0, int_stack+706186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2037298,int_stack+511941,int_stack+510681, 0.0, zero_stack, 2.0, int_stack+708076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+2037298,int_stack+2034463, 0.0, zero_stack, 2.0, int_stack+4024888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2041078,int_stack+513561,int_stack+511941, 0.0, zero_stack, 2.0, int_stack+710596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2045938,int_stack+2041078,int_stack+2037298, 0.0, zero_stack, 2.0, int_stack+4027723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2053498,int_stack+2045938,int_stack+5760706, 0.0, zero_stack, 2.0, int_stack+4031503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2034463,int_stack+515586,int_stack+513561, 0.0, zero_stack, 2.0, int_stack+713836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6108484,int_stack+2034463,int_stack+2041078, 0.0, zero_stack, 2.0, int_stack+4148494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1894979,int_stack+6108484,int_stack+2045938, 0.0, zero_stack, 2.0, int_stack+4153354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6136708,int_stack+1894979,int_stack+2053498, 0.0, zero_stack, 2.0, int_stack+4160914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2040538,int_stack+518061,int_stack+515586, 0.0, zero_stack, 2.0, int_stack+717886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2047963,int_stack+2040538,int_stack+2034463, 0.0, zero_stack, 2.0, int_stack+4170364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+498231,int_stack+2047963,int_stack+6108484, 0.0, zero_stack, 2.0, int_stack+4176439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2034463,int_stack+498231,int_stack+1894979, 0.0, zero_stack, 2.0, int_stack+4186159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+498231,int_stack+2034463,int_stack+6136708, 0.0, zero_stack, 2.0, int_stack+4198759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+498231,int_stack+6120832,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+7547908,int_stack+7500280,int_stack+6508030,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+521472,int_stack+521031, 1.0, int_stack+1278711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548536,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+522060,int_stack+521472, 1.0, int_stack+1279152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548977,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030, 1.0, int_stack+1827485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4212934,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+522816,int_stack+522060, 1.0, int_stack+1279740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1549565,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353, 1.0, int_stack+1828808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4214257,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117, 1.0, int_stack+1830572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4216021,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+523761,int_stack+522816, 1.0, int_stack+1280496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550321,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763, 1.0, int_stack+1833218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4218667,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031, 1.0, int_stack+1835486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4220935,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559, 1.0, int_stack+1839014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4224463,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+524916,int_stack+523761, 1.0, int_stack+1281441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1551266,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030, 1.0, int_stack+1843424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4037173,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969, 1.0, int_stack+1846259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1791680,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6517480,int_stack+6534385,int_stack+6528505, 1.0, int_stack+1850795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4228873,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+6517480,int_stack+6510865, 1.0, int_stack+1856675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1796216,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+526890,int_stack+526302, 1.0, int_stack+1289253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559078,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+527674,int_stack+526890, 1.0, int_stack+1289841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559666,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6508030,int_stack+5762470,int_stack+5760706, 1.0, int_stack+1921467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4244014,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6511558,int_stack+528682,int_stack+527674, 1.0, int_stack+1290625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1560450,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6514582,int_stack+6511558,int_stack+5762470, 1.0, int_stack+1923231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4245778,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519286,int_stack+6514582,int_stack+6508030, 1.0, int_stack+1925583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4248130,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+529942,int_stack+528682, 1.0, int_stack+1291633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1561458,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6525166,int_stack+5760706,int_stack+6511558, 1.0, int_stack+1929111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4251658,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6531214,int_stack+6525166,int_stack+6514582, 1.0, int_stack+1932135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4254682,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6508030,int_stack+6531214,int_stack+6519286, 1.0, int_stack+1936839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4259386,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6516850,int_stack+531482,int_stack+529942, 1.0, int_stack+1292893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1562718,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6539054,int_stack+6516850,int_stack+5760706, 1.0, int_stack+1942719, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1863290,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7500280,int_stack+6539054,int_stack+6525166, 1.0, int_stack+1946499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4265266,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6539054,int_stack+7500280,int_stack+6531214, 1.0, int_stack+1952547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4271314,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7500280,int_stack+6539054,int_stack+6508030, 1.0, int_stack+1960387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4279154,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6508030,int_stack+7500280,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+534086,int_stack+533330, 1.0, int_stack+1303309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573890,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+535094,int_stack+534086, 1.0, int_stack+1304065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575654,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6535813,int_stack+83754,int_stack+81486, 1.0, int_stack+2072650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1881371,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+536390,int_stack+535094, 1.0, int_stack+1305073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1577958,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6540349,int_stack+86778,int_stack+83754, 1.0, int_stack+2074918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1883639,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6546397,int_stack+6540349,int_stack+6535813, 1.0, int_stack+2077942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1886663,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+538010,int_stack+536390, 1.0, int_stack+1306369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580874,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7512628,int_stack+81486,int_stack+86778, 1.0, int_stack+2082478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4287974,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7520404,int_stack+7512628,int_stack+6540349, 1.0, int_stack+2086366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4291862,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7530484,int_stack+7520404,int_stack+6546397, 1.0, int_stack+2092414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4413526,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6535813,int_stack+539990,int_stack+538010, 1.0, int_stack+1307989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1584474,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6541753,int_stack+6535813,int_stack+81486, 1.0, int_stack+2099974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969207,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+498231,int_stack+6541753,int_stack+7512628, 1.0, int_stack+2104834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4421086,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6535813,int_stack+498231,int_stack+7520404, 1.0, int_stack+2112610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4428862,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+6535813,int_stack+7530484, 1.0, int_stack+2122690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4438942,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+498231,int_stack+1894979,int_stack+7500280,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2034463,int_stack+498231,int_stack+6508030,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+545516,int_stack+543311, 1.0, int_stack+542366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748086,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6510865,int_stack+548396,int_stack+545516, 1.0, int_stack+544256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751236,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+6510865,int_stack+6508030, 1.0, int_stack+2146315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2021098,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6514645,int_stack+552041,int_stack+548396, 1.0, int_stack+546776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755376,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6519505,int_stack+6514645,int_stack+6510865, 1.0, int_stack+2322076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1891199,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6527065,int_stack+6519505,int_stack+5760706, 1.0, int_stack+2325856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2023933,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+556541,int_stack+552041, 1.0, int_stack+550016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+760641,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6536515,int_stack+6508030,int_stack+6514645, 1.0, int_stack+2331526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029603,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7500280,int_stack+6536515,int_stack+6519505, 1.0, int_stack+2336386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4558768,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7512880,int_stack+7500280,int_stack+6527065, 1.0, int_stack+2343946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4566328,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6514105,int_stack+559016,int_stack+556541, 1.0, int_stack+554066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764691,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6521530,int_stack+6514105,int_stack+6508030, 1.0, int_stack+2353396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134030,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7527055,int_stack+6521530,int_stack+6536515, 1.0, int_stack+2359471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4575778,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6508030,int_stack+7527055,int_stack+7500280, 1.0, int_stack+2369191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4585498,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7527055,int_stack+6508030,int_stack+7512880, 1.0, int_stack+2381791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4598098,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+7527055,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2321623,int_stack+6508030,int_stack+498231,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+562427,int_stack+561986, 1.0, int_stack+1332676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548536, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+499554,int_stack+563015,int_stack+562427, 1.0, int_stack+1333117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548977, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+501318,int_stack+499554,int_stack+498231, 1.0, int_stack+2395966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4212934, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+503964,int_stack+563771,int_stack+563015, 1.0, int_stack+1333705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1549565, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+506232,int_stack+503964,int_stack+499554, 1.0, int_stack+2397289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4214257, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+509760,int_stack+506232,int_stack+501318, 1.0, int_stack+2399053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4216021, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+564716,int_stack+563771, 1.0, int_stack+1334461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550321, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+514170,int_stack+498231,int_stack+503964, 1.0, int_stack+2401699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4218667, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+518706,int_stack+514170,int_stack+506232, 1.0, int_stack+2403967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4220935, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+501066,int_stack+518706,int_stack+509760, 1.0, int_stack+2407495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4224463, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+507681,int_stack+565871,int_stack+564716, 1.0, int_stack+1335406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1551266, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+507681,int_stack+498231, 1.0, int_stack+2411905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4037173, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+524586,int_stack+5760706,int_stack+514170, 1.0, int_stack+2414740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1791680, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+507681,int_stack+524586,int_stack+518706, 1.0, int_stack+2419276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4228873, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+507681,int_stack+501066, 1.0, int_stack+2425156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1796216, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+567845,int_stack+567257, 1.0, int_stack+1343218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559078, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+568629,int_stack+567845, 1.0, int_stack+1343806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559666, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+498231,int_stack+5762470,int_stack+5760706, 1.0, int_stack+2431771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4244014, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+501759,int_stack+569637,int_stack+568629, 1.0, int_stack+1344590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1560450, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504783,int_stack+501759,int_stack+5762470, 1.0, int_stack+2433535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4245778, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+509487,int_stack+504783,int_stack+498231, 1.0, int_stack+2435887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4248130, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+570897,int_stack+569637, 1.0, int_stack+1345598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1561458, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+515367,int_stack+5760706,int_stack+501759, 1.0, int_stack+2449852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4251658, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+521415,int_stack+515367,int_stack+504783, 1.0, int_stack+2452876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4254682, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+498231,int_stack+521415,int_stack+509487, 1.0, int_stack+2457580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4259386, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2449852,int_stack+572437,int_stack+570897, 1.0, int_stack+1346858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1562718, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2454472,int_stack+2449852,int_stack+5760706, 1.0, int_stack+2463460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1863290, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+529255,int_stack+2454472,int_stack+515367, 1.0, int_stack+2467240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4265266, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2449852,int_stack+529255,int_stack+521415, 1.0, int_stack+2473288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4271314, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2461612,int_stack+2449852,int_stack+498231, 1.0, int_stack+2556427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4279154, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+2461612,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+575041,int_stack+574285, 1.0, int_stack+1357274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573890, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+576049,int_stack+575041, 1.0, int_stack+1358030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575654, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2556427,int_stack+83754,int_stack+81486, 1.0, int_stack+2565247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1881371, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+577345,int_stack+576049, 1.0, int_stack+1359038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1577958, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2560963,int_stack+86778,int_stack+83754, 1.0, int_stack+2567515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1883639, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+526014,int_stack+2560963,int_stack+2556427, 1.0, int_stack+2570539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1886663, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+578965,int_stack+577345, 1.0, int_stack+1360334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580874, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2567011,int_stack+81486,int_stack+86778, 1.0, int_stack+2617138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4287974, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+533574,int_stack+2567011,int_stack+2560963, 1.0, int_stack+2621026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4291862, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+543654,int_stack+533574,int_stack+526014, 1.0, int_stack+2627074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4413526, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+526014,int_stack+580945,int_stack+578965, 1.0, int_stack+1361954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1584474, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2617138,int_stack+526014,int_stack+81486, 1.0, int_stack+2634634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969207, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+554994,int_stack+2617138,int_stack+2567011, 1.0, int_stack+2639494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4421086, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2617138,int_stack+554994,int_stack+533574, 1.0, int_stack+2647270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4428862, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+2617138,int_stack+543654, 1.0, int_stack+2657350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4438942, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2617138,int_stack+1894979,int_stack+2461612,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+526014,int_stack+2617138,int_stack+498231,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+586471,int_stack+584266, 1.0, int_stack+583321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748086, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+589351,int_stack+586471, 1.0, int_stack+585211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751236, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 1.0, int_stack+2668690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2021098, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+592996,int_stack+589351, 1.0, int_stack+587731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755376, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 1.0, int_stack+2671525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1891199, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2654182,int_stack+509706,int_stack+5760706, 1.0, int_stack+2675305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2023933, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+597496,int_stack+592996, 1.0, int_stack+590971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+760641, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2663632,int_stack+498231,int_stack+504846, 1.0, int_stack+2792296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029603, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+581580,int_stack+2663632,int_stack+509706, 1.0, int_stack+2797156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4558768, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+581580,int_stack+2654182, 1.0, int_stack+2804716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4566328, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2654182,int_stack+599971,int_stack+597496, 1.0, int_stack+595021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764691, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2792296,int_stack+2654182,int_stack+498231, 1.0, int_stack+2814166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134030, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2556427,int_stack+2792296,int_stack+2663632, 1.0, int_stack+2820241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4575778, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2792296,int_stack+2556427,int_stack+581580, 1.0, int_stack+2829961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4585498, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+581580,int_stack+2792296,int_stack+504306, 1.0, int_stack+2842561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4598098, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+581580,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+7621996,int_stack+6508030,int_stack+2617138,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2617138,int_stack+603382,int_stack+602941, 1.0, int_stack+1386641, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548536, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2618461,int_stack+603970,int_stack+603382, 1.0, int_stack+1387082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548977, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2620225,int_stack+2618461,int_stack+2617138, 1.0, int_stack+2856736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4212934, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2622871,int_stack+604726,int_stack+603970, 1.0, int_stack+1387670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1549565, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2625139,int_stack+2622871,int_stack+2618461, 1.0, int_stack+2858059, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4214257, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2628667,int_stack+2625139,int_stack+2620225, 1.0, int_stack+2859823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4216021, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2617138,int_stack+605671,int_stack+604726, 1.0, int_stack+1388426, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550321, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2633077,int_stack+2617138,int_stack+2622871, 1.0, int_stack+2862469, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4218667, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2637613,int_stack+2633077,int_stack+2625139, 1.0, int_stack+2864737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4220935, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2619973,int_stack+2637613,int_stack+2628667, 1.0, int_stack+2868265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4224463, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2626588,int_stack+606826,int_stack+605671, 1.0, int_stack+1389371, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1551266, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+2626588,int_stack+2617138, 1.0, int_stack+2680975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4037173, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2643493,int_stack+5760706,int_stack+2633077, 1.0, int_stack+2872675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2626588,int_stack+2643493,int_stack+2637613, 1.0, int_stack+2877211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4228873, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+2626588,int_stack+2619973, 1.0, int_stack+2883091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1796216, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5760706,int_stack+608800,int_stack+608212, 1.0, int_stack+1397183, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559078, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5762470,int_stack+609584,int_stack+608800, 1.0, int_stack+1397771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559666, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2617138,int_stack+5762470,int_stack+5760706, 1.0, int_stack+2889706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2620666,int_stack+610592,int_stack+609584, 1.0, int_stack+1398555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1560450, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2623690,int_stack+2620666,int_stack+5762470, 1.0, int_stack+2891470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4245778, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2628394,int_stack+2623690,int_stack+2617138, 1.0, int_stack+2893822, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4248130, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5760706,int_stack+611852,int_stack+610592, 1.0, int_stack+1399563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1561458, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2634274,int_stack+5760706,int_stack+2620666, 1.0, int_stack+2907787, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4251658, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2640322,int_stack+2634274,int_stack+2623690, 1.0, int_stack+2910811, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4254682, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2617138,int_stack+2640322,int_stack+2628394, 1.0, int_stack+2915515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4259386, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2907787,int_stack+613392,int_stack+611852, 1.0, int_stack+1400823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1562718, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2912407,int_stack+2907787,int_stack+5760706, 1.0, int_stack+2921395, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2648162,int_stack+2912407,int_stack+2634274, 1.0, int_stack+2925175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4265266, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2907787,int_stack+2648162,int_stack+2640322, 1.0, int_stack+2931223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4271314, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2919547,int_stack+2907787,int_stack+2617138, 1.0, int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4279154, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+2919547,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+615996,int_stack+615240, 1.0, int_stack+1411239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573890, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+617004,int_stack+615996, 1.0, int_stack+1411995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575654, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+618300,int_stack+617004, 1.0, int_stack+1413003, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1577958, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2617138,int_stack+86778,int_stack+83754, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1883639, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2623186,int_stack+2617138,int_stack+3017197, 1.0, int_stack+3066148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1886663, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+619920,int_stack+618300, 1.0, int_stack+1414299, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580874, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2630746,int_stack+3017197,int_stack+86778, 1.0, int_stack+2939063, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4287974, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2638522,int_stack+2630746,int_stack+2617138, 1.0, int_stack+3070684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4291862, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2648602,int_stack+2638522,int_stack+2623186, 1.0, int_stack+3076732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4413526, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2617138,int_stack+621900,int_stack+619920, 1.0, int_stack+1415919, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1584474, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3066148,int_stack+2617138,int_stack+3017197, 1.0, int_stack+3084292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2617138,int_stack+3066148,int_stack+2630746, 1.0, int_stack+3089152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4421086, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3066148,int_stack+2617138,int_stack+2638522, 1.0, int_stack+3096928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4428862, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+3066148,int_stack+2648602, 1.0, int_stack+3107008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4438942, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3066148,int_stack+1894979,int_stack+2919547,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2617138,int_stack+3066148,int_stack+498231,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+627426,int_stack+625221, 1.0, int_stack+624276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748086, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+630306,int_stack+627426, 1.0, int_stack+626166, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751236, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 1.0, int_stack+3118348, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+633951,int_stack+630306, 1.0, int_stack+628686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755376, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 1.0, int_stack+3121183, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1891199, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3103192,int_stack+509706,int_stack+5760706, 1.0, int_stack+3124963, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2023933, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+638451,int_stack+633951, 1.0, int_stack+631926, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+760641, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3112642,int_stack+498231,int_stack+504846, 1.0, int_stack+3241954, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029603, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2907787,int_stack+3112642,int_stack+509706, 1.0, int_stack+3246814, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4558768, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+2907787,int_stack+3103192, 1.0, int_stack+3254374, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4566328, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3103192,int_stack+640926,int_stack+638451, 1.0, int_stack+635976, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764691, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3241954,int_stack+3103192,int_stack+498231, 1.0, int_stack+3263824, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2920387,int_stack+3241954,int_stack+3112642, 1.0, int_stack+3269899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4575778, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3241954,int_stack+2920387,int_stack+2907787, 1.0, int_stack+3279619, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4585498, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2907787,int_stack+3241954,int_stack+504306, 1.0, int_stack+3292219, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4598098, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+2907787,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2792296,int_stack+6508030,int_stack+3066148,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3066148,int_stack+644337,int_stack+643896, 1.0, int_stack+1440606, 0.0, zero_stack, 1.0, int_stack+1548536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3067471,int_stack+644925,int_stack+644337, 1.0, int_stack+1441047, 0.0, zero_stack, 1.0, int_stack+1548977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3069235,int_stack+3067471,int_stack+3066148, 1.0, int_stack+3306394, 0.0, zero_stack, 1.0, int_stack+4212934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3071881,int_stack+645681,int_stack+644925, 1.0, int_stack+1441635, 0.0, zero_stack, 1.0, int_stack+1549565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3074149,int_stack+3071881,int_stack+3067471, 1.0, int_stack+3307717, 0.0, zero_stack, 1.0, int_stack+4214257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3077677,int_stack+3074149,int_stack+3069235, 1.0, int_stack+3309481, 0.0, zero_stack, 1.0, int_stack+4216021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3066148,int_stack+646626,int_stack+645681, 1.0, int_stack+1442391, 0.0, zero_stack, 1.0, int_stack+1550321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3082087,int_stack+3066148,int_stack+3071881, 1.0, int_stack+3312127, 0.0, zero_stack, 1.0, int_stack+4218667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3086623,int_stack+3082087,int_stack+3074149, 1.0, int_stack+3314395, 0.0, zero_stack, 1.0, int_stack+4220935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3068983,int_stack+3086623,int_stack+3077677, 1.0, int_stack+3317923, 0.0, zero_stack, 1.0, int_stack+4224463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3075598,int_stack+647781,int_stack+646626, 1.0, int_stack+1443336, 0.0, zero_stack, 1.0, int_stack+1551266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+3075598,int_stack+3066148, 1.0, int_stack+3130633, 0.0, zero_stack, 1.0, int_stack+4037173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3092503,int_stack+5760706,int_stack+3082087, 1.0, int_stack+3322333, 0.0, zero_stack, 1.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+3092503,int_stack+3086623, 1.0, int_stack+3326869, 0.0, zero_stack, 1.0, int_stack+4228873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+3068983, 1.0, int_stack+3332749, 0.0, zero_stack, 1.0, int_stack+1796216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+649755,int_stack+649167, 1.0, int_stack+1451148, 0.0, zero_stack, 1.0, int_stack+1559078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+650539,int_stack+649755, 1.0, int_stack+1451736, 0.0, zero_stack, 1.0, int_stack+1559666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 1.0, int_stack+3339364, 0.0, zero_stack, 1.0, int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+651547,int_stack+650539, 1.0, int_stack+1452520, 0.0, zero_stack, 1.0, int_stack+1560450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3066148,int_stack+5760706,int_stack+3018961, 1.0, int_stack+3341128, 0.0, zero_stack, 1.0, int_stack+4245778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3070852,int_stack+3066148,int_stack+3021313, 1.0, int_stack+3343480, 0.0, zero_stack, 1.0, int_stack+4248130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+652807,int_stack+651547, 1.0, int_stack+1453528, 0.0, zero_stack, 1.0, int_stack+1561458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3076732,int_stack+3017197,int_stack+5760706, 1.0, int_stack+3357445, 0.0, zero_stack, 1.0, int_stack+4251658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3082780,int_stack+3076732,int_stack+3066148, 1.0, int_stack+3360469, 0.0, zero_stack, 1.0, int_stack+4254682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3090620,int_stack+3082780,int_stack+3070852, 1.0, int_stack+3365173, 0.0, zero_stack, 1.0, int_stack+4259386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3066148,int_stack+654347,int_stack+652807, 1.0, int_stack+1454788, 0.0, zero_stack, 1.0, int_stack+1562718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3357445,int_stack+3066148,int_stack+3017197, 1.0, int_stack+3371053, 0.0, zero_stack, 1.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3066148,int_stack+3357445,int_stack+3076732, 1.0, int_stack+3374833, 0.0, zero_stack, 1.0, int_stack+4265266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3357445,int_stack+3066148,int_stack+3082780, 1.0, int_stack+3380881, 0.0, zero_stack, 1.0, int_stack+4271314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3066148,int_stack+3357445,int_stack+3090620, 1.0, int_stack+3466855, 0.0, zero_stack, 1.0, int_stack+4279154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+3066148,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+656951,int_stack+656195, 1.0, int_stack+1465204, 0.0, zero_stack, 1.0, int_stack+1573890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+657959,int_stack+656951, 1.0, int_stack+1465960, 0.0, zero_stack, 1.0, int_stack+1575654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3466855,int_stack+83754,int_stack+81486, 1.0, int_stack+3475675, 0.0, zero_stack, 1.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+659255,int_stack+657959, 1.0, int_stack+1466968, 0.0, zero_stack, 1.0, int_stack+1577958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3471391,int_stack+86778,int_stack+83754, 1.0, int_stack+3477943, 0.0, zero_stack, 1.0, int_stack+1883639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3357445,int_stack+3471391,int_stack+3466855, 1.0, int_stack+3480967, 0.0, zero_stack, 1.0, int_stack+1886663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+660875,int_stack+659255, 1.0, int_stack+1468264, 0.0, zero_stack, 1.0, int_stack+1580874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3477439,int_stack+81486,int_stack+86778, 1.0, int_stack+3388721, 0.0, zero_stack, 1.0, int_stack+4287974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3365005,int_stack+3477439,int_stack+3471391, 1.0, int_stack+3527566, 0.0, zero_stack, 1.0, int_stack+4291862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3375085,int_stack+3365005,int_stack+3357445, 1.0, int_stack+3533614, 0.0, zero_stack, 1.0, int_stack+4413526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3357445,int_stack+662855,int_stack+660875, 1.0, int_stack+1469884, 0.0, zero_stack, 1.0, int_stack+1584474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3527566,int_stack+3357445,int_stack+81486, 1.0, int_stack+3541174, 0.0, zero_stack, 1.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3078496,int_stack+3527566,int_stack+3477439, 1.0, int_stack+3546034, 0.0, zero_stack, 1.0, int_stack+4421086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3527566,int_stack+3078496,int_stack+3365005, 1.0, int_stack+3553810, 0.0, zero_stack, 1.0, int_stack+4428862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+3527566,int_stack+3375085, 1.0, int_stack+3563890, 0.0, zero_stack, 1.0, int_stack+4438942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3527566,int_stack+1894979,int_stack+3066148,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+3066148,int_stack+3527566,int_stack+498231,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+668381,int_stack+666176, 1.0, int_stack+665231, 0.0, zero_stack, 1.0, int_stack+748086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+671261,int_stack+668381, 1.0, int_stack+667121, 0.0, zero_stack, 1.0, int_stack+751236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 1.0, int_stack+3575230, 0.0, zero_stack, 1.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+674906,int_stack+671261, 1.0, int_stack+669641, 0.0, zero_stack, 1.0, int_stack+755376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 1.0, int_stack+3578065, 0.0, zero_stack, 1.0, int_stack+1891199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3121714,int_stack+509706,int_stack+5760706, 1.0, int_stack+3581845, 0.0, zero_stack, 1.0, int_stack+2023933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+679406,int_stack+674906, 1.0, int_stack+672881, 0.0, zero_stack, 1.0, int_stack+760641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3564610,int_stack+498231,int_stack+504846, 1.0, int_stack+3698836, 0.0, zero_stack, 1.0, int_stack+2029603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3574330,int_stack+3564610,int_stack+509706, 1.0, int_stack+3703696, 0.0, zero_stack, 1.0, int_stack+4558768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+3574330,int_stack+3121714, 1.0, int_stack+3711256, 0.0, zero_stack, 1.0, int_stack+4566328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3121714,int_stack+681881,int_stack+679406, 1.0, int_stack+676931, 0.0, zero_stack, 1.0, int_stack+764691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3698836,int_stack+3121714,int_stack+498231, 1.0, int_stack+3720706, 0.0, zero_stack, 1.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3357445,int_stack+3698836,int_stack+3564610, 1.0, int_stack+3726781, 0.0, zero_stack, 1.0, int_stack+4575778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3698836,int_stack+3357445,int_stack+3574330, 1.0, int_stack+3736501, 0.0, zero_stack, 1.0, int_stack+4585498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3357445,int_stack+3698836,int_stack+504306, 1.0, int_stack+3749101, 0.0, zero_stack, 1.0, int_stack+4598098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+3357445,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+3241954,int_stack+6508030,int_stack+3527566,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3527566,int_stack+685292,int_stack+684851, 1.0, int_stack+1494571, 1.0, int_stack+1548536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3528889,int_stack+685880,int_stack+685292, 1.0, int_stack+1495012, 1.0, int_stack+1548977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3530653,int_stack+3528889,int_stack+3527566, 1.0, int_stack+3763276, 1.0, int_stack+4212934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3533299,int_stack+686636,int_stack+685880, 1.0, int_stack+1495600, 1.0, int_stack+1549565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3535567,int_stack+3533299,int_stack+3528889, 1.0, int_stack+3764599, 1.0, int_stack+4214257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3539095,int_stack+3535567,int_stack+3530653, 1.0, int_stack+3766363, 1.0, int_stack+4216021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3527566,int_stack+687581,int_stack+686636, 1.0, int_stack+1496356, 1.0, int_stack+1550321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3543505,int_stack+3527566,int_stack+3533299, 1.0, int_stack+3769009, 1.0, int_stack+4218667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3548041,int_stack+3543505,int_stack+3535567, 1.0, int_stack+3771277, 1.0, int_stack+4220935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3530401,int_stack+3548041,int_stack+3539095, 1.0, int_stack+3774805, 1.0, int_stack+4224463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3537016,int_stack+688736,int_stack+687581, 1.0, int_stack+1497301, 1.0, int_stack+1551266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+3537016,int_stack+3527566, 1.0, int_stack+3587515, 1.0, int_stack+4037173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3553921,int_stack+5760706,int_stack+3543505, 1.0, int_stack+3779215, 1.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+3553921,int_stack+3548041, 1.0, int_stack+3783751, 1.0, int_stack+4228873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+3530401, 1.0, int_stack+3789631, 1.0, int_stack+1796216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+690710,int_stack+690122, 1.0, int_stack+1505113, 1.0, int_stack+1559078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+691494,int_stack+690710, 1.0, int_stack+1505701, 1.0, int_stack+1559666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 1.0, int_stack+3796246, 1.0, int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+692502,int_stack+691494, 1.0, int_stack+1506485, 1.0, int_stack+1560450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3527566,int_stack+5760706,int_stack+3018961, 1.0, int_stack+3798010, 1.0, int_stack+4245778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3532270,int_stack+3527566,int_stack+3021313, 1.0, int_stack+3800362, 1.0, int_stack+4248130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+693762,int_stack+692502, 1.0, int_stack+1507493, 1.0, int_stack+1561458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3538150,int_stack+3017197,int_stack+5760706, 1.0, int_stack+3814327, 1.0, int_stack+4251658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3544198,int_stack+3538150,int_stack+3527566, 1.0, int_stack+3817351, 1.0, int_stack+4254682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3552038,int_stack+3544198,int_stack+3532270, 1.0, int_stack+3822055, 1.0, int_stack+4259386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3527566,int_stack+695302,int_stack+693762, 1.0, int_stack+1508753, 1.0, int_stack+1562718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3814327,int_stack+3527566,int_stack+3017197, 1.0, int_stack+3827935, 1.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3527566,int_stack+3814327,int_stack+3538150, 1.0, int_stack+3831715, 1.0, int_stack+4265266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3814327,int_stack+3527566,int_stack+3544198, 1.0, int_stack+3837763, 1.0, int_stack+4271314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3527566,int_stack+3814327,int_stack+3552038, 1.0, int_stack+3923737, 1.0, int_stack+4279154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+3527566,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+697906,int_stack+697150, 1.0, int_stack+1519169, 1.0, int_stack+1573890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+698914,int_stack+697906, 1.0, int_stack+1519925, 1.0, int_stack+1575654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 1.0, int_stack+5292, 1.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+700210,int_stack+698914, 1.0, int_stack+1520933, 1.0, int_stack+1577958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3814327,int_stack+86778,int_stack+83754, 1.0, int_stack+7560, 1.0, int_stack+1883639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3820375,int_stack+3814327,int_stack+3923737, 1.0, int_stack+3972688, 1.0, int_stack+1886663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+701830,int_stack+700210, 1.0, int_stack+1522229, 1.0, int_stack+1580874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3827935,int_stack+3923737,int_stack+86778, 1.0, int_stack+3845603, 1.0, int_stack+4287974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3835711,int_stack+3827935,int_stack+3814327, 1.0, int_stack+3977224, 1.0, int_stack+4291862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3539914,int_stack+3835711,int_stack+3820375, 1.0, int_stack+3983272, 1.0, int_stack+4413526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3814327,int_stack+703810,int_stack+701830, 1.0, int_stack+1523849, 1.0, int_stack+1584474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3972688,int_stack+3814327,int_stack+3923737, 1.0, int_stack+3990832, 1.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3814327,int_stack+3972688,int_stack+3827935, 1.0, int_stack+3995692, 1.0, int_stack+4421086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3972688,int_stack+3814327,int_stack+3835711, 1.0, int_stack+4003468, 1.0, int_stack+4428862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+3972688,int_stack+3539914, 1.0, int_stack+4013548, 1.0, int_stack+4438942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3539914,int_stack+1894979,int_stack+3527566,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+3698836,int_stack+3539914,int_stack+498231,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+709336,int_stack+707131, 1.0, int_stack+706186, 1.0, int_stack+748086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+712216,int_stack+709336, 1.0, int_stack+708076, 1.0, int_stack+751236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 1.0, int_stack+4024888, 1.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+715861,int_stack+712216, 1.0, int_stack+710596, 1.0, int_stack+755376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 1.0, int_stack+4027723, 1.0, int_stack+1891199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3527566,int_stack+509706,int_stack+5760706, 1.0, int_stack+4031503, 1.0, int_stack+2023933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+720361,int_stack+715861, 1.0, int_stack+713836, 1.0, int_stack+760641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3576958,int_stack+498231,int_stack+504846, 1.0, int_stack+4148494, 1.0, int_stack+2029603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3972688,int_stack+3576958,int_stack+509706, 1.0, int_stack+4153354, 1.0, int_stack+4558768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+3972688,int_stack+3527566, 1.0, int_stack+4160914, 1.0, int_stack+4566328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3527566,int_stack+722836,int_stack+720361, 1.0, int_stack+717886, 1.0, int_stack+764691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4148494,int_stack+3527566,int_stack+498231, 1.0, int_stack+4170364, 1.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3985288,int_stack+4148494,int_stack+3576958, 1.0, int_stack+4176439, 1.0, int_stack+4575778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4148494,int_stack+3985288,int_stack+3972688, 1.0, int_stack+4186159, 1.0, int_stack+4585498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3972688,int_stack+4148494,int_stack+504306, 1.0, int_stack+4198759, 1.0, int_stack+4598098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+3972688,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+581580,int_stack+6508030,int_stack+3539914,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+726247,int_stack+725806, 2.0, int_stack+1548536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+726835,int_stack+726247, 2.0, int_stack+1548977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030, 2.0, int_stack+4212934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+727591,int_stack+726835, 2.0, int_stack+1549565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353, 2.0, int_stack+4214257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117, 2.0, int_stack+4216021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+728536,int_stack+727591, 2.0, int_stack+1550321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763, 2.0, int_stack+4218667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031, 2.0, int_stack+4220935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559, 2.0, int_stack+4224463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+729691,int_stack+728536, 2.0, int_stack+1551266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030, 2.0, int_stack+4037173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969, 2.0, int_stack+1791680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+6534385,int_stack+6528505, 2.0, int_stack+4228873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+6510865, 2.0, int_stack+1796216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+731665,int_stack+731077, 2.0, int_stack+1559078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+732449,int_stack+731665, 2.0, int_stack+1559666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 2.0, int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1791680,int_stack+733457,int_stack+732449, 2.0, int_stack+1560450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1794704,int_stack+1791680,int_stack+3925501, 2.0, int_stack+4245778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+1794704,int_stack+3927853, 2.0, int_stack+4248130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4244014,int_stack+734717,int_stack+733457, 2.0, int_stack+1561458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3923737,int_stack+4244014,int_stack+1791680, 2.0, int_stack+4251658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6513910,int_stack+3923737,int_stack+1794704, 2.0, int_stack+4254682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+6513910,int_stack+6508030, 2.0, int_stack+4259386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+736257,int_stack+734717, 2.0, int_stack+1562718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1791680,int_stack+6508030,int_stack+4244014, 2.0, int_stack+1863290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4244014,int_stack+1791680,int_stack+3923737, 2.0, int_stack+4265266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4254094,int_stack+4244014,int_stack+6513910, 2.0, int_stack+4271314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4265854,int_stack+4254094,int_stack+3017197, 2.0, int_stack+4279154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+4265854,int_stack+81486,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+738861,int_stack+738105, 2.0, int_stack+1573890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+739869,int_stack+738861, 2.0, int_stack+1575654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 2.0, int_stack+1881371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+741165,int_stack+739869, 2.0, int_stack+1577958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4244014,int_stack+86778,int_stack+83754, 2.0, int_stack+1883639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4250062,int_stack+4244014,int_stack+3017197, 2.0, int_stack+1886663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+742785,int_stack+741165, 2.0, int_stack+1580874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1881371,int_stack+3017197,int_stack+86778, 2.0, int_stack+4287974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1791680,int_stack+1881371,int_stack+4244014, 2.0, int_stack+4291862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1573134,int_stack+1791680,int_stack+4250062, 2.0, int_stack+4413526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4413526,int_stack+744765,int_stack+742785, 2.0, int_stack+1584474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+4413526,int_stack+3017197, 2.0, int_stack+1969207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4278202,int_stack+4244014,int_stack+1881371, 2.0, int_stack+4421086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4244014,int_stack+4278202,int_stack+1791680, 2.0, int_stack+4428862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1894979,int_stack+4244014,int_stack+1573134, 2.0, int_stack+4438942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+1894979,int_stack+4265854,441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+3972688,int_stack+6508030,int_stack+498231,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+752496,int_stack+749031, 2.0, int_stack+748086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+756996,int_stack+752496, 2.0, int_stack+751236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 2.0, int_stack+2021098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+762666,int_stack+756996, 2.0, int_stack+755376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 2.0, int_stack+1891199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1573134,int_stack+509706,int_stack+5760706, 2.0, int_stack+2023933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2021098,int_stack+767166,int_stack+762666, 2.0, int_stack+760641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4244014,int_stack+2021098,int_stack+504846, 2.0, int_stack+2029603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4253734,int_stack+4244014,int_stack+509706, 2.0, int_stack+4558768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+498231,int_stack+4253734,int_stack+1573134, 2.0, int_stack+4566328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1573134,int_stack+769641,int_stack+767166, 2.0, int_stack+764691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4558768,int_stack+1573134,int_stack+2021098, 2.0, int_stack+2134030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4266334,int_stack+4558768,int_stack+4244014, 2.0, int_stack+4575778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4558768,int_stack+4266334,int_stack+4253734, 2.0, int_stack+4585498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4558768,int_stack+498231, 2.0, int_stack+4598098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+4244014,int_stack+1894979,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+4148494,int_stack+7500280,int_stack+6508030,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+773052,int_stack+772611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617486,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+773640,int_stack+773052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617927,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4642702,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+774396,int_stack+773640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1618515,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4644025,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4645789,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+775341,int_stack+774396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619271,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4648435,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4650703,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4654231,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+776496,int_stack+775341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620216,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1910855,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1913690,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+6534385,int_stack+6528505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4612273,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+6510865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285419,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+778470,int_stack+777882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628028,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+779254,int_stack+778470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628616,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2292034,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+780262,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1629400,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6508030,int_stack+5760706,int_stack+3018961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2293798,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6512734,int_stack+6508030,int_stack+3021313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2296150,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+781522,int_stack+780262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630408,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6518614,int_stack+3017197,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2310115,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6524662,int_stack+6518614,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2313139,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+6524662,int_stack+6512734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140105,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+783062,int_stack+781522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1631668,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2317843,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+6518614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974067,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+6524662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802831,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810671,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6508030,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1872110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+785666,int_stack+784910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642084,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+786674,int_stack+785666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642840,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4789555,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+787970,int_stack+786674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1643848,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6520378,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4791823,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6526426,int_stack+6520378,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4794847,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+789590,int_stack+787970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645144,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6533986,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4799383,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6541762,int_stack+6533986,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4803271,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7500280,int_stack+6541762,int_stack+6526426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819491,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6520378,int_stack+791570,int_stack+789590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1646764,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867070,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+6533986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10584,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+6541762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4851526,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4861606,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+7500280,int_stack+6520378,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1980967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3527566,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1993315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+794891,int_stack+793946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957096,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+796151,int_stack+794891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958986,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+797771,int_stack+796151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961506,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744064,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4981432,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+799796,int_stack+797771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+964746,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7537324,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6536254,int_stack+7537324,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4987102,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6536254,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4994662,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+802271,int_stack+799796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+968796,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5004112,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+7537324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5010187,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+6536254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5019907,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5032507,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+4244014,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2149150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+655668,int_stack+6108484,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2165026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7500280,int_stack+805682,int_stack+805241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617486, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7501603,int_stack+806270,int_stack+805682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617927, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7503367,int_stack+7501603,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4642702, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7506013,int_stack+807026,int_stack+806270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1618515, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7508281,int_stack+7506013,int_stack+7501603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4644025, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7511809,int_stack+7508281,int_stack+7503367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4645789, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7500280,int_stack+807971,int_stack+807026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619271, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7516219,int_stack+7500280,int_stack+7506013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4648435, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7520755,int_stack+7516219,int_stack+7508281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4650703, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7503115,int_stack+7520755,int_stack+7511809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4654231, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7509730,int_stack+809126,int_stack+807971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620216, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+7509730,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1910855, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7526635,int_stack+5760706,int_stack+7516219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1913690, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+7526635,int_stack+7520755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4612273, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+7503115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285419, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+811100,int_stack+810512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628028, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+811884,int_stack+811100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628616, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2292034, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+812892,int_stack+811884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1629400, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7500280,int_stack+5760706,int_stack+3925501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2293798, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7504984,int_stack+7500280,int_stack+3927853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2296150, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+814152,int_stack+812892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630408, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7510864,int_stack+3923737,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2310115, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7516912,int_stack+7510864,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2313139, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+7516912,int_stack+7504984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140105, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+815692,int_stack+814152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1631668, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2317843, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+7510864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974067, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+7516912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802831, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810671, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+7500280,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2440591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+818296,int_stack+817540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642084, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+819304,int_stack+818296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642840, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4789555, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+820600,int_stack+819304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1643848, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7512628,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4791823, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7518676,int_stack+7512628,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4794847, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+822220,int_stack+820600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645144, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7526236,int_stack+3017197,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4799383, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7534012,int_stack+7526236,int_stack+7512628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4803271, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+7534012,int_stack+7518676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819491, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7512628,int_stack+824200,int_stack+822220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1646764, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6119824,int_stack+7512628,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867070, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7512628,int_stack+6119824,int_stack+7526236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10584, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6119824,int_stack+7512628,int_stack+7534012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4851526, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7512628,int_stack+6119824,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4861606, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+7512628,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2577007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+729756,int_stack+6108484,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2589355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+827521,int_stack+826576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957096, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+828781,int_stack+827521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958986, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+830401,int_stack+828781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961506, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744064, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7500280,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4981432, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+832426,int_stack+830401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+964746, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6145528,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7528504,int_stack+6145528,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4987102, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+7528504,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4994662, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+834901,int_stack+832426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+968796, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5004112, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+6145528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5010187, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+7528504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5019907, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5032507, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+4244014,int_stack+7512628, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2683810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+7696084,int_stack+6508030,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2699686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+838312,int_stack+837871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617486, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+838900,int_stack+838312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617927, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4642702, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+839656,int_stack+838900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1618515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4644025, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4645789, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+840601,int_stack+839656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619271, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4648435, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4650703, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4654231, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+841756,int_stack+840601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620216, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1910855, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1913690, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4612273, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285419, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+843730,int_stack+843142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628028, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+844514,int_stack+843730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628616, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2292034, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+845522,int_stack+844514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1629400, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6108484,int_stack+5760706,int_stack+3018961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2293798, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6113188,int_stack+6108484,int_stack+3021313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2296150, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+846782,int_stack+845522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630408, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6119068,int_stack+3017197,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2310115, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6125116,int_stack+6119068,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2313139, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+6125116,int_stack+6113188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140105, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+848322,int_stack+846782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1631668, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2317843, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+6119068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974067, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+6125116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802831, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810671, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6108484,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2898526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+850926,int_stack+850170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642084, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+851934,int_stack+850926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642840, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4789555, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+853230,int_stack+851934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1643848, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6120832,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4791823, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6126880,int_stack+6120832,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4794847, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+854850,int_stack+853230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645144, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6134440,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4799383, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6142216,int_stack+6134440,int_stack+6120832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4803271, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6508030,int_stack+6142216,int_stack+6126880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819491, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6120832,int_stack+856830,int_stack+854850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1646764, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6519370,int_stack+6120832,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867070, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6120832,int_stack+6519370,int_stack+6134440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10584, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6519370,int_stack+6120832,int_stack+6142216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4851526, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6120832,int_stack+6519370,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4861606, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+6120832,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3026017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+785322,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3038365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+860151,int_stack+859206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957096, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+861411,int_stack+860151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958986, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+863031,int_stack+861411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961506, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744064, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6108484,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4981432, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+865056,int_stack+863031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+964746, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6545074,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6136708,int_stack+6545074,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4987102, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6136708,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4994662, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+867531,int_stack+865056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+968796, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+6108484,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5004112, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+6545074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5010187, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+6136708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5019907, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5032507, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+4244014,int_stack+6120832, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3133468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+7770172,int_stack+7500280,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3149344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+870942,int_stack+870501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+871530,int_stack+870942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1617927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4642702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+872286,int_stack+871530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1618515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4644025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4645789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+873231,int_stack+872286, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1619271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4648435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4650703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4654231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+874386,int_stack+873231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1910855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1913690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+6534385,int_stack+6528505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4612273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+6510865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2285419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+876360,int_stack+875772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+877144,int_stack+876360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1628616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2292034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+878152,int_stack+877144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1629400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6508030,int_stack+5760706,int_stack+3925501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2293798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6512734,int_stack+6508030,int_stack+3927853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2296150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+879412,int_stack+878152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1630408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6518614,int_stack+3923737,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2310115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6524662,int_stack+6518614,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2313139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+6524662,int_stack+6512734, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2140105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+880952,int_stack+879412, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1631668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2317843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+6518614, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1974067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+6524662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1810671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6508030,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3348184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+883556,int_stack+882800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+884564,int_stack+883556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1642840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4789555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+885860,int_stack+884564, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1643848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6520378,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4791823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6526426,int_stack+6520378,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4794847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+887480,int_stack+885860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6533986,int_stack+3017197,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4799383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6541762,int_stack+6533986,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4803271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7500280,int_stack+6541762,int_stack+6526426, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6520378,int_stack+889460,int_stack+887480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1646764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1867070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+6533986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+6541762, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4851526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4861606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+7500280,int_stack+6520378,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3487435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+7844260,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3499783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+892781,int_stack+891836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+894041,int_stack+892781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+895661,int_stack+894041, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1744064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4981432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+897686,int_stack+895661, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+964746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7537324,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6536254,int_stack+7537324,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4987102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6536254,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4994662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+900161,int_stack+897686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+968796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5004112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+7537324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5010187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+6536254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5019907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5032507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+4244014,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3590350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+7899826,int_stack+6108484,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3606226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7500280,int_stack+903572,int_stack+903131, 0.0, zero_stack, 1.0, int_stack+1617486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7501603,int_stack+904160,int_stack+903572, 0.0, zero_stack, 1.0, int_stack+1617927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7503367,int_stack+7501603,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+4642702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7506013,int_stack+904916,int_stack+904160, 0.0, zero_stack, 1.0, int_stack+1618515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7508281,int_stack+7506013,int_stack+7501603, 0.0, zero_stack, 1.0, int_stack+4644025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7511809,int_stack+7508281,int_stack+7503367, 0.0, zero_stack, 1.0, int_stack+4645789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7500280,int_stack+905861,int_stack+904916, 0.0, zero_stack, 1.0, int_stack+1619271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7516219,int_stack+7500280,int_stack+7506013, 0.0, zero_stack, 1.0, int_stack+4648435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7520755,int_stack+7516219,int_stack+7508281, 0.0, zero_stack, 1.0, int_stack+4650703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7503115,int_stack+7520755,int_stack+7511809, 0.0, zero_stack, 1.0, int_stack+4654231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7509730,int_stack+907016,int_stack+905861, 0.0, zero_stack, 1.0, int_stack+1620216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+7509730,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+1910855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7526635,int_stack+5760706,int_stack+7516219, 0.0, zero_stack, 1.0, int_stack+1913690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+7526635,int_stack+7520755, 0.0, zero_stack, 1.0, int_stack+4612273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+7503115, 0.0, zero_stack, 1.0, int_stack+2285419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+908990,int_stack+908402, 0.0, zero_stack, 1.0, int_stack+1628028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+909774,int_stack+908990, 0.0, zero_stack, 1.0, int_stack+1628616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 0.0, zero_stack, 1.0, int_stack+2292034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+910782,int_stack+909774, 0.0, zero_stack, 1.0, int_stack+1629400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7500280,int_stack+5760706,int_stack+3018961, 0.0, zero_stack, 1.0, int_stack+2293798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7504984,int_stack+7500280,int_stack+3021313, 0.0, zero_stack, 1.0, int_stack+2296150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+912042,int_stack+910782, 0.0, zero_stack, 1.0, int_stack+1630408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7510864,int_stack+3017197,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2310115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7516912,int_stack+7510864,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+2313139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+7516912,int_stack+7504984, 0.0, zero_stack, 1.0, int_stack+2140105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+913582,int_stack+912042, 0.0, zero_stack, 1.0, int_stack+1631668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+3017197, 0.0, zero_stack, 1.0, int_stack+2317843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+7510864, 0.0, zero_stack, 1.0, int_stack+1974067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+7516912, 0.0, zero_stack, 1.0, int_stack+1802831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+1810671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+7500280,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3805066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+916186,int_stack+915430, 0.0, zero_stack, 1.0, int_stack+1642084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+917194,int_stack+916186, 0.0, zero_stack, 1.0, int_stack+1642840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+4789555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+918490,int_stack+917194, 0.0, zero_stack, 1.0, int_stack+1643848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7512628,int_stack+86778,int_stack+83754, 0.0, zero_stack, 1.0, int_stack+4791823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7518676,int_stack+7512628,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+4794847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+920110,int_stack+918490, 0.0, zero_stack, 1.0, int_stack+1645144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7526236,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 1.0, int_stack+4799383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7534012,int_stack+7526236,int_stack+7512628, 0.0, zero_stack, 1.0, int_stack+4803271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+7534012,int_stack+7518676, 0.0, zero_stack, 1.0, int_stack+1819491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7512628,int_stack+922090,int_stack+920110, 0.0, zero_stack, 1.0, int_stack+1646764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6119824,int_stack+7512628,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+1867070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7512628,int_stack+6119824,int_stack+7526236, 0.0, zero_stack, 1.0, int_stack+10584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6119824,int_stack+7512628,int_stack+7534012, 0.0, zero_stack, 1.0, int_stack+4851526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7512628,int_stack+6119824,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+4861606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+7512628,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3932557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+840888,int_stack+6108484,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3944905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+925411,int_stack+924466, 0.0, zero_stack, 1.0, int_stack+957096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+926671,int_stack+925411, 0.0, zero_stack, 1.0, int_stack+958986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+928291,int_stack+926671, 0.0, zero_stack, 1.0, int_stack+961506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 1.0, int_stack+1744064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7500280,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+4981432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+930316,int_stack+928291, 0.0, zero_stack, 1.0, int_stack+964746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6145528,int_stack+498231,int_stack+504846, 0.0, zero_stack, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7528504,int_stack+6145528,int_stack+509706, 0.0, zero_stack, 1.0, int_stack+4987102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+7528504,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+4994662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+932791,int_stack+930316, 0.0, zero_stack, 1.0, int_stack+968796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+5004112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+6145528, 0.0, zero_stack, 1.0, int_stack+5010187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+7528504, 0.0, zero_stack, 1.0, int_stack+5019907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 1.0, int_stack+5032507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+4244014,int_stack+7512628, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4040008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+7973914,int_stack+6508030,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4055884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+936202,int_stack+935761, 1.0, int_stack+1617486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+936790,int_stack+936202, 1.0, int_stack+1617927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 1.0, int_stack+4642702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+937546,int_stack+936790, 1.0, int_stack+1618515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 1.0, int_stack+4644025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 1.0, int_stack+4645789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+938491,int_stack+937546, 1.0, int_stack+1619271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 1.0, int_stack+4648435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 1.0, int_stack+4650703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 1.0, int_stack+4654231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+939646,int_stack+938491, 1.0, int_stack+1620216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 1.0, int_stack+1910855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 1.0, int_stack+1913690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+6134839,int_stack+6128959, 1.0, int_stack+4612273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+6111319, 1.0, int_stack+2285419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+941620,int_stack+941032, 1.0, int_stack+1628028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+942404,int_stack+941620, 1.0, int_stack+1628616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 1.0, int_stack+2292034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+943412,int_stack+942404, 1.0, int_stack+1629400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6108484,int_stack+5760706,int_stack+3925501, 1.0, int_stack+2293798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6113188,int_stack+6108484,int_stack+3927853, 1.0, int_stack+2296150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+944672,int_stack+943412, 1.0, int_stack+1630408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6119068,int_stack+3923737,int_stack+5760706, 1.0, int_stack+2310115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6125116,int_stack+6119068,int_stack+6108484, 1.0, int_stack+2313139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+6125116,int_stack+6113188, 1.0, int_stack+2140105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+946212,int_stack+944672, 1.0, int_stack+1631668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2310115,int_stack+6108484,int_stack+3923737, 1.0, int_stack+2317843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+2310115,int_stack+6119068, 1.0, int_stack+1974067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+6125116, 1.0, int_stack+1802831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+3017197, 1.0, int_stack+1810671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6108484,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4234753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+948816,int_stack+948060, 1.0, int_stack+1642084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+949824,int_stack+948816, 1.0, int_stack+1642840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 1.0, int_stack+4789555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+951120,int_stack+949824, 1.0, int_stack+1643848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6120832,int_stack+86778,int_stack+83754, 1.0, int_stack+4791823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6126880,int_stack+6120832,int_stack+3017197, 1.0, int_stack+4794847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+952740,int_stack+951120, 1.0, int_stack+1645144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4789555,int_stack+3017197,int_stack+86778, 1.0, int_stack+4799383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6134440,int_stack+4789555,int_stack+6120832, 1.0, int_stack+4803271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4797331,int_stack+6134440,int_stack+6126880, 1.0, int_stack+1819491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6120832,int_stack+954720,int_stack+952740, 1.0, int_stack+1646764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6144520,int_stack+6120832,int_stack+3017197, 1.0, int_stack+1867070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6120832,int_stack+6144520,int_stack+4789555, 1.0, int_stack+10584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6508030,int_stack+6120832,int_stack+6134440, 1.0, int_stack+4851526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6120832,int_stack+6508030,int_stack+4797331, 1.0, int_stack+4861606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+6120832,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4373395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+4558768,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4385743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+960246,int_stack+958041, 1.0, int_stack+957096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+963126,int_stack+960246, 1.0, int_stack+958986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 1.0, int_stack+1741229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+966771,int_stack+963126, 1.0, int_stack+961506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 1.0, int_stack+1744064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6108484,int_stack+509706,int_stack+5760706, 1.0, int_stack+4981432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1741229,int_stack+971271,int_stack+966771, 1.0, int_stack+964746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6545074,int_stack+1741229,int_stack+504846, 1.0, int_stack+1725416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4851526,int_stack+6545074,int_stack+509706, 1.0, int_stack+4987102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+498231,int_stack+4851526,int_stack+6108484, 1.0, int_stack+4994662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+973746,int_stack+971271, 1.0, int_stack+968796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4981432,int_stack+6108484,int_stack+1741229, 1.0, int_stack+5004112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4993582,int_stack+4981432,int_stack+6545074, 1.0, int_stack+5010187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6136708,int_stack+4993582,int_stack+4851526, 1.0, int_stack+5019907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4851526,int_stack+6136708,int_stack+498231, 1.0, int_stack+5032507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+4851526,int_stack+6120832, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4450282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1791680,int_stack+7500280,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4466158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+977157,int_stack+976716,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+977745,int_stack+977157,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+978501,int_stack+977745,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+979446,int_stack+978501,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+980601,int_stack+979446,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+6534385,int_stack+6528505,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+6510865,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+982575,int_stack+981987,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+983359,int_stack+982575,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+984367,int_stack+983359,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6508030,int_stack+5760706,int_stack+3018961,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6512734,int_stack+6508030,int_stack+3021313,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+985627,int_stack+984367,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6518614,int_stack+3017197,int_stack+5760706,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6524662,int_stack+6518614,int_stack+6508030,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+6524662,int_stack+6512734,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+987167,int_stack+985627,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+3017197,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+6518614,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+6524662,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+3923737,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6508030,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2300854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+989771,int_stack+989015,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+990779,int_stack+989771,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+992075,int_stack+990779,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6520378,int_stack+86778,int_stack+83754,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6526426,int_stack+6520378,int_stack+3923737,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+993695,int_stack+992075,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6533986,int_stack+3923737,int_stack+86778,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6541762,int_stack+6533986,int_stack+6520378,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+7500280,int_stack+6541762,int_stack+6526426,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6520378,int_stack+995675,int_stack+993695,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+3923737,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+6533986,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+6541762,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+7500280,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+7500280,int_stack+6520378,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4811395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+4981432,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4823743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+998996,int_stack+998051,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1000256,int_stack+998996,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1001876,int_stack+1000256,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+509706,int_stack+5760706,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1003901,int_stack+1001876,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+7537324,int_stack+498231,int_stack+504846,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6536254,int_stack+7537324,int_stack+509706,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6536254,int_stack+6508030,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1006376,int_stack+1003901,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+4851526,int_stack+6508030,int_stack+498231,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+4851526,int_stack+7537324,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+4851526,int_stack+6108484,int_stack+6536254,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+4851526,int_stack+504306,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+4244014,int_stack+6108484,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4872946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+896454,int_stack+4244014,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4888822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7500280,int_stack+1009787,int_stack+1009346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671451,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7501603,int_stack+1010375,int_stack+1009787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671892,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7503367,int_stack+7501603,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5046682,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7506013,int_stack+1011131,int_stack+1010375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672480,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7508281,int_stack+7506013,int_stack+7501603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5048005,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7511809,int_stack+7508281,int_stack+7503367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5049769,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7500280,int_stack+1012076,int_stack+1011131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1673236,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7516219,int_stack+7500280,int_stack+7506013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5052415,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7520755,int_stack+7516219,int_stack+7508281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5054683,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7503115,int_stack+7520755,int_stack+7511809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5058211,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7509730,int_stack+1013231,int_stack+1012076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674181,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+7509730,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5062621,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7526635,int_stack+5760706,int_stack+7516219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5065456,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+7526635,int_stack+7520755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5069992,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+7503115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5075872,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+1015205,int_stack+1014617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1681993,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+1015989,int_stack+1015205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1682581,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5082487,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1016997,int_stack+1015989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683365,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7500280,int_stack+5760706,int_stack+3925501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5084251,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7504984,int_stack+7500280,int_stack+3927853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5086603,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1018257,int_stack+1016997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684373,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7510864,int_stack+3923737,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5100568,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7516912,int_stack+7510864,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5103592,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+7516912,int_stack+7504984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5108296,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1019797,int_stack+1018257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1685633,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5114176,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+7510864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5117956,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+7516912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5124004,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5207143,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+7500280,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+1872110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1022401,int_stack+1021645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696049,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1023409,int_stack+1022401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696805,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18360,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1024705,int_stack+1023409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1697813,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7512628,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1918226,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7518676,int_stack+7512628,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5256094,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+1026325,int_stack+1024705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1699109,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7526236,int_stack+3017197,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5260630,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7534012,int_stack+7526236,int_stack+7512628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5264518,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4244014,int_stack+7534012,int_stack+7518676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5270566,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7512628,int_stack+1028305,int_stack+1026325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1700729,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4255354,int_stack+7512628,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5278126,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7512628,int_stack+4255354,int_stack+7526236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5282986,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4255354,int_stack+7512628,int_stack+7534012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5290762,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7512628,int_stack+4255354,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5300842,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+4244014,int_stack+7512628,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+1980967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+970542,int_stack+4244014,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+1993315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1031626,int_stack+1030681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1193831,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1032886,int_stack+1031626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1195721,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5312182,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1034506,int_stack+1032886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198241,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5315017,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7500280,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5318797,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1036531,int_stack+1034506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1201481,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4281058,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5435788,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7528504,int_stack+4281058,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5440648,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+7528504,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5448208,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1039006,int_stack+1036531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1205531,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6108484,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5457658,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6120634,int_stack+6108484,int_stack+4281058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5463733,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6136834,int_stack+6120634,int_stack+7528504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473453,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+6136834,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5486053,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+6108484,int_stack+7512628, 0.0, zero_stack, 1.0, int_stack+2149150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8048002,int_stack+6508030,int_stack+4244014, 0.0, zero_stack, 1.0, int_stack+2165026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4244014,int_stack+1042417,int_stack+1041976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671451, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4245337,int_stack+1043005,int_stack+1042417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671892, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4247101,int_stack+4245337,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5046682, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4249747,int_stack+1043761,int_stack+1043005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672480, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4252015,int_stack+4249747,int_stack+4245337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5048005, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4255543,int_stack+4252015,int_stack+4247101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5049769, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4244014,int_stack+1044706,int_stack+1043761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1673236, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4259953,int_stack+4244014,int_stack+4249747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5052415, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4264489,int_stack+4259953,int_stack+4252015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5054683, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4246849,int_stack+4264489,int_stack+4255543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5058211, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4253464,int_stack+1045861,int_stack+1044706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674181, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+4253464,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5062621, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4270369,int_stack+5760706,int_stack+4259953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5065456, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+4270369,int_stack+4264489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5069992, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+4246849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5075872, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+1047835,int_stack+1047247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1681993, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+1048619,int_stack+1047835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1682581, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5082487, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1049627,int_stack+1048619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683365, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4244014,int_stack+5760706,int_stack+3018961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5084251, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4248718,int_stack+4244014,int_stack+3021313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5086603, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+1050887,int_stack+1049627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684373, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4254598,int_stack+3017197,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5100568, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4260646,int_stack+4254598,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5103592, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+4260646,int_stack+4248718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5108296, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4244014,int_stack+1052427,int_stack+1050887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1685633, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4268486,int_stack+4244014,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5114176, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4244014,int_stack+4268486,int_stack+4254598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5117956, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4268486,int_stack+4244014,int_stack+4260646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5124004, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4268486,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5207143, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+4244014,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+2440591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1055031,int_stack+1054275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696049, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1056039,int_stack+1055031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696805, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18360, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1057335,int_stack+1056039, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1697813, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4256362,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1918226, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4262410,int_stack+4256362,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5256094, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1058955,int_stack+1057335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1699109, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4269970,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5260630, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4277746,int_stack+4269970,int_stack+4256362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5264518, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4287826,int_stack+4277746,int_stack+4262410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5270566, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4256362,int_stack+1060935,int_stack+1058955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1700729, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6508030,int_stack+4256362,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5278126, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256362,int_stack+6508030,int_stack+4269970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5282986, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6508030,int_stack+4256362,int_stack+4277746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5290762, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4256362,int_stack+6508030,int_stack+4287826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5300842, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+4256362,int_stack+4244014, 0.0, zero_stack, 1.0, int_stack+2577007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2090029,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+2589355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1064256,int_stack+1063311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1193831, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1065516,int_stack+1064256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1195721, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5312182, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1067136,int_stack+1065516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198241, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5315017, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4244014,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5318797, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1069161,int_stack+1067136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1201481, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6545074,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5435788, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4272238,int_stack+6545074,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5440648, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+4272238,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5448208, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4244014,int_stack+1071636,int_stack+1069161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1205531, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4284838,int_stack+4244014,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5457658, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+4284838,int_stack+6545074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5463733, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6124684,int_stack+6108484,int_stack+4272238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473453, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4272238,int_stack+6124684,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5486053, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+4272238,int_stack+4256362, 0.0, zero_stack, 1.0, int_stack+2683810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8122090,int_stack+6108484,int_stack+6508030, 0.0, zero_stack, 1.0, int_stack+2699686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+1075047,int_stack+1074606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671451, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+1075635,int_stack+1075047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671892, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5046682, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+1076391,int_stack+1075635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672480, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5048005, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5049769, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+1077336,int_stack+1076391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1673236, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5052415, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5054683, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5058211, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+1078491,int_stack+1077336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674181, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5062621, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5065456, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+6534385,int_stack+6528505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5069992, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+6510865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5075872, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+1080465,int_stack+1079877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1681993, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+1081249,int_stack+1080465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1682581, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5082487, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1082257,int_stack+1081249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683365, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6508030,int_stack+5760706,int_stack+3925501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5084251, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6512734,int_stack+6508030,int_stack+3927853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5086603, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1083517,int_stack+1082257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684373, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6518614,int_stack+3923737,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5100568, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6524662,int_stack+6518614,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5103592, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+6524662,int_stack+6512734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5108296, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1085057,int_stack+1083517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1685633, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5114176, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+6518614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5117956, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+6524662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5124004, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6508030,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+2898526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1087661,int_stack+1086905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696049, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1088669,int_stack+1087661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696805, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18360, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1089965,int_stack+1088669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1697813, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6520378,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1918226, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6526426,int_stack+6520378,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5256094, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+1091585,int_stack+1089965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1699109, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6533986,int_stack+3017197,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5260630, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6541762,int_stack+6533986,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5264518, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6541762,int_stack+6526426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5270566, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6520378,int_stack+1093565,int_stack+1091585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1700729, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6119824,int_stack+6520378,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5278126, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6520378,int_stack+6119824,int_stack+6533986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5282986, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6119824,int_stack+6520378,int_stack+6541762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5290762, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6520378,int_stack+6119824,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5300842, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+6520378,int_stack+6508030, 0.0, zero_stack, 1.0, int_stack+3026017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1026108,int_stack+6108484,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+3038365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1096886,int_stack+1095941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1193831, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1098146,int_stack+1096886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1195721, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5312182, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1099766,int_stack+1098146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198241, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5315017, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5318797, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1101791,int_stack+1099766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1201481, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6145528,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5435788, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6536254,int_stack+6145528,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5440648, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6536254,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5448208, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1104266,int_stack+1101791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1205531, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5457658, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+6145528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5463733, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+6536254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473453, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5486053, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+4244014,int_stack+6520378, 0.0, zero_stack, 1.0, int_stack+3133468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8196178,int_stack+7500280,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3149344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+1107677,int_stack+1107236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+1108265,int_stack+1107677, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1671892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5046682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+1109021,int_stack+1108265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5048005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5049769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+1109966,int_stack+1109021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1673236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5052415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5054683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5058211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+1111121,int_stack+1109966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1674181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5062621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5065456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5069992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5075872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+1113095,int_stack+1112507, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1681993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+1113879,int_stack+1113095, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1682581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5082487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1114887,int_stack+1113879, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1683365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6108484,int_stack+5760706,int_stack+3018961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5084251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6113188,int_stack+6108484,int_stack+3021313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5086603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+1116147,int_stack+1114887, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1684373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6119068,int_stack+3017197,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5100568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6125116,int_stack+6119068,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5103592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+6125116,int_stack+6113188, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5108296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1117687,int_stack+1116147, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1685633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+3017197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5114176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+6119068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5117956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+6125116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5124004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6108484,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+3348184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1120291,int_stack+1119535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1121299,int_stack+1120291, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1696805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1122595,int_stack+1121299, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1697813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6120832,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1918226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6126880,int_stack+6120832,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5256094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1124215,int_stack+1122595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1699109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6134440,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5260630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6142216,int_stack+6134440,int_stack+6120832, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5264518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7500280,int_stack+6142216,int_stack+6126880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5270566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6120832,int_stack+1126195,int_stack+1124215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1700729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7511620,int_stack+6120832,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5278126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6120832,int_stack+7511620,int_stack+6134440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5282986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7511620,int_stack+6120832,int_stack+6142216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5290762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6120832,int_stack+7511620,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5300842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+7500280,int_stack+6120832,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+3487435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1921250,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+3499783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1129516,int_stack+1128571, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1193831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1130776,int_stack+1129516, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1195721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5312182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1132396,int_stack+1130776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5315017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6108484,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5318797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1134421,int_stack+1132396, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1201481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7537324,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5435788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6136708,int_stack+7537324,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5440648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6136708,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5448208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1136896,int_stack+1134421, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1205531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+6108484,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5457658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+7537324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5463733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+6136708, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5486053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+4244014,int_stack+6120832, 0.0, zero_stack, 1.0, int_stack+3590350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8270266,int_stack+6508030,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+3606226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7500280,int_stack+1140307,int_stack+1139866, 0.0, zero_stack, 1.0, int_stack+1671451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7501603,int_stack+1140895,int_stack+1140307, 0.0, zero_stack, 1.0, int_stack+1671892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7503367,int_stack+7501603,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5046682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7506013,int_stack+1141651,int_stack+1140895, 0.0, zero_stack, 1.0, int_stack+1672480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7508281,int_stack+7506013,int_stack+7501603, 0.0, zero_stack, 1.0, int_stack+5048005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7511809,int_stack+7508281,int_stack+7503367, 0.0, zero_stack, 1.0, int_stack+5049769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7500280,int_stack+1142596,int_stack+1141651, 0.0, zero_stack, 1.0, int_stack+1673236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7516219,int_stack+7500280,int_stack+7506013, 0.0, zero_stack, 1.0, int_stack+5052415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7520755,int_stack+7516219,int_stack+7508281, 0.0, zero_stack, 1.0, int_stack+5054683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7503115,int_stack+7520755,int_stack+7511809, 0.0, zero_stack, 1.0, int_stack+5058211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7509730,int_stack+1143751,int_stack+1142596, 0.0, zero_stack, 1.0, int_stack+1674181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+7509730,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5062621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7526635,int_stack+5760706,int_stack+7516219, 0.0, zero_stack, 1.0, int_stack+5065456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+7526635,int_stack+7520755, 0.0, zero_stack, 1.0, int_stack+5069992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+7503115, 0.0, zero_stack, 1.0, int_stack+5075872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+1145725,int_stack+1145137, 0.0, zero_stack, 1.0, int_stack+1681993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+1146509,int_stack+1145725, 0.0, zero_stack, 1.0, int_stack+1682581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+5082487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1147517,int_stack+1146509, 0.0, zero_stack, 1.0, int_stack+1683365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7500280,int_stack+5760706,int_stack+3925501, 0.0, zero_stack, 1.0, int_stack+5084251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7504984,int_stack+7500280,int_stack+3927853, 0.0, zero_stack, 1.0, int_stack+5086603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1148777,int_stack+1147517, 0.0, zero_stack, 1.0, int_stack+1684373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7510864,int_stack+3923737,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+5100568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7516912,int_stack+7510864,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5103592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3017197,int_stack+7516912,int_stack+7504984, 0.0, zero_stack, 1.0, int_stack+5108296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1150317,int_stack+1148777, 0.0, zero_stack, 1.0, int_stack+1685633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+5114176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+7510864, 0.0, zero_stack, 1.0, int_stack+5117956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+7516912, 0.0, zero_stack, 1.0, int_stack+5124004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+3017197, 0.0, zero_stack, 1.0, int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+7500280,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+3805066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1152921,int_stack+1152165, 0.0, zero_stack, 1.0, int_stack+1696049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1153929,int_stack+1152921, 0.0, zero_stack, 1.0, int_stack+1696805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3017197,int_stack+83754,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+18360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1155225,int_stack+1153929, 0.0, zero_stack, 1.0, int_stack+1697813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7512628,int_stack+86778,int_stack+83754, 0.0, zero_stack, 1.0, int_stack+1918226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7518676,int_stack+7512628,int_stack+3017197, 0.0, zero_stack, 1.0, int_stack+5256094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+1156845,int_stack+1155225, 0.0, zero_stack, 1.0, int_stack+1699109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7526236,int_stack+3017197,int_stack+86778, 0.0, zero_stack, 1.0, int_stack+5260630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7534012,int_stack+7526236,int_stack+7512628, 0.0, zero_stack, 1.0, int_stack+5264518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6508030,int_stack+7534012,int_stack+7518676, 0.0, zero_stack, 1.0, int_stack+5270566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7512628,int_stack+1158825,int_stack+1156845, 0.0, zero_stack, 1.0, int_stack+1700729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6519370,int_stack+7512628,int_stack+3017197, 0.0, zero_stack, 1.0, int_stack+5278126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7512628,int_stack+6519370,int_stack+7526236, 0.0, zero_stack, 1.0, int_stack+5282986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6519370,int_stack+7512628,int_stack+7534012, 0.0, zero_stack, 1.0, int_stack+5290762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7512628,int_stack+6519370,int_stack+6508030, 0.0, zero_stack, 1.0, int_stack+5300842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+7512628,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+3932557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1081674,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+3944905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1162146,int_stack+1161201, 0.0, zero_stack, 1.0, int_stack+1193831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1163406,int_stack+1162146, 0.0, zero_stack, 1.0, int_stack+1195721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+5312182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1165026,int_stack+1163406, 0.0, zero_stack, 1.0, int_stack+1198241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 1.0, int_stack+5315017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7500280,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+5318797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1167051,int_stack+1165026, 0.0, zero_stack, 1.0, int_stack+1201481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6545074,int_stack+498231,int_stack+504846, 0.0, zero_stack, 1.0, int_stack+5435788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7528504,int_stack+6545074,int_stack+509706, 0.0, zero_stack, 1.0, int_stack+5440648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+7528504,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5448208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1169526,int_stack+1167051, 0.0, zero_stack, 1.0, int_stack+1205531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+5457658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+6545074, 0.0, zero_stack, 1.0, int_stack+5463733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+7528504, 0.0, zero_stack, 1.0, int_stack+5473453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 1.0, int_stack+5486053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+4244014,int_stack+7512628, 0.0, zero_stack, 1.0, int_stack+4040008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8344354,int_stack+6108484,int_stack+6508030, 0.0, zero_stack, 1.0, int_stack+4055884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+1172937,int_stack+1172496, 1.0, int_stack+1671451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+1173525,int_stack+1172937, 1.0, int_stack+1671892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030, 1.0, int_stack+5046682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+1174281,int_stack+1173525, 1.0, int_stack+1672480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353, 1.0, int_stack+5048005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117, 1.0, int_stack+5049769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+1175226,int_stack+1174281, 1.0, int_stack+1673236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763, 1.0, int_stack+5052415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031, 1.0, int_stack+5054683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559, 1.0, int_stack+5058211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+1176381,int_stack+1175226, 1.0, int_stack+1674181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030, 1.0, int_stack+5062621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969, 1.0, int_stack+5065456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3017197,int_stack+6534385,int_stack+6528505, 1.0, int_stack+5069992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3017197,int_stack+6510865, 1.0, int_stack+5075872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3017197,int_stack+1178355,int_stack+1177767, 1.0, int_stack+1681993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3018961,int_stack+1179139,int_stack+1178355, 1.0, int_stack+1682581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3021313,int_stack+3018961,int_stack+3017197, 1.0, int_stack+5082487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1180147,int_stack+1179139, 1.0, int_stack+1683365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6508030,int_stack+5760706,int_stack+3018961, 1.0, int_stack+5084251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6512734,int_stack+6508030,int_stack+3021313, 1.0, int_stack+5086603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3017197,int_stack+1181407,int_stack+1180147, 1.0, int_stack+1684373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6518614,int_stack+3017197,int_stack+5760706, 1.0, int_stack+5100568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6524662,int_stack+6518614,int_stack+6508030, 1.0, int_stack+5103592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+6524662,int_stack+6512734, 1.0, int_stack+5108296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1182947,int_stack+1181407, 1.0, int_stack+1685633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5100568,int_stack+6508030,int_stack+3017197, 1.0, int_stack+5114176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+5100568,int_stack+6518614, 1.0, int_stack+5117956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5100568,int_stack+6508030,int_stack+6524662, 1.0, int_stack+5124004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+5100568,int_stack+3923737, 1.0, int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6508030,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+4234753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1185551,int_stack+1184795, 1.0, int_stack+1696049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1186559,int_stack+1185551, 1.0, int_stack+1696805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5207143,int_stack+83754,int_stack+81486, 1.0, int_stack+18360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1187855,int_stack+1186559, 1.0, int_stack+1697813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3923737,int_stack+86778,int_stack+83754, 1.0, int_stack+1918226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5100568,int_stack+3923737,int_stack+5207143, 1.0, int_stack+5256094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1189475,int_stack+1187855, 1.0, int_stack+1699109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5108128,int_stack+5207143,int_stack+86778, 1.0, int_stack+5260630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5115904,int_stack+5108128,int_stack+3923737, 1.0, int_stack+5264518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5256094,int_stack+5115904,int_stack+5100568, 1.0, int_stack+5270566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5100568,int_stack+1191455,int_stack+1189475, 1.0, int_stack+1700729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5267434,int_stack+5100568,int_stack+5207143, 1.0, int_stack+5278126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6520378,int_stack+5267434,int_stack+5108128, 1.0, int_stack+5282986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5267434,int_stack+6520378,int_stack+5115904, 1.0, int_stack+5290762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6520378,int_stack+5267434,int_stack+5256094, 1.0, int_stack+5300842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+5256094,int_stack+6520378,int_stack+6508030, 0.0, zero_stack, 1.0, int_stack+4373395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1137240,int_stack+5256094,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+4385743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1196981,int_stack+1194776, 1.0, int_stack+1193831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1199861,int_stack+1196981, 1.0, int_stack+1195721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 1.0, int_stack+5312182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1203506,int_stack+1199861, 1.0, int_stack+1198241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 1.0, int_stack+5315017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+509706,int_stack+5760706, 1.0, int_stack+5318797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1208006,int_stack+1203506, 1.0, int_stack+1201481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5293138,int_stack+498231,int_stack+504846, 1.0, int_stack+5435788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5302858,int_stack+5293138,int_stack+509706, 1.0, int_stack+5440648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+5302858,int_stack+6508030, 1.0, int_stack+5448208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1210481,int_stack+1208006, 1.0, int_stack+1205531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5435788,int_stack+6508030,int_stack+498231, 1.0, int_stack+5457658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6536254,int_stack+5435788,int_stack+5293138, 1.0, int_stack+5463733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5435788,int_stack+6536254,int_stack+5302858, 1.0, int_stack+5473453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+5293138,int_stack+5435788,int_stack+504306, 1.0, int_stack+5486053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+5293138,int_stack+6520378, 0.0, zero_stack, 1.0, int_stack+4450282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8418442,int_stack+6108484,int_stack+5256094, 0.0, zero_stack, 1.0, int_stack+4466158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5256094,int_stack+1213892,int_stack+1213451,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5257417,int_stack+1214480,int_stack+1213892,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5259181,int_stack+5257417,int_stack+5256094,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5261827,int_stack+1215236,int_stack+1214480,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5264095,int_stack+5261827,int_stack+5257417,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5267623,int_stack+5264095,int_stack+5259181,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5256094,int_stack+1216181,int_stack+1215236,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5272033,int_stack+5256094,int_stack+5261827,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5276569,int_stack+5272033,int_stack+5264095,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5258929,int_stack+5276569,int_stack+5267623,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5265544,int_stack+1217336,int_stack+1216181,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+5265544,int_stack+5256094,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5282449,int_stack+5760706,int_stack+5272033,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5207143,int_stack+5282449,int_stack+5276569,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5207143,int_stack+5258929,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5207143,int_stack+1219310,int_stack+1218722,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5208907,int_stack+1220094,int_stack+1219310,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5211259,int_stack+5208907,int_stack+5207143,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1221102,int_stack+1220094,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5256094,int_stack+5760706,int_stack+5208907,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5260798,int_stack+5256094,int_stack+5211259,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1222362,int_stack+1221102,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5266678,int_stack+5207143,int_stack+5760706,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5272726,int_stack+5266678,int_stack+5256094,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+5272726,int_stack+5260798,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5256094,int_stack+1223902,int_stack+1222362,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5280566,int_stack+5256094,int_stack+5207143,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5256094,int_stack+5280566,int_stack+5266678,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5280566,int_stack+5256094,int_stack+5272726,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5256094,int_stack+5280566,int_stack+3923737,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+5256094,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+2300854, 1.0, int_stack+5091307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1226506,int_stack+1225750,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1227514,int_stack+1226506,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1228810,int_stack+1227514,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5268442,int_stack+86778,int_stack+83754,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5274490,int_stack+5268442,int_stack+3923737,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1230430,int_stack+1228810,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5282050,int_stack+3923737,int_stack+86778,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5289826,int_stack+5282050,int_stack+5268442,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5299906,int_stack+5289826,int_stack+5274490,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5268442,int_stack+1232410,int_stack+1230430,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5311246,int_stack+5268442,int_stack+3923737,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5268442,int_stack+5311246,int_stack+5282050,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+5268442,int_stack+5289826,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5268442,int_stack+6108484,int_stack+5299906,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+5268442,int_stack+5256094, 0.0, zero_stack, 1.0, int_stack+4811395, 1.0, int_stack+5215963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+5435788,int_stack+6108484,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+4823743, 1.0, int_stack+5228311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1235731,int_stack+1234786,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1236991,int_stack+1235731,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1238611,int_stack+1236991,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5256094,int_stack+509706,int_stack+5760706,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1240636,int_stack+1238611,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6145528,int_stack+498231,int_stack+504846,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5284318,int_stack+6145528,int_stack+509706,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+5284318,int_stack+5256094,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5256094,int_stack+1243111,int_stack+1240636,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5296918,int_stack+5256094,int_stack+498231,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+5296918,int_stack+6145528,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5296918,int_stack+6508030,int_stack+5284318,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+5296918,int_stack+504306,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+6508030,int_stack+5268442, 0.0, zero_stack, 1.0, int_stack+4872946, 1.0, int_stack+5327302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8492530,int_stack+7500280,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+4888822, 1.0, int_stack+5343178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+1246522,int_stack+1246081,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+1247110,int_stack+1246522,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+1247866,int_stack+1247110,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+1248811,int_stack+1247866,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+1249966,int_stack+1248811,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+6134839,int_stack+6128959,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+6111319,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+1251940,int_stack+1251352,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+1252724,int_stack+1251940,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1253732,int_stack+1252724,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6108484,int_stack+5760706,int_stack+3925501,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6113188,int_stack+6108484,int_stack+3927853,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1254992,int_stack+1253732,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6119068,int_stack+3923737,int_stack+5760706,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6125116,int_stack+6119068,int_stack+6108484,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5207143,int_stack+6125116,int_stack+6113188,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1256532,int_stack+1254992,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+3923737,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+6119068,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+6125116,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+5207143,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6108484,int_stack+81486, 0.0, zero_stack, 2.0, int_stack+5091307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1259136,int_stack+1258380,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1260144,int_stack+1259136,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5207143,int_stack+83754,int_stack+81486,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1261440,int_stack+1260144,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6120832,int_stack+86778,int_stack+83754,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6126880,int_stack+6120832,int_stack+5207143,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1263060,int_stack+1261440,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6134440,int_stack+5207143,int_stack+86778,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6142216,int_stack+6134440,int_stack+6120832,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+7500280,int_stack+6142216,int_stack+6126880,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6120832,int_stack+1265040,int_stack+1263060,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+7511620,int_stack+6120832,int_stack+5207143,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6120832,int_stack+7511620,int_stack+6134440,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+7511620,int_stack+6120832,int_stack+6142216,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6120832,int_stack+7511620,int_stack+7500280,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+7500280,int_stack+6120832,int_stack+6108484, 0.0, zero_stack, 2.0, int_stack+5215963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+5256094,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 2.0, int_stack+5228311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1268361,int_stack+1267416,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1269621,int_stack+1268361,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1271241,int_stack+1269621,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6108484,int_stack+509706,int_stack+5760706,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1273266,int_stack+1271241,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+7537324,int_stack+498231,int_stack+504846,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6136708,int_stack+7537324,int_stack+509706,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6136708,int_stack+6108484,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1275741,int_stack+1273266,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6508030,int_stack+6108484,int_stack+498231,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6520180,int_stack+6508030,int_stack+7537324,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6536380,int_stack+6520180,int_stack+6136708,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6536380,int_stack+504306,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+4244014,int_stack+6508030,int_stack+6120832, 0.0, zero_stack, 2.0, int_stack+5327302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1192806,int_stack+4244014,int_stack+7500280, 0.0, zero_stack, 2.0, int_stack+5343178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7500280,int_stack+1284423,int_stack+1283982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730687,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7501603,int_stack+1285011,int_stack+1284423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731128,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7503367,int_stack+7501603,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5500228,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7506013,int_stack+1285767,int_stack+1285011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731716,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7508281,int_stack+7506013,int_stack+7501603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5501551,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7511809,int_stack+7508281,int_stack+7503367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5503315,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7500280,int_stack+1286712,int_stack+1285767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732472,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7516219,int_stack+7500280,int_stack+7506013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5505961,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7520755,int_stack+7516219,int_stack+7508281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5508229,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7503115,int_stack+7520755,int_stack+7511809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5511757,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7509730,int_stack+1287867,int_stack+1286712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733417,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+7509730,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5324467,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7526635,int_stack+5760706,int_stack+7516219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5516167,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5207143,int_stack+7526635,int_stack+7520755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5520703,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5207143,int_stack+7503115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5526583,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5207143,int_stack+1296869,int_stack+1296281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748257,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5208907,int_stack+1297653,int_stack+1296869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748845,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5211259,int_stack+5208907,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5533198,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1298661,int_stack+1297653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1749629,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7500280,int_stack+5760706,int_stack+5208907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5534962,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7504984,int_stack+7500280,int_stack+5211259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5537314,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1299921,int_stack+1298661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1750637,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7510864,int_stack+5207143,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5551279,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7516912,int_stack+7510864,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5554303,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+7516912,int_stack+7504984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5559007,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1301461,int_stack+1299921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1751897,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5564887,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+7510864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5568667,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+7516912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574715,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5660689,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+7500280,int_stack+81486, 1.0, int_stack+1872110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1313101,int_stack+1312345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1762313,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1314109,int_stack+1313101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763069,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20628,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1315405,int_stack+1314109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764077,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7512628,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22896,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7518676,int_stack+7512628,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4618153,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1317025,int_stack+1315405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1765373,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7526236,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5582555,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7534012,int_stack+7526236,int_stack+7512628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4622689,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4244014,int_stack+7534012,int_stack+7518676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5709640,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7512628,int_stack+1319005,int_stack+1317025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1766993,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4255354,int_stack+7512628,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5717200,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7512628,int_stack+4255354,int_stack+7526236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5722060,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4255354,int_stack+7512628,int_stack+7534012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5729836,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7512628,int_stack+4255354,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5739916,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+4244014,int_stack+7512628,int_stack+7500280, 1.0, int_stack+1980967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+8566618,int_stack+4244014,int_stack+498231, 1.0, int_stack+1993315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1322326,int_stack+1321381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597866,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1323586,int_stack+1322326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599756,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1325206,int_stack+1323586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1602276,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260471,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7500280,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2264251,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1327231,int_stack+1325206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1605516,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4281058,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269921,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7528504,int_stack+4281058,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274781,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+7528504,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5751256,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1329706,int_stack+1327231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1609566,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6508030,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4628737,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6520180,int_stack+6508030,int_stack+4281058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5874862,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6536380,int_stack+6520180,int_stack+7528504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5884582,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6536380,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5897182,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+6508030,int_stack+7512628, 1.0, int_stack+2149150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+8622184,int_stack+6108484,int_stack+4244014, 1.0, int_stack+2165026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4244014,int_stack+1338388,int_stack+1337947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730687, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4245337,int_stack+1338976,int_stack+1338388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731128, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4247101,int_stack+4245337,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5500228, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4249747,int_stack+1339732,int_stack+1338976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731716, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4252015,int_stack+4249747,int_stack+4245337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5501551, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4255543,int_stack+4252015,int_stack+4247101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5503315, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4244014,int_stack+1340677,int_stack+1339732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732472, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4259953,int_stack+4244014,int_stack+4249747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5505961, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4264489,int_stack+4259953,int_stack+4252015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5508229, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4246849,int_stack+4264489,int_stack+4255543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5511757, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4253464,int_stack+1341832,int_stack+1340677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733417, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+4253464,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5324467, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4270369,int_stack+5760706,int_stack+4259953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5516167, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+4270369,int_stack+4264489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5520703, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+4246849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5526583, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+1350834,int_stack+1350246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748257, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+1351618,int_stack+1350834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748845, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5533198, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1352626,int_stack+1351618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1749629, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4244014,int_stack+5760706,int_stack+3925501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5534962, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4248718,int_stack+4244014,int_stack+3927853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5537314, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1353886,int_stack+1352626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1750637, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4254598,int_stack+3923737,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5551279, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4260646,int_stack+4254598,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5554303, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5207143,int_stack+4260646,int_stack+4248718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5559007, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4244014,int_stack+1355426,int_stack+1353886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1751897, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4268486,int_stack+4244014,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5564887, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4244014,int_stack+4268486,int_stack+4254598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5568667, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4268486,int_stack+4244014,int_stack+4260646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574715, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4268486,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5660689, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+4244014,int_stack+81486, 1.0, int_stack+2440591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1367066,int_stack+1366310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1762313, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1368074,int_stack+1367066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763069, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5207143,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20628, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1369370,int_stack+1368074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764077, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4256362,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22896, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4262410,int_stack+4256362,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4618153, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1370990,int_stack+1369370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1765373, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4269970,int_stack+5207143,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5582555, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4277746,int_stack+4269970,int_stack+4256362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4622689, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4287826,int_stack+4277746,int_stack+4262410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5709640, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4256362,int_stack+1372970,int_stack+1370990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1766993, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6108484,int_stack+4256362,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5717200, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256362,int_stack+6108484,int_stack+4269970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5722060, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+4256362,int_stack+4277746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5729836, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4256362,int_stack+6108484,int_stack+4287826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5739916, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+4256362,int_stack+4244014, 1.0, int_stack+2577007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1266894,int_stack+6108484,int_stack+498231, 1.0, int_stack+2589355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1376291,int_stack+1375346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597866, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1377551,int_stack+1376291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599756, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1379171,int_stack+1377551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1602276, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260471, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4244014,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2264251, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1381196,int_stack+1379171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1605516, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6145528,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269921, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4272238,int_stack+6145528,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274781, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+4272238,int_stack+4244014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5751256, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4244014,int_stack+1383671,int_stack+1381196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1609566, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4284838,int_stack+4244014,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4628737, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+4284838,int_stack+6145528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5874862, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6524230,int_stack+6508030,int_stack+4272238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5884582, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4272238,int_stack+6524230,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5897182, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+4272238,int_stack+4256362, 1.0, int_stack+2683810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+2395711,int_stack+6508030,int_stack+6108484, 1.0, int_stack+2699686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+1392353,int_stack+1391912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730687, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+1392941,int_stack+1392353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731128, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5500228, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+1393697,int_stack+1392941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731716, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5501551, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5503315, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+1394642,int_stack+1393697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732472, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5505961, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5508229, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5511757, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+1395797,int_stack+1394642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733417, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5324467, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5516167, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5207143,int_stack+6134839,int_stack+6128959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5520703, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5207143,int_stack+6111319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5526583, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5207143,int_stack+1404799,int_stack+1404211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748257, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5208907,int_stack+1405583,int_stack+1404799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748845, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5211259,int_stack+5208907,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5533198, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1406591,int_stack+1405583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1749629, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6108484,int_stack+5760706,int_stack+5208907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5534962, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6113188,int_stack+6108484,int_stack+5211259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5537314, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1407851,int_stack+1406591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1750637, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6119068,int_stack+5207143,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5551279, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6125116,int_stack+6119068,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5554303, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+6125116,int_stack+6113188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5559007, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1409391,int_stack+1407851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1751897, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5564887, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+6119068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5568667, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6132956,int_stack+6108484,int_stack+6125116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574715, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+6132956,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5660689, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6108484,int_stack+81486, 1.0, int_stack+2898526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1421031,int_stack+1420275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1762313, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1422039,int_stack+1421031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763069, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20628, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1423335,int_stack+1422039, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764077, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6120832,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22896, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6126880,int_stack+6120832,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4618153, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1424955,int_stack+1423335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1765373, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6134440,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5582555, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6142216,int_stack+6134440,int_stack+6120832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4622689, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6508030,int_stack+6142216,int_stack+6126880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5709640, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6120832,int_stack+1426935,int_stack+1424955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1766993, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6519370,int_stack+6120832,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5717200, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6120832,int_stack+6519370,int_stack+6134440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5722060, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6519370,int_stack+6120832,int_stack+6142216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5729836, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6120832,int_stack+6519370,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5739916, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+6120832,int_stack+6108484, 1.0, int_stack+3026017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2672704,int_stack+6508030,int_stack+498231, 1.0, int_stack+3038365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1430256,int_stack+1429311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597866, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1431516,int_stack+1430256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599756, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1433136,int_stack+1431516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1602276, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260471, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6108484,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2264251, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1435161,int_stack+1433136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1605516, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6545074,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269921, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6136708,int_stack+6545074,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274781, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6136708,int_stack+6108484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5751256, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1437636,int_stack+1435161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1609566, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+6108484,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4628737, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+6545074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5874862, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+6136708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5884582, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5897182, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+4244014,int_stack+6120832, 1.0, int_stack+3133468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1322460,int_stack+7500280,int_stack+6508030, 1.0, int_stack+3149344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+1446318,int_stack+1445877, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+1446906,int_stack+1446318, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5500228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+1447662,int_stack+1446906, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1731716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5501551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5503315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+1448607,int_stack+1447662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5505961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5508229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5511757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+1449762,int_stack+1448607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1733417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6517480,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5324467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6534385,int_stack+5760706,int_stack+6523969, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5516167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3923737,int_stack+6534385,int_stack+6528505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5520703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+3923737,int_stack+6510865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5526583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3923737,int_stack+1458764,int_stack+1458176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3925501,int_stack+1459548,int_stack+1458764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1748845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3927853,int_stack+3925501,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5533198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1460556,int_stack+1459548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1749629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6508030,int_stack+5760706,int_stack+3925501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5534962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6512734,int_stack+6508030,int_stack+3927853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5537314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1461816,int_stack+1460556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1750637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6518614,int_stack+3923737,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5551279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6524662,int_stack+6518614,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5554303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5207143,int_stack+6524662,int_stack+6512734, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5559007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1463356,int_stack+1461816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1751897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+3923737, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5564887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+6518614, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5568667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6532502,int_stack+6508030,int_stack+6524662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5574715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6508030,int_stack+6532502,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5660689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6508030,int_stack+81486, 1.0, int_stack+3348184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1474996,int_stack+1474240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1762313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1476004,int_stack+1474996, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5207143,int_stack+83754,int_stack+81486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1477300,int_stack+1476004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6520378,int_stack+86778,int_stack+83754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6526426,int_stack+6520378,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4618153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1478920,int_stack+1477300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1765373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6533986,int_stack+5207143,int_stack+86778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5582555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6541762,int_stack+6533986,int_stack+6520378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4622689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7500280,int_stack+6541762,int_stack+6526426, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5709640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6520378,int_stack+1480900,int_stack+1478920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1766993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+5207143, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5717200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+6533986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5722060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7511620,int_stack+6520378,int_stack+6541762, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5729836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6520378,int_stack+7511620,int_stack+7500280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5739916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+7500280,int_stack+6520378,int_stack+6508030, 1.0, int_stack+3487435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3121714,int_stack+7500280,int_stack+498231, 1.0, int_stack+3499783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1484221,int_stack+1483276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1485481,int_stack+1484221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1487101,int_stack+1485481, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1602276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2260471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2264251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1489126,int_stack+1487101, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1605516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7537324,int_stack+498231,int_stack+504846, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2269921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6536254,int_stack+7537324,int_stack+509706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+6536254,int_stack+6508030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5751256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1491601,int_stack+1489126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1609566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4244014,int_stack+6508030,int_stack+498231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4628737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4256164,int_stack+4244014,int_stack+7537324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5874862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4272364,int_stack+4256164,int_stack+6536254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5884582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+4244014,int_stack+4272364,int_stack+504306, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5897182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+4244014,int_stack+6520378, 1.0, int_stack+3590350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+3316042,int_stack+6108484,int_stack+7500280, 1.0, int_stack+3606226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7500280,int_stack+1500283,int_stack+1499842, 0.0, zero_stack, 1.0, int_stack+1730687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7501603,int_stack+1500871,int_stack+1500283, 0.0, zero_stack, 1.0, int_stack+1731128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7503367,int_stack+7501603,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5500228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7506013,int_stack+1501627,int_stack+1500871, 0.0, zero_stack, 1.0, int_stack+1731716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7508281,int_stack+7506013,int_stack+7501603, 0.0, zero_stack, 1.0, int_stack+5501551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7511809,int_stack+7508281,int_stack+7503367, 0.0, zero_stack, 1.0, int_stack+5503315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7500280,int_stack+1502572,int_stack+1501627, 0.0, zero_stack, 1.0, int_stack+1732472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7516219,int_stack+7500280,int_stack+7506013, 0.0, zero_stack, 1.0, int_stack+5505961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7520755,int_stack+7516219,int_stack+7508281, 0.0, zero_stack, 1.0, int_stack+5508229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7503115,int_stack+7520755,int_stack+7511809, 0.0, zero_stack, 1.0, int_stack+5511757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7509730,int_stack+1503727,int_stack+1502572, 0.0, zero_stack, 1.0, int_stack+1733417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+7509730,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5324467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7526635,int_stack+5760706,int_stack+7516219, 0.0, zero_stack, 1.0, int_stack+5516167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5207143,int_stack+7526635,int_stack+7520755, 0.0, zero_stack, 1.0, int_stack+5520703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5207143,int_stack+7503115, 0.0, zero_stack, 1.0, int_stack+5526583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5207143,int_stack+1512729,int_stack+1512141, 0.0, zero_stack, 1.0, int_stack+1748257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5208907,int_stack+1513513,int_stack+1512729, 0.0, zero_stack, 1.0, int_stack+1748845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5211259,int_stack+5208907,int_stack+5207143, 0.0, zero_stack, 1.0, int_stack+5533198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1514521,int_stack+1513513, 0.0, zero_stack, 1.0, int_stack+1749629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7500280,int_stack+5760706,int_stack+5208907, 0.0, zero_stack, 1.0, int_stack+5534962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7504984,int_stack+7500280,int_stack+5211259, 0.0, zero_stack, 1.0, int_stack+5537314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1515781,int_stack+1514521, 0.0, zero_stack, 1.0, int_stack+1750637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7510864,int_stack+5207143,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+5551279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7516912,int_stack+7510864,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5554303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3923737,int_stack+7516912,int_stack+7504984, 0.0, zero_stack, 1.0, int_stack+5559007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1517321,int_stack+1515781, 0.0, zero_stack, 1.0, int_stack+1751897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+5207143, 0.0, zero_stack, 1.0, int_stack+5564887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+7510864, 0.0, zero_stack, 1.0, int_stack+5568667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7524752,int_stack+7500280,int_stack+7516912, 0.0, zero_stack, 1.0, int_stack+5574715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7500280,int_stack+7524752,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+5660689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+7500280,int_stack+81486, 1.0, int_stack+3805066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1528961,int_stack+1528205, 0.0, zero_stack, 1.0, int_stack+1762313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1529969,int_stack+1528961, 0.0, zero_stack, 1.0, int_stack+1763069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3923737,int_stack+83754,int_stack+81486, 0.0, zero_stack, 1.0, int_stack+20628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1531265,int_stack+1529969, 0.0, zero_stack, 1.0, int_stack+1764077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7512628,int_stack+86778,int_stack+83754, 0.0, zero_stack, 1.0, int_stack+22896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7518676,int_stack+7512628,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+4618153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3923737,int_stack+1532885,int_stack+1531265, 0.0, zero_stack, 1.0, int_stack+1765373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7526236,int_stack+3923737,int_stack+86778, 0.0, zero_stack, 1.0, int_stack+5582555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7534012,int_stack+7526236,int_stack+7512628, 0.0, zero_stack, 1.0, int_stack+4622689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+7534012,int_stack+7518676, 0.0, zero_stack, 1.0, int_stack+5709640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7512628,int_stack+1534865,int_stack+1532885, 0.0, zero_stack, 1.0, int_stack+1766993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6119824,int_stack+7512628,int_stack+3923737, 0.0, zero_stack, 1.0, int_stack+5717200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7512628,int_stack+6119824,int_stack+7526236, 0.0, zero_stack, 1.0, int_stack+5722060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6119824,int_stack+7512628,int_stack+7534012, 0.0, zero_stack, 1.0, int_stack+5729836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7512628,int_stack+6119824,int_stack+6108484, 0.0, zero_stack, 1.0, int_stack+5739916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+7512628,int_stack+7500280, 1.0, int_stack+3932557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3583132,int_stack+6108484,int_stack+498231, 1.0, int_stack+3944905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1538186,int_stack+1537241, 0.0, zero_stack, 1.0, int_stack+1597866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1539446,int_stack+1538186, 0.0, zero_stack, 1.0, int_stack+1599756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1541066,int_stack+1539446, 0.0, zero_stack, 1.0, int_stack+1602276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 0.0, zero_stack, 1.0, int_stack+2260471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7500280,int_stack+509706,int_stack+5760706, 0.0, zero_stack, 1.0, int_stack+2264251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1543091,int_stack+1541066, 0.0, zero_stack, 1.0, int_stack+1605516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6145528,int_stack+498231,int_stack+504846, 0.0, zero_stack, 1.0, int_stack+2269921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7528504,int_stack+6145528,int_stack+509706, 0.0, zero_stack, 1.0, int_stack+2274781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+7528504,int_stack+7500280, 0.0, zero_stack, 1.0, int_stack+5751256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7500280,int_stack+1545566,int_stack+1543091, 0.0, zero_stack, 1.0, int_stack+1609566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3923737,int_stack+7500280,int_stack+498231, 0.0, zero_stack, 1.0, int_stack+4628737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3935887,int_stack+3923737,int_stack+6145528, 0.0, zero_stack, 1.0, int_stack+5874862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3952087,int_stack+3935887,int_stack+7528504, 0.0, zero_stack, 1.0, int_stack+5884582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+3923737,int_stack+3952087,int_stack+504306, 0.0, zero_stack, 1.0, int_stack+5897182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+3923737,int_stack+7512628, 1.0, int_stack+4040008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+3754402,int_stack+6508030,int_stack+6108484, 1.0, int_stack+4055884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+1554248,int_stack+1553807, 1.0, int_stack+1730687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+1554836,int_stack+1554248, 1.0, int_stack+1731128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484, 1.0, int_stack+5500228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+1555592,int_stack+1554836, 1.0, int_stack+1731716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807, 1.0, int_stack+5501551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571, 1.0, int_stack+5503315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+1556537,int_stack+1555592, 1.0, int_stack+1732472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217, 1.0, int_stack+5505961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485, 1.0, int_stack+5508229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013, 1.0, int_stack+5511757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+1557692,int_stack+1556537, 1.0, int_stack+1733417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5760706,int_stack+6117934,int_stack+6108484, 1.0, int_stack+5324467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6134839,int_stack+5760706,int_stack+6124423, 1.0, int_stack+5516167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5207143,int_stack+6134839,int_stack+6128959, 1.0, int_stack+5520703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5207143,int_stack+6111319, 1.0, int_stack+5526583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5207143,int_stack+1566694,int_stack+1566106, 1.0, int_stack+1748257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5208907,int_stack+1567478,int_stack+1566694, 1.0, int_stack+1748845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5211259,int_stack+5208907,int_stack+5207143, 1.0, int_stack+5533198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5760706,int_stack+1568486,int_stack+1567478, 1.0, int_stack+1749629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6108484,int_stack+5760706,int_stack+5208907, 1.0, int_stack+5534962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6113188,int_stack+6108484,int_stack+5211259, 1.0, int_stack+5537314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1569746,int_stack+1568486, 1.0, int_stack+1750637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6119068,int_stack+5207143,int_stack+5760706, 1.0, int_stack+5551279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6125116,int_stack+6119068,int_stack+6108484, 1.0, int_stack+5554303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6132956,int_stack+6125116,int_stack+6113188, 1.0, int_stack+5559007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1571286,int_stack+1569746, 1.0, int_stack+1751897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5551279,int_stack+6108484,int_stack+5207143, 1.0, int_stack+5564887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6108484,int_stack+5551279,int_stack+6119068, 1.0, int_stack+5568667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5551279,int_stack+6108484,int_stack+6125116, 1.0, int_stack+5574715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6108484,int_stack+5551279,int_stack+6132956, 1.0, int_stack+5660689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6108484,int_stack+81486, 1.0, int_stack+4234753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1589586,int_stack+1588830, 1.0, int_stack+1762313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1590594,int_stack+1589586, 1.0, int_stack+1763069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5660689,int_stack+83754,int_stack+81486, 1.0, int_stack+20628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1591890,int_stack+1590594, 1.0, int_stack+1764077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5551279,int_stack+86778,int_stack+83754, 1.0, int_stack+22896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5557327,int_stack+5551279,int_stack+5660689, 1.0, int_stack+4618153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5660689,int_stack+1593510,int_stack+1591890, 1.0, int_stack+1765373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5564887,int_stack+5660689,int_stack+86778, 1.0, int_stack+5582555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5572663,int_stack+5564887,int_stack+5551279, 1.0, int_stack+4622689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6120832,int_stack+5572663,int_stack+5557327, 1.0, int_stack+5709640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5709640,int_stack+1595490,int_stack+1593510, 1.0, int_stack+1766993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5551279,int_stack+5709640,int_stack+5660689, 1.0, int_stack+5717200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6132172,int_stack+5551279,int_stack+5564887, 1.0, int_stack+5722060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5551279,int_stack+6132172,int_stack+5572663, 1.0, int_stack+5729836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+6132172,int_stack+5551279,int_stack+6120832, 1.0, int_stack+5739916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+5709640,int_stack+6132172,int_stack+6108484, 1.0, int_stack+4373395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+4028254,int_stack+5709640,int_stack+498231, 1.0, int_stack+4385743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1601016,int_stack+1598811, 1.0, int_stack+1597866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1603896,int_stack+1601016, 1.0, int_stack+1599756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5760706,int_stack+501066,int_stack+498231, 1.0, int_stack+2257636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504846,int_stack+1607541,int_stack+1603896, 1.0, int_stack+1602276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+509706,int_stack+504846,int_stack+501066, 1.0, int_stack+2260471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4373395,int_stack+509706,int_stack+5760706, 1.0, int_stack+2264251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2257636,int_stack+1612041,int_stack+1607541, 1.0, int_stack+1605516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4382845,int_stack+2257636,int_stack+504846, 1.0, int_stack+2269921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4392565,int_stack+4382845,int_stack+509706, 1.0, int_stack+2274781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2263711,int_stack+4392565,int_stack+4373395, 1.0, int_stack+5751256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4373395,int_stack+1614516,int_stack+1612041, 1.0, int_stack+1609566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2277886,int_stack+4373395,int_stack+2257636, 1.0, int_stack+4628737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+498231,int_stack+2277886,int_stack+4382845, 1.0, int_stack+5874862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2277886,int_stack+498231,int_stack+4392565, 1.0, int_stack+5884582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+498231,int_stack+2277886,int_stack+2263711, 1.0, int_stack+5897182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+498231,int_stack+6132172, 1.0, int_stack+4450282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+4373395,int_stack+6508030,int_stack+5709640, 1.0, int_stack+4466158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5709640,int_stack+1623198,int_stack+1622757,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5710963,int_stack+1623786,int_stack+1623198,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5712727,int_stack+5710963,int_stack+5709640,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5715373,int_stack+1624542,int_stack+1623786,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5717641,int_stack+5715373,int_stack+5710963,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5721169,int_stack+5717641,int_stack+5712727,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5709640,int_stack+1625487,int_stack+1624542,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5725579,int_stack+5709640,int_stack+5715373,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5730115,int_stack+5725579,int_stack+5717641,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5712475,int_stack+5730115,int_stack+5721169,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5719090,int_stack+1626642,int_stack+1625487,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5735995,int_stack+5719090,int_stack+5709640,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5741665,int_stack+5735995,int_stack+5725579,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5660689,int_stack+5741665,int_stack+5730115,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5660689,int_stack+5712475,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5660689,int_stack+1635644,int_stack+1635056,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5662453,int_stack+1636428,int_stack+1635644,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5664805,int_stack+5662453,int_stack+5660689,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5709640,int_stack+1637436,int_stack+1636428,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5712664,int_stack+5709640,int_stack+5662453,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5717368,int_stack+5712664,int_stack+5664805,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5660689,int_stack+1638696,int_stack+1637436,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5723248,int_stack+5660689,int_stack+5709640,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5729296,int_stack+5723248,int_stack+5712664,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5207143,int_stack+5729296,int_stack+5717368,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5709640,int_stack+1640236,int_stack+1638696,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5714260,int_stack+5709640,int_stack+5660689,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5737136,int_stack+5714260,int_stack+5723248,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5709640,int_stack+5737136,int_stack+5729296,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5721400,int_stack+5709640,int_stack+5207143,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+5721400,int_stack+81486, 1.0, int_stack+2300854, 0.0, zero_stack, 1.0, int_stack+5542018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1651876,int_stack+1651120,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1652884,int_stack+1651876,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5207143,int_stack+83754,int_stack+81486,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1654180,int_stack+1652884,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5709640,int_stack+86778,int_stack+83754,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5660689,int_stack+5709640,int_stack+5207143,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1655800,int_stack+1654180,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5733748,int_stack+5207143,int_stack+86778,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5741524,int_stack+5733748,int_stack+5709640,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5709640,int_stack+5741524,int_stack+5660689,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5660689,int_stack+1657780,int_stack+1655800,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5751604,int_stack+5660689,int_stack+5207143,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6508030,int_stack+5751604,int_stack+5733748,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6520990,int_stack+6508030,int_stack+5741524,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5733748,int_stack+6520990,int_stack+5709640,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6508030,int_stack+5733748,int_stack+5721400, 1.0, int_stack+4811395, 0.0, zero_stack, 1.0, int_stack+5669509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2257636,int_stack+6508030,int_stack+498231, 1.0, int_stack+4823743, 0.0, zero_stack, 1.0, int_stack+5681857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1661101,int_stack+1660156,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1662361,int_stack+1661101,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+504846,int_stack+501066,int_stack+498231,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+510516,int_stack+1663981,int_stack+1662361,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+515376,int_stack+510516,int_stack+501066,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5709640,int_stack+515376,int_stack+504846,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1666006,int_stack+1663981,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+5719090,int_stack+498231,int_stack+510516,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5749624,int_stack+5719090,int_stack+515376,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+5749624,int_stack+5709640,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5709640,int_stack+1668481,int_stack+1666006,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5874862,int_stack+5709640,int_stack+498231,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5887012,int_stack+5874862,int_stack+5719090,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5709640,int_stack+5887012,int_stack+5749624,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5874862,int_stack+5709640,int_stack+504306,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6108484,int_stack+5874862,int_stack+5733748, 1.0, int_stack+4872946, 0.0, zero_stack, 1.0, int_stack+5766376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+4789555,int_stack+6108484,int_stack+6508030, 1.0, int_stack+4888822, 0.0, zero_stack, 1.0, int_stack+5782252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6508030,int_stack+1677163,int_stack+1676722,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6509353,int_stack+1677751,int_stack+1677163,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6511117,int_stack+6509353,int_stack+6508030,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6513763,int_stack+1678507,int_stack+1677751,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6516031,int_stack+6513763,int_stack+6509353,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6519559,int_stack+6516031,int_stack+6511117,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6508030,int_stack+1679452,int_stack+1678507,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6523969,int_stack+6508030,int_stack+6513763,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6528505,int_stack+6523969,int_stack+6516031,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+6510865,int_stack+6528505,int_stack+6519559,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6517480,int_stack+1680607,int_stack+1679452,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6534385,int_stack+6517480,int_stack+6508030,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6540055,int_stack+6534385,int_stack+6523969,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5207143,int_stack+6540055,int_stack+6528505,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5207143,int_stack+6510865,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5207143,int_stack+1689609,int_stack+1689021,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5208907,int_stack+1690393,int_stack+1689609,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5211259,int_stack+5208907,int_stack+5207143,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6508030,int_stack+1691401,int_stack+1690393,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6511054,int_stack+6508030,int_stack+5208907,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6515758,int_stack+6511054,int_stack+5211259,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5207143,int_stack+1692661,int_stack+1691401,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6521638,int_stack+5207143,int_stack+6508030,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6527686,int_stack+6521638,int_stack+6511054,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+5660689,int_stack+6527686,int_stack+6515758,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1694201,int_stack+1692661,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6512650,int_stack+6508030,int_stack+5207143,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6535526,int_stack+6512650,int_stack+6521638,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6508030,int_stack+6535526,int_stack+6527686,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6519790,int_stack+6508030,int_stack+5660689,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6519790,int_stack+81486, 1.0, int_stack+5091307, 1.0, int_stack+5542018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1705841,int_stack+1705085,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1706849,int_stack+1705841,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5660689,int_stack+83754,int_stack+81486,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1708145,int_stack+1706849,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6508030,int_stack+86778,int_stack+83754,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5207143,int_stack+6508030,int_stack+5660689,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5660689,int_stack+1709765,int_stack+1708145,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6532138,int_stack+5660689,int_stack+86778,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6539914,int_stack+6532138,int_stack+6508030,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+6508030,int_stack+6539914,int_stack+5207143,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5207143,int_stack+1711745,int_stack+1709765,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6108484,int_stack+5207143,int_stack+5660689,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6118204,int_stack+6108484,int_stack+6532138,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6131164,int_stack+6118204,int_stack+6539914,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6532138,int_stack+6131164,int_stack+6508030,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+6108484,int_stack+6532138,int_stack+6519790, 1.0, int_stack+5215963, 1.0, int_stack+5669509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+5709640,int_stack+6108484,int_stack+498231, 1.0, int_stack+5228311, 1.0, int_stack+5681857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1715066,int_stack+1714121,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1716326,int_stack+1715066,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+504846,int_stack+501066,int_stack+498231,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+510516,int_stack+1717946,int_stack+1716326,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+515376,int_stack+510516,int_stack+501066,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6508030,int_stack+515376,int_stack+504846,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1719971,int_stack+1717946,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6517480,int_stack+498231,int_stack+510516,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5207143,int_stack+6517480,int_stack+515376,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+5207143,int_stack+6508030,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6508030,int_stack+1722446,int_stack+1719971,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5219743,int_stack+6508030,int_stack+498231,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5231893,int_stack+5219743,int_stack+6517480,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6508030,int_stack+5231893,int_stack+5207143,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5207143,int_stack+6508030,int_stack+504306,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+7500280,int_stack+5207143,int_stack+6532138, 1.0, int_stack+5327302, 1.0, int_stack+5766376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+5036998,int_stack+7500280,int_stack+6108484, 1.0, int_stack+5343178, 1.0, int_stack+5782252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6108484,int_stack+1736399,int_stack+1735958,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6109807,int_stack+1736987,int_stack+1736399,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6111571,int_stack+6109807,int_stack+6108484,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6114217,int_stack+1737743,int_stack+1736987,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6116485,int_stack+6114217,int_stack+6109807,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6120013,int_stack+6116485,int_stack+6111571,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6108484,int_stack+1738688,int_stack+1737743,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6124423,int_stack+6108484,int_stack+6114217,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6128959,int_stack+6124423,int_stack+6116485,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+6111319,int_stack+6128959,int_stack+6120013,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6117934,int_stack+1739843,int_stack+1738688,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6134839,int_stack+6117934,int_stack+6108484,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6140509,int_stack+6134839,int_stack+6124423,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+5660689,int_stack+6140509,int_stack+6128959,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+81486,int_stack+5660689,int_stack+6111319,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5660689,int_stack+1755873,int_stack+1755285,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5662453,int_stack+1756657,int_stack+1755873,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5664805,int_stack+5662453,int_stack+5660689,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6108484,int_stack+1757665,int_stack+1756657,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6111508,int_stack+6108484,int_stack+5662453,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6116212,int_stack+6111508,int_stack+5664805,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5660689,int_stack+1758925,int_stack+1757665,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6122092,int_stack+5660689,int_stack+6108484,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6128140,int_stack+6122092,int_stack+6111508,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+6135980,int_stack+6128140,int_stack+6116212,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1760465,int_stack+1758925,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+6113104,int_stack+6108484,int_stack+5660689,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+6144800,int_stack+6113104,int_stack+6122092,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+6144800,int_stack+6128140,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6120244,int_stack+6108484,int_stack+6135980,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+498231,int_stack+6120244,int_stack+81486, 2.0, int_stack+5542018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+81486,int_stack+1772105,int_stack+1771349,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+83754,int_stack+1773113,int_stack+1772105,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6108484,int_stack+83754,int_stack+81486,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+86778,int_stack+1774409,int_stack+1773113,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6113020,int_stack+86778,int_stack+83754,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5660689,int_stack+6113020,int_stack+6108484,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+81486,int_stack+1776029,int_stack+1774409,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6132592,int_stack+81486,int_stack+86778,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6140368,int_stack+6132592,int_stack+6113020,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+6108484,int_stack+6140368,int_stack+5660689,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+5660689,int_stack+1778009,int_stack+1776029,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+7500280,int_stack+5660689,int_stack+81486,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+7510000,int_stack+7500280,int_stack+6132592,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+7522960,int_stack+7510000,int_stack+6140368,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+6132592,int_stack+7522960,int_stack+6108484,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+7500280,int_stack+6132592,int_stack+6120244, 2.0, int_stack+5669509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hd|hh) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+4447483,int_stack+7500280,int_stack+498231, 2.0, int_stack+5681857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+498231,int_stack+1781330,int_stack+1780385,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+501066,int_stack+1782590,int_stack+1781330,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+504846,int_stack+501066,int_stack+498231,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+510516,int_stack+1784210,int_stack+1782590,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+515376,int_stack+510516,int_stack+501066,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6108484,int_stack+515376,int_stack+504846,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+498231,int_stack+1786235,int_stack+1784210,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6117934,int_stack+498231,int_stack+510516,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5660689,int_stack+6117934,int_stack+515376,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+504306,int_stack+5660689,int_stack+6108484,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+6108484,int_stack+1788710,int_stack+1786235,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+5673289,int_stack+6108484,int_stack+498231,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5685439,int_stack+5673289,int_stack+6117934,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6108484,int_stack+5685439,int_stack+5660689,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+5660689,int_stack+6108484,int_stack+504306,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+6508030,int_stack+5660689,int_stack+6132592, 2.0, int_stack+5766376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+5491354,int_stack+6508030,int_stack+7500280, 2.0, int_stack+5782252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1396548,int_stack+2482339,int_stack+2202070,441);
     Libderiv->ABCD[11] = int_stack + 1396548;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1489158,int_stack+2943109,int_stack+2736730,441);
     Libderiv->ABCD[10] = int_stack + 1489158;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1581768,int_stack+3392767,int_stack+3186388,441);
     Libderiv->ABCD[9] = int_stack + 1581768;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+3390130,int_stack+3849649,int_stack+3643270,441);
     Libderiv->ABCD[8] = int_stack + 3390130;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+3828490,int_stack+4299307,int_stack+4092928,441);
     Libderiv->ABCD[7] = int_stack + 3828490;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+4222582,int_stack+4659901,int_stack+4503202,441);
     Libderiv->ABCD[6] = int_stack + 4222582;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+4614334,int_stack+5133055,int_stack+4925866, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4733989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 4614334;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+5111086,int_stack+5586601,int_stack+5380222, 0.0, zero_stack, 1.0, int_stack+4733989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 5111086;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+5565442,int_stack+5978830,int_stack+5819296, 1.0, int_stack+4733989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 5565442;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1674378,int_stack+6156112,int_stack+6052918,441);
     Libderiv->ABCD[155] = int_stack + 1674378;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+2866384,int_stack+6230200,int_stack+5911357,441);
     Libderiv->ABCD[143] = int_stack + 2866384;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+5874862,int_stack+6359854,int_stack+6304288,441);
     Libderiv->ABCD[142] = int_stack + 5874862;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+5967472,int_stack+6433942,int_stack+90747,441);
     Libderiv->ABCD[131] = int_stack + 5967472;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6060082,int_stack+6555658,int_stack+25920,441);
     Libderiv->ABCD[130] = int_stack + 6060082;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6152692,int_stack+6685312,int_stack+6629746,441);
     Libderiv->ABCD[129] = int_stack + 6152692;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6245302,int_stack+146313,int_stack+6759400,441);
     Libderiv->ABCD[119] = int_stack + 6245302;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6337912,int_stack+6870532,int_stack+6814966,441);
     Libderiv->ABCD[118] = int_stack + 6337912;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6430522,int_stack+220401,int_stack+6944620,441);
     Libderiv->ABCD[117] = int_stack + 6430522;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6523132,int_stack+7055752,int_stack+7000186,441);
     Libderiv->ABCD[116] = int_stack + 6523132;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6615742,int_stack+294489,int_stack+7129840,441);
     Libderiv->ABCD[107] = int_stack + 6615742;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6708352,int_stack+7240972,int_stack+7185406,441);
     Libderiv->ABCD[106] = int_stack + 6708352;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6800962,int_stack+368577,int_stack+7315060,441);
     Libderiv->ABCD[105] = int_stack + 6800962;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6893572,int_stack+7426192,int_stack+7370626,441);
     Libderiv->ABCD[104] = int_stack + 6893572;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+6986182,int_stack+7547908,int_stack+442665,441);
     Libderiv->ABCD[103] = int_stack + 6986182;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+7078792,int_stack+2321623,int_stack+2034463,441);
     Libderiv->ABCD[95] = int_stack + 7078792;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+7171402,int_stack+7621996,int_stack+526014,441);
     Libderiv->ABCD[94] = int_stack + 7171402;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+7264012,int_stack+2792296,int_stack+2617138,441);
     Libderiv->ABCD[93] = int_stack + 7264012;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+7356622,int_stack+3241954,int_stack+3066148,441);
     Libderiv->ABCD[92] = int_stack + 7356622;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+7449232,int_stack+581580,int_stack+3698836,441);
     Libderiv->ABCD[91] = int_stack + 7449232;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+7541842,int_stack+4148494,int_stack+3972688,441);
     Libderiv->ABCD[90] = int_stack + 7541842;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+3921100,int_stack+655668,int_stack+3527566, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2202070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[47] = int_stack + 3921100;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+3482740,int_stack+7696084,int_stack+729756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2736730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[46] = int_stack + 3482740;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+7634452,int_stack+7770172,int_stack+785322, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3186388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[45] = int_stack + 7634452;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+7727062,int_stack+7899826,int_stack+7844260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3643270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[44] = int_stack + 7727062;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+7819672,int_stack+7973914,int_stack+840888, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4092928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[43] = int_stack + 7819672;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+7912282,int_stack+1791680,int_stack+4558768, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4503202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[42] = int_stack + 7912282;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+0,int_stack+896454,int_stack+4981432, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4925866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[38] = int_stack + 0;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+92610,int_stack+8048002,int_stack+970542, 0.0, zero_stack, 1.0, int_stack+2202070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[35] = int_stack + 92610;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+8004892,int_stack+8122090,int_stack+2090029, 0.0, zero_stack, 1.0, int_stack+2736730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[34] = int_stack + 8004892;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+8097502,int_stack+8196178,int_stack+1026108, 0.0, zero_stack, 1.0, int_stack+3186388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[33] = int_stack + 8097502;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+185220,int_stack+8270266,int_stack+1921250, 0.0, zero_stack, 1.0, int_stack+3643270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[32] = int_stack + 185220;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+8190112,int_stack+8344354,int_stack+1081674, 0.0, zero_stack, 1.0, int_stack+4092928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[31] = int_stack + 8190112;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+8282722,int_stack+8418442,int_stack+1137240, 0.0, zero_stack, 1.0, int_stack+4503202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[30] = int_stack + 8282722;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+8375332,int_stack+8492530,int_stack+5435788, 0.0, zero_stack, 1.0, int_stack+4925866, 1.0, int_stack+5380222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[26] = int_stack + 8375332;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+8467942,int_stack+1192806,int_stack+5256094, 0.0, zero_stack, 2.0, int_stack+5380222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[25] = int_stack + 8467942;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+5203696,int_stack+8622184,int_stack+8566618, 1.0, int_stack+2202070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[23] = int_stack + 5203696;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+8560552,int_stack+2395711,int_stack+1266894, 1.0, int_stack+2736730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[22] = int_stack + 8560552;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+2313202,int_stack+1322460,int_stack+2672704, 1.0, int_stack+3186388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[21] = int_stack + 2313202;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+2405812,int_stack+3316042,int_stack+3121714, 1.0, int_stack+3643270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[20] = int_stack + 2405812;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+2498422,int_stack+3754402,int_stack+3583132, 1.0, int_stack+4092928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[19] = int_stack + 2498422;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+2591032,int_stack+4373395,int_stack+4028254, 1.0, int_stack+4503202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[18] = int_stack + 2591032;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+2683642,int_stack+4789555,int_stack+2257636, 1.0, int_stack+4925866, 0.0, zero_stack, 1.0, int_stack+5819296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[14] = int_stack + 2683642;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+4503049,int_stack+5036998,int_stack+5709640, 1.0, int_stack+5380222, 1.0, int_stack+5819296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[13] = int_stack + 4503049;
 /*--- compute (hf|hh) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+5658052,int_stack+5491354,int_stack+4447483, 2.0, int_stack+5819296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[12] = int_stack + 5658052;

}
